
/* Copyright (C) 2005-2009 Zimbra Inc. http://www.zimbra.com/ */
if(AjxPackage.define("BriefcaseCore")){
if(AjxPackage.define("zimbraMail.briefcase.model.ZmBriefcase")){
ZmBriefcase=function(e){
e.type=ZmOrganizer.BRIEFCASE;
ZmFolder.call(this,e)
};
ZmBriefcase.prototype=new ZmFolder;
ZmBriefcase.prototype.constructor=ZmBriefcase;
ZmBriefcase.PAGE_INDEX="_Index";
ZmBriefcase.PAGE_CHROME="_Template";
ZmBriefcase.PAGE_CHROME_STYLES="_TemplateStyles";
ZmBriefcase.PAGE_TITLE_BAR="_TitleBar";
ZmBriefcase.PAGE_HEADER="_Header";
ZmBriefcase.PAGE_FOOTER="_Footer";
ZmBriefcase.PAGE_SIDE_BAR="_SideBar";
ZmBriefcase.PAGE_TOC_BODY_TEMPLATE="_TocBodyTemplate";
ZmBriefcase.PAGE_TOC_ITEM_TEMPLATE="_TocItemTemplate";
ZmBriefcase.PATH_BODY_TEMPLATE="_PathBodyTemplate";
ZmBriefcase.PATH_ITEM_TEMPLATE="_PathItemTemplate";
ZmBriefcase.PATH_SEPARATOR="_PathSeparator";
ZmBriefcase.prototype.toString=function(){
return"ZmBriefcase"
};
ZmBriefcase.prototype.getIcon=function(){
if(this.nId==ZmOrganizer.ID_ROOT){
return null
}
if(this.link){
return"SharedMailFolder"
}
return"Folder"
};
ZmBriefcase.prototype.notifyModify=function(a){
ZmOrganizer.prototype.notifyModify.call(this,a);
var t=false;
var e={};
if(a.name!=null&&this.name!=a.name&&!a._isRemote){
this.name=a.name;
e[ZmOrganizer.F_NAME]=true;
t=true
}else{
if(a.color!=null&&this.color!=a.color&&!a._isRemote){
this.color=a.color;
e[ZmOrganizer.F_COLOR]=true;
t=true
}}
if(t){
this._notify(ZmEvent.E_MODIFY,{
fields:e}
)
}};
ZmBriefcase.checkName=function(e){
return ZmOrganizer.checkName(e)
};
ZmBriefcase.sortCompare=function(i,a){
var e=ZmOrganizer.checkSortArgs(i,a);
if(e!=null){
return e
}
if(i.link!=a.link){
return i.link?1:-1
}
var o=i.name.toLowerCase();
var t=a.name.toLowerCase();
if(o<t){
return -1
}
if(o>t){
return 1
}
return 0
};
ZmBriefcase.prototype.mayContain=function(r,o){
if(!r){
return true
}
var s=false;
o=o||this.type;
if(r instanceof ZmFolder){
s=(r.parent==this||this.isChildOf(r)||o==ZmOrganizer.SEARCH||o==ZmOrganizer.TAG||(!this.isInTrash()&&this.hasChild(r.name))||(r.id==this.id)||(this.isRemote()&&!this._remoteMoveOk(r))||(r.isRemote()&&!this._remoteMoveOk(r))||r.disallowSubFolder)
}else{
var t=AjxUtil.toArray(r);
var n=t[0];
if(n.type==ZmItem.BRIEFCASE_ITEM){
s=this._checkInvalidFolderItems(t);
if(!s){
for(var a=0;
a<t.length;
a++){
if(t[a] instanceof ZmBriefcaseFolderItem&&(t[a].id==this.id||this.isChildOf(t[a].folder))){
s=true;
break
}}}
if(!s&&n.folderId){
s=true;
for(var a=0;
a<t.length;
a++){
var e=appCtxt.getById(t[a].folderId);
if(e!=this){
s=false;
break
}}}}else{
s=true
}
if(n&&n.msgId&&n.partId){
s=false
}}
if(!s&&this.link){
s=this.isReadOnly()
}
return !s
};
ZmBriefcase.prototype._checkInvalidFolderItems=function(e,a){
var n=false;
for(var t=0;
t<e.length&&!n;
t++){
if(e[t] instanceof ZmBriefcaseFolderItem){
var o=e[t];
n=(o.parent==this||this.isChildOf(o)||a==ZmOrganizer.SEARCH||a==ZmOrganizer.TAG||(!this.isInTrash()&&this.hasChild(o.name))||(o.id==this.id)||(o.folder&&o.folder.isRemote()&&!this.isRemote()&&!o.folder.rid)||(o.folder&&this.isRemote()))
}}
return n
};
ZmBriefcase.prototype.supportsPublicAccess=function(){
return true
};
ZmBriefcase.prototype.isShared=function(){
return this.link?true:false
};
ZmBriefcase.prototype._generateRestUrl=function(){
var i=document.location;
var t=this.getOwner();
var a=i.host;
var e=t.match(/^(.*)@(.*)$/);
a=(e&&e[2])||a;
if(i.port&&i.port!=80){
a=a+":"+i.port
}
return[i.protocol,"//",a,"/service/user/",t,"/",AjxStringUtil.urlEncode(this.getSearchPath(true)).replace(/'/g,"%27")].join("")
}
}
if(AjxPackage.define("zimbraMail.briefcase.model.ZmBriefcaseItem")){
ZmBriefcaseBaseItem=function(i,a,e,t){
if(arguments.length==0){
return
}
ZmItem.call(this,t,i,a,e)
};
ZmBriefcaseBaseItem.prototype=new ZmItem;
ZmBriefcaseBaseItem.prototype.constructor=ZmBriefcaseBaseItem;
ZmBriefcaseBaseItem.prototype.getPath=function(a){
var t=appCtxt.getById(this.folderId);
var e=!a?this.name:"";
return[t.getPath(),"/",e].join("")
};
ZmBriefcaseBaseItem.prototype.getRestUrl=function(i,a,t){
var e=ZmItem.prototype.getRestUrl.call(this);
if(i){
e=e.replace(/[^\/]+$/,"")
}
if(t&&this.version){
e=e+(e.match(/\?/)?"&":"?")+"ver="+this.version
}
return e.replace(/'/g,"%27")
};
ZmBriefcaseBaseItem.prototype.isRealFile=function(){
return(!this.isFolder&&!this.isWebDoc())
};
ZmBriefcaseBaseItem.prototype.isWebDoc=function(){
return(this.contentType==ZmMimeTable.APP_ZIMBRA_SLIDES||this.contentType==ZmMimeTable.APP_ZIMBRA_SPREADSHEET||this.contentType==ZmMimeTable.APP_ZIMBRA_DOC)
};
ZmBriefcaseBaseItem.prototype.isDownloadable=function(){
return(!this.isWebDoc()&&!ZmMimeTable.isRenderable(this.contentType)&&!ZmMimeTable.isRenderableImage(this.contentType)&&!ZmMimeTable.isTextType(this.contentType))
};
ZmBriefcaseBaseItem.prototype.isSlideDoc=function(){
return(this.contentType==ZmMimeTable.APP_ZIMBRA_SLIDES)
};
ZmBriefcaseBaseItem.prototype.getContentType=function(){
return this.contentType
};
ZmBriefcaseBaseItem.prototype.getIcon=function(i){
if(this.isFolder){
return"Folder"
}
var t=this.contentType,a;
if(t&&t.match(/;/)){
t=t.split(";")[0]
}
var e=t?ZmMimeTable.getInfo(t):null;
if(i){
a=e?e.imageLarge:"UnknownDoc_48"
}else{
a=e?e.image:"UnknownDoc"
}
return a
};
ZmBriefcaseBaseItem.prototype.isReadOnly=function(){
var a=false;
var t=appCtxt.getById(this.folderId);
var e=ZmOrganizer.getSystemId(ZmOrganizer.ID_ROOT);
while(t&&t.parent&&(t.parent.id!=e)&&!t.isReadOnly()){
t=t.parent
}
if(t&&t.isReadOnly()){
a=true
}
return a
};
ZmBriefcaseBaseItem.prototype.getBriefcaseFolder=function(){
if(!this._briefcase){
var t=appCtxt.getById(this.folderId);
var e=ZmOrganizer.getSystemId(ZmOrganizer.ID_ROOT);
while(t&&t.parent&&(t.parent.id!=e)){
t=t.parent
}
this._briefcase=t
}
return this._briefcase
};
ZmBriefcaseBaseItem.prototype.isShared=function(){
var e=this.getBriefcaseFolder();
return e&&e.link
};
ZmBriefcaseBaseItem.prototype.createFromAttachment=function(i,n,t,a,e){
e=e||{};
var r=appCtxt.getActiveAccount().id;
var h={
SaveDocumentRequest:{
_jsns:"urn:zimbraMail",doc:{
m:{
id:i,part:n}}}};
var s=h.SaveDocumentRequest.doc;
if(e.id&&e.version){
s.id=e.id;
s.ver=e.version
}else{
s.l=a
}
if(e.rename){
s.name=e.rename
}
var o={
jsonObj:h,asyncMode:true,callback:(new AjxCallback(this,this._handleResponseCreateItem,[a,e.callback])),errorCallback:(new AjxCallback(this,this._handleErrorCreateItem,[e.errorCallback]))};
appCtxt.getAppController().sendRequest(o)
};
ZmBriefcaseBaseItem.prototype.restoreVersion=function(e,i){
var t={
SaveDocumentRequest:{
_jsns:"urn:zimbraMail",doc:{
id:this.id,ver:this.version,doc:{
id:this.id,ver:e}}}};
var a={
jsonObj:t,asyncMode:true,callback:i};
return appCtxt.getAppController().sendRequest(a)
};
ZmBriefcaseBaseItem.prototype.deleteVersion=function(e,o,t){
var a={
PurgeRevisionRequest:{
_jsns:"urn:zimbraMail",revision:{
id:this.id,ver:e,includeOlderRevisions:false}}};
if(t){
t.addRequestParams(a,o)
}else{
var i={
jsonObj:a,asyncMode:true,callback:o};
return appCtxt.getAppController().sendRequest(i)
}};
ZmBriefcaseBaseItem.prototype._handleResponseCreateItem=function(e,a,t){
appCtxt.getAppController().setStatusMsg(ZmMsg.fileCreated);
appCtxt.getChooseFolderDialog().popdown();
if(a){
a.run(t)
}};
ZmBriefcaseBaseItem.prototype._handleErrorCreateItem=function(a,e){
var t=false;
if(a){
t=a.run(e)
}
appCtxt.getAppController().setStatusMsg(ZmMsg.errorCreateFile,ZmStatusView.LEVEL_CRITICAL);
return t
};
ZmBriefcaseBaseItem.prototype.notifyModify=function(o,n){
var t=ZmItem.prototype.notifyModify.apply(this,arguments);
if(t){
return t
}
var a=false,i=true,e=[];
this.set(o);
if(i){
this._notify(ZmEvent.E_MODIFY,{
fields:e}
)
}};
ZmBriefcaseBaseItem.prototype.getFolder=function(){
return appCtxt.getById(this.folderId)
};
ZmBriefcaseBaseItem.prototype.getModifyDate=function(t){
if(t.d&&(Number(t.md)<Number(t.d))){
var e=Number(t.md)*1000;
return new Date(e)
}else{
return new Date(Number(t.md))
}};
ZmBriefcaseBaseItem.prototype._loadFromDom=function(e){
this.id=e.id;
if(e.rest){
this.restUrl=e.rest
}
if(e.l){
this.folderId=e.l
}
if(e.name){
this.name=e.name
}
if(e.cr){
this.creator=e.cr
}
if(e.d){
this.createDate=new Date(Number(e.d))
}
if(e.md){
this.modifyDate=this.getModifyDate(e)
}
if(e.leb){
this.modifier=e.leb
}
if(e.s||e.s==0){
this.size=Number(e.s)
}
if(e.ver){
this.version=Number(e.ver)||0
}
if(e.ct){
this.contentType=e.ct.split(";")[0]
}
if(e.t){
this._parseTags(e.t)
}
this.locked=false;
if(e.loid){
this.locked=true;
this.lockId=e.loid;
this.lockUser=e.loe;
this.lockTime=new Date(Number(e.lt))
}
if(e.desc){
this.notes=AjxStringUtil.htmlEncode(e.desc)
}
this.subject=this.getNotes()
};
ZmBriefcaseItem=function(a,t,e){
if(arguments.length==0){
return
}
ZmBriefcaseBaseItem.call(this,a,t,e,ZmItem.BRIEFCASE_ITEM)
};
ZmBriefcaseItem.prototype=new ZmBriefcaseBaseItem;
ZmBriefcaseItem.prototype.constructor=ZmBriefcaseItem;
ZmBriefcaseItem.prototype.toString=function(){
return"ZmBriefcaseItem"
};
ZmBriefcaseItem.createFromDom=function(a,e){
var t=new ZmBriefcaseItem(a.id,e.list);
t._loadFromDom(a);
return t
};
ZmBriefcaseItem.getRevision=function(n,e,s,t,a){
var i={
ListDocumentRevisionsRequest:{
_jsns:"urn:zimbraMail",doc:{
id:n,ver:e,count:50}}};
var o={
jsonObj:i,asyncMode:Boolean(s),callback:s,errorCallback:t,accountName:a};
return appCtxt.getAppController().sendRequest(o)
};
ZmBriefcaseItem.lock=function(o,n,e,t){
var a={
ItemActionRequest:{
_jsns:"urn:zimbraMail",action:{
id:o instanceof Array?o.join():o,op:"lock"}}};
var i={
jsonObj:a,asyncMode:Boolean(n),callback:n,errorCallback:e,accountName:t};
return appCtxt.getAppController().sendRequest(i)
};
ZmBriefcaseItem.unlock=function(o,n,e,t){
var a={
ItemActionRequest:{
_jsns:"urn:zimbraMail",action:{
id:o instanceof Array?o.join():o,op:"unlock"}}};
var i={
jsonObj:a,asyncMode:Boolean(n),callback:n,errorCallback:e,accountName:t};
return appCtxt.getAppController().sendRequest(i)
};
ZmBriefcaseItem.prototype.getRevisions=function(a,e,t){
ZmBriefcaseItem.getRevision(this.id,-1,a,e,t)
};
ZmBriefcaseItem.prototype.lock=function(a,e,t){
ZmBriefcaseItem.lock(this.id,a,e,t)
};
ZmBriefcaseItem.prototype.unlock=function(a,e,t){
ZmBriefcaseItem.unlock(this.id,a,e,t)
};
ZmBriefcaseItem.prototype.set=function(e){
this.id=e.id;
if(e.rest){
this.restUrl=e.rest
}
if(e.l){
this.folderId=e.l
}
if(e.name){
this.name=e.name
}
if(e.cr){
this.creator=e.cr
}
if(e.d){
this.createDate=new Date(Number(e.d))
}
if(e.md){
this.modifyDate=this.getModifyDate(e)
}
if(e.leb){
this.modifier=e.leb
}
if(e.s){
this.size=Number(e.s)
}
if(e.ver){
this.version=Number(e.ver)
}
if(e.ct){
this.contentType=e.ct.split(";")[0]
}
if(e.t){
this._parseTags(e.t)
}
if(e.loid){
this.locked=true;
this.lockId=e.loid;
this.lockUser=e.loe;
this.lockTime=new Date(Number(e.lt))
}else{
if(e.loid===""){
this.locked=false
}}
if(e.desc){
this.notes=AjxStringUtil.htmlEncode(e.desc)
}
this.subject=this.getNotes()
};
ZmBriefcaseItem.prototype.getNotes=function(){
return AjxMessageFormat.format(ZmMsg.revisionNotes,[this.version,(this.notes||"")])
};
ZmBriefcaseItem.prototype.getNormalizedItemId=function(){
if(!this.getBriefcaseFolder().isShared()){
return this.id
}
return AjxStringUtil.split(this.id,":")[1]
};
ZmBriefcaseFolderItem=function(e){
ZmBriefcaseItem.call(this,e.id,null,true);
this.name=e.name;
this.folderId=e.parent&&e.parent.id;
this.isFolder=true;
this.folder=e;
this.size=e.sizeTotal;
this.creator=e.getOwner();
this._data={}
};
ZmBriefcaseFolderItem.prototype=new ZmBriefcaseItem;
ZmBriefcaseFolderItem.prototype.constructor=ZmBriefcaseFolderItem;
ZmBriefcaseFolderItem.prototype.toString=function(){
return"ZmBriefcaseFolderItem"
};
ZmBriefcaseFolderItem.prototype.getData=function(e){
return this._data[e]
};
ZmBriefcaseFolderItem.prototype.setData=function(e,t){
this._data[e]=t
};
ZmBriefcaseFolderItem.prototype.getIcon=function(t,e){
if(t){
return ZmBriefcaseBaseItem.prototype.getIcon.call(this,true)
}else{
return this.folder.getIconWithColor()
}};
ZmBriefcaseFolderItem.prototype.getOwner=function(){
return this.folder.getOwner()
};
ZmRevisionItem=function(t,e){
if(arguments.length==0){
return
}
this.parent=e;
this.isRevision=true;
this.id=t;
ZmBriefcaseBaseItem.call(this,t,null,false,ZmItem.BRIEFCASE_REVISION_ITEM)
};
ZmRevisionItem.prototype=new ZmBriefcaseBaseItem;
ZmRevisionItem.prototype.constructor=ZmRevisionItem;
ZmRevisionItem.prototype.toString=function(){
return"ZmRevisionItem"
};
ZmRevisionItem.prototype.set=function(e){
this.version=e.ver;
if(e.name){
this.name=e.name
}
if(e.l){
this.folderId=e.l
}
if(e.ct){
this.contentType=e.ct.split(";")[0]
}
if(e.s){
this.size=Number(e.s)
}
if(e.cr){
this.creator=e.cr
}
if(e.cd){
this.createDate=new Date(Number(e.cd))
}
if(e.leb){
this.modifier=e.leb
}
if(e.md){
this.modifyDate=this.getModifyDate(e)
}
if(e.desc){
this.notes=AjxStringUtil.htmlEncode(e.desc)
}
this.subject=this.getNotes();
this._parseTags(e.t)
};
ZmRevisionItem.prototype.getNotes=function(){
return((this.notes)?AjxMessageFormat.format(ZmMsg.revisionNotes,[this.version,this.notes]):AjxMessageFormat.format(ZmMsg.revisionWithoutNotes,[this.version]))
};
ZmRevisionItem.prototype.getRestUrl=function(){
var e=this.parent.getRestUrl();
if(this.version){
e=e+(e.match(/\?/)?"&":"?")+"ver="+this.version
}
return e.replace(/'/g,"%27")
};
ZmRevisionItem.prototype.getIcon=function(){
return null
}
}};
