
/* Copyright (C) 2005-2009 Zimbra Inc. http://www.zimbra.com/ */
if(AjxPackage.define("Spreadsheet")){
if(AjxPackage.define("zimbraMail.spreadsheets.ZmSpreadSheetApp")){
ZmSpreadSheetApp=function(){
appCtxt.setAppController(this);
this._init();
this.startup();
window.app=this
};
ZmSpreadSheetApp.prototype.constructor=ZmSpreadSheetApp;
ZmSpreadSheetApp.APP_ZIMBRA_XLS="application/x-zimbra-xls";
ZmSpreadSheetApp.prototype.toString=function(){
return"ZmSpreadSheetApp"
};
ZmSpreadSheetApp.prototype._init=function(){
this._controller=new ZmSpreadSheetController(appCtxt.getShell())
};
ZmSpreadSheetApp.prototype.startup=function(){
this._controller.show()
};
ZmSpreadSheetApp.launch=function(){
window.appCtxt=new ZmAppCtxt();
appCtxt.rememberMe=false;
window.skin=null;
var a=new ZmSettings();
appCtxt.setSettings(a);
var e=new DwtShell({
className:"MainShell"}
);
appCtxt.setShell(e);
e.getKeyboardMgr().registerKeyMap(new DwtKeyMap(true));
var t=location.href;
ZmSpreadSheetApp.restUrl=t.replace(/\?.*/,"");
new ZmSpreadSheetApp()
};
ZmSpreadSheetApp.setItemInfo=function(e){
ZmSpreadSheetApp.fileInfo=e;
ZmSpreadSheetApp.fileInfo.loaded=true
};
ZmSpreadSheetApp.setFile=function(t,a,e){
if(!t||t==""){
t=null
}
if(!a||a==""){
a=t?null:ZmMsg.untitled
}
e=(!e||e=="")?ZmOrganizer.ID_BRIEFCASE:e;
ZmSpreadSheetApp.fileInfo={
folderId:e,contentType:ZmSpreadSheetApp.APP_ZIMBRA_XLS,name:a,id:t,version:1}
};
ZmSpreadSheetApp.prototype.setStatusMsg=function(){
if(!this.statusView){
this.statusView=new ZmStatusView(appCtxt.getShell(),"ZmStatus",Dwt.ABSOLUTE_STYLE,ZmId.STATUS_VIEW)
}
params=Dwt.getParams(arguments,ZmStatusView.MSG_PARAMS);
params.transitions=ZmToast.DEFAULT_TRANSITIONS;
this.statusView.setStatusMsg(params)
};
ZmSpreadSheetApp.prototype.exit=function(){
return this._controller.checkForChanges()
};
window.onbeforeunload=function(){
return appCtxt.getAppController().exit()
};
window.onload=function(){
setTimeout(function(){
ZmSpreadSheetApp.launch()
}
,200)
}
}
if(AjxPackage.define("zimbraMail.spreadsheets.controller.ZmSpreadSheetController")){
ZmSpreadSheetController=function(e){
if(arguments.length==0){
return
}
ZmController.call(this,e);
this._spreadSheet=null;
this._toolbar=null;
this._docMgr=new ZmDocletMgr();
appCtxt.getShell().addControlListener(new AjxListener(this,this.resize))
};
ZmSpreadSheetController.prototype=new ZmController();
ZmSpreadSheetController.prototype.constructor=ZmSpreadSheetController;
ZmSpreadSheetController.NEW="new";
ZmSpreadSheetController.EDIT="edit";
ZmSpreadSheetController.prototype.save=function(){
var t=ZmSpreadSheetApp.fileInfo;
var n=this._toolbar.get("fileName").getValue();
var o;
if(!t.id){
if(n==""){
o=ZmMsg.emptyDocName
}else{
o=this._docMgr.checkInvalidDocName(n)
}}
if(o){
var a=DwtMessageDialog.WARNING_STYLE;
var e=this.warngDlg=appCtxt.getMsgDialog();
e.setMessage(o,a);
e.popup();
e.registerCallback(DwtDialog.OK_BUTTON,new AjxCallback(this,this._okListener,[e]));
return false
}
ZmSpreadSheetApp.fileInfo.name=n;
ZmSpreadSheetApp.fileInfo.content=this._origContent=this._spreadSheet.getXML();
ZmSpreadSheetApp.fileInfo.contentType=ZmSpreadSheetApp.APP_ZIMBRA_XLS;
this._docMgr.setSaveCallback(new AjxCallback(this,this._postSaveHandler));
this._docMgr.saveDocument(ZmSpreadSheetApp.fileInfo)
};
ZmSpreadSheetController.prototype._okListener=function(e){
e.popdown()
};
ZmSpreadSheetController.prototype._postSaveHandler=function(a,e){
if(e){
var t=new AjxMessageFormat(ZmMsg.saveConflictSpreadsheet);
appCtxt.setStatusMsg(t.format(a[0].name),ZmStatusView.LEVEL_WARNING)
}else{
if(a&&a.length>0){
ZmSpreadSheetApp.fileInfo.id=a[0].id;
ZmSpreadSheetApp.fileInfo.version=a[0].ver;
appCtxt.setStatusMsg(ZmMsg.savedSpreadsheet,ZmStatusView.LEVEL_INFO);
this._state=ZmSpreadSheetController.EDIT
}}};
ZmSpreadSheetController.prototype._initToolbar=function(){
if(!this._toolbar){
this._toolbar=new ZmSpreadSheetToolbars(this._spreadSheet,this._spreadSheet,this)
}
this._toolbar._buttons.fileName.setValue(ZmSpreadSheetApp.fileInfo.name)
};
ZmSpreadSheetController.prototype._initSpreadSheet=function(){
if(this._spreadSheet){
return
}
this._spreadSheet=new ZmSpreadSheet(this._container,this,null,"absolute")
};
ZmSpreadSheetController.prototype.loadData=function(e){
return this._docMgr.getItemInfo({
id:e}
)
};
ZmSpreadSheetController.prototype.loadSheet=function(a){
var t=this._docMgr.fetchDocumentContent(a);
if(t){
var e=new ZmSpreadSheetModel(0,0);
e.loadFromXML(t);
this._spreadSheet.setModel(e);
AjxTimedAction.scheduleAction(new AjxCallback(this,this._getOrigContent),500)
}};
ZmSpreadSheetController.prototype._getOrigContent=function(){
this._origContent=this._spreadSheet.getXML()
};
ZmSpreadSheetController.prototype._initModel=function(){
if(ZmSpreadSheetApp.fileInfo&&ZmSpreadSheetApp.fileInfo.id){
var a=ZmSpreadSheetApp.fileInfo.loaded?ZmSpreadSheetApp.fileInfo:this.loadData(ZmSpreadSheetApp.fileInfo.id);
if(!a.rest){
a.rest=ZmSpreadSheetApp.restUrl
}
if(a!=null){
ZmSpreadSheetApp.fileInfo=a;
this.loadSheet(a);
this._state=ZmSpreadSheetController.EDIT
}}else{
var e=document.body.clientWidth;
var t=document.body.clientHeight;
var n=Math.ceil(e/ZmSpreadSheetModel.getDefaultColProp().width)+2;
var o=Math.ceil(t/ZmSpreadSheetModel.getDefaultRowProp().height)-5;
this._spreadSheet.setModel(new ZmSpreadSheetModel(o||40,n||15));
this._state=ZmSpreadSheetController.NEW
}};
ZmSpreadSheetController.prototype.show=function(t){
this._initSpreadSheet();
this._initModel();
var e=this._spreadSheet;
this._initToolbar();
e._selectedCell=null;
e.setZIndex(Dwt.Z_VIEW);
this.resize();
e.focus()
};
ZmSpreadSheetController.prototype.resize=function(o){
var t=this._spreadSheet;
if(!t){
return
}
t.setDisplay("none");
var e=document.body.clientWidth;
var a=document.body.clientHeight;
if(!AjxEnv.isIE){
e-=2;
a-=2
}
t.setDisplay("block");
t.setBounds(0,0,e,a)
};
ZmSpreadSheetController.prototype.setStatusMsg=function(){
if(!this.statusView){
this.statusView=new ZmStatusView(appCtxt.getShell(),"ZmStatus",Dwt.ABSOLUTE_STYLE,ZmId.STATUS_VIEW)
}
params=Dwt.getParams(arguments,ZmStatusView.MSG_PARAMS);
params.transitions=ZmToast.DEFAULT_TRANSITIONS;
this.statusView.setStatusMsg(params)
};
ZmSpreadSheetController.prototype.toString=function(){
return"ZmSpreadSheetController"
};
ZmSpreadSheetController.prototype.checkForChanges=function(){
var e=(this._state==ZmSpreadSheetController.NEW)||(this._origContent!=this._spreadSheet.getXML());
if(e){
return ZmMsg.exitSpreadsheetUnsavedChanges
}}
}
if(AjxPackage.define("zimbraMail.spreadsheets.controller.ZmSpreadSheetToolbars")){
ZmSpreadSheetToolbars=function(o,t,e){
if(t==null){
t=o
}
this._spreadSheet=t;
this._controller=e;
DwtComposite.call(this,{
parent:o,className:"ZmSpreadSheetToolbars",posStyle:DwtControl.RELATIVE_STYLE}
);
this._on_buttonPress=new AjxListener(this,this._on_buttonPress);
this._buttons={};
this._createWidgets();
if(o===t){
var a=o.getHtmlElement();
a.insertBefore(this.getHtmlElement(),a.firstChild)
}
t.onSelectCell.push(new AjxCallback(this,this._cellSelected))
};
ZmSpreadSheetToolbars.prototype=new DwtComposite;
ZmSpreadSheetToolbars.prototype.construction=ZmSpreadSheetToolbars;
ZmSpreadSheetToolbars.prototype._cellSelected=function(e){
this._buttons.bold.setSelected(e.getStyleProp("fontWeight")=="bold");
this._buttons.italic.setSelected(e.getStyleProp("fontStyle")=="italic");
this._buttons.underline.setSelected(e.getStyleProp("textDecoration")=="underline");
this._buttons.strike.setSelected(e.getStyleProp("textDecoration")=="line-through");
var a=e.getStyleProp("textAlign");
this._buttons.justifyLeft.setSelected(a=="left");
this._buttons.justifyCenter.setSelected(a=="center");
this._buttons.justifyRight.setSelected(a=="right");
if(this._dataField){
this._dataField.setValue(e.getEditValue())
}
this._buttons.typeSelect.setSelectedValue(e.getType());
var t=e.getDecimals();
if(t==null){
t=-1
}
this._buttons.decimalsSelect.setSelectedValue(t)
};
ZmSpreadSheetToolbars.prototype._createWidgets=function(){
var e=new DwtToolBar({
parent:this,className:"ToolBar",posStyle:DwtControl.RELATIVE_STYLE}
);
this._createToolbar(e);
this._createToolbar1(e);
this._createToolbar2(e)
};
ZmSpreadSheetToolbars.prototype._createToolbar=function(t){
var e=this._buttons.fileName=new DwtInputField({
parent:t,size:20}
);
e=this._buttons.saveFile=new DwtToolBarButton({
parent:t}
);
e.setImage("Save");
e.setText(ZmMsg.save);
e.setData("SS","Save");
e.addSelectionListener(new AjxListener(this,this._saveButtonListener));
e.setToolTipContent(ZmMsg.save);
new DwtControl({
parent:t,className:"vertSep"}
)
};
ZmSpreadSheetToolbars.prototype._saveButtonListener=function(e){
var t=this._controller;
t.save()
};
ZmSpreadSheetToolbars.prototype.get=function(e){
return this._buttons[e]
};
ZmSpreadSheetToolbars.prototype._createToolbar1=function(t){
var a=this._on_buttonPress;
var e;
var o={
parent:t};
e=this._buttons.clipboardCopy=new DwtToolBarButton(o);
e.setImage("Copy");
e.setData("SS","ClipboardCopy");
e.addSelectionListener(a);
e.setToolTipContent(ZmMsg.copy);
e=this._buttons.clipboardCut=new DwtToolBarButton(o);
e.setImage("Cut");
e.setData("SS","ClipboardCut");
e.addSelectionListener(a);
e.setToolTipContent(ZmMsg.cut);
e=this._buttons.clipboardPaste=new DwtToolBarButton(o);
e.setImage("Paste");
e.setData("SS","ClipboardPaste");
e.addSelectionListener(a);
e.setToolTipContent(ZmMsg.paste);
new DwtControl({
parent:t,className:"vertSep"}
);
o.style=DwtButton.TOGGLE_STYLE;
e=this._buttons.bold=new DwtToolBarButton(o);
e.setImage("Bold");
e.setData("SS","Bold");
e.addSelectionListener(a);
e.setToolTipContent(AjxKeys["editor.Bold.summary"]);
e=this._buttons.italic=new DwtToolBarButton(o);
e.setImage("Italics");
e.setData("SS","Italic");
e.addSelectionListener(a);
e.setToolTipContent(AjxKeys["editor.Italic.summary"]);
e=this._buttons.underline=new DwtToolBarButton(o);
e.setImage("Underline");
e.setData("SS","Underline");
e.addSelectionListener(a);
e.setToolTipContent(AjxKeys["editor.Underline.summary"]);
e=this._buttons.strike=new DwtToolBarButton(o);
e.setImage("StrikeThru");
e.setData("SS","Strike");
e.addSelectionListener(a);
e.setToolTipContent(AjxKeys["editor.Strikethru.summary"]);
new DwtControl({
parent:t,className:"vertSep"}
);
e=this._buttons.justifyLeft=new DwtToolBarButton(o);
e.setImage("LeftJustify");
e.setData("SS","JustifyLeft");
e.addSelectionListener(a);
e.setToolTipContent(AjxKeys["editor.LeftJustify.summary"]);
e=this._buttons.justifyCenter=new DwtToolBarButton(o);
e.setImage("CenterJustify");
e.setData("SS","JustifyCenter");
e.addSelectionListener(a);
e.setToolTipContent(AjxKeys["editor.CenterJustify.summary"]);
e=this._buttons.justifyRight=new DwtToolBarButton(o);
e.setImage("RightJustify");
e.setData("SS","JustifyRight");
e.addSelectionListener(a);
e.setToolTipContent(AjxKeys["editor.RightJustify.summary"]);
new DwtControl({
parent:t,className:"vertSep"}
);
e=this._buttons.fontColor=new ZmSpreadSheetEditorColorPicker(t,null,"DwtToolbarButton",null,null,null,ZmMsg.auto);
e.setImage("FontColor");
e.showColorDisplay();
e.setToolTipContent(ZmMsg.fontColor);
e.addSelectionListener(new AjxListener(this,this._on_fontColor));
e=this._buttons.bgColor=new ZmSpreadSheetEditorColorPicker(t,null,"DwtToolbarButton",null,null,null,ZmMsg.auto);
e.setImage("FontBackground");
e.showColorDisplay();
e.setToolTipContent(ZmMsg.fontBackground);
e.addSelectionListener(new AjxListener(this,this._on_bgColor))
};
ZmSpreadSheetToolbars.prototype._inputModified=function(e){
if(this._dataField){
this._dataField.setValue(e)
}};
ZmSpreadSheetToolbars.prototype._input_clicked=function(t){
var e=new DwtUiEvent();
this._dataField.getInputElement().blur();
e.setFromDhtmlEvent(t);
var a=this._spreadSheet._selectedCell;
if(a){
this._spreadSheet.focus();
this._spreadSheet._editCell(a)
}
e._stopPropagation=true;
e._returnValue=false;
e.setToDhtmlEvent(t);
return false
};
ZmSpreadSheetToolbars.prototype._createToolbar2=function(h){
var a=this._on_buttonPress;
var o={
parent:h,style:0};
new DwtControl({
parent:h,className:"vertSep"}
);
b=this._buttons.rowInsertAbove=new DwtToolBarButton(o);
b.setImage("InsertRowBefore");
b.setData("SS","RowInsertAbove");
b.addSelectionListener(a);
b.setToolTipContent(ZmMsg.insertRowAbove);
b=this._buttons.rowInsertUnder=new DwtToolBarButton(o);
b.setImage("InsertRowAfter");
b.setData("SS","RowInsertUnder");
b.addSelectionListener(a);
b.setToolTipContent(ZmMsg.insertRowUnder);
b=this._buttons.rowDelete=new DwtToolBarButton(o);
b.setImage("DeleteRow");
b.setData("SS","RowDelete");
b.addSelectionListener(a);
b.setToolTipContent(ZmMsg.deleteRow);
new DwtControl({
parent:h,className:"vertSep"}
);
b=this._buttons.colInsertBefore=new DwtToolBarButton(o);
b.setImage("InsertColBefore");
b.setData("SS","ColInsertBefore");
b.addSelectionListener(a);
b.setToolTipContent(ZmMsg.insertColumnBefore);
b=this._buttons.colInsertAfter=new DwtToolBarButton(o);
b.setImage("InsertColAfter");
b.setData("SS","ColInsertAfter");
b.addSelectionListener(a);
b.setToolTipContent(ZmMsg.insertColumnAfter);
b=this._buttons.colDelete=new DwtToolBarButton(o);
b.setImage("DeleteCol");
b.setData("SS","ColDelete");
b.addSelectionListener(a);
b.setToolTipContent(ZmMsg.deleteColumn);
new DwtControl({
parent:h,className:"vertSep"}
);
b=this._buttons.chart=new DwtToolBarButton(o);
b.setImage("PieChart");
b.setData("SS","PieChart");
b.addSelectionListener(a);
b=this._buttons.chart=new DwtToolBarButton(o);
b.setImage("BarChart");
b.setData("SS","BarChart");
b.addSelectionListener(a);
b=this._buttons.chart=new DwtToolBarButton(o);
b.setImage("LineChart");
b.setData("SS","LineChart");
b.addSelectionListener(a);
new DwtControl({
parent:h,className:"vertSep"}
);
b=new DwtToolBarButton(o);
b.setImage("Sum");
b.setToolTipContent(ZmMsg.sumCells);
b.setData("SS","Func-SumCells");
b.addSelectionListener(a);
b=new DwtToolBarButton(o);
b.setText(ZmMsg.insertFunction);
var t=new DwtMenu({
parent:b}
);
t.dontStealFocus();
var e=[];
for(var r in ZmSpreadSheetFormulae.HELP){
e.push(r)
}
e=e.sort();
var c=new AjxListener(this,this._on_insertFunction);
for(var r=0;
r<e.length;
++r){
var n=ZmSpreadSheetFormulae.HELP[e[r]];
if(n.alias){
continue
}
var d=new DwtMenuItem({
parent:t}
);
d.setText(['<div style="float:left; width: 5em; text-align: right">',e[r],"</div>",'<div style="margin-left: 5em">&nbsp;- ',n.help,"</div>"].join(""));
d.setData("SS",e[r]);
d.addSelectionListener(c);
if(n.args){
d.setToolTipContent(n.args)
}}
b.setMenu(t);
new DwtControl({
parent:h,className:"vertSep"}
);
var u=this._buttons.typeSelect=new ZmSpreadSheetEditorSelect(h,null);
u.addChangeListener(new AjxListener(this,this._on_typeSelect));
u.addOption(ZmMsg.spreadSheet_msg_autoType,true,null);
u.addOption(ZmMsg.number,false,"number");
u.addOption(ZmMsg.currency,false,"currency");
u.addOption(ZmMsg.percent,false,"percentage");
u.addOption(ZmMsg.text,false,"string");
u.addOption(ZmMsg.date,false,"date");
var u=this._buttons.decimalsSelect=new ZmSpreadSheetEditorSelect(h,null);
u.addChangeListener(new AjxListener(this,this._on_decimalsSelect));
u.addOption(ZmMsg.spreadSheet_msg_autoDecimals,true,-1);
var l=new AjxMessageFormat(ZmMsg.spreadsheet_msg_numberOfDecimals);
for(var r=0;
r<=6;
r++){
u.addOption(l.format(r),false,r)
}
if(ZmSpreadSheetModel.DEBUG){
new DwtControl({
parent:h,className:"vertSep"}
);
new DwtLabel({
parent:h}
).setText("DEBUG: ");
b=new DwtToolBarButton(o);
b.setText("Serialize");
b.addSelectionListener(new AjxListener(this,function(){
var s=this.getModel().serialize();
var f=window.open(appContextPath+"/public/blank.html","_blank","scrollbars=no");
var m=setInterval(function(){
try{
var y=f.document;
b=y.body;
b.style.backgroundColor="ButtonFace";
var g=y.createElement("textarea");
g.value=s;
b.appendChild(g);
g.style.width="100%";
g.style.height="100%";
clearInterval(m)
}
catch(p){}}
,250)
}
));
b=new DwtToolBarButton(o);
b.setText("getHtml");
b.addSelectionListener(new AjxListener(this,function(){
var s=this.getModel().getHtml();
var f=window.open(appContextPath+"/public/blank.html","_blank","scrollbars=yes");
var m=setInterval(function(){
try{
var g=f.document;
b=g.body;
b.style.backgroundColor="ButtonFace";
b.innerHTML=s;
clearInterval(m)
}
catch(p){}}
,250)
}
))
}};
ZmSpreadSheetToolbars.prototype._on_insertFunction=function(e){
this.insertFunction(e.item.getData("SS"))
};
ZmSpreadSheetToolbars.prototype._on_fontColor=function(e){
this.applyStyle("color",e.detail);
this._spreadSheet.focus()
};
ZmSpreadSheetToolbars.prototype._on_bgColor=function(e){
this.applyStyle("backgroundColor",e.detail);
this._spreadSheet.focus()
};
ZmSpreadSheetToolbars.prototype._on_buttonPress=function(o){
var a=o.item;
var n=a.getData("SS");
var t=this._spreadSheet;
t.focus();
switch(n){
case"ClipboardCopy":t.clipboardCopy();
break;
case"ClipboardCut":t.clipboardCut();
break;
case"ClipboardPaste":t.clipboardPaste();
break;
case"Bold":this.applyStyle("fontWeight",a.isToggled()?"bold":"");
break;
case"Italic":this.applyStyle("fontStyle",a.isToggled()?"italic":"");
break;
case"Strike":this.applyStyle("textDecoration",a.isToggled()?"line-through":"");
this._buttons.underline.setSelected(false);
break;
case"Underline":this.applyStyle("textDecoration",a.isToggled()?"underline":"");
this._buttons.strike.setSelected(false);
break;
case"JustifyLeft":this.applyStyle("textAlign",a.isToggled()?"left":"");
this._buttons.justifyCenter.setSelected(false);
this._buttons.justifyRight.setSelected(false);
break;
case"JustifyCenter":this.applyStyle("textAlign",a.isToggled()?"center":"");
this._buttons.justifyLeft.setSelected(false);
this._buttons.justifyRight.setSelected(false);
break;
case"JustifyRight":this.applyStyle("textAlign",a.isToggled()?"right":"");
this._buttons.justifyLeft.setSelected(false);
this._buttons.justifyCenter.setSelected(false);
break;
case"RowInsertAbove":var e=t.getSelectedCellModel();
if(e){
this.getModel().insertRow(e.getRow()-1)
}
break;
case"RowInsertUnder":var e=t.getSelectedCellModel();
if(e){
this.getModel().insertRow(e.getRow())
}
break;
case"ColInsertBefore":var e=t.getSelectedCellModel();
if(e){
this.getModel().insertCol(e.getCol()-1)
}
break;
case"ColInsertAfter":var e=t.getSelectedCellModel();
if(e){
this.getModel().insertCol(e.getCol())
}
break;
case"RowDelete":var e=t.getSelectedCellModel();
if(e){
this.getModel().deleteRow(e.getRow()-1)
}
break;
case"ColDelete":var e=t.getSelectedCellModel();
if(e){
this.getModel().deleteCol(e.getCol()-1)
}
break;
case"Func-SumCells":this.insertFunction("sum");
break;
case"BarChart":this._spreadSheet.makeChart(ZmSpreadSheetChart.BAR);
break;
case"PieChart":this._spreadSheet.makeChart(ZmSpreadSheetChart.PIE);
break;
case"LineChart":this._spreadSheet.makeChart(ZmSpreadSheetChart.LINE);
break;
case"Import":this._spreadSheet._importDialog();
break
}};
ZmSpreadSheetToolbars.prototype.insertFunction=function(n){
var o=this._spreadSheet;
var e=o.getSelectedCellModel();
if(e){
var a=ZmSpreadSheetFormulae.HELP[n];
var s=n.length+2;
if(a&&a.helper){
n=a.helper;
s=n.indexOf("|");
n=n.replace(/\|/g,"")
}else{
n="="+n+"()"
}
var t=o._getInputField();
o.focus();
o._editCell(e._td);
t.setValue(n);
Dwt.setSelectionRange(t,s,s)
}};
ZmSpreadSheetToolbars.prototype._on_typeSelect=function(a){
this._spreadSheet.focus();
var e=this._spreadSheet.getSelectionRange();
if(!e){
return
}
var t=a._args.newValue;
this.getModel().forEachCell(e,function(o){
o.setType(t)
}
,this)
};
ZmSpreadSheetToolbars.prototype._on_decimalsSelect=function(t){
this._spreadSheet.focus();
var e=this._spreadSheet.getSelectionRange();
if(!e){
return
}
var a=t._args.newValue;
if(a==-1){
a=null
}
this.getModel().forEachCell(e,function(o){
o.setDecimals(a)
}
,this)
};
ZmSpreadSheetToolbars.prototype.getModel=function(){
return this._spreadSheet._model
};
ZmSpreadSheetToolbars.prototype.applyStyle=function(t,a){
var e=this._spreadSheet.getSelectionRange();
if(!e){
return
}
this.getModel().forEachCell(e,function(o){
o.setStyleProp(t,a)
}
,this)
};
ZmSpreadSheetEditorColorPicker=function(n,o,a,t,r,e,s){
DwtButtonColorPicker.call(this,n,o,a,t,r,e,s)
};
ZmSpreadSheetEditorColorPicker.prototype=new DwtButtonColorPicker;
ZmSpreadSheetEditorColorPicker.prototype.constructor=ZmSpreadSheetEditorColorPicker;
ZmSpreadSheetEditorColorPicker.prototype.TEMPLATE="dwt.Widgets#ZToolbarButton";
ZmSpreadSheetEditorSelect=function(o,e,a,t){
DwtSelect.call(this,{
parent:o,options:e,className:a,posStyle:t}
)
};
ZmSpreadSheetEditorSelect.prototype=new DwtSelect;
ZmSpreadSheetEditorSelect.prototype.constructor=ZmSpreadSheetEditorSelect;
ZmSpreadSheetEditorSelect.prototype.TEMPLATE="dwt.Widgets#ZBorderlessButton"
}
if(AjxPackage.define("zimbraMail.spreadsheets.model.msgs")){
ZmMsg.SS={
func:{
sum:{
help:ZmMsg.spreadSheet_func_sum}
,multiply:{
help:ZmMsg.spreadSheet_func_multiply}
,modulo:{
help:ZmMsg.spreadSheet_func_modulo}
,PI:{
help:ZmMsg.spreadSheet_func_PI,helper:"=PI|"}
,sin:{
help:ZmMsg.spreadSheet_func_sin}
,cos:{
help:ZmMsg.spreadSheet_func_cos}
,tan:{
help:ZmMsg.spreadSheet_func_tan}
,round:{
help:ZmMsg.spreadSheet_func_round}
,ceil:{
help:ZmMsg.spreadSheet_func_ceil}
,floor:{
help:ZmMsg.spreadSheet_func_floor}
,abs:{
help:ZmMsg.spreadSheet_func_abs}
,sqrt:{
help:ZmMsg.spreadSheet_func_sqrt}
,exp:{
help:ZmMsg.spreadSheet_func_exp}
,log:{
help:ZmMsg.spreadSheet_func_log}
,min:{
help:ZmMsg.spreadSheet_func_min}
,max:{
help:ZmMsg.spreadSheet_func_max}
,len:{
help:ZmMsg.spreadSheet_func_len}
,concat:{
help:ZmMsg.spreadSheet_func_concat}
,average:{
help:ZmMsg.spreadSheet_func_average}
,join:{
help:ZmMsg.spreadSheet_func_join,args:"join(separator, string1 [, string2...])",helper:'=join(", ", |)'}
,"if":{
help:ZmMsg.spreadSheet_func_if,args:"if(condition, true_value, false_value)"}}}
}
if(AjxPackage.define("zimbraMail.spreadsheets.model.ZmSpreadSheetModel")){
ZmSpreadSheetModel=function(a,o){
this.ROWS=a;
this.COLS=o;
this.version=1;
var s=this.data=new Array(a);
for(var t=0;
t<a;
++t){
var n=s[t]=new Array(o);
for(var e=0;
e<o;
++e){
n[e]=new ZmSpreadSheetCellModel(this)
}}
this.colProps=new Array(o);
for(var t=0;
t<o;
++t){
this.colProps[t]=ZmSpreadSheetModel.getDefaultColProp()
}
this.rowProps=new Array(a);
for(var t=0;
t<a;
++t){
this.rowProps[t]=ZmSpreadSheetModel.getDefaultRowProp()
}
this._expressionCells=[];
this.reset();
this._maxActiveRow=0;
this._maxActiveCol=0
};
ZmSpreadSheetModel.DEBUG=false;
ZmSpreadSheetModel.DATE_FORMATS=["MM/dd/yy","MM/dd/yyyy","MM-dd-yy","MM-dd-yyyy","MMM dd","MMMM dd","M/d","MMM yyyy","MMMM yyyy","MMMM dd,yyyy","dd-MMM-yyyy","dd-MM"];
ZmSpreadSheetModel.getDefaultColProp=function(){
var e={
width:100};
return e
};
ZmSpreadSheetModel.getDefaultRowProp=function(){
var e={
height:15};
return e
};
ZmSpreadSheetModel.getCellName=function(t,e){
return ZmSpreadSheetModel.getColName(e)+t
};
ZmSpreadSheetModel.getRangeName=function(t,o,e,a){
return ZmSpreadSheetModel.getCellName(t,o)+":"+ZmSpreadSheetModel.getCellName(e,a)
};
ZmSpreadSheetModel.getColName=function(e){
--e;
var t=[];
do{
t.unshift(String.fromCharCode(65+e%26));
e=Math.floor(e/26)
}
while(e>0);
return t.join("")
};
ZmSpreadSheetModel.identifyCell=function(n){
if(/^([a-z]+)([0-9]+)$/i.test(n)){
var t=RegExp.$1.toUpperCase();
var e=parseInt(RegExp.$2);
var o=0;
for(var a=0;
a<t.length;
++a){
o*=26;
o+=t.charCodeAt(a)-64
}
return{
row:e-1,col:o-1}
}
throw"Can't parse cell identifier "+n+" at ZmSpreadSheetModel.identifyCell"
};
ZmSpreadSheetModel.getRangeBounds=function(n){
var e=n.split(/:/);
var r=ZmSpreadSheetModel.identifyCell(e[0]);
var s=ZmSpreadSheetModel.identifyCell(e[1]);
var o=Math.min(r.row,s.row);
var l=Math.min(r.col,s.col);
var t=Math.max(r.row,s.row);
var h=Math.max(r.col,s.col);
return[{
row:o,col:l}
,{
row:t,col:h}
]
};
ZmSpreadSheetModel.shiftCell=function(e,t,a){
var o=ZmSpreadSheetModel.identifyCell(e);
o.row+=t;
o.col+=a;
return ZmSpreadSheetModel.getCellName(o.row+1,o.col+1)
};
ZmSpreadSheetModel.shiftRange=function(t,o,n){
var e=t.split(/:/);
return ZmSpreadSheetModel.shiftCell(e[0],o,n)+":"+ZmSpreadSheetModel.shiftCell(e[1],o,n)
};
ZmSpreadSheetModel.getRangeGeometry=function(e){
var t=ZmSpreadSheetModel.getRangeBounds(e);
return{
rows:t[1].row-t[0].row+1,cols:t[1].col-t[0].col+1,bounds:t}
};
ZmSpreadSheetModel.prototype.getCellsInRange=function(s){
var e=ZmSpreadSheetModel.getRangeBounds(s);
var h=e[0].row;
var t=e[0].col;
var o=e[1].row;
var r=e[1].col;
var l=[];
for(var n=h;
n<=o;
++n){
for(var a=t;
a<=r;
++a){
l.push(this.data[n][a])
}}
return l
};
ZmSpreadSheetModel.prototype._setMaxActiveRow=function(e){
if(this._maxActiveRow<e){
this._maxActiveRow=e
}};
ZmSpreadSheetModel.prototype._setMaxActiveCol=function(e){
if(this._maxActiveCol<e){
this._maxActiveCol=e
}};
ZmSpreadSheetModel.prototype.forEachCell=function(e,o,n){
var t=this.getCellsInRange(e);
for(var a=0;
a<t.length;
++a){
o.apply(n,[t[a],a,t])
}};
ZmSpreadSheetModel.prototype.insertRow=function(t){
if(t==null){
t=this.ROWS
}
var a=new Array(this.COLS);
for(var e=this.COLS;
--e>=0;
){
a[e]=new ZmSpreadSheetCellModel(this)
}
this.data.splice(t,0,a);
this.rowProps.splice(t,0,ZmSpreadSheetModel.getDefaultRowProp());
++this.ROWS;
this.triggerEvent("onInsertRow",a,t);
this.recompute()
};
ZmSpreadSheetModel.prototype.insertCol=function(a){
if(a==null){
a=this.COLS
}
var e=new Array(this.ROWS);
for(var t=this.ROWS;
--t>=0;
){
var o=new ZmSpreadSheetCellModel(this);
e[t]=o;
this.data[t].splice(a,0,o)
}
this.colProps.splice(a,0,ZmSpreadSheetModel.getDefaultColProp());
++this.COLS;
this.triggerEvent("onInsertCol",e,a);
this.recompute()
};
ZmSpreadSheetModel.prototype.deleteRow=function(a){
if(this.ROWS>1){
var e=this.data[a];
for(var t=e.length;
--t>=0;
){
if(e[t]._expr){
e[t].setExpression(null)
}
e[t]._td=null
}
this.data.splice(a,1);
this.rowProps.splice(a,1);
--this.ROWS;
this.triggerEvent("onDeleteRow",a);
this.recompute()
}};
ZmSpreadSheetModel.prototype.deleteCol=function(t){
if(this.COLS>1){
for(var a=this.ROWS;
--a>=0;
){
var e=this.data[a][t];
if(e._expr){
e.setExpression(null)
}
this.data[a].splice(t,1);
e._td=null
}
this.colProps.splice(t,1);
--this.COLS;
this.triggerEvent("onDeleteCol",t);
this.recompute()
}};
ZmSpreadSheetModel.prototype.getRowHeight=function(e){
if(!this.rowProps[e]){
return ZmSpreadSheetModel.getDefaultRowProp().height
}
return this.rowProps[e].height
};
ZmSpreadSheetModel.prototype.setRowHeight=function(t,e){
this.rowProps[t].height=e
};
ZmSpreadSheetModel.prototype.getColWidth=function(e){
return this.colProps[e].width
};
ZmSpreadSheetModel.prototype.setColWidth=function(e,t){
this.colProps[e].width=t
};
ZmSpreadSheetModel.prototype.checkBounds=function(t,e){
if(t<0||t>this.ROWS-1){
throw"Row out of bounds"
}
if(e<0||e>this.COLS-1){
throw"Col out of bounds"
}};
ZmSpreadSheetModel.prototype.reset=function(){
this._viewEvents={}
};
ZmSpreadSheetModel.prototype.triggerEvent=function(e){
var o=this._viewEvents[e];
if(!o){
return null
}
var t=new Array(arguments.length-1);
for(var a=1;
a<arguments.length;
++a){
t[a-1]=arguments[a]
}
o.run.apply(o,t)
};
ZmSpreadSheetModel.prototype.setViewListener=function(e,t){
this._viewEvents[e]=t
};
ZmSpreadSheetModel.prototype.getCell=function(t,e){
return this.data[t-1][e-1]
};
ZmSpreadSheetModel.prototype.getCellByID=function(e){
var t=ZmSpreadSheetModel.identifyCell(e);
return this.data[t.row][t.col]
};
ZmSpreadSheetModel.prototype._orderExpressionCells=function(s){
var o=[];
var r={};
var t=s||this._expressionCells;
while(t.length>0){
var e=t.shift();
var n=e.getName();
if(e._expr&&!r[n]){
t.unshift.apply(t,e._expr.dependsArray());
r[n]=true;
o.push(e)
}}
if(!s){
this._expressionCells=o
}
return o
};
ZmSpreadSheetModel.prototype.recompute=function(o){
for(var a=this._expressionCells.length;
--a>=0;
){
var e=this._expressionCells[a];
try{
e.updateExpression()
}
catch(t){
e._td.firstChild.innerHTML="#REF"
}}};
ZmSpreadSheetModel.prototype.fillSeries=function(t,e){};
ZmSpreadSheetModel.prototype.paste=function(r,f){
var n=r.geometry;
var m=r.bounds;
var t=ZmSpreadSheetModel.getRangeGeometry(f);
var u=t.bounds;
var h;
if(t.rows<n.rows){
t.rows=n.rows
}else{
t.rows-=t.rows%n.rows
}
if(t.cols<n.cols){
t.cols=n.cols
}else{
t.cols-=t.cols%n.cols
}
u[1].row=u[0].row+t.rows-1;
u[1].col=u[0].col+t.cols-1;
r.setDelta(u[0].row-m[0].row,u[0].col-m[0].col);
for(h=u[1].row-this.ROWS;
h-->=0;
){
this.insertRow()
}
for(h=u[1].col-this.COLS;
h-->=0;
){
this.insertCol()
}
var a=0;
var o=0;
var l=[];
for(var h=u[0].row;
h<=u[1].row;
++h){
var e=0;
var p=0;
for(var s=u[0].col;
s<=u[1].col;
++s){
var d=this.data[h][s];
r.paste(a,e,d,o,p);
l.push(d);
e++;
if(e==n.cols){
p+=n.cols;
e=0
}}
a++;
if(a==n.rows){
o+=n.rows;
a=0
}}
var c=this._orderExpressionCells(l);
for(var h=0;
h<c.length;
++h){
c[h].recompute()
}
return[ZmSpreadSheetModel.getCellName(u[0].row+1,u[0].col+1),ZmSpreadSheetModel.getCellName(u[1].row+1,u[1].col+1)]
};
ZmSpreadSheetModel.serializeJSObject=function(a){
var e;
var o=ZmSpreadSheetModel.DEBUG?",\n":",";
switch(typeof a){
case"object":if(a==null){
e="null"
}else{
if(a.serialize&&typeof a.serialize=="function"){
e=a.serialize()
}else{
if(a instanceof Array){
e=new Array(a.length);
for(var t=0;
t<a.length;
++t){
e[t]=this.serializeJSObject(a[t])
}
e=["[",e.join(o),"]"].join("")
}else{
e=new Array();
for(var t in a){
e.push(['"',t.replace(/\x22/g,"\\x22"),'":',this.serializeJSObject(a[t])].join(""))
}
e=["{",e.join(o),"}"].join("")
}}}
break;
case"string":e=a.replace(/\n/g,"\\n").replace(/\x5c/g,"\\x5c").replace(/\x22/g,'\\"');
e=['"',e,'"'].join("");
break;
default:e=a
}
return e
};
ZmSpreadSheetModel.deserializeJSObject=function(str){
var tmp=str.replace(/(\x22(\\.|[^\x22\\])*\x22|\x27(\\.|[^\x27\\])*\x27)/g,"");
var forbid=ZmSpreadSheetModel.DEBUG?/([;()+=\x2f*.-])/g:/([\n;()+=\x2f*.-])/g;
if(forbid.test(tmp)){
throw new DwtException("Can't deserialize in ZmSpreadSheetModel: "+RegExp.$1+" characters not allowed.")
}
try{
var foo;
eval(["foo=",str].join(""));
return foo
}
catch(ex){
throw new DwtException("Can't deserialize in ZmSpreadSheetModel: malformed data\n[ "+ex+" ]")
}};
ZmSpreadSheetModel.prototype.serialize=function(){
var e={
ROWS:this.ROWS,COLS:this.COLS,version:1,colProps:this.colProps,data:this.data};
return ZmSpreadSheetModel.serializeJSObject(e)
};
ZmSpreadSheetModel.prototype.deserialize=function(s){
var a=ZmSpreadSheetModel.deserializeJSObject(s);
this.ROWS=a.ROWS;
this.COLS=a.COLS;
this.colProps=a.colProps;
this.version=a.version||0;
var o=this.data=a.data;
for(var t=0;
t<this.ROWS;
++t){
var n=o[t];
for(var e=0;
e<this.COLS;
++e){
n[e]=ZmSpreadSheetCellModel.deserialize(this,n[e])
}}};
ZmSpreadSheetModel.prototype.loadFromXml=function(h){
var a=AjxXmlDoc.createFromXml(h);
if(a){
var u=a.toJSObject(false,false,true);
if(!u){
return
}
var r=(u&&u.Worksheet)?u.Worksheet:null;
var p=(r&&r.ColProps)?r.ColProps:null;
var c=(r&&r.Table)?r.Table:null;
var f=(c&&c.Row)?c.Row:[];
this.ROWS=(c&&c.ExpandedRowCount)?c.ExpandedRowCount:0;
this.COLS=(c&&c.ExpandedColumnCount)?c.ExpandedColumnCount:0;
this.colProps=(p&&p.Col)?p.Col:[];
this.version=(r&&r.version)?r.version:0;
var n=this.data=new Array(this.ROWS);
var s=null;
var o=null;
for(var t=0;
t<this.ROWS;
++t){
if(!f||!f[t]){
continue
}
var l=f[t].Cell;
if(!l){
continue
}
var m=n[t]=new Array(this.COLS);
for(var e=0;
e<this.COLS;
++e){
if(!l[e]){
continue
}
s=l[e];
o={
row:s.row,col:s.col,type:s.type,decimals:s.decimals,editValue:s.editValue,style:s.Style};
m[e]=ZmSpreadSheetCellModel.deserialize(this,o)
}}}};
ZmSpreadSheetModel.prototype.doneSetView=function(){
var r=this.data;
for(var s=0;
s<this.ROWS;
++s){
var h=r[s];
for(var n=0;
n<this.COLS;
++n){
var e=h[n];
e.setEditValue(e._editValue,true)
}}
this._orderExpressionCells();
var t=this._expressionCells;
if(ZmSpreadSheetModel.DEBUG){
var o=[];
for(var s=0;
s<t.length;
++s){
o[s]=t[s].getName()
}
console.log("Computing: %s",o.join(", "))
}
for(var s=0;
s<t.length;
++s){
t[s].recompute()
}};
ZmSpreadSheetModel.prototype.getHtml=function(){
var a=["<table style='font: 8pt tahoma,verdana,sans-serif; background-color: #fff; border-collapse: collapse'>"];
for(var t=0;
t<this.ROWS;
++t){
a.push("<tr>");
for(var e=0;
e<this.COLS;
++e){
a.push(this.data[t][e].getHtml())
}
a.push("</tr>")
}
a.push("</table>");
return a.join("")
};
ZmSpreadSheetModel.prototype.addChart=function(e){
if(!this._charts){
this._charts={}
}
var t=e.getHTMLElId();
this._charts[t]=e
};
ZmSpreadSheetModel.prototype.removeChart=function(e){
if(this._charts){
delete this._charts[e];
if(this._charts[e]){
this._charts[e]=null
}}};
ZmSpreadSheetModel.prototype.getXML=function(v){
var d=AjxXmlDoc.createRoot("WorkBook");
d.root.setAttribute("version",1);
var c=AjxXmlDoc.createElement("WorkSheets");
var u=AjxXmlDoc.createElement("WorkSheet");
u.root.setAttribute("name","Sheet1");
if(v.selRow&&v.selCol){
var e=AjxXmlDoc.createElement("Selection");
e.root.setAttribute("row",v.selRow);
e.root.setAttribute("col",v.selCol);
u.appendChild(e)
}
var w=AjxXmlDoc.createElement("Cols");
var s=ZmSpreadSheetModel.getDefaultColProp().width,k,h,p=false;
for(var g=0;
g<this.COLS;
++g){
k=this.colProps[g].width;
if(k!=s){
h=AjxXmlDoc.createElement("Col");
h.root.setAttribute("col",g+1);
h.root.setAttribute("width",this.colProps[g].width);
w.appendChild(h);
p=true
}}
if(p){
u.appendChild(w)
}
var l=this.getChartsXML();
if(l){
u.appendChild(l)
}
var m=AjxXmlDoc.createElement("SheetData");
var r,x,n,p=false,a=0,q=0,o;
var y=ZmSpreadSheetModel.getDefaultRowProp().height;
for(var g=0;
g<this.ROWS;
++g){
p=false;
r=AjxXmlDoc.createElement("Row");
r.root.setAttribute("row",g+1);
for(var f=0;
f<this.COLS;
++f){
o=this.data[g][f];
x=o.getXML(g+1,f+1);
if(x){
a=o.getRow();
q=o.getCol();
r.appendChild(x);
p=true
}}
n=this.rowProps[g].height;
if(n!=y){
r.root.setAttribute("height",n);
p=true
}
if(p){
m.appendChild(r)
}}
var t=AjxXmlDoc.createElement("Active");
t.root.setAttribute("row",a);
t.root.setAttribute("col",q);
u.appendChild(t);
u.appendChild(m);
c.appendChild(u);
d.appendChild(c);
return d
};
ZmSpreadSheetModel.prototype.getChartsXML=function(){
if(!this._charts){
return null
}
var a=AjxXmlDoc.createElement("Charts");
var r,e=false;
for(var s in this._charts){
var t=this._charts[s];
r=AjxXmlDoc.createElement("Chart");
r.root.setAttribute("type",t.getChartType());
var o=t.getChartRange();
r.root.setAttribute("srow",o.sRow);
r.root.setAttribute("scol",o.sCol);
r.root.setAttribute("erow",o.eRow);
r.root.setAttribute("ecol",o.eCol);
var n=t.getChartPos();
if(n){
r.root.setAttribute("x",n.x);
r.root.setAttribute("y",n.y)
}
a.appendChild(r);
e=true
}
return(e?a:null)
};
ZmSpreadSheetModel.MIN_ROWS=40;
ZmSpreadSheetModel.MIN_COLS=15;
ZmSpreadSheetModel.prototype.loadFromXML=function(a){
var n=AjxXmlDoc.createFromXml(a);
if(!n){
return
}
var T=n.toJSObject(false,false,true);
if(!T){
return
}
this.version=T.version;
var k=T.WorkSheets;
k=(k)?k.WorkSheet:null;
if(!k){
return
}
var l=(k instanceof Array)?k[0]:k;
var h,u,s,v;
h=l.Active;
var f=h?new Number(h.row):0;
var p=h?new Number(h.col):0;
this.ROWS=f=(f<=ZmSpreadSheetModel.MIN_ROWS)?ZmSpreadSheetModel.MIN_ROWS:f+5;
this.COLS=p=(p<=ZmSpreadSheetModel.MIN_COLS)?ZmSpreadSheetModel.MIN_COLS:p+3;
this.colProps=new Array(this.COLS);
for(v=0;
v<this.colProps.length;
v++){
this.colProps[v]=ZmSpreadSheetModel.getDefaultColProp()
}
this.rowProps=new Array(this.ROWS);
for(v=0;
v<this.rowProps.length;
v++){
this.rowProps[v]=ZmSpreadSheetModel.getDefaultRowProp()
}
u=l.Cols;
if(u&&u.Col){
u=u.Col;
if(!(u instanceof Array)){
u=[u]
}
for(var v=0;
v<u.length;
v++){
s=new Number(u[v].col)-1;
this.colProps[s].width=u[v].width
}}
var g,q=l.Charts;
if(q&&q.Chart){
this._rawCharts=[];
q=q.Chart;
if(!(q instanceof Array)){
q=[q]
}
for(v=0;
v<q.length;
v++){
g=q[v];
this._rawCharts.push({
type:g.type,sRow:g.srow,sCol:g.scol,eRow:g.erow,eCol:g.ecol,x:g.x,y:g.y}
)
}}
var z,r,c,y,o,t,m,x;
function e(A,O){
var W=null;
for(var j=0;
j<A.length;
j++){
if(A[j].row==O){
W=A[j];
break
}}
return W
}
function d(A,W){
var O=null;
for(var j=0;
j<A.length;
j++){
if(A[j].col==W){
O=A[j];
break
}}
return O
}
z=l.SheetData;
c=z.Row;
if(c){
c=(c instanceof Array)?c:[c]
}
this.data=new Array(this.ROWS);
for(v=0;
v<this.ROWS;
++v){
this.data[v]=r=new Array(this.COLS);
x=c?e(c,v+1):null;
if(x){
if(x.height){
this.rowProps[v].height=x.height
}
o=x.Cell;
if(o&&!(o instanceof Array)){
o=[o]
}}
for(var w=0;
w<this.COLS;
++w){
if(o){
t=d(o,w+1)
}
t=t||{
row:v+1,col:w+1,type:"",decimals:"",editValue:""};
m={
row:t.row,col:t.col,type:t.type,decimals:t.decimals,editValue:t.value,style:t.Style};
r[w]=ZmSpreadSheetCellModel.deserialize(this,m)
}
o=null;
x=null
}};
ZmSpreadSheetClipboard=function(n,o,t){
this._move=!!t;
this.model=n;
this.geometry=ZmSpreadSheetModel.getRangeGeometry(o);
this.range=o;
this.bounds=this.geometry.bounds;
var e=this.cells=n.getCellsInRange(o);
if(!t){
for(var s=e.length;
--s>=0;
){
e[s]=e[s].clone()
}}};
ZmSpreadSheetClipboard.prototype.getCell=function(t,e){
return this.cells[t*this.geometry.cols+e]
};
ZmSpreadSheetClipboard.prototype.setDelta=function(e,t){
this.delta={
rows:e,cols:t}
};
ZmSpreadSheetClipboard.prototype.paste=function(d,a,l,o,c){
var t=this.getCell(d,a);
for(var s in t._style){
l._style[s]=t._style[s]
}
if(t._expr){
var r=t._expr;
var n=r.shift(this.delta.rows+o,this.delta.cols+c);
l._type=t._type;
l._decimals=t._decimals;
l.setEditValue("="+n)
}else{
l._type=t._type;
l._autoType=t._autoType;
l._decimals=t._decimals;
l.setEditValue(t.getEditValue())
}
if(this._move&&!t._wasCut){
var h=t.clone();
this.cells[d*this.geometry.cols+a]=h;
h._wasCut=true;
t.clearAll()
}};
ZmSpreadSheetCellModel=function(t,o,e,a){
if(e==null){
e=""
}
if(o==null){
o=null
}
this._model=t;
this._td=null;
this._decimals=null;
this._type=o;
this._autoType=null;
this._editValue=e;
this._value=e;
this._style=ZmSpreadSheetCellModel.getDefaultStyle(a);
this._expr=null;
this._affects=[]
};
ZmSpreadSheetCellModel.defaultStyle={
fontFamily:"",fontWeight:"",fontStyle:"",fontSize:"",backgroundColor:"",color:"",textAlign:"",verticalAlign:"",textDecoration:""};
ZmSpreadSheetCellModel.prototype.serialize=function(){
var e={
decimals:this._decimals,type:this._type,editValue:this._editValue,style:this._style,row:this.getRow(),col:this.getCol()};
return ZmSpreadSheetModel.serializeJSObject(e)
};
ZmSpreadSheetCellModel.deserialize=function(t,a){
var e=new ZmSpreadSheetCellModel(t,a.type,a.editValue,a.style);
e._decimals=a.decimals;
e._savedRow=a.row;
e._savedCol=a.col;
return e
};
ZmSpreadSheetCellModel.getDefaultStyle=function(a){
if(!a){
a={}
}
var t=ZmSpreadSheetCellModel.defaultStyle;
for(var e in t){
if(typeof a[e]=="undefined"){
a[e]=t[e]
}}
return a
};
ZmSpreadSheetCellModel.prototype.clone=function(){
var t=new ZmSpreadSheetCellModel(null);
t._decimals=this._decimals;
t._type=this._type;
t._autoType=this._autoType;
t._editValue=this._editValue;
t._value=this._value;
t._expr=this._expr;
for(var e in this._style){
t._style[e]=this._style[e]
}
return t
};
ZmSpreadSheetCellModel.prototype.getHtml=function(){
var n=[];
for(var a in this._style){
if(this._style[a]!=""){
var e=a.replace(/([a-z])([A-Z])([a-z])/g,function(c,l,h,r){
return l+"-"+h.toLowerCase()+r
}
);
n.push(e+":"+this._style[a])
}}
var o=this._model.getColWidth(this.getCol()-1);
if(AjxEnv.isIE){
o-=2
}
n.push("width:"+o+"px");
n.push("border:1px solid #aaa");
if(n.length>0){
n=[" style='",n.join(";"),"'"].join("")
}else{
n=""
}
var t=this.getType();
if(t){
var t=" class='SpreadSheet-Type-"+t+"'"
}else{
t=""
}
var s=AjxStringUtil.htmlEncode(this.getDisplayValue().toString());
if(s==""){
s="&nbsp;"
}
return["<td",t,n,">",s,"</td>"].join("")
};
ZmSpreadSheetCellModel.prototype.getXML=function(r,a){
var h=AjxXmlDoc.createElement("Style");
var t=false;
for(var o in this._style){
if(this._style[o]!=""){
var e=o;
if(e!="toString"){
h.root.setAttribute(e,this._style[o]);
t=true
}}}
if(!t&&!this._editValue&&!this._decimals&&!this._type){
return null
}
var s=AjxXmlDoc.createElement("Cell");
var n=s.root;
n.setAttribute("row",r);
n.setAttribute("col",a);
n.setAttribute("value",(this._editValue?this._editValue:""));
if(this._decimals){
n.setAttribute("decimals",(this._decimals?this._decimals:""))
}
if(this._type){
n.setAttribute("type",(this._type?this._type:""))
}
if(t){
s.appendChild(h)
}
return s
};
ZmSpreadSheetCellModel.prototype.setToElement=function(t){
var o=t.firstChild;
if(!o){
t.innerHTML="<div class='Wrapper'></div>";
o=t.firstChild
}
var a=this.getDisplayValue();
if(!/\S/.test(a)){
a="\xA0"
}else{
a=a.toString().replace(/\s/g,"\xA0")
}
o.innerHTML="";
o.appendChild(document.createTextNode(a));
this.setStyleToElement(t);
if(this._expr){
Dwt.addClass(t,"hasFormula")
}else{
Dwt.delClass(t,"hasFormula")
}
var e=this.getType();
if(e){
t.className=t.className.replace(/(^|\s)SpreadSheet-Type-.*?(\s|$)/g," ");
Dwt.addClass(t,"SpreadSheet-Type-"+e)
}};
ZmSpreadSheetCellModel.prototype.setStyleToElement=function(a,e){
for(var t in this._style){
var o=this._style[t];
switch(t){
default:a.style[t]=o
}}};
ZmSpreadSheetCellModel.prototype._mkDeps=function(){
var a=[];
var t={};
function e(o){
var n=o._affects,r=0,h,s;
while(h=n[r++]){
s=h.getName();
if(!t[s]){
t[s]=true;
e(h);
a.unshift(h)
}}}
e(this);
return a
};
ZmSpreadSheetCellModel.prototype.setValue=function(n,t){
if(!this._settingValue){
this._settingValue=true;
this._value=n;
this._model.triggerEvent("onCellValue",this.getRow(),this.getCol(),this);
if(!t){
var e=this._mkDeps();
for(var o=0;
o<e.length;
++o){
e[o].recompute()
}}
this._settingValue=false
}};
ZmSpreadSheetCellModel.prototype.getValue=function(){
switch(this.getType()){
case"currency":case"percentage":case"number":return ZmSpreadSheetFormulae.parseFloat(this._value)
}
return this._value
};
ZmSpreadSheetCellModel.prototype.getEditValue=function(){
return this._editValue
};
ZmSpreadSheetCellModel.prototype.getDisplayValue=function(){
var s=this.getValue();
var o=this.getType();
switch(o){
case"number":if(!/\S/.test(this._editValue)){
s=""
}else{
s=ZmSpreadSheetFormulae.parseFloat(s);
if(this._decimals!=null){
s=s.toFixed(this._decimals)
}}
break;
case"currency":s=ZmSpreadSheetFormulae.parseFloat(s);
if(this._decimals!=null){
s=s.toFixed(this._decimals)
}
s="$"+s;
break;
case"percentage":s=ZmSpreadSheetFormulae.parseFloat(s);
if(this._decimals!=null){
s=s.toFixed(this._decimals)
}
s=s+"%";
break;
case"date":this._formatter=new AjxDateFormat("MM/dd/yy");
var t=null;
for(var a in ZmSpreadSheetModel.DATE_FORMATS){
var n=ZmSpreadSheetModel.DATE_FORMATS[a];
var e=(new AjxDateFormat(n)).parse(s);
if(e){
t=e;
break
}}
s=t?this._formatter.format(t):s;
break
}
return s
};
ZmSpreadSheetCellModel.prototype.setExpression=function(s){
var e=this._model._expressionCells;
for(var n=e.length;
--n>=0;
){
if(e[n]===this){
e.splice(n,1)
}}
if(this._expr){
var r=this._expr.depends();
for(var n in r){
var t=r[n]._affects;
for(var o=t.length;
--o>=0;
){
if(t[o]===this){
t.splice(o,1)
}}}}
this._expr=s;
if(s){
e.push(this);
var r=this._expr.depends();
for(var n in r){
r[n]._affects.push(this)
}}};
ZmSpreadSheetCellModel.prototype.recompute=function(){
this.setValue(this._expr.eval(),true)
};
ZmSpreadSheetCellModel.prototype.updateExpression=function(){
if(this._expr){
var e=this._expr.update();
if(e){
this._editValue="="+e;
this.recompute()
}}};
ZmSpreadSheetCellModel.prototype._determineType=function(a){
var t=a;
var e=null;
if(/^\x27(.*)$/.test(a)){
e="string";
t=RegExp.$1
}else{
if(/^=(.+)$/.test(a)){
t=RegExp.$1;
if(/\S/.test(t)){
e="expression"
}else{
t=a
}}else{
if(/^(\-?[0-9]*\.?[0-9]+)$/.test(a)){
e="number";
t=RegExp.$1
}else{
if(/^\$\s*(\-?[0-9]*\.?[0-9]+)$/.test(a)||/^(\-?[0-9]*\.?[0-9]+)\$$/.test(a)){
e="currency";
t=RegExp.$1;
if(this._decimals==null){
this._decimals=2
}}else{
if(/^(\-?[0-9]*\.?[0-9]+)\s*%$/.test(a)){
e="percentage";
t=RegExp.$1
}else{
if(/^(\d{1,2})(\/|-|\.)(\d{1,2})(\/|-|\.)(\d{2}|\d{4})$/.test(a)){
if(AjxDateUtil.validDate(RegExp.$5,(RegExp.$1-1),RegExp.$3)){
e="date";
this._editValue=t=[RegExp.$1,"/",RegExp.$3,"/",RegExp.$5].join("")
}}}}}}}
return{
type:e,val:t}
};
ZmSpreadSheetCellModel.prototype.getType=function(){
return this._type||this._autoType||"string"
};
ZmSpreadSheetCellModel.prototype.setType=function(e){
this._type=e;
if(e==null){
var t=this._determineType(this.getValue());
this._value=t.val;
this._type=t.type
}else{
if(e=="currency"&&this._decimals==null){
this._decimals=2
}}
if(this._td){
this.setToElement(this._td)
}};
ZmSpreadSheetCellModel.prototype.getDecimals=function(){
return this._decimals
};
ZmSpreadSheetCellModel.prototype.setDecimals=function(t){
this._decimals=t;
var e=this.getType();
if(e=="currency"&&t==null){
this._decimals=2
}
if(this._td){
this.setToElement(this._td)
}};
ZmSpreadSheetCellModel.prototype.clearValue=function(){
this._type=null;
this.setEditValue("")
};
ZmSpreadSheetCellModel.prototype.clearStyle=function(){
this._style=ZmSpreadSheetCellModel.getDefaultStyle();
if(this._td){
this.setStyleToElement(this._td)
}};
ZmSpreadSheetCellModel.prototype.clearAll=function(){
this._type=this._decimals=null;
this.clearStyle();
this.clearValue()
};
ZmSpreadSheetCellModel.prototype.setEditValue=function(editValue,force){
if(force||editValue!=this._editValue){
this._editValue=editValue;
var val=editValue;
var auto=this._determineType(editValue);
this._autoType=auto.type;
if(auto.type=="expression"){
var expr;
try{
expr=new ZmSpreadSheetFormulae(this._model,auto.val);
this._errorMessage=null
}
catch(ex){
expr=null;
this._errorMessage=ex;
val="#ERROR"
}
this.setExpression(expr);
if(expr){
val=expr.eval();
if(expr.decimals!=null&&this._decimals==null){
this._decimals=expr.decimals
}
auto=this._determineType(val);
this._autoType=expr.autoType||auto.type;
if(this._autoType=="currency"){
val=auto.val
}}else{
this._type=null;
this._autoType="error"
}}else{
this.setExpression(null);
val=auto.val;
if(auto.type=="string"){
if(!/^([\x27=]|\$?[0-9]+\.?[0-9]*$)/.test(val)){
this._editValue=editValue=val
}}}
this.setValue(val)
}};
ZmSpreadSheetCellModel.prototype.getEditValue=function(){
return this._expr?"="+this._expr.getFormula():this._editValue
};
ZmSpreadSheetCellModel.prototype.getRow=function(){
if(this._td){
return this._td.parentNode.rowIndex
}else{
return this._savedRow
}};
ZmSpreadSheetCellModel.prototype.getCol=function(){
if(this._td){
return this._td.cellIndex
}else{
return this._savedCol
}};
ZmSpreadSheetCellModel.prototype._getTD=function(){
return this._td
};
ZmSpreadSheetCellModel.prototype.getName=function(){
if(this._td||(this._savedRow&&this._savedCol)){
return ZmSpreadSheetModel.getCellName(this.getRow(),this.getCol())
}else{
return"##"
}};
ZmSpreadSheetCellModel.prototype.setStyleProp=function(t,e){
this._style[t]=e;
if(this._td){
this.setStyleToElement(this._td)
}};
ZmSpreadSheetCellModel.prototype.getStyleProp=function(e){
return this._style[e]
};
ZmSpreadSheetCellModel.prototype.isEmpty=function(){
return this._editValue==""
};
ZmSpreadSheetCellModel.prototype.getTooltipText=function(){
var o=["<div class='ZmSpreadSheet-Tooltip'>","<div class='CellName'>",ZmMsg.cell," - ",this.getName(),"</div>"];
if(!this.isEmpty()){
o.push("<div class='CellType'>",ZmMsg.type,": ",this.getType(),"</div>")
}else{
o.push("<div class='CellType'>",ZmMsg.emptyCell,"</div>")
}
if(this._errorMessage){
o.push(ZmMsg.editValue,": ",this._editValue);
o.push("<div class='CellExprError'>",this._errorMessage,"</div>")
}else{
if(this._expr){
o.push(ZmMsg.expression,":");
o.push("<div class='CellExpr'>[",this._expr.toString(),"]</div>")
}}
if(ZmSpreadSheetModel.DEBUG){
var e=this._affects;
if(e.length>0){
o.push("Directly affects cells:<br />");
for(var t=0;
t<e.length;
++t){
o.push(e[t].getName()," ")
}
o.push("<br />")
}
e=this._mkDeps();
if(e.length>0){
o.push("Affects cells:<br />");
for(var t=0;
t<e.length;
++t){
o.push(e[t].getName()," ")
}
o.push("<br />")
}
var n=this._td.firstChild;
if(n.offsetWidth>=this._td.offsetWidth){
o.push("Value:","<div class='CellValue'>",this.getDisplayValue(),"</div>")
}}
o.push("</div>");
return o.join("")
}
}
if(AjxPackage.define("zimbraMail.spreadsheets.model.ZmSpreadSheetFormulae")){
ZmSpreadSheetFormulae=function(e,t){
this._model=e;
if(t){
this.compile(t)
}};
ZmSpreadSheetFormulae.TOKEN={
STRING:{
match:{
exec:function(e){
if(!(/^([\x22\x27])/.test(e))){
return null
}
var a=RegExp.$1;
var t=false;
var n="";
for(var o=1;
o<e.length;
++o){
var s=e.charAt(o);
if(!t&&s=="\\"){
t=true
}else{
if(s==a&&!t){
return[e.substr(0,o+1),n]
}
if(t){
switch(s){
case"n":s="\n";
break;
case"t":s="\t";
break
}}
n+=s;
t=false
}}
throw"Unfinished string: "+e
}}
,getVal:function(e){
return e[1]
}
,isOpr:true,type:"string"}
,NUMBER:{
match:/^([0-9]*\.?[0-9]+)/,getVal:function(e){
return parseFloat(e[1],10)
}
,isOpr:true,isNumber:true,type:"number"}
,CURRENCY:{
match:/^\$\s*([0-9]*\.?[0-9]+)/,getVal:function(e){
return parseFloat(e[1],10)
}
,isOpr:true,isNumber:true,type:"currency"}
,CELLRANGE:{
match:/^([a-z]+[0-9]+:[a-z]+[0-9]+)/i,getVal:function(e){
return e[1].toUpperCase()
}
,isOpr:true,type:"cellrange"}
,CELL:{
match:/^([a-z]+[0-9]+)/i,getVal:function(e){
return e[1].toUpperCase()
}
,isOpr:true,type:"cell"}
,OPERATOR:{
match:/^(<=|>=|==|!=|lt|gt|eq|uc|lc|ne|&&|and|\|\||or|not|[-x*\/+%^.<>!])/,getVal:function(e){
return e[1]
}
,isOpr:false,type:"operator"}
,IDENTIFIER:{
match:/^([a-z_][a-z0-9_?]*)/i,getVal:function(e){
return e[1]
}
,isOpr:false,type:"identifier"}
,OPENPAREN:{
match:new RegExp("^\\("),getVal:function(e){
return e[0]
}
,isOpr:false,type:"openparen"}
,CLOSEPAREN:{
match:/^\)/,getVal:function(e){
return e[0]
}
,isOpr:false,type:"closeparen"}
,COMMA:{
match:new RegExp("^,"),getVal:function(e){
return e[0]
}
,isOpr:false,type:"comma"}};
ZmSpreadSheetFormulae.parseFloat=function(t,e){
if(typeof t=="boolean"){
return t?1:0
}
t=parseFloat(t,10);
if(isNaN(t)){
t=e?e:0
}
return t
};
ZmSpreadSheetFormulae.OPERATORS={
"+":{
priority:10,assoc:3,n_args:2}
,"-":{
priority:10,assoc:2,n_args:2}
,"*":{
priority:20,assoc:3,n_args:2}
,"/":{
priority:20,assoc:2,n_args:2}
,"%":{
priority:30,assoc:2,n_args:2}
,"^":{
priority:30,assoc:2,n_args:2}
,".":{
priority:5,assoc:2,n_args:2}
,lc:{
priority:5,assoc:1,n_args:1}
,uc:{
priority:5,assoc:1,n_args:1}
,x:{
priority:35,assoc:2,n_args:2}
,"<":{
priority:3,assoc:2,n_args:2}
,">":{
priority:3,assoc:2,n_args:2}
,"<=":{
priority:3,assoc:2,n_args:2}
,">=":{
priority:3,assoc:2,n_args:2}
,"==":{
priority:3,assoc:2,n_args:2}
,"!=":{
priority:3,assoc:2,n_args:2}
,lt:{
priority:3,assoc:2,n_args:2}
,gt:{
priority:3,assoc:2,n_args:2}
,eq:{
priority:3,assoc:2,n_args:2}
,ne:{
priority:3,assoc:2,n_args:2}
,"&&":{
priority:2,assoc:2,n_args:2}
,and:{
priority:2,assoc:2,n_args:2}
,"||":{
priority:2,assoc:2,n_args:2}
,or:{
priority:2,assoc:2,n_args:2}
,"!":{
priority:4,assoc:1,n_args:1}
,not:{
priority:4,assoc:1,n_args:1}};
ZmSpreadSheetFormulae.FUNCTIONS={};
ZmSpreadSheetFormulae.getFunc=function(e){
return ZmSpreadSheetFormulae.FUNCTIONS[e.toLowerCase()]
};
ZmSpreadSheetFormulae.HELP={};
ZmSpreadSheetFormulae.getHelp=function(t){
var a=ZmSpreadSheetFormulae.HELP[t];
var e=null;
if(a){
e=a.help;
if(a.args){
e+="<br />"+a.args
}}
return e
};
ZmSpreadSheetFormulae.DEF=function(a,t,h,e){
if(a instanceof Array){
var r=a[0];
var s;
ZmSpreadSheetFormulae.DEF(r,t,h,e);
if(e&&a.length>1){
var n={
alias:r};
for(s in e){
n[s]=e[s]
}
e=n
}
for(s=1;
s<a.length;
++s){
ZmSpreadSheetFormulae.DEF(a[s],t,h,e)
}}else{
var o={
name:a,n_args:t,func:h};
ZmSpreadSheetFormulae.FUNCTIONS[a.toLowerCase()]=o;
if(e){
ZmSpreadSheetFormulae.HELP[a]=e
}}};
ZmSpreadSheetFormulae.DEF(["sum","+"],-1,function(){
var e=0;
for(var t=arguments.length;
--t>=0;
){
e+=ZmSpreadSheetFormulae.parseFloat(arguments[t])
}
return e
}
,ZmMsg.SS.func.sum);
ZmSpreadSheetFormulae.DEF(["multiply","*"],-1,function(){
var e=1;
for(var t=arguments.length;
--t>=0;
){
e*=ZmSpreadSheetFormulae.parseFloat(arguments[t],1)
}
return e
}
,ZmMsg.SS.func.multiply);
ZmSpreadSheetFormulae.DEF(["modulo","%"],2,function(t,e){
return ZmSpreadSheetFormulae.parseFloat(t)%ZmSpreadSheetFormulae.parseFloat(e)
}
,ZmMsg.SS.func.modulo);
ZmSpreadSheetFormulae.DEF(["average","avg"],-1,function(){
var t=arguments.length;
var a=0;
for(var e=t;
--e>=0;
){
var o=arguments[e];
if(!/\S/.test(o)){
o=NaN
}
if(!isNaN(o)){
o=ZmSpreadSheetFormulae.parseFloat(o,NaN)
}
if(!isNaN(o)){
a+=o
}else{
--t
}}
return a/t
}
,ZmMsg.SS.func.average);
ZmSpreadSheetFormulae.DEF("PI",0,function(){
return Math.PI
}
,ZmMsg.SS.func.PI);
ZmSpreadSheetFormulae.DEF("sin",1,function(e){
return Math.sin(e)
}
,ZmMsg.SS.func.sin);
ZmSpreadSheetFormulae.DEF("cos",1,function(e){
return Math.cos(e)
}
,ZmMsg.SS.func.cos);
ZmSpreadSheetFormulae.DEF("tan",1,function(e){
return Math.tan(e)
}
,ZmMsg.SS.func.tan);
ZmSpreadSheetFormulae.DEF("round",1,function(e){
return Math.round(e)
}
,ZmMsg.SS.func.round);
ZmSpreadSheetFormulae.DEF("ceil",1,function(e){
return Math.ceil(e)
}
,ZmMsg.SS.func.ceil);
ZmSpreadSheetFormulae.DEF("floor",1,function(e){
return Math.floor(e)
}
,ZmMsg.SS.func.floor);
ZmSpreadSheetFormulae.DEF("abs",1,function(e){
return Math.abs(e)
}
,ZmMsg.SS.func.abs);
ZmSpreadSheetFormulae.DEF("sqrt",1,function(e){
return Math.sqrt(e)
}
,ZmMsg.SS.func.sqrt);
ZmSpreadSheetFormulae.DEF("exp",1,function(e){
return Math.exp(e)
}
,ZmMsg.SS.func.exp);
ZmSpreadSheetFormulae.DEF("log",1,function(e){
return Math.log(e)
}
,ZmMsg.SS.func.log);
ZmSpreadSheetFormulae.DEF("min",-1,function(){
var t=arguments[0];
for(var e=1;
e<arguments.length;
++e){
if(t>arguments[e]){
t=arguments[e]
}}
return t
}
,ZmMsg.SS.func.min);
ZmSpreadSheetFormulae.DEF("max",-1,function(){
var e=arguments[0];
for(var t=1;
t<arguments.length;
++t){
if(e<arguments[t]){
e=arguments[t]
}}
return e
}
,ZmMsg.SS.func.max);
ZmSpreadSheetFormulae.DEF("len",1,function(e){
return e.toString().length
}
,ZmMsg.SS.func.len);
ZmSpreadSheetFormulae.DEF(["concat","."],-1,function(){
var e=[arguments[0]];
for(var t=1;
t<arguments.length;
++t){
if(arguments[t]!=""){
e.push(arguments[t])
}}
return e.join("")
}
,ZmMsg.SS.func.concat);
ZmSpreadSheetFormulae.DEF("join",-2,function(t){
var e=[arguments[1]];
for(var a=2;
a<arguments.length;
++a){
if(arguments[a]!=""){
e.push(arguments[a])
}}
return e.join(t)
}
,ZmMsg.SS.func.join);
ZmSpreadSheetFormulae.DEF("x",2,function(a,t){
var e="";
while(t-->0){
e+=a
}
return e
}
);
ZmSpreadSheetFormulae.DEF("<",2,function(t,e){
return ZmSpreadSheetFormulae.parseFloat(t)<ZmSpreadSheetFormulae.parseFloat(e)
}
);
ZmSpreadSheetFormulae.DEF(">",2,function(t,e){
return ZmSpreadSheetFormulae.parseFloat(t)>ZmSpreadSheetFormulae.parseFloat(e)
}
);
ZmSpreadSheetFormulae.DEF("<=",2,function(t,e){
return ZmSpreadSheetFormulae.parseFloat(t)<=ZmSpreadSheetFormulae.parseFloat(e)
}
);
ZmSpreadSheetFormulae.DEF(">=",2,function(t,e){
return ZmSpreadSheetFormulae.parseFloat(t)>=ZmSpreadSheetFormulae.parseFloat(e)
}
);
ZmSpreadSheetFormulae.DEF("==",2,function(t,e){
return t==e
}
);
ZmSpreadSheetFormulae.DEF("!=",2,function(t,e){
return t!=e
}
);
ZmSpreadSheetFormulae.DEF(["&&","and"],2,function(t,e){
return t&&e
}
);
ZmSpreadSheetFormulae.DEF(["||","or"],2,function(t,e){
return t||e
}
);
ZmSpreadSheetFormulae.DEF(["!","not"],1,function(e){
return !e
}
);
ZmSpreadSheetFormulae.DEF("lt",2,function(t,e){
return t.toString()<e.toString()
}
);
ZmSpreadSheetFormulae.DEF("gt",2,function(t,e){
return t.toString()>e.toString()
}
);
ZmSpreadSheetFormulae.DEF("eq",2,function(t,e){
return t.toString()==e.toString()
}
);
ZmSpreadSheetFormulae.DEF("ne",2,function(t,e){
return t.toString()!=e.toString()
}
);
ZmSpreadSheetFormulae.DEF("lc",1,function(e){
return e.toString().toLowerCase()
}
);
ZmSpreadSheetFormulae.DEF("uc",1,function(e){
return e.toString().toUpperCase()
}
);
ZmSpreadSheetFormulae.DEF("if",3,function(a,e,t){
return a?e:t
}
);
ZmSpreadSheetFormulae.DEF("WHO_are_YOU?",0,function(){
return"http://www.zimbra.com/"
}
);
ZmSpreadSheetFormulae.DEF("-",2,function(t,e){
return ZmSpreadSheetFormulae.parseFloat(t)-ZmSpreadSheetFormulae.parseFloat(e)
}
);
ZmSpreadSheetFormulae.DEF("/",2,function(t,e){
return ZmSpreadSheetFormulae.parseFloat(t)/ZmSpreadSheetFormulae.parseFloat(e)
}
);
ZmSpreadSheetFormulae.DEF("^",2,function(t,e){
return Math.pow(t,e)
}
);
ZmSpreadSheetFormulae.prototype.depends=function(e){
return e!=null?this._deps[e]:this._deps
};
ZmSpreadSheetFormulae.prototype.dependsArray=function(){
return this._depsArray
};
ZmSpreadSheetFormulae.prototype.callFunction=function(t,e){
var a=ZmSpreadSheetFormulae.getFunc(t);
if(!a){
throw"No such function: "+t
}
return a.func.apply(this,e)
};
ZmSpreadSheetFormulae.prototype._analyzeRange=function(g){
var o=g.val;
var m=o.split(/:/);
var l=ZmSpreadSheetModel.identifyCell(m[0]);
var s=ZmSpreadSheetModel.identifyCell(m[1]);
var f=g.startRow=Math.min(l.row,s.row);
var t=g.startCol=Math.min(l.col,s.col);
var r=g.endRow=Math.max(l.row,s.row);
var d=g.endCol=Math.max(l.col,s.col);
g.startCell=this._model.data[f][t];
g.endCell=this._model.data[r][d];
var p=g.cells=[];
for(var h=f;
h<=r;
++h){
for(var n=t;
n<=d;
++n){
var u=this._model.data[h][n];
p.push(u);
var e=ZmSpreadSheetModel.getCellName(h+1,n+1);
if(!this._deps[e]){
this._deps[e]=u;
this._depsArray.push(u)
}}}};
ZmSpreadSheetFormulae.prototype.update=function(){
var h=this._formula,e=this._cellTokens,r=ZmSpreadSheetFormulae.TOKEN;
for(var s=e.length;
--s>=0;
){
var n=e[s];
var o=null;
if(n.type===r.CELL){
o=n.cell.getName()
}
if(n.type===r.CELLRANGE){
o=n.startCell.getName()+":"+n.endCell.getName()
}
if(o&&n.val!=o){
h=[h.substr(0,n.strPos),o,h.substr(n.strPos+n.strLen)].join("")
}}
if(h!=this._formula){
this.compile(h);
return h
}};
ZmSpreadSheetFormulae.prototype.shift=function(r,h){
var c=this._formula,e=this._cellTokens,l=ZmSpreadSheetFormulae.TOKEN;
for(var s=e.length;
--s>=0;
){
var n=e[s];
var o=null;
if(n.type===l.CELL){
o=ZmSpreadSheetModel.shiftCell(n.val,r,h)
}
if(n.type===l.CELLRANGE){
o=ZmSpreadSheetModel.shiftRange(n.val,r,h)
}
if(o&&n.val!=o){
c=[c.substr(0,n.strPos),o,c.substr(n.strPos+n.strLen)].join("")
}}
return c
};
ZmSpreadSheetFormulae.prototype.getFormula=function(){
return this._formula
};
ZmSpreadSheetFormulae.parseTokens=function(c,s){
var l=ZmSpreadSheetFormulae.TOKEN;
var d=[];
var u=0;
function g(t){
return t[t.length-1]
}
while(c.length>0){
var m=/^\s+/.exec(c);
if(m){
var h=m[0].length;
u+=h;
c=c.substr(h)
}
var y=false;
for(var r in l){
var p=l[r];
var m=p.match.exec(c);
if(m){
var e=p.getVal(m);
var h=m[0].length;
c=c.substr(h);
var f={
type:p,val:e,isOpr:p.isOpr,strPos:u,strLen:h};
u+=h;
if(p===l.OPERATOR){
var n=ZmSpreadSheetFormulae.OPERATORS[e];
f.priority=n.priority;
f.assoc=n.assoc;
f.n_args=n.n_args
}
if(p===l.IDENTIFIER){
var o=ZmSpreadSheetFormulae.getFunc(e);
if(!o&&!s){
throw'No such function: "'+e+'"'
}
f.priority=100;
if(o&&o.n_args==0){
f.isOpr=true;
f.val=o.func()
}}
d.push(f);
y=true;
break
}}
if(!y){
if(!s){
throw"Parse error at: "+c
}else{
c=c.substr(1);
++u
}}}
return d
};
ZmSpreadSheetFormulae.prototype.getTokens=function(){
return this._tokens
};
ZmSpreadSheetFormulae.prototype.compile=function(h){
this._formula=new String(h);
this._deps={};
this._depsArray=[];
this._cellTokens=[];
this._running=false;
var r=ZmSpreadSheetFormulae.TOKEN;
function p(t){
return t[t.length-1]
}
var l=this._tokens=ZmSpreadSheetFormulae.parseTokens(h);
var u=null;
var m=0;
var y=false;
for(var n=0;
n<l.length;
++n){
var f=l[n];
var s=l[n+1];
if(f.type===r.OPERATOR&&!s){
throw"Misplaced operator"
}
if(u){
if(f.type===r.COMMA&&(u.type===r.COMMA||u.type===r.OPENPAREN)){
throw"Misplaced comma"
}}
if(f.type===r.CELL){
f.val=f.val.toUpperCase();
var d=ZmSpreadSheetModel.identifyCell(f.val);
this._model.checkBounds(d.row,d.col);
f.cell=this._deps[f.val];
if(!f.cell){
f.cell=this._deps[f.val]=this._model.data[d.row][d.col];
this._depsArray.push(f.cell)
}
this._cellTokens.push(f)
}
if(f.type===r.CELLRANGE){
this._analyzeRange(f);
this._cellTokens.push(f)
}
if(f.type===r.OPENPAREN){
m++;
if(u&&u.isOpr){
throw"Paren after operand"
}}
if(f.type===r.CLOSEPAREN){
m--
}
if(f.type===r.OPERATOR&&f.val=="-"&&(!u||!u.isOpr)&&s.type.isNumber){
s.val=-s.val;
l.splice(n,1);
f=u;
--n
}
u=f
}
if(m!=0){
throw"Mismatched parentheses"
}
var c=[];
var a=[];
for(var n=0;
n<l.length;
++n){
var f=l[n];
if(f.isOpr){
a.push(f)
}else{
if(f.type===r.IDENTIFIER){
f.n_args=-1;
c.push(f);
if(ZmSpreadSheetFormulae.getFunc(f.val).n_args!=0){
if(!l[n+1]||l[n+1].type!==r.OPENPAREN){
throw'Function "'+f.val+'" expects arguments.'
}}}else{
if(f.type===r.COMMA){
while(c.length>0&&p(c).type!==r.OPENPAREN){
a.push(c.pop())
}
if(c.length==0||!l[n+1]||l[n+1].type===r.CLOSEPAREN){
throw"Syntax error: misplaced comma or parens"
}
var o=c[c.length-2];
if(!o||o.type!==r.IDENTIFIER){
throw"Syntax error: expecting a function identifier"
}
++o.n_args
}else{
if(f.type===r.OPERATOR){
var e;
while(((e=p(c))!=null)&&e.type===r.OPERATOR&&((f.assoc>=2&&f.priority<=e.priority)||(f.assoc==1&&f.priority>e.priority))){
a.push(c.pop())
}
c.push(f)
}else{
if(f.type===r.OPENPAREN){
var o=p(c);
var s=l[n+1];
if(o&&o.type===r.IDENTIFIER&&s&&s.type!==r.CLOSEPAREN){
++o.n_args
}
c.push(f)
}else{
if(f.type===r.CLOSEPAREN){
while(c.length>0&&p(c).type!==r.OPENPAREN){
a.push(c.pop())
}
if(c.length==0){
throw"Syntax error: misplaced parens"
}else{
c.pop()
}
if(c.length>0&&p(c).type===r.IDENTIFIER){
var o=c.pop();
o.n_args++;
a.push(o);
var g=ZmSpreadSheetFormulae.getFunc(o.val).n_args;
if(g!=null){
if(g>=0&&o.n_args!=g){
throw"Function "+o.val+" expects exactly "+g+" arguments."
}
if(g<0&&o.n_args+g<0){
throw"Function "+o.val+" expects at least "+(-g)+" arguments."
}}}}}}}}}}
while(c.length>0){
var f=c.pop();
if((f.type!==r.OPERATOR&&f.type!==r.IDENTIFIER)||(f.type===r.IDENTIFIER&&ZmSpreadSheetFormulae.getFunc(f.val).n_args>0)){
throw"Expecting only operators or constants at ZmSpreadSheetFormulae.compile"
}
a.push(f)
}
this._stack=a
};
ZmSpreadSheetFormulae.prototype.eval=function(){
if(this._running){
return""
}
this._running=true;
var n=ZmSpreadSheetFormulae.TOKEN,s=this._stack,a=s.length-1,h=this;
var l={};
var e=null;
function r(c){
l[c.getType()]=true;
if(c.getDecimals()!=null){
if(e==null){
e=0
}
if(e<c.getDecimals()){
e=c.getDecimals()
}}
return c.getValue()
}
function t(){
var d=s[a--];
if(d.type===n.CELL){
return r(d.cell)
}
if(d.type===n.CELLRANGE){
var c=new Array(d.cells.length);
for(var f=c.length;
--f>=0;
){
c[f]=r(d.cells[f])
}
return c
}
if(d.isOpr){
return d.val
}
var m=[],u=d.n_args;
while(u-->0){
var p=t();
if(p instanceof Array){
m.unshift.apply(m,p)
}else{
m.unshift(p)
}}
return h.callFunction(d.val,m)
}
var o=t();
if(l.percentage&&!l.currency){
l="percentage"
}else{
if(l.currency){
l="currency"
}else{
l=null
}}
this.autoType=l;
this.decimals=e;
this._running=false;
return o
};
ZmSpreadSheetFormulae.prototype.toString=function(){
return this._formula
}
}
if(AjxPackage.define("zimbraMail.spreadsheets.view.ZmSpreadSheet")){
ZmSpreadSheet=function(n,e,o,a,t){
if(arguments.length==0){
return
}
o=o||"ZmSpreadSheet";
DwtComposite.call(this,{
parent:n,className:o,posStyle:a,deferred:t}
);
this._controller=e;
this._selectRangeCapture=new DwtMouseEventCapture({
targetObj:this,id:"ZmSpreadSheet",mouseMoveHdlr:AjxCallback.simpleClosure(this._table_selrange_MouseMove,this),mouseUpHdlr:AjxCallback.simpleClosure(this._clear_selectRangeCapture,this)}
);
this._autofillRangeCapture=new DwtMouseEventCapture({
targetObj:this,id:"ZmSpreadSheet-AutoFill",mouseMoveHdlr:AjxCallback.simpleClosure(this._table_autofill_mouseMove,this),mouseUpHdlr:AjxCallback.simpleClosure(this._table_autofill_mouseUp,this)}
);
this._colsizeCapture=new DwtMouseEventCapture({
targetObj:this,id:"ZmSpreadSheet-Col",mouseMoveHdlr:AjxCallback.simpleClosure(this._colsize_mouseMove,this),mouseUpHdlr:AjxCallback.simpleClosure(this._colsize_mouseUp,this)}
);
this._rowsizeCapture=new DwtMouseEventCapture({
targetObj:this,id:"ZmSpreadSheet-Row",mouseMoveHdlr:AjxCallback.simpleClosure(this._rowsize_mouseMove,this),mouseUpHdlr:AjxCallback.simpleClosure(this._rowsize_mouseUp,this)}
);
this._onResize=new AjxListener(this,this._onResize);
this._hoverOverListener=new AjxListener(this,this._handleOverListener);
this._hoverOutListener=new AjxListener(this,this._handleOutListener);
this.addControlListener(this._onResize);
this.onSelectCell=[];
this.onInputModified=[];
Dwt.setHandler(document,DwtEvent.ONKEYPRESS,AjxCallback.simpleClosure(this._keyPress,this));
if(AjxEnv.isIE||AjxEnv.isOpera){
Dwt.setHandler(document,DwtEvent.ONKEYDOWN,AjxCallback.simpleClosure(this._keyPress,this))
}
Dwt.setHandler(document,DwtEvent.ONBLUR,AjxCallback.simpleClosure(this._clipboard_blur,this))
};
ZmSpreadSheet.TOOLTIP_DELAY=750;
ZmSpreadSheet.prototype=new DwtComposite;
ZmSpreadSheet.prototype.construction=ZmSpreadSheet;
ZmSpreadSheet.prototype.getXML=function(){
var e=this.getCellModel(this._selectedCell);
var t={
selCol:e.getCol(),selRow:e.getRow()};
return(this._model?this._model.getXML(t).getDocXml():null)
};
ZmSpreadSheet.getCellName=function(e){
return ZmSpreadSheetModel.getCellName(e.parentNode.rowIndex,e.cellIndex)
};
ZmSpreadSheet.prototype.setModel=function(e){
e.reset();
this._model=e;
this._init();
e.setViewListener("onCellValue",new AjxCallback(this,this._model_cellComputed));
e.setViewListener("onInsertRow",new AjxCallback(this,this._model_insertRow));
e.setViewListener("onInsertCol",new AjxCallback(this,this._model_insertCol));
e.setViewListener("onDeleteRow",new AjxCallback(this,this._model_deleteRow));
e.setViewListener("onDeleteCol",new AjxCallback(this,this._model_deleteCol))
};
ZmSpreadSheet.prototype._model_cellComputed=function(a,t,e){
var o=this._getTable().rows[a].cells[t];
e.setToElement(o)
};
ZmSpreadSheet.prototype._model_deleteRow=function(h){
this._hideRange();
var o=this._selectedCell;
this._selectCell();
var t=o.cellIndex;
var e=o.parentNode.rowIndex;
var r=this._getTable().rows;
var s=r[r.length-1];
s.removeChild(s.firstChild);
++h;
for(var a=r.length;
--a>h;
){
var n=r[a-1].firstChild;
r[a].insertBefore(n,r[a].firstChild)
}
var s=r[a];
s.parentNode.removeChild(s);
if(e>=r.length){
--e
}
this._selectCell(r[e].cells[t])
};
ZmSpreadSheet.prototype._model_deleteCol=function(a){
this._hideRange();
var n=this._selectedCell;
this._selectCell();
var t=n.cellIndex;
var e=n.parentNode.rowIndex;
var r=this._getTable().rows;
for(var o=1;
o<r.length;
++o){
var s=r[o];
var h=s.cells[a+1];
s.removeChild(h)
}
s=r[0];
s.removeChild(s.cells[s.cells.length-1]);
if(t>=s.cells.length){
--t
}
this._header_resetColWidths();
this._selectCell(r[e].cells[t])
};
ZmSpreadSheet.prototype._model_insertRow=function(l,r){
this._hideRange();
var a=this._selectedCell;
this._selectCell();
var d=this._getTable().rows;
var h=r+1;
var c=this._getTable().insertRow(h);
var o=true;
for(var s=c.rowIndex;
s<d.length-1;
++s){
var e=d[s+1].firstChild;
var n=e;
if(s==d.length-2){
e=e.cloneNode(true);
n.firstChild.innerHTML=s+1
}
d[s].insertBefore(e,d[s].firstChild);
o=false
}
if(o){
var t=c.insertCell(0);
t.className="LeftBar";
t.innerHTML="<div>"+(h)+"</div>"
}
for(var s=0;
s<l.length;
++s){
var t=c.insertCell(s+1);
t.className="cell";
l[s]._td=t;
l[s].setToElement(t)
}
this._setRowHeight(r);
this._selectCell(a)
};
ZmSpreadSheet.prototype._model_insertCol=function(t,e){
this._hideRange();
var o=this._selectedCell;
this._selectCell();
var n=this._getTable().rows;
var s=n[0];
var r=s.insertCell(e+1);
r.innerHTML="<div></div>";
for(var a=e+1;
a<s.cells.length;
++a){
s.cells[a].firstChild.innerHTML=ZmSpreadSheetModel.getColName(a)
}
for(var a=0;
a<t.length;
++a){
s=n[a+1];
var r=s.insertCell(e+1);
r.className="cell";
t[a]._td=r;
t[a].setToElement(r)
}
this._setColWidth(e);
this._header_resetColWidths();
this._selectCell(o)
};
ZmSpreadSheet.prototype.getCellModel=function(e){
return this._model.getCell(e.parentNode.rowIndex,e.cellIndex)
};
ZmSpreadSheet.prototype._init=function(){
var h=[];
var d=true;
if(!this._relDivID){
d=false;
this._relDivID=Dwt.getNextId();
h.push("<div id='",this._relDivID,"' class='ZmSpreadSheet-RelDiv'>")
}
this._tableID=Dwt.getNextId();
this._autoFillID=Dwt.getNextId();
h.push("<div class='AutoFill' id='",this._autoFillID,"'><img src='",appContextPath,"/img/zimbra/ImgBlank_9.gif' width='5' height='5'/></div>");
h.push("<table class='SpreadSheet' id='",this._tableID,"' cellspacing='1' cellpadding='0' border='0'>");
var f=["<tr><td class='LeftBar'></td>"];
var u=this._model.ROWS;
var l=this._model.COLS;
this._inputFieldID=null;
this._spanFieldID=null;
for(var n=l;
n>0;
){
f[n--]="<td class='cell'></td>"
}
f[l+1]="</tr>";
f=f.join("");
for(var n=u;
n-->=0;
){
h[h.length]=f
}
h[h.length]="</table>";
if(!d){
h[h.length]="</div>";
var e=this.getHtmlElement();
e.innerHTML=h.join("")
}else{
this._getRelDiv().innerHTML=h.join("")
}
var m=this._getTable();
m.rows[0].className="TopBar";
m.rows[0].cells[0].className="TopLeft";
for(var n=0;
n<m.rows.length;
++n){
m.rows[n].cells[0].innerHTML="<div>"+n+"</div>"
}
f=m.rows[0];
for(var n=1;
n<f.cells.length;
++n){
f.cells[n].innerHTML="<div>"+ZmSpreadSheetModel.getColName(n)+"</div>"
}
m.onmouseup=AjxCallback.simpleClosure(this._table_onMouseUp,this);
m.onmousedown=AjxCallback.simpleClosure(this._table_onClick,this);
m.onclick=AjxCallback.simpleClosure(this._table_onClick,this);
m.ondblclick=AjxCallback.simpleClosure(this._table_onClick,this);
m.onmousemove=AjxCallback.simpleClosure(this._table_mouseMove,this);
m.onmouseout=AjxCallback.simpleClosure(this._table_mouseOut,this);
var t=this._getAutoFill();
t.onmousedown=AjxCallback.simpleClosure(this._table_autoFill_mouseDown,this);
t.style.display="none";
var r=document.createElement("table");
r.cellSpacing=1;
r.cellPadding=0;
r.border=0;
r.id=this._headerID=Dwt.getNextId();
r.className="SpreadSheet Header";
var s=document.createElement("tbody");
r.appendChild(s);
r.style.position="absolute";
r.style.left="0px";
r.style.top="0px";
this._getRelDiv().appendChild(r);
r.onclick=m.onclick;
r.onmousemove=AjxCallback.simpleClosure(this._header_onMouseMove,this);
r.onmousedown=AjxCallback.simpleClosure(this._header_onMouseDown,this);
this._getRelDiv().onscroll=AjxCallback.simpleClosure(this._header_resetScrollTop,this);
this.getHtmlElement().style.display="none";
if(!this._model.version){
if(ZmSpreadSheetModel.DEBUG){
console.log("Loading old spreadsheet file -- slower")
}
for(var n=0;
n<u;
++n){
var f=m.rows[n+1];
for(var o=0;
o<l;
++o){
this._model.data[n][o]._td=f.cells[o+1]
}}}
this._model.doneSetView();
for(var n=0;
n<u;
++n){
var f=m.rows[n+1];
for(var o=0;
o<l;
++o){
var c=this._model.data[n][o];
var a=c._td=f.cells[o+1];
c._savedRow=c._savedCol=null;
c.setToElement(a)
}}
this._table_setColWidths();
this._table_setRowHeights();
this.getHtmlElement().style.display="";
this._header_resetColWidths();
this._showCharts()
};
ZmSpreadSheet.prototype._getAutoFillRangeDiv=function(){
if(!this._autoFillRangeDiv){
this._autoFillRangeDivID=Dwt.getNextId();
var e=this._autoFillRangeDiv=document.createElement("div");
e.id=this._autoFillRangeDivID;
e.className="ShowAutoFillRange";
e.style.display="none";
this._getRelDiv().appendChild(e)
}
return this._autoFillRangeDiv
};
ZmSpreadSheet.prototype._isRangeEqual=function(c,l){
var o=Math.min(c.sR,c.eR);
var h=Math.min(c.sC,c.eC);
var t=Math.max(c.sR,c.eR);
var s=Math.max(c.sC,c.eC);
var a=Math.min(l.sR,l.eR);
var r=Math.min(l.sC,l.eC);
var e=Math.max(l.sR,l.eR);
var n=Math.max(l.sC,l.eC);
if(o==a&&h==r&&t==e&&s==n){
return true
}
return false
};
ZmSpreadSheet.prototype._table_autofill_mouseMove=function(f){
var r=new DwtMouseEvent();
r.setFromDhtmlEvent(f);
var s=DwtUiEvent.getTarget(r);
var l;
if(s.id==this._autoFillRangeDivID){
var p=this._aRangeStartRow;
var o=this._aRangeStartCol;
var c=this._aRangeEndRow;
var u=this._aRangeEndCol;
var a=r.docX+this._getRelDiv().scrollLeft;
var e=r.docY+this._getRelDiv().scrollTop;
e=e-this._getRelDiv().offsetTop;
var d=(o<=u)?(u==0?0:1):-1;
var m=(p<=c)?(c==0?0:1):-1;
if(this.isRange()){
if((o==this._startRangeCol&&u==this._endRangeCol)&&this._checkBoundriesForRange(a,e,c,o,c,u)){
l=null
}else{
if((p==this._startRangeRow&&c==this._endRangeRow)&&this._checkBoundriesForRange(a,e,p,u,c,u)){
l=null
}else{
if(this._checkBoundriesForRange(a,e,this._startRangeRow,this._startRangeCol,this._endRangeRow,this._endRangeCol)){
l=null;
if(!this._isRangeEqual({
sR:p,sC:o,eR:c,eC:u}
,{
sR:this._startRangeRow,sC:this._startRangeCol,eR:this._endRangeRow,eC:this._endRangeCol}
)){
this._showAutoFillRange(this._startRangeRow,this._startRangeCol,this._endRangeRow,this._endRangeCol)
}}else{
if(this._checkBoundries(a,e,this._getCell(c-m,u))){
l=this._getCell(c-m,u)
}else{
if(this._checkBoundries(a,e,this._getCell(c,u-d))){
l=this._getCell(c,u-d)
}else{
if(this._checkBoundriesForRange(a,e,p,o,c,u)){
l=this._findCell(a,e,p,o,c,u)
}}}}}}}else{
if(this._checkBoundries(a,e,this._getCell(c,u))){
l=null
}else{
if(o==u&&this._checkBoundries(a,e,this._getCell(c-m,u))){
l=this._getCell(c-m,u)
}else{
if(p==c&&this._checkBoundries(a,e,this._getCell(c,u-d))){
l=this._getCell(c,u-d)
}else{
if(this._checkBoundriesForRange(a,e,p,o,c,u)){
l=this._findCell(a,e,p,o,c,u)
}}}}}}else{
l=s;
var y=this._getTable();
while(l&&l!==y&&!/^td$/i.test(l.tagName)){
l=l.parentNode
}}
if(l&&/^td$/i.test(l.tagName)&&l.cellIndex>0&&l.parentNode.rowIndex>0){
var h=l;
var p,o,c,u;
if(this.isRange()){
var g=h.parentNode.rowIndex-1;
var n=h.cellIndex-1;
p=Math.min(this._startRangeRow,this._endRangeRow);
o=Math.min(this._startRangeCol,this._endRangeCol);
c=Math.max(this._startRangeRow,this._endRangeRow);
u=Math.max(this._startRangeCol,this._endRangeCol);
if(g>=p&&g<=c){
if(n>u){
u=n
}else{
if(n<o){
o=n
}}}else{
if(g>c){
c=g
}else{
if(g<p){
p=g
}}}}else{
var t=this._selectedCell;
p=t.parentNode.rowIndex-1;
o=t.cellIndex-1;
c=h.parentNode.rowIndex-1;
u=h.cellIndex-1;
if(p!=c&&o!=u){
u=o
}}
if(!(this._isRangeEqual({
sR:p,sC:o,eR:c,eC:u}
,{
sR:this._aRangeStartRow,sC:this._aRangeStartCol,eR:this._aRangeEndRow,eC:this._aRangeEndCol}
))){
this._showAutoFillRange(p,o,c,u)
}}
r._stopPropagation=true;
r._returnValue=false;
r.setToDhtmlEvent(f)
};
ZmSpreadSheet.prototype._hideAutoFillRange=function(){
this._isAutoFillRange=false;
var e=this._getAutoFillRangeDiv();
e.style.display="none";
e.style.top="0px";
e.style.left="0px";
e.style.width="5px";
e.style.height="5px"
};
ZmSpreadSheet.prototype._showAutoFillRange=function(e,s,m,g){
this._isAutoFillRange=true;
this._aRangeStartRow=e;
this._aRangeStartCol=s;
this._aRangeEndRow=m;
this._aRangeEndCol=g;
var p=Math.min(e,m);
var a=Math.min(s,g);
var l=Math.max(e,m);
var u=Math.max(s,g);
this._model.checkBounds(p,a);
this._model.checkBounds(l,u);
var n=this._getTable().rows[p+1];
var o=this._getTable().rows[l+1];
if(!n||!o){
this._hideRange()
}
var c=n.cells[a+1];
var r=o.cells[u+1];
var t=this._getAutoFillRangeDiv();
var f=r.offsetTop+r.offsetHeight-c.offsetTop;
var d=r.offsetLeft+r.offsetWidth-c.offsetLeft;
if(AjxEnv.isIE){
f+=2;
d+=2
}
t.style.display="none";
t.style.height=f+"px";
t.style.width=d+"px";
t.style.left=c.offsetLeft-1+"px";
t.style.top=c.offsetTop-1+"px";
t.style.display=""
};
ZmSpreadSheet.prototype._table_autofill_mouseUp=function(t){
var e=new DwtMouseEvent();
e.setFromDhtmlEvent(t);
this._model.paste(this._autoFillClipboard,ZmSpreadSheetModel.getRangeName(this._aRangeStartRow+1,this._aRangeStartCol+1,this._aRangeEndRow+1,this._aRangeEndCol+1));
this._autofillRangeCapture.release();
this._hideAutoFillRange();
this._showRange(this._aRangeStartRow,this._aRangeStartCol,this._aRangeEndRow,this._aRangeEndCol);
e._stopPropagation=true;
e._returnValue=false;
e.setToDhtmlEvent(t)
};
ZmSpreadSheet.prototype._table_autoFill_mouseDown=function(t){
var e=new DwtMouseEvent();
e.setFromDhtmlEvent(t);
this._autoFillClipboard=new ZmSpreadSheetClipboard(this._model,this.getSelectionRange(),false);
this._getAutoFillRangeDiv();
this._autofillRangeCapture.capture();
e._stopPropagation=true;
e._returnValue=false;
e.setToDhtmlEvent(t)
};
ZmSpreadSheet.prototype._getAutoFill=function(){
if(!this._autoFillDiv){
this._autoFillDiv=document.getElementById(this._autoFillID)
}
return this._autoFillDiv
};
ZmSpreadSheet.prototype._topCellClicked=function(n,o){
if(/click/i.test(o.type)){
var e=n.cellIndex;
this._selectCell(this._getTable().rows[n.parentNode.rowIndex+1].cells[e]);
var e=ZmSpreadSheetModel.getColName(e);
var a=e+"1";
var t=e+this._model.ROWS;
this._selectRange(a,t)
}};
ZmSpreadSheet.prototype._leftCellClicked=function(s,o){
var e=this._resizeRowIndex;
if(e){
this._hideRange();
var s=this._getTable().rows[e].cells[0];
this._rowsizeArgs={
td:s,h:s.firstChild.offsetHeight,docX:o.docX,docY:o.docY};
this._rowsizeCapture.capture();
o._stopPropagation=true;
o._returnValue=false
}else{
var n=s.parentNode.rowIndex;
this._selectCell(this._getTable().rows[n].cells[s.cellIndex+1]);
var a="A"+n;
var t=ZmSpreadSheetModel.getColName(this._model.COLS)+n;
this._selectRange(a,t)
}};
ZmSpreadSheet.prototype._topLeftCellClicked=function(o,a){
var t="A1";
var e=ZmSpreadSheetModel.getColName(this._model.COLS)+this._model.ROWS;
this.focus();
this._selectRange(t,e,true)
};
ZmSpreadSheet.prototype._cellClicked=function(o,r){
var l=/mousedown/i.test(r.type);
var e=/dblclick/i.test(r.type);
this._hideRange();
if(AjxEnv.isIE&&DwtMenu._activeMenu){
DwtMenu._activeMenu.popdown()
}
if(l){
var n=true;
if(this._editingCell&&this._hasExpression){
var a=ZmSpreadSheet.getCellName(o);
a=a+":"+a;
this._showRangeByRangeName(a);
var h=this._getInputField();
var t=Dwt.getSelectionStart(h);
var s=h.value.substr(0,t);
if(/\)\s*$/.test(s)){
n=false
}else{
this._editRangeSelectedCell=o;
this._updateCellRangeToken();
n=true
}}else{
if(this._editingCell){
this._input_blur()
}
if(r.shiftKey&&this._selectedCell&&(this._selectedCell!=o)){
this._selectRange(ZmSpreadSheet.getCellName(this._selectedCell),ZmSpreadSheet.getCellName(o),true)
}else{
this._selectCell(o)
}}
if(n){
r._stopPropagation=true;
r._returnValue=false;
this._selectRangeCapture.capture()
}}
if(e){
r._stopPropagation=true;
r._returnValue=false;
this._editCell(o)
}};
ZmSpreadSheet.prototype.focus=function(){
if(!this._selectedCell){
this._selectCell(this._getTable().rows[1].cells[1])
}};
ZmSpreadSheet.prototype._getTopLeftCell=function(){
return this._getHeaderTable().rows[0].cells[0]
};
ZmSpreadSheet.prototype._getTopHeaderCell=function(e){
return this._getHeaderTable().rows[0].cells[e.cellIndex]
};
ZmSpreadSheet.prototype._getLeftHeaderCell=function(s){
var e=null;
var t=this._getTable();
var a=(t&&t.rows)?t.rows:null;
var n=(s&&s.parentNode)?s.parentNode.rowIndex:0;
var o=a?a[n]:null;
return(o?o.cells[0]:null)
};
ZmSpreadSheet.prototype._table_setRowHeights=function(){
var a=this._model.ROWS;
var t=this._getTable();
for(var e=0;
e<a;
++e){
var n=t.rows[e+1];
var o=n.cells[0];
o.firstChild.style.height=this._model.getRowHeight(e)+"px"
}};
ZmSpreadSheet.prototype._setRowHeight=function(a,e){
var t=this._getTable().rows[a+1].cells[0];
e=e||this._model.getRowHeight(a);
t.firstChild.style.height=e+"px";
this._model.setRowHeight(a,e)
};
ZmSpreadSheet.MIN_ROW_HEIGHT=11;
ZmSpreadSheet.prototype._rowsize_mouseMove=function(a){
var t=new DwtMouseEvent();
t.setFromDhtmlEvent(a);
var o=0;
var n=t.docY-this._rowsizeArgs.docY;
var e=this._rowsizeArgs.h+n+o;
if(e>ZmSpreadSheet.MIN_ROW_HEIGHT){
this._rowsizeArgs.td.firstChild.style.height=e+"px";
this._rowsizeArgs.delta=n
}
t._stopPropagation=true;
t._returnValue=false;
t.setToDhtmlEvent(a);
return t._returnValue
};
ZmSpreadSheet.prototype._rowsize_mouseUp=function(o){
var a=new DwtMouseEvent();
a.setFromDhtmlEvent(o);
var n=this._rowsizeArgs.delta;
if(n){
var e=this._resizeRowIndex;
var t=this._model.getRowHeight(e-1);
if((t+n)>ZmSpreadSheet.MIN_ROW_HEIGHT){
this._setRowHeight(e-1,t+n)
}}
this._rowsizeArgs.td=null;
this._rowsizeArgs=null;
this._rowsizeCapture.release();
a._stopPropagation=true;
a._returnValue=false;
a.setToDhtmlEvent(o);
return a._returnValue
};
ZmSpreadSheet.prototype._table_setColWidths=function(){
var a=this._model.COLS;
var t=this._getTable().rows[0];
var e;
for(i=0;
i<a;
i++){
e=t.cells[i+1];
e.firstChild.style.width=this._model.getColWidth(i)+"px"
}};
ZmSpreadSheet.prototype._setColWidth=function(t,a){
var e=this._getTable().rows[0].cells[t+1];
a=a||this._model.getColWidth(t);
e.firstChild.style.width=a+"px";
this._model.setColWidth(t,a)
};
ZmSpreadSheet.MIN_COL_WIDTH=7;
ZmSpreadSheet.prototype._colsize_mouseMove=function(a){
var t=new DwtMouseEvent();
t.setFromDhtmlEvent(a);
var n=t.docX-this._colsizeArgs.docX;
var o=AjxEnv.isIE?0:-2;
var e=this._colsizeArgs.w+n+o;
if(e>ZmSpreadSheet.MIN_COL_WIDTH){
this._colsizeArgs.td.firstChild.style.width=e+"px";
this._colsizeArgs.col.firstChild.style.width=e+"px";
this._colsizeArgs.delta=n
}
t._stopPropagation=true;
t._returnValue=false;
t.setToDhtmlEvent(a);
return t._returnValue
};
ZmSpreadSheet.prototype._colsize_mouseUp=function(o){
var a=new DwtMouseEvent();
a.setFromDhtmlEvent(o);
this._colsizeCapture.release();
var n=this._colsizeArgs.delta;
if(n){
var t=this._resizeColIndex;
var e=this._model.getColWidth(t-1);
if((e+n)>ZmSpreadSheet.MIN_COL_WIDTH){
this._setColWidth(t-1,e+n)
}}
this._colsizeArgs.td=null;
this._colsizeArgs=null;
a._stopPropagation=true;
a._returnValue=false;
a.setToDhtmlEvent(o);
return a._returnValue
};
ZmSpreadSheet.prototype._header_onMouseDown=function(a){
var t=new DwtMouseEvent();
t.setFromDhtmlEvent(a);
if(this._resizeColIndex){
this._hideRange();
var o=this._getHeaderTable().rows[0].cells[this._resizeColIndex];
var e=this._getTable().rows[0].cells[this._resizeColIndex];
this._colsizeArgs={
td:o,col:e,w:o.firstChild.offsetWidth,docX:t.docX,docY:t.docY};
this._colsizeCapture.capture();
t._stopPropagation=true;
t._returnValue=false
}
t.setToDhtmlEvent(a);
return t._returnValue
};
ZmSpreadSheet.prototype._header_onMouseMove=function(s){
var e=new DwtMouseEvent();
e.setFromDhtmlEvent(s);
var r=this._getHeaderTable();
var t=DwtUiEvent.getTarget(e);
while(t&&t!==r&&!/^td$/i.test(t.tagName)){
t=t.parentNode
}
if(t&&/^td$/i.test(t.tagName)){
var o=t.cellIndex;
if(o>0){
var l=t.parentNode;
var h=l.cells;
var a=Dwt.getLocation(this._getRelDiv());
var n=e.docX-a.x-t.offsetLeft;
if(Math.abs(n-t.offsetWidth)<5){
this._resizeColIndex=o;
Dwt.delClass(r,"Header-ColWSize","Header-ColESize")
}else{
if(n<5&&o>1){
this._resizeColIndex=o-1;
Dwt.delClass(r,"Header-ColESize","Header-ColWSize")
}else{
this._resizeColIndex=null;
Dwt.delClass(r,"Header-ColWSize");
Dwt.delClass(r,"Header-ColESize")
}}}}
e.setToDhtmlEvent(s);
return e._returnValue
};
ZmSpreadSheet.prototype._header_resetColWidths=function(){
var n=this._getTable();
var r=this._getHeaderTable();
if(r.rows.length>0){
r.deleteRow(0)
}
r.firstChild.appendChild(n.rows[0].cloneNode(true));
var t=n.rows[0].cells;
var e=r.rows[0].cells;
var s=AjxEnv.isIE?0:-2;
for(var o=0;
o<t.length;
++o){
e[o].firstChild.style.width=t[o].firstChild.offsetWidth+s+"px"
}};
ZmSpreadSheet.prototype._header_resetScrollTop=function(){
this._getHeaderTable().style.top=this._getRelDiv().scrollTop+"px"
};
ZmSpreadSheet.prototype.getToolbar=function(){
if(!this._toolbar){
this._toolbar=this._controller._toolbar
}
return this._toolbar
};
ZmSpreadSheet.prototype._selectCell=function(a){
if(this._selectedCell){
Dwt.delClass(this._getTopHeaderCell(this._selectedCell),"TopSelected");
Dwt.delClass(this._getLeftHeaderCell(this._selectedCell),"LeftSelected");
Dwt.delClass(this._selectedCell,"SSelected")
}
this._selectedCell=a;
if(a){
if(this.isRange()&&!this._editingCell){
this._hideRange()
}
Dwt.addClass(a,"SSelected");
Dwt.addClass(this._getTopHeaderCell(a),"TopSelected");
Dwt.addClass(this._getLeftHeaderCell(a),"LeftSelected");
this._getTopLeftCell().innerHTML="<div>"+ZmSpreadSheet.getCellName(a)+"</div>";
var t=this._getAutoFill();
t.className="AutoFill";
t.style.top=a.offsetTop+a.offsetHeight-4+"px";
t.style.left=a.offsetLeft+a.offsetWidth-4+"px";
t.style.display="block";
if(!this._editingCell){
this.focus();
for(var e=this.onSelectCell.length;
--e>=0;
){
this.onSelectCell[e].run(this.getCellModel(a),a)
}}}
if(!this._editingCell){
this.getToolbar().get("fileName").blur()
}};
ZmSpreadSheet.prototype._getHeaderTable=function(){
return document.getElementById(this._headerID)
};
ZmSpreadSheet.prototype._getRelDiv=function(){
return document.getElementById(this._relDivID)
};
ZmSpreadSheet.prototype._input_setValue=function(a){
var e=this._getInputField();
e.value=a;
for(var t=this.onInputModified.length;
--t>=0;
){
this.onInputModified[t].run(a)
}};
ZmSpreadSheet.prototype._getInputField=function(){
var e=null;
if(this._inputFieldID){
e=document.getElementById(this._inputFieldID)
}
if(!e){
var t=this._getRelDiv();
e=document.createElement("input");
this._inputFieldID=e.id=Dwt.getNextId();
e.setAttribute("autocomplete","off");
e.type="text";
e.className="InputField";
e.style.left="0px";
e.style.top="0px";
e.style.visibility="hidden";
t.appendChild(e);
e[(AjxEnv.isIE||AjxEnv.isOpera)?"onkeydown":"onkeypress"]=AjxCallback.simpleClosure(this._input_keyPress,this);
e.onmouseup=AjxCallback.simpleClosure(this._input_mouseUp,this);
e.onblur=AjxCallback.simpleClosure(this._input_blur,this);
e.onfocus=AjxCallback.simpleClosure(this._input_focus,this);
e.setValue=AjxCallback.simpleClosure(this._input_setValue,this)
}
return e
};
ZmSpreadSheet.prototype._getSpanField=function(){
var e=null;
if(this._spanFieldID){
e=document.getElementById(this._spanFieldID)
}
if(!e){
var e=document.createElement("span");
this._spanFieldID=e.id=Dwt.getNextId();
e.className="InputField";
var t=this._getRelDiv();
t.appendChild(e)
}
return e
};
ZmSpreadSheet.prototype._editCell=function(o){
this._shiftRangeStart=null;
var e=this._getInputField();
if(this._editingCell){
e.blur()
}
if(o){
if(this.isRange()){
this._hideRange()
}
this._selectCell(o);
e.style.visibility="";
e.style.top=o.offsetTop-1+"px";
e.style.left=o.offsetLeft-1+"px";
e.style.width=o.offsetWidth+2+"px";
e.style.height=o.offsetHeight+2+"px";
var a=this.getCellModel(o);
e.setValue(a.getEditValue());
e._caretMoved=false;
e.select();
e.focus();
this._editingCell=o;
a.setStyleToElement(e,true);
this._displayRangeIfAny();
var t=this._getAutoFill();
t.style.display="none";
this._input_keyPress()
}};
ZmSpreadSheet.prototype._input_blur=function(t){
this._shiftRangeStart=null;
var e=this._getInputField();
e.style.visibility="hidden";
e.style.left=0;
e.style.top=0;
e.style.width="";
if(!this._preventSaveOnBlur&&this._editingCell){
this._save_value(e.value)
}
this._editingCell=null;
this._hideRange()
};
ZmSpreadSheet.prototype._input_focus=function(t){
var e=this._getInputField();
if(e.style.visibility=="hidden"&&this._selectedCell){
this._editCell(this._selectedCell)
}};
ZmSpreadSheet.prototype._save_value=function(e){
this.getCellModel(this._editingCell).setEditValue(e)
};
ZmSpreadSheet.prototype._getNextCell=function(a){
if(a==null){
a=this._editingCell||this._selectedCell
}
var t=a.parentNode;
if(a.cellIndex<t.cells.length-1){
return t.cells[a.cellIndex+1]
}
var e=this._getTable();
if(t.rowIndex<e.rows.length-1){
return e.rows[t.rowIndex+1].cells[1]
}
return null
};
ZmSpreadSheet.prototype._getPrevCell=function(a){
if(a==null){
a=this._editingCell||this._selectedCell
}
var t=a.parentNode;
if(a.cellIndex>1){
return t.cells[a.cellIndex-1]
}
var e=this._getTable();
if(t.rowIndex>1){
t=e.rows[t.rowIndex-1];
return t.cells[t.cells.length-1]
}
return null
};
ZmSpreadSheet.prototype._getDownCell=function(a){
if(a==null){
a=this._editingCell||this._selectedCell
}
var t=a.parentNode;
var e=this._getTable();
if(t.rowIndex<e.rows.length-1){
t=e.rows[t.rowIndex+1];
return t.cells[a.cellIndex]
}
return null
};
ZmSpreadSheet.prototype._getUpCell=function(a){
if(a==null){
a=this._editingCell||this._selectedCell
}
var t=a.parentNode;
var e=this._getTable();
if(t.rowIndex>1){
t=e.rows[t.rowIndex-1];
return t.cells[a.cellIndex]
}
return null
};
ZmSpreadSheet.prototype._getRightCell=function(t){
if(t==null){
t=this._editingCell||this._selectedCell
}
var e=t.parentNode;
if(t.cellIndex<e.cells.length-1){
return e.cells[t.cellIndex+1]
}
return null
};
ZmSpreadSheet.prototype._getLeftCell=function(t){
if(t==null){
t=this._editingCell||this._selectedCell
}
var e=t.parentNode;
if(t.cellIndex>1){
return e.cells[t.cellIndex-1]
}
return null
};
ZmSpreadSheet.prototype._handleKey=function(t,a){
var h=AjxEnv.isIE||AjxEnv.isOpera;
this.focus();
var n=true;
var o=false;
var e=this._selectedCell;
var r;
switch(t.keyCode){
case 9:r=t.shiftKey?this._getPrevCell():this._getNextCell();
if(r){
this._selectCell(r)
}
break;
case 37:case 39:r=(t.shiftKey&&this._shiftRangeEnd)?this._shiftRangeEnd:this._selectedCell;
r=t.keyCode==37?this._getLeftCell(r):this._getRightCell(r);
if(!t.shiftKey&&r){
this._selectCell(r)
}else{
o=true
}
break;
case 13:r=(t.shiftKey?this._getUpCell():this._getDownCell());
if(r){
this._selectCell(r)
}
break;
case 38:case 40:r=(t.shiftKey&&this._shiftRangeEnd)?this._shiftRangeEnd:this._selectedCell;
r=(t.keyCode==38?this._getUpCell(r):this._getDownCell(r));
if(!t.shiftKey&&r){
this._selectCell(r)
}else{
if(this._editingCell){
o=false;
n=false
}else{
o=false
}}
break;
case 113:this._editCell(this._selectedCell);
break;
case 46:if(this._selectedRangeName){
this._model.forEachCell(this._selectedRangeName,function(l){
if(t.isCommand()){
l.clearAll()
}else{
l.clearValue()
}}
);
this._showRangeByRangeName(this._selectedRangeName)
}
this.getCellModel(this._selectedCell).clearValue();
break;
case 27:this._hideRange();
break;
default:if(!this._editingCell&&t.keyCode==8){
this._handleDelKey(t)
}else{
if(!this._editingCell&&!t.isCommand()&&((!h&&a.charCode)||(h&&/keypress/i.test(t.type)))){
var s=String.fromCharCode(t.charCode);
this._editCell(this._selectedCell);
this._getInputField().setValue(s);
Dwt.setSelectionRange(this._getInputField(),1,1)
}else{
n=false
}}}
if(!n){
switch(String.fromCharCode(t.charCode).toLowerCase()){
case"c":if(t.isCommand()){
this.clipboardCopy();
this.focusTextArea();
this._addDataToTextArea()
}
break;
case"x":if(t.isCommand()){
n=true;
this.clipboardCut()
}
break;
case"v":if(t.isCommand()){
if(this.hasClipboardData()){
n=true;
this.clipboardPaste()
}else{
this.focusTextArea();
window.setTimeout(AjxCallback.simpleClosure(this._pasteFromTextArea,this),50)
}}
break
}}
if(n){
t._stopPropagation=true;
t._returnValue=false
}
if(o){
if(t.shiftKey&&!this._shiftRangeStart){
this._shiftRangeStart=e;
this._shiftRangeEnd=e
}else{
if(!t.shiftKey){
this._shiftRangeStart=null;
this._shiftRangeEnd=null;
this._hideRange()
}}
if(this._shiftRangeStart&&r){
this._shiftRangeEnd=r;
this._selectRange(ZmSpreadSheet.getCellName(this._shiftRangeStart),ZmSpreadSheet.getCellName(this._shiftRangeEnd),false)
}}
return n
};
ZmSpreadSheet.prototype._handleDelKey=function(e){
if(this._selectedRangeName){
this._model.forEachCell(this._selectedRangeName,function(t){
if(e.isCommand()){
t.clearAll()
}else{
t.clearValue()
}}
);
this._showRangeByRangeName(this._selectedRangeName)
}
this.getCellModel(this._selectedCell).clearValue()
};
ZmSpreadSheet.prototype._keyPress=function(t){
this._clearTooltip();
t||(t=window.event);
var e=new DwtKeyEvent();
e.setFromDhtmlEvent(t);
var a=DwtUiEvent.getTarget(e);
var o=this.getToolbar().get("fileName");
if(a==o.getInputElement()||(this._import&&a==this._import)){
e._stopPropagation=true;
e._returnValue=true
}else{
this._handleKey(e,t)
}
e.setToDhtmlEvent(t);
return e._returnValue
};
ZmSpreadSheet.prototype._input_mouseUp=function(){
this._displayRangeIfAny()
};
ZmSpreadSheet.prototype._input_keyPress=function(n){
n||(n=window.event);
var e=true;
if(n){
var o=new DwtKeyEvent();
o.setFromDhtmlEvent(n);
var a=this._getInputField();
this._preventSaveOnBlur=true;
switch(n.keyCode){
case 9:e=false;
this._save_value(a.value);
a.blur();
this._handleKey(o,n);
break;
case 37:case 39:var r=(!a._caretMoved&&((Dwt.getSelectionStart(a)==0&&o.keyCode==37)||(Dwt.getSelectionEnd(a)==a.value.length&&o.keyCode==39)));
if(r||!a.value||n.altKey){
e=false;
this._save_value(a.value);
a.blur();
this._handleKey(o,n)
}else{
a._caretMoved=true;
o._stopPropagation=true;
o._returnValue=true
}
break;
case 38:case 13:case 40:e=false;
this._save_value(a.value);
a.blur();
this._handleKey(o,n);
break;
case 27:e=false;
if(AjxEnv.isIE){
var s=this.getCellModel(this._editingCell);
a.setValue(s.getEditValue())
}
this.focus();
break;
case 113:Dwt.setSelectionRange(a,0,a.value.length);
break
}
if(e){
o._stopPropagation=true;
o._returnValue=true
}
o.setToDhtmlEvent(n);
this._preventSaveOnBlur=false
}
if(e){
if(this._input_keyPress_timer){
clearTimeout(this._input_keyPress_timer)
}
var t=this;
this._input_keyPress_timer=setTimeout(function(){
var c=t._getSpanField();
var h=t._getInputField();
c.innerHTML="";
c.appendChild(document.createTextNode(h.value));
if(c.offsetWidth>(h.offsetWidth-20)){
h.style.width=c.offsetWidth+50+"px"
}
t._input_keyPress_timer=null;
t._displayRangeIfAny();
for(var l=t.onInputModified.length;
--l>=0;
){
t.onInputModified[l].run(h.value)
}}
,10)
}else{
this._hideRange()
}};
ZmSpreadSheet.prototype._selectRange=function(a,t,o){
this._selectedRangeName=null;
var e=o||(a.toLowerCase()!=t.toLowerCase());
a=ZmSpreadSheetModel.identifyCell(a);
t=ZmSpreadSheetModel.identifyCell(t);
if(e&&a&&t){
this._showRange(a.row,a.col,t.row,t.col)
}else{
this._hideRange()
}};
ZmSpreadSheet.prototype._displayRangeIfAny=function(){
var d=this._getInputField();
this._hasExpression=/^=(.*)$/.test(d.value);
if(!this._hasExpression){
this._hideRange();
return
}
var u=RegExp.$1;
var e=Dwt.getSelectionStart(d),l=Dwt.getSelectionEnd(d);
try{
if(e>0){
--e
}
if(l>0){
--l
}
var h=ZmSpreadSheetFormulae.parseTokens(u,true);
var m=null;
for(var n=0;
n<h.length;
++n){
var s=h[n];
if(s.strPos<=e&&s.strPos+s.strLen>=l&&(s.type===ZmSpreadSheetFormulae.TOKEN.CELL||s.type===ZmSpreadSheetFormulae.TOKEN.CELLRANGE)){
m=s;
break
}}
this._rangeToken=m;
if(m){
var o,t;
if(m.type===ZmSpreadSheetFormulae.TOKEN.CELL){
o=t=m.val
}
if(m.type===ZmSpreadSheetFormulae.TOKEN.CELLRANGE){
var c=m.val.split(/:/);
o=c[0];
t=c[1]
}
this._selectRange(o,t,true)
}else{
throw"HIDE"
}}
catch(r){
this._hideRange()
}};
ZmSpreadSheet.prototype._showRangeByRangeName=function(n){
var e=n.split(/:/);
var o=ZmSpreadSheetModel.identifyCell(e[0]);
var t=ZmSpreadSheetModel.identifyCell(e[1]);
this._showRange(o.row,o.col,t.row,t.col)
};
ZmSpreadSheet.prototype._showRange=function(e,r,f,y){
this._isRange=true;
this._startRangeRow=e;
this._startRangeCol=r;
this._endRangeRow=f;
this._endRangeCol=y;
var g=Math.min(e,f);
var a=Math.min(r,y);
var c=Math.max(e,f);
var m=Math.max(r,y);
this._model.checkBounds(g,a);
this._model.checkBounds(c,m);
var n=this._getTable().rows[g+1];
var o=this._getTable().rows[c+1];
if(!n||!o){
this._hideRange()
}
var d=n.cells[a+1];
var l=o.cells[m+1];
if(!d||!l){
this._hideRange()
}
this._selectedRangeName=[ZmSpreadSheet.getCellName(d),ZmSpreadSheet.getCellName(l)].join(":");
var t=this._getRangeDiv();
var p=l.offsetTop+l.offsetHeight-d.offsetTop;
var u=l.offsetLeft+l.offsetWidth-d.offsetLeft;
if(AjxEnv.isIE){
p+=2;
u+=2
}
t.style.display="none";
t.style.height=p+"px";
t.style.width=u+"px";
t.style.left=d.offsetLeft-1+"px";
t.style.top=d.offsetTop-1+"px";
t.style.display="";
var s=this._getAutoFill();
s.className="AutoFill AutoFillRange";
s.style.top=l.offsetTop+l.offsetHeight-4+"px";
s.style.left=l.offsetLeft+l.offsetWidth-4+"px";
s.style.display="block";
this._startRangeCell=d;
this._endRangeCell=l;
this._selectedRangeName=[ZmSpreadSheet.getCellName(d),ZmSpreadSheet.getCellName(l)].join(":")
};
ZmSpreadSheet.prototype._getRangeDiv=function(){
if(!this._rangeDivID){
this._rangeDivID=Dwt.getNextId()
}
var e=document.getElementById(this._rangeDivID);
if(!e){
var e=document.createElement("div");
e.id=this._rangeDivID;
e.className="ShowRange";
e.style.display="none";
this._getRelDiv().appendChild(e);
e.onmousedown=AjxCallback.simpleClosure(this._rangediv_mousedown,this);
e.onmousemove=AjxCallback.simpleClosure(this._rangediv_mousemove,this)
}
return e
};
ZmSpreadSheet.prototype._rangediv_mousemove=function(ev){
if(this._selectRangeCapture.capturing()){
return
}
var dwtev=new DwtMouseEvent(ev);
dwtev.setFromDhtmlEvent(ev);
var html=["<div class='ZmSpreadSheet-Tooltip'>","<div class='CellName'>",ZmMsg.cellRange+" - "+this._selectedRangeName,"</div>"];
var g=ZmSpreadSheetModel.getRangeGeometry(this._selectedRangeName);
html.push("<div class='CellDesc'>[ ",g.rows," rows x ",g.cols," cols = ",g.rows*g.cols," cells ]</div>");
try{
var formula=new ZmSpreadSheetFormulae(this._model,"sum("+this._selectedRangeName+")");
html.push("Sum: ",formula.eval())
}
catch(ex){}
html.push("</div>");
this._setTooltip(html.join(""),dwtev.docX,dwtev.docY)
};
ZmSpreadSheet.prototype._rangediv_mousedown=function(t){
this._clearTooltip();
var e=new DwtUiEvent(t);
e.setFromDhtmlEvent(t);
var a=(this._editingCell&&this._hasExpression);
this._rangediv_findCell(e,a,a);
this._hideRange();
e._stopPropagation=true;
e._returnValue=false;
e.setToDhtmlEvent(t)
};
ZmSpreadSheet.prototype._rangediv_findCell=function(h,r,l){
var d=this._startRangeRow;
var a=this._startRangeCol;
var n=this._endRangeRow;
var s=this._endRangeCol;
var t=h.docX+this._getRelDiv().scrollLeft;
var e=h.docY+this._getRelDiv().scrollTop;
e=e-this._getRelDiv().offsetTop;
var c=this._findCell(t,e,d,a,n,s);
if(c&&r){
this._editRangeSelectedCell=c;
var o=ZmSpreadSheet.getCellName(c);
o=o+":"+o;
this._showRangeByRangeName(o);
this._updateCellRangeToken()
}
if(c&&!l){
this._selectCell(c)
}};
ZmSpreadSheet.prototype._getCell=function(t,e){
return this._model.data[t][e]._td
};
ZmSpreadSheet.prototype._findCell=function(u,d,e,a,l,f){
var m=Math.min(e,l);
var t=Math.min(a,f);
var o=Math.max(e,l);
var s=Math.max(a,f);
var n=m+Math.ceil((o-m)/2);
var r=t+Math.ceil((s-t)/2);
var h=this._getCell(n,r);
var p=h.offsetTop,g=h.offsetLeft;
if(d>=p){
m=n;
if(d<=p+h.offsetHeight){
o=n
}else{
m=n+1
}}else{
o=n-1
}
if(u>=g){
t=r;
if(u<=g+h.offsetWidth){
s=r
}else{
t=r+1
}}else{
s=r-1
}
if(t==s&&m==o){
return this._getCell(m,t)
}
return this._findCell(u,d,m,t,o,s)
};
ZmSpreadSheet.prototype._hideRange=function(){
this._isRange=false;
this._startRangeCell=null;
this._endRangeCell=null;
this._shiftRangeStart=null;
this._selectedRangeName=null;
var e=this._getRangeDiv();
e.style.display="none";
e.style.top="0px";
e.style.left="0px";
e.style.width="5px";
e.style.height="5px"
};
ZmSpreadSheet.prototype.isRange=function(){
return this._isRange
};
ZmSpreadSheet.prototype._table_selrange_MouseMove=function(d){
var n=new DwtMouseEvent();
n.setFromDhtmlEvent(d);
var f=this._getTable();
var o=DwtUiEvent.getTarget(n);
var s;
if(o.id==this._rangeDivID){
var m=this._startRangeRow;
var a=this._startRangeCol;
var r=this._endRangeRow;
var l=this._endRangeCol;
var t=n.docX+this._getRelDiv().scrollLeft;
var e=n.docY+this._getRelDiv().scrollTop;
e=e-this._getRelDiv().offsetTop;
var h=(a<=l)?(l==0?0:1):-1;
var c=(m<=r)?(r==0?0:1):-1;
if(this._checkBoundries(t,e,this._getCell(r,l))){
s=null
}else{
if(this._checkBoundries(t,e,this._getCell(r,l-h))){
s=this._getCell(r,l-h)
}else{
if(this._checkBoundries(t,e,this._getCell(r-c,l))){
s=this._getCell(r-c,l)
}else{
if(this._checkBoundries(t,e,this._getCell(r-c,l-h))){
s=this._getCell(r-c,l-h)
}else{
if(this._checkBoundriesForRange(t,e,m,a,r,l)){
s=this._findCell(t,e,m,a,r,l)
}}}}}}else{
s=o;
while(s&&s!==f&&!/^td$/i.test(s.tagName)){
s=s.parentNode
}}
if(s&&/^td$/i.test(s.tagName)&&s.cellIndex>0&&s.parentNode.rowIndex>0){
var u=this._selectedCell;
if(this._editingCell){
u=this._editRangeSelectedCell
}
this._selectRange(ZmSpreadSheet.getCellName(u),ZmSpreadSheet.getCellName(s),true);
this._updateCellRangeToken()
}
n._stopPropagation=true;
n._returnValue=false;
n.setToDhtmlEvent(d);
return n._returnValue
};
ZmSpreadSheet.prototype._checkBoundries=function(t,a,e){
if(e&&(t>=e.offsetLeft&&t<=(e.offsetLeft+e.offsetWidth))&&(a>=e.offsetTop&&a<=(e.offsetTop+e.offsetHeight))){
return true
}
return false
};
ZmSpreadSheet.prototype._checkBoundriesForRange=function(c,h,e,o,r,u){
var d=Math.min(e,r);
var t=Math.min(o,u);
var n=Math.max(e,r);
var s=Math.max(o,u);
var l=this._getCell(d,t);
var a=this._getCell(n,s);
if(l&&a&&(c>=l.offsetLeft&&c<=(a.offsetLeft+a.offsetWidth))&&(h>=l.offsetTop&&h<=(a.offsetTop+a.offsetHeight))){
return true
}
return false
};
ZmSpreadSheet.prototype._updateCellRangeToken=function(){
if(this._editingCell&&this._hasExpression){
var a=this._selectedRangeName||ZmSpreadSheet.getCellName(this._selectedCell);
var t=this._getInputField();
var e=this._rangeToken;
if(!e){
e={
strPos:Dwt.getSelectionStart(t)};
e.strLen=Dwt.getSelectionEnd(t)-e.strPos;
e.strPos--
}
Dwt.setSelectionRange(t,e.strPos+1,e.strPos+e.strLen+1);
e.strLen=a.length;
Dwt.setSelectionText(t,a);
a=e.strPos+e.strLen+1;
Dwt.setSelectionRange(t,a,a);
this._displayRangeIfAny()
}};
ZmSpreadSheet.prototype._clear_selectRangeCapture=function(e){
this._selectRangeCapture.release();
if(this._editingCell){
this._selectCell(this._editingCell)
}};
ZmSpreadSheet.prototype._table_onMouseUp=function(e){
if(this._editingCell&&!this._hasExpression){
this._getInputField().blur()
}};
ZmSpreadSheet.prototype._setTooltip=function(t,e,n){
var o=DwtShell.getShell(window);
var a=o.getHoverMgr();
if(!a.isHovering()){
a.reset();
a.setHoverOverDelay(ZmSpreadSheet.TOOLTIP_DELAY);
if(typeof t=="object"){
a.setHoverOverData(t.getTooltipText())
}else{
a.setHoverOverData(t)
}
a.setHoverOverListener(this._hoverOverListener);
a.hoverOver(e,n)
}};
ZmSpreadSheet.prototype._handleOverListener=function(t){
var e=DwtShell.getShell(window);
var o=t.object;
var a=e.getToolTip();
a.setContent(o);
a.popup(t.x,t.y)
};
ZmSpreadSheet.prototype._handleOutListener=function(t){
var e=DwtShell.getShell(window);
var a=e.getToolTip();
a.popdown()
};
ZmSpreadSheet.prototype._clearTooltip=function(){
var t=DwtShell.getShell(window);
var e=t.getHoverMgr();
e.setHoverOutDelay(0);
e.setHoverOutData(null);
e.setHoverOutListener(this._hoverOutListener);
e.hoverOut()
};
ZmSpreadSheet.prototype._table_mouseOut=function(){
this._clearTooltip()
};
ZmSpreadSheet.prototype._table_mouseMove=function(r){
if(this._editingCell||this._selectRangeCapture.capturing()){
return
}
var e=new DwtMouseEvent();
e.setFromDhtmlEvent(r);
var l=this._getTable();
var t=DwtUiEvent.getTarget(e);
while(t&&t!==l&&!/^td$/i.test(t.tagName)){
t=t.parentNode
}
if(t&&/^td$/i.test(t.tagName)){
var n=t.cellIndex;
if(n==0){
var c=t.parentNode;
n=c.rowIndex;
var a=Dwt.getLocation(this._getRelDiv());
var o=e.docY-a.y-t.offsetTop;
if(Math.abs(o-t.offsetHeight)<5){
this._resizeRowIndex=n;
Dwt.delClass(l,"RowNSize","RowSSize")
}else{
if(o<5&&n>1){
this._resizeRowIndex=n-1;
Dwt.delClass(l,"RowSSize","RowNSize")
}else{
this._resizeRowIndex=null;
Dwt.delClass(l,"RowSSize");
Dwt.delClass(l,"RowNSize")
}}}else{
if(this._resizeRowIndex){
this._resizeRowIndex=null;
Dwt.delClass(l,"RowSSize");
Dwt.delClass(l,"RowNSize")
}
try{
var h=this.getCellModel(t);
this._setTooltip(h,e.docX,e.docY)
}
catch(s){}}}};
ZmSpreadSheet.prototype._table_onClick=function(a){
this._clearTooltip();
var e=new DwtMouseEvent();
e.setFromDhtmlEvent(a);
var t=this._getTable();
var n=DwtUiEvent.getTarget(e);
while(n&&n!==t&&!/^td$/i.test(n.tagName)){
n=n.parentNode
}
if(n&&/^td$/i.test(n.tagName)){
var o=n.parentNode;
if(o.rowIndex==0){
if(n.cellIndex==0){
this._topLeftCellClicked(n,e)
}else{
this._topCellClicked(n,e)
}}else{
if(n.cellIndex==0){
this._leftCellClicked(n,e)
}else{
this._cellClicked(n,e)
}}}
e.setToDhtmlEvent(a);
return e._returnValue
};
ZmSpreadSheet.prototype._getTable=function(){
return document.getElementById(this._tableID)
};
ZmSpreadSheet.prototype._onResize=function(n){
var o=this.getHtmlElement();
var t=this._getRelDiv();
t.style.display="none";
var a=o.offsetHeight;
t.style.display="";
a-=t.offsetTop+2;
var e=n.requestedWidth||o.offsetWidth;
if(AjxEnv.isIE){
e-=2
}
var s=t.nextSibling;
while(s){
a-=s.offsetHeight;
s=s.nextSibling
}
t.style.height=a+"px";
t.style.width=e+"px"
};
ZmSpreadSheet.prototype.getSelectionRange=function(){
var e=this._selectedRangeName;
if(!e&&this._selectedCell){
e=ZmSpreadSheet.getCellName(this._selectedCell);
e+=":"+e
}
return e
};
ZmSpreadSheet.prototype.getSelectedCellModel=function(){
if(this._selectedCell){
return this.getCellModel(this._selectedCell)
}
return null
};
ZmSpreadSheet.prototype.clipboardCopy=function(){
window.top._ZmSpreadSheet_clipboard=new ZmSpreadSheetClipboard(this._model,this.getSelectionRange(),false);
window.top._ZmSpreadSheet_cliboard_backup=null
};
ZmSpreadSheet.prototype.clipboardCut=function(){
window.top._ZmSpreadSheet_clipboard=new ZmSpreadSheetClipboard(this._model,this.getSelectionRange(),true);
window.top._ZmSpreadSheet_cliboard_backup=null
};
ZmSpreadSheet.prototype.clipboardPaste=function(){
var t=window.top._ZmSpreadSheet_clipboard;
t=t||window.top._ZmSpreadSheet_cliboard_backup;
if(t){
var e=this._model.paste(t,this.getSelectionRange());
this._selectRange.apply(this,e)
}};
ZmSpreadSheet.prototype.hasClipboardData=function(){
return(window.top._ZmSpreadSheet_clipboard!=null)
};
ZmSpreadSheet.prototype._clipboard_blur=function(){
window.top._ZmSpreadSheet_cliboard_backup=window.top._ZmSpreadSheet_clipboard;
window.top._ZmSpreadSheet_clipboard=null
};
ZmSpreadSheet.prototype._addDataToTextArea=function(){
var e=this._startRangeRow;
var o=this._startRangeCol;
var c=this._endRangeRow;
var u=this._endRangeCol;
var d=Math.min(e,c);
var t=Math.min(o,u);
var s=Math.max(e,c);
var l=Math.max(o,u);
var a=this._getTextArea();
var h="";
for(var r=d;
r<=s;
r++){
for(var n=t;
n<=l;
n++){
h+=this.getCell(r,n).getValue();
if(n!=l){
h+="\t"
}}
if(r!=s){
h+="\n"
}}
a.value=h;
this.focusTextArea()
};
ZmSpreadSheet.prototype._pasteFromTextArea=function(){
var y=this._getTextArea();
var f=y.value;
var w,t=0,e=0,d=0,r,h,l,o,g;
var s=f.split("\n");
for(g=0;
g<s.length;
g++){
d=(s[g].split("\t")).length;
if(d>t){
t=d
}}
e=s.length;
if(d==0){
e=e-1
}
var l=this.getCellModel(this._selectedCell);
var n=l.getRow()-1;
var a=l.getCol()-1;
e=e+n;
t=t+a;
r=this._model.ROWS;
h=this._model.COLS;
o=2;
g=0;
if(e>r){
r=(e-r)+o;
while(g<r){
this._model.insertRow();
g++
}}
g=0;
if(t>h){
h=(t-h)+o;
while(g<h){
this._model.insertCol();
g++
}}
var m,u,d,c=f.split("\n");
for(var g=0;
g<c.length;
g++){
m=n+g;
d=c[g].split("\t");
for(var p=0;
p<d.length;
p++){
this.getCell(n+g,a+p).setEditValue(d[p],true);
u=a+p
}}
this._showRange(n,a,m,u);
this.clipboardCopy();
y.blur()
};
ZmSpreadSheet.prototype.focusTextArea=function(){
var e=this._getTextArea();
e.focus();
e.select()
};
ZmSpreadSheet.prototype._getTextArea=function(){
if(!this._textarea){
var t=document.createElement("div");
t.style.top="-1000px";
t.style.left="-1000px";
t.style.position="absolute";
this._textAreaId=Dwt.getNextId();
var e=this._textarea=document.createElement("textarea");
e.id=this._textAreaId;
e.onKeyDown=function(){
this.blur()
};
t.appendChild(e);
appCtxt.getShell().getHtmlElement().appendChild(t)
}
return this._textarea
};
ZmSpreadSheet.prototype._showCharts=function(){
var t=this._model._rawCharts;
if(!t){
return
}
for(var e=0;
e<t.length;
e++){
var a=t[e];
this.makeChart(a.type,a,{
posX:a.x,posY:a.y}
)
}};
ZmSpreadSheet.prototype.addChart=function(e){
this._model.addChart(e)
};
ZmSpreadSheet.prototype.removeChart=function(e){
this._model.removeChart(e)
};
ZmSpreadSheet.prototype.getChart=function(e,t){
return(new ZmSpreadSheetChart(appCtxt.getShell(),this,e,t))
};
ZmSpreadSheet.prototype.getNextChartPos=function(){
if(!this._chartPos){
this._chartPos={
x:100,y:100}
}
this._chartPos.x=this._chartPos.x+10;
this._chartPos.y=this._chartPos.y+5;
return{
posX:this._chartPos.x,posY:this._chartPos.y}
};
ZmSpreadSheet.prototype.makeChart=function(o,e,n){
o=o||ZmSpreadSheetChart.BAR;
var t=this.getChartData(e);
var a=this.getChart(o,t);
n=n||this.getNextChartPos();
a.show(o,n);
a.makeDraggable();
this.addChart(a)
};
ZmSpreadSheet.prototype._getSeriesName=function(e){
return("Series "+e)
};
ZmSpreadSheet.prototype.getCell=function(t,e){
return this.getCellModel(this._getCell(t,e))
};
ZmSpreadSheet.prototype.getChartData=function(h){
var o={};
var O=new Array();
if(!this.isRange()&&!h){
O[0]=new Array();
O[0][0]="";
O[0][1]="1";
O[1]=new Array();
O[1][0]=this._getSeriesName(1);
var t=this._selectedCell;
t=this.getCellModel(t);
O[1][1]=t.getDisplayValue();
o.sRow=t.getRow();
o.sCol=t.getCol();
o.eRow=t.getRow();
o.eCol=t.getCol()
}else{
var x,w,y,p;
h=h||{};
var v=h.sRow||this._startRangeRow;
var f=h.sCol||this._startRangeCol;
var u=h.eRow||this._endRangeRow;
var c=h.eCol||this._endRangeCol;
var e=o.sRow=Math.min(v,u);
var T=o.sCol=Math.min(f,c);
var g=o.eRow=Math.max(v,u);
var m=o.eCol=Math.max(f,c);
var n=g-e+1;
var s=m-T+1;
var a=this.getCell(e,T);
var d=a.getValue();
var r=a.getType();
O[0]=new Array();
O[0][0]="";
if(n==1&&s>1){
O[1]=new Array();
if(r=="string"||r=="date"){
O[1][0]=d;
w=1
}else{
O[1][0]=this._getSeriesName(1);
w=0
}
var x=1;
while(w<s){
O[0][x]=x;
O[1][x]=this.getCell(e,T+w).getValue();
x++;
w++
}}else{
if(s==1&&n>1){
if(r=="string"||r=="date"){
O[0][1]=d;
w=1
}else{
O[0][1]=this._getSeriesName(1);
w=0
}
var x=1;
while(w<n){
O[x]=new Array();
O[x][0]=x;
O[x][1]=this.getCell(e+w,T).getValue();
x++;
w++
}}else{
var z=this._isLabelRow(e,g,T);
var q=this._isLabelCol(T,m,e);
x=1;
while(x<s){
O[0][x]=q?this.getCell(e,T+x).getValue():this._getSeriesName(x);
x++
}
x=1;
w=z?1:0;
while(w<n){
O[x]=new Array();
O[x][0]=z?this.getCell(e+x,T).getValue():this._getSeriesName(x);
y=1;
p=q?1:0;
while(p<s){
O[x][y]=this.getCell(e+x,T+y).getValue();
y++;
p++
}
x++;
w++
}}}}
o.data=O;
return o
};
ZmSpreadSheet.prototype._isLabelRow=function(e,n,a){
var o;
for(var t=e;
t<=n;
t++){
o=this.getCell(t,a).getType();
if(o=="string"||o=="date"){
return true
}}
return false
};
ZmSpreadSheet.prototype._isLabelCol=function(o,t,n){
var a;
for(var e=o;
e<=t;
e++){
a=this.getCell(n,e).getType();
if(a=="string"||a=="date"){
return true
}}
return false
};
ZmSpreadSheet.prototype._importDialog=function(t){
var a=Dwt.getNextId();
var o=new DwtDialog(appCtxt.getShell(),null,"Import Spreadsheet XML content");
var e=["<table height='400' width='300'  padding='5' cellspacing='5'>","<tr><td><textarea id='",a,"' style='width:100%;height:100%;'></textarea></td></tr>","</table>"].join("");
o.setContent(e);
o.setButtonListener(DwtDialog.OK_BUTTON,new AjxListener(this,function(){
this._importContent(document.getElementById(a).value);
o.popdown()
}
));
o.popup();
this._import=document.getElementById(a)
};
ZmSpreadSheet.prototype._importContent=function(t){
if(t){
var e=new ZmSpreadSheetModel(0,0);
e.loadFromXML(t);
this.setModel(e)
}}
}
if(AjxPackage.define("zimbraMail.spreadsheets.view.ZmSpreadSheetChart")){
ZmSpreadSheetChart=function(o,e,a,t){
DwtComposite.call(this,o,"ZmSpreadSheetChart",Dwt.ABSOLUTE_STYLE);
this._type=a;
this._cData=t;
this._spreadsheet=e;
this._createHtml();
this.setZIndex(Dwt.Z_VIEW);
this.setVisible(false)
};
ZmSpreadSheetChart.prototype=new DwtComposite;
ZmSpreadSheetChart.prototype.constructor=ZmSpreadSheetChart;
ZmSpreadSheetChart.BAR="bar";
ZmSpreadSheetChart.PIE="pie";
ZmSpreadSheetChart.LINE="line";
ZmSpreadSheetChart.prototype.getChartType=function(){
return this._type
};
ZmSpreadSheetChart.prototype.getChartRange=function(){
var e=this._cData;
return{
sRow:e.sRow,sCol:e.sCol,eRow:e.eRow,eCol:e.eCol}
};
ZmSpreadSheetChart.prototype.getChartPos=function(){
var e=this.getBounds();
return{
x:e.x,y:e.y}
};
ZmSpreadSheetChart.prototype._showChart=function(n,t,e,a){
var o;
switch(n){
case ZmSpreadSheetChart.BAR:o=new YAHOO.widget.BarChart(t,e,a);
break;
case ZmSpreadSheetChart.PIE:o=new YAHOO.widget.PieChart(t,e,a);
break;
case ZmSpreadSheetChart.LINE:o=new YAHOO.widget.LineChart(t,e,a);
break
}
return o
};
ZmSpreadSheetChart.prototype._getDataSource=function(s){
var a=new Array();
var n=s.length;
var r=s[0].length;
var e=new Array();
e.push("rowlabels");
for(var o=1;
o<r;
o++){
e.push(s[0][o])
}
this._dataFields=e;
for(var o=1;
o<n;
o++){
a[o-1]={};
for(var t=0;
t<r;
t++){
a[o-1][e[t]]=s[o][t]
}}
YAHOO.example.sheetData=a;
a=this._dataSrc=new YAHOO.util.DataSource(YAHOO.example.sheetData);
a.responseType=YAHOO.util.DataSource.TYPE_JSARRAY;
a.responseSchema={
fields:this._dataFields};
return a
};
ZmSpreadSheetChart.prototype.show=function(e,a){
e=e||this._type;
this._type=e;
var t=this._getDataSource(this._cData.data);
a=this._getAttributes(e,a);
this.setBounds(a.posX,a.posY);
this.setVisible(true);
this._showChart(e,this._containerId,t,a)
};
ZmSpreadSheetChart.prototype._getAttributes=function(o,n){
switch(o){
case ZmSpreadSheetChart.BAR:var t=new Array();
var e=this._dataFields.length;
for(var a=1;
a<e;
a++){
t.push({
xField:this._dataFields[a],displayName:this._dataFields[a]}
)
}
n.series=t;
n.yField=this._dataFields[0];
n.style={
legend:{
display:"bottom",font:{
family:"Arial",size:10}}};
break;
case ZmSpreadSheetChart.PIE:n.categoryField=this._dataFields[0];
n.dataField=this._dataFields[1];
n.series=[{}
];
n.style={
legend:{
display:"right",font:{
family:"Arial",size:10}}};
break;
case ZmSpreadSheetChart.LINE:var t=new Array();
var e=this._dataFields.length;
for(var a=1;
a<e;
a++){
t.push({
yField:this._dataFields[a],displayName:this._dataFields[a]}
)
}
n.series=t;
n.xField=this._dataFields[0];
n.style={
legend:{
display:"bottom",font:{
family:"Arial",size:10}}};
break
}
return n
};
ZmSpreadSheetChart.prototype._createHtml=function(){
var t=[];
var e=0;
this._headerId=Dwt.getNextId();
this._containerId=Dwt.getNextId();
t[e++]="<div class='ZmSpreadSheetChartHeader' id ='"+this._headerId+"'>";
t[e++]="<div class='ZmSpreadSheetChartName' id='"+this._headerId+"_name'>Sample Chart:"+this.getHTMLElId()+"</div>";
t[e++]="<div class='ImgCancel ZmSpreadSheetChartClose' id='"+this._headerId+"_close'></div>";
t[e++]="</div>";
t[e++]="<div id='"+this._containerId+"' class='ZmSpreadSheetChartContainer'></div>";
this.setContent(t.join(""));
Dwt.setHandler(Dwt.byId(this._headerId+"_close"),DwtEvent.ONCLICK,AjxCallback.simpleClosure(this._closeListener,this))
};
ZmSpreadSheetChart.prototype._closeListener=function(e){
this._spreadsheet.removeChart(this.getHTMLElId());
this.setContent("");
this.dispose()
};
ZmSpreadSheetChart.prototype.makeDraggable=function(e){
this._dnd=new YAHOO.util.DD(this.getHTMLElId())
}
}
if(AjxPackage.define("zimbraMail.briefcase.model.ZmDocletMgr")){
ZmDocletMgr=function(){};
ZmDocletMgr.prototype.saveDocument=function(e){
this._uploadSaveDocs2([{
id:e.id,name:e.name,version:(e.version?e.version:1),folderId:e.folderId}
],null,null,e.name,e.content,e.contentType,e.descEnabled,e.desc)
};
ZmDocletMgr.prototype._uploadSaveDocs2=function(n,d,l,k,u,a,y,f){
var v=AjxSoapDoc.create("BatchRequest","urn:zimbra",null);
v.setMethodAttribute("onerror","continue");
for(var m=0;
m<n.length;
m++){
var g=n[m];
if(g.done){
continue
}
var e=v.set("SaveDocumentRequest",null,null,"urn:zimbraMail");
e.setAttribute("requestId",m);
var c=v.set("doc",null,e);
if(g.id){
c.setAttribute("id",g.id);
c.setAttribute("ver",g.version)
}else{
c.setAttribute("l",g.folderId)
}
if(a){
c.setAttribute("ct",a)
}
if(g.guid){
var w=v.set("upload",null,c);
w.setAttribute("id",g.guid)
}
if(k!=null&&u!=null){
var r=v.set("content",u,c);
c.setAttribute("name",k)
}
c.setAttribute("descEnabled",y?"true":"false");
if(f){
c.setAttribute("desc",f)
}}
var t=[n,d,l];
var o=new AjxCallback(this,this._uploadSaveDocsResponse,t);
var p={
soapDoc:v,asyncMode:true,callback:o};
var s=window.opener&&window.opener.appCtxt;
if(s){
var h=s.getActiveAccount();
p.accountName=(h&&h.id!=ZmAccountList.DEFAULT_ID)?h.name:null
}
this.sendRequest(p)
};
ZmDocletMgr.prototype.sendRequest=function(e){
if(!this._requestMgr){
this._requestMgr=new ZmRequestMgr(this)
}
e.noSession=true;
return this._requestMgr.sendRequest(e)
};
ZmDocletMgr.prototype._uploadSaveDocsResponse=function(n,g,m,t){
var c=t&&t._data&&t._data.BatchResponse;
var k=[];
if(c&&c.SaveDocumentResponse){
for(var w=0;
w<c.SaveDocumentResponse.length;
w++){
var e=c.SaveDocumentResponse[w];
n[e.requestId].done=true;
n[e.requestId].rest=e.doc[0].rest;
n[e.requestId].ver=e.doc[0].ver;
n[e.requestId].id=e.doc[0].id;
if(n[e.requestId].folderId){
k.push(n[e.requestId].folderId)
}}}
var l=null;
if(c&&c.Fault){
var h=[];
l=[];
for(var w=0;
w<c.Fault.length;
w++){
var r=c.Fault[w];
var y=r.Detail.Error;
var a=y.Code;
var u=y.a;
if(a==ZmCsfeException.MAIL_ALREADY_EXISTS||a==ZmCsfeException.MODIFY_CONFLICT){
var v=n[r.requestId];
for(var d in u){
var f=u[d];
switch(f.n){
case"id":v.id=f._content;
break;
case"ver":v.version=f._content;
break;
case"rest":v.rest=f._content;
break
}}
l.push(v)
}else{
h[r.requestId]=r
}}}
var s=window.opener&&window.opener.appCtxt;
var o=s&&s.getAppController();
if(o&&!o.getInstantNotify()){
o.sendNoOp()
}
if(this._saveCallback){
this._saveCallback.run(n,l)
}};
ZmDocletMgr.prototype.setSaveCallback=function(e){
this._saveCallback=e
};
ZmDocletMgr.prototype._kickPolling=function(e){};
ZmDocletMgr.prototype._handleException=function(t,e){};
ZmDocletMgr.prototype.runAppFunction=function(t,e){};
ZmDocletMgr.prototype.fetchDocumentContent=function(o){
var a=o.rest;
var n=AjxStringUtil.parseURL(a);
if(n&&n.path){
var e=AjxRpc.invoke("",n.path+"?fmt=native&ver="+o.version,{}
,null,true);
var t="";
if(e&&e.success){
t=this._pendingContent=e.text
}
return t
}
return""
};
ZmDocletMgr.prototype.getItemInfo=function(a){
var l=AjxSoapDoc.create("GetItemRequest","urn:zimbraMail");
var o=l.set("item");
if(a.path){
o.setAttribute("path",a.path)
}else{
if(a.folderId&&a.id){
o.setAttribute("l",a.folderId);
o.setAttribute("id",a.id)
}else{
if(a.folderId&&a.name){
o.setAttribute("l",a.folderId);
o.setAttribute("name",a.name)
}else{
if(a.id){
o.setAttribute("id",a.id)
}}}}
var r=[];
var e=(a.callback?true:false);
var n=null;
if(e){
n=new AjxCallback(this,this.handleGetItemResponse,[a])
}
var s=window.opener&&window.opener.appCtxt;
if(s&&s.multiAccounts){
var h=s.getActiveAccount();
a.accountName=h&&h.name
}
var c={
soapDoc:l,asyncMode:e,callback:n,accountName:a.accountName};
var t=this.sendRequest(c);
if(!e&&t){
var d=this.handleGetItemResponse(a,t.GetItemResponse);
return d
}
return null
};
ZmDocletMgr.prototype.handleGetItemResponse=function(r,e){
var s=r.path;
var h=r.callback;
var a=e;
if(e&&e._data){
a=e&&e._data&&e._data.GetItemResponse
}
var t=a&&a.doc&&a.doc[0];
var o=null;
if(t){
o=new ZmItem();
var n=t;
if(n.id){
o.id=n.id
}
if(n.rest){
o.rest=n.rest
}
if(n.l){
o.folderId=n.l
}
if(n.name){
o.name=n.name
}
if(n.cr){
o.creator=n.cr
}
if(n.d){
o.createDate=new Date(Number(n.d))
}
if(n.md){
o.modifyDate=new Date(Number(n.md))
}
if(n.leb){
o.modifier=n.leb
}
if(n.s){
o.size=Number(n.s)
}
if(n.ver){
o.version=Number(n.ver)
}
if(n.ct){
o.contentType=n.ct.split(";")[0]
}
o.folderId=t.l||ZmOrganizer.ID_BRIEFCASE;
o.locked=false;
if(n.loid){
o.locked=true;
o.lockId=n.loid;
o.lockUser=n.loe;
o.lockTime=new Date(Number(n.lt))
}
o.descEnabled=n.descEnabled
}
if(h){
h.run(o)
}
return o
};
ZmDocletMgr.createItem=function(e){
var t=new ZmDocletMgr();
return t.handleGetItemResponse({}
,e)
};
ZmDocletMgr.prototype.getThemeContent=function(t){
if(!t){
return""
}
var e=AjxRpc.invoke("",t,{}
,null,true);
var a="";
if(e&&e.success){
a=e.text
}
return a
};
ZmDocletMgr.INVALID_DOC_NAME_CHARS="[\\|]";
ZmDocletMgr.INVALID_DOC_NAME_RE=new RegExp(ZmDocletMgr.INVALID_DOC_NAME_CHARS);
ZmDocletMgr.prototype.checkInvalidDocName=function(t){
var e;
t=t.replace(/^\s+/,"").replace(/\s+$/,"");
if(t==""){
e=ZmMsg.emptyDocName
}else{
if(!ZmOrganizer.VALID_NAME_RE.test(t)||ZmDocletMgr.INVALID_DOC_NAME_RE.test(t)){
e=AjxMessageFormat.format(ZmMsg.errorInvalidName,AjxStringUtil.htmlEncode(t))
}else{
if(t.length>ZmOrganizer.MAX_NAME_LENGTH){
e=AjxMessageFormat.format(ZmMsg.nameTooLong,ZmOrganizer.MAX_NAME_LENGTH)
}}}
return e
};
ZmDocletMgr.prototype.unlock=function(o,s,e,t){
var a={
ItemActionRequest:{
_jsns:"urn:zimbraMail",action:{
id:o.id,op:"unlock"}}};
var n={
jsonObj:a,asyncMode:Boolean(s),callback:s,errorCallback:e,accountName:t};
return this.sendRequest(n)
};
ZmDocletMgr.getEditURLForContentType=function(t){
AjxDispatcher.require("Startup1_1");
var e="Slides.jsp";
switch(t){
case ZmMimeTable.APP_ZIMBRA_SLIDES:e="Slides.jsp";
break;
case ZmMimeTable.APP_ZIMBRA_SPREADSHEET:e="SpreadsheetDoc.jsp";
break;
case ZmMimeTable.APP_ZIMBRA_DOC:e="Docs.jsp";
break;
default:return null
}
return(window.appContextPath+"/public/"+e)
}
}};
