
/* Copyright (C) 2005-2009 Zimbra Inc. http://www.zimbra.com/ */
Dwt=function(){};
Dwt.STATIC_STYLE="static";
Dwt.ABSOLUTE_STYLE="absolute";
Dwt.RELATIVE_STYLE="relative";
Dwt.FIXED_STYLE="fixed";
Dwt.NO_REPEAT="no-repeat";
Dwt.REPEAT="repeat";
Dwt.REPEAT_X="repeat-x";
Dwt.REPEAT_Y="repeat-y";
Dwt.DISPLAY_INLINE="inline";
Dwt.DISPLAY_BLOCK="block";
Dwt.DISPLAY_NONE="none";
Dwt.DISPLAY_TABLE_ROW=AjxEnv.isIE?Dwt.DISPLAY_BLOCK:"table-row";
Dwt.DISPLAY_TABLE_CELL=AjxEnv.isIE?Dwt.DISPLAY_BLOCK:"table-cell";
Dwt.CLIP=1;
Dwt.VISIBLE=2;
Dwt.SCROLL=3;
Dwt.FIXED_SCROLL=4;
Dwt.SCROLL_Y=5;
Dwt.SCROLL_X=6;
Dwt.Z_HIDDEN=100;
Dwt.Z_CURTAIN=200;
Dwt.Z_VIEW=300;
Dwt.Z_MENU=500;
Dwt.Z_VEIL=600;
Dwt.Z_DIALOG=700;
Dwt.Z_DIALOG_MENU=750;
Dwt.Z_TOOLTIP=775;
Dwt.Z_DND=800;
Dwt.Z_BUSY=900;
Dwt.Z_TOAST=950;
Dwt.Z_SPLASH=1000;
Dwt.DEFAULT=-123456789;
Dwt.CLEAR=-20000;
Dwt.LOC_NOWHERE=-10000;
Dwt.DND_DROP_NONE=0;
Dwt.DND_DROP_COPY=1;
Dwt.DND_DROP_MOVE=2;
Dwt.SCROLLBAR_WIDTH=22;
Dwt.KEY_OBJECT="_object_";
Dwt.KEY_ID="_id_";
Dwt._Z_INC=1;
Dwt.__nextId={};
Dwt.getNextId=function(e){
if(arguments.length==0){
e="DWT"
}
if(!Dwt.__nextId[e]){
Dwt.__nextId[e]=1
}
return e+Dwt.__nextId[e]++
};
Dwt.associateElementWithObject=function(a,e,t){
a[t||"dwtObj"]=e.__internalId=AjxCore.assignId(e)
};
Dwt.disassociateElementFromObject=function(a,e,t){
if(a){
a.removeAttribute(t||"dwtObj")
}
if(e.__internalId){
AjxCore.unassignId(e.__internalId)
}};
Dwt.getObjectFromElement=function(t,e){
return AjxCore.objectWithId(t[e||"dwtObj"])
};
Dwt.findAncestor=function(a,t){
var e=Dwt.getAttr(a,t);
while(a&&(e==null||e=="")){
a=a.parentNode;
e=Dwt.getAttr(a,t)
}
return a
};
Dwt.isAncestor=function(t,e){
if(t==e){
return true
}
var a=e;
while(a){
a=a.parentNode;
if(a==t){
return true
}}
return false
};
Dwt.setHandler=function(a,t,e){
if(t==DwtEvent.ONMOUSEWHEEL&&AjxEnv.isGeckoBased){
Dwt.clearHandler(a,t)
}
a[t]=e;
if(t==DwtEvent.ONMOUSEWHEEL&&AjxEnv.isGeckoBased){
a.addEventListener("DOMMouseScroll",e,true)
}};
Dwt.clearHandler=function(a,t){
if(t==DwtEvent.ONMOUSEWHEEL&&AjxEnv.isGeckoBased){
if(a[t]){
var e=a[t];
a.removeEventListener("DOMMouseScroll",e,true)
}}
a[t]=null
};
Dwt.getBackgroundRepeat=function(e){
return DwtCssStyle.getProperty(e,"background-repeat")
};
Dwt.setBackgroundRepeat=function(t,e){
t.style.backgroundRepeat=e
};
Dwt.getBounds=function(o,a){
var i=DwtPoint.tmp;
Dwt.getLocation(o,i);
var t=i.x;
var e=i.y;
Dwt.getSize(o,i);
if(!a){
return new DwtRectangle(t,e,i.x,i.y)
}else{
a.set(t,e,i.x,i.y);
return a
}};
Dwt.setBounds=function(i,t,o,a,e){
Dwt.setLocation(i,t,o);
Dwt.setSize(i,a,e)
};
Dwt.getCursor=function(e){
return DwtCssStyle.getProperty(e,"cursor")
};
Dwt.setCursor=function(t,e){
t.style.cursor=e
};
Dwt.getLocation=function(t,e){
e=e||new DwtPoint(0,0);
if(t.style.position==Dwt.ABSOLUTE_STYLE){
e.set(parseInt(DwtCssStyle.getProperty(t,"left")),parseInt(DwtCssStyle.getProperty(t,"top")));
return e
}
return Dwt.toWindow(t,0,0,null,null,e)
};
Dwt.setLocation=function(a,t,i){
var e=a.style.position;
if(e!=Dwt.ABSOLUTE_STYLE&&e!=Dwt.RELATIVE_STYLE&&e!=Dwt.FIXED_STYLE){
throw new DwtException("Static widgets may not be positioned",DwtException.INVALID_OP,"Dwt.setLocation")
}
if(t=Dwt.__checkPxVal(t)){
a.style.left=t
}
if(i=Dwt.__checkPxVal(i)){
a.style.top=i
}};
Dwt.getPosition=function(e){
return e.style.position
};
Dwt.setPosition=function(t,e){
t.style.position=e
};
Dwt.getScrollStyle=function(a){
var i=DwtCssStyle.getProperty(a,"overflow");
if(i=="hidden"){
return Dwt.CLIP
}
if(i=="auto"){
return Dwt.SCROLL
}
if(i=="scroll"){
return Dwt.FIXED_SCROLL
}
if(i==""){
var t=DwtCssStyle.getProperty(a,"overflowX");
var e=DwtCssStyle.getProperty(a,"overflowY");
if(t=="scroll"){
return Dwt.SCROLL_X
}
if(e=="scroll"){
return Dwt.SCROLL_Y
}}
return Dwt.VISIBLE
};
Dwt.setScrollStyle=function(t,e){
if(e==Dwt.CLIP){
t.style.overflow="hidden"
}else{
if(e==Dwt.SCROLL){
t.style.overflow="auto"
}else{
if(e==Dwt.FIXED_SCROLL){
t.style.overflow="scroll"
}else{
if(e==Dwt.SCROLL_Y){
t.style.overflowX="hidden";
t.style.overflowY="auto"
}else{
if(e==Dwt.SCROLL_X){
t.style.overflowY="hidden";
t.style.overflowX="auto"
}else{
t.style.overflow="visible"
}}}}}};
Dwt.getSize=function(a,e){
var t;
if(!e){
t=new DwtPoint(0,0)
}else{
t=e;
t.set(0,0)
}
if(!a){
return t
}
t.x=a.offsetWidth;
if(t.x!=null){
t.y=a.offsetHeight
}else{
if(a.clip&&a.clip.width!=null){
t.x=parseInt(a.clip.width);
t.y=parseInt(a.clip.height)
}else{
if(a.style&&a.style.pixelWidth!=null){
t.x=parseInt(a.style.pixelWidth);
t.y=parseInt(a.style.pixelHeight)
}}}
return t
};
Dwt.setSize=function(a,t,e){
if(!a.style){
return
}
if(t==Dwt.CLEAR){
a.style.width=null
}else{
if(t=Dwt.__checkPxVal(t,true)){
a.style.width=t
}}
if(e==Dwt.CLEAR){
a.style.height=null
}else{
if(e=Dwt.__checkPxVal(e,true)){
a.style.height=e
}}};
Dwt.getHtmlExtent=function(e){
var t=AjxStringUtil.calcDIV();
t.innerHTML=e;
return Dwt.getSize(t)
};
Dwt.toDocumentFragment=function(a,n){
var o=AjxStringUtil.calcDIV();
o.innerHTML=a;
var t=document.createDocumentFragment();
var e=n&&document.getElementById(n);
if(e){
t.appendChild(e)
}else{
for(var i=o.firstChild;
i;
i=o.firstChild){
t.appendChild(i)
}}
return t
};
Dwt.getAttr=function(a,e,t){
if(!t){
return a&&a.tagName?(a.getAttribute(e)||a[e]):null
}else{
while(a){
if(Dwt.getAttr(a,e)!=null){
return a
}
a=a.parentNode
}
return null
}};
Dwt.getVisible=function(t){
var e=DwtCssStyle.getProperty(t,"display");
return(e!=Dwt.DISPLAY_NONE)
};
Dwt.setVisible=function(t,a){
if(a){
if(t.nodeName.match(/tr/i)){
t.style.display=Dwt.DISPLAY_TABLE_ROW
}else{
if(t.nodeName.match(/td|th/i)){
t.style.display=Dwt.DISPLAY_TABLE_CELL
}else{
t.style.display=t.getAttribute("x-display")||Dwt.DISPLAY_BLOCK
}}}else{
var e=DwtCssStyle.getComputedStyleObject(t).display;
if(e!="none"){
t.setAttribute("x-display",e)
}
t.style.display=Dwt.DISPLAY_NONE
}};
Dwt.getVisibility=function(t){
var e=DwtCssStyle.getProperty(t,"visibility");
return(e=="visible")
};
Dwt.setVisibility=function(e,t){
e.style.visibility=t?"visible":"hidden"
};
Dwt.__MSIE_OPACITY_RE=/alpha\(opacity=(\d+)\)/;
Dwt.getOpacity=function(a){
if(AjxEnv.isIE){
var t=a.style.filter;
var e=Dwt.__MSIE_OPACITY_RE.exec(t)||[t,"100"];
return Number(e[1])
}
return Number(a.style.opacity||1)*100
};
Dwt.setOpacity=function(t,e){
if(AjxEnv.isIE){
t.style.filter="alpha(opacity="+e+")"
}else{
t.style.opacity=e/100
}};
Dwt.getZIndex=function(e){
return DwtCssStyle.getProperty(e,"z-index")
};
Dwt.setZIndex=function(t,e){
t.style.zIndex=e
};
Dwt.getDisplay=function(e){
DwtCssStyle.getProperty(e,"display")
};
Dwt.setDisplay=function(t,e){
t.style.display=e
};
Dwt.getWindowSize=function(e){
var t=(!e)?new DwtPoint(0,0):e;
if(window.innerWidth){
t.x=window.innerWidth;
t.y=window.innerHeight
}else{
if(AjxEnv.isIE6CSS){
t.x=document.body.parentElement.clientWidth;
t.y=document.body.parentElement.clientHeight
}else{
if(document.body&&document.body.clientWidth){
t.x=document.body.clientWidth;
t.y=document.body.clientHeight
}}}
return t
};
Dwt.toWindow=function(i,s,n,l,r,h){
var t;
if(!h){
t=new DwtPoint(s,n)
}else{
t=h;
t.set(s,n)
}
var e=i;
while(e&&e!=l){
t.x+=e.offsetLeft-e.scrollLeft;
t.y+=e.offsetTop;
if(!r){
var a=AjxEnv.isOpera?e.pageYOffset:e.scrollTop;
if(a){
t.y-=a
}
var o=e.parentNode;
while(o!=e.offsetParent&&o!=l){
a=AjxEnv.isOpera?o.pageYOffset:o.scrollTop;
if(a){
t.y-=a
}
o=o.parentNode
}}
e=e.offsetParent
}
return t
};
Dwt.getInsets=function(i){
var t=DwtCssStyle.getComputedStyleObject(i);
var a=parseInt(t.borderLeftWidth)||0;
var r=parseInt(t.borderTopWidth)||0;
var h=parseInt(t.borderRightWidth)||0;
var n=parseInt(t.borderBottomWidth)||0;
var o=parseInt(t.paddingLeft)||0;
var l=parseInt(t.paddingTop)||0;
var e=parseInt(t.paddingRight)||0;
var s=parseInt(t.paddingBottom)||0;
return{
left:a+o,top:r+l,right:h+e,bottom:n+s}
};
Dwt.insetBounds=function(t,e){
if(isNaN(t.x)||isNaN(e.left)){
return t
}
t.x+=e.left;
t.y+=e.top;
t.width-=e.left+e.right;
t.height-=e.top+e.bottom;
return t
};
Dwt.setStatus=function(e){
window.status=e
};
Dwt.getTitle=function(){
return window.document.title
};
Dwt.setTitle=function(e){
window.document.title=e
};
Dwt.getIframeDoc=function(e){
if(e){
return AjxEnv.isIE?e.contentWindow.document:e.contentDocument
}
return null
};
Dwt.getIframeWindow=function(e){
return e.contentWindow
};
Dwt.parseHtmlFragment=function(o,a){
if(!Dwt._div){
Dwt._div=document.createElement("div")
}
if(a){
o="<table style='table-layout:fixed'>"+o+"</table>"
}
Dwt._div.innerHTML=o;
if(a){
var e=document.createDocumentFragment();
var n=Dwt._div.firstChild.rows;
for(var t=n.length-1;
t>=0;
t--){
e.appendChild(n[0])
}
return e.childNodes.length>1?e:e.firstChild
}
return Dwt._div.firstChild
};
Dwt.contains=function(a,t){
var i=false;
if(a.compareDocumentPosition){
var e=a.compareDocumentPosition(t);
if((e==(document.DOCUMENT_POSITION_CONTAINED_BY|document.DOCUMENT_POSITION_FOLLOWING))){
i=true
}}else{
if(a.contains){
i=a.contains(t)
}}
return i
};
Dwt.removeChildren=function(e){
while(e.hasChildNodes()){
e.removeChild(e.firstChild)
}};
Dwt.getCellIndex=function(t){
if(AjxEnv.isOpera){
if(t.tagName&&t.tagName.toLowerCase()=="td"){
var a=t.parentNode.cells;
var e=a.length;
for(var o=0;
o<e;
o++){
if(a[o]==t){
return o
}}}}else{
return t.cellIndex
}
return -1
};
Dwt.delClass=function(a,e,i){
if(a==null){
return
}
if(!e&&!i){
return
}
if(typeof e=="string"&&e.length){
e=Dwt._DELCLASS_CACHE[e]||(Dwt._DELCLASS_CACHE[e]=new RegExp("\\b"+e+"\\b","ig"))
}
var t=a.className||"";
t=t.replace(e," ");
a.className=i?t+" "+i:t
};
Dwt._DELCLASS_CACHE={};
Dwt.addClass=function(e,t){
Dwt.delClass(e,t,t)
};
Dwt.condClass=function(i,o,t,e){
if(!!o){
if(e){
Dwt.delClass(i,e)
}
Dwt.addClass(i,t)
}else{
Dwt.delClass(i,t);
if(e){
Dwt.addClass(i,e)
}}};
Dwt.hasClass=function(t,e){
if(!t||!e){
return false
}
return t.className.match(new RegExp("\\b"+e+"\\b"))
};
Dwt.setSelectionRange=function(a,i,e){
if(AjxEnv.isGeckoBased||AjxEnv.isSafari){
a.setSelectionRange(i,e)
}else{
if(AjxEnv.isIE){
var t=a.createTextRange();
t.collapse(true);
t.moveStart("character",i);
t.moveEnd("character",e-i);
t.select()
}else{
a.select()
}}};
Dwt.getSelectionStart=function(i){
if(AjxEnv.isGeckoBased){
return i.selectionStart
}
if(AjxEnv.isIE){
var a=document.selection.createRange();
var t=a.compareEndPoints("StartToEnd",a)==0;
if(!t){
a.collapse(true)
}
var e=a.getBookmark();
return e.charCodeAt(2)-2
}
return i.value.length
};
Dwt.getSelectionEnd=function(i){
if(AjxEnv.isGeckoBased){
return i.selectionEnd
}
if(AjxEnv.isIE){
var a=document.selection.createRange();
var t=a.compareEndPoints("StartToEnd",a)==0;
if(!t){
a.collapse(false)
}
var e=a.getBookmark();
return e.charCodeAt(2)-2
}
return i.value.length
};
Dwt.setSelectionText=function(t,o){
var n=Dwt.getSelectionStart(t);
var e=Dwt.getSelectionEnd(t);
var i=t.value;
var a=[i.substr(0,n),o,i.substr(e)].join("");
if(typeof t.setValue=="function"){
t.setValue(a)
}else{
t.value=a
}
Dwt.setSelectionRange(t,n,n+o.length)
};
Dwt.instanceOf=function(t,e){
if(typeof t=="string"){
return window[t]&&(t==e||window[t].prototype instanceof window[e])
}
return(window[e]&&t instanceof window[e])
};
Dwt.getParams=function(e,o){
if(!(e&&e.length)){
return{}
}
if(e.length>1||e[0]._eventMgr){
var a={};
for(var t=0;
t<e.length;
t++){
a[o[t]]=e[t]
}
return a
}
if(e.length==1){
return e[0]
}
return{}
};
Dwt.__checkPxVal=function(t,e){
if(t==Dwt.DEFAULT){
return false
}
if(e&&t<0&&t!=Dwt.LOC_NOWHERE){
t=0
}
if(typeof(t)=="number"){
t=t+"px"
}
return t
};
Dwt.byId=function(o,t){
if(!t){
return(typeof o=="string"?document.getElementById(o):o)
}
if(t==o||t.id==o){
return t
}
for(var e=0;
e<t.childNodes.length;
e++){
if(t.childNodes[e].nodeType==1){
var a=Dwt.byId(o,t.childNodes[e]);
if(a){
return a
}}}
return null
};
Dwt.byTag=function(e){
return document.getElementsByTagName(e)
};
Dwt.show=function(t){
var e=Dwt.byId(t);
if(e){
Dwt.setVisible(e,true)
}};
Dwt.hide=function(t){
var e=Dwt.byId(t);
if(e){
Dwt.setVisible(e,false)
}};
Dwt.toggle=function(t,e){
t=Dwt.byId(t);
if(e==null){
e=(Dwt.getVisible(t)!=true)
}
Dwt.setVisible(t,e)
};
Dwt.setText=function(e,t){
e.appendChild(document.createTextNode(t))
};
Dwt.populateText=function(){
if(arguments.length==0){
return
}
var a,e=0,t=arguments.length;
while(e<t){
a=document.getElementById(arguments[e]);
if(a){
Dwt.setText(a,arguments[e+1])
}
e+=2
}};
Dwt.setInnerHtml=function(t,e){
t.innerHTML=e
};
Dwt.setFavIcon=function(r){
return;
var e=null;
if(Dwt._favIconId){
e=document.getElementById(Dwt._favIconId)
}else{
var h=document.getElementsByTagName("head")[0];
var t=h.getElementsByTagName("link");
for(var o=0;
o<t.length;
o++){
var s=t[o];
if(s.rel.toUpperCase()=="SHORTCUT ICON"){
if(!s.id){
s.id=Dwt._favIconId=Dwt.getNextId()
}
e=s;
break
}}}
if(e){
e.href=r;
var n=e.parentNode;
n.removeChild(e);
n.appendChild(e)
}else{
var a=document.createElement("link");
a.id=Dwt._favIconId=Dwt.getNextId();
a.rel="SHORTCUT ICON";
a.href=r;
h=h||document.getElementsByTagName("head")[0];
h.appendChild(a)
}};
Dwt.enableDesignMode=function(a,e){
if(!AjxEnv.isIE){
a.designMode=e?"on":"off"
}else{
var t=a.body;
if(!t||t.contentEditable===undefined){
a.designMode=e?"on":"off"
}else{
t.contentEditable=e?true:false
}}};
Dwt.ffScrollbarCheck=function(a){
if(AjxEnv.isFirefox3_6up||AjxEnv.isDesktop2up){
var e=a.target;
if(e&&(e.clientHeight&&e.scrollHeight&&(e.clientHeight!=e.scrollHeight))||(e.clientWidth&&e.scrollWidth&&(e.clientWidth!=e.scrollWidth))){
a._dontCallPreventDefault=true;
a._stopPropagation=false;
a._returnValue=true;
return true
}}
return false
};
Dwt.selectText=function(t){
if(!t){
Dwt.deselectText();
return
}
if(document.selection){
var e=t.parentTextEdit.createTextRange();
e.moveToElementText(t);
e.select()
}else{
if(window.getSelection){
var e=document.createRange();
e.selectNode(t);
var a=window.getSelection();
a.addRange(e)
}}};
Dwt.deselectText=function(){
if(document.selection){
document.selection.empty()
}else{
if(window.getSelection){
window.getSelection().removeAllRanges()
}}};
Dwt.doOverlap=function(n,o){
if(!n||!o){
return false
}
var r=Dwt.getLocation(n),s=Dwt.getLocation(o);
var d=Dwt.getSize(n),c=Dwt.getSize(o);
var m=r.x,u=s.x,l=r.y,h=s.y;
var i=m+d.x,t=u+c.x;
var a=l+d.y,e=h+c.y;
return !(m>t||i<u||l>e||a<h)
};
Dwt.setLoadingTime=function(a,e){
if(!window.isPerfMetric){
return
}
if(!e){
e=new Date()
}
a+="_loading";
var t=document.getElementById(a);
if(!t){
t=document.createElement("div");
t.id=a;
t.style.display="none";
document.body.appendChild(t)
}
t.innerHTML=e.getTime()
};
Dwt.setLoadedTime=function(a,e){
if(!window.isPerfMetric){
return
}
if(!e){
e=new Date()
}
a+="_loaded";
var t=document.getElementById(a);
if(!t){
t=document.createElement("div");
t.id=a;
t.style.display="none";
document.body.appendChild(t)
}
t.innerHTML=e.getTime()
};
