
/* Copyright (C) 2005-2009 Zimbra Inc. http://www.zimbra.com/ */
DwtAlert=function(a,t,e){
if(arguments.length==0){
return
}
t=t||"DwtAlert";
e=e||DwtControl.STATIC_STYLE;
DwtControl.call(this,{
parent:a,className:t,posStyle:e}
);
this._alertStyle=DwtAlert.INFORMATION;
this._createHtml()
};
DwtAlert.prototype=new DwtControl;
DwtAlert.prototype.constructor=DwtAlert;
DwtAlert.INFORMATION=0;
DwtAlert.WARNING=1;
DwtAlert.CRITICAL=2;
DwtAlert._ICONS=[AjxImg.getClassForImage("Information_32"),AjxImg.getClassForImage("Warning_32"),AjxImg.getClassForImage("Critical_32")];
DwtAlert._CLASSES=["DwtAlertInfo","DwtAlertWarn","DwtAlertCrit"];
DwtAlert._RE_ICONS=new RegExp(DwtAlert._ICONS.join("|"));
DwtAlert._RE_CLASSES=new RegExp(DwtAlert._CLASSES.join("|"));
DwtAlert.prototype.TEMPLATE="dwt.Widgets#DwtAlert";
DwtAlert.prototype.setStyle=function(e){
this._alertStyle=e||DwtAlert.INFORMATION;
if(this._iconDiv){
Dwt.delClass(this._iconDiv,DwtAlert._RE_ICONS,DwtAlert._ICONS[this._alertStyle])
}
Dwt.delClass(this.getHtmlElement(),DwtAlert._RE_CLASSES,DwtAlert._CLASSES[this._alertStyle])
};
DwtAlert.prototype.getStyle=function(){
return this._alertStyle
};
DwtAlert.prototype.setIconVisible=function(e){
if(this._iconDiv){
Dwt.setVisible(this._iconDiv,e)
}};
DwtAlert.prototype.getIconVisible=function(){
return this._iconDiv?Dwt.getVisible(this._iconDiv):false
};
DwtAlert.prototype.setTitle=function(e){
this._alertTitle=e;
if(this._titleDiv){
this._titleDiv.innerHTML=e||""
}};
DwtAlert.prototype.getTitle=function(){
return this._alertTitle
};
DwtAlert.prototype.setContent=function(e){
this._alertContent=e;
if(this._contentDiv){
this._contentDiv.innerHTML=e||""
}};
DwtAlert.prototype.getContent=function(){
return this._alertContent
};
DwtAlert.prototype.setDismissContent=function(e){
if(this._dismissDiv){
e.reparentHtmlElement(this._dismissDiv.id)
}};
DwtAlert.prototype.getTabGroupMember=function(){
return null
};
DwtAlert.prototype._createHtml=function(e){
var t={
id:this._htmlElId};
this._createHtmlFromTemplate(e||this.TEMPLATE,t)
};
DwtAlert.prototype._createHtmlFromTemplate=function(e,t){
DwtControl.prototype._createHtmlFromTemplate.apply(this,arguments);
this._iconDiv=document.getElementById(t.id+"_icon");
this._titleDiv=document.getElementById(t.id+"_title");
this._contentDiv=document.getElementById(t.id+"_content");
this._dismissDiv=document.getElementById(t.id+"_dismiss")
};
