
/* Copyright (C) 2005-2009 Zimbra Inc. http://www.zimbra.com/ */
DwtCalendar=function(e){
if(arguments.length==0){
return
}
e=Dwt.getParams(arguments,DwtCalendar.PARAMS);
e.className=e.className||"DwtCalendar";
DwtComposite.call(this,e);
this._skipNotifyOnPage=false;
this._hidePrevNextMo=e.hidePrevNextMo;
this._readOnly=e.readOnly;
this._showWeekNumber=e.showWeekNumber;
this._uuid=Dwt.getNextId();
var t=this._origDayClassName=e.className+"Day";
this._todayClassName=" "+e.className+"Day-today";
this._selectedDayClassName=" "+t+"-"+DwtCssStyle.SELECTED;
this._hoveredDayClassName=" "+t+"-"+DwtCssStyle.HOVER;
this._activeDayClassName=" "+t+"-"+DwtCssStyle.ACTIVE;
this._hiliteClassName=" "+t+"-hilited";
this._greyClassName=" "+t+"-grey";
if(!this._readOnly){
this._installListeners()
}
this._selectionMode=DwtCalendar.DAY;
this._init();
this._weekDays=new Array(7);
this._workingDays=e.workingDays||DwtCalendar._DEF_WORKING_DAYS;
this._useISO8601WeekNo=e.useISO8601WeekNo;
this.setFirstDayOfWeek(e.firstDayOfWeek||DwtCalendar.SUN);
this._forceRollOver=(e.forceRollOver!==false)
};
DwtCalendar.PARAMS=["parent","className","posStyle","firstDayOfWeek","forceRollOver","workingDaysArray","hidePrevNextMo","readOnly"];
DwtCalendar.prototype=new DwtComposite;
DwtCalendar.prototype.constructor=DwtCalendar;
DwtCalendar.SUN=0;
DwtCalendar.MON=1;
DwtCalendar.TUE=2;
DwtCalendar.WED=3;
DwtCalendar.THU=4;
DwtCalendar.FRI=5;
DwtCalendar.SAT=6;
DwtCalendar.DAY=1;
DwtCalendar.WEEK=2;
DwtCalendar.WORK_WEEK=3;
DwtCalendar.MONTH=4;
DwtCalendar.RANGE_CHANGE="DwtCalendar.RANGE_CHANGE";
DwtCalendar._FULL_WEEK=[1,1,1,1,1,1,1];
DwtCalendar._DEF_WORKING_DAYS=[0,1,1,1,1,1,0];
DwtCalendar._DAYS_IN_MONTH=[31,28,31,30,31,30,31,31,30,31,30,31];
DwtCalendar._NO_MONTH=-2;
DwtCalendar._PREV_MONTH=-1;
DwtCalendar._THIS_MONTH=0;
DwtCalendar._NEXT_MONTH=1;
DwtCalendar._NORMAL=1;
DwtCalendar._HOVERED=2;
DwtCalendar._ACTIVE=3;
DwtCalendar._SELECTED=4;
DwtCalendar._DESELECTED=5;
DwtCalendar.DATE_SELECTED=1;
DwtCalendar.DATE_DESELECTED=2;
DwtCalendar.DATE_DBL_CLICKED=3;
DwtCalendar._LAST_DAY_CELL_IDX=41;
DwtCalendar._BUTTON_CLASS="DwtCalendarButton";
DwtCalendar._BUTTON_HOVERED_CLASS=DwtCalendar._BUTTON_CLASS+"-"+DwtCssStyle.HOVER;
DwtCalendar._BUTTON_ACTIVE_CLASS=DwtCalendar._BUTTON_CLASS+"-"+DwtCssStyle.ACTIVE;
DwtCalendar._TITLE_CLASS="DwtCalendarTitle";
DwtCalendar._TITLE_HOVERED_CLASS=DwtCalendar._TITLE_CLASS+"-"+DwtCssStyle.HOVER;
DwtCalendar._TITLE_ACTIVE_CLASS=DwtCalendar._TITLE_CLASS+"-"+DwtCssStyle.ACTIVE;
DwtCalendar.prototype.toString=function(){
return"DwtCalendar"
};
DwtCalendar.prototype.addSelectionListener=function(e){
this.addListener(DwtEvent.SELECTION,e)
};
DwtCalendar.prototype.removeSelectionListener=function(e){
this.removeListener(DwtEvent.SELECTION,e)
};
DwtCalendar.prototype.addActionListener=function(e){
this.addListener(DwtEvent.ACTION,e)
};
DwtCalendar.prototype.removeActionListener=function(e){
this.removeListener(DwtEvent.ACTION,e)
};
DwtCalendar.prototype.addDateRangeListener=function(e){
this.addListener(DwtEvent.DATE_RANGE,e)
};
DwtCalendar.prototype.removeDateRangeListener=function(e){
this.removeListener(DwtEvent.DATE_RANGE,e)
};
DwtCalendar.prototype.setSkipNotifyOnPage=function(e){
this._skipNotifyOnPage=e
};
DwtCalendar.prototype.getSkipNotifyOnPage=function(){
return this._skipNotifyOnPage
};
DwtCalendar.prototype.setDate=function(i,s,a,t){
a=(a==null)?this._forceRollOver:a;
if(!i){
i=new Date()
}
var l=new Date(i.getTime());
var o=this._date;
var n=false;
var d=false;
var e;
if(this._date2CellId!=null){
var h=(l.getFullYear()*10000)+(l.getMonth()*100)+l.getDate();
var e=this._date2CellId[h];
if(e){
if(e==this._selectedCellId){
d=true
}
var c=document.getElementById(e);
if(c._dayType==DwtCalendar._THIS_MONTH){
d=true
}else{
if(a){
d=n=true
}else{
d=true
}}}else{
d=n=true
}}else{
d=n=true
}
if(d){
if(this._date){
if(AjxDateUtil.isDayShifted(l)){
AjxDateUtil.rollToNextDay(l)
}
l.setHours(this._date.getHours(),this._date.getMinutes(),this._date.getSeconds(),0)
}
this._date=l;
if(!n&&!this._readOnly){
this._setSelectedDate();
this._setToday()
}}
if(n){
this._layout()
}
if(d&&!s){
var r=t?DwtCalendar.DATE_DBL_CLICKED:DwtCalendar.DATE_SELECTED;
this._notifyListeners(DwtEvent.SELECTION,r,this._date)
}
return true
};
DwtCalendar.prototype.isSelected=function(t){
if(t==this._selectedDayElId){
return true
}else{
if(this._selectionMode!=DwtCalendar.DAY){
var e=this._getDayCellIndex(t);
if(Math.floor(e/7)==Math.floor(this._getDayCellIndex(this._selectedDayElId)/7)&&this._currWorkingDays[e%7]){
return true
}}}
return false
};
DwtCalendar.prototype.getForceRollOver=function(){
return this._forceRollOver
};
DwtCalendar.prototype.setForceRollOver=function(e){
if(e==null){
return
}
if(this._forceRollOver!=e){
this._forceRollOver=e;
this._layout()
}};
DwtCalendar.prototype.getSelectionMode=function(){
return this._selectionMode
};
DwtCalendar.prototype.setSelectionMode=function(e){
if(this._selectionMode==e){
return
}
this._selectionMode=e;
if(e==DwtCalendar.WEEK){
this._currWorkingDays=DwtCalendar._FULL_WEEK
}else{
if(e==DwtCalendar.WORK_WEEK){
this._currWorkingDays=this._workingDays
}}
this._layout()
};
DwtCalendar.prototype.setWorkingWeek=function(e){
this._workingDays=this._currWorkingDays=e;
if(this._selectionMode==DwtCalendar.WORK_WEEK){
this._layout()
}};
DwtCalendar.prototype.setHilite=function(s,a,t){
if(this._date2CellId==null){
return
}
var e;
var r;
if(t){
for(r in this._date2CellId){
e=document.getElementById(this._date2CellId[r]);
if(e._isHilited){
e._isHilited=false;
this._setClassName(e,DwtCalendar._NORMAL)
}}}
var n;
for(var o in s){
r=s[o];
n=this._date2CellId[r.getFullYear()*10000+r.getMonth()*100+r.getDate()];
if(n){
e=document.getElementById(n);
if(e._isHilited!=a){
e._isHilited=a;
this._setClassName(e,DwtCalendar._NORMAL)
}}}};
DwtCalendar.prototype.getDate=function(){
return this._date
};
DwtCalendar.prototype.setFirstDayOfWeek=function(e){
for(var a=0;
a<7;
a++){
this._weekDays[a]=(a<e)?(6-(e-a-1)):(a-e);
var t=document.getElementById(this._getDOWCellId(a));
t.innerHTML=AjxDateUtil.WEEKDAY_SHORT[(e+a)%7]
}
this._firstDayOfWeek=e;
this._layout()
};
DwtCalendar.prototype.getDateRange=function(){
return this._range
};
DwtCalendar.prototype._getDayCellId=function(e){
return("c:"+e+":"+this._uuid)
};
DwtCalendar.prototype._getDayCellIndex=function(e){
return e.substring(2,e.indexOf(":",3))
};
DwtCalendar.prototype._getDOWCellId=function(e){
return("w:"+e+":"+this._uuid)
};
DwtCalendar.prototype._getWeekNumberCellId=function(e){
return("k:"+e+":"+this._uuid)
};
DwtCalendar.prototype._getDaysInMonth=function(t,e){
if(t!=1){
return DwtCalendar._DAYS_IN_MONTH[t]
}
if(e%4!=0||(e%100==0&&e%400!=0)){
return 28
}
return 29
};
DwtCalendar.prototype._installListeners=function(){
this._setMouseEventHdlrs();
this.addListener(DwtEvent.ONMOUSEOVER,new AjxListener(this,this._mouseOverListener));
this.addListener(DwtEvent.ONMOUSEOUT,new AjxListener(this,this._mouseOutListener));
this.addListener(DwtEvent.ONMOUSEDOWN,new AjxListener(this,this._mouseDownListener));
this.addListener(DwtEvent.ONMOUSEUP,new AjxListener(this,this._mouseUpListener));
this.addListener(DwtEvent.ONDBLCLICK,new AjxListener(this,this._doubleClickListener))
};
DwtCalendar.prototype._notifyListeners=function(e,a,t,i){
if(!this.isListenerRegistered(e)){
return
}
var o=DwtShell.selectionEvent;
if(i){
DwtUiEvent.copy(o,i)
}else{
o.reset()
}
o.item=this;
o.detail=t;
o.type=a;
this.notifyListeners(e,o)
};
DwtCalendar.prototype._layout=function(){
if(this._date==null){
this._date=new Date()
}
if(!this._calWidgetInited){
this._init()
}
var p=new Date(this._date.getTime());
p.setDate(1);
var s=p.getFullYear();
var g=p.getMonth();
var n=p.getDay();
var a=this._getDaysInMonth(g,s);
var l=1;
var y=1;
this._date2CellId=new Object();
this._selectedDayElId=null;
var o,d,b,f,e;
if(!this._hidePrevNextMo){
if(g!=0){
o=this._getDaysInMonth(g-1,s)-this._weekDays[n]+1;
d=s;
b=g-1;
if(g!=11){
f=g+1;
e=s
}else{
f=0;
e=s+1
}}else{
o=this._getDaysInMonth(11,s-1)-this._weekDays[n]+1;
d=s-1;
b=11;
f=1;
e=s
}}
for(var c=0;
c<6;
c++){
for(var h=0;
h<7;
h++){
var m=document.getElementById(this._getDayCellId(c*7+h));
if(m._isHilited==null){
m._isHilited=false
}
if(l<=a){
if(c!=0||h>=this._weekDays[n]){
this._date2CellId[(s*10000)+(g*100)+l]=m.id;
m._day=l;
m._month=g;
m._year=s;
m.innerHTML=l++;
m._dayType=DwtCalendar._THIS_MONTH;
if(this._readOnly){
m.style.fontFamily="Arial";
m.style.fontSize="10px"
}}else{
if(this._hidePrevNextMo){
m.innerHTML=""
}else{
this._date2CellId[(d*10000)+(b*100)+o]=m.id;
m._day=o;
m._month=b;
m._year=d;
m.innerHTML=o++;
m._dayType=DwtCalendar._PREV_MONTH
}}}else{
if(!this._hidePrevNextMo){
this._date2CellId[(e*10000)+(f*100)+y]=m.id;
m._day=y;
m._month=f;
m._year=e;
m.innerHTML=y++;
m._dayType=DwtCalendar._NEXT_MONTH
}}
this._setClassName(m,DwtCalendar._NORMAL)
}
if(this._showWeekNumber){
var r=this._getWeekNumberCellId("kw"+c*7);
var u=document.getElementById(r);
if(u){
var t=document.getElementById(this._getDayCellId(c*7));
u.innerHTML=AjxDateUtil.getWeekNumber(new Date(t._year,t._month,t._day),this._firstDayOfWeek,null,this._useISO8601WeekNo)
}}}
this._setTitle(g,s);
if(!this._readOnly){
this._setSelectedDate();
this._setToday()
}
this._setRange()
};
DwtCalendar.prototype._setRange=function(){
var e=document.getElementById(this._getDayCellId(0));
var i=new Date(e._year,e._month,e._day,0,0,0,0);
e=document.getElementById(this._getDayCellId(DwtCalendar._LAST_DAY_CELL_IDX));
var a=this._getDaysInMonth(e._month,e._year);
var t;
if(e._day<a){
t=new Date(e._year,e._month,e._day+1,0,0,0,0)
}else{
if(e._month<11){
t=new Date(e._year,e._month+1,1,0,0,0,0)
}else{
t=new Date(e._year+1,0,1,0,0,0,0)
}}
if(this._range==null){
this._range={}
}else{
if(this._range.start.getTime()==i.getTime()&&this._range.end.getTime()==t.getTime()){
return false
}}
this._range.start=i;
this._range.end=t;
if(!this.isListenerRegistered(DwtEvent.DATE_RANGE)){
return
}
if(!this._dateRangeEvent){
this._dateRangeEvent=new DwtDateRangeEvent(true)
}
this._dateRangeEvent.item=this;
this._dateRangeEvent.start=i;
this._dateRangeEvent.end=t;
this.notifyListeners(DwtEvent.DATE_RANGE,this._dateRangeEvent)
};
DwtCalendar.prototype._setToday=function(){
var e;
var t=new Date();
var a=t.getDate();
if(!this._todayDay||this._todayDay!=a){
if(this._todayCellId!=null){
e=document.getElementById(this._todayCellId);
e._isToday=false;
this._setClassName(e,DwtCalendar._NORMAL)
}
this._todayCellId=this._date2CellId[(t.getFullYear()*10000)+(t.getMonth()*100)+a];
if(this._todayCellId!=null){
e=document.getElementById(this._todayCellId);
e._isToday=true;
this._setClassName(e,DwtCalendar._NORMAL)
}}};
DwtCalendar.prototype._setSelectedDate=function(){
var t=this._date.getDate();
var o=this._date.getMonth();
var a=this._date.getFullYear();
var e;
if(this._selectedDayElId){
e=document.getElementById(this._selectedDayElId);
this._setClassName(e,DwtCalendar._DESELECTED)
}
var i=this._date2CellId[(a*10000)+(o*100)+t];
e=document.getElementById(i);
this._selectedDayElId=i;
this._setClassName(e,DwtCalendar._SELECTED)
};
DwtCalendar.prototype._setCellClassName=function(t,a,i){
if(t._dayType!=DwtCalendar._THIS_MONTH){
a+=this._greyClassName
}
if(this._selectionMode==DwtCalendar.DAY&&t.id==this._selectedDayElId&&i!=DwtCalendar._DESELECTED){
a+=this._selectedDayClassName
}else{
if(this._selectionMode!=DwtCalendar.DAY&&i!=DwtCalendar._DESELECTED&&this._selectedDayElId!=null){
var e=this._getDayCellIndex(t.id);
if(Math.floor(this._getDayCellIndex(this._selectedDayElId)/7)==Math.floor(e/7)&&this._currWorkingDays[e%7]){
a+=this._selectedDayClassName
}}}
if(t._isHilited){
a+=this._hiliteClassName
}
if(t._isToday){
a+=this._todayClassName
}
return a
};
DwtCalendar.prototype._setClassName=function(e,s){
var a="";
if(s==DwtCalendar._NORMAL){
a=this._origDayClassName
}else{
if(s==DwtCalendar._HOVERED){
a=this._hoveredDayClassName
}else{
if(s==DwtCalendar._ACTIVE){
a=this._activeDayClassName
}else{
if(s==DwtCalendar._DESELECTED&&this._selectionMode==DwtCalendar.DAY){
a=this._origDayClassName
}else{
if(this._selectionMode!=DwtCalendar.DAY&&(s==DwtCalendar._SELECTED||s==DwtCalendar._DESELECTED)){
var n=Math.floor(this._getDayCellIndex(this._selectedDayElId)/7)*7;
for(var t=0;
t<7;
t++){
a=this._origDayClassName;
var o=document.getElementById(this._getDayCellId(n++));
o.className=this._setCellClassName(o,a,s)
}
return
}}}}}
e.className=this._setCellClassName(e,a,s)
};
DwtCalendar.prototype._setTitle=function(o,i){
var e=document.getElementById(this._monthCell);
var a=DwtCalendar.getMonthFormatter();
var t=new Date(i,o);
e.innerHTML=a.format(t)
};
DwtCalendar.prototype._init=function(){
var o=new Array(100);
var e=0;
this._monthCell="t:"+this._uuid;
o[e++]="<table width=100% cellspacing='0' cellpadding='0' style='border-collapse:collapse;'>";
o[e++]="<tr><td class=DwtCalendarTitlebar>";
o[e++]="<table width='100%' cellspacing='0' cellpadding='0'>";
o[e++]="<tr>";
o[e++]="<td class='";
o[e++]=DwtCalendar._BUTTON_CLASS;
o[e++]="' id='b:py:";
o[e++]=this._uuid;
o[e++]="'>";
o[e++]=AjxImg.getImageHtml("FastRevArrowSmall",null,["id='b:py:img:",this._uuid,"'"].join(""));
o[e++]="</td>";
o[e++]="<td class='";
o[e++]=DwtCalendar._BUTTON_CLASS;
o[e++]="' id='b:pm:";
o[e++]=this._uuid;
o[e++]="'>";
o[e++]=AjxImg.getImageHtml("RevArrowSmall",null,["id='b:pm:img:",this._uuid,"'"].join(""));
o[e++]="</td>";
o[e++]="<td align='center' class='DwtCalendarTitleCell' nowrap'><span class='";
o[e++]=DwtCalendar._TITLE_CLASS;
o[e++]="' id='";
o[e++]=this._monthCell;
o[e++]="'>&nbsp;</span></td>";
o[e++]="<td class='";
o[e++]=DwtCalendar._BUTTON_CLASS;
o[e++]="' id='b:nm:";
o[e++]=this._uuid;
o[e++]="'>";
o[e++]=AjxImg.getImageHtml("FwdArrowSmall",null,["id='b:nm:img:",this._uuid,"'"].join(""));
o[e++]="</td>";
o[e++]="<td class='";
o[e++]=DwtCalendar._BUTTON_CLASS;
o[e++]="' id='b:ny:";
o[e++]=this._uuid;
o[e++]="'>";
o[e++]=AjxImg.getImageHtml("FastFwdArrowSmall",null,["id='b:ny:img:",this._uuid,"'"].join(""));
o[e++]="</td>";
o[e++]="</tr>";
o[e++]="</table>";
o[e++]="</td></tr>";
o[e++]="<tr><td>";
o[e++]="<table cellspacing='0' cellpadding='1' width='100%'>";
o[e++]="<tr>";
if(this._showWeekNumber){
o[e++]="<td class='DwtCalendarWeekNoTitle' width='14%' id='";
o[e++]=this._getWeekNumberCellId("kw");
o[e++]="'>";
o[e++]=AjxMsg.calendarWeekTitle;
o[e++]="</td>"
}
for(var a=0;
a<7;
a++){
o[e++]="<td class='DwtCalendarDow' width='";
o[e++]=(a<5?"14%":"15%");
o[e++]="' id='";
o[e++]=this._getDOWCellId(a);
o[e++]="'>&nbsp;</td>"
}
o[e++]="</tr>";
for(var a=0;
a<6;
a++){
o[e++]=(AjxEnv.isLinux||AjxEnv.isMac)?"<tr style='line-height:12px'>":"<tr>";
if(this._showWeekNumber){
o[e++]="<td class='DwtCalendarWeekNo' id='"+this._getWeekNumberCellId("kw"+a*7)+"'>&nbsp;</td>"
}
for(var t=0;
t<7;
t++){
o[e++]="<td id='";
o[e++]=this._getDayCellId(a*7+t);
o[e++]="'>&nbsp;</td>"
}
o[e++]="</tr>"
}
o[e++]="</td></tr></table></table>";
this.getHtmlElement().innerHTML=o.join("");
if(!this._readOnly){
document.getElementById("b:py:img:"+this._uuid)._origClassName=AjxImg.getClassForImage("FastRevArrowSmall");
document.getElementById("b:pm:img:"+this._uuid)._origClassName=AjxImg.getClassForImage("RevArrowSmall");
document.getElementById("b:nm:img:"+this._uuid)._origClassName=AjxImg.getClassForImage("FwdArrowSmall");
document.getElementById("b:ny:img:"+this._uuid)._origClassName=AjxImg.getClassForImage("FastFwdArrowSmall")
}
this._calWidgetInited=true
};
DwtCalendar.prototype.setMouseOverDayCallback=function(e){
this._mouseOverDayCB=e
};
DwtCalendar.prototype.setMouseOutDayCallback=function(e){
this._mouseOutDayCB=e
};
DwtCalendar.prototype.getDndDate=function(){
var e=this._lastDndCell;
if(e){
return new Date(e._year,e._month,e._day)
}
return null
};
DwtCalendar._tmpDate=new Date();
DwtCalendar._tmpDate.setHours(0,0,0,0);
DwtCalendar.prototype._mouseOverListener=function(t){
var a=t.target;
if(a.id.charAt(0)=="c"){
this._setClassName(a,DwtCalendar._HOVERED);
if(this._mouseOverDayCB){
DwtCalendar._tmpDate.setFullYear(a._year,a._month,a._day);
this._mouseOverDayCB.run(this,DwtCalendar._tmpDate)
}}else{
if(a.id.charAt(0)=="t"){
return
}else{
if(a.id.charAt(0)=="b"){
var e;
if(a.firstChild==null){
e=a;
AjxImg.getParentElement(a).className=DwtCalendar._BUTTON_HOVERED_CLASS
}else{
a.className=DwtCalendar._BUTTON_HOVERED_CLASS;
e=AjxImg.getImageElement(a)
}
e.className=e._origClassName
}}}
t._stopPropagation=true
};
DwtCalendar.prototype._mouseOutListener=function(t){
this.setToolTipContent(null);
var a=t.target;
if(a.id.charAt(0)=="c"){
this._setClassName(a,DwtCalendar._NORMAL);
if(this._mouseOutDayCB){
this._mouseOutDayCB.run(this)
}}else{
if(a.id.charAt(0)=="b"){
var e;
a.className=DwtCalendar._BUTTON_CLASS;
if(a.firstChild==null){
e=a;
AjxImg.getParentElement(a).className=DwtCalendar._BUTTON_CLASS
}else{
a.className=DwtCalendar._BUTTON_CLASS;
e=AjxImg.getImageElement(a)
}
e.className=e._origClassName
}}};
DwtCalendar.prototype._mouseDownListener=function(t){
if(t.button==DwtMouseEvent.LEFT){
var a=t.target;
if(a.id.charAt(0)=="c"){
this._setClassName(a,DwtCalendar._ACTIVE)
}else{
if(a.id.charAt(0)=="t"){
a.className=DwtCalendar._TITLE_ACTIVE_CLASS
}else{
if(a.id.charAt(0)=="b"){
var e;
if(a.firstChild==null){
e=a;
AjxImg.getParentElement(a).className=DwtCalendar._BUTTON_ACTIVE_CLASS
}else{
a.className=DwtCalendar._BUTTON_ACTIVE_CLASS;
e=AjxImg.getImageElement(a)
}
e.className=e._origClassName
}else{
if(a.id.charAt(0)=="w"){}}}}}};
DwtCalendar.prototype._mouseUpListener=function(t){
var i=t.target;
if(t.button==DwtMouseEvent.LEFT){
if(i.id.charAt(0)=="c"){
if(this.parent instanceof DwtMenu){
DwtMenu.closeActiveMenu()
}
var a=new Date(i._year,i._month,i._day);
if(a.getDate()!=i._day){
a.setDate(i._day)
}
if(this.setDate(a)){
return
}
this._setClassName(i,DwtCalendar._HOVERED)
}else{
if(i.id.charAt(0)=="b"){
var e;
if(i.firstChild==null){
e=i;
AjxImg.getParentElement(i).className=DwtCalendar._BUTTON_HOVERED_CLASS
}else{
i.className=DwtCalendar._BUTTON_HOVERED_CLASS;
e=AjxImg.getImageElement(i)
}
e.className=e._origClassName;
if(e.id.indexOf("py")!=-1){
this._prevYear()
}else{
if(e.id.indexOf("pm")!=-1){
this._prevMonth()
}else{
if(e.id.indexOf("nm")!=-1){
this._nextMonth()
}else{
this._nextYear()
}}}}else{
if(i.id.charAt(0)=="t"){
i.className=DwtCalendar._TITLE_HOVERED_CLASS;
this.setDate(new Date(),this._skipNotifyOnPage);
if(this.parent instanceof DwtMenu){
DwtMenu.closeActiveMenu()
}}}}}else{
if(t.button==DwtMouseEvent.RIGHT&&i.id.charAt(0)=="c"){
this._notifyListeners(DwtEvent.ACTION,0,new Date(i._year,i._month,i._day),t)
}}};
DwtCalendar.prototype._doubleClickListener=function(e){
var t=e.target;
if(this._selectionEvent){
this._selectionEvent.type=DwtCalendar.DATE_DBL_CLICKED
}
if(t.id.charAt(0)=="c"){
if(this.parent instanceof DwtMenu){
DwtMenu.closeActiveMenu()
}
this.setDate(new Date(t._year,t._month,t._day),false,false,true)
}};
DwtCalendar.prototype._prevMonth=function(e){
var t=new Date(this._date.getTime());
this.setDate(AjxDateUtil.roll(t,AjxDateUtil.MONTH,-1),this._skipNotifyOnPage)
};
DwtCalendar.prototype._nextMonth=function(e){
var t=new Date(this._date.getTime());
this.setDate(AjxDateUtil.roll(t,AjxDateUtil.MONTH,1),this._skipNotifyOnPage)
};
DwtCalendar.prototype._prevYear=function(e){
var t=new Date(this._date.getTime());
this.setDate(AjxDateUtil.roll(t,AjxDateUtil.YEAR,-1),this._skipNotifyOnPage)
};
DwtCalendar.prototype._nextYear=function(e){
var t=new Date(this._date.getTime());
this.setDate(AjxDateUtil.roll(t,AjxDateUtil.YEAR,1),this._skipNotifyOnPage)
};
DwtCalendar.getDateFormatter=function(){
if(!DwtCalendar._dateFormatter){
DwtCalendar._dateFormatter=new AjxDateFormat(AjxMsg.formatCalDate)
}
return DwtCalendar._dateFormatter
};
DwtCalendar.getDateLongFormatter=function(){
if(!DwtCalendar._dateLongFormatter){
DwtCalendar._dateLongFormatter=new AjxDateFormat(AjxMsg.formatCalDateLong)
}
return DwtCalendar._dateLongFormatter
};
DwtCalendar.getDateFullFormatter=function(){
if(!DwtCalendar._dateFullFormatter){
DwtCalendar._dateFullFormatter=new AjxDateFormat(AjxMsg.formatCalDateFull)
}
return DwtCalendar._dateFullFormatter
};
DwtCalendar.getHourFormatter=function(){
if(!DwtCalendar._hourFormatter){
DwtCalendar._hourFormatter=new AjxMessageFormat(AjxMsg.formatCalHour)
}
return DwtCalendar._hourFormatter
};
DwtCalendar.getDayFormatter=function(){
if(!DwtCalendar._dayFormatter){
DwtCalendar._dayFormatter=new AjxDateFormat(AjxMsg.formatCalDay)
}
return DwtCalendar._dayFormatter
};
DwtCalendar.getMonthFormatter=function(){
if(!DwtCalendar._monthFormatter){
DwtCalendar._monthFormatter=new AjxDateFormat(AjxMsg.formatCalMonth)
}
return DwtCalendar._monthFormatter
};
DwtCalendar.getShortMonthFormatter=function(){
if(!DwtCalendar._shortMonthFormatter){
DwtCalendar._shortMonthFormatter=new AjxDateFormat(AjxMsg.formatShortCalMonth)
}
return DwtCalendar._shortMonthFormatter
};
DwtCalendar.prototype._dragEnter=function(e){};
DwtCalendar.prototype._dragHover=function(e){};
DwtCalendar.prototype._dragOver=function(e){
var t=e.target;
if(t.id.charAt(0)=="c"){
this._setClassName(t,DwtCalendar._HOVERED);
this._lastDndCell=t
}else{
this._lastDndCell=null
}};
DwtCalendar.prototype._dragLeave=function(e){};
