
/* Copyright (C) 2005-2009 Zimbra Inc. http://www.zimbra.com/ */
DwtControl=function(t){
if(arguments.length==0){
return
}
t=Dwt.getParams(arguments,DwtControl.PARAMS);
var e=this.parent=t.parent;
if(e&&!(e instanceof DwtComposite)){
throw new DwtException("Parent must be a subclass of Composite",DwtException.INVALIDPARENT,"DwtControl")
}
this.shell=null;
this._data={};
this._eventMgr=new AjxEventMgr();
this._disposed=false;
if(!e){
return
}
this._className=t.className||"DwtControl";
this.__posStyle=t.posStyle;
if(t.id){
this._htmlElId=t.id
}
this.__index=t.index;
this.__parentElement=t.parentElement;
this._enabled=false;
this._dragging=null;
this._dndProxy=null;
this._hasFocus=false;
if(!t.deferred){
this.__initCtrl()
}
this._hoverOverListener=new AjxListener(this,this.__handleHoverOver);
this._hoverOutListener=new AjxListener(this,this.__handleHoverOut);
this._dblClickIsolation=false;
this._ignoreInternalOverOut=false;
this.TEMPLATE=t.template||this.TEMPLATE
};
DwtControl.PARAMS=["parent","className","posStyle","deferred","id","index","template"];
DwtControl.ALL_BY_ID={};
DwtControl.prototype.toString=function(){
return"DwtControl"
};
DwtControl.NORMAL="";
DwtControl.ACTIVE="ZActive";
DwtControl.FOCUSED="ZFocused";
DwtControl.DISABLED="ZDisabled";
DwtControl.HOVER="ZHover";
DwtControl.SELECTED="ZSelected";
DwtControl.DEFAULT="ZDefault";
DwtControl.ERROR="ZError";
DwtControl._RE_STATES=new RegExp("\\b("+[DwtControl.ACTIVE,DwtControl.FOCUSED,DwtControl.DISABLED,DwtControl.HOVER,DwtControl.SELECTED,DwtControl.DEFAULT,DwtControl.ERROR].join("|")+")\\b","g");
DwtControl.STATIC_STYLE=Dwt.STATIC_STYLE;
DwtControl.ABSOLUTE_STYLE=Dwt.ABSOLUTE_STYLE;
DwtControl.RELATIVE_STYLE=Dwt.RELATIVE_STYLE;
DwtControl.FIXED_STYLE=Dwt.FIXED_STYLE;
DwtControl.CLIP=Dwt.CLIP;
DwtControl.VISIBLE=Dwt.VISIBLE;
DwtControl.SCROLL=Dwt.SCROLL;
DwtControl.FIXED_SCROLL=Dwt.FIXED_SCROLL;
DwtControl.DEFAULT=Dwt.DEFAULT;
DwtControl._NO_DRAG=1;
DwtControl._DRAGGING=2;
DwtControl._DRAG_REJECTED=3;
DwtControl.__DRAG_THRESHOLD=3;
DwtControl.__TOOLTIP_THRESHOLD=5;
DwtControl.__DND_HOVER_DELAY=750;
DwtControl.__controlEvent=new DwtControlEvent();
DwtControl.__DBL_CLICK_TIMEOUT=300;
DwtControl.prototype._displayState="";
DwtControl.prototype.addControlListener=function(e){
this.addListener(DwtEvent.CONTROL,e)
};
DwtControl.prototype.removeControlListener=function(e){
this.removeListener(DwtEvent.CONTROL,e)
};
DwtControl.prototype.addDisposeListener=function(e){
this.addListener(DwtEvent.DISPOSE,e)
};
DwtControl.prototype.removeDisposeListener=function(e){
this.removeListener(DwtEvent.DISPOSE,e)
};
DwtControl.prototype.addListener=function(t,a,e){
return this._eventMgr.addListener(t,a,e)
};
DwtControl.prototype.removeListener=function(e,t){
return this._eventMgr.removeListener(e,t)
};
DwtControl.prototype.removeAllListeners=function(e){
return this._eventMgr.removeAll(e)
};
DwtControl.prototype.isListenerRegistered=function(e){
return this._eventMgr.isListenerRegistered(e)
};
DwtControl.prototype.notifyListeners=function(e,t){
return this._eventMgr.notifyListeners(e,t)
};
DwtControl.prototype.dispose=function(){
if(this._disposed){
return
}
if(this.parent!=null&&this.parent instanceof DwtComposite){
this.parent.removeChild(this)
}
this._elRef=null;
if(DwtControl.ALL_BY_ID){
DwtControl.ALL_BY_ID[this._htmlElId]=null;
delete DwtControl.ALL_BY_ID[this._htmlElId]
}
this._disposed=true;
var e=new DwtDisposeEvent();
e.dwtObj=this;
this.notifyListeners(DwtEvent.DISPOSE,e)
};
DwtControl.prototype.getDocument=function(){
return document
};
DwtControl.prototype.getTabGroupMember=function(){
return this
};
DwtControl.prototype.getData=function(e){
return this._data[e]
};
DwtControl.prototype.setData=function(e,t){
this._data[e]=t
};
DwtControl.prototype.isDisposed=function(){
return this._isDisposed
};
DwtControl.prototype.isInitialized=function(){
return this.__ctrlInited
};
DwtControl.prototype.focus=function(){
DwtShell.getShell(window).getKeyboardMgr().grabFocus(this);
this.__doFocus()
};
DwtControl.prototype.blur=function(){
this.__doBlur()
};
DwtControl.prototype.hasFocus=function(){
return this._hasFocus
};
DwtControl.prototype.handleKeyAction=function(e,t){
return false
};
DwtControl.prototype.reparent=function(t,e){
if(!this._checkState()){
return
}
var a=this.getHtmlElement();
this.parent.removeChild(this,true);
DwtComposite._pendingElements[this._htmlElId]=a;
t.addChild(this,e);
this.parent=t
};
DwtControl.prototype.reparentHtmlElement=function(a,e){
if(typeof a=="string"){
a=document.getElementById(a)
}
if(!a){
return
}
var t=this.getHtmlElement();
if(e==null){
a.appendChild(t)
}else{
if(typeof e=="object"){
a.insertBefore(t,e)
}else{
if(a.childNodes[e]){
a.insertBefore(t,a.childNodes[e])
}else{
a.appendChild(t)
}}}};
DwtControl.prototype.setHandler=function(t,e){
if(!this._checkState()){
return
}
var a=this.getHtmlElement();
Dwt.setHandler(a,t,e)
};
DwtControl.prototype.clearHandler=function(e){
if(!this._checkState()){
return
}
var t=this.getHtmlElement();
Dwt.clearHandler(t,e)
};
DwtControl.prototype.getBounds=function(){
if(!this._checkState()){
return
}
return Dwt.getBounds(this.getHtmlElement())
};
DwtControl.prototype.setBounds=function(a,n,i,t){
if(!this._checkState()){
return
}
var o=this.getHtmlElement();
if(this.isListenerRegistered(DwtEvent.CONTROL)){
this.__controlEvent.reset(DwtControlEvent.RESIZE|DwtControlEvent.MOVE);
var e=Dwt.getBounds(o);
this.__controlEvent.oldX=e.x;
this.__controlEvent.oldY=e.y;
this.__controlEvent.oldWidth=e.width;
this.__controlEvent.oldHeight=e.height;
this.setLocation(a,n);
this.setSize(i,t);
e=Dwt.getBounds(o);
this.__controlEvent.newX=e.x;
this.__controlEvent.newY=e.y;
this.__controlEvent.newWidth=e.width;
this.__controlEvent.newHeight=e.height;
this.__controlEvent.requestedWidth=i;
this.__controlEvent.requestedHeight=t;
this.notifyListeners(DwtEvent.CONTROL,this.__controlEvent)
}else{
this.setLocation(a,n);
this.setSize(i,t)
}
return this
};
DwtControl.prototype.getClassName=function(){
return this._className
};
DwtControl.prototype.setClassName=function(t){
if(!this._checkState()){
return
}
this._className=t;
var e=this.getHtmlElement();
e.className=t;
Dwt.addClass(e,this._displayState)
};
DwtControl.prototype.addClassName=function(e){
Dwt.addClass(this.getHtmlElement(),e)
};
DwtControl.prototype.delClassName=function(e,t){
Dwt.delClass(this.getHtmlElement(),e,t)
};
DwtControl.prototype.condClassName=function(a,e,t){
Dwt.condClass(this.getHtmlElement(),a,e,t)
};
DwtControl.prototype.setDisplayState=function(o){
if(!this._enabled){
o=DwtControl.DISABLED
}
if(arguments.length>1){
var e=[];
for(var t=0;
t<arguments.length;
t++){
e.push(arguments[t])
}
o=e.join(" ")
}
if(this._displayState!=o){
this._displayState=o;
Dwt.delClass(this.getHtmlElement(),DwtControl._RE_STATES,o)
}};
DwtControl.prototype.showAlert=function(e){
if(e&&!this._alert){
this.delClassName(null,"ZAlert")
}else{
if(!e&&this._alert){
this.delClassName("ZAlert",null)
}}
this._alert=e
};
DwtControl.prototype.isAlertShown=function(){
return this._alert
};
DwtControl.prototype._createHtmlFromTemplate=function(e,a){
this.getHtmlElement().innerHTML=AjxTemplate.expand(e,a);
var i=AjxTemplate.getParams(e);
var t=i&&i["class"];
if(t){
t=[this._className,t].join(" ");
this.setClassName(t)
}};
DwtControl.prototype.getCursor=function(){
if(!this._checkState()){
return
}
return Dwt.getCursor(this.getHtmlElement())
};
DwtControl.prototype.setCursor=function(e){
if(!this._checkState()){
return
}
Dwt.setCursor(this.getHtmlElement(),e)
};
DwtControl.prototype.getDragSource=function(){
return this._dragSource
};
DwtControl.prototype.setDragSource=function(e){
this._dragSource=e;
if(e&&!this._ctrlCaptureObj){
this.__initCapture();
this._dndHoverAction=new AjxTimedAction(null,this.__dndDoHover)
}};
DwtControl.prototype.getDropTarget=function(){
return this._dropTarget
};
DwtControl.prototype.setDropTarget=function(e){
this._dropTarget=e
};
DwtControl.prototype.getDragBox=function(){
return this._dragBox
};
DwtControl.prototype.setDragBox=function(e){
this._dragBox=e;
if(e&&!this._ctrlCaptureObj){
this.__initCapture()
}};
DwtControl.prototype.__initCapture=function(e){
this._ctrlCaptureObj=new DwtMouseEventCapture({
targetObj:this,id:"DwtControl",mouseOverHdlr:DwtControl.__mouseOverHdlr,mouseDownHdlr:DwtControl.__mouseDownHdlr,mouseMoveHdlr:DwtControl.__mouseMoveHdlr,mouseUpHdlr:DwtControl.__mouseUpHdlr,mouseOutHdlr:DwtControl.__mouseOutHdlr}
)
};
DwtControl.prototype.getEnabled=function(){
if(!this._checkState()){
return
}
return this._enabled
};
DwtControl.prototype.setEnabled=function(e,t){
if(!this._checkState()){
return
}
if(e!=this._enabled){
this._enabled=e;
this.setDisplayState(e?DwtControl.NORMAL:DwtControl.DISABLED);
if(t){
this.getHtmlElement().disabled=!e
}}};
DwtControl.prototype.getHTMLElId=function(){
return this._htmlElId
};
DwtControl.prototype.getHtmlElement=function(){
if(!this._checkState()){
return
}
var e=this._elRef||document.getElementById(this._htmlElId);
if(e==null){
e=DwtComposite._pendingElements[this._htmlElId]
}else{
if(!e._rendered){
delete DwtComposite._pendingElements[this._htmlElId];
e._rendered=true
}}
return this._elRef=e
};
DwtControl.fromElement=function(e){
return DwtControl.ALL_BY_ID&&DwtControl.ALL_BY_ID[e.id]
};
DwtControl.fromElementId=function(e){
return DwtControl.ALL_BY_ID&&DwtControl.ALL_BY_ID[e]
};
DwtControl.findControl=function(a){
if(AjxEnv.isFirefox3_5up&&!AjxEnv.isFirefox3_6up){
var t=HTMLElement.prototype.toString.call(a);
if(t=="[xpconnect wrapped native prototype]"||t=="[object XULElement]"){
return null
}}
try{
while(a){
if(a.id&&DwtControl.ALL_BY_ID&&DwtControl.ALL_BY_ID[a.id]){
return DwtControl.ALL_BY_ID[a.id]
}
a=a.parentNode
}}
catch(i){}
return null
};
DwtControl.getTargetControl=function(e,a){
var t=DwtUiEvent.getTarget(e,a);
return t?DwtControl.findControl(t):null
};
DwtControl.prototype.setHtmlElementId=function(t){
if(this._disposed){
return
}
if(this.__ctrlInited){
var e=this.getHtmlElement();
if(!e._rendered){
delete DwtComposite._pendingElements[this._htmlElId];
DwtComposite._pendingElements[t]=e
}else{
delete DwtControl.ALL_BY_ID[this._htmlElId];
DwtControl.ALL_BY_ID[t]=this
}
e.id=t
}
this._htmlElId=t
};
DwtControl.prototype.getX=function(){
if(!this._checkState()){
return
}
return Dwt.getLocation(this.getHtmlElement()).x
};
DwtControl.prototype.getXW=function(){
if(!this._checkState()){
return
}
var e=this.getBounds();
return e.x+e.width
};
DwtControl.prototype.getY=function(){
if(!this._checkState()){
return
}
return Dwt.getLocation(this.getHtmlElement()).y
};
DwtControl.prototype.getYH=function(){
if(!this._checkState()){
return
}
var e=this.getBounds();
return e.y+e.height
};
DwtControl.prototype.getLocation=function(){
if(!this._checkState()){
return
}
return Dwt.getLocation(this.getHtmlElement())
};
DwtControl.prototype.setLocation=function(e,i){
if(!this._checkState()){
return
}
if(this.isListenerRegistered(DwtEvent.CONTROL)){
var t=this.getHtmlElement();
this.__controlEvent.reset(DwtControlEvent.MOVE);
var a=Dwt.getLocation(t);
this.__controlEvent.oldX=a.x;
this.__controlEvent.oldY=a.y;
Dwt.setLocation(t,e,i);
a=Dwt.getLocation(t);
this.__controlEvent.newX=a.x;
this.__controlEvent.newY=a.y;
this.notifyListeners(DwtEvent.CONTROL,this.__controlEvent)
}else{
Dwt.setLocation(this.getHtmlElement(),e,i)
}
return this
};
DwtControl.prototype.getScrollStyle=function(){
if(!this._checkState()){
return
}
return Dwt.getScrollStyle(this.getHtmlElement())
};
DwtControl.prototype.setScrollStyle=function(e){
if(!this._checkState()){
return
}
Dwt.setScrollStyle(this.getHtmlElement(),e)
};
DwtControl.prototype.setPosition=function(e){
if(!this._checkState()){
return
}
if(e==DwtControl.STATIC_STYLE||e==DwtControl.ABSOLUTE_STYLE||e==DwtControl.RELATIVE_STYLE){
this.__posStyle=e;
Dwt.setPosition(this.getHtmlElement(),e)
}};
DwtControl.prototype.getW=function(){
if(!this._checkState()){
return
}
return Dwt.getSize(this.getHtmlElement()).x
};
DwtControl.prototype.getH=function(){
if(!this._checkState()){
return
}
return Dwt.getSize(this.getHtmlElement()).y
};
DwtControl.prototype.getSize=function(){
if(!this._checkState()){
return
}
return Dwt.getSize(this.getHtmlElement())
};
DwtControl.prototype.setSize=function(t,e){
if(!this._checkState()){
return
}
if(this.isListenerRegistered(DwtEvent.CONTROL)){
var i=this.getHtmlElement();
this.__controlEvent.reset(DwtControlEvent.RESIZE);
var a=Dwt.getSize(i);
this.__controlEvent.oldWidth=a.x;
this.__controlEvent.oldHeight=a.y;
Dwt.setSize(i,t,e);
a=Dwt.getSize(i);
this.__controlEvent.newWidth=a.x;
this.__controlEvent.newHeight=a.y;
this.notifyListeners(DwtEvent.CONTROL,this.__controlEvent)
}else{
Dwt.setSize(this.getHtmlElement(),t,e)
}
return this
};
DwtControl.prototype.getToolTipContent=function(e){
if(this._disposed){
return
}
return this.__toolTipContent
};
DwtControl.prototype.setToolTipContent=function(e){
if(this._disposed){
return
}
this.__toolTipContent=e
};
DwtControl.prototype.getVisible=function(){
if(!this._checkState()){
return
}
return Dwt.getVisible(this.getHtmlElement())
};
DwtControl.prototype.setVisible=function(e){
if(!this._checkState()){
return
}
Dwt.setVisible(this.getHtmlElement(),e)
};
DwtControl.prototype.setVisibility=function(e){
if(!this._checkState()){
return
}
Dwt.setVisibility(this.getHtmlElement(),e)
};
DwtControl.prototype.getVisibility=function(){
if(!this._checkState()){
return
}
return Dwt.getVisiblility(this.getHtmlElement())
};
DwtControl.prototype.getZIndex=function(){
if(!this._checkState()){
return
}
return Dwt.getZIndex(this.getHtmlElement())
};
DwtControl.prototype.setZIndex=function(e){
if(!this._checkState()){
return
}
Dwt.setZIndex(this.getHtmlElement(),e)
};
DwtControl.prototype.zShow=function(e){
this.setZIndex(e?Dwt.Z_VIEW:Dwt.Z_HIDDEN)
};
DwtControl.prototype.setDisplay=function(e){
if(!this._checkState()){
return
}
Dwt.setDisplay(this.getHtmlElement(),e)
};
DwtControl.prototype.preventSelection=function(e){
return !this.__isInputEl(e)
};
DwtControl.prototype.preventContextMenu=function(e){
return e?(!this.__isInputEl(e)):true
};
DwtControl.prototype.setContent=function(e){
if(e){
this.getHtmlElement().innerHTML=e
}};
DwtControl.prototype.clearContent=function(){
this.getHtmlElement().innerHTML=""
};
DwtControl.prototype.appendElement=function(t){
var e=AjxUtil.isString(t)?document.getElementById(t):t;
if(e){
e.appendChild(this.getHtmlElement(),e)
}};
DwtControl.prototype.replaceElement=function(i,e,o){
var t=AjxUtil.isString(i)?document.getElementById(i):i;
if(t){
var a=this.getHtmlElement();
t.parentNode.replaceChild(a,t);
this._replaceElementHook(t,a,e,o)
}};
DwtControl.prototype._replaceElementHook=function(a,o,t,r){
if((t==null||t)&&a.className){
Dwt.addClass(o,a.className)
}
if(r==null||r){
var i=a.getAttribute("style")||a.style;
if(i){
if(AjxUtil.isString(i)){
o.setAttribute("style",[o.getAttribute("style"),i].join(";"))
}else{
for(var n in i){
if(i[n]){
try{
o.style[n]=i[n]
}
catch(s){}}}}}}};
DwtControl.prototype._blur=function(){};
DwtControl.prototype._focus=function(){};
DwtControl.prototype._focusByMouseUpEvent=function(e){
if(this.getEnabled()){
this.focus()
}};
DwtControl.prototype._focusByMouseDownEvent=function(e){
this._focusByMouseUpEvent(e)
};
DwtControl.prototype._getDragOp=function(e){
return e.ctrlKey?Dwt.DND_DROP_COPY:Dwt.DND_DROP_MOVE
};
DwtControl.prototype._getDragProxy=function(e){
return null
};
DwtControl.prototype.getDragSelectionBox=function(e){
if(!this._dragSelectionBox){
var t=this._dragSelectionBox=document.createElement("div");
t.className="dndSelectionBox";
Dwt.setPosition(t,Dwt.ABSOLUTE_STYLE);
this.shell.getHtmlElement().appendChild(t);
Dwt.setZIndex(t,Dwt.Z_DND)
}
return this._dragSelectionBox
};
DwtControl.prototype._setDragProxyState=function(e){
if(this._dndProxy){
Dwt.condClass(this._dndProxy,e,DwtCssStyle.DROPPABLE,DwtCssStyle.NOT_DROPPABLE)
}};
DwtControl.__junkIconId=0;
DwtControl.prototype._destroyDragProxy=function(e){
if(e){
if(e.parentNode){
e.parentNode.removeChild(e)
}else{
e.style.zIndex=-100;
e.id="DwtJunkIcon"+DwtControl.__junkIconId++;
e=null
}}};
DwtControl.prototype.destroyDragSelectionBox=function(){
var e=this._dragSelectionBox;
if(e&&e.parentNode){
e.parentNode.removeChild(e)
}
this._dragSelectionBox=null
};
DwtControl.prototype._isValidDragObject=function(e){
return true
};
DwtControl.prototype._dragEnter=function(e){};
DwtControl.prototype._dragOver=function(e){};
DwtControl.prototype._dragHover=function(e){};
DwtControl.prototype._dragLeave=function(e){};
DwtControl.prototype._drop=function(e){};
DwtControl.prototype._setKeyPressEventHdlr=function(e){
this._setEventHdlrs([DwtEvent.ONKEYPRESS],e)
};
DwtControl.prototype._setMouseEventHdlrs=function(e){
this._setEventHdlrs(DwtEvent.MOUSE_EVENTS,e)
};
DwtControl.prototype._setEventHdlrs=function(a,e){
if(!this._checkState()){
return
}
var o=this.getHtmlElement();
for(var t=0;
t<a.length;
t++){
if(e!==true){
Dwt.setHandler(o,a[t],DwtControl.__HANDLER[a[t]])
}else{
Dwt.clearHandler(o,a[t])
}}};
DwtControl.prototype._setMouseEvents=function(){
var e=[DwtEvent.ONCONTEXTMENU,DwtEvent.ONCLICK,DwtEvent.ONDBLCLICK,DwtEvent.ONMOUSEDOWN,DwtEvent.ONMOUSEMOVE,DwtEvent.ONMOUSEUP,DwtEvent.ONSELECTSTART];
if(AjxEnv.isIE){
e.push(DwtEvent.ONMOUSEENTER,DwtEvent.ONMOUSELEAVE)
}else{
e.push(DwtEvent.ONMOUSEOVER,DwtEvent.ONMOUSEOUT)
}
this._setEventHdlrs(e)
};
DwtControl.prototype._setMouseEvent=function(t,e){
t.reset();
e.ersatz=true;
DwtUiEvent.copy(t,e);
t.button=e.button
};
DwtControl.prototype._getStopPropagationValForMouseEv=function(e){
return true
};
DwtControl.prototype._getEventReturnValForMouseEv=function(e){
return false
};
DwtControl.prototype._checkState=function(){
if(this._disposed){
return false
}
if(!this.__ctrlInited){
this.__initCtrl()
}
return true
};
DwtControl.prototype._position=function(i){
this._checkState();
var a=this.shell.getSize();
var t=this.getSize();
var e,o;
if(!i){
e=Math.round((a.x-t.x)/2);
o=Math.round((a.y-t.y)/2)
}else{
e=i.x;
o=i.y
}
if((e+t.x)>a.x){
e=a.x-t.x
}
if((o+t.y)>a.y){
o=a.y-t.y
}
this.setLocation(e,o)
};
DwtControl._scrollIntoView=function(a,t){
if(!a||!t){
return
}
var e=Dwt.toWindow(a,0,0,null,null,DwtPoint.tmp).y;
var s=Dwt.toWindow(t,0,0,null,null,DwtPoint.tmp).y+t.scrollTop;
var n=e-s;
if(n<0){
t.scrollTop+=n
}else{
var o=Dwt.getSize(t,DwtPoint.tmp).y;
var i=Dwt.getSize(a,DwtPoint.tmp).y;
n=(e+i)-(s+o);
if(n>0){
t.scrollTop+=n
}}};
DwtControl._dndScrollCallback=function(a,s){
var t=a.container;
if(!t){
return
}
var c=s.dwtObj&&s.dwtObj._dndScrollId;
if(s.type=="mouseup"||!c||(a.id&&c!=a.id)){
if(t._dndScrollActionId!=-1){
AjxTimedAction.cancelAction(t._dndScrollActionId);
t._dndScrollActionId=-1
}
return
}
t._scrollAmt=0;
if(t.clientHeight<t.scrollHeight){
var i=Dwt.toWindow(t,0,0,null,null,DwtPoint.tmp).y;
var d=i+t.scrollTop;
var r=t.scrollTop;
var h=s.docY-d;
var o=(t.clientWidth<t.scrollWidth)?a.threshold+Dwt.SCROLLBAR_WIDTH:a.threshold;
var n=(h<=o)?-1*a.amount:0;
if(n==0){
var e=Dwt.getSize(t,DwtPoint.tmp).y;
var l=d+e;
h=l-s.docY;
n=(h<=o)?a.amount:0
}
t._scrollAmt=n;
if(n){
if(!t._dndScrollAction){
t._dndScrollAction=new AjxTimedAction(null,DwtControl._dndScroll,[a]);
t._dndScrollActionId=-1
}
if(t._dndScrollActionId==-1){
t._dndScrollActionId=AjxTimedAction.scheduleAction(t._dndScrollAction,0)
}}else{
if(t._dndScrollActionId!=-1){
AjxTimedAction.cancelAction(t._dndScrollActionId);
t._dndScrollActionId=-1
}}}};
DwtControl._dndScroll=function(o){
var t=o.container;
var i=Dwt.toWindow(t,0,0,null,null,DwtPoint.tmp).y;
var a=Dwt.getSize(t,DwtPoint.tmp).y;
var e=t.scrollTop;
if((t._scrollAmt<0&&e>0)||(t._scrollAmt>0&&(e+a<t.scrollHeight))){
t.scrollTop+=t._scrollAmt;
t._dndScrollActionId=AjxTimedAction.scheduleAction(t._dndScrollAction,o.interval)
}};
DwtControl.__keyPressHdlr=function(a){
var i=i?i:DwtControl.getTargetControl(a);
if(!i){
return false
}
if(i.__hasToolTipContent()){
var t=DwtShell.getShell(window);
var e=t.getHoverMgr();
e.setHoverOutListener(i._hoverOutListener);
e.hoverOut();
i.__tooltipClosed=false
}};
DwtControl.prototype.__hasToolTipContent=function(){
if(this._disposed){
return false
}
return Boolean(this.__toolTipContent||(this.getToolTipContent!=DwtControl.prototype.getToolTipContent))
};
DwtControl.prototype.__doBlur=function(){
this._hasFocus=false;
if(this.isListenerRegistered(DwtEvent.ONBLUR)){
var e=DwtShell.focusEvent;
e.dwtObj=this;
e.state=DwtFocusEvent.BLUR;
obj.notifyListeners(DwtEvent.ONBLUR,mouseEv)
}
this._blur()
};
DwtControl.prototype.__doFocus=function(){
this._hasFocus=true;
if(this.isListenerRegistered(DwtEvent.ONFOCUS)){
var e=DwtShell.focusEvent;
e.dwtObj=this;
e.state=DwtFocusEvent.FOCUS;
obj.notifyListeners(DwtEvent.ONFOCUS,mouseEv)
}
this._focus()
};
DwtControl.__clickHdlr=function(t){
try{
return DwtControl.__mouseEvent(t,DwtEvent.ONCLICK)
}
catch(e){
AjxException.reportScriptError(e)
}};
DwtControl.__dblClickHdlr=function(t){
try{
var a=DwtControl.getTargetControl(t);
if(a&&a._dblClickIsolation){
a._clickPending=false;
AjxTimedAction.cancelAction(a._dblClickActionId)
}
return DwtControl.__mouseEvent(t,DwtEvent.ONDBLCLICK)
}
catch(e){
AjxException.reportScriptError(e)
}};
DwtControl.__mouseOverHdlr=function(n,s){
try{
var a=(DwtMouseEventCapture.getId()=="DwtControl")?DwtMouseEventCapture.getCaptureObj():null;
if(a!=null){
n=DwtUiEvent.getEvent(n);
n._stopPropagation=true;
return false
}
var t=DwtControl.getTargetControl(n);
if(!t){
return false
}
s=s||DwtEvent.ONMOUSEOVER;
if((s==DwtEvent.ONMOUSEOVER)&&t._ignoreInternalOverOut){
var h=DwtControl.getTargetControl(n,true);
if(t==h){
return false
}}
var r=DwtShell.mouseEvent;
if(t._dragging==DwtControl._NO_DRAG){
r.setFromDhtmlEvent(n,t);
r.hoverStarted=false;
if(t.isListenerRegistered(s)){
t.notifyListeners(s,r)
}
if(t.__hasToolTipContent(r)&&!r.hoverStarted){
var i=DwtShell.getShell(window);
var e=i.getHoverMgr();
if((!e.isHovering()||e.getHoverObject()!=t)&&!DwtMenu.menuShowing()){
e.reset();
e.setHoverObject(t);
e.setHoverOverData(r);
e.setHoverOverDelay(DwtToolTip.TOOLTIP_DELAY);
e.setHoverOverListener(t._hoverOverListener);
e.hoverOver(r.docX,r.docY)
}}}
r._stopPropagation=true;
r._returnValue=false;
r.setToDhtmlEvent(n);
return false
}
catch(o){
AjxException.reportScriptError(o)
}};
DwtControl.__mouseEnterHdlr=function(e){
return DwtControl.__mouseOverHdlr(e,DwtEvent.ONMOUSEENTER)
};
DwtControl.__mouseDownHdlr=function(o){
try{
var n=DwtControl.getTargetControl(o);
if(!n){
return false
}
o=DwtUiEvent.getEvent(o);
var i=DwtShell.mouseEvent;
i.setFromDhtmlEvent(o,n);
if(i.button==DwtMouseEvent.LEFT){
n._focusByMouseDownEvent(o);
i.setFromDhtmlEvent(o,n)
}
if(n.__hasToolTipContent()){
var a=DwtShell.getShell(window);
var t=a.getHoverMgr();
t.setHoverOutListener(n._hoverOutListener);
t.hoverOut()
}
if(n._dragSource&&(i.button==DwtMouseEvent.LEFT)&&n._isValidDragObject(i)){
try{
n._ctrlCaptureObj.capture()
}
catch(e){}
n._dragOp=n._getDragOp(i);
n.__dragStartX=i.docX;
n.__dragStartY=i.docY
}else{
if(n._dragBox){
if(n._dragBox._setStart(i,n)){
try{
n._ctrlCaptureObj.capture()
}
catch(e){}}}}
return DwtControl.__mouseEvent(o,DwtEvent.ONMOUSEDOWN,n,i)
}
catch(e){
AjxException.reportScriptError(e)
}};
DwtControl.__mouseMoveHdlr=function(u){
try{
var s=(DwtMouseEventCapture.getId()=="DwtControl")?DwtMouseEventCapture.getCaptureObj():null;
var n=s?s.targetObj:DwtControl.getTargetControl(u);
if(!n){
return false
}
if(n.__dndHoverActionId!=-1){
AjxTimedAction.cancelAction(n.__dndHoverActionId);
n.__dndHoverActionId=-1
}
var m=DwtShell.mouseEvent;
m.setFromDhtmlEvent(u,s?true:n);
if(m.docX<0||m.docY<0){
m._stopPropagation=true;
m._returnValue=false;
m.setToDhtmlEvent(u);
return false
}
var c=(n._dragSource&&s&&(Math.abs(n.__dragStartX-m.docX)>=DwtControl.__DRAG_THRESHOLD||Math.abs(n.__dragStartY-m.docY)>=DwtControl.__DRAG_THRESHOLD));
var f=(s&&n._dragBox&&n._dragBox._dragObj==n);
if(!c&&!f){
if(n.__hasToolTipContent()){
var h=DwtShell.getShell(window);
var a=h.getHoverMgr();
if(!a.isHovering()&&!n.__tooltipClosed&&!DwtMenu.menuShowing()){
a.hoverOver(m.docX,m.docY)
}else{
var i=n.__lastTooltipX?Math.abs(m.docX-n.__lastTooltipX):null;
var t=n.__lastTooltipY?Math.abs(m.docY-n.__lastTooltipY):null;
if((i!=null&&i>DwtControl.__TOOLTIP_THRESHOLD)||(t!=null&&t>DwtControl.__TOOLTIP_THRESHOLD)){
a.setHoverOutListener(n._hoverOutListener);
a.hoverOut();
n.__tooltipClosed=true
}}}
return DwtControl.__mouseEvent(u,DwtEvent.ONMOUSEMOVE,n,m)
}else{
if(n._dragging==DwtControl._NO_DRAG){
if(n._dragSource){
n._dragOp=n._dragSource._beginDrag(n._dragOp,n);
if(n._dragOp!=Dwt.DND_DROP_NONE){
n._dragging=DwtControl._DRAGGING;
n._dndProxy=n._getDragProxy(n._dragOp);
Dwt.addClass(n._dndProxy,"DwtDragProxy");
if(!n._dndProxy){
n._dragging=DwtControl._DRAG_REJECTED
}}else{
n._dragging=DwtControl._DRAG_REJECTED
}}else{
if(n._dragBox){
n._dragging=DwtControl._DRAGGING;
n._dragBox._beginDrag(n)
}}}
if(n._dragging!=DwtControl._DRAG_REJECTED){
var l=m.dwtObj;
if(n._dragSource){
var e=l&&l._dropTarget;
var p=n.__lastTargetObj;
if(l){
n._dndHoverAction.args=[l];
n.__dndHoverActionId=AjxTimedAction.scheduleAction(n._dndHoverAction,DwtControl.__DND_HOVER_DELAY)
}
if(l&&e&&((l!=n)||e.hasMultipleTargets())){
if(l!=p||e.hasMultipleTargets()){
var o=n._dragSource._getData();
if(e._dragEnter(n._dragOp,l,o,m,n._dndProxy)){
n._setDragProxyState(true);
n.__dropAllowed=true;
l._dragEnter(m)
}else{
n._setDragProxyState(false);
n.__dropAllowed=false
}}else{
if(n.__dropAllowed){
l._dragOver(m)
}}}else{
n._setDragProxyState(false)
}
if(p&&p!=l&&p._dropTarget&&p!=n){
if(l&&!l._dndScrollCallback&&p._dndScrollCallback){
p._dndScrollCallback.run(m)
}
p._dragLeave(m);
p._dropTarget._dragLeave()
}
n.__lastTargetObj=l;
if((l!=n)&&l&&l._dndScrollCallback){
l._dndScrollCallback.run(m)
}
Dwt.setLocation(n._dndProxy,m.docX+2,m.docY+2)
}else{
if(n._dragBox){
var r=DwtUiEvent.getTarget(u);
if(l&&(Dwt.isAncestor(n.getHtmlElement(),r)||r==n._dragSelectionBox)){
n._dragBox._dragMove(m,n)
}}}}else{
DwtControl.__mouseEvent(u,DwtEvent.ONMOUSEMOVE,n,m)
}
m._stopPropagation=true;
m._returnValue=false;
m.setToDhtmlEvent(u);
return false
}}
catch(d){
AjxException.reportScriptError(d)
}};
DwtControl.__mouseUpHdlr=function(i){
try{
var n=(DwtMouseEventCapture.getId()=="DwtControl")?DwtMouseEventCapture.getCaptureObj():null;
var o=n?n.targetObj:DwtControl.getTargetControl(i);
if(!o){
return false
}
if(o.__dndHoverActionId!=-1){
AjxTimedAction.cancelAction(o.__dndHoverActionId);
o.__dndHoverActionId=-1
}
var a=DwtShell.mouseEvent;
a.setFromDhtmlEvent(i,n?true:o);
if(!(n&&(o._dragSource||o._dragBox))){
return DwtControl.__processMouseUpEvent(i,o,a)
}else{
n.release();
if(o._dragging!=DwtControl._DRAGGING){
o._dragging=DwtControl._NO_DRAG;
return DwtControl.__processMouseUpEvent(i,o,a)
}
if(o._dragSource){
o.__lastTargetObj=null;
var t=a.dwtObj;
var s=t&&t._dropTarget;
if(t&&s&&o.__dropAllowed&&((t!=o)||s.hasMultipleTargets())){
t._drop(a);
s._drop(o._dragSource._getData(),a);
o._dragSource._endDrag();
o._destroyDragProxy(o._dndProxy);
o._dragging=DwtControl._NO_DRAG
}else{
DwtControl.__badDrop(o,a)
}
if(t&&t._dndScrollCallback){
t._dndScrollCallback.run(a)
}}else{
if(o._dragBox){
o._dragBox._endDrag(o)
}}
a._stopPropagation=true;
a._returnValue=false;
a.setToDhtmlEvent(i);
return false
}}
catch(e){
AjxException.reportScriptError(e)
}};
DwtControl.__badDrop=function(a,t){
a._dragSource._cancelDrag();
a.__dragEndX=t.docX;
a.__dragEndY=t.docY;
if(a.__badDropAction==null){
a.__badDropAction=new AjxTimedAction(a,a.__badDropEffect)
}
var e=(a.__dragEndY-a.__dragStartY)/(a.__dragEndX-a.__dragStartX);
a.__badDropAction.args=[e,a.__dragStartY-(e*a.__dragStartX),(a.__dragStartX-a.__dragEndX<0)?-1:1];
AjxTimedAction.scheduleAction(a.__badDropAction,0)
};
DwtControl.__processMouseUpEvent=function(i,n,a){
var t=DwtShell.getShell(window);
var o=t.getHoverMgr();
o.ignoreHoverOverOnClick();
if(n._dblClickIsolation&&a&&(a.button==DwtMouseEvent.LEFT)){
if(n._clickPending){
return false
}else{
n._clickPending=true;
var e=new AjxTimedAction(null,DwtControl.__timedClick,[i,n,a]);
n._dblClickActionId=AjxTimedAction.scheduleAction(e,DwtControl.__DBL_CLICK_TIMEOUT);
DwtUiEvent.setBehaviour(i,true,false);
n._st=new Date();
return false
}}else{
n._clickPending=false;
return DwtControl.__mouseEvent(i,DwtEvent.ONMOUSEUP,n,a)
}};
DwtControl.__timedClick=function(t,a,e){
a._clickPending=false;
DwtControl.__mouseEvent(t,DwtEvent.ONMOUSEUP,a,e)
};
DwtControl.__mouseOutHdlr=function(n,o){
try{
var s=DwtControl.getTargetControl(n);
if(!s){
return false
}
o=o||DwtEvent.ONMOUSEOUT;
if((o==DwtEvent.ONMOUSEOUT)&&s._ignoreInternalOverOut){
var e=DwtControl.getTargetControl(n,true);
if(s==e){
return false
}}
if(s.__hasToolTipContent()){
var i=DwtShell.getShell(window);
var a=i.getHoverMgr();
a.setHoverOutListener(s._hoverOutListener);
a.hoverOut();
s.__tooltipClosed=false
}
return DwtControl.__mouseEvent(n,o||DwtEvent.ONMOUSEOUT,s)
}
catch(t){
AjxException.reportScriptError(t)
}};
DwtControl.__mouseLeaveHdlr=function(e){
return DwtControl.__mouseOutHdlr(e,DwtEvent.ONMOUSELEAVE)
};
DwtControl.__mouseWheelHdlr=function(t){
try{
var a=DwtControl.getTargetControl(t);
if(!a){
return false
}
return DwtControl.__mouseEvent(t,DwtEvent.ONMOUSEWHEEL,a)
}
catch(e){
AjxException.reportScriptError(e)
}};
DwtControl.__selectStartHdlr=function(t){
try{
return DwtControl.__mouseEvent(t,DwtEvent.ONSELECTSTART)
}
catch(e){
AjxException.reportScriptError(e)
}};
DwtControl.__contextMenuHdlr=function(a){
try{
if(AjxEnv.isSafari){
var i=DwtControl.getTargetControl(a);
var e=i?i.preventContextMenu():true;
if(e){
DwtControl.__mouseEvent(a,DwtEvent.ONMOUSEDOWN);
return DwtControl.__mouseEvent(a,DwtEvent.ONMOUSEUP)
}}
return DwtControl.__mouseEvent(a,DwtEvent.ONCONTEXTMENU)
}
catch(t){
AjxException.reportScriptError(t)
}};
DwtControl.__mouseEvent=function(i,t,o,a){
var o=o?o:DwtControl.getTargetControl(i);
if(!o){
return false
}
if(!a){
a=DwtShell.mouseEvent;
a.setFromDhtmlEvent(i,o)
}
var e=a.target.tagName&&a.target.tagName.toLowerCase();
if(!e||(e!="input"&&e!="textarea"&&e!="a")){
a._stopPropagation=true;
a._returnValue=false
}else{
a._stopPropagation=false;
a._returnValue=true
}
DwtEventManager.notifyListeners(t,a);
if(o.isListenerRegistered&&o.isListenerRegistered(t)){
o.notifyListeners(t,a)
}
a.setToDhtmlEvent(i);
return a._returnValue
};
DwtControl.__HANDLER={};
DwtControl.__HANDLER[DwtEvent.ONCONTEXTMENU]=DwtControl.__contextMenuHdlr;
DwtControl.__HANDLER[DwtEvent.ONCLICK]=DwtControl.__clickHdlr;
DwtControl.__HANDLER[DwtEvent.ONDBLCLICK]=DwtControl.__dblClickHdlr;
DwtControl.__HANDLER[DwtEvent.ONMOUSEDOWN]=DwtControl.__mouseDownHdlr;
DwtControl.__HANDLER[DwtEvent.ONMOUSEENTER]=DwtControl.__mouseEnterHdlr;
DwtControl.__HANDLER[DwtEvent.ONMOUSELEAVE]=DwtControl.__mouseLeaveHdlr;
DwtControl.__HANDLER[DwtEvent.ONMOUSEMOVE]=DwtControl.__mouseMoveHdlr;
DwtControl.__HANDLER[DwtEvent.ONMOUSEOUT]=DwtControl.__mouseOutHdlr;
DwtControl.__HANDLER[DwtEvent.ONMOUSEOVER]=DwtControl.__mouseOverHdlr;
DwtControl.__HANDLER[DwtEvent.ONMOUSEUP]=DwtControl.__mouseUpHdlr;
DwtControl.__HANDLER[DwtEvent.ONMOUSEWHEEL]=DwtControl.__mouseWheelHdlr;
DwtControl.__HANDLER[DwtEvent.ONSELECTSTART]=DwtControl.__selectStartHdlr;
DwtControl.__HANDLER[DwtEvent.ONKEYPRESS]=DwtControl.__keyPressHdlr;
DwtControl.prototype.__initCtrl=function(){
this.shell=this.parent.shell||this.parent;
this._htmlElId=this.__internalId=this._htmlElId||Dwt.getNextId();
var e=this._elRef=this._createElement(this._htmlElId);
e.id=this._htmlElId;
if(DwtControl.ALL_BY_ID){
if(DwtControl.ALL_BY_ID[this._htmlElId]){
this._htmlElId=e.id=this.__internalId=DwtId._makeId(this._htmlElId,Dwt.getNextId())
}
DwtControl.ALL_BY_ID[this._htmlElId]=this
}
DwtComposite._pendingElements[this._htmlElId]=e;
e.style.position=this.__posStyle||DwtControl.STATIC_STYLE;
e.className=this._className;
e.style.overflow="visible";
this._enabled=true;
this.__controlEvent=DwtControl.__controlEvent;
this._dragging=DwtControl._NO_DRAG;
this.__ctrlInited=true;
this.parent.addChild(this,this.__index)
};
DwtControl.prototype._createElement=function(e){
return document.createElement("DIV")
};
DwtControl.prototype.__dndDoHover=function(e){
e._dragHover()
};
DwtControl.prototype.__badDropEffect=function(e,o,a){
var t=(Math.abs(e)<=1);
var i=t?this.__dragStartX-this.__dragEndX:this.__dragStartY-this.__dragEndY;
if(i*a>0&&!(this.__dragEndY==this.__dragStartY||this.__dragEndX==this.__dragStartX)){
if(t){
this.__dragEndX+=(30*a);
this._dndProxy.style.top=e*this.__dragEndX+o;
this._dndProxy.style.left=this.__dragEndX
}else{
this.__dragEndY+=(30*a);
this._dndProxy.style.top=this.__dragEndY;
this._dndProxy.style.left=(this.__dragEndY-o)/e
}
AjxTimedAction.scheduleAction(this.__badDropAction,0)
}else{
this._destroyDragProxy(this._dndProxy);
this._dragging=DwtControl._NO_DRAG
}};
DwtControl.prototype.__handleHoverOver=function(i){
if(this._eventMgr.isListenerRegistered(DwtEvent.HOVEROVER)){
this._eventMgr.notifyListeners(DwtEvent.HOVEROVER,i)
}
var a=i&&i.object;
var o=this.getToolTipContent(a);
var t,n;
if(!o){
t=""
}else{
if(typeof(o)=="string"){
t=o
}else{
if(o instanceof AjxCallback){
n=o
}else{
if(typeof(o)=="object"){
t=o.content;
n=o.callback
}}}}
if(!t&&n&&o.loading){
t=AjxMsg.loading
}
if(t){
this.__showToolTip(i,t)
}
if(n){
var e=new AjxCallback(this,this.__showToolTip,[i]);
AjxTimedAction.scheduleAction(new AjxTimedAction(null,function(){
n.run(e)
}
),0)
}};
DwtControl.prototype.__showToolTip=function(t,e){
if(!e){
return
}
DwtControl.showToolTip(e,t.x,t.y);
this.__lastTooltipX=t.x;
this.__lastTooltipY=t.y;
this.__tooltipClosed=false
};
DwtControl.prototype.__handleHoverOut=function(e){
if(this._eventMgr.isListenerRegistered(DwtEvent.HOVEROUT)){
this._eventMgr.notifyListeners(DwtEvent.HOVEROUT,e)
}
DwtControl.hideToolTip();
this.__lastTooltipX=null;
this.__lastTooltipY=null
};
DwtControl.prototype.__isInputEl=function(a){
var i=false;
if(!a||!a.tagName){
return i
}
var e=a.tagName.toLowerCase();
var t=e=="input"?a.type.toLowerCase():null;
if(e=="textarea"||(t&&(t=="text"||t=="password"))){
i=true
}
return i
};
DwtControl.ON_UNLOAD=function(){
var t=DwtControl.ALL_BY_ID,e;
for(e in t){
t[e]._elRef=null
}
DwtControl.ALL_BY_ID=null
};
if(AjxEnv.isIE){
window.attachEvent("onunload",DwtControl.ON_UNLOAD)
}else{
window.addEventListener("unload",DwtControl.ON_UNLOAD,false)
}
DwtControl.showToolTip=function(a,e,o){
if(!a){
return
}
var t=DwtShell.getShell(window);
var i=t.getToolTip();
i.setContent(a);
i.popup(e,o)
};
DwtControl.hideToolTip=function(){
var e=DwtShell.getShell(window);
var t=e.getToolTip();
t.popdown()
};
