
/* Copyright (C) 2005-2009 Zimbra Inc. http://www.zimbra.com/ */
DwtHtmlEditor=function(e){
if(arguments.length==0){
return
}
e=Dwt.getParams(arguments,DwtHtmlEditor.PARAMS);
e.className=e.className||"DwtHtmlEditor";
DwtComposite.call(this,e);
this._mode=(e.mode==DwtHtmlEditor.HTML&&this.isHtmlEditingSupported())?e.mode:DwtHtmlEditor.TEXT;
this.__eventClosure=AjxCallback.simpleClosure(this.__eventClosure,this);
this._pendingContent=e.content||"";
this._htmlModeInited=false;
this._initialize()
};
DwtHtmlEditor.PARAMS=["parent","className","posStyle","content","mode","blankIframeSrc"];
DwtHtmlEditor.prototype=new DwtComposite();
DwtHtmlEditor.prototype.constructor=DwtHtmlEditor;
DwtHtmlEditor.HTML="text/html";
DwtHtmlEditor.TEXT="text/plain";
DwtHtmlEditor.H1=1;
DwtHtmlEditor.H2=2;
DwtHtmlEditor.H3=3;
DwtHtmlEditor.H4=4;
DwtHtmlEditor.H5=5;
DwtHtmlEditor.H6=6;
DwtHtmlEditor.PARAGRAPH=7;
DwtHtmlEditor.ADDRESS=8;
DwtHtmlEditor.PREFORMATTED=9;
DwtHtmlEditor._STYLES=["","<h1>","<h2>","<h3>","<h4>","<h5>","<h6>","<p>","<address>","<pre>"];
DwtHtmlEditor.BOLD_STYLE="bold";
DwtHtmlEditor.ITALIC_STYLE="italic";
DwtHtmlEditor.UNDERLINE_STYLE="underline";
DwtHtmlEditor.STRIKETHRU_STYLE="strikethrough";
DwtHtmlEditor.SUBSCRIPT_STYLE="subscript";
DwtHtmlEditor.SUPERSCRIPT_STYLE="superscript";
DwtHtmlEditor.JUSTIFY_LEFT="justifyleft";
DwtHtmlEditor.JUSTIFY_CENTER="justifycenter";
DwtHtmlEditor.JUSTIFY_RIGHT="justifyright";
DwtHtmlEditor.JUSTIFY_FULL="justifyfull";
DwtHtmlEditor.OUTDENT="outdent";
DwtHtmlEditor.INDENT="indent";
DwtHtmlEditor.HORIZ_RULE="inserthorizontalrule";
DwtHtmlEditor.ORDERED_LIST="insertorderedlist";
DwtHtmlEditor.UNORDERED_LIST="insertunorderedlist";
DwtHtmlEditor.IMAGE="insertimage";
DwtHtmlEditor.BORDER_TOP=0;
DwtHtmlEditor.BORDER_MIDDLE=1;
DwtHtmlEditor.BORDER_BOTTOM=2;
DwtHtmlEditor.BORDER_LEFT=3;
DwtHtmlEditor.BORDER_CENTER=4;
DwtHtmlEditor.BORDER_RIGHT=5;
DwtHtmlEditor._H1_RE=/Heading 1|h1/;
DwtHtmlEditor._H2_RE=/Heading 2|h2/;
DwtHtmlEditor._H3_RE=/Heading 2|h3/;
DwtHtmlEditor._H4_RE=/Heading 2|h4/;
DwtHtmlEditor._H5_RE=/Heading 2|h5/;
DwtHtmlEditor._H6_RE=/Heading 2|h6/;
DwtHtmlEditor._PARAGRAPH_RE=/Normal|p/;
DwtHtmlEditor._ADDRESS_RE=/Address|address/;
DwtHtmlEditor._PREFORMATTED_RE=/Formatted|pre/;
DwtHtmlEditor._FONT_NAME="fontname";
DwtHtmlEditor._FONT_SIZE="fontsize";
DwtHtmlEditor._FONT_COLOR="forecolor";
DwtHtmlEditor._FONT_HILITE="hilitecolor";
DwtHtmlEditor._FONT_HILITE_IE="backcolor";
DwtHtmlEditor._FORMAT_BLOCK="formatblock";
DwtHtmlEditor._INITDELAY=50;
DwtHtmlEditor.FONT_SIZE_VALUES=["8pt","10pt","12pt","14pt","18pt","24pt","36pt"];
DwtHtmlEditor._BLOCK_ELEMENTS={
address:1,body:1,div:1,dl:1,fieldset:1,form:1,h1:1,h2:1,h3:1,h4:1,h5:1,h6:1,iframe:1,li:1,ol:1,p:1,pre:1,quote:1,table:1,tbody:1,td:1,textarea:1,tfoot:1,thead:1,tr:1,ul:1};
DwtHtmlEditor._ACTION_CODE_TO_CMD={};
DwtHtmlEditor._ACTION_CODE_TO_CMD[DwtKeyMap.TEXT_BOLD]=DwtHtmlEditor.BOLD_STYLE;
DwtHtmlEditor._ACTION_CODE_TO_CMD[DwtKeyMap.TEXT_ITALIC]=DwtHtmlEditor.ITALIC_STYLE;
DwtHtmlEditor._ACTION_CODE_TO_CMD[DwtKeyMap.TEXT_UNDERLINE]=DwtHtmlEditor.UNDERLINE_STYLE;
DwtHtmlEditor._ACTION_CODE_TO_CMD[DwtKeyMap.TEXT_STRIKETHRU]=DwtHtmlEditor.STRIKETHRU_STYLE;
DwtHtmlEditor._ACTION_CODE_TO_CMD[DwtKeyMap.JUSTIFY_LEFT]=DwtHtmlEditor.JUSTIFY_LEFT;
DwtHtmlEditor._ACTION_CODE_TO_CMD[DwtKeyMap.JUSTIFY_CENTER]=DwtHtmlEditor.JUSTIFY_CENTER;
DwtHtmlEditor._ACTION_CODE_TO_CMD[DwtKeyMap.JUSTIFY_RIGHT]=DwtHtmlEditor.JUSTIFY_RIGHT;
DwtHtmlEditor._ACTION_CODE_TO_CMD[DwtKeyMap.HEADER1]=DwtHtmlEditor._STYLES[1];
DwtHtmlEditor._ACTION_CODE_TO_CMD[DwtKeyMap.HEADER2]=DwtHtmlEditor._STYLES[2];
DwtHtmlEditor._ACTION_CODE_TO_CMD[DwtKeyMap.HEADER3]=DwtHtmlEditor._STYLES[3];
DwtHtmlEditor._ACTION_CODE_TO_CMD[DwtKeyMap.HEADER4]=DwtHtmlEditor._STYLES[4];
DwtHtmlEditor._ACTION_CODE_TO_CMD[DwtKeyMap.HEADER5]=DwtHtmlEditor._STYLES[5];
DwtHtmlEditor._ACTION_CODE_TO_CMD[DwtKeyMap.HEADER6]=DwtHtmlEditor._STYLES[6];
DwtHtmlEditor.INIT_HTML=["<html><head><title>ZWC</title></head><body><p>",AjxEnv.isGeckoBased?"<br type='_moz' />":"","</p></body></html>"].join("");
DwtHtmlEditor.TAB="<span style='white-space:pre'>\t</span>";
DwtHtmlEditor.prototype.focus=function(t){
if(!AjxEnv.isIE&&this._mode==DwtHtmlEditor.TEXT){
document.getElementById(this._textAreaId).focus()
}else{
try{
if(!this._htmlModeInited){
t=t||0;
if(t<10){
setTimeout(AjxCallback.simpleClosure(this.focus,this,t+1),DwtHtmlEditor._INITDELAY)
}
return
}
if(AjxEnv.isSafari){
document.getElementById(this._iFrameId).focus()
}else{
this._getIframeWin().focus()
}
if(AjxEnv.isIE){
if(this._currInsPt){
if(this._currInsPt.text.length<=1){
this._currInsPt.collapse(false)
}
this._currInsPt.select()
}}}
catch(e){}}};
DwtHtmlEditor.prototype.moveCaretToTop=function(){
var n=document.activeElement;
if(this._mode==DwtHtmlEditor.TEXT){
var o=document.getElementById(this._textAreaId);
if(o.createTextRange){
var t=o.createTextRange();
t.collapse(true);
t.select()
}else{
if(o.setSelectionRange){
o.setSelectionRange(0,0)
}}}else{
this._moveCaretToTopHtml(true)
}
if(n){
try{
n.focus()
}
catch(a){}}};
DwtHtmlEditor.prototype._moveCaretToTopHtml=function(t){
var e=this._getIframeDoc().body;
var n=false;
if(AjxEnv.isIE){
if(e){
e.createTextRange().collapse(true);
n=true
}}else{
var a=this._getSelection();
if(a){
a.collapse(e,0);
n=true
}}
if(!n&&t){
var o=new AjxTimedAction(this,this._moveCaretToTopHtml);
AjxTimedAction.scheduleAction(o,DwtHtmlEditor._INITDELAY+1)
}};
DwtHtmlEditor.prototype.addStateChangeListener=function(e){
this.addListener(DwtEvent.STATE_CHANGE,e)
};
DwtHtmlEditor.prototype.removeStateChangeListener=function(e){
this.removeListener(DwtEvent.STATE_CHANGE,e)
};
DwtHtmlEditor.prototype.clear=function(){
AjxDebug.println(AjxDebug.REPLY,"DwtHtmlEditor::clear");
this.setContent("")
};
DwtHtmlEditor.prototype.enable=function(e){
if(this._textAreaId!=null){
document.getElementById(this._textAreaId).disabled=!e
}
if(this._iFrameId!=null){
document.getElementById(this._iFrameId).disabled=!e
}};
DwtHtmlEditor.prototype.isHtmlEditingSupported=function(){
return(!!(AjxEnv.isGeckoBased||AjxEnv.isIE||AjxEnv.isSafari3up))
};
DwtHtmlEditor.prototype.getContent=function(){
if(this._mode==DwtHtmlEditor.HTML){
var a=this._getIframeDoc();
var e=a&&a.body?(this._getIframeDoc().body.innerHTML):"";
return this._embedHtmlContent(e)
}else{
var t=document.getElementById(this._textAreaId);
return t&&t.value
}};
DwtHtmlEditor.prototype._embedHtmlContent=function(e){
return["<html><body>",e,"</body></html>"].join("")
};
DwtHtmlEditor.prototype.setContent=function(e){
if(AjxEnv.isIE){
this._currInsPt=null
}
e=e||"";
AjxDebug.println(AjxDebug.REPLY,"DwtHtmlEditor::setContent - Content length: "+e.length);
if(this._mode==DwtHtmlEditor.HTML){
this._pendingContent=e;
AjxDebug.println(AjxDebug.REPLY,"HTML mode, initialized: "+this._htmlModeInited);
if(this._htmlModeInited){
this._setContentOnTimer()
}}else{
AjxDebug.println(AjxDebug.REPLY,"Text mode, set textarea value");
document.getElementById(this._textAreaId).value=e
}};
DwtHtmlEditor.prototype.insertElement=function(e){
this._execCommand(e)
};
DwtHtmlEditor.prototype.insertText=function(a,e){
var t=this._getIframeDoc().createTextNode(a);
this._insertNodeAtSelection(t,e)
};
DwtHtmlEditor.prototype.insertImage=function(s,r,a,e){
if(r){
var o=this._getIframeDoc();
var t=o.createElement("img");
if(s&&s.indexOf("cid:")==0){
t.setAttribute("dfsrc",s)
}else{
t.setAttribute("src",s)
}
if(a){
t.width=a
}else{
t.removeAttribute("width")
}
if(e){
t.height=e
}else{
t.removeAttribute("height")
}
t.style.border="0";
var n=o.createDocumentFragment();
n.appendChild(t);
this._insertNodeAtSelection(n)
}else{
this._execCommand(DwtHtmlEditor.IMAGE,s)
}};
DwtHtmlEditor.prototype.replaceImage=function(o,a){
var t=this._getIframeDoc();
if(t){
var e=t.getElementById(o);
if(e&&e.getAttribute("data-zim-uri")===o){
e.src=a;
e.removeAttribute("id");
e.removeAttribute("data-zim-uri")
}}};
DwtHtmlEditor.prototype.insertTable=function(y,u,a,t,h,d){
if(this._mode!=DwtHtmlEditor.HTML){
return
}
var f=this._getIframeDoc();
var g=f.createElement("table");
g.style.borderRight="1px solid #000";
g.style.borderLeft="1px solid #000";
g.style.borderTop="1px solid #000";
g.style.borderBottom="1px solid #000";
if(a!=null){
g.style.width=a
}else{
g.style.width="100%"
}
g.style.textAlign="left";
g.style.verticalAlign="middle";
if(d!=null){
g.align=d.toLowerCase()
}
if(t!=null){
g.cellSpacing=t
}else{
g.cellSpacing=0
}
if(h!=null){
g.cellPadding=h
}else{
g.cellPadding=0
}
if(!AjxEnv.isIE){
g.style.border="1px solid #000"
}
g.style.borderCollapse="collapse";
var l;
l=Math.floor(100/u)+"%";
var r=f.createElement("tbody");
g.appendChild(r);
for(var s=0;
s<y;
s++){
var c=f.createElement("tr");
r.appendChild(c);
for(var n=0;
n<u;
n++){
var o=f.createElement("td");
if(s==0&&l){
o.style.width=l
}
if(AjxEnv.isGeckoBased){
o.appendChild(f.createElement("br"))
}else{
if(AjxEnv.isIE){
o.innerHTML="&nbsp;"
}}
if(AjxEnv.isIE){
o.style.border="1px solid #000"
}else{
o.style.borderTop=o.style.borderLeft="1px solid #000"
}
c.appendChild(o)
}}
var e=f.createElement("br");
var m=f.createDocumentFragment();
m.appendChild(e);
m.appendChild(g);
m.appendChild(e.cloneNode(true));
this._insertNodeAtSelection(m);
this.selectNodeContents(g.rows[0].cells[0],true);
return g
};
DwtHtmlEditor.prototype.applyTableProperties=function(c,h){
var l=this._getIframeDoc();
var r=[];
for(var s in h){
var e=AjxStringUtil.trim(h[s].toString());
var t=e!="";
switch(s){
case"caption":var d=c.getElementsByTagName("caption");
d=d.length>0?d[0]:null;
if(t&&!d){
d=l.createElement("caption");
c.insertBefore(d,c.firstChild)
}
if(!t&&d){
d.parentNode.removeChild(d)
}
if(d){
d.innerHTML=e
}
break;
case"summary":case"align":case"cellSpacing":case"cellPadding":if(!t){
c.removeAttribute(s,0)
}else{
c[s]=e
}
break;
case"borderWidth":case"borderStyle":case"borderColor":c.style[s]=e;
r.push([s,e]);
break;
default:c.style[s]=e;
break
}}
if(r.length>0){
var n=c.getElementsByTagName("td");
for(var s=n.length;
--s>=0;
){
var a=n[s];
for(var o=r.length;
--o>=0;
){
a.style[r[o][0]]=r[o][1]
}}}
if(AjxEnv.isGeckoBased){
this._forceRedraw()
}};
DwtHtmlEditor.prototype.applyCellProperties=function(d,u,s){
var r=true;
for(var a=u.length;
--a>=0;
){
var m=u[a];
if(!m){
continue
}
var n=(a==0);
var c=true;
for(var t=m.length;
--t>=0;
){
var l=(t==0);
var e=m[t];
if(s.backgroundColor!=null){
e.style.backgroundColor=s.backgroundColor
}
if(s.color!=null){
e.style.color=s.color
}
if(s.textAlign!=null){
e.style.textAlign=s.textAlign
}
if(s.verticalAlign!=null){
e.style.verticalAlign=s.verticalAlign
}
if(s.width!=null){
if(s.width){
e.style.width=s.width+"px"
}else{
e.style.width=""
}}
if(s.height!=null){
if(s.height){
e.style.height=s.height+"px"
}else{
e.style.height=""
}}
if(s.vertPadding!=null){
if(s.vertPadding){
e.style.paddingTop=e.style.paddingBottom=s.vertPadding+"px"
}else{
e.style.paddingTop=e.style.paddingBottom=""
}}
if(s.horizPadding!=null){
if(s.horizPadding){
e.style.paddingLeft=e.style.paddingRight=s.horizPadding+"px"
}else{
e.style.paddingLeft=e.style.paddingRight=""
}}
var o=s.borders,h;
h=o[DwtHtmlEditor.BORDER_TOP];
if(h!=null&&n){
e.style.borderTop=h.width+" "+h.style+" "+h.color
}
h=o[DwtHtmlEditor.BORDER_MIDDLE];
if(h!=null){
h=h.width+" "+h.style+" "+h.color;
if(!r){
e.style.borderBottom=h
}
if(!n){
e.style.borderTop=h
}}
h=o[DwtHtmlEditor.BORDER_BOTTOM];
if(h!=null&&r){
e.style.borderBottom=h.width+" "+h.style+" "+h.color
}
h=o[DwtHtmlEditor.BORDER_LEFT];
if(h!=null&&l){
e.style.borderLeft=h.width+" "+h.style+" "+h.color
}
h=o[DwtHtmlEditor.BORDER_CENTER];
if(h!=null){
h=h.width+" "+h.style+" "+h.color;
if(!c){
e.style.borderRight=h
}
if(!l){
e.style.borderLeft=h
}}
h=o[DwtHtmlEditor.BORDER_RIGHT];
if(h!=null&&c){
e.style.borderRight=h.width+" "+h.style+" "+h.color
}
c=false
}
r=false
}
if(AjxEnv.isGeckoBased){
this._forceRedraw()
}};
DwtHtmlEditor.prototype._insertHTML=function(o,a){
var n=this._getSelection();
var e=this._createRange(n);
if(AjxEnv.isIE){
if(this.insertRange){
this.insertRange.pasteHTML(o)
}else{
e.pasteHTML(o)
}}else{
var r=this._getIframeDoc();
var t=r.createDocumentFragment();
var s=r.createElement("div");
s.innerHTML=o;
while(s.firstChild){
t.appendChild(s.firstChild)
}
this._insertNodeAtSelection(t,null,null,a)
}};
DwtHtmlEditor.prototype._getSelectionHtml=function(o){
var e=o.createRange();
var e=o.createRange();
var a=o.type.toLowerCase();
if(a=="text"){
return e.htmlText
}else{
if(a=="control"){
var t="";
for(i=0;
i<e.length;
i++){
t+=e(i).innerHTML
}
return t
}}
return null
};
DwtHtmlEditor.prototype._insertNodeAtSelection=function(s,u,r,d){
this.focus();
if(!AjxEnv.isIE){
var h=this._getRange();
if(!d){
var n=this._getIframeWin().getSelection();
n.removeAllRanges()
}
try{
h.deleteContents();
if(d){
var t=s.firstChild
}
h.insertNode(s);
if(d&&t.nextSibling){
h.selectNode(t.nextSibling);
h.collapse(true)
}else{
h.selectNode(s)
}
if(u){
n.addRange(h)
}}
catch(l){}}else{
var n=this._getRange();
if(r){
var m=this._getSelectionHtml(n)
}
var h=n.createRange();
var a="FOO-"+Dwt.getNextId();
try{
h.pasteHTML("<span id='"+a+"'></span>")
}
catch(c){
h.collapse(false);
h.pasteHTML("<span id='"+a+"'></span>")
}
var o=this._getIframeDoc().getElementById(a);
o.parentNode.insertBefore(s,o);
o.parentNode.removeChild(o);
return m
}};
DwtHtmlEditor.prototype.isHtmlModeInited=function(){
return this._htmlModeInited
};
DwtHtmlEditor.prototype.setMode=function(r,n,a){
if(r==this._mode||(r!=DwtHtmlEditor.HTML&&r!=DwtHtmlEditor.TEXT)){
return
}
var t=this._getIframeDoc();
this._mode=r;
if(r==DwtHtmlEditor.HTML){
var s=Dwt.byId(this._textAreaId);
var e;
var o=n?AjxStringUtil.convertToHtml(s.value,true):s.value;
if(this._iFrameId){
AjxDebug.println(AjxDebug.REPLY,"DwtHtmlEditor::setMode - content length = "+o.length);
AjxDebug.println(AjxDebug.REPLY,"Set innerHTML of iframe body");
t.body.innerHTML=o;
e=document.getElementById(this._iFrameId)
}else{
e=this._initHtmlMode(o)
}
Dwt.setVisible(s,false);
Dwt.setVisible(e,true);
if(AjxEnv.isGeckoBased||AjxEnv.isSafari){
this._enableDesignMode(t)
}}else{
var s=this._textAreaId?Dwt.byId(this._textAreaId):this._initTextMode(true);
s.value=n?this._convertHtml2Text(a):t.innerHTML;
Dwt.setVisible(document.getElementById(this._iFrameId),false);
Dwt.setVisible(s,true)
}};
DwtHtmlEditor.prototype.getMode=function(){
return this._mode
};
DwtHtmlEditor.prototype.setFont=function(n,o,a,e,t){
if(n){
this._execCommand(DwtHtmlEditor._FONT_NAME,n)
}
if(o){
this._execCommand(o)
}
if(a){
this._execCommand(DwtHtmlEditor._FONT_SIZE,a)
}
if(e){
this._execCommand(DwtHtmlEditor._FONT_COLOR,e)
}
if(t){
this._execCommand((AjxEnv.isIE)?DwtHtmlEditor._FONT_HILITE_IE:DwtHtmlEditor._FONT_HILITE,t)
}};
DwtHtmlEditor.prototype.setJustification=function(e){
this._execCommand(e)
};
DwtHtmlEditor.prototype.setIndent=function(e){
this._execCommand(e)
};
DwtHtmlEditor.prototype.setStyle=function(e){
this._execCommand(DwtHtmlEditor._FORMAT_BLOCK,DwtHtmlEditor._STYLES[e])
};
DwtHtmlEditor.prototype.setSize=function(a,t){
DwtComposite.prototype.setSize.call(this,a,t);
var o=this.getHtmlElement();
if(this._iFrameId!=null){
var e=document.getElementById(this._iFrameId);
e.width=o.style.width;
e.height=o.style.height
}else{
var n=document.getElementById(this._textAreaId);
n.style.width=o.style.width;
n.style.height=o.style.height
}};
DwtHtmlEditor.prototype.getIframe=function(){
return document.getElementById(this._iFrameId)
};
DwtHtmlEditor.prototype.getInputElement=function(){
var e=(this._mode==DwtHtmlEditor.HTML)?this._iFrameId:this._textAreaId;
return document.getElementById(e)
};
DwtHtmlEditor.prototype._initialize=function(){
if(this._mode==DwtHtmlEditor.HTML){
this._initHtmlMode(this._pendingContent)
}else{
this._initTextMode()
}};
DwtHtmlEditor.prototype.TEXTAREA_CLASSNAME="DwtHtmlEditorTextArea";
DwtHtmlEditor.prototype._initTextMode=function(t){
var e=this.getHtmlElement();
if(!this._textAreaId){
this._textAreaId="textarea_"+Dwt.getNextId()
}
var a=document.createElement("textarea");
a.className=this.TEXTAREA_CLASSNAME;
a.id=this._textAreaId;
e.appendChild(a);
if(!t){
a.value=this._pendingContent;
this._pendingContent=null
}
return a
};
DwtHtmlEditor.prototype._initHtmlMode=function(o){
this._pendingContent=o||"";
this._keyEvent=new DwtKeyEvent();
this._stateEvent=new DwtHtmlEditorStateEvent();
this._stateEvent.dwtObj=this;
this._updateStateAction=new AjxTimedAction(this,this._updateState);
var n=this.getHtmlElement();
this._iFrameId="iframe_"+Dwt.getNextId();
var a=document.createElement("iframe");
a.id=this._iFrameId;
a.className="DwtHtmlEditorIFrame";
a.setAttribute("border","0",false);
a.setAttribute("frameborder","0",false);
a.setAttribute("vspace","0",false);
a.setAttribute("autocomplete","off",false);
var t=AjxCallback.simpleClosure(this._finishHtmlModeInit,this);
setTimeout(t,DwtHtmlEditor._INITDELAY);
if(this._isPasteEnabled){
var e=AjxCallback.simpleClosure(this._registerPasteEvent,this);
a.onload=e
}
a.src='javascript:(function(d){d.open();d.write("<html><body></body></html>");d.close();})(document)';
n.appendChild(a);
return a
};
DwtHtmlEditor.prototype._registerPasteEvent=function(){
var e=this,t=e._getIframeDoc();
e._unregisterEditorEventHandler(t,"paste");
e._registerEditorEventHandler(t,"paste")
};
DwtHtmlEditor.prototype._finishHtmlModeInit=function(){
var a=this._getIframeDoc();
try{
if(AjxEnv.isSafari&&a.body==null){
a.open();
a.write("<html><head></head><body></body></html>");
a.close()
}}
catch(t){
return
}
if(AjxEnv.isGeckoBased){
a.open();
a.write(DwtHtmlEditor.INIT_HTML);
a.close()
}
function e(o){
this._enableDesignMode(o);
this._setContentOnTimer();
this._updateState();
this._htmlModeInited=true;
this._registerEditorEventHandlers(document.getElementById(this._iFrameId),o)
}
setTimeout(AjxCallback.simpleClosure(e,this,a),DwtHtmlEditor._INITDELAY*4)
};
DwtHtmlEditor.prototype._focus=function(){
this.focus()
};
DwtHtmlEditor.prototype._getIframeDoc=function(){
return this._iFrameId?Dwt.getIframeDoc(document.getElementById(this._iFrameId)):null
};
DwtHtmlEditor.prototype._getIframeWin=function(){
return Dwt.getIframeWindow(document.getElementById(this._iFrameId))
};
DwtHtmlEditor.prototype._getParentElement=function(){
if(AjxEnv.isIE){
var s=this._getIframeDoc();
var a=s.selection;
var t=a.createRange();
if(a.type=="None"||a.type=="Text"){
return a.createRange().parentElement()
}
if(a.type=="Control"){
return a.createRange().item(0)
}
return s.body
}else{
try{
var t=this._getRange();
var n=t.commonAncestorContainer;
if(!t.collapsed&&t.startContainer==t.endContainer&&t.startOffset-t.endOffset<=1&&t.startContainer.hasChildNodes()){
n=t.startContainer.childNodes[t.startOffset]
}
while(n.nodeType==3){
n=n.parentNode
}
return n
}
catch(o){
return null
}}};
DwtHtmlEditor.prototype.getNearestElement=function(t){
try{
var a=this._getParentElement();
t=t.toLowerCase();
while(a&&a.nodeName.toLowerCase()!=t){
a=a.parentNode
}
return a
}
catch(e){
return null
}};
DwtHtmlEditor.prototype.selectNodeContents=function(a,s,e){
var t;
var n=(typeof s=="boolean");
if(AjxEnv.isIE){
t=this._getIframeDoc().body.createTextRange();
t.moveToElementText(a);
(n)&&t.collapse(s);
t.select()
}else{
var o=this._getSelection();
t=this._getIframeDoc().createRange();
if(e){
t.selectNode(a)
}else{
t.selectNodeContents(a)
}
(n)&&t.collapse(s);
o.removeAllRanges();
o.addRange(t)
}};
DwtHtmlEditor.prototype._forceRedraw=function(){
var e=this._getIframeDoc().body;
e.style.display="none";
var t=this;
setTimeout(function(){
e.style.display="";
t.focus();
t=null
}
,10)
};
DwtHtmlEditor.prototype.getSelectedCells=function(){
var h=null;
var e=this._getSelection();
var s,n=0;
var a=1000;
var c=[];
var l=null;
if(!AjxEnv.isIE){
try{
for(n=0;
(s=e.getRangeAt(n))&&n<a;
n++){
var t=s.startContainer.childNodes[s.startOffset];
if(t){
if(t.parentNode!=l){
l=t.parentNode;
h&&c.push(h);
h=[]
}
if(t.tagName&&/^td$/i.test(t.tagName)){
h.push(t)
}}}}
catch(r){}
c.push(h)
}else{
s=e.createRange();
var o=s.duplicate();
s.collapse(true);
for(n=0;
o.compareEndPoints("EndToStart",s)>=0&&n<a;
n++){
var t=s.parentElement();
while(t&&t.nodeName.toLowerCase()!="td"){
t=t.parentNode
}
if(t){
if(t.parentNode!=l){
l=t.parentNode;
h&&c.push(h);
h=[]
}
h.push(t);
s.moveToElementText(t);
s.collapse(false)
}
if(s.move("character",1)==0){
break
}}
o.select();
c.push(h)
}
if(c.length==0||!c[0]||c[0].length==0){
h=this.getNearestElement("td");
if(h){
c=[[h]]
}}
return c
};
DwtHtmlEditor.prototype._splitCells=function(s){
var o=s;
while(o&&o.nodeName.toLowerCase()!="table"){
o=o.parentNode
}
var e=AjxEnv.isGeckoBased?"<br />":"";
function t(m){
var u=m.rowSpan;
var d=m.colSpan;
m.rowSpan=1;
tr=m.parentNode;
var l=tr.rowIndex;
var r=tr.parentNode.rows;
var h=m.cellIndex;
while(--u>0){
tr=r[++l];
var c=m.cloneNode(false);
c.removeAttribute("rowspan");
c.colSpan=m.colSpan;
c.innerHTML=e;
tr.insertBefore(c,tr.cells[h])
}}
function n(c){
var l=c.colSpan;
c.colSpan=1;
tr=c.parentNode;
var h=c.nextSibling;
while(--l>0){
var r=c.cloneNode(false);
r.removeAttribute("colspan");
r.rowSpan=c.rowSpan;
r.innerHTML=e;
tr.insertBefore(r,h)
}}
function a(c){
var l=c.colSpan;
n(c);
var r=c.parentNode.cells;
var h=c.cellIndex;
while(l-->0){
t(r[h++])
}}
a(s)
};
DwtHtmlEditor.prototype.doTableOperation=function(e,a){
var c=a.table||this.getNearestElement("table");
var t=a.td||this.getNearestElement("td");
var h,l,r;
if(t){
h=t.cellIndex;
r=t.parentNode;
l=r.rowIndex
}else{
h=0;
r=this.getNearestElement("tr");
if(r){
l=r.rowIndex
}}
var d=a.cells;
while(true){
switch(e){
case"insertRowAbove":DwtHtmlEditor.table_fixCells(DwtHtmlEditor.table_insertRow(t));
break;
case"insertRowUnder":DwtHtmlEditor.table_fixCells(DwtHtmlEditor.table_insertRow(t,true));
break;
case"insertColumnBefore":DwtHtmlEditor.table_fixCells(DwtHtmlEditor.table_insertCol(t));
break;
case"insertColumnAfter":DwtHtmlEditor.table_fixCells(DwtHtmlEditor.table_insertCol(t,true));
break;
case"deleteRow":for(var n=0;
n<d.length;
++n){
var t=DwtHtmlEditor.table_deleteRow(d[n][0]);
if(t){
this.selectNodeContents(t,true);
this.focus()
}}
break;
case"deleteColumn":for(var n=0;
n<d[0].length;
++n){
var t=DwtHtmlEditor.table_deleteCol(d[0][n]);
if(t){
this.selectNodeContents(t,true);
this.focus()
}}
break;
case"mergeCells":t=d[0][0];
var s=[t.innerHTML.replace(/<br>$/i,"")];
for(var n=0;
n<d.length;
++n){
var u=d[n];
for(var o=0;
o<u.length;
++o){
if(n||o){
s.push(u[o].innerHTML.replace(/<br>$/i,""));
u[o].parentNode.removeChild(u[o])
}}}
t.colSpan=d[0].length;
t.rowSpan=d.length;
s=s.join(" ");
if(AjxEnv.isGeckoBased){
s+="<br/>"
}
t.innerHTML=s;
this.selectNodeContents(t,true);
break;
case"splitCells":this._splitCells(t);
break;
case"deleteTable":if(!AjxEnv.isIE){
this.selectNodeContents(c,null,true);
this.deleteSelectedNodes()
}else{
c.parentNode.removeChild(c)
}
break
}
break
}
if(AjxEnv.isGeckoBased){
this._forceRedraw()
}
this._updateState()
};
DwtHtmlEditor.prototype._getRange=function(){
var o=this._getIframeDoc();
if(AjxEnv.isIE){
return o.selection
}else{
this.focus();
var t=this._getIframeWin().getSelection();
if(t!=null){
try{
return t.getRangeAt(0)
}
catch(a){
return o.createRange()
}}else{
return o.createRange()
}}};
DwtHtmlEditor.prototype._createRange=function(t){
var o=this._getIframeDoc();
if(AjxEnv.isIE){
return t.createRange()
}else{
this.focus();
if(t!=null){
try{
return t.getRangeAt(0)
}
catch(a){
return o.createRange()
}}else{
return o.createRange()
}}};
DwtHtmlEditor.prototype.deleteSelectedNodes=function(){
var e=this._getSelection();
if(AjxEnv.isGeckoBased){
e.deleteFromDocument()
}else{
e.clear()
}};
DwtHtmlEditor.prototype._getSelection=function(){
if(AjxEnv.isIE){
return this._getIframeDoc().selection
}else{
return this._getIframeWin().getSelection()
}};
DwtHtmlEditor.prototype.__eventClosure=function(e){
return this._handleEditorEvent(AjxEnv.isIE?this._getIframeWin().event:e)
};
DwtHtmlEditor.prototype._registerEditorEventHandlers=function(e,n){
var a=["mouseup","drag","mousedown","keydown"];
if(!AjxEnv.isIE7up){
a.push("keypress")
}
for(var t=0;
t<a.length;
++t){
this._registerEditorEventHandler(n,a[t])
}
if(AjxEnv.isIE){
var o=this;
n.attachEvent("onbeforedeactivate",function(){
var s=n.selection;
if(s){
o._currInsPt=s.createRange()
}}
)
}};
DwtHtmlEditor.prototype._registerEditorEventHandler=function(t,e){
if(AjxEnv.isIE){
t.attachEvent("on"+e,this.__eventClosure)
}else{
t.addEventListener(e,this.__eventClosure,true)
}};
DwtHtmlEditor.prototype._unregisterEditorEventHandler=function(t,e){
if(AjxEnv.isIE){
t.detachEvent("on"+e,this.__eventClosure)
}else{
t.removeEventListener(e,this.__eventClosure,true)
}};
DwtHtmlEditor.prototype._handleEditorEvent=function(f){
var n=true;
if(f.type=="mousedown"||f.type=="mousewheel"){
DwtOutsideMouseEventMgr.forwardEvent(f)
}
if(f.type=="mouseup"){
var t=DwtShell.getShell(window).getKeyboardMgr();
if(AjxEnv.isIE){
t.__focusObj=this
}else{
t.grabFocus(this)
}}
if(f.type=="contextmenu"){
var y=DwtShell.mouseEvent;
y.setFromDhtmlEvent(f);
var m=Dwt.getLocation(document.getElementById(this._iFrameId));
if(!AjxEnv.isIE){
var g=this._getIframeDoc();
var h=g.documentElement.scrollLeft||g.body.scrollLeft;
var w=g.documentElement.scrollTop||g.body.scrollTop;
m.x-=h;
m.y-=w
}
y.docX+=m.x;
y.docY+=m.y;
DwtControl.__mouseEvent(f,DwtEvent.ONCONTEXTMENU,this,y);
n=y._returnValue
}
var s=null;
if(DwtKeyEvent.isKeyPressEvent(f)){
var l=this._keyEvent;
l.setFromDhtmlEvent(f);
if(AjxEnv.isGeckoBased&&f.keyCode==13){
this._stateEvent._ignoreCommandState=true;
var e=this._getRange(),o=e.startContainer,u=/^h[1-6]$/i;
if((o.nodeType==3&&u.test(o.parentNode.tagName))||u.test(o.tagName)){
var b=this;
setTimeout(function(){
var p=b._getIframeDoc();
p.body.style.display="none";
p.body.style.display="";
var r=b._getSelection();
r.removeAllRanges();
r.addRange(e)
}
,5)
}}}
var d=false;
if(f.type=="keydown"){
if(AjxEnv.isFirefox&&(AjxEnv.isMac&&f.metaKey||!AjxEnv.isMac&&f.altKey)&&(f.keyCode==37||f.keyCode==39)){
DwtUiEvent.setDhtmlBehaviour(f,true,false);
n=false
}else{
if(f.keyCode==9&&!f.shiftKey){
if(AjxEnv.isIE){
this._handleIETabKey(!f.shiftKey);
l._stopPropagation=true;
l._returnValue=false;
l.setToDhtmlEvent(f);
n=false
}else{
if(AjxEnv.isFirefox||AjxEnv.isPrism){
if(!f.shiftKey){
this._insertHTML(DwtHtmlEditor.TAB,true);
DwtUiEvent.setDhtmlBehaviour(f,true,false);
n=false
}}}}else{
if(DwtKeyboardMgr.isPossibleInputShortcut(f)){
n=d=DwtKeyboardMgr.__keyDownHdlr(f)
}}}}
if(AjxEnv.isIE){
if(d&&f.keyCode==65&&f.ctrlKey&&!f.altKey){
var a=this._getParentElement();
while(a&&(a.nodeType==1)&&(a.tagName.toLowerCase()!="body")){
a=a.parentNode
}
var c=this._getIframeDoc();
this._currInsPt=c.selection.createRange();
this._currInsPt.moveToElementText(a);
this._currInsPt.select()
}}
if(this._stateUpdateActionId!=null){
AjxTimedAction.cancelAction(this._stateUpdateActionId)
}
this._stateUpdateActionId=AjxTimedAction.scheduleAction(this._updateStateAction,100);
if(window.DwtIdleTimer){
DwtIdleTimer.resetIdle()
}
return n
};
DwtHtmlEditor.prototype.getKeyMapName=function(){
return"DwtHtmlEditor"
};
DwtHtmlEditor.prototype.handleKeyAction=function(t,a){
var n="",o="";
if(t==DwtKeyMap.SWITCH_MODE){
try{
this.setMode((this._mode==DwtHtmlEditor.HTML)?DwtHtmlEditor.TEXT:DwtHtmlEditor.HTML,true)
}
catch(s){}}else{
if(t.indexOf("Header")==0){
n=DwtHtmlEditor._FORMAT_BLOCK;
o=DwtHtmlEditor._ACTION_CODE_TO_CMD[t]
}else{
n=DwtHtmlEditor._ACTION_CODE_TO_CMD[t]
}}
if(n){
this._execCommand(n,o);
return true
}
return false
};
DwtHtmlEditor.prototype._handleIETabKey=function(s){
var l=this._getIframeDoc();
var o=this._getParentElement();
var c=o.parentNode;
var d=o.tagName.toLowerCase();
if(d=="p"||d=="body"){
if(s){
this._insertHTML("&nbsp;&nbsp;&nbsp;")
}}else{
if(d=="li"){
this._execCommand((s)?"Indent":"Outdent","")
}else{
try{
var t=this._getAllAncestors();
var r=this._locateNode(t,"td");
if(r!=null){
o=r;
c=o.parentNode;
d=o.tagName.toLowerCase();
if(d=="td"){
var e=(s?o.nextSibling:o.previousSibling);
if(e!=null){
this._setCursor(e)
}else{
e=(s)?c.nextSibling:c.previousSibling;
if(e==null){
if(!s){
return
}
DwtHtmlEditor.table_insertRow(o,s);
e=c.nextSibling
}
if(e!=null){
var n=e.childNodes;
if(n!=null&&n.length>0){
var a=(s)?(0):(n.length-1);
this._setCursor(n[a])
}}}}}}
catch(h){}}}};
DwtHtmlEditor.prototype._setCursor=function(a){
var s=this._getIframeDoc();
var e=s.body;
var t;
if(AjxEnv.isIE){
t=e.createTextRange();
t.moveToElementText(a);
t.collapse(0);
t.select()
}else{
t=s.createRange();
t.selectNodeContents(a);
t.collapse(false);
var n=this._getIframeWin().contentWindow;
var o=n.getSelection();
o.addRange(t);
o.collapseToEnd()
}};
DwtHtmlEditor.prototype._locateNode=function(t,e){
if(t&&e){
for(var a=0;
a<t.length;
a++){
if(t[a].tagName.toLowerCase()==e.toLowerCase()){
return t[a]
}}}
return null
};
DwtHtmlEditor.prototype._getAllAncestors=function(){
var a=this._getParentElement();
var e=[];
while(a&&(a.nodeType==1)&&(a.tagName.toLowerCase()!="body")){
e.push(a);
a=a.parentNode
}
var t=this._getIframeDoc();
if(t.body!=null){
e.push(t.body)
}
return e
};
DwtHtmlEditor.prototype._updateState=function(n){
if(this._mode!=DwtHtmlEditor.HTML){
return
}
this._stateUpdateActionId=null;
var a=this._stateEvent;
if(!a._ignoreCommandState){
a.reset()
}
var s=this._getIframeDoc();
try{
if(!a._ignoreCommandState){
a.isBold=s.queryCommandState(DwtHtmlEditor.BOLD_STYLE);
a.isItalic=s.queryCommandState(DwtHtmlEditor.ITALIC_STYLE);
a.isUnderline=s.queryCommandState(DwtHtmlEditor.UNDERLINE_STYLE);
a.isStrikeThru=s.queryCommandState(DwtHtmlEditor.STRIKETHRU_STYLE);
a.isSuperscript=s.queryCommandState(DwtHtmlEditor.SUPERSCRIPT_STYLE);
a.isSubscript=s.queryCommandState(DwtHtmlEditor.SUBSCRIPT_STYLE);
a.isOrderedList=s.queryCommandState(DwtHtmlEditor.ORDERED_LIST);
a.isUnorderedList=s.queryCommandState(DwtHtmlEditor.UNORDERED_LIST)
}else{
a._ignoreCommandState=null
}
a.fontFamily=s.queryCommandValue(DwtHtmlEditor._FONT_NAME);
var o=s.queryCommandValue(DwtHtmlEditor._FONT_SIZE);
if(!o&&n){
o=(DwtHtmlEditor.FONT_SIZE_VALUES.indexOf(n)+1)
}else{
if(/\d+px/.test(o)){
o=Math.ceil(0.75*parseInt(o))+"pt"
}}
if(/\d+pt/.test(o)){
o=(DwtHtmlEditor.FONT_SIZE_VALUES.indexOf(o)+1)
}
a.fontSize=o;
a.backgroundColor=s.queryCommandValue((AjxEnv.isIE)?"backcolor":"hilitecolor");
a.color=s.queryCommandValue("forecolor");
if(AjxEnv.isIE){
if(AjxUtil.isNumber(a.backgroundColor)){
a.backgroundColor="#"+DwtButtonColorPicker.toHex(a.backgroundColor,6).replace(/(..)(..)(..)/,"$3$2$1")
}
if(AjxUtil.isNumber(a.color)){
a.color="#"+DwtButtonColorPicker.toHex(a.color,6).replace(/(..)(..)(..)/,"$3$2$1")
}}
a.justification=null;
a.direction=null;
var t=s.queryCommandValue(DwtHtmlEditor._FORMAT_BLOCK);
if(t){
if(t.search(DwtHtmlEditor._H1_RE)!=-1){
a.style=DwtHtmlEditor.H1
}else{
if(t.search(DwtHtmlEditor._H2_RE)!=-1){
a.style=DwtHtmlEditor.H2
}else{
if(t.search(DwtHtmlEditor._H3_RE)!=-1){
a.style=DwtHtmlEditor.H3
}else{
if(t.search(DwtHtmlEditor._H4_RE)!=-1){
a.style=DwtHtmlEditor.H4
}else{
if(t.search(DwtHtmlEditor._H5_RE)!=-1){
a.style=DwtHtmlEditor.H5
}else{
if(t.search(DwtHtmlEditor._H6_RE)!=-1){
a.style=DwtHtmlEditor.H6
}else{
if(t.search(DwtHtmlEditor._PARAGRAPH_RE)!=-1){
a.style=DwtHtmlEditor.PARAGRAPH
}else{
if(t.search(DwtHtmlEditor._ADDRESS_RE)!=-1){
a.style=DwtHtmlEditor.ADDRESS
}else{
if(t.search(DwtHtmlEditor._PREFORMATTED_RE)!=-1){
a.style=DwtHtmlEditor.PREFORMATTED
}}}}}}}}}}
if(s.queryCommandState(DwtHtmlEditor.JUSTIFY_LEFT)){
a.justification=DwtHtmlEditor.JUSTIFY_LEFT
}else{
if(s.queryCommandState(DwtHtmlEditor.JUSTIFY_CENTER)){
a.justification=DwtHtmlEditor.JUSTIFY_CENTER
}else{
if(s.queryCommandState(DwtHtmlEditor.JUSTIFY_RIGHT)){
a.justification=DwtHtmlEditor.JUSTIFY_RIGHT
}else{
if(s.queryCommandState(DwtHtmlEditor.JUSTIFY_FULL)){
a.justification=DwtHtmlEditor.JUSTIFY_FULL
}}}}
if(this.isListenerRegistered(DwtEvent.STATE_CHANGE)){
this.notifyListeners(DwtEvent.STATE_CHANGE,a)
}}
catch(e){
if(AjxEnv.isGeckoBased){
this._enableDesignMode(s)
}}};
DwtHtmlEditor.prototype._enableDesignMode=function(a){
if(!a){
return
}
try{
Dwt.enableDesignMode(a,true);
if(AjxEnv.isGeckoBased&&(AjxEnv.isLinux||AjxEnv.isMac)){
this._registerEditorEventHandlers(document.getElementById(this._iFrameId),a)
}}
catch(t){
if(AjxEnv.isGeckoBased||AjxEnv.isSafari){
var e=new AjxTimedAction(this,this._enableDesignMode,[a]);
AjxTimedAction.scheduleAction(e,10);
return true
}else{
return false
}}};
DwtHtmlEditor.prototype._onContentInitialized=function(){
AjxDebug.println(AjxDebug.REPLY,"DwtHtmlEditor::_onContentInitialized - clear pending content, length = "+this._pendingContent.length);
this._pendingContent=null
};
DwtHtmlEditor.prototype._setContentOnTimer=function(){
var a=this._getIframeDoc();
try{
AjxDebug.println(AjxDebug.REPLY,"DwtHtmlEditor::_setContentOnTimer");
if(this._pendingContent!=null){
AjxDebug.println(AjxDebug.REPLY,"Pending content length: "+this._pendingContent.length);
AjxDebug.println(AjxDebug.REPLY,"Set innerHTML of iframe body");
a.body.innerHTML=this._pendingContent
}
if(AjxEnv.isGeckoBased||AjxEnv.isSafari){
AjxDebug.println(AjxDebug.REPLY,"Turn on design mode");
this._enableDesignMode(a)
}
this._onContentInitialized()
}
catch(t){
AjxDebug.println(AjxDebug.REPLY,"_setContentOnTimer got exception, trying again - ["+t+"]");
var e=new AjxTimedAction(this,this._setContentOnTimer);
AjxTimedAction.scheduleAction(e,10);
return true
}};
DwtHtmlEditor.prototype._execCommand=function(o,t){
if(this._mode!=DwtHtmlEditor.HTML){
return
}
try{
this.focus();
this._getIframeDoc().execCommand(o,false,t)
}
catch(a){
this._enableDesignMode(this._getIframeDoc())
}
this._updateState()
};
DwtHtmlEditor.prototype._convertHtml2Text=function(e){
var t=this._getIframeDoc();
return(t&&t.body)?AjxStringUtil.convertHtml2Text(t.body,e,true):""
};
DwtHtmlEditor.prototype.insertLink=function(o){
var u=this._getIframeDoc();
var r=(AjxEnv.isIE&&u&&u.body)?(u.body.innerHTML):"";
if(AjxEnv.isIE&&r==""){
var c=u.createElement("a");
c.href=o.url;
if(o.title){
c.title=o.title
}
var s=u.createTextNode(o.text);
c.appendChild(s);
u.body.appendChild(c);
return c
}else{
var e="javascript:"+Dwt.getNextId();
if(AjxEnv.isIE){
var t=this._getIframeDoc().createElement("a");
t.href=e;
var l=!o.text||o.text==o.url;
var d=this._insertNodeAtSelection(t,false,l);
if(d){
t.innerHTML=d
}else{
t.innerText=o.text
}
this.selectNodeContents(t)
}else{
if(o.text){
this.insertText(o.text,true)
}
this._execCommand("createlink",e)
}
var c=u.getElementsByTagName("a");
var h;
for(var n=c.length;
--n>=0;
){
if(c[n].href==e){
h=c[n];
break
}}
if(h){
h.href=o.url;
if(o.title){
h.title=o.title
}}
return h
}};
DwtHtmlEditor.prototype.getLinkProps=function(){
this.focus();
var e=this.getNearestElement("a");
if(e){
this.selectNodeContents(e)
}
var t=this._getRange();
var o={
text:AjxEnv.isIE?t.createRange().text:t.toString()};
if(e){
o.url=e.href;
o.title=e.title
}
return o
};
DwtHtmlEditor.table_analyzeCells=function(l){
var c=l.parentNode.parentNode;
while(c&&!/table/i.test(c.tagName)){
c=c.parentNode
}
var h={};
var u=c.rows;
for(var n=0;
n<u.length;
++n){
var d=u[n].cells;
var r=0;
for(var a=0;
a<d.length;
){
var e=d[a];
var s=e.colSpan||1;
var t=(e.rowSpan||1)-1;
var o=h[r];
if(o){
if(--o.rs==0){
h[r]=null
}
r+=o.cs
}
e.ZmIndex=r;
if(++a<d.length){
if(t){
h[r]={
cs:s,rs:t}
}
r+=s
}}}
return c
};
DwtHtmlEditor.table_getCellAt=function(r,s){
var l=r.cells;
var h=null,o=null;
for(var a=0;
a<l.length;
++a){
var e=l[a];
var n=(e.colSpan||1)-1;
if(e.ZmIndex<=s&&e.ZmIndex+n>=s){
var t=(e.rowSpan||1)-1;
return{
td:e,cs:n,rs:t}
}else{
if(e.ZmIndex<s){
h=e
}else{
if(e.ZmIndex+n>s&&!o){
o=e
}}}}
return{
last:h,next:o}
};
DwtHtmlEditor.table_getPrevCellAt=function(n,e){
var a=n.parentNode;
while(a&&!/table/i.test(a.tagName)){
a=a.parentNode
}
var o=a.rows;
for(var t=n.rowIndex;
--t>=0;
){
var s=DwtHtmlEditor.table_getCellAt(o[t],e);
if(s.td){
s.dist=n.rowIndex-t;
return s
}}
return null
};
DwtHtmlEditor.table_fixCells=function(e){
for(var t=0;
t<e.length;
++t){
var a=e[t];
if(AjxEnv.isIE){
a.innerHTML="&nbsp;"
}else{
if(AjxEnv.isGeckoBased){
a.innerHTML="<br/>"
}}}};
DwtHtmlEditor.table_insertCol=function(n,t){
var d=DwtHtmlEditor.table_analyzeCells(n);
var u=d.rows;
var l=n.ZmIndex;
if(t){
l+=n.colSpan-1
}
var h=[];
var s=0;
for(var r=0;
r<u.length;
++r){
var c=u[r];
var a=DwtHtmlEditor.table_getCellAt(c,l);
var o=a.td;
var e=null;
if(o){
if(o.ZmIndex==l&&!t){
e=c.insertCell(o.cellIndex)
}else{
if(o.ZmIndex+a.cs==l&&t){
e=c.insertCell(o.cellIndex+1)
}}
if(e){
s=a.rs
}else{
o.colSpan=a.cs+2
}}else{
if(s>0){
if(a.last){
e=c.insertCell(a.last.cellIndex+1)
}else{
if(a.next){
e=c.insertCell(a.next.cellIndex)
}}
--s
}}
if(e){
h.push(e)
}}
return h
};
DwtHtmlEditor.table_insertRow=function(o,t){
var l=o.parentNode;
var m=DwtHtmlEditor.table_analyzeCells(o);
var h=l.rowIndex;
if(t){
h+=o.rowSpan;
l=m.rows[h-1]
}
o=m.rows[0].cells[m.rows[0].cells.length-1];
var c=o.ZmIndex+o.colSpan;
var d=m.insertRow(h);
var r=[];
var u=l.cells;
var e;
for(var s=0;
s<c;
++s){
var a=DwtHtmlEditor.table_getCellAt(l,s);
if(a.td){
if(!t||!a.rs){
for(var n=0;
n<=a.cs;
++n){
r.push(d.insertCell(-1))
}}else{
if(a.rs){
a.td.rowSpan=a.rs+2
}}}else{
a=DwtHtmlEditor.table_getPrevCellAt(l,s);
if(t&&a.rs==a.dist){
for(var n=0;
n<=a.cs;
++n){
r.push(d.insertCell(-1))
}}else{
a.td.rowSpan=a.rs+2
}}
s+=a.cs
}
return r
};
DwtHtmlEditor.table_deleteCol=function(a){
if(!a){
return
}
var l=DwtHtmlEditor.table_analyzeCells(a);
var c=l.rows;
var n=a.ZmIndex;
var h=a.parentNode;
var s;
try{
s=h.cells[a.cellIndex+1];
if(!s){
s=h.cells[a.cellIndex-1]
}}
catch(r){
s=null
}
var e=[];
for(var o=0;
o<c.length;
++o){
var h=c[o];
var t=DwtHtmlEditor.table_getCellAt(h,n);
if(t.td){
if(t.cs){
t.td.colSpan=t.cs
}else{
h.removeChild(t.td);
if(h.cells.length==0){
e.push(h)
}}
o+=t.rs
}}
for(var o=e.length;
--o>=0;
){
h=e[o];
h.parentNode.removeChild(h)
}
if(l.rows.length==0){
l.parentNode.removeChild(l)
}
return s
};
DwtHtmlEditor.table_deleteRow=function(t){
if(!t){
return
}
var s=t.parentNode;
var l=DwtHtmlEditor.table_analyzeCells(t);
t=l.rows[0].cells[l.rows[0].cells.length-1];
var r=t.ZmIndex+t.colSpan;
var h;
for(var a=r;
--a>=0;
){
var e=DwtHtmlEditor.table_getCellAt(s,a);
if(e.td){
if(e.rs){
h=l.rows[s.rowIndex+1];
var o=DwtHtmlEditor.table_getCellAt(h,a);
t=null;
if(o.last){
t=h.insertCell(o.last.cellIndex+1)
}else{
if(o.next){
t=h.insertCell(o.next.cellIndex)
}}
if(t){
if(e.cs>0){
t.colSpan=e.cs+1
}
if(e.rs>1){
t.rowSpan=e.rs
}}}
s.removeChild(e.td)
}else{
e=DwtHtmlEditor.table_getPrevCellAt(s,a);
if(e){
if(e.rs){
e.td.rowSpan=e.rs;
a-=e.cs
}}}}
try{
h=l.rows[s.rowIndex+1];
if(!h){
h=l.rows[s.rowIndex-1]
}}
catch(n){
h=null
}
s.parentNode.removeChild(s);
if(l.rows.length==0){
l.parentNode.removeChild(l)
}
if(h){
return h.cells[0]
}};
DwtHtmlEditor.prototype.searchnReplace=function(a){
var n=this._getIframeWin();
n.focus();
var h=this._getIframeDoc();
var o=h.body;
var s=this._getSelectedText();
if(o.innerHTML==""){
return true
}
str1=a.searchstring;
str2=s;
if(a.replacemode=="current"){
str1=str1.toString();
str2=str2.toString();
if(!a.casesensitive){
str1=str1.toLowerCase();
str2=str2.toLowerCase()
}
if(str1==str2){
this.replaceSel(a.searchstring,a.replacestring);
a.replacemode="none"
}}
if(AjxEnv.isIE){
var e=this.lastSearchRng?this.lastSearchRng:this.range_findnreplace;
var t=0;
if(a.wholeword){
t=t|2
}
if(a.casesensitive){
t=t|4
}
if(!e.findText){
alert("This operation is currently not supported by this browser.");
return true
}
if(a.replacemode=="all"){
if(AjxEnv.isIE){
this.focus()
}
var r=new RegExp(a.searchstring,((a.casesensitive)?"":"i")+"g");
var l=this.replaceNodeContent(o,r,a.replacestring,"all",0);
return true
}
if(e.findText(a.searchstring,a.backwards?-1:1,t)){
e.scrollIntoView();
e.select();
e.collapse(a.backwards);
this.lastSearchRng=e;
if(AjxEnv.isIE&&(a.replacemode=="current")){
this.replaceSel(a.searchstring,a.replacestring)
}}else{
rng1=o.createTextRange();
rng1.findText(a.searchstring,a.backwards?-1:1,t);
rng1.scrollIntoView();
if(rng1.text.toLowerCase()==a.searchstring.toLowerCase()){
rng1.select()
}
rng1.collapse(false);
this.lastSearchRng=rng1;
if(AjxEnv.isIE&&(a.replacemode=="current")){
this.replaceSel(a.searchstring,a.replacestring)
}}}else{
if(a.replacemode=="all"){
var r=new RegExp(a.searchstring,(a.casesensitive?"":"i")+"g");
var l=this.replaceNodeContent(o,r,a.replacestring,"all",0);
return true
}
if(!n.find(a.searchstring,a.casesensitive,a.backwards,a.wrap,a.wholeword,false,false)){
while(n.find(a.searchstring,a.casesensitive,true,a.wrap,a.wholeword,false,false)){}}}};
DwtHtmlEditor.prototype.replaceSel=function(e,s){
if(s==null){
return
}
var n=this._getIframeWin();
var o=n.document;
var t;
if(!AjxEnv.isIE){
var a=n.getSelection();
t=a.getRangeAt(0)
}else{
t=n.document.selection.createRange()
}
if(!AjxEnv.isIE){
if(s.indexOf(e)==-1){
t.deleteContents();
t.insertNode(t.createContextualFragment(s));
t.collapse(false)
}}else{
if(t.item){
t.item(0).outerHTML=s
}else{
t.pasteHTML(s)
}}};
DwtHtmlEditor.prototype._getSelectedText=function(){
var a=this._getIframeWin();
var t=this._getIframeDoc();
var e="";
if(a.getSelection){
e=a.getSelection()
}else{
if(t.getSelection){
e=t.getSelection()
}else{
if(t.selection){
e=t.selection.createRange().text
}}}
return e
};
DwtHtmlEditor.prototype.replaceNodeContent=function(a,r,o,h,t){
for(var n=0;
n<a.childNodes.length;
n++){
var s=a.childNodes[n];
if(s.nodeType==3){
var e=s.nodeValue.replace(r,o);
if(s.nodeValue!=e){
s.nodeValue=e;
t++;
if(h!="all"){
return t
}}}
this.replaceNodeContent(s,r,o,h,t);
if((h!="all")&&(t>0)){
return t
}}
return t
};
DwtHtmlEditor.prototype.setTextAreaId=function(e){
this._textAreaId=e
};
DwtHtmlEditor._normalizeFontId=function(h,r){
var o=h;
h=h.replace(/,\s/g,",").replace(/'/g,"").toLowerCase();
if(!r){
var n=DwtHtmlEditor.FONT_FAMILY;
if(n&&!n[h]){
var a=AjxUtil.keys(n);
if(a.length){
var s=h.split(",");
for(var t=0;
t<s.length;
t++){
for(var e=0;
e<a.length;
e++){
if(a[e].indexOf(s[t])!=-1){
return a[e]
}}}
return a[0]
}}}
return h
};
DwtHtmlEditor._normalizeFontName=function(e){
return DwtHtmlEditor.FONT_FAMILY[DwtHtmlEditor._normalizeFontId(e)].name
};
DwtHtmlEditor._normalizeFontValue=function(e){
return DwtHtmlEditor.FONT_FAMILY[DwtHtmlEditor._normalizeFontId(e)].value
};
DwtHtmlEditor.FONT_FAMILY={};
(function(){
var e=["fontFamilyIntl","fontFamilyBase"];
var n,a,o,s,t;
for(a=0;
a<e.length;
a++){
for(n=1;
s=AjxMsg[e[a]+n+".css"];
n++){
if(s.match(/^#+$/)){
break
}
s=DwtHtmlEditor._normalizeFontId(s,true);
t=AjxMsg[e[a]+n+".display"];
DwtHtmlEditor.FONT_FAMILY[s]={
name:t,value:s}
}}}
)();
