
/* Copyright (C) 2005-2009 Zimbra Inc. http://www.zimbra.com/ */
DwtPropertyEditor=function(o,t,i,a,e){
if(arguments.length>0){
if(!i){
i="DwtPropertyEditor"
}
DwtComposite.call(this,{
parent:o,className:i,posStyle:a,deferred:e}
);
this._useDwtInputField=t!=null?t:true;
this._schema=null;
this._init()
}};
DwtPropertyEditor.MSG_TIMEOUT=4000;
DwtPropertyEditor.MSG={
mustMatch:"This field does not match validators: REGEXP",mustNotMatch:"This field matches anti-validators: REGEXP"};
DwtPropertyEditor.prototype=new DwtComposite;
DwtPropertyEditor.prototype.constructor=DwtPropertyEditor;
DwtPropertyEditor.prototype.toString=function(){
return"DwtPropertyEditor"
};
DwtPropertyEditor.prototype._init=function(){
var t=document.createElement("div");
t.id=this._relDivId=Dwt.getNextId();
t.style.position="relative";
var e=document.createElement("table");
e.id=this._tableId=Dwt.getNextId();
e.cellSpacing=e.cellPadding=0;
e.appendChild(document.createElement("tbody"));
t.appendChild(e);
this.getHtmlElement().appendChild(t);
this.maxLabelWidth=0;
this.maxFieldWidth=0;
this._setMouseEventHdlrs();
this._onMouseDown=new AjxListener(this,this._onMouseDown);
this.addListener(DwtEvent.ONMOUSEDOWN,this._onMouseDown)
};
DwtPropertyEditor.prototype.getRelDiv=function(){
return document.getElementById(this._relDivId)
};
DwtPropertyEditor.prototype.getTable=function(){
return document.getElementById(this._tableId)
};
DwtPropertyEditor.prototype._onMouseDown=function(a){
var i=a.target;
var e=i.tagName.toLowerCase();
if(e=="input"){
a._stopPropagation=false;
a._returnValue=true;
return true
}
if(this._currentInputField&&!this._currentInputField.onblur()){
a._stopPropagation=true;
a._returnValue=false;
return false
}
try{
while(i&&e!="tr"){
i=i.parentNode;
e=i.tagName.toLowerCase()
}
if(i&&i.__msh_doMouseDown){
i.__msh_doMouseDown(a)
}}
catch(t){}};
DwtPropertyEditor.prototype.getProperties=function(){
if(this._currentInputField){
this._currentInputField.onblur()
}
function e(o){
var r={}
,a,s=o.length;
for(var t=0;
t<s;
++t){
a=o[t];
if(a.type=="struct"){
r[a.name]=e(a.children)
}else{
r[a.name]=a.value
}}
return r
}
return e(this._schema)
};
DwtPropertyEditor.prototype.validateData=function(){
var e=true;
function t(s){
var o,r=s.length;
for(var a=0;
a<r;
++a){
o=s[a];
if(o.type=="struct"){
t(o.children)
}else{
if(!o._validate()){
e=false
}}}}
t(this._schema);
return e
};
DwtPropertyEditor.prototype.initProperties=function(a,t){
if(t==null){
this._schema=a;
t=null
}
for(var e=0;
e<a.length;
++e){
this._createProperty(a[e],t)
}};
DwtPropertyEditor.prototype._createProperty=function(e,l){
var t=l?l._level+1:0;
var h=this.getTable().firstChild.appendChild(document.createElement("tr"));
e._parent=l;
e._level=t;
e._rowElId=h.id=Dwt.getNextId();
e._propertyEditor=this;
for(var s in DwtPropertyEditor._prop_functions){
e[s]=DwtPropertyEditor._prop_functions[s]
}
e._init();
h.className="level-"+t;
if(e.visible=="false"){
h.className+=" invisible"
}
if(e.readonly){
h.className+=" readonly"
}
if(e.type!="struct"){
h.className+=" "+e.type;
var a=document.createElement("td");
a.className="label";
if(e.type=="checkboxgroup"){
a.className+=" grouplabel"
}
h.appendChild(a);
var r=AjxStringUtil.htmlEncode(e.label||e.name);
if(e.required){
r+="<span class='DwtPropertyEditor-required'>*</span>"
}
a.innerHTML=r;
var o=document.createElement("td");
o.className="field";
h.appendChild(o);
switch(e.type){
case"boolean":this._createCheckbox(e,o);
break;
case"enum":this._createDropDown(e,o);
break;
case"date":this._createCalendar(e,o);
break;
case"checkboxgroup":this._createCheckBoxGroup(e,o);
break;
default:if(this._useDwtInputField){
this._createInputField(e,o)
}else{
o.innerHTML=e._makeDisplayValue();
h.__msh_doMouseDown=DwtPropertyEditor.simpleClosure(e._edit,e)
}
break
}
e._fieldCellId=o.id=Dwt.getNextId();
if(a.offsetWidth>this.maxLabelWidth){
this.maxLabelWidth=a.offsetWidth
}
if(o.offsetWidth>this.maxFieldWidth){
this.maxFieldWidth=o.offsetWidth
}}else{
var n=document.createElement("td");
n.colSpan=2;
h.appendChild(n);
n.className="label";
h.className+=" expander-collapsed";
n.innerHTML=["<div>",AjxStringUtil.htmlEncode(e.label),"</div>"].join("");
this.initProperties(e.children,e);
h.__msh_doMouseDown=DwtPropertyEditor.simpleClosure(e._toggle,e)
}
if(t>0){
h.style.display="none";
l._hidden=true
}};
DwtPropertyEditor.prototype.setFixedLabelWidth=function(e){
try{
this.getTable().rows[0].cells[0].style.width=(e||this.maxLabelWidth)+"px"
}
catch(t){}};
DwtPropertyEditor.prototype.setFixedFieldWidth=function(e){
try{
this.getTable().rows[0].cells[1].style.width=(e||this.maxFieldWidth)+"px"
}
catch(t){}};
DwtPropertyEditor.prototype._setCurrentMsgDiv=function(e){
this._currentMsgDiv=e;
this._currentMsgDivTimer=setTimeout(DwtPropertyEditor.simpleClosure(this._clearMsgDiv,this),DwtPropertyEditor.MSG_TIMEOUT)
};
DwtPropertyEditor.prototype._clearMsgDiv=function(){
try{
this._stopMsgDivTimer()
}
catch(e){}
var t=this._currentMsgDiv;
if(t){
t.parentNode.removeChild(t);
this._currentMsgDiv=t=null;
this._currentMsgDivTimer=null
}};
DwtPropertyEditor.prototype._stopMsgDivTimer=function(){
if(this._currentMsgDivTimer){
clearTimeout(this._currentMsgDivTimer);
this._currentMsgDivTimer=null
}};
DwtPropertyEditor.prototype.addChild=function(e){
if(!this._currentFieldCell){
DwtComposite.prototype.addChild.call(this,e)
}else{
this._children.add(e);
this._currentFieldCell.appendChild(e.getHtmlElement())
}};
DwtPropertyEditor.prototype._createCheckbox=function(a,t){
var e=document.createElement("input");
e._prop=a;
e.id=a.name;
e.type="checkbox";
if(AjxEnv.isIE){
e.attachEvent("onclick",a._onCheckboxChange)
}else{
e.addEventListener("click",a._onCheckboxChange,false)
}
this._children.add(e);
t.appendChild(e);
if(a.value=="true"){
e.checked=a.value
}};
DwtPropertyEditor.prototype._createCheckBoxGroup=function(e,n){
var t=document.createElement("div");
t._prop=e;
t.id=e.name;
e._checkBox=[];
t.appendChild(document.createTextNode(e.value));
var h=document.createElement("table");
h.id=Dwt.getNextId();
h.border=0;
h.cellSpacing=h.cellPadding=0;
h.appendChild(document.createElement("tbody"));
for(var a=0;
a<e.checkBox.length;
a++){
var s=document.createElement("tr");
var l=document.createElement("td");
l.className="field";
var o=this._createCheckboxForGroup(e,e.checkBox[a],l);
s.appendChild(l);
o._label=e.checkBox[a].label;
var r=document.createElement("td");
r.className="field";
r.appendChild(document.createTextNode(e.checkBox[a].label));
s.appendChild(r);
h.firstChild.appendChild(s);
e._checkBox[a]=o
}
t.appendChild(h);
this._children.add(t);
n.appendChild(t);
return t
};
DwtPropertyEditor.prototype._createCheckboxForGroup=function(e,i,a){
var t=document.createElement("input");
t._prop=e;
t.id=i.name;
t.type="checkbox";
if(i.value=="true"){
t.checked=i.value
}
if(AjxEnv.isIE){
t.attachEvent("onclick",e._onCheckboxGroupChange)
}else{
t.addEventListener("click",e._onCheckboxGroupChange,false)
}
this._children.add(t);
a.appendChild(t);
return t
};
DwtPropertyEditor.prototype._createDropDown=function(r,s){
this._currentFieldCell=s;
var o,n,a=0,t=[],e=r.item;
while(o=e[a]){
t[a++]=new DwtSelectOption(o.value,o.value==r.value,o.label)
}
r._select=n=new DwtSelect({
parent:this,options:t}
);
n.addChangeListener(new AjxListener(r,r._onSelectChange));
n.addListener(DwtEvent.ONMOUSEDOWN,this._onMouseDown);
this._currentFieldCell=null
};
DwtPropertyEditor.prototype._createCalendar=function(n,i){
this._currentFieldCell=i;
var t=new DwtButton({
parent:this}
);
this._currentFieldCell=null;
t.setText(n._makeDisplayValue());
var o=new DwtMenu({
parent:t,style:DwtMenu.CALENDAR_PICKER_STYLE}
);
o.setAssociatedObj(t);
var a=new DwtCalendar({
parent:o}
);
var e=new Date();
e.setTime(n.value);
a.setDate(e);
a.setSize(150,"auto");
a.addSelectionListener(new AjxListener(n,n._onCalendarSelect));
t.setMenu(o);
n._dateButton=t;
n._dateCalendar=a
};
DwtPropertyEditor.DWT_INPUT_FIELD_TYPES={
string:DwtInputField.STRING,password:DwtInputField.PASSWORD,integer:DwtInputField.INTEGER,number:DwtInputField.FLOAT};
DwtPropertyEditor.prototype._createInputField=function(i,a){
this._currentFieldCell=a;
var e=DwtPropertyEditor.DWT_INPUT_FIELD_TYPES[i.type]||DwtInputField.STRING;
var t=new DwtInputField({
parent:this,type:e,initialValue:i.value,maxLen:i.maxLength,rows:i.rows}
);
if(e==DwtInputField.INTEGER||e==DwtInputField.FLOAT){
t.setValidNumberRange(i.minValue||null,i.maxValue||null);
if(i.decimals!=null){
t.setNumberPrecision(i.decimals)
}}
if(e==DwtInputField.STRING||e==DwtInputField.PASSWORD){
t.setValidStringLengths(i.minLength,i.maxLength)
}
if(i.required){
t.setRequired()
}
this._currentFieldCell=null;
i._inputField=t;
t.setValue(i.value);
if(i.readonly){
t.setReadOnly(true)
}
t.setValidationCallback(new AjxCallback(i,i._onDwtInputFieldValidated))
};
DwtPropertyEditor._prop_functions={
_init:function(){
this.type!=null||(this.type="string");
this.value!=null||(this.value="");
this._initialVal=this.value;
if(this.type=="date"){
if(!this.value){
this.value=new Date().getTime()
}
if(!this.format){
this.format=AjxDateUtil.getSimpleDateFormat().toPattern()
}}}
,_modified:function(){
return this._initialVal!=this.value
}
,_getRowEl:function(){
return document.getElementById(this._rowElId)
}
,_makeDisplayValue:function(){
var t=this._getValue();
switch(this.type){
case"password":t=t.replace(/./g,"*");
break;
case"date":var e=new Date();
e.setTime(t);
t=AjxDateFormat.format(this.format,e);
break
}
if(t==""){
t="<br />"
}else{
t=AjxStringUtil.htmlEncode(String(t))
}
return t
}
,_display:function(o){
var n=this.children,a=o?"":"none";
if(n){
var e=n.length;
while(--e>=0){
n[e]._getRowEl().style.display=a;
if(!o){
n[e]._display(false)
}}
this._hidden=!o;
var t=this._getRowEl();
t.className=t.className.replace(/expander-[^\s]+/,o?"expander-expanded":"expander-collapsed")
}}
,_toggle:function(){
this._display(this._hidden)
}
,_edit:function(){
if(this.readonly){
return
}
switch(this.type){
case"string":case"number":case"integer":case"password":setTimeout(DwtPropertyEditor.simpleClosure(this._createInputField,this),50);
break
}}
,_createInputField:function(){
var e=this._propertyEditor;
var n=document.getElementById(this._fieldCellId);
var a=e.getRelDiv();
var t=document.createElement("input");
t.className="DwtPropertyEditor-input "+this.type;
t.setAttribute("autocomplete","off");
t.type=this.type=="password"?"password":"text";
var o=n.offsetLeft,i=n.offsetTop;
if(AjxEnv.isGeckoBased){
--o;
--i
}
t.style.left=o+"px";
t.style.top=i+"px";
t.style.width=n.offsetWidth+1+"px";
t.style.height=n.offsetHeight+1+"px";
t.value=this._getValue();
a.appendChild(t);
t.focus();
t.onblur=DwtPropertyEditor.simpleClosure(this._saveInput,this);
t.onkeydown=DwtPropertyEditor.simpleClosure(this._inputKeyPress,this);
this._propertyEditor._currentInputField=this._inputField=t;
if(!AjxEnv.isGeckoBased){
t.select()
}else{
t.setSelectionRange(0,t.value.length)
}}
,_getValue:function(){
return this.value||""
}
,_checkValue:function(a){
var e=a=="";
if(e){
if(!this.required){
return a
}
this._displayMsg(AjxMsg.valueIsRequired);
return null
}
if(this.maxLength!=null&&a.length>this.maxLength){
this._displayMsg(AjxMessageFormat.format(AjxMsg.stringTooLong,this.maxLength));
return null
}
if(this.minLength!=null&&a.length<this.minLength){
this._displayMsg(AjxMessageFormat.format(AjxMsg.stringTooShort,this.minLength));
return null
}
if(this.mustMatch&&!this.mustMatch.test(a)){
this._displayMsg(this.msg_mustMatch||DwtPropertyEditor.MSG.mustMatch.replace(/REGEXP/,this.mustMatch.toString()));
return null
}
if(this.mustNotMatch&&this.mustNotMatch.test(a)){
this._displayMsg(this.msg_mustNotMatch||DwtPropertyEditor.MSG.mustNotMatch.replace(/REGEXP/,this.mustNotMatch.toString()));
return null
}
switch(this.type){
case"integer":case"number":var o=new Number(a);
if(isNaN(o)){
this._displayMsg(AjxMsg.notANumber);
return null
}
if(this.type=="integer"&&Math.round(o)!=o){
this._displayMsg(AjxMsg.notAnInteger);
return null
}
if(this.minValue!=null&&o<this.minValue){
this._displayMsg(AjxMessageFormat.format(AjxMsg.numberLessThanMin,this.minValue));
return null
}
if(this.maxValue!=null&&o>this.maxValue){
this._displayMsg(AjxMessageFormat.format(AjxMsg.numberMoreThanMax,this.maxValue));
return null
}
a=o;
if(this.type=="number"&&this.decimals!=null){
var t=a.toString();
var i=t.indexOf(".");
if(i==-1){
i=t.length
}
a=a.toPrecision(i+this.decimals)
}
break
}
return a
}
,_displayMsg:function(t){
var s,n,r,i;
var o=this._propertyEditor;
var e=o._currentMsgDiv;
if(!e){
e=document.createElement("div");
e.className="DwtPropertyEditor-ErrorMsg";
o.getRelDiv().appendChild(e)
}else{
o._stopMsgDivTimer()
}
e.style.visibility="hidden";
e.innerHTML=AjxStringUtil.htmlEncode(t);
var l=o.getTable();
r=l.offsetWidth;
if(!AjxEnv.isIE){
r-=12
}
s=l.offsetLeft;
e.style.left=s+"px";
e.style.width=r+"px";
i=e.offsetHeight;
var a=document.getElementById(this._fieldCellId);
n=a.offsetTop+a.offsetHeight;
if(n+i>l.offsetTop+l.offsetHeight){
n=a.offsetTop-i
}
e.style.top=n+"px";
e.style.visibility="";
o._setCurrentMsgDiv(e)
}
,_saveInput:function(){
var e=this._inputField;
var t=this._checkValue(e.value);
if(t!=null){
this._setValue(t);
e.onblur=e.onkeyup=e.onkeydown=e.onkeypress=null;
var a=document.getElementById(this._fieldCellId);
a.innerHTML=this._makeDisplayValue();
this._inputField=null;
this._propertyEditor._currentInputField=null;
this._propertyEditor._clearMsgDiv();
e.parentNode.removeChild(e);
return true
}else{
if(e.className.indexOf(" DwtPropertyEditor-input-error")==-1){
e.className+=" DwtPropertyEditor-input-error"
}
e.focus();
return false
}}
,_inputKeyPress:function(t){
t||(t=window.event);
var e=this._inputField;
if(t.keyCode==13){
this._saveInput()
}else{
if(t.keyCode==27){
e.value=this._getValue();
this._saveInput()
}else{
this._propertyEditor._clearMsgDiv();
e.className=e.className.replace(/ DwtPropertyEditor-input-error/,"")
}}}
,_onCheckboxChange:function(t){
t||(t=window.event);
var e=AjxEnv.isIE?t.srcElement:t.target;
e._prop._setValue(e.checked?"true":"false")
}
,_onSelectChange:function(){
this._setValue(this._select.getValue())
}
,_onCheckboxGroupChange:function(o){
o||(o=window.event);
var a=AjxEnv.isIE?o.srcElement:o.target;
var e=a._prop._checkBox;
var n=[];
for(var t=0;
t<e.length;
t++){
if(e[t].checked){
n.push(e[t]._label)
}}
a._prop._setValue(n)
}
,_onCalendarSelect:function(){
this._setValue(this._dateCalendar.getDate().getTime());
this._dateButton.setText(this._makeDisplayValue())
}
,_onDwtInputFieldValidated:function(e,a,t){
if(a){
this._setValue(t)
}}
,_setValue:function(t){
this.value=t;
var e=this._getRowEl();
e.className=e.className.replace(/ dirty/,"");
if(this._modified()){
e.className+=" dirty"
}}
,_validate:function(){
if(this._inputField){
if(this._inputField instanceof DwtInputField){
return this._inputField.validate()
}else{
return this._inputField.onblur()
}}else{
return true
}}};
DwtPropertyEditor.simpleClosure=function(e,t){
return function(){
return e.call(t,arguments[0])
}
};
