
/* Copyright (C) 2005-2009 Zimbra Inc. http://www.zimbra.com/ */
DwtPropertySheet=function(o,i,a,e){
if(arguments.length==0){
return
}
i=i||"DwtPropertySheet";
DwtComposite.call(this,{
parent:o,className:i,posStyle:a}
);
this._labelSide=e||DwtPropertySheet.DEFAULT;
this._propertyIdCount=0;
this._propertyList=[];
this._propertyMap={};
this._tableEl=document.createElement("TABLE");
this._tableEl.border=0;
this._tableEl.cellSpacing=3;
this._tableEl.cellPadding=0;
var t=this.getHtmlElement();
t.appendChild(this._tableEl)
};
DwtPropertySheet.prototype=new DwtComposite;
DwtPropertySheet.prototype.constructor=DwtPropertySheet;
DwtPropertySheet.prototype.toString=function(){
return"DwtPropertySheet"
};
DwtPropertySheet.RIGHT="right";
DwtPropertySheet.LEFT="left";
DwtPropertySheet.DEFAULT=DwtPropertySheet.LEFT;
DwtPropertySheet.prototype._labelSide;
DwtPropertySheet.prototype._labelCssClass="Label";
DwtPropertySheet.prototype._valueCssClass="Field";
DwtPropertySheet.prototype._tableEl;
DwtPropertySheet.prototype._propertyIdCount;
DwtPropertySheet.prototype._propertyList;
DwtPropertySheet.prototype._propertyMap;
DwtPropertySheet.prototype.addProperty=function(t,i,n){
var e=this._tableEl.rows.length;
var o=this._tableEl.insertRow(e);
o.vAlign=this._vAlign?this._vAlign:"top";
if(this._labelSide==DwtPropertySheet.LEFT){
this._insertLabel(o,t,n);
this._insertValue(o,i,n)
}else{
this._insertValue(o,i,n);
this._insertLabel(o,t,n)
}
var s=this._propertyIdCount++;
var a={
id:s,index:e,row:o,visible:true};
this._propertyList.push(a);
this._propertyMap[s]=a;
return s
};
DwtPropertySheet.prototype._insertLabel=function(o,e,i){
var a=o.insertCell(-1);
a.className=this._labelCssClass;
if(this._labelSide!=DwtPropertySheet.LEFT){
a.width="100%";
a.style.textAlign="left"
}
a.innerHTML=e;
if(i){
var t=this._tableEl.ownerDocument.createElement("SUP");
t.innerHTML="*";
a.insertBefore(t,a.firstChild)
}};
DwtPropertySheet.prototype._insertValue=function(i,t,a){
var e=i.insertCell(-1);
e.className=this._valueCssClass;
if(!t){
e.innerHTML="&nbsp;"
}else{
if(t instanceof DwtControl){
e.appendChild(t.getHtmlElement())
}else{
if(t.nodeType==AjxUtil.ELEMENT_NODE){
e.appendChild(t)
}else{
e.innerHTML=String(t)
}}}};
DwtPropertySheet.prototype.removeProperty=function(s){
var n=this._propertyMap[s];
if(n.visible){
var t=n.index;
var o=this.__getTableIndex(t);
var a=this._tableEl.rows[o];
a.parentNode.removeChild(a)
}
n.row=null;
for(var e=index+1;
e<this._propertyList.length;
e++){
var n=this._propertyList[e];
n.index--
}
this._propertyList.splice(index,1);
delete this._propertyMap[s]
};
DwtPropertySheet.prototype.setPropertyVisible=function(n,i){
var o=this._propertyMap[n];
if(o.visible!=i){
o.visible=i;
var e=o.index;
if(i){
var a=this.__getTableIndex(e);
var t=this._tableEl.insertRow(a);
DwtPropertySheet.__moveChildNodes(o.row,t);
o.row=t
}else{
var t=o.row;
if(t&&t.parentNode){
t.parentNode.removeChild(t)
}}}};
DwtPropertySheet.prototype.__getTableIndex=function(t){
var a=0;
for(var e=0;
e<t;
e++){
var o=this._propertyList[e];
if(o.visible){
a++
}}
return a
};
DwtPropertySheet.__moveChildNodes=function(t,e){
if(t===e){
return
}
var a=t.firstChild;
while(a!=null){
e.appendChild(a);
a=t.firstChild
}};
