
/* Copyright (C) 2005-2009 Zimbra Inc. http://www.zimbra.com/ */
DwtSelect=function(o){
if(arguments.length==0){
return
}
o=Dwt.getParams(arguments,DwtSelect.PARAMS);
o.className=o.className||"ZSelect";
o.posStyle=o.posStyle||Dwt.STATIC_STYLE;
DwtButton.call(this,o);
var a=AjxEnv.isIE?[DwtEvent.ONMOUSEDOWN,DwtEvent.ONMOUSEUP]:[DwtEvent.ONMOUSEDOWN,DwtEvent.ONMOUSEUP,DwtEvent.ONMOUSEOVER,DwtEvent.ONMOUSEOUT];
this._setEventHdlrs(a);
this._hasSetMouseEvents=true;
this._currentSelectionId=-1;
this._options=new AjxVector();
this._optionValuesToIndices={};
this._selectedValue=this._selectedOption=null;
this._maxRows=o.maxRows||0;
this._layout=o.layout;
var e=o.options;
if(e){
for(var t=0;
t<e.length;
++t){
this.addOption(e[t])
}}
this.setDropDownImages("SelectPullDownArrow","SelectPullDownArrowDis","SelectPullDownArrow","SelectPullDownArrow");
this._menuCallback=new AjxListener(this,this._createMenu);
this.setMenu(this._menuCallback,true)
};
DwtSelect.PARAMS=["parent","options","style","className","layout"];
DwtSelect.prototype=new DwtButton;
DwtSelect.prototype.constructor=DwtSelect;
DwtSelect.prototype.toString=function(){
return"DwtSelect"
};
DwtSelect._CONTAINER_TEMPLATE="dwt.Widgets#ZSelectAutoSizingContainer";
DwtSelect._objectIds=[null];
DwtSelect.prototype.TEMPLATE="dwt.Widgets#ZSelect";
DwtSelect.getObjectFromElement=function(e){
return e&&e.dwtObj?AjxCore.objectWithId(e.dwtObj):null
};
DwtSelect.prototype.addOption=function(o,i,n,a){
if(!o){
return -1
}
a=a||null;
var e=null;
var t=null;
if(typeof(o)=="string"){
t=n!=null?n:o;
e=new DwtSelectOption(t,i,o,this,null,a)
}else{
if(o instanceof DwtSelectOption){
e=o;
if(n){
e.setValue(n)
}
i=e.isSelected()
}else{
if(o instanceof DwtSelectOptionData||o.value!=null){
t=n!=null?n:o.value;
e=new DwtSelectOption(t,o.isSelected,o.displayValue,this,null,o.image,o.selectedValue);
i=Boolean(o.isSelected)
}else{
return -1
}}}
this._options.add(e);
if(this._options.size()==1||i){
this._setSelectedOption(e)
}
var r=this._pseudoItemsEl;
var h=r.insertRow(-1);
var s=h.insertCell(-1);
s.className="ZSelectPseudoItem";
s.innerHTML=["<div class='ZWidgetTitle'>",AjxStringUtil.htmlEncode(e.getDisplayValue()),"</div>"].join("");
this.setMenu(this._menuCallback,true);
this._optionValuesToIndices[e.getValue()]=this._options.size()-1;
return(this._options.size()-1)
};
DwtSelect.prototype.removeOption=function(o){
if(!o){
return -1
}
this.setMenu(this._menuCallback,true);
this._options.remove(o);
var a=this._options.size();
var n=o.getValue();
var e=this._optionValuesToIndices[n];
if(e!=null){
this._pseudoItemsEl.deleteRow(e);
if(this._selectedOption==o&&a>0){
var s=(e>=a)?a-1:e;
this._setSelectedOption(this._options.get(s))
}}
delete this._optionValuesToIndices[n];
for(var t=e;
t<a;
t++){
var o=this._options.get(t);
this._optionValuesToIndices[o.getValue()]=t
}
return e
};
DwtSelect.prototype.removeOptionWithValue=function(t){
var e=this.getOptionWithValue(t);
return e?this.removeOption(e):-1
};
DwtSelect.prototype.popup=function(){
var n=this.getMenu();
if(!n){
return
}
var i=this._selectEl;
var t=Dwt.getBounds(i);
var o=(i.style.borderLeftWidth=="")?0:parseInt(i.style.borderLeftWidth);
var r=(i.style.borderTopWidth=="")?0:parseInt(i.style.borderTopWidth);
r+=(i.style.borderBottomWidth=="")?0:parseInt(i.style.borderBottomWidth);
var a=Dwt.toWindow(i,0,0);
var e=a.x+o;
var s=a.y+t.height+r;
n.popup(0,e,s)
};
DwtSelect.prototype.rename=function(t,a){
var e=this.getOptionWithValue(t);
if(!e){
return
}
e._displayValue=a;
if(this._selectedOption&&(this._selectedOption._value==t)){
this.setText(AjxStringUtil.htmlEncode(a))
}
this.setMenu(this._menuCallback,true)
};
DwtSelect.prototype.enableOption=function(i,e){
var t=this.getOptionWithValue(i);
if(!t){
return
}
if(t.enabled!=e){
t.enabled=e;
var a=t.getItem();
if(a){
a.setEnabled(e)
}}};
DwtSelect.prototype.clearOptions=function(){
var t=this._options.getArray();
for(var e=0;
e<t.length;
++e){
t[e]=null
}
this._options.removeAll();
this._optionValuesToIndices=null;
this._optionValuesToIndices=[];
this._selectedValue=null;
this._selectedOption=null;
this._currentSelectionId=-1
};
DwtSelect.prototype.setName=function(e){
this._name=e
};
DwtSelect.prototype.getName=function(){
return this._name
};
DwtSelect.prototype.setSelectedValue=function(t){
var e=this._optionValuesToIndices[t];
if(e!=null){
this.setSelected(e)
}};
DwtSelect.prototype.setSelected=function(e){
var t=this.getOptionWithHandle(e);
this.setSelectedOption(t)
};
DwtSelect.prototype.getOptionCount=function(){
return this._options.size()
};
DwtSelect.prototype.getOptions=function(){
return this._options
};
DwtSelect.prototype.getOptionWithHandle=function(e){
return this._options.get(e)
};
DwtSelect.prototype.getOptionAtIndex=DwtSelect.prototype.getOptionWithHandle;
DwtSelect.prototype.getIndexForValue=function(e){
return this._optionValuesToIndices[e]
};
DwtSelect.prototype.getOptionWithValue=function(a){
var e=this._optionValuesToIndices[a];
var t=null;
if(e!=null){
t=this.getOptionWithHandle(e)
}
return t
};
DwtSelect.prototype.setSelectedOption=function(e){
if(e){
this._setSelectedOption(e)
}};
DwtSelect.prototype.getValue=function(){
return this._selectedValue
};
DwtSelect.prototype.getSelectedOption=function(){
return this._selectedOption
};
DwtSelect.prototype.getSelectedIndex=function(){
return this.getIndexForValue(this.getValue())
};
DwtSelect.prototype.addChangeListener=function(e){
this.addListener(DwtEvent.ONCHANGE,e)
};
DwtSelect.prototype.size=function(){
return this._options.size()
};
DwtSelect.prototype.disable=function(){
this.setEnabled(false)
};
DwtSelect.prototype.enable=function(){
this.setEnabled(true)
};
DwtSelect.prototype.setImage=function(e){
DwtLabel.prototype.setImage.call(this,e)
};
DwtSelect.prototype.setText=function(e){
DwtLabel.prototype.setText.call(this,e)
};
DwtSelect.prototype.dispose=function(){
this._selectEl=null;
this._pseudoItemsEl=null;
this._containerEl=null;
DwtButton.prototype.dispose.call(this);
if(this._internalObjectId){
DwtSelect._unassignId(this._internalObjectId)
}};
DwtSelect._assignId=function(e){
var t=DwtSelect._objectIds.length;
DwtSelect._objectIds[t]=e;
return t
};
DwtSelect._getObjectWithId=function(e){
return DwtSelect._objectIds[e]
};
DwtSelect._unassignId=function(e){
DwtSelect._objectIds[e]=null
};
DwtSelect.prototype.dynamicButtonWidth=function(){
this._pseudoItemsEl.style.display="none"
};
DwtSelect.prototype._createHtmlFromTemplate=function(a,o){
var t=DwtSelect._CONTAINER_TEMPLATE;
var e={
id:o.id,selectTemplateId:a||this.TEMPLATE,selectData:o};
DwtButton.prototype._createHtmlFromTemplate.call(this,t,e);
this._selectEl=document.getElementById(o.id+"_select_container");
this._pseudoItemsEl=document.getElementById(o.id+"_pseudoitems_container");
this._pseudoItemsEl.style.display="block";
var i=this.getHtmlElement();
this._containerEl=i;
this._selectEl.className=i.className;
i.className="ZSelectAutoSizingContainer";
i.setAttribute("style","");
if(AjxEnv.isIE){
i.style.overflow="hidden"
}};
DwtSelect.prototype._createMenu=function(){
var r=new DwtSelectMenu(this);
for(var a=0,e=this._options.size();
a<e;
++a){
var t=new DwtSelectMenuItem(r);
var o=this._options.get(a);
var n=o.getImage();
if(n){
t.setImage(n)
}
var s=o.getDisplayValue();
if(s){
t.setText(AjxStringUtil.htmlEncode(s))
}
t.setEnabled(o.enabled);
t.addSelectionListener(new AjxListener(this,this._handleOptionSelection));
t._optionIndex=a;
o.setItem(t)
}
return r
};
DwtSelect.prototype._handleOptionSelection=function(s){
var i=s.item;
var n=i._optionIndex;
var a=this._options.get(n);
var t=this.getValue();
this._setSelectedOption(a);
var e=new Object();
e.selectObj=this;
e.newValue=a.getValue();
e.oldValue=t;
var o=DwtUiEvent.getEvent(s);
o._args=e;
this.notifyListeners(DwtEvent.ONCHANGE,o)
};
DwtSelect.prototype._clearOptionSelection=function(){
if(this._currentSelectionId!=-1){
var e=DwtSelect._getObjectWithId(this._currentSelectionId);
e.deSelect()
}};
DwtSelect.prototype._setSelectedOption=function(t){
var e=t.getSelectedValue()||t.getDisplayValue();
var a=t.getImage();
if(this._selectedOption!=t){
if(e){
this.setText(AjxStringUtil.htmlEncode(e))
}
this.setImage(a);
this._selectedValue=t._value;
this._selectedOption=t
}
this._updateSelection(t);
this.autoResize()
};
DwtSelect.prototype.autoResize=function(){
var e=this.getHtmlElement();
AjxTimedAction.scheduleAction(new AjxTimedAction(this,function(){
var t=document.getElementById(e.id);
if(t){
t.style.width=t.childNodes[0].offsetWidth||"auto"
}}
,200))
};
DwtSelect.prototype._updateSelection=function(e){
var a=(this._currentSelectionId!=-1)?DwtSelect._getObjectWithId(this._currentSelectionId):null;
if(a){
a.deSelect()
}
if(e){
e.select();
this._currentSelectionId=e.getIdentifier();
var t=this.getMenu();
if(t){
t.setSelectedItem(e.getItem())
}}};
DwtSelect.prototype.updateRendering=function(){
var e=this.getScrollStyle();
this.setScrollStyle(e==Dwt.VISIBLE?Dwt.CLIP:Dwt.VISIBLE);
var t=function(){
try{
this.setScrollStyle(e)
}
catch(i){}};
var a=new AjxTimedAction(this,t);
AjxTimedAction.scheduleAction(a,4)
};
DwtSelectOptionData=function(i,a,e,t,o){
if(i==null||a==null){
return null
}
this.value=i;
this.displayValue=a;
this.isSelected=e;
this.selectedValue=t;
this.image=o
};
DwtSelectOption=function(n,o,i,t,e,s,a){
this._value=n;
this._selected=o;
this._displayValue=i;
this._image=s;
this._selectedValue=a;
this._internalObjectId=DwtSelect._assignId(this);
this.enabled=true
};
DwtSelectOption.prototype.toString=function(){
return"DwtSelectOption"
};
DwtSelectOption.prototype.setItem=function(e){
this._menuItem=e
};
DwtSelectOption.prototype.getItem=function(e){
return this._menuItem
};
DwtSelectOption.prototype.getDisplayValue=function(){
return this._displayValue
};
DwtSelectOption.prototype.getImage=function(){
return this._image
};
DwtSelectOption.prototype.getSelectedValue=function(){
return this._selectedValue
};
DwtSelectOption.prototype.getValue=function(){
return this._value
};
DwtSelectOption.prototype.setValue=function(e){
this._value=e
};
DwtSelectOption.prototype.select=function(){
this._selected=true
};
DwtSelectOption.prototype.deSelect=function(){
this._selected=false
};
DwtSelectOption.prototype.isSelected=function(){
return this._selected
};
DwtSelectOption.prototype.getIdentifier=function(){
return this._internalObjectId
};
DwtSelectMenu=function(e){
DwtMenu.call(this,{
parent:e,style:DwtMenu.DROPDOWN_STYLE,className:"DwtMenu",layout:e._layout,maxRows:e._maxRows}
)
};
DwtSelectMenu.prototype=new DwtMenu;
DwtSelectMenu.prototype.constructor=DwtSelectMenu;
DwtSelectMenu.prototype.TEMPLATE="dwt.Widgets#ZSelectMenu";
DwtSelectMenu.prototype.toString=function(){
return"DwtSelectMenu"
};
DwtSelectMenuItem=function(e){
DwtMenuItem.call(this,{
parent:e,style:DwtMenuItem.SELECT_STYLE,className:"ZSelectMenuItem"}
)
};
DwtSelectMenuItem.prototype=new DwtMenuItem;
DwtSelectMenuItem.prototype.constructor=DwtSelectMenuItem;
DwtSelectMenuItem.prototype.TEMPLATE="dwt.Widgets#ZSelectMenuItem";
DwtSelectMenuItem.prototype.toString=function(){
return"DwtSelectMenuItem"
};
