
/* Copyright (C) 2005-2009 Zimbra Inc. http://www.zimbra.com/ */
DwtSlider=function(i,e,a,t){
if(arguments.length==0){
return
}
this._orientation=e||DwtSlider.HORIZONTAL;
a=a||(this._orientation==DwtSlider.HORIZONTAL?"DwtHorizontalSlider":"DwtVerticalSlider");
DwtControl.call(this,{
parent:i,className:a,posStyle:t}
);
this._size=0;
this._buttonSize=0;
this._value=0;
this._minimum=0;
this._maximum=100;
this._isDragging=false;
DwtDragTracker.init(this,null,0,0,this._dragListener,this);
this._createHtml()
};
DwtSlider.prototype=new DwtControl;
DwtSlider.prototype.constructor=DwtSlider;
DwtSlider.HORIZONTAL=1;
DwtSlider.VERTICAL=2;
DwtSlider.prototype.toString=function(){
return"DwtSlider"
};
DwtSlider.prototype.setValue=function(o,a){
o=Math.max(this._minimum,o);
o=Math.min(this._maximum,o);
this._value=o;
var e=this._valueToLocation(o);
var i=this._orientation==DwtSlider.HORIZONTAL?"left":"top";
var t=this._getButtonElement();
t.style[i]=e;
if(a){
if(!this._changeEvent){
this._changeEvent=new DwtEvent(true);
this._changeEvent.dwtObj=this
}
this.notifyListeners(DwtEvent.ONCHANGE,this._changeEvent)
}};
DwtSlider.prototype.getValue=function(){
return this._value
};
DwtSlider.prototype.setRange=function(t,i,a,e){
if(t>=i){
throw new DwtException("Invalid slider range: ["+t+", "+i+"]")
}
this._minimum=t;
this._maximum=i;
if(typeof a=="undefined"){
a=t
}
this.setValue(a,e)
};
DwtSlider.prototype.getMinimum=function(){
return this._minimum
};
DwtSlider.prototype.getMaximum=function(){
return this._maximum
};
DwtSlider.prototype.isDragging=function(){
return this._isDragging
};
DwtSlider.prototype.addChangeListener=function(e){
this.addListener(DwtEvent.ONCHANGE,e)
};
DwtSlider.prototype._setLocation=function(e,t){
var a=this._locationToValue(e);
this.setValue(a,t)
};
DwtSlider.prototype._getLocation=function(){
return this._valueToLocation(this._value)
};
DwtSlider.prototype._valueToLocation=function(e){
if(this._orientation==DwtSlider.HORIZONTAL){
return(e-this._minimum)/(this._maximum-this._minimum)*(this._size-this._buttonSize)
}else{
return this._size-this._buttonSize-(e-this._minimum)/(this._maximum-this._minimum)*(this._size-this._buttonSize)
}};
DwtSlider.prototype._locationToValue=function(e){
if(this._orientation==DwtSlider.HORIZONTAL){
return e/(this._size-this._buttonSize)*(this._maximum-this._minimum)+this._minimum
}else{
return(this._size-this._buttonSize-e)/(this._size-this._buttonSize)*(this._maximum-this._minimum)+this._minimum
}};
DwtSlider.prototype._calculateSizes=function(){
var e=this._orientation==DwtSlider.HORIZONTAL?"x":"y";
this._buttonSize=Dwt.getSize(this._getButtonElement())[e];
this._size=Dwt.getSize(this.getHtmlElement())[e];
if(this._buttonSize>=this._size){
throw new DwtException("Invalid slider sizes")
}};
DwtSlider.prototype._getButtonElement=function(){
return document.getElementById(this._htmlElId+"_button")
};
DwtSlider.prototype._createHtml=function(){
var t=this.getHtmlElement();
var e={
id:this._htmlElId};
var a=this._orientation==DwtSlider.HORIZONTAL?"dwt.Widgets#DwtHorizontalSlider":"dwt.Widgets#DwtVerticalSlider";
t.innerHTML=AjxTemplate.expand(a,e);
this._calculateSizes()
};
DwtSlider.prototype._dragListener=function(t,h,s){
var o=this._orientation==DwtSlider.HORIZONTAL?"x":"y";
var n=this._orientation==DwtSlider.HORIZONTAL?"docX":"docY";
if(t.state==DwtDragTracker.STATE_START){
var e=Dwt.toWindow(this.getHtmlElement(),0,0);
var i=t.mouseEv[n]-e[o];
var r=this._getLocation();
if(i<r||i>(r+this._buttonSize)){
this._setLocation(i-this._buttonSize/2,true)
}
t.userData={
location:this._getLocation(),value:this._value};
this._isDragging=true;
this._moved=false
}else{
if(t.state==DwtDragTracker.STATE_END){
this._isDragging=false
}else{
if(t.state==DwtDragTracker.STATE_DRAGGING){
this._moved=true
}}
if(this._moved){
var l=t.userData.location+t.delta[o];
this._setLocation(l,true)
}}};
