
/* Copyright (C) 2005-2009 Zimbra Inc. http://www.zimbra.com/ */
DwtTreeItem=function(t){
if(arguments.length==0){
return
}
t=Dwt.getParams(arguments,DwtTreeItem.PARAMS);
var e=t.parent;
if(e instanceof DwtTree){
this._tree=e
}else{
if(e instanceof DwtTreeItem){
this._tree=e._tree
}else{
throw new DwtException("DwtTreeItem parent must be a DwtTree or DwtTreeItem",DwtException.INVALIDPARENT,"DwtTreeItem")
}}
this._origClassName=t.className||"DwtTreeItem";
this._textClassName=[this._origClassName,"Text"].join("-");
this._selectedClassName=[this._origClassName,DwtCssStyle.SELECTED].join("-");
this._selectedFocusedClassName=[this._origClassName,DwtCssStyle.SELECTED,DwtCssStyle.FOCUSED].join("-");
this._actionedClassName=[this._origClassName,DwtCssStyle.ACTIONED].join("-");
this._dragOverClassName=[this._origClassName,DwtCssStyle.DRAG_OVER].join("-");
t.deferred=(t.deferred!==false);
t.className=null;
DwtComposite.call(this,t);
this._imageInfoParam=t.imageInfo;
this._extraInfo=t.extraInfo;
this._textParam=t.text;
this._deferred=t.deferred;
this._expandNodeImage=t.expandNodeImage||"NodeExpanded";
this._collapseNodeImage=t.collapseNodeImage||"NodeCollapsed";
this._itemChecked=false;
this._initialized=false;
this._selectionEnabled=Boolean(t.selectable!==false);
this._forceNotifySelection=Boolean(t.forceNotifySelection);
this._actionEnabled=true;
this._forceNotifyAction=Boolean(t.forceNotifyAction);
this._dndScrollCallback=t.dndScrollCallback;
this._dndScrollId=t.dndScrollId;
if(this._tree.isCheckedStyle){
this.enableSelection(false);
this._selectedClassName=this._origClassName
}
if(t.singleClickAction){
this._singleClickAction=true;
this._selectedFocusedClassName=this._selectedClassName=this._textClassName;
this._hoverClassName=[this._origClassName,DwtCssStyle.HOVER].join("-")
}else{
this._hoverClassName=this._textClassName
}
if(e instanceof DwtTree||(e._initialized&&(!e._deferred||e._expanded))||!t.deferred){
this._initialize(t.index)
}else{
e._addDeferredChild(this,t.index);
this._index=t.index
}};
DwtTreeItem.PARAMS=["parent","index","text","imageInfo","deferred","className","posStyle","forceNotifySelection","forceNotifyAction"];
DwtTreeItem.prototype=new DwtComposite;
DwtTreeItem.prototype.constructor=DwtTreeItem;
DwtTreeItem.prototype.TEMPLATE="dwt.Widgets#ZTreeItem";
DwtTreeItem.prototype._checkBoxVisible=true;
DwtTreeItem._NODECELL_DIM="16px";
DwtTreeItem._processedMouseDown=false;
DwtTreeItem.prototype.dispose=function(){
this._itemDiv=null;
this._nodeCell=null;
this._checkBoxCell=null;
this._checkedImg=null;
this._checkBox=null;
this._imageCell=null;
this._textCell=null;
this._childDiv=null;
DwtComposite.prototype.dispose.call(this)
};
DwtTreeItem.prototype.toString=function(){
return"DwtTreeItem"
};
DwtTreeItem.prototype.getChecked=function(){
return this._itemChecked
};
DwtTreeItem.prototype.setChecked=function(e,t){
if((this._itemChecked!=e)||t){
this._itemChecked=e;
if(this._checkBox!=null&&(this._checkBoxCell&&Dwt.getVisible(this._checkBoxCell))){
Dwt.setVisible(this._checkedImg,e)
}}};
DwtTreeItem.prototype._handleCheckboxOnclick=function(e){
this.setChecked(!Dwt.getVisible(this._checkedImg));
e=e||window.event;
e.item=this;
this._tree._itemChecked(this,e)
};
DwtTreeItem.prototype.getExpanded=function(){
return this._expanded
};
DwtTreeItem.prototype.setExpanded=function(t,s,n){
if(t){
var r=this.parent;
while(r instanceof DwtTreeItem&&!r._expanded){
r.setExpanded(true);
r=r.parent
}
this._realizeDeferredChildren()
}
if(this.getNumChildren()){
if(t&&s){
if(!this._expanded){
this._expand(t,null,n)
}
var e=this.getChildren();
for(var o=0;
o<e.length;
o++){
if(e[o] instanceof DwtTreeItem){
e[o].setExpanded(t,s,n)
}}}else{
if(this._expanded!=t){
this._expand(t,null,n)
}}}};
DwtTreeItem.prototype.getItemCount=function(){
return this._children.size()
};
DwtTreeItem.prototype.getItems=function(){
return this._children.getArray()
};
DwtTreeItem.prototype.getChildIndex=function(e){
return this._children.indexOf(e)
};
DwtTreeItem.prototype.getImage=function(){
return this._imageInfo
};
DwtTreeItem.prototype.setImage=function(e){
if(this._initialized){
if(this._imageCell){
AjxImg.setImage(this._imageCell,e)
}
this._imageInfo=e
}else{
this._imageInfoParam=e
}};
DwtTreeItem.prototype.setDndImage=function(e){
this._dndImageInfo=e
};
DwtTreeItem.prototype.getSelected=function(){
return this._selected
};
DwtTreeItem.prototype.getActioned=function(){
return this._actioned
};
DwtTreeItem.prototype.getText=function(){
return this._text
};
DwtTreeItem.prototype.setText=function(e){
if(this._initialized){
if(!e){
e=""
}
this._text=this._textCell.innerHTML=e
}else{
this._textParam=e
}};
DwtTreeItem.prototype.setDndText=function(e){
this._dndText=e
};
DwtTreeItem.prototype.showCheckBox=function(e){
this._checkBoxVisible=e;
if(this._checkBoxCell){
Dwt.setVisible(this._checkBoxCell,e)
}};
DwtTreeItem.prototype.showExpansionIcon=function(e){
if(this._nodeCell){
Dwt.setVisible(this._nodeCell,e)
}};
DwtTreeItem.prototype.enableSelection=function(e){
this._selectionEnabled=e;
this._selectedClassName=e?this._origClassName+"-"+DwtCssStyle.SELECTED:this._origClassName
};
DwtTreeItem.prototype.enableAction=function(e){
this._actionEnabled=e
};
DwtTreeItem.prototype.addSeparator=function(e){
this._children.add((new DwtTreeItemSeparator(this)),e)
};
DwtTreeItem.prototype.setVisible=function(a,t,e){
if(t&&!e){
Dwt.setVisible(this._itemDiv,a)
}else{
if(e&&!t){
Dwt.setVisible(this._childDiv,a)
}else{
DwtComposite.prototype.setVisible.call(this,a)
}}};
DwtTreeItem.prototype.removeChild=function(t){
if(t._initialized){
this._tree._deselect(t);
if(this._childDiv){
this._childDiv.removeChild(t.getHtmlElement())
}}
this._children.remove(t);
if(this._children.size()==0){
if(this._expanded){
this._expanded=false
}
if(this._initialized&&this._nodeCell){
AjxImg.setImage(this._nodeCell,"Blank_16");
var e=AjxImg.getImageElement(this._nodeCell);
if(e){
Dwt.clearHandler(e,DwtEvent.ONMOUSEDOWN)
}}}};
DwtTreeItem.prototype.getKeyMapName=function(){
return"DwtTreeItem"
};
DwtTreeItem.prototype.handleKeyAction=function(a,n){
switch(a){
case DwtKeyMap.NEXT:var o=this._tree._getNextTreeItem(true);
if(o){
o._tree.setSelection(o,false,true)
}
break;
case DwtKeyMap.PREV:var o=this._tree._getNextTreeItem(false);
if(o){
o._tree.setSelection(o,false,true)
}
break;
case DwtKeyMap.EXPAND:if(!this._expanded){
this.setExpanded(true,false,true)
}
break;
case DwtKeyMap.COLLAPSE:if(this._expanded){
this.setExpanded(false,false,true)
}
break;
case DwtKeyMap.ACTION:var h=this.getHtmlElement();
var r=Dwt.toWindow(h,0,0);
var i=this.getSize();
var t=r.x+i.x/4;
var e=r.y+i.y/2;
this._gotMouseDownRight=true;
this._emulateSingleClick({
dwtObj:this,target:h,button:DwtMouseEvent.RIGHT,docX:t,docY:e,kbNavEvent:true}
);
break;
default:return false
}
return true
};
DwtTreeItem.prototype.addNodeIconListeners=function(){
var e=AjxImg.getImageElement(this._nodeCell);
if(e){
Dwt.setHandler(e,DwtEvent.ONMOUSEDOWN,DwtTreeItem._nodeIconMouseDownHdlr);
Dwt.setHandler(e,DwtEvent.ONMOUSEUP,DwtTreeItem._nodeIconMouseUpHdlr)
}};
DwtTreeItem.prototype._initialize=function(e,i,a){
this._checkState();
if(AjxEnv.isIE){
this._setEventHdlrs([DwtEvent.ONMOUSEENTER,DwtEvent.ONMOUSELEAVE])
}
if(AjxEnv.isSafari){
this._setEventHdlrs([DwtEvent.ONCONTEXTMENU])
}
var t={
id:this._htmlElId,divClassName:this._origClassName,isCheckedStyle:this._tree.isCheckedStyle,textClassName:this._textClassName};
this._createHtmlFromTemplate(this.TEMPLATE,t);
this.parent._addItem(this,e,i);
this._itemDiv=document.getElementById(t.id+"_div");
this._nodeCell=document.getElementById(t.id+"_nodeCell");
this._checkBoxCell=document.getElementById(t.id+"_checkboxCell");
this._checkBox=document.getElementById(t.id+"_checkbox");
this._checkedImg=document.getElementById(t.id+"_checkboxImg");
this._imageCell=document.getElementById(t.id+"_imageCell");
this._textCell=document.getElementById(t.id+"_textCell");
this._extraCell=document.getElementById(t.id+"_extraCell");
if(this._nodeCell){
this._nodeCell.style.width=this._nodeCell.style.height=DwtTreeItem._NODECELL_DIM;
if(this._children.size()>0||a){
AjxImg.setImage(this._nodeCell,this._collapseNodeImage);
this.addNodeIconListeners()
}}
if(this._extraCell){
AjxImg.setImage(this._extraCell,(this._extraInfo||"Blank_16"))
}
if(this._tree.isCheckedStyle&&this._checkBox){
this._checkBox.onclick=AjxCallback.simpleClosure(this._handleCheckboxOnclick,this);
this.showCheckBox(this._checkBoxVisible);
this.setChecked(this._tree.isCheckedByDefault,true)
}
if(this._imageCell&&this._imageInfoParam){
AjxImg.setImage(this._imageCell,this._imageInfoParam);
this._imageInfo=this._imageInfoParam
}
if(this._textCell&&this._textParam){
this._textCell.innerHTML=this._text=this._textParam
}
this._expanded=this._selected=this._actioned=false;
this._gotMouseDownLeft=this._gotMouseDownRight=false;
this._addMouseListeners();
this._initialized=true
};
DwtTreeItem.prototype.setTreeItemColor=function(i){
var n=this._htmlElId+"_table";
var a=document.getElementById(n);
var o=document.getElementById(this._htmlElId+"_div");
var t=this.getHtmlElement();
var e=this._origClassName+" "+i;
if(o){
o.className=e
}else{
if(t){
t.className=i
}}};
DwtTreeItem.prototype._addMouseListeners=function(){
var t=[DwtEvent.ONMOUSEDOWN,DwtEvent.ONMOUSEUP,DwtEvent.ONDBLCLICK];
if(AjxEnv.isIE){
t.push(DwtEvent.ONMOUSEENTER,DwtEvent.ONMOUSELEAVE)
}else{
t.push(DwtEvent.ONMOUSEOVER,DwtEvent.ONMOUSEOUT)
}
if(AjxEnv.isSafari){
t.push(DwtEvent.ONCONTEXTMENU)
}
for(var e=0;
e<t.length;
e++){
this.addListener(t[e],DwtTreeItem._listeners[t[e]])
}};
DwtTreeItem.prototype._addDeferredChild=function(a,e){
if(this._initialized&&this._children.size()==0){
if(this._nodeCell){
AjxImg.setImage(this._nodeCell,this._collapseNodeImage);
var t=AjxImg.getImageElement(this._nodeCell);
if(t){
Dwt.setHandler(t,DwtEvent.ONMOUSEDOWN,DwtTreeItem._nodeIconMouseDownHdlr);
Dwt.setHandler(t,DwtEvent.ONMOUSEUP,DwtTreeItem._nodeIconMouseUpHdlr)
}}}
this._children.add(a,e)
};
DwtTreeItem.prototype.addChild=function(e){};
DwtTreeItem.prototype._addItem=function(a,t,n){
if(!this._children.contains(a)){
this._children.add(a,t)
}
if(this._childDiv==null){
this._childDiv=document.createElement("div");
this._childDiv.className=(this.parent!=this._tree)?"DwtTreeItemChildDiv":"DwtTreeItemLevel1ChildDiv";
this.getHtmlElement().appendChild(this._childDiv);
if(!this._expanded){
this._childDiv.style.display="none"
}}
if(n&&this._nodeCell){
if(AjxImg.getImageClass(this._nodeCell)==AjxImg.getClassForImage("Blank_16")){
AjxImg.setImage(this._nodeCell,this._expanded?this._expandNodeImage:this._collapseNodeImage);
var o=AjxImg.getImageElement(this._nodeCell);
if(o){
Dwt.setHandler(o,DwtEvent.ONMOUSEDOWN,DwtTreeItem._nodeIconMouseDownHdlr)
}}}
var e=this._childDiv;
var i=e.childNodes.length;
if(t==null||t>=i||i==0){
e.appendChild(a.getHtmlElement())
}else{
e.insertBefore(a.getHtmlElement(),e.childNodes[t])
}};
DwtTreeItem.prototype.sort=function(e){
this._children.sort(e);
if(this._childDiv){
this._setChildElOrder()
}else{
this._needsSort=true
}};
DwtTreeItem.prototype._setChildElOrder=function(e){
var t=document.createDocumentFragment();
this._children.foreach(function(o,a){
t.appendChild(o.getHtmlElement());
o._index=a
}
);
this._childDiv.appendChild(t)
};
DwtTreeItem.prototype._getDragProxy=function(){
var t=document.createElement("div");
Dwt.setPosition(t,Dwt.ABSOLUTE_STYLE);
var a=document.createElement("table");
t.appendChild(a);
a.cellSpacing=a.cellPadding=0;
var o=a.insertRow(0);
var e=0;
var n=o.insertCell(e++);
n.noWrap=true;
if(this._dndImageInfo){
AjxImg.setImage(n,this._dndImageInfo)
}else{
if(this._imageInfo){
AjxImg.setImage(n,this._imageInfo)
}}
n=o.insertCell(e);
n.noWrap=true;
n.className=this._origClassName;
if(this._dndText){
n.innerHTML=this._dndText
}else{
if(this._text){
n.innerHTML=this._text
}}
this.shell.getHtmlElement().appendChild(t);
Dwt.setZIndex(t,Dwt.Z_DND);
return t
};
DwtTreeItem.prototype._dragEnter=function(){
this._preDragClassName=this._textCell.className;
this._textCell.className=this._dragOverClassName
};
DwtTreeItem.prototype._dragHover=function(){
if(this.getNumChildren()>0&&!this.getExpanded()){
this.setExpanded(true)
}};
DwtTreeItem.prototype._dragLeave=function(e){
if(this._preDragClassName){
this._textCell.className=this._preDragClassName
}};
DwtTreeItem.prototype._drop=function(){
if(this._preDragClassName){
this._textCell.className=this._preDragClassName
}};
DwtTreeItem._nodeIconMouseDownHdlr=function(t){
var a=DwtControl.getTargetControl(t);
var e=DwtShell.mouseEvent;
e.setFromDhtmlEvent(t,a);
if(e.button==DwtMouseEvent.LEFT){
a._expand(!a._expanded,e)
}else{
if(e.button==DwtMouseEvent.RIGHT){
e.dwtObj._tree._itemActioned(e.dwtObj,e)
}}
e._stopPropagation=true;
e._returnValue=false;
e.setToDhtmlEvent(t);
return false
};
DwtTreeItem._nodeIconMouseUpHdlr=function(t){
var a=DwtControl.getTargetControl(t);
var e=DwtShell.mouseEvent;
e._stopPropagation=true;
e._returnValue=false;
e.setToDhtmlEvent(t);
return false
};
DwtTreeItem.prototype._expand=function(t,a,e){
if(t!==this._expanded){
if(!t){
this._expanded=false;
this._childDiv.style.display="none";
if(this._nodeCell){
AjxImg.setImage(this._nodeCell,this._collapseNodeImage)
}
this._tree._itemCollapsed(this,a,e)
}else{
this._realizeDeferredChildren();
this._expanded=true;
if(this._childDiv&&this._childDiv.style){
this._childDiv.style.display="block"
}
if(this._nodeCell){
AjxImg.setImage(this._nodeCell,this._expandNodeImage)
}
this._tree._itemExpanded(this,a,e)
}}};
DwtTreeItem.prototype._realizeDeferredChildren=function(){
var e=this._children.getArray();
for(var t=0;
t<e.length;
t++){
var o=e[t];
if(!o._initialized){
o._initialize(o._index,true)
}else{
if(o._isSeparator&&!o.div&&this._childDiv){
var n=o.div=document.createElement("div");
n.className="vSpace";
this._childDiv.appendChild(n);
o._initialized=true
}}}
if(this._needsSort){
if(e.length){
this._setChildElOrder()
}
delete this.__needsSort
}};
DwtTreeItem.prototype._isChildOf=function(e){
var t=this.parent;
while(t&&t!=this._tree){
if(t==e){
return true
}
t=t.parent
}
return false
};
DwtTreeItem.prototype._setSelected=function(e,t){
if(this._selected!=e){
this._selected=e;
if(!this._initialized){
this._initialize()
}
if(!this._itemDiv){
return
}
if(e&&(this._selectionEnabled||this._forceNotifySelection)){
this._itemDiv.className=this._selectedClassName;
if(!t){
this.focus()
}
return true
}else{
this._itemDiv.className=this._origClassName;
return false
}}};
DwtTreeItem.prototype._setActioned=function(e){
if(this._actioned!=e){
this._actioned=e;
if(!this._initialized){
this._initialize()
}
if(!this._itemDiv){
return
}
if(e&&(this._actionEnabled||this._forceNotifyAction)&&!this._selected){
this._itemDiv.className=this._actionedClassName;
return true
}
if(!e){
if(!this._selected){
this._itemDiv.className=this._origClassName
}
return false
}}};
DwtTreeItem.prototype._focus=function(){
if(!this._itemDiv){
return
}
if(this._selectionEnabled){
this._itemDiv.className=this._selectedFocusedClassName
}};
DwtTreeItem.prototype._blur=function(){
if(!this._itemDiv){
return
}
this._itemDiv.className=this._selected?this._selectedClassName:this._origClassName
};
DwtTreeItem._mouseDownListener=function(e){
var t=e.dwtObj;
if(!t){
return false
}
if(e.target==t._childDiv){
return
}
if(e.button==DwtMouseEvent.LEFT&&(t._selectionEnabled||t._forceNotifySelection)){
t._gotMouseDownLeft=true
}else{
if(e.button==DwtMouseEvent.RIGHT&&(t._actionEnabled||t._forceNotifyAction)){
t._gotMouseDownRight=true
}}};
DwtTreeItem._mouseOutListener=function(e){
var t=e.dwtObj;
if(!t){
return false
}
if(e.target==t._childDiv){
return
}
t._gotMouseDownLeft=false;
t._gotMouseDownRight=false;
if(t._singleClickAction&&t._textCell){
t._textCell.className=t._textClassName
}};
DwtTreeItem._mouseOverListener=function(e){
var t=e.dwtObj;
if(!t){
return false
}
if(e.target==t._childDiv){
return
}
if(t._singleClickAction&&t._textCell){
t._textCell.className=t._hoverClassName
}};
DwtTreeItem._mouseUpListener=function(e){
var t=e.dwtObj;
if(!t){
return false
}
if(e.target==t._childDiv){
return
}
if(e.button==DwtMouseEvent.LEFT&&t._gotMouseDownLeft){
t._tree._itemClicked(t,e)
}else{
if(e.button==DwtMouseEvent.RIGHT&&t._gotMouseDownRight){
t._tree._itemActioned(t,e)
}}};
DwtTreeItem._doubleClickListener=function(t){
var a=t.dwtObj;
if(!a){
return false
}
if(t.target==a._childDiv){
return
}
var i=DwtControl.getTargetControl(t);
var e=DwtShell.mouseEvent;
e.setFromDhtmlEvent(t,i);
if(e.button==DwtMouseEvent.LEFT||e.button==DwtMouseEvent.NONE){
e.dwtObj._tree._itemDblClicked(e.dwtObj,e)
}};
DwtTreeItem._contextListener=function(t){
if(AjxEnv.isSafari){
var a=DwtControl.getTargetControl(t);
var e=a?a.preventContextMenu():true;
if(e){
a.notifyListeners(DwtEvent.ONMOUSEDOWN,t);
return a.notifyListeners(DwtEvent.ONMOUSEUP,t)
}}};
DwtTreeItem.prototype._emulateSingleClick=function(e){
var t=new DwtMouseEvent();
this._setMouseEvent(t,e);
t.kbNavEvent=e.kbNavEvent;
this.notifyListeners(DwtEvent.ONMOUSEUP,t)
};
DwtTreeItem._listeners={};
DwtTreeItem._listeners[DwtEvent.ONMOUSEDOWN]=new AjxListener(null,DwtTreeItem._mouseDownListener);
DwtTreeItem._listeners[DwtEvent.ONMOUSEOUT]=new AjxListener(null,DwtTreeItem._mouseOutListener);
DwtTreeItem._listeners[DwtEvent.ONMOUSELEAVE]=new AjxListener(null,DwtTreeItem._mouseOutListener);
DwtTreeItem._listeners[DwtEvent.ONMOUSEENTER]=new AjxListener(null,DwtTreeItem._mouseOverListener);
DwtTreeItem._listeners[DwtEvent.ONMOUSEOVER]=new AjxListener(null,DwtTreeItem._mouseOverListener);
DwtTreeItem._listeners[DwtEvent.ONMOUSEUP]=new AjxListener(null,DwtTreeItem._mouseUpListener);
DwtTreeItem._listeners[DwtEvent.ONDBLCLICK]=new AjxListener(null,DwtTreeItem._doubleClickListener);
DwtTreeItem._listeners[DwtEvent.ONCONTEXTMENU]=new AjxListener(null,DwtTreeItem._contextListener);
DwtTreeItemSeparator=function(e){
this.parent=e;
this._isSeparator=true;
this._initialized=true
};
DwtTreeItemSeparator.prototype.dispose=function(){
DwtComposite.prototype.removeChild.call(this.parent,this)
};
DwtTreeItemSeparator.prototype.isInitialized=function(){
return this._initialized
};
DwtTreeItemSeparator.prototype.getHtmlElement=function(){
return this.div
};
