
/* Copyright (C) 2005-2009 Zimbra Inc. http://www.zimbra.com/ */
var _MODEL_="model";
var _INSTANCE_="instance";
var _INHERIT_="inherit";
var _MODELITEM_="modelitem";
XModel=function(e){
XFG.assignUniqueId(this,"_Model_");
if(e){
for(var t in e){
this[t]=e[t]
}}
if(this.items==null){
this.items=[]
}
this._pathIndex={};
this._pathGetters={};
this._parentGetters={};
this._itemsAreInitialized=false;
this._errorMessages={};
if(this.getDeferInit()==false){
this.initializeItems()
}};
XModel.toString=function(){
return"[Class XModel]"
};
XModel.prototype.toString=function(){
return"[XModel "+this.__id+"]"
};
XModel.prototype.pathDelimiter="/";
XModel.prototype.getterScope=_INSTANCE_;
XModel.prototype.setterScope=_INSTANCE_;
XModel.prototype.deferInit=true;
XModel.prototype.getDeferInit=function(){
return this.deferInit
};
XModel.prototype.initializeItems=function(){
if(this._itemsAreInitialized){
return
}
var t=new Date().getTime();
this.__nestedItemCount=0;
this.items=this.initItemList(this.items,null);
this._itemsAreInitialized=true;
var e=new Date().getTime()
};
XModel.prototype.initItemList=function(o,e){
var t=[];
for(var a=0;
a<o.length;
a++){
t[a]=this.initItem(o[a],e)
}
this.__nestedItemCount+=o.length;
return t
};
XModel.prototype.initItem=function(t,e){
if(t.__isXModelItem){
return t
}
var a=XModelItemFactory.createItem(t,e,this);
a.initializeItems();
return a
};
XModel.prototype.addItem=function(t,e){
if(!t.__isXModelItem){
t=this.initItem(t,e)
}
if(e==null){
this.items.push(t)
}else{
e.addItem(t)
}};
XModel.prototype.indexItem=function(e,t){
this._pathIndex[t]=e
};
XModel.prototype.getItem=function(h,o){
var s=this._pathIndex[h];
if(s!=null){
return this._pathIndex[h]
}
var t=this.normalizePath(h);
for(var n=0;
n<t.length;
n++){
if(t[n].charAt(0)=="#"){
t[n]="#"
}}
s=this._pathIndex[t.join(this.pathDelimiter)];
if(s!=null){
this._pathIndex[h]=s;
return s
}
if(o!=true){
return null
}
var e=null;
for(var r=0;
r<t.length;
r++){
var a=t.slice(0,r+1).join(this.pathDelimiter);
var s=this.getItem(a,false);
if(s==null){
s=XModelItemFactory.createItem({
id:t[r]}
,e,this)
}
e=s
}
return s
};
XModel.prototype.normalizePath=function(o){
if(o.indexOf("[")>-1){
o=o.split("[").join("/#");
o=o.split("]").join("")
}
if(o.indexOf(".")>-1){
o=o.split(/[\/\.]+/);
var e=[];
for(var t=0;
t<o.length;
t++){
var a=o[t];
if(a==".."){
e.pop()
}else{
if(a!="."){
e.push(a)
}}}
return e
}
return o.split(this.pathDelimiter)
};
XModel.prototype.getParentPath=function(e){
e=this.normalizePath(e);
return e.slice(0,e.length-1)
};
XModel.prototype.getLeafPath=function(e){
e=this.normalizePath(e);
return e[e.length-1]
};
XModel.prototype.getInstanceValue=function(t,a){
var e=this._getPathGetter(a);
return e.call(this,t)
};
XModel.prototype.getParentInstanceValue=function(t,a){
var e=this._getParentPathGetter(a);
return e.call(this,t)
};
XModel.prototype.setInstanceValue=function(d,m,c){
var l=this.getParentInstanceValue(d,m);
if(l==null){
l=this.setParentInstanceValues(d,m)
}
var r=this.getItem(m,true);
var h=this.getLeafPath(m);
var o=r.ref;
if(h.charAt(0)=="#"){
o=parseInt(h.substr(1))
}
if(r.setter){
if(o.indexOf(this.pathDelimiter)>-1){
o=o.split(this.pathDelimiter).join(".")
}
var n=r.setter;
var u=r.setterScope;
if(u==_INHERIT_){
u=this.setterScope
}
if(u==_INSTANCE_){
d[n](c,l,o)
}else{
if(u==_MODEL_){
this[n](c,d,l,o)
}else{
r[n](c,d,l,o)
}}}else{
if(typeof o=="string"&&o.indexOf(this.pathDelimiter)>-1){
o=o.split(this.pathDelimiter);
for(var s=0;
s<o.length-1;
s++){
l=l[o[s]]
}
o=o.pop()
}
l[o]=c;
var t=r.getParentItem();
if(t){
var a=this.getParentPath(m).join(this.pathDelimiter);
if(t.setter){
XModel.prototype.setInstanceValue.call(this,d,a,l)
}else{
var e=new DwtXModelEvent(d,t,a,l);
t.notifyListeners(DwtEvent.XFORMS_VALUE_CHANGED,e)
}}}
var e=new DwtXModelEvent(d,r,m,c);
r.notifyListeners(DwtEvent.XFORMS_VALUE_CHANGED,e);
return c
};
XModel.prototype.setParentInstanceValues=function(e,s){
var h=this.getParentPath(s);
for(var n=0;
n<h.length;
n++){
var a=h.slice(0,n+1).join(this.pathDelimiter);
var r=this.getInstanceValue(e,a);
if(r==null){
var o=this.getItem(a,true);
var t=o.getDefaultValue();
r=this.setInstanceValue(e,a,t)
}}
return r
};
XModel.prototype.getInstanceCount=function(e,a){
var t=this.getParentInstanceValue(e,a);
if(t!=null&&t.length){
return t.length
}
return 0
};
XModel.prototype.addRowAfter=function(t,n,e){
var i=null;
var a=this.getItem(n);
if(a){
i=this.getNewListItemInstance(a)
}else{
i=""
}
var o=this.getInstanceValue(t,n);
if(o==null){
o=[]
}
o.splice(e+1,0,i);
this.setInstanceValue(t,n,o)
};
XModel.prototype.getNewListItemInstance=function(e){
var t=e.listItem;
if(t==null){
return""
}
return this.getNewInstance(t)
};
XModel.prototype.getNewInstance=function(a){
if(a.defaultValue!=null){
return a.defaultValue
}
var o=a.type;
switch(o){
case _STRING_:return"";
case _NUMBER_:return 0;
case _OBJECT_:var e={};
if(a.items){
for(var t=0;
t<a.items.length;
t++){
var n=a.items[t];
if(n.ref){
e[n.ref]=this.getNewInstance(n)
}else{
if(n.id){
e[n.id]=this.getNewInstance(n)
}}}}
return e;
case _LIST_:return[];
case _DATE_:case _TIME_:case _DATETIME_:return new Date();
default:return""
}};
XModel.prototype.removeRow=function(h,l,r){
var n=this.getInstanceValue(h,l);
if(n==null){
return
}
var e=false;
if(n instanceof String||typeof(n)=="string"){
e=true
}
var s=e?n.split(","):n;
var t=[];
var a=s.length;
for(var o=0;
o<a;
o++){
if(o!=r){
t.push(s[o])
}}
this.setInstanceValue(h,l,t)
};
XModel.prototype._getPathGetter=function(t){
var e=this._pathGetters[t];
if(e!=null){
return e
}
e=this._makePathGetter(t);
this._pathGetters[t]=e;
return e
};
XModel.prototype._getParentPathGetter=function(a){
var e=this._parentGetters[a];
if(e!=null){
return e
}
var t=this.getParentPath(a).join(this.pathDelimiter);
e=this._getPathGetter(t);
this._parentGetters[a]=e;
this._pathGetters[t]=e;
return e
};
XModel.prototype._makePathGetter=function(u){
if(u==null){
return new Function("return null")
}
var d=this.normalizePath(u);
if(d[0]==""){
d=d.slice(1)
}
var l=[];
var o="";
for(var n=0;
n<d.length;
n++){
var r=d[0,n];
if(r.charAt(0)=="#"){
r=r.substr(1);
o=o+"#"
}else{
o=o+r
}
var s=this.getItem(o,true);
var t=s.ref;
if(t.indexOf(this.pathDelimiter)>-1){
t=t.split(this.pathDelimiter).join(".")
}
if(s.getter){
var h=s.getter;
var c=s.getterScope;
if(c==_INHERIT_){
c=this.getterScope
}
if(c==_INSTANCE_){
l.push("if(instance) {");
l.push("	current = instance."+h+"(current, '"+t+"');");
l.push("}")
}else{
if(c==_MODEL_){
l.push("current = this."+h+"(instance, current, '"+t+"');")
}else{
l.push('current = this.getItem("'+o+'").'+h+"(instance, current, '"+t+"');")
}}}else{
if(t=="#"){
l.push("if(current) {");
l.push("	current = current["+r+"];");
l.push("}")
}else{
l.push("if(current) {");
l.push("	current = current."+t+";");
l.push("}")
}}
o+=this.pathDelimiter
}
var a=AjxBuffer.concat("try {\r","var current = instance;\r","\t",l.join("\r\t"),"\r","} catch (e) {\r ","	DBG.println('Error in getting path for \"",u,"\": ' + e);\r","	current = null;\r","}\r","return current;\r");
var e=new Function("instance",a);
return e
};
XModel._errorMessages={};
XModel.registerErrorMessage=XModel.prototype.registerErrorMessage=function(t,e){
this._errorMessages[t]=e
};
XModel.registerErrorMessage("unknownError","Unknown error.");
XModel.prototype.defaultErrorMessage="unknownError";
XModel.prototype.getDefaultErrorMessage=function(e){
if(e&&e.errorMessage){
return e.getDefaultErrorMessage()
}
return this.defaultErrorMessage
};
XModel.prototype.getErrorMessage=function(s,o,i,a,t,e){
var n=this._errorMessages[s];
if(n==null){
n=XModel._errorMessages[s]
}
if(n==null){
return s
}
if(o!==null){
n=n.split("{0}").join(o)
}
if(i!==null){
n=n.split("{1}").join(i)
}
if(a!==null){
n=n.split("{2}").join(a)
}
if(t!==null){
n=n.split("{3}").join(t)
}
if(e!==null){
n=n.split("{4}").join(e)
}
return n
};
