
/* Copyright (C) 2005-2009 Zimbra Inc. http://www.zimbra.com/ */
AjxDateUtil=function(){};
AjxDateUtil.YEAR=1;
AjxDateUtil.MONTH=2;
AjxDateUtil.WEEK=3;
AjxDateUtil.DAY=4;
AjxDateUtil.TWO_WEEKS=5;
AjxDateUtil.MSEC_PER_FIFTEEN_MINUTES=900000;
AjxDateUtil.MSEC_PER_HALF_HOUR=1800000;
AjxDateUtil.MSEC_PER_HOUR=3600000;
AjxDateUtil.MSEC_PER_DAY=24*AjxDateUtil.MSEC_PER_HOUR;
AjxDateUtil.WEEKDAY_SHORT=AjxDateFormat.WeekdaySegment.WEEKDAYS[AjxDateFormat.SHORT];
AjxDateUtil.WEEKDAY_MEDIUM=AjxDateFormat.WeekdaySegment.WEEKDAYS[AjxDateFormat.MEDIUM];
AjxDateUtil.WEEKDAY_LONG=AjxDateFormat.WeekdaySegment.WEEKDAYS[AjxDateFormat.LONG];
AjxDateUtil.MONTH_SHORT=AjxDateFormat.MonthSegment.MONTHS[AjxDateFormat.SHORT];
AjxDateUtil.MONTH_MEDIUM=AjxDateFormat.MonthSegment.MONTHS[AjxDateFormat.MEDIUM];
AjxDateUtil.MONTH_LONG=AjxDateFormat.MonthSegment.MONTHS[AjxDateFormat.LONG];
AjxDateUtil._daysPerMonth={
0:31,1:29,2:31,3:30,4:31,5:30,6:31,7:31,8:30,9:31,10:30,11:31};
AjxDateUtil.MAX_DAYS_PER_MONTH=31;
AjxDateUtil.WEEK_ONE_JAN_DATE=1;
AjxDateUtil._init=function(){
AjxDateUtil._dateFormat=AjxDateFormat.getDateInstance(AjxDateFormat.SHORT).clone();
var e=AjxDateUtil._dateFormat.getSegments();
for(var t=0;
t<e.length;
t++){
if(e[t] instanceof AjxDateFormat.YearSegment){
e[t]=new AjxDateFormat.YearSegment(AjxDateUtil._dateFormat,"yyyy")
}}
AjxDateUtil._dateTimeFormat=new AjxDateFormat(AjxDateUtil._dateFormat.toPattern()+" "+AjxDateFormat.getTimeInstance(AjxDateFormat.SHORT));
AjxDateUtil._dateFormatNoYear=new AjxDateFormat(AjxMsg.formatDateMediumNoYear)
};
AjxDateUtil._init();
AjxDateUtil.validDate=function(o,e,i){
var t=new Date(o,e,i);
var a=o>999?t.getFullYear():t.getYear();
return t.getMonth()==e&&t.getDate()==i&&a==o
};
AjxDateUtil.daysInMonth=function(a,e){
var t=new Date(a,e,1,12);
t.setMonth(t.getMonth()+1);
t.setDate(t.getDate()-1);
return t.getDate()
};
AjxDateUtil.isLeapYear=function(e){
return(new Date(e,1,29)).getMonth()==1
};
AjxDateUtil.isLocale24Hour=function(){
var t=AjxDateFormat.getTimeInstance(AjxDateFormat.SHORT);
var e=t._segments.length;
for(var a=0;
a<e;
a++){
if(t._segments[a]._s=="a"){
return false
}}
return true
};
AjxDateUtil.roll=function(t,a,o){
var i=t.getDate();
if(a==AjxDateUtil.MONTH){
t.setDate(1);
t.setMonth(t.getMonth()+o);
var e=AjxDateUtil.daysInMonth(t.getFullYear(),t.getMonth());
t.setDate(Math.min(i,e))
}else{
if(a==AjxDateUtil.YEAR){
t.setDate(1);
t.setFullYear(t.getFullYear()+o);
var e=AjxDateUtil.daysInMonth(t.getFullYear(),t.getMonth());
t.setDate(Math.min(i,e))
}else{
if(a==AjxDateUtil.WEEK){
t.setDate(t.getDate()+7*o)
}else{
if(a==AjxDateUtil.DAY){
t.setDate(t.getDate()+o)
}else{
if(a==AjxDateUtil.TWO_WEEKS){
t.setDate(t.getDate()+14*o)
}else{
return t
}}}}}
return t
};
AjxDateUtil.isDayShifted=function(e){
var t=new Date(e.getTime());
t.setDate(t.getDate()+1);
t.setHours(0,0,0,0);
return t.getTime()==e.getTime()
};
AjxDateUtil.rollToNextDay=function(e){
e.setHours(0,0,0,0);
e.setTime(e.getTime()+AjxDateUtil.MSEC_PER_DAY)
};
AjxDateUtil.computeDateDelta=function(e){
var t=(new Date()).getTime()-e;
var a=AjxDateUtil.computeDuration(t);
return a?(a+" "+AjxMsg.ago):null
};
AjxDateUtil.computeDuration=function(a,h){
if(a<0){
return null
}
var o=Math.floor(a/(AjxDateUtil.MSEC_PER_DAY*365));
if(o!=0){
a-=o*AjxDateUtil.MSEC_PER_DAY*365
}
var t=Math.floor(a/(AjxDateUtil.MSEC_PER_DAY*30.42));
if(t>0){
a-=Math.floor(t*AjxDateUtil.MSEC_PER_DAY*30.42)
}
var r=Math.floor(a/AjxDateUtil.MSEC_PER_DAY);
if(r>0){
a-=r*AjxDateUtil.MSEC_PER_DAY
}
var n=Math.floor(a/AjxDateUtil.MSEC_PER_HOUR);
if(n>0){
a-=n*AjxDateUtil.MSEC_PER_HOUR
}
var e=Math.floor(a/60000);
if(e>0){
a-=e*60000
}
var i=Math.floor(a/1000);
var s=h?AjxDurationFormatConcise:AjxDurationFormatVerbose;
if(o>0){
return s.formatYears(o,t)
}else{
if(t>0){
return s.formatMonths(t,r)
}else{
if(r>0){
return s.formatDays(r,n)
}else{
if(n>0){
return s.formatHours(n,e)
}else{
if(e>0){
return s.formatMinutes(e,i)
}else{
return s.formatSeconds(i)
}}}}}};
AjxDateUtil.simpleComputeDateStr=function(t,a){
var e=AjxDateUtil._dateFormat.format(t);
return a?a+e:e
};
AjxDateUtil.simpleParseDateStr=function(e){
return AjxDateUtil._dateFormat.parse(e)
};
AjxDateUtil.simpleComputeDateTimeStr=function(t,a){
var e=AjxDateUtil._dateTimeFormat.format(t);
return a?a+e:e
};
AjxDateUtil.simpleParseDateTimeStr=function(e){
return AjxDateUtil._dateTimeFormat.parse(e)
};
AjxDateUtil.longComputeDateStr=function(e){
var t=AjxDateFormat.getDateInstance(AjxDateFormat.FULL);
return t.format(e)
};
AjxDateUtil.computeDateStr=function(a,t){
if(t==null){
return""
}
var e=new Date(t);
if(a.getTime()-t<AjxDateUtil.MSEC_PER_DAY&&a.getDay()==e.getDay()){
return AjxDateUtil.computeTimeString(e)
}
if(a.getFullYear()==e.getFullYear()){
return AjxDateUtil._dateFormatNoYear.format(e)
}
return AjxDateUtil.simpleComputeDateStr(e)
};
AjxDateUtil.computeDateStrNoYear=function(e){
return AjxDateUtil._dateFormatNoYear.format(e)
};
AjxDateUtil.computeWordyDateStr=function(a,t){
if(t==null){
return""
}
var e=new Date(t);
if(a.getTime()-t<AjxDateUtil.MSEC_PER_DAY&&a.getDay()==e.getDay()){
if(!AjxDateUtil._wordyDateToday){
AjxDateUtil._wordyDateToday=new AjxDateFormat(AjxMsg.formatWordyDateToday)
}
return AjxDateUtil._wordyDateToday.format(e)
}else{
if((a.getTime()-t)<(2*AjxDateUtil.MSEC_PER_DAY)&&(a.getDay()-1)==e.getDay()){
if(!AjxDateUtil._wordyDateYesterday){
AjxDateUtil._wordyDateYesterday=new AjxDateFormat(AjxMsg.formatWordyDateYesterday)
}
return AjxDateUtil._wordyDateYesterday.format(e)
}else{
if(!AjxDateUtil._wordyDate){
AjxDateUtil._wordyDate=new AjxDateFormat(AjxMsg.formatWordyDate)
}
return AjxDateUtil._wordyDate.format(e)
}}};
AjxDateUtil.computeTimeString=function(e){
var t=AjxDateFormat.getTimeInstance(AjxDateFormat.SHORT);
return t.format(e)
};
AjxDateUtil.computeDateTimeString=function(e){
var t=AjxDateFormat.getDateTimeInstance(AjxDateFormat.LONG);
return t.format(e)
};
AjxDateUtil._getHoursStr=function(t,a,e){
var i=t.getHours();
if(!e){
i%=12;
if(i==0){
i=12
}}
return a?AjxDateUtil._pad(i):i
};
AjxDateUtil._getMinutesStr=function(e){
return AjxDateUtil._pad(e.getMinutes())
};
AjxDateUtil._getSecondsStr=function(e){
return AjxDateUtil._pad(e.getSeconds())
};
AjxDateUtil._getAMPM=function(t,a){
var e=t.getHours();
return(e<12)?(a?"AM":"am"):(a?"PM":"pm")
};
AjxDateUtil._getMonthName=function(e,t){
return t?AjxDateUtil.MONTH_MEDIUM[e.getMonth()]:AjxDateUtil.MONTH_LONG[e.getMonth()]
};
AjxDateUtil._getMonth=function(e,a){
var t=e.getMonth()+1;
if(a){
return AjxDateUtil._pad(t)
}else{
return t
}};
AjxDateUtil._getDate=function(e,t){
var a=e.getDate();
return t?AjxDateUtil._pad(a):a
};
AjxDateUtil._getWeekday=function(e){
var t=e.getDay();
return AjxDateUtil.WEEKDAY_LONG[t]
};
AjxDateUtil._getWeekdayMedium=function(e){
var t=e.getDay();
return AjxDateUtil.WEEKDAY_MEDIUM[t]
};
AjxDateUtil._getFullYear=function(e){
return e.getFullYear()
};
AjxDateUtil.getFirstDayOfWeek=function(i,e){
e=e||0;
var t=i.getDay();
var a=(t-e+7)%7;
i.setDate(i.getDate()-a);
return i
};
AjxDateUtil.getWeekNumber=function(p,l,k,b){
l=l||0;
k=k||AjxDateUtil.WEEK_ONE_JAN_DATE;
p=p||new Date();
p.setHours(12,0,0,0);
var o=p,v,r;
if(o.getDay()===l){
v=o
}else{
v=AjxDateUtil.getFirstDayOfWeek(o,l)
}
var d=v.getFullYear(),h=v.getTime();
r=new Date(v.getTime()+6*AjxDateUtil.MSEC_PER_DAY);
var e;
if(!b){
if(d!==r.getFullYear()&&r.getDate()>=k){
e=1
}else{
var n=(new Date(d,0,k));
n.setHours(12,0,0,0);
var i=AjxDateUtil.getFirstDayOfWeek(n,l);
var m=Math.round((o.getTime()-i.getTime())/AjxDateUtil.MSEC_PER_DAY);
var t=m%7;
var w=(m-t)/7;
e=w+1
}
return e
}else{
var g=new Date(p.getFullYear(),0,1);
var u=g.getDay()-1;
u=(u>=0?u:u+7);
var a=Math.floor((p.getTime()-g.getTime()-(p.getTimezoneOffset()-g.getTimezoneOffset())*60000)/AjxDateUtil.MSEC_PER_DAY)+1;
if(u<4){
e=Math.floor((a+u-1)/7)+1;
if(e>52){
var y=new Date(p.getFullYear()+1,0,1);
var f=y.getDay()-1;
f=f>=0?f:f+7;
e=f<4?1:53
}}else{
e=Math.floor((a+u-1)/7);
if(e==0){
var s=new Date(p.getFullYear()-1,0,1);
var c=s.getDay()-1;
c=(c>=0?c:c+7);
e=(c==3||(AjxDateUtil.isLeapYear(s.getFullYear())&&c==2))?53:52
}}
return e
}};
AjxDateUtil.getTimeStr=function(e,a){
var t=a;
t=t.replace(/%d/g,AjxDateUtil._getDate(e,true));
t=t.replace(/%D/g,AjxDateUtil._getDate(e,false));
t=t.replace(/%w/g,AjxDateUtil._getWeekday(e));
t=t.replace(/%M/g,AjxDateUtil._getMonthName(e));
t=t.replace(/%t/g,AjxDateUtil._getMonthName(e,true));
t=t.replace(/%n/g,AjxDateUtil._getMonth(e,true));
t=t.replace(/%Y/g,AjxDateUtil._getFullYear(e));
t=t.replace(/%h/g,AjxDateUtil._getHoursStr(e,false,false));
t=t.replace(/%H/g,AjxDateUtil._getHoursStr(e,true,false));
t=t.replace(/%m/g,AjxDateUtil._getMinutesStr(e));
t=t.replace(/%s/g,AjxDateUtil._getSecondsStr(e));
t=t.replace(/%P/g,AjxDateUtil._getAMPM(e,true));
t=t.replace(/%p/g,AjxDateUtil._getAMPM(e,false));
return t
};
AjxDateUtil.getRoundedMins=function(e,a){
var t=e.getMinutes();
if(t!=0&&a){
t=(Math.ceil((t/a)))*a
}
return t
};
AjxDateUtil.roundTimeMins=function(t,i){
var a=t.getMinutes();
var e=t.getHours();
if(a!=0&&i){
a=(Math.ceil((a/i)))*i;
if(a==60){
a=0;
e++
}
t.setMinutes(a);
t.setHours(e)
}
return t
};
AjxDateUtil.isInRange=function(i,t,a,e){
return(i<e&&t>a)
};
AjxDateUtil.getSimpleDateFormat=function(){
return AjxDateUtil._dateFormat
};
AjxDateUtil.getServerDate=function(e){
if(!AjxDateUtil._serverDateFormatter){
AjxDateUtil._serverDateFormatter=new AjxDateFormat("yyyyMMdd")
}
return AjxDateUtil._serverDateFormatter.format(e)
};
AjxDateUtil.getServerDateTime=function(t,i){
var e=t;
var a=null;
if(i){
if(!AjxDateUtil._serverDateTimeFormatterUTC){
AjxDateUtil._serverDateTimeFormatterUTC=new AjxDateFormat("yyyyMMdd'T'HHmmss'Z'")
}
a=AjxDateUtil._serverDateTimeFormatterUTC;
e=new Date(t.getTime());
e.setMinutes(e.getMinutes()+e.getTimezoneOffset())
}else{
if(!AjxDateUtil._serverDateTimeFormatter){
AjxDateUtil._serverDateTimeFormatter=new AjxDateFormat("yyyyMMdd'T'HHmmss")
}
a=AjxDateUtil._serverDateTimeFormatter
}
return a.format(e)
};
AjxDateUtil.parseServerTime=function(o,e,i){
if(o.charAt(8)=="T"){
var a=parseInt(o.substr(9,2),10);
var n=parseInt(o.substr(11,2),10);
var t=parseInt(o.substr(13,2),10);
if(!i&&o.charAt(15)=="Z"){
n+=AjxTimezone.getOffset(AjxTimezone.DEFAULT,e)
}
e.setHours(a,n,t,0)
}
return e
};
AjxDateUtil.parseISO8601Date=function(o){
var t=AjxDateUtil.__ISO8601_formats;
if(!t){
t=AjxDateUtil.__ISO8601_formats=[new AjxDateUtil.TZDFormat("yyyy-MM-dd'T'HH:mm:ss.SZ"),new AjxDateUtil.TZDFormat("yyyy-MM-dd'T'HH:mm:ssZ"),new AjxDateUtil.TZDFormat("yyyy-MM-dd'T'HH:mmZ"),new AjxDateFormat("yyyy-MM-dd"),new AjxDateFormat("yyyy-MM"),new AjxDateFormat("yyyy")]
}
for(var a=0;
a<t.length;
a++){
var e=t[a].parse(o);
if(e){
return e
}}
return null
};
AjxDateUtil.TZDFormat=function(o){
if(arguments.length==0){
return
}
AjxDateFormat.apply(this,arguments);
var e=this._segments||[];
for(var t=0;
t<e.length;
t++){
var a=e[t];
if(a instanceof AjxDateFormat.TimezoneSegment){
e[t]=new AjxDateUtil.TZDSegment(a.toSubPattern())
}}};
AjxDateUtil.TZDFormat.prototype=new AjxDateFormat;
AjxDateUtil.TZDFormat.prototype.constructor=AjxDateUtil.TZDFormat;
AjxDateUtil.TZDFormat.prototype.toString=function(){
return"TZDFormat"
};
AjxDateUtil.TZDSegment=function(e){
if(arguments.length==0){
return
}
AjxDateFormat.TimezoneSegment.apply(this,arguments)
};
AjxDateUtil.TZDSegment.prototype=new AjxDateFormat.TimezoneSegment;
AjxDateUtil.TZDSegment.prototype.constructor=AjxDateUtil.TZDSegment;
AjxDateUtil.TZDSegment.prototype.toString=function(){
return"TZDSegment"
};
AjxDateUtil.TZDSegment.prototype.parse=function(l,n,a){
var e=/^(Z)|^(\+|\-)(\d\d):(\d\d)/.exec(n.substr(a));
if(e){
var h=new Date().getTimezoneOffset();
if(e[1]){
l.timezone=h
}else{
var t=parseInt(e[3],10),r=parseInt(e[4],10);
l.timezone=t*60+r;
if(e[2]!="-"){
l.timezone*=-1
}
l.timezone-=h
}}
return a+(e?e[0].length:0)
};
AjxDateUtil.parseServerDateTime=function(a,t){
if(a==null){
return null
}
var i=new Date();
var n=parseInt(a.substr(0,4),10);
var o=parseInt(a.substr(4,2),10);
var e=parseInt(a.substr(6,2),10);
i.setFullYear(n);
i.setMonth(o-1);
i.setMonth(o-1);
i.setDate(e);
AjxDateUtil.parseServerTime(a,i,t);
return i
};
AjxDateUtil._pad=function(e){
return e<10?("0"+e):e
};
AjxDurationFormatVerbose=function(){};
AjxDurationFormatVerbose.formatYears=function(a,e){
var t=a+" ";
t+=(a>1)?AjxMsg.years:AjxMsg.year;
if(a<=3&&e>0){
t+=" "+e;
t+=" "+((e>1)?AjxMsg.months:AjxMsg.months)
}
return t
};
AjxDurationFormatVerbose.formatMonths=function(e,a){
var t=e+" ";
t+=(e>1)?AjxMsg.months:AjxMsg.month;
if(e<=3&&a>0){
t+=" "+a;
t+=" "+((a>1)?AjxMsg.days:AjxMsg.day)
}
return t
};
AjxDurationFormatVerbose.formatDays=function(a,e){
var t=a+" ";
t+=(a>1)?AjxMsg.days:AjxMsg.day;
if(a<=2&&e>0){
t+=" "+e;
t+=" "+((e>1)?AjxMsg.hours:AjxMsg.hour)
}
return t
};
AjxDurationFormatVerbose.formatHours=function(e,a){
var t=e+" ";
t+=(e>1)?AjxMsg.hours:AjxMsg.hour;
if(e<5&&a>0){
t+=" "+a;
t+=" "+((a>1)?AjxMsg.minutes:AjxMsg.minute)
}
return t
};
AjxDurationFormatVerbose.formatMinutes=function(a,t){
var e=a+" ";
e+=((a>1)?AjxMsg.minutes:AjxMsg.minute);
if(a<5&&t>0){
e+=" "+t;
e+=" "+((t>1)?AjxMsg.seconds:AjxMsg.second)
}
return e
};
AjxDurationFormatVerbose.formatSeconds=function(e){
return(e+" "+((e>1)?AjxMsg.seconds:AjxMsg.second))
};
AjxDurationFormatConcise=function(){};
AjxDurationFormatConcise.formatYears=function(t,e){
return this._format(t,e)
};
AjxDurationFormatConcise.formatMonths=function(e,t){
return this._format(e,t)
};
AjxDurationFormatConcise.formatDays=function(t,e){
return this._format(t,e)
};
AjxDurationFormatConcise.formatHours=function(e,t){
return this._format(e,t)
};
AjxDurationFormatConcise.formatMinutes=function(t,e){
return this._format(t,e)
};
AjxDurationFormatConcise.formatSeconds=function(e){
return this._format(0,e)
};
AjxDurationFormatConcise._format=function(o,t){
var n=0;
var e=[];
e[n++]=o;
e[n++]=":";
if(t<10){
e[n++]="0"
}
e[n++]=t;
return e.join("")
};
AjxDateUtil.SUNDAY=0;
AjxDateUtil.MONDAY=1;
AjxDateUtil.TUESDAY=2;
AjxDateUtil.WEDNESDAY=3;
AjxDateUtil.THURSDAY=4;
AjxDateUtil.FRIDAY=5;
AjxDateUtil.SATURDAY=6;
AjxDateUtil.getDateForNextDay=function(t,n,o){
o=o||1;
var a=new Date(t);
for(var e=0;
e<o;
e++){
a=AjxDateUtil._getDateForNextWeekday(a,n);
if(e<o-1){
a.setDate(a.getDate()+1)
}}
return a
};
AjxDateUtil.getDateForNextWorkWeekDay=function(t,o){
o=o?o:1;
var a=new Date(t);
for(var e=0;
e<o;
e++){
a=AjxDateUtil._getDateForNextWorkWeekday(a);
if(e<o-1){
a.setDate(a.getDate()+1)
}}
return a
};
AjxDateUtil.getDateForThisDay=function(e,a,t){
if(t<0){
return AjxDateUtil.getDateForPrevDay(e,a,-t)
}else{
return AjxDateUtil.getDateForNextDay(e,a,t)
}};
AjxDateUtil.getDateForThisWorkWeekDay=function(e,t){
if(t<0){
return AjxDateUtil.getDateForPrevWorkWeekDay(e,-t)
}else{
return AjxDateUtil.getDateForNextWorkWeekDay(e,t)
}};
AjxDateUtil.getDateForPrevDay=function(t,n,o){
o=o||1;
var a=new Date(t);
for(var e=0;
e<o;
e++){
a=AjxDateUtil._getDateForPrevWeekday(a,n);
if(e<o-1){
a.setDate(a.getDate()-1)
}}
return a
};
AjxDateUtil.getDateForPrevWorkWeekDay=function(t,o){
o=o||1;
var a=new Date(t);
for(var e=0;
e<o;
e++){
a=AjxDateUtil._getDateForPrevWorkWeekday(a);
if(e<o-1){
a.setDate(a.getDate()-1)
}}
return a
};
AjxDateUtil._getDateForNextWeekday=function(a,o){
var e=new Date(a);
var t=a.getDay();
if(t==o){
return e
}
var i=(o-t);
if(i>0){
e.setDate(a.getDate()+i)
}else{
e.setDate(a.getDate()+(7+i))
}
return e
};
AjxDateUtil._getDateForNextWorkWeekday=function(a){
var e=new Date(a);
var t=a.getDay();
if(t==AjxDateUtil.SUNDAY){
e.setDate(a.getDate()+1)
}else{
if(t==AjxDateUtil.SATURDAY){
e.setDate(a.getDate()+2)
}}
return e
};
AjxDateUtil._getDateForPrevWeekday=function(a,o){
var e=new Date(a);
var t=a.getDay();
if(t==o){
return e
}
var i=(t-o);
if(i>0){
e.setDate(a.getDate()-i)
}else{
e.setDate(a.getDate()-(7+i))
}
return e
};
AjxDateUtil._getDateForPrevWorkWeekday=function(a){
var e=new Date(a);
var t=a.getDay();
if(t==AjxDateUtil.SUNDAY){
e.setDate(a.getDate()-2)
}else{
if(t==AjxDateUtil.SATURDAY){
e.setDate(a.getDate()-1)
}}
return e
};
AjxDateUtil.calculate=function(u,n){
if(!AjxDateUtil.__calculate_initialized){
AjxDateUtil.__calculate_initialized=true;
AjxDateUtil.__calculate_init()
}
var e=n||new Date;
u=u.replace(/^\s*|\s*$/,"").replace(/\s*=\s*/g,"=").replace(/\s*,\s*/g,",");
var f=u.split(/\s+/g);
var g,r,o,h,d,c,p,t;
for(var l=0;
l<f.length;
l++){
g=f[l];
if(g.match(AjxDateUtil.RE_COMMENT)){
break
}
if(g.match(AjxDateUtil.RE_NOW)){
n=new Date(e.getTime());
continue
}
if(r=g.match(AjxDateUtil.RE_ADD_NUMBER)){
o=r[1];
h=AjxDateUtil.__calculate_parseInt(r[2]);
d=f[++l];
c=o=="+"?h:h*-1;
AjxDateUtil.__calculate_add(n,d,c);
continue
}
if(r=g.match(AjxDateUtil.RE_SET)){
AjxDateUtil.__calculate_set(n,r[1],r[2]);
continue
}
n=AjxDateFormat.parse("yyyyy-MM-dd",g);
if(!n&&(n=AjxDateFormat.parse("yyyy-MM-dd'T'hh:mm:ss'Z'",g))){
n.setMinutes(n.getMinutes()-n.getTimezoneOffset())
}
if(!n){
n=AjxDateFormat.parse("yyyy-MM-dd'T'HH:mm:ss",g)
}
if(!n){
throw'invalid date pattern: "'+g+'"'
}}
return n
};
AjxDateUtil.S_DAYNAME=[AjxMsg["calc.dayname.sunday"],AjxMsg["calc.dayname.monday"],AjxMsg["calc.dayname.tuesday"],AjxMsg["calc.dayname.wednesday"],AjxMsg["calc.dayname.thursday"],AjxMsg["calc.dayname.friday"],AjxMsg["calc.dayname.saturday"]].join("|");
AjxDateUtil.S_MONTHNAME=[AjxMsg["calc.monthname.january"],AjxMsg["calc.monthname.february"],AjxMsg["calc.monthname.march"],AjxMsg["calc.monthname.april"],AjxMsg["calc.monthname.may"],AjxMsg["calc.monthname.june"],AjxMsg["calc.monthname.july"],AjxMsg["calc.monthname.august"],AjxMsg["calc.monthname.september"],AjxMsg["calc.monthname.october"],AjxMsg["calc.monthname.november"],AjxMsg["calc.monthname.december"]].join("|");
AjxDateUtil.S_WEEKORD=[AjxMsg["calc.ordinal.first"],AjxMsg["calc.ordinal.second"],AjxMsg["calc.ordinal.third"],AjxMsg["calc.ordinal.fourth"],AjxMsg["calc.ordinal.fifth"],AjxMsg["calc.ordinal.last"]].join("|");
AjxDateUtil.WEEKORD_RE=[new RegExp("(first|"+AjxMsg["calc.ordinal.first"]+")","i"),new RegExp("(second|"+AjxMsg["calc.ordinal.second"]+")","i"),new RegExp("(third|"+AjxMsg["calc.ordinal.third"]+")","i"),new RegExp("(fourth|"+AjxMsg["calc.ordinal.fourth"]+")","i"),new RegExp("(last|"+AjxMsg["calc.ordinal.last"]+")","i")];
AjxMsg["calc.now"]="now";
AjxMsg["calc.date"]="date";
AjxMsg["calc.duration.year"]="year|years";
AjxMsg["calc.duration.month"]="mon|mons|month|months";
AjxMsg["calc.duration.day"]="day|days";
AjxMsg["calc.duration.hour"]="hour|hours";
AjxMsg["calc.duration.minute"]="min|mins|minute|minutes";
AjxMsg["calc.duration.week"]="week";
AjxMsg["calc.duration.second"]="sec|secs|second|seconds";
AjxMsg["calc.duration.millisecond"]="milli|millis|millisecond|milliseconds";
AjxDateUtil.S_DURATION=[AjxMsg["calc.duration.year"],AjxMsg["calc.duration.month"],AjxMsg["calc.duration.week"],AjxMsg["calc.duration.day"],AjxMsg["calc.duration.hour"],AjxMsg["calc.duration.minute"],AjxMsg["calc.duration.second"],AjxMsg["calc.duration.millisecond"]].join("|");
AjxDateUtil.__calculate_init=function(){
AjxDateUtil.WEEKDAYS={};
var t=["sunday","monday","tuesday","wednesday","thursday","friday","saturday"];
for(var o=0;
o<t.length;
o++){
var n=AjxMsg["calc.dayname."+t[o]].split("|");
for(var a=0;
a<n.length;
a++){
AjxDateUtil.WEEKDAYS[n[a].toLowerCase()]=o
}}
AjxDateUtil.MONTHNAME2MONTHNUM={};
var e=["january","february","march","april","may","june","july","august","september","october","november","december"];
for(var o=0;
o<e.length;
o++){
var s=AjxMsg["calc.monthname."+e[o]].split("|");
for(var a=0;
a<s.length;
a++){
AjxDateUtil.MONTHNAME2MONTHNUM[s[a].toLowerCase()]=o
}}
AjxDateUtil.RE_YEAR=new RegExp("^("+AjxMsg["calc.duration.year"]+")$","i");
AjxDateUtil.RE_MONTH=new RegExp("^("+AjxMsg["calc.duration.month"]+")$","i");
AjxDateUtil.RE_WEEK=new RegExp("^("+AjxMsg["calc.duration.week"]+")$","i");
AjxDateUtil.RE_DAY=new RegExp("^("+AjxMsg["calc.duration.day"]+")$","i");
AjxDateUtil.RE_HOUR=new RegExp("^("+AjxMsg["calc.duration.hour"]+")$","i");
AjxDateUtil.RE_MINUTE=new RegExp("^("+AjxMsg["calc.duration.minute"]+")$","i");
AjxDateUtil.RE_SECOND=new RegExp("^("+AjxMsg["calc.duration.second"]+")$","i");
AjxDateUtil.RE_MILLISECOND=new RegExp("^("+AjxMsg["calc.duration.millisecond"]+")$","i");
AjxDateUtil.RE_DATE=new RegExp("^("+AjxMsg["calc.date"]+")$","i");
AjxDateUtil.RE_DAYNAME=new RegExp("^("+AjxDateUtil.S_DAYNAME+")$","i");
AjxDateUtil.RE_MONTHNAME=new RegExp("^("+AjxDateUtil.S_MONTHNAME+")$","i");
AjxDateUtil.RE_WEEKORD=new RegExp("^("+AjxDateUtil.S_WEEKORD+")$","i");
AjxDateUtil.RE_COMMENT=/^#/;
AjxDateUtil.RE_NOW=new RegExp("^("+AjxMsg["calc.now"]+")$","i");
AjxDateUtil.RE_ADD_NUMBER=new RegExp("^([+\\-])(\\d+)$","i");
AjxDateUtil.RE_SET=new RegExp("^("+AjxDateUtil.S_DURATION+"|"+AjxMsg["calc.date"]+")=(.*)$","i")
};
AjxDateUtil.__calculate_normalizeFullWidthDigit=function(t){
var e="0".charCodeAt(0)+t.charCodeAt(0)-"\uff10".charCodeAt(0);
return String.fromCharCode(e)
};
AjxDateUtil.__calculate_replaceFullWidthDigit=function(e,t){
return AjxDateUtil.__calculate_normalizeFullWidthDigit(t)
};
AjxDateUtil.__calculate_parseInt=function(e){
e=e.replace(/([\uFF10-\uFF19])/g,AjxDateUtil.__calculate_normalizeFullWidthDigit);
return parseInt(e,10)
};
AjxDateUtil.__calculate_add=function(a,o,i){
if(o.match(AjxDateUtil.RE_YEAR)){
a.setFullYear(a.getFullYear()+i);
return
}
if(o.match(AjxDateUtil.RE_MONTH)){
var n=a.getMonth();
a.setMonth(n+i);
if(Math.abs(n+i)%12!=a.getMonth()){
a.setDate(0)
}
return
}
if(o.match(AjxDateUtil.RE_WEEK)){
a.setDate(a.getDate()+i*7);
return
}
if(o.match(AjxDateUtil.RE_DAY)){
a.setDate(a.getDate()+i);
return
}
if(o.match(AjxDateUtil.RE_HOUR)){
a.setHours(a.getHours()+i);
return
}
if(o.match(AjxDateUtil.RE_MINUTE)){
a.setMinutes(a.getMinutes()+i);
return
}
if(o.match(AjxDateUtil.RE_SECOND)){
a.setSeconds(a.getSeconds()+i);
return
}
if(o.match(AjxDateUtil.RE_MILLISECOND)){
a.setMilliseconds(a.getMilliseconds()+i);
return
}
if(o.match(AjxDateUtil.RE_MONTHNAME)){
var e=AjxDateUtil.MONTHNAME2MONTHNUM[o.toLowerCase()];
if(e<a.getMonth()){
i+=i>0?0:1
}else{
if(e>a.getMonth()){
i+=i>0?-1:0
}}
a.setFullYear(a.getFullYear()+i,e,1);
return
}
if(o.match(AjxDateUtil.RE_DAYNAME)){
var t=AjxDateUtil.WEEKDAYS[o.toLowerCase()];
if(t<a.getDay()){
i+=i>0?0:1
}else{
if(t>a.getDay()){
i+=i>0?-1:0
}}
a.setDate(a.getDate()+(t-a.getDay())+7*i);
return
}
throw"unknown type: "+o
};
AjxDateUtil.__calculate_add_ordinal=function(){
throw"TODO: not implemented"
};
AjxDateUtil.__calculate_set=function(i,r,l){
var n=l.split(/,/);
if(n[0].indexOf("H")==0){
n[0]=parseInt(n[0].replace("H",""))+1988
}
if(r.match(AjxDateUtil.RE_YEAR)){
n[0]=AjxDateUtil.__calculate_fullYear(n[0]);
if(n[1]!=null){
n[1]=AjxDateUtil.__calculate_month(n[1])
}
if(n[2]!=null){
n[2]=parseInt(n[2],10)
}
i.setFullYear.apply(i,n);
return
}
if(r.match(AjxDateUtil.RE_MONTH)){
n[0]=AjxDateUtil.__calculate_month(n[0]);
if(n[1]!=null){
n[1]=parseInt(n[1],10)
}
i.setMonth.apply(i,n);
return
}
if(r.match(AjxDateUtil.RE_WEEK)){
var t=AjxDateUtil.__calculate_week(n[0]);
var h=n[1]?AjxDateUtil.__calculate_day(n[1]):i.getDay();
var o;
if(t!=-1){
var e=new Date(i.getFullYear(),i.getMonth(),1,12,0,0,0);
var a=e.getDay();
var c=a-h;
o=new Date(e.getTime());
o.setDate(1-c);
if(c>0){
o.setDate(o.getDate()+7)
}
o.setDate(o.getDate()+7*t)
}else{
var s=new Date(i.getFullYear(),i.getMonth()+1,0,12,0,0,0);
o=new Date(s.getTime());
o.setDate(o.getDate()-(o.getDay()-h));
if(o.getMonth()!=s.getMonth()){
o.setDate(o.getDate()-7)
}}
if(o&&(i.getMonth()==o.getMonth())){
i.setTime(o.getTime())
}
return
}
if(r.match(AjxDateUtil.RE_DATE)){
n[0]=parseInt(n[0],10);
i.setDate.apply(i,n);
return
}
if(r.match(AjxDateUtil.RE_HOUR)){
n[0]=parseInt(n[0],10);
if(n[1]!=null){
n[1]=parseInt(n[1],10)
}
if(n[2]!=null){
n[2]=parseInt(n[2],10)
}
if(n[3]!=null){
n[3]=parseInt(n[3],10)
}
i.setHours.apply(i,n);
return
}
if(r.match(AjxDateUtil.RE_MINUTE)){
n[0]=parseInt(n[0],10);
if(n[1]!=null){
n[1]=parseInt(n[1],10)
}
if(n[2]!=null){
n[2]=parseInt(n[2],10)
}
i.setMinutes.apply(i,n);
return
}
if(r.match(AjxDateUtil.RE_SECOND)){
n[0]=parseInt(n[0],10);
if(n[1]!=null){
n[1]=parseInt(n[1],10)
}
i.setSeconds.apply(i,n);
return
}
if(r.match(AjxDateUtil.RE_MILLISECOND)){
i.setMilliseconds.apply(i,n);
return
}
throw"unknown type: "+r
};
AjxDateUtil.__calculate_fullYear=function(t){
if(t.length==2){
var a=new Date;
a.setYear(parseInt(t,10));
var e=a.getFullYear();
if(e<=AjxMsg.dateParsing2DigitStartYear){
t=String(e+100)
}else{
t=String(e).substr(0,2)+t
}}
return parseInt(t,10)
};
AjxDateUtil.__calculate_month=function(t){
var e=AjxDateUtil.MONTHNAME2MONTHNUM[t.toLowerCase()];
return e!=null?e:parseInt(t,10)-1
};
AjxDateUtil.__calculate_week=function(t){
for(var e=0;
e<AjxDateUtil.WEEKORD_RE.length;
e++){
if(t.match(AjxDateUtil.WEEKORD_RE[e])){
if(e==AjxDateUtil.WEEKORD_RE.length-1){
return -1
}
return e
}}
return 0
};
AjxDateUtil.__calculate_day=function(t){
var e=AjxDateUtil.WEEKDAYS[t.toLowerCase()];
return e!=null?e:parseInt(t,10)
};
