
/* Copyright (C) 2005-2009 Zimbra Inc. http://www.zimbra.com/ */
AjxTimezone=function(){};
AjxTimezone.convertTimezone=function(t,e,o){
if(e==o){
return t
}
var i=AjxTimezone.getOffset(o,t);
var a=AjxTimezone.getOffset(e,t);
return new Date(t.getTime()+(i-a)*60*1000)
};
AjxTimezone.getTransition=function(i,a){
var t=[a||new Date().getFullYear(),i.mon,1];
if(i.mday){
t[2]=i.mday
}else{
if(i.wkday){
var e=new Date(a,i.mon-1,1,i.hour,i.min,i.sec);
if(i.week==-1){
var n=new Date(new Date(e.getTime()).setMonth(i.mon,0));
var o=n.getDate();
var r=n.getDay()+1;
var s=r>=i.wkday?r-i.wkday:7-i.wkday-r;
t[2]=o-s
}else{
var r=e.getDay()+1;
var s=i.wkday==r?1:0;
t[2]=i.wkday+7*(i.week-s)-r+1
}}}
return t
};
AjxTimezone.createMDayTransition=function(e,a){
if(e instanceof Date){
a=a!=null?a:e.getTimezoneOffset();
e=[e.getFullYear(),e.getMonth()+1,e.getDate(),e.getHours(),e.getMinutes(),e.getSeconds()]
}
var t={
offset:a,trans:e};
return AjxTimezone.addMDayTransition(t)
};
AjxTimezone.addMDayTransition=function(t){
var e=t.trans;
t.mon=e[1];
t.mday=e[2];
t.hour=e[3];
t.min=e[4];
t.sec=e[5];
return t
};
AjxTimezone.createWkDayTransition=function(e,a){
if(e instanceof Date){
a=a!=null?a:e.getTimezoneOffset();
e=[e.getFullYear(),e.getMonth()+1,e.getDate(),e.getHours(),e.getMinutes(),e.getSeconds()]
}
var t={
offset:a,trans:e};
return AjxTimezone.addWkDayTransition(t)
};
AjxTimezone.addWkDayTransition=function(o){
var a=o.trans;
var i=a[1];
var r=a[2];
var t=Math.floor((r-1)/7);
var e=new Date(a[0],a[1]-1,a[2],12,0,0);
var s=new Date(new Date(e.getTime()).setMonth(i-1,0)).getDate();
var n=s-r<7;
o.mon=i;
o.week=n?-1:t+1;
o.wkday=e.getDay()+1;
o.hour=a[3];
o.min=a[4];
o.sec=a[5];
return o
};
AjxTimezone.createTransitionDate=function(o){
var e=new Date(AjxTimezoneData.TRANSITION_YEAR,o.mon-1,1,12,0,0);
if(o.mday){
e.setDate(o.mday)
}else{
if(o.week==-1){
e.setMonth(e.getMonth()+1,0);
for(var a=0;
a<7;
a++){
if(e.getDay()+1==o.wkday){
break
}
e.setDate(e.getDate()-1)
}}else{
for(var a=0;
a<7;
a++){
if(e.getDay()+1==o.wkday){
break
}
e.setDate(e.getDate()+1)
}
e.setDate(e.getDate()+7*(o.week-1))
}}
var t=[e.getFullYear(),e.getMonth()+1,e.getDate()];
return t
};
AjxTimezone.getZonePreferences=function(){
if(AjxTimezone._PREF_ZONE_DISPLAY){
var a=AjxTimezone._PREF_ZONE_DISPLAY.length;
var t=AjxTimezone.STANDARD_RULES.length+AjxTimezone.DAYLIGHT_RULES.length;
if(a!=t){
AjxTimezone._PREF_ZONE_DISPLAY=null
}}
if(!AjxTimezone._PREF_ZONE_DISPLAY){
AjxTimezone._PREF_ZONE_DISPLAY=[];
AjxTimezone.getAbbreviatedZoneChoices();
for(var e=0;
e<AjxTimezone._ABBR_ZONE_OPTIONS.length;
e++){
AjxTimezone._PREF_ZONE_DISPLAY.push(AjxTimezone._ABBR_ZONE_OPTIONS[e].displayValue)
}}
return AjxTimezone._PREF_ZONE_DISPLAY
};
AjxTimezone.getZonePreferencesOptions=function(){
if(AjxTimezone._PREF_ZONE_OPTIONS){
var a=AjxTimezone._PREF_ZONE_OPTIONS.length;
var t=AjxTimezone.STANDARD_RULES.length+AjxTimezone.DAYLIGHT_RULES.length;
if(a!=t){
AjxTimezone._PREF_ZONE_OPTIONS=null
}}
if(!AjxTimezone._PREF_ZONE_OPTIONS){
AjxTimezone._PREF_ZONE_OPTIONS=[];
AjxTimezone.getAbbreviatedZoneChoices();
for(var e=0;
e<AjxTimezone._ABBR_ZONE_OPTIONS.length;
e++){
AjxTimezone._PREF_ZONE_OPTIONS.push(AjxTimezone._ABBR_ZONE_OPTIONS[e].value)
}}
return AjxTimezone._PREF_ZONE_OPTIONS
};
AjxTimezone.getServerId=function(e){
return AjxTimezone._CLIENT2SERVER[e]||e
};
AjxTimezone.getClientId=function(e){
return AjxTimezone._SERVER2CLIENT[e]||e
};
AjxTimezone.getShortName=function(t){
var a=AjxTimezone.getRule(t);
if(a&&a.shortName){
return a.shortName
}
var e=["GMT",AjxTimezone._SHORT_NAMES[t]].join("");
if(a){
a.shortName=e
}
return e
};
AjxTimezone.getMediumName=function(e){
var a=AjxTimezone.getRule(e);
if(a&&a.mediumName){
return a.mediumName
}
var t=AjxMsg[e]||["(",AjxTimezone.getShortName(e),") ",e].join("");
if(a){
a.mediumName=t
}
return t
};
AjxTimezone.getLongName=AjxTimezone.getMediumName;
AjxTimezone.addRule=function(a){
var t=a.serverId;
var e=a.clientId;
AjxTimezone._CLIENT2SERVER[e]=t;
AjxTimezone._SERVER2CLIENT[t]=e;
AjxTimezone._SHORT_NAMES[e]=AjxTimezone._generateShortName(a.standard.offset);
AjxTimezone._CLIENT2RULE[e]=a;
var i=a.daylight?AjxTimezone.DAYLIGHT_RULES:AjxTimezone.STANDARD_RULES;
i.push(a)
};
AjxTimezone.getRule=function(e,o){
var c=AjxTimezone._CLIENT2RULE[e];
if(!c){
e=AjxTimezone._SERVER2CLIENT[e];
c=AjxTimezone._CLIENT2RULE[e]
}
if(!c&&o){
var l=["standard","daylight"];
var d=o.daylight?AjxTimezone.DAYLIGHT_RULES:AjxTimezone.STANDARD_RULES;
for(var s=0;
s<d.length;
s++){
c=d[s];
var u=true;
for(var n=0;
n<l.length;
n++){
var t=l[n];
var r=c[t];
if(!r){
continue
}
var h=false;
for(var a in o[t]){
if(o[t][a]!=r[a]){
u=false;
h=true;
break
}}
if(h){
break
}}
if(u){
return c
}}
return null
}
return c
};
AjxTimezone.getOffset=function(e,o){
var u=AjxTimezone.getRule(e||AjxTimezone.DEFAULT);
if(u&&u.daylight){
var c=o.getFullYear();
var s=u.standard,t=u.daylight;
var l=AjxTimezone.getTransition(s,c);
var f=AjxTimezone.getTransition(t,c);
var h=o.getMonth()+1,d=o.getDate();
var n=l[1],m=l[2];
var r=f[1],i=f[2];
var a=false;
if(r<n){
a=h>r&&h<n;
a=a||(h==r&&d>=i);
a=a||(h==n&&d<m)
}else{
a=h<n||h>r;
a=a||(h==r&&d>=i);
a=a||(h==n&&d<m)
}
return a?t.offset:s.offset
}
return u?u.standard.offset:-(new Date().getTimezoneOffset())
};
AjxTimezone.guessMachineTimezone=function(){
return AjxTimezone._guessMachineTimezone().clientId
};
AjxTimezone.getAbbreviatedZoneChoices=function(){
if(AjxTimezone._ABBR_ZONE_OPTIONS){
var o=AjxTimezone._ABBR_ZONE_OPTIONS.length;
var i=AjxTimezone.STANDARD_RULES.length+AjxTimezone.DAYLIGHT_RULES.length;
if(o!=i){
AjxTimezone._ABBR_ZONE_OPTIONS=null
}}
if(!AjxTimezone._ABBR_ZONE_OPTIONS){
AjxTimezone._ABBR_ZONE_OPTIONS=[];
for(var e in AjxTimezone._CLIENT2SERVER){
var n=AjxTimezone._CLIENT2RULE[e];
var t=n.serverId;
var a={
displayValue:AjxTimezone.getMediumName(e),value:t,standard:n.standard,serverId:t,clientId:e};
AjxTimezone._ABBR_ZONE_OPTIONS.push(a)
}
AjxTimezone._ABBR_ZONE_OPTIONS.sort(AjxTimezone._BY_OFFSET)
}
return AjxTimezone._ABBR_ZONE_OPTIONS
};
AjxTimezone.getMatchingTimezoneChoices=function(){
if(AjxTimezone._MATCHING_ZONE_OPTIONS){
var s=AjxTimezone._MATCHING_ZONE_OPTIONS.length;
var n=AjxTimezone.STANDARD_RULES.length+AjxTimezone.DAYLIGHT_RULES.length;
if(s!=n){
AjxTimezone._MATCHING_ZONE_OPTIONS=null
}}
if(!AjxTimezone._MATCHING_ZONE_OPTIONS){
AjxTimezone._MATCHING_ZONE_OPTIONS=[];
for(var a in AjxTimezone.MATCHING_RULES){
var r=AjxTimezone.MATCHING_RULES[a];
var e=r.clientId;
var t=r.serverId;
if(e==AjxTimezone.AUTO_DETECTED){
continue
}
var o={
displayValue:AjxTimezone.getMediumName(e),value:t,standard:r.standard,serverId:t,clientId:e};
AjxTimezone._MATCHING_ZONE_OPTIONS.push(o)
}
AjxTimezone._MATCHING_ZONE_OPTIONS.sort(AjxTimezone._BY_OFFSET)
}
return AjxTimezone._MATCHING_ZONE_OPTIONS
};
AjxTimezone._BY_OFFSET=function(a,t){
var o=a.standard.offset-t.standard.offset;
if(o==0){
var e=a.serverId;
var i=t.serverId;
if(e<i){
o=-1
}else{
if(e>i){
o=1
}}}
return o
};
AjxTimezone.GMT="Europe/London";
AjxTimezone.GMT_NO_DST="UTC";
AjxTimezone.AUTO_DETECTED="Auto-Detected";
AjxTimezone.DEFAULT;
AjxTimezone.DEFAULT_RULE;
AjxTimezone._CLIENT2SERVER={};
AjxTimezone._SERVER2CLIENT={};
AjxTimezone._SHORT_NAMES={};
AjxTimezone._CLIENT2RULE={};
AjxTimezone.STANDARD_RULES=[];
AjxTimezone.DAYLIGHT_RULES=[];
(function(){
for(var e=0;
e<AjxTimezoneData.TIMEZONE_RULES.length;
e++){
var t=AjxTimezoneData.TIMEZONE_RULES[e];
var a=t.daylight?AjxTimezone.DAYLIGHT_RULES:AjxTimezone.STANDARD_RULES;
a.push(t)
}}
)();
AjxTimezone._guessMachineTimezone=function(f){
var u=new Date(AjxTimezoneData.TRANSITION_YEAR,11,1,0,0,0);
var w=new Date(AjxTimezoneData.TRANSITION_YEAR,5,1,0,0,0);
var t=-u.getTimezoneOffset();
var g=-w.getTimezoneOffset();
AjxTimezone.MATCHING_RULES=[];
AjxTimezone.TIMEZONE_CONFLICT=false;
var c=[];
var s={};
var r=[];
var p=false;
if(g==t){
var m=AjxTimezone.STANDARD_RULES;
for(var y=0;
y<m.length;
++y){
var h=m[y];
if(h.standard.offset==g){
if(!s[h.serverId]){
c.push(h);
s[h.serverId]=true
}
AjxTimezone.MATCHING_RULES.push(h)
}}}else{
var m=AjxTimezone.DAYLIGHT_RULES;
var x=Math.max(t,g);
var v=Math.min(t,g);
var o=new Date();
var b=-o.getTimezoneOffset();
for(var y=0;
y<m.length;
++y){
var h=m[y];
if(h.standard.offset==v&&h.daylight.offset==x){
var l=h.standard.trans;
var d=h.daylight.trans;
var n=new Date(l[0],l[1]-1,l[2]-1);
var a=new Date(l[0],l[1]-1,l[2]+2);
var e=new Date(d[0],d[1]-1,d[2]-1);
var k=new Date(d[0],d[1]-1,d[2]+2);
if(-a.getTimezoneOffset()==v&&-k.getTimezoneOffset()==x&&-n.getTimezoneOffset()==x&&-e.getTimezoneOffset()==v){
if(!s[h.serverId]){
c.push(h);
s[h.serverId]=true
}
p=true
}}
if(h.standard.offset==b||h.daylight.offset==b){
AjxTimezone.MATCHING_RULES.push(h)
}}}
if((c.length>0)&&f!=null){
var m=c;
for(var y in m){
if(m[y].serverId==f){
return m[y]
}}}
if(c.length>0){
if(c.length>1){
c.sort(AjxTimezone.__BY_SCORE);
if(c[0].score!=c[1].score){
c.length=1
}}
AjxTimezone.TIMEZONE_CONFLICT=(c.length>1);
return c[0]
}
if((AjxTimezone.MATCHING_RULES.length>0)&&f!=null){
var m=AjxTimezone.MATCHING_RULES;
for(var y in m){
if(m[y].serverId==f){
return m[y]
}}}
return AjxTimezone._generateDefaultRule()
};
AjxTimezone.__BY_SCORE=function(t,e){
return e.score-t.score
};
AjxTimezone._generateDefaultRule=function(){
var l=0;
var a=1;
var i=2;
var s=3;
var o=4;
function c(m,u,w,v){
var p=u.getTime();
var b=new Date();
b.setTime(m.getTime());
var y=new Date();
y.setTime(b.getTime());
var k=m.getTimezoneOffset()*-1;
if(!v){
v={
clientId:AjxTimezone.AUTO_DETECTED,autoDetected:true}
}
while(b.getTime()<=p){
if(w==l){
b.setUTCMonth(b.getUTCMonth()+1)
}else{
if(w==a){
b.setUTCDate(b.getUTCDate()+1)
}else{
if(w==i){
b.setUTCHours(b.getUTCHours()+1)
}else{
if(w==s){
b.setUTCMinutes(b.getUTCMinutes()+1)
}else{
if(w==o){
b.setUTCSeconds(b.getUTCSeconds()+1)
}else{
return v
}}}}}
var f=b.getTimezoneOffset()*-1;
if(f!=k){
if(w<o){
v=c(y,b,w+1,v)
}else{
var x=new Date();
x.setUTCFullYear(y.getFullYear(),y.getMonth(),y.getDate());
x.setUTCHours(y.getHours(),y.getMinutes(),y.getSeconds()+1);
var g=v[k<f?"daylight":"standard"]={
offset:f,trans:[x.getUTCFullYear(),x.getUTCMonth()+1,x.getUTCDate(),x.getUTCHours(),x.getUTCMinutes(),x.getUTCSeconds()]};
AjxTimezone.addWkDayTransition(g);
return v
}}
y.setTime(b.getTime());
k=f
}
return v
}
var t=new Date();
var e=new Date();
var r=t.getFullYear();
t.setUTCFullYear(r,t.getMonth(),t.getDate()-1);
t.setUTCHours(0,0,0,0);
e.setTime(t.getTime());
e.setUTCFullYear(r+1,t.getMonth(),t.getDate()+1);
var h=c(t,e,l);
if(!h.daylight||!h.standard){
h.standard={
offset:t.getTimezoneOffset()*-1};
delete h.daylight
}
h.serverId=["(GMT",AjxTimezone._generateShortName(h.standard.offset,true),") ",AjxTimezone.AUTO_DETECTED].join("");
if(h.daylight&&h.daylight.offset<h.standard.offset){
var n=h.daylight;
h.daylight=h.standard;
h.standard=n
}
return h
};
AjxTimezone._generateShortName=function(n,o){
if(n==0){
return""
}
var t=n<0?"-":"+";
var a=Math.abs(n);
var e=Math.floor(a/60);
var i=a%60;
e=e<10?"0"+e:e;
i=i<10?"0"+i:i;
return[t,e,o?".":"",i].join("")
};
AjxTimezone.DEFAULT_RULE=AjxTimezone._guessMachineTimezone();
(function(){
AjxTimezoneData.TIMEZONE_RULES.sort(AjxTimezone._BY_OFFSET);
for(var e=0;
e<AjxTimezoneData.TIMEZONE_RULES.length;
e++){
var t=AjxTimezoneData.TIMEZONE_RULES[e];
AjxTimezone.addRule(t)
}}
)();
AjxTimezone.DEFAULT=AjxTimezone.getClientId(AjxTimezone.DEFAULT_RULE.serverId);
