
/* Copyright (C) 2005-2009 Zimbra Inc. http://www.zimbra.com/ */
AjxVector=function(){
this._array=new Array()
};
AjxVector.prototype.toString=function(n,t){
if(t!==true){
return this._array.join(n)
}
var o=new Array();
for(var s=0;
s<this._array.length;
s++){
var e=this._array[s];
if(e!=undefined&&e!=null&&e!=""){
o.push(e)
}}
return o.join(n)
};
AjxVector.fromArray=function(t){
var e=new AjxVector();
e._array.length=0;
if(AjxUtil.isArray1(t)){
e._array=t
}
return e
};
AjxVector.prototype.size=function(){
return this._array.length
};
AjxVector.prototype.add=function(a,e,t){
if(t&&this.contains(a)){
return
}
AjxUtil.arrayAdd(this._array,a,e)
};
AjxVector.prototype.addList=function(a){
if(!a){
return
}
if(a.length){
this._array=this._array.concat(a)
}else{
if(a.size&&a.size()){
if(AjxEnv.isIE&&(!(a._array instanceof Array))){
var t=[];
for(var e=0;
e<a._array.length;
e++){
t.push(a._array[e])
}
a._array=t
}
this._array=this._array.concat(a._array)
}}};
AjxVector.prototype.remove=function(e){
return AjxUtil.arrayRemove(this._array,e)
};
AjxVector.prototype.removeAt=function(t){
if(t>=this._array.length||t<0){
return null
}
var a=this._array.splice(t,1);
var e=null;
if(a){
e=a[0]
}
return e
};
AjxVector.prototype.removeAll=function(){
for(var e=0;
e<this._array.length;
e++){
this._array[e]=null
}
this._array.length=0
};
AjxVector.prototype.removeLast=function(){
return this._array.length>0?this._array.pop():null
};
AjxVector.prototype.reverse=function(){
this._array.reverse()
};
AjxVector.prototype.replace=function(a,t){
var e=this._array[a];
this._array[a]=t;
return e
};
AjxVector.prototype.replaceObject=function(a,e){
for(var t=0;
t<this._array.length;
t++){
if(this._array[t]==a){
this._array[t]=e;
return a
}}
return null
};
AjxVector.prototype.indexOf=function(t){
if(t==null){
return -1
}
for(var e=0;
e<this._array.length;
e++){
if(this._array[e]==t){
return e
}}
return -1
};
AjxVector.prototype.indexOfLike=function(o,a){
var t=a.call(o);
for(var e=0;
e<this._array.length;
e++){
var n=a.call(this._array[e]);
if(n==t){
return e
}}
return -1
};
AjxVector.prototype.clone=function(){
var e=new AjxVector();
e.addList(this);
return e
};
AjxVector.prototype.contains=function(t){
for(var e=0;
e<this._array.length;
e++){
if(this._array[e]==t){
return true
}}
return false
};
AjxVector.prototype.containsLike=function(o,a){
var t=a.call(o);
for(var e=0;
e<this._array.length;
e++){
var n=a.call(this._array[e]);
if(n==t){
return true
}}
return false
};
AjxVector.prototype.get=function(e){
return e>=this._array.length||e<0?null:this._array[e]
};
AjxVector.prototype.getArray=function(){
return this._array
};
AjxVector.prototype.getLast=function(){
return this._array.length==0?null:this._array[this._array.length-1]
};
AjxVector.prototype.getNext=function(t){
var e=this.indexOf(t);
if(e==-1){
return null
}
return this.get(++e)
};
AjxVector.prototype.getPrev=function(t){
var e=this.indexOf(t);
if(e==-1){
return null
}
return this.get(--e)
};
AjxVector.prototype.sort=function(e){
if(!e){
e=AjxVector._defaultArrayComparator
}
this._array.sort(e)
};
AjxVector.prototype.binarySearch=function(s,r){
if(!r){
r=AjxVector._defaultArrayComparator
}
var a=0;
var e=this._array;
var o=e.length-1;
while(true){
if(o<a){
return -1
}
var n=Math.floor((a+o)/2);
var t=r(s,e[n]);
if(t<0){
o=n-1
}else{
if(t>0){
a=n+1
}else{
return n
}}}};
AjxVector.prototype.merge=function(n,o){
if(n<0){
return
}
var s=o instanceof AjxVector?o.getArray():o;
var e=this._array.length<(n+s.length)?this._array.length:n+s.length;
if(n<this._array.length){
var a=0;
for(var t=n;
t<e;
t++){
this._array[t]=s[a++]
}
if(a<s.length){
this._array=this._array.concat(s.slice(a))
}}else{
this._array=this._array.concat(s)
}};
AjxVector._defaultArrayComparator=function(t,e){
return t<e?-1:(t>e?1:0)
};
AjxVector.prototype.foreach=function(o,n){
var e=this.size(),t=0,a;
if(typeof o=="function"){
while(--e>=0){
o.call(n,this.get(t),t++)
}}else{
while(--e>=0){
a=this.get(t++);
if(a!=null){
a[o].call(a)
}}}};
AjxVector.prototype.map=function(n,s){
var e=[],t=this.size(),o;
if(typeof n=="function"){
while(--t>=0){
e[t]=n.call(s,this.get(t),t)
}}else{
if(n instanceof AjxCallback){
while(--t>=0){
e[t]=n.run(this.get(t),t)
}}else{
while(--t>=0){
o=this.get(t);
if(o!=null){
if(typeof o[n]=="function"){
e.unshift(o[n].call(o))
}else{
e.unshift(o[n])
}}}}}
return AjxVector.fromArray(e)
};
AjxVector.prototype.join=function(e){
return this._array.join(e)
};
AjxVector.prototype.sub=function(s,r){
var t=[],e=this.size(),o=0,n;
while(--e>=0){
n=this.get(o++);
if(!s.call(r,n,o)){
t.push(n)
}}
return AjxVector.fromArray(t)
};
AjxVector.prototype.slice=function(t,e){
return AjxVector.fromArray(this._array.slice(t,e))
};
