
/* Copyright (C) 2005-2009 Zimbra Inc. http://www.zimbra.com/ */
tinyMCEPopup.requireLangPack();
var defaultFonts="Arial, Helvetica, sans-serif=Arial, Helvetica, sans-serif;Times New Roman, Times, serif=Times New Roman, Times, serif;Courier New, Courier, mono=Courier New, Courier, mono;Times New Roman, Times, serif=Times New Roman, Times, serif;Georgia, Times New Roman, Times, serif=Georgia, Times New Roman, Times, serif;Verdana, Arial, Helvetica, sans-serif=Verdana, Arial, Helvetica, sans-serif;Geneva, Arial, Helvetica, sans-serif=Geneva, Arial, Helvetica, sans-serif";
var defaultSizes="9;10;12;14;16;18;24;xx-small;x-small;small;medium;large;x-large;xx-large;smaller;larger";
var defaultMeasurement="+pixels=px;points=pt;inches=in;centimetres=cm;millimetres=mm;picas=pc;ems=em;exs=ex;%";
var defaultSpacingMeasurement="pixels=px;points=pt;inches=in;centimetres=cm;millimetres=mm;picas=pc;+ems=em;exs=ex;%";
var defaultIndentMeasurement="pixels=px;+points=pt;inches=in;centimetres=cm;millimetres=mm;picas=pc;ems=em;exs=ex;%";
var defaultWeight="normal;bold;bolder;lighter;100;200;300;400;500;600;700;800;900";
var defaultTextStyle="normal;italic;oblique";
var defaultVariant="normal;small-caps";
var defaultLineHeight="normal";
var defaultAttachment="fixed;scroll";
var defaultRepeat="no-repeat;repeat;repeat-x;repeat-y";
var defaultPosH="left;center;right";
var defaultPosV="top;center;bottom";
var defaultVAlign="baseline;sub;super;top;text-top;middle;bottom;text-bottom";
var defaultDisplay="inline;block;list-item;run-in;compact;marker;table;inline-table;table-row-group;table-header-group;table-footer-group;table-row;table-column-group;table-column;table-cell;table-caption;none";
var defaultBorderStyle="none;solid;dashed;dotted;double;groove;ridge;inset;outset";
var defaultBorderWidth="thin;medium;thick";
var defaultListType="disc;circle;square;decimal;lower-roman;upper-roman;lower-alpha;upper-alpha;none";
function init(){
var t=document.getElementById("container"),e;
t.style.cssText=tinyMCEPopup.getWindowArg("style_text");
e=getBrowserHTML("background_image_browser","background_image","image","advimage");
document.getElementById("background_image_browser").innerHTML=e;
document.getElementById("text_color_pickcontainer").innerHTML=getColorPickerHTML("text_color_pick","text_color");
document.getElementById("background_color_pickcontainer").innerHTML=getColorPickerHTML("background_color_pick","background_color");
document.getElementById("border_color_top_pickcontainer").innerHTML=getColorPickerHTML("border_color_top_pick","border_color_top");
document.getElementById("border_color_right_pickcontainer").innerHTML=getColorPickerHTML("border_color_right_pick","border_color_right");
document.getElementById("border_color_bottom_pickcontainer").innerHTML=getColorPickerHTML("border_color_bottom_pick","border_color_bottom");
document.getElementById("border_color_left_pickcontainer").innerHTML=getColorPickerHTML("border_color_left_pick","border_color_left");
fillSelect(0,"text_font","style_font",defaultFonts,";",true);
fillSelect(0,"text_size","style_font_size",defaultSizes,";",true);
fillSelect(0,"text_size_measurement","style_font_size_measurement",defaultMeasurement,";",true);
fillSelect(0,"text_case","style_text_case","capitalize;uppercase;lowercase",";",true);
fillSelect(0,"text_weight","style_font_weight",defaultWeight,";",true);
fillSelect(0,"text_style","style_font_style",defaultTextStyle,";",true);
fillSelect(0,"text_variant","style_font_variant",defaultVariant,";",true);
fillSelect(0,"text_lineheight","style_font_line_height",defaultLineHeight,";",true);
fillSelect(0,"text_lineheight_measurement","style_font_line_height_measurement",defaultMeasurement,";",true);
fillSelect(0,"background_attachment","style_background_attachment",defaultAttachment,";",true);
fillSelect(0,"background_repeat","style_background_repeat",defaultRepeat,";",true);
fillSelect(0,"background_hpos_measurement","style_background_hpos_measurement",defaultMeasurement,";",true);
fillSelect(0,"background_vpos_measurement","style_background_vpos_measurement",defaultMeasurement,";",true);
fillSelect(0,"background_hpos","style_background_hpos",defaultPosH,";",true);
fillSelect(0,"background_vpos","style_background_vpos",defaultPosV,";",true);
fillSelect(0,"block_wordspacing","style_wordspacing","normal",";",true);
fillSelect(0,"block_wordspacing_measurement","style_wordspacing_measurement",defaultSpacingMeasurement,";",true);
fillSelect(0,"block_letterspacing","style_letterspacing","normal",";",true);
fillSelect(0,"block_letterspacing_measurement","style_letterspacing_measurement",defaultSpacingMeasurement,";",true);
fillSelect(0,"block_vertical_alignment","style_vertical_alignment",defaultVAlign,";",true);
fillSelect(0,"block_text_align","style_text_align","left;right;center;justify",";",true);
fillSelect(0,"block_whitespace","style_whitespace","normal;pre;nowrap",";",true);
fillSelect(0,"block_display","style_display",defaultDisplay,";",true);
fillSelect(0,"block_text_indent_measurement","style_text_indent_measurement",defaultIndentMeasurement,";",true);
fillSelect(0,"box_width_measurement","style_box_width_measurement",defaultMeasurement,";",true);
fillSelect(0,"box_height_measurement","style_box_height_measurement",defaultMeasurement,";",true);
fillSelect(0,"box_float","style_float","left;right;none",";",true);
fillSelect(0,"box_clear","style_clear","left;right;both;none",";",true);
fillSelect(0,"box_padding_left_measurement","style_padding_left_measurement",defaultMeasurement,";",true);
fillSelect(0,"box_padding_top_measurement","style_padding_top_measurement",defaultMeasurement,";",true);
fillSelect(0,"box_padding_bottom_measurement","style_padding_bottom_measurement",defaultMeasurement,";",true);
fillSelect(0,"box_padding_right_measurement","style_padding_right_measurement",defaultMeasurement,";",true);
fillSelect(0,"box_margin_left_measurement","style_margin_left_measurement",defaultMeasurement,";",true);
fillSelect(0,"box_margin_top_measurement","style_margin_top_measurement",defaultMeasurement,";",true);
fillSelect(0,"box_margin_bottom_measurement","style_margin_bottom_measurement",defaultMeasurement,";",true);
fillSelect(0,"box_margin_right_measurement","style_margin_right_measurement",defaultMeasurement,";",true);
fillSelect(0,"border_style_top","style_border_style_top",defaultBorderStyle,";",true);
fillSelect(0,"border_style_right","style_border_style_right",defaultBorderStyle,";",true);
fillSelect(0,"border_style_bottom","style_border_style_bottom",defaultBorderStyle,";",true);
fillSelect(0,"border_style_left","style_border_style_left",defaultBorderStyle,";",true);
fillSelect(0,"border_width_top","style_border_width_top",defaultBorderWidth,";",true);
fillSelect(0,"border_width_right","style_border_width_right",defaultBorderWidth,";",true);
fillSelect(0,"border_width_bottom","style_border_width_bottom",defaultBorderWidth,";",true);
fillSelect(0,"border_width_left","style_border_width_left",defaultBorderWidth,";",true);
fillSelect(0,"border_width_top_measurement","style_border_width_top_measurement",defaultMeasurement,";",true);
fillSelect(0,"border_width_right_measurement","style_border_width_right_measurement",defaultMeasurement,";",true);
fillSelect(0,"border_width_bottom_measurement","style_border_width_bottom_measurement",defaultMeasurement,";",true);
fillSelect(0,"border_width_left_measurement","style_border_width_left_measurement",defaultMeasurement,";",true);
fillSelect(0,"list_type","style_list_type",defaultListType,";",true);
fillSelect(0,"list_position","style_list_position","inside;outside",";",true);
fillSelect(0,"positioning_type","style_positioning_type","absolute;relative;static",";",true);
fillSelect(0,"positioning_visibility","style_positioning_visibility","inherit;visible;hidden",";",true);
fillSelect(0,"positioning_width_measurement","style_positioning_width_measurement",defaultMeasurement,";",true);
fillSelect(0,"positioning_height_measurement","style_positioning_height_measurement",defaultMeasurement,";",true);
fillSelect(0,"positioning_overflow","style_positioning_overflow","visible;hidden;scroll;auto",";",true);
fillSelect(0,"positioning_placement_top_measurement","style_positioning_placement_top_measurement",defaultMeasurement,";",true);
fillSelect(0,"positioning_placement_right_measurement","style_positioning_placement_right_measurement",defaultMeasurement,";",true);
fillSelect(0,"positioning_placement_bottom_measurement","style_positioning_placement_bottom_measurement",defaultMeasurement,";",true);
fillSelect(0,"positioning_placement_left_measurement","style_positioning_placement_left_measurement",defaultMeasurement,";",true);
fillSelect(0,"positioning_clip_top_measurement","style_positioning_clip_top_measurement",defaultMeasurement,";",true);
fillSelect(0,"positioning_clip_right_measurement","style_positioning_clip_right_measurement",defaultMeasurement,";",true);
fillSelect(0,"positioning_clip_bottom_measurement","style_positioning_clip_bottom_measurement",defaultMeasurement,";",true);
fillSelect(0,"positioning_clip_left_measurement","style_positioning_clip_left_measurement",defaultMeasurement,";",true);
TinyMCE_EditableSelects.init();
setupFormData();
showDisabledControls()
}
function setupFormData(){
var n=document.getElementById("container"),o=document.forms[0],a,e,t;
selectByValue(o,"text_font",n.style.fontFamily,true,true);
selectByValue(o,"text_size",getNum(n.style.fontSize),true,true);
selectByValue(o,"text_size_measurement",getMeasurement(n.style.fontSize));
selectByValue(o,"text_weight",n.style.fontWeight,true,true);
selectByValue(o,"text_style",n.style.fontStyle,true,true);
selectByValue(o,"text_lineheight",getNum(n.style.lineHeight),true,true);
selectByValue(o,"text_lineheight_measurement",getMeasurement(n.style.lineHeight));
selectByValue(o,"text_case",n.style.textTransform,true,true);
selectByValue(o,"text_variant",n.style.fontVariant,true,true);
o.text_color.value=tinyMCEPopup.editor.dom.toHex(n.style.color);
updateColor("text_color_pick","text_color");
o.text_underline.checked=inStr(n.style.textDecoration,"underline");
o.text_overline.checked=inStr(n.style.textDecoration,"overline");
o.text_linethrough.checked=inStr(n.style.textDecoration,"line-through");
o.text_blink.checked=inStr(n.style.textDecoration,"blink");
o.background_color.value=tinyMCEPopup.editor.dom.toHex(n.style.backgroundColor);
updateColor("background_color_pick","background_color");
o.background_image.value=n.style.backgroundImage.replace(new RegExp("url\\('?([^']*)'?\\)","gi"),"$1");
selectByValue(o,"background_repeat",n.style.backgroundRepeat,true,true);
selectByValue(o,"background_attachment",n.style.backgroundAttachment,true,true);
selectByValue(o,"background_hpos",getNum(getVal(n.style.backgroundPosition,0)),true,true);
selectByValue(o,"background_hpos_measurement",getMeasurement(getVal(n.style.backgroundPosition,0)));
selectByValue(o,"background_vpos",getNum(getVal(n.style.backgroundPosition,1)),true,true);
selectByValue(o,"background_vpos_measurement",getMeasurement(getVal(n.style.backgroundPosition,1)));
selectByValue(o,"block_wordspacing",getNum(n.style.wordSpacing),true,true);
selectByValue(o,"block_wordspacing_measurement",getMeasurement(n.style.wordSpacing));
selectByValue(o,"block_letterspacing",getNum(n.style.letterSpacing),true,true);
selectByValue(o,"block_letterspacing_measurement",getMeasurement(n.style.letterSpacing));
selectByValue(o,"block_vertical_alignment",n.style.verticalAlign,true,true);
selectByValue(o,"block_text_align",n.style.textAlign,true,true);
o.block_text_indent.value=getNum(n.style.textIndent);
selectByValue(o,"block_text_indent_measurement",getMeasurement(n.style.textIndent));
selectByValue(o,"block_whitespace",n.style.whiteSpace,true,true);
selectByValue(o,"block_display",n.style.display,true,true);
o.box_width.value=getNum(n.style.width);
selectByValue(o,"box_width_measurement",getMeasurement(n.style.width));
o.box_height.value=getNum(n.style.height);
selectByValue(o,"box_height_measurement",getMeasurement(n.style.height));
if(tinymce.isGecko){
selectByValue(o,"box_float",n.style.cssFloat,true,true)
}else{
selectByValue(o,"box_float",n.style.styleFloat,true,true)
}
selectByValue(o,"box_clear",n.style.clear,true,true);
setupBox(o,n,"box_padding","padding","");
setupBox(o,n,"box_margin","margin","");
setupBox(o,n,"border_style","border","Style");
setupBox(o,n,"border_width","border","Width");
setupBox(o,n,"border_color","border","Color");
updateColor("border_color_top_pick","border_color_top");
updateColor("border_color_right_pick","border_color_right");
updateColor("border_color_bottom_pick","border_color_bottom");
updateColor("border_color_left_pick","border_color_left");
o.elements.border_color_top.value=tinyMCEPopup.editor.dom.toHex(o.elements.border_color_top.value);
o.elements.border_color_right.value=tinyMCEPopup.editor.dom.toHex(o.elements.border_color_right.value);
o.elements.border_color_bottom.value=tinyMCEPopup.editor.dom.toHex(o.elements.border_color_bottom.value);
o.elements.border_color_left.value=tinyMCEPopup.editor.dom.toHex(o.elements.border_color_left.value);
selectByValue(o,"list_type",n.style.listStyleType,true,true);
selectByValue(o,"list_position",n.style.listStylePosition,true,true);
o.list_bullet_image.value=n.style.listStyleImage.replace(new RegExp("url\\('?([^']*)'?\\)","gi"),"$1");
selectByValue(o,"positioning_type",n.style.position,true,true);
selectByValue(o,"positioning_visibility",n.style.visibility,true,true);
selectByValue(o,"positioning_overflow",n.style.overflow,true,true);
o.positioning_zindex.value=n.style.zIndex?n.style.zIndex:"";
o.positioning_width.value=getNum(n.style.width);
selectByValue(o,"positioning_width_measurement",getMeasurement(n.style.width));
o.positioning_height.value=getNum(n.style.height);
selectByValue(o,"positioning_height_measurement",getMeasurement(n.style.height));
setupBox(o,n,"positioning_placement","","",["top","right","bottom","left"]);
a=n.style.clip.replace(new RegExp("rect\\('?([^']*)'?\\)","gi"),"$1");
a=a.replace(/,/g," ");
if(!hasEqualValues([getVal(a,0),getVal(a,1),getVal(a,2),getVal(a,3)])){
o.positioning_clip_top.value=getNum(getVal(a,0));
selectByValue(o,"positioning_clip_top_measurement",getMeasurement(getVal(a,0)));
o.positioning_clip_right.value=getNum(getVal(a,1));
selectByValue(o,"positioning_clip_right_measurement",getMeasurement(getVal(a,1)));
o.positioning_clip_bottom.value=getNum(getVal(a,2));
selectByValue(o,"positioning_clip_bottom_measurement",getMeasurement(getVal(a,2)));
o.positioning_clip_left.value=getNum(getVal(a,3));
selectByValue(o,"positioning_clip_left_measurement",getMeasurement(getVal(a,3)))
}else{
o.positioning_clip_top.value=getNum(getVal(a,0));
selectByValue(o,"positioning_clip_top_measurement",getMeasurement(getVal(a,0)));
o.positioning_clip_right.value=o.positioning_clip_bottom.value=o.positioning_clip_left.value
}}
function getMeasurement(e){
return e.replace(/^([0-9.]+)(.*)$/,"$2")
}
function getNum(e){
if(new RegExp("^(?:[0-9.]+)(?:[a-z%]+)$","gi").test(e)){
return e.replace(/[^0-9.]/g,"")
}
return e
}
function inStr(e,t){
return new RegExp(t,"gi").test(e)
}
function getVal(o,t){
var e=o.split(" ");
if(e.length>1){
return e[t]
}
return""
}
function setValue(t,a,e){
if(t.elements[a].type=="text"){
t.elements[a].value=e
}else{
selectByValue(t,a,e,true,true)
}}
function setupBox(i,o,t,n,a,e){
if(typeof(e)=="undefined"){
e=["Top","Right","Bottom","Left"]
}
if(isSame(o,n,a,e)){
i.elements[t+"_same"].checked=true;
setValue(i,t+"_top",getNum(o.style[n+e[0]+a]));
i.elements[t+"_top"].disabled=false;
i.elements[t+"_right"].value="";
i.elements[t+"_right"].disabled=true;
i.elements[t+"_bottom"].value="";
i.elements[t+"_bottom"].disabled=true;
i.elements[t+"_left"].value="";
i.elements[t+"_left"].disabled=true;
if(i.elements[t+"_top_measurement"]){
selectByValue(i,t+"_top_measurement",getMeasurement(o.style[n+e[0]+a]));
i.elements[t+"_left_measurement"].disabled=true;
i.elements[t+"_bottom_measurement"].disabled=true;
i.elements[t+"_right_measurement"].disabled=true
}}else{
i.elements[t+"_same"].checked=false;
setValue(i,t+"_top",getNum(o.style[n+e[0]+a]));
i.elements[t+"_top"].disabled=false;
setValue(i,t+"_right",getNum(o.style[n+e[1]+a]));
i.elements[t+"_right"].disabled=false;
setValue(i,t+"_bottom",getNum(o.style[n+e[2]+a]));
i.elements[t+"_bottom"].disabled=false;
setValue(i,t+"_left",getNum(o.style[n+e[3]+a]));
i.elements[t+"_left"].disabled=false;
if(i.elements[t+"_top_measurement"]){
selectByValue(i,t+"_top_measurement",getMeasurement(o.style[n+e[0]+a]));
selectByValue(i,t+"_right_measurement",getMeasurement(o.style[n+e[1]+a]));
selectByValue(i,t+"_bottom_measurement",getMeasurement(o.style[n+e[2]+a]));
selectByValue(i,t+"_left_measurement",getMeasurement(o.style[n+e[3]+a]));
i.elements[t+"_left_measurement"].disabled=false;
i.elements[t+"_bottom_measurement"].disabled=false;
i.elements[t+"_right_measurement"].disabled=false
}}}
function isSame(h,l,r,o){
var n=[],s,t;
if(typeof(o)=="undefined"){
o=["Top","Right","Bottom","Left"]
}
if(typeof(r)=="undefined"||r==null){
r=""
}
n[0]=h.style[l+o[0]+r];
n[1]=h.style[l+o[1]+r];
n[2]=h.style[l+o[2]+r];
n[3]=h.style[l+o[3]+r];
for(s=0;
s<n.length;
s++){
if(n[s]==null){
return false
}
for(t=0;
t<n.length;
t++){
if(n[t]!=n[s]){
return false
}}}
return true
}
function hasEqualValues(t){
var o,e;
for(o=0;
o<t.length;
o++){
if(t[o]==null){
return false
}
for(e=0;
e<t.length;
e++){
if(t[e]!=t[o]){
return false
}}}
return true
}
function applyAction(){
var t=document.getElementById("container"),e=tinyMCEPopup.editor;
generateCSS();
tinyMCEPopup.restoreSelection();
e.dom.setAttrib(e.selection.getNode(),"style",tinyMCEPopup.editor.dom.serializeStyle(tinyMCEPopup.editor.dom.parseStyle(t.style.cssText)))
}
function updateAction(){
applyAction();
tinyMCEPopup.close()
}
function generateCSS(){
var n=document.getElementById("container"),o=document.forms[0],e=new RegExp("[0-9]+","g"),i,a;
n.style.cssText="";
n.style.fontFamily=o.text_font.value;
n.style.fontSize=o.text_size.value+(isNum(o.text_size.value)?(o.text_size_measurement.value||"px"):"");
n.style.fontStyle=o.text_style.value;
n.style.lineHeight=o.text_lineheight.value+(isNum(o.text_lineheight.value)?o.text_lineheight_measurement.value:"");
n.style.textTransform=o.text_case.value;
n.style.fontWeight=o.text_weight.value;
n.style.fontVariant=o.text_variant.value;
n.style.color=o.text_color.value;
i="";
i+=o.text_underline.checked?" underline":"";
i+=o.text_overline.checked?" overline":"";
i+=o.text_linethrough.checked?" line-through":"";
i+=o.text_blink.checked?" blink":"";
i=i.length>0?i.substring(1):i;
if(o.text_none.checked){
i="none"
}
n.style.textDecoration=i;
n.style.backgroundColor=o.background_color.value;
n.style.backgroundImage=o.background_image.value!=""?"url("+o.background_image.value+")":"";
n.style.backgroundRepeat=o.background_repeat.value;
n.style.backgroundAttachment=o.background_attachment.value;
if(o.background_hpos.value!=""){
i="";
i+=o.background_hpos.value+(isNum(o.background_hpos.value)?o.background_hpos_measurement.value:"")+" ";
i+=o.background_vpos.value+(isNum(o.background_vpos.value)?o.background_vpos_measurement.value:"");
n.style.backgroundPosition=i
}
n.style.wordSpacing=o.block_wordspacing.value+(isNum(o.block_wordspacing.value)?o.block_wordspacing_measurement.value:"");
n.style.letterSpacing=o.block_letterspacing.value+(isNum(o.block_letterspacing.value)?o.block_letterspacing_measurement.value:"");
n.style.verticalAlign=o.block_vertical_alignment.value;
n.style.textAlign=o.block_text_align.value;
n.style.textIndent=o.block_text_indent.value+(isNum(o.block_text_indent.value)?o.block_text_indent_measurement.value:"");
n.style.whiteSpace=o.block_whitespace.value;
n.style.display=o.block_display.value;
n.style.width=o.box_width.value+(isNum(o.box_width.value)?o.box_width_measurement.value:"");
n.style.height=o.box_height.value+(isNum(o.box_height.value)?o.box_height_measurement.value:"");
n.style.styleFloat=o.box_float.value;
if(tinymce.isGecko){
n.style.cssFloat=o.box_float.value
}
n.style.clear=o.box_clear.value;
if(!o.box_padding_same.checked){
n.style.paddingTop=o.box_padding_top.value+(isNum(o.box_padding_top.value)?o.box_padding_top_measurement.value:"");
n.style.paddingRight=o.box_padding_right.value+(isNum(o.box_padding_right.value)?o.box_padding_right_measurement.value:"");
n.style.paddingBottom=o.box_padding_bottom.value+(isNum(o.box_padding_bottom.value)?o.box_padding_bottom_measurement.value:"");
n.style.paddingLeft=o.box_padding_left.value+(isNum(o.box_padding_left.value)?o.box_padding_left_measurement.value:"")
}else{
n.style.padding=o.box_padding_top.value+(isNum(o.box_padding_top.value)?o.box_padding_top_measurement.value:"")
}
if(!o.box_margin_same.checked){
n.style.marginTop=o.box_margin_top.value+(isNum(o.box_margin_top.value)?o.box_margin_top_measurement.value:"");
n.style.marginRight=o.box_margin_right.value+(isNum(o.box_margin_right.value)?o.box_margin_right_measurement.value:"");
n.style.marginBottom=o.box_margin_bottom.value+(isNum(o.box_margin_bottom.value)?o.box_margin_bottom_measurement.value:"");
n.style.marginLeft=o.box_margin_left.value+(isNum(o.box_margin_left.value)?o.box_margin_left_measurement.value:"")
}else{
n.style.margin=o.box_margin_top.value+(isNum(o.box_margin_top.value)?o.box_margin_top_measurement.value:"")
}
if(!o.border_style_same.checked){
n.style.borderTopStyle=o.border_style_top.value;
n.style.borderRightStyle=o.border_style_right.value;
n.style.borderBottomStyle=o.border_style_bottom.value;
n.style.borderLeftStyle=o.border_style_left.value
}else{
n.style.borderStyle=o.border_style_top.value
}
if(!o.border_width_same.checked){
n.style.borderTopWidth=o.border_width_top.value+(isNum(o.border_width_top.value)?o.border_width_top_measurement.value:"");
n.style.borderRightWidth=o.border_width_right.value+(isNum(o.border_width_right.value)?o.border_width_right_measurement.value:"");
n.style.borderBottomWidth=o.border_width_bottom.value+(isNum(o.border_width_bottom.value)?o.border_width_bottom_measurement.value:"");
n.style.borderLeftWidth=o.border_width_left.value+(isNum(o.border_width_left.value)?o.border_width_left_measurement.value:"")
}else{
n.style.borderWidth=o.border_width_top.value+(isNum(o.border_width_top.value)?o.border_width_top_measurement.value:"")
}
if(!o.border_color_same.checked){
n.style.borderTopColor=o.border_color_top.value;
n.style.borderRightColor=o.border_color_right.value;
n.style.borderBottomColor=o.border_color_bottom.value;
n.style.borderLeftColor=o.border_color_left.value
}else{
n.style.borderColor=o.border_color_top.value
}
n.style.listStyleType=o.list_type.value;
n.style.listStylePosition=o.list_position.value;
n.style.listStyleImage=o.list_bullet_image.value!=""?"url("+o.list_bullet_image.value+")":"";
n.style.position=o.positioning_type.value;
n.style.visibility=o.positioning_visibility.value;
if(n.style.width==""){
n.style.width=o.positioning_width.value+(isNum(o.positioning_width.value)?o.positioning_width_measurement.value:"")
}
if(n.style.height==""){
n.style.height=o.positioning_height.value+(isNum(o.positioning_height.value)?o.positioning_height_measurement.value:"")
}
n.style.zIndex=o.positioning_zindex.value;
n.style.overflow=o.positioning_overflow.value;
if(!o.positioning_placement_same.checked){
n.style.top=o.positioning_placement_top.value+(isNum(o.positioning_placement_top.value)?o.positioning_placement_top_measurement.value:"");
n.style.right=o.positioning_placement_right.value+(isNum(o.positioning_placement_right.value)?o.positioning_placement_right_measurement.value:"");
n.style.bottom=o.positioning_placement_bottom.value+(isNum(o.positioning_placement_bottom.value)?o.positioning_placement_bottom_measurement.value:"");
n.style.left=o.positioning_placement_left.value+(isNum(o.positioning_placement_left.value)?o.positioning_placement_left_measurement.value:"")
}else{
i=o.positioning_placement_top.value+(isNum(o.positioning_placement_top.value)?o.positioning_placement_top_measurement.value:"");
n.style.top=i;
n.style.right=i;
n.style.bottom=i;
n.style.left=i
}
if(!o.positioning_clip_same.checked){
i="rect(";
i+=(isNum(o.positioning_clip_top.value)?o.positioning_clip_top.value+o.positioning_clip_top_measurement.value:"auto")+" ";
i+=(isNum(o.positioning_clip_right.value)?o.positioning_clip_right.value+o.positioning_clip_right_measurement.value:"auto")+" ";
i+=(isNum(o.positioning_clip_bottom.value)?o.positioning_clip_bottom.value+o.positioning_clip_bottom_measurement.value:"auto")+" ";
i+=(isNum(o.positioning_clip_left.value)?o.positioning_clip_left.value+o.positioning_clip_left_measurement.value:"auto");
i+=")";
if(i!="rect(auto auto auto auto)"){
n.style.clip=i
}}else{
i="rect(";
a=isNum(o.positioning_clip_top.value)?o.positioning_clip_top.value+o.positioning_clip_top_measurement.value:"auto";
i+=a+" ";
i+=a+" ";
i+=a+" ";
i+=a+")";
if(i!="rect(auto auto auto auto)"){
n.style.clip=i
}}
n.style.cssText=n.style.cssText
}
function isNum(e){
return new RegExp("[0-9]+","g").test(e)
}
function showDisabledControls(){
var o=document.forms,t,e;
for(t=0;
t<o.length;
t++){
for(e=0;
e<o[t].elements.length;
e++){
if(o[t].elements[e].disabled){
tinyMCEPopup.editor.dom.addClass(o[t].elements[e],"disabled")
}else{
tinyMCEPopup.editor.dom.removeClass(o[t].elements[e],"disabled")
}}}}
function fillSelect(h,c,o,t,d,a){
var r,n,e,l;
h=document.forms[h];
d=typeof(d)=="undefined"?";":d;
if(a){
addSelectValue(h,c,"","")
}
n=tinyMCEPopup.getParam(o,t).split(d);
for(r=0;
r<n.length;
r++){
l=false;
if(n[r].charAt(0)=="+"){
n[r]=n[r].substring(1);
l=true
}
e=n[r].split("=");
if(e.length>1){
addSelectValue(h,c,e[0],e[1]);
if(l){
selectByValue(h,c,e[1])
}}else{
addSelectValue(h,c,e[0],e[0]);
if(l){
selectByValue(h,c,e[0])
}}}}
function toggleSame(o,a){
var t=document.forms[0].elements,e;
if(o.checked){
t[a+"_top"].disabled=false;
t[a+"_right"].disabled=true;
t[a+"_bottom"].disabled=true;
t[a+"_left"].disabled=true;
if(t[a+"_top_measurement"]){
t[a+"_top_measurement"].disabled=false;
t[a+"_right_measurement"].disabled=true;
t[a+"_bottom_measurement"].disabled=true;
t[a+"_left_measurement"].disabled=true
}}else{
t[a+"_top"].disabled=false;
t[a+"_right"].disabled=false;
t[a+"_bottom"].disabled=false;
t[a+"_left"].disabled=false;
if(t[a+"_top_measurement"]){
t[a+"_top_measurement"].disabled=false;
t[a+"_right_measurement"].disabled=false;
t[a+"_bottom_measurement"].disabled=false;
t[a+"_left_measurement"].disabled=false
}}
showDisabledControls()
}
function synch(e,a){
var t=document.forms[0];
t.elements[a].value=t.elements[e].value;
if(t.elements[e+"_measurement"]){
selectByValue(t,a+"_measurement",t.elements[e+"_measurement"].value)
}}
tinyMCEPopup.onInit.add(init);
