
/* Copyright (C) 2005-2009 Zimbra Inc. http://www.zimbra.com/ */
(function(){
tinymce.create("tinymce.plugins.XHTMLXtrasPlugin",{
init:function(e,i){
e.addCommand("mceCite",function(){
e.windowManager.open({
file:i+"/cite.htm",width:350+parseInt(e.getLang("xhtmlxtras.cite_delta_width",0)),height:250+parseInt(e.getLang("xhtmlxtras.cite_delta_height",0)),inline:1}
,{
plugin_url:i}
)
}
);
e.addCommand("mceAcronym",function(){
e.windowManager.open({
file:i+"/acronym.htm",width:350+parseInt(e.getLang("xhtmlxtras.acronym_delta_width",0)),height:250+parseInt(e.getLang("xhtmlxtras.acronym_delta_width",0)),inline:1}
,{
plugin_url:i}
)
}
);
e.addCommand("mceAbbr",function(){
e.windowManager.open({
file:i+"/abbr.htm",width:350+parseInt(e.getLang("xhtmlxtras.abbr_delta_width",0)),height:250+parseInt(e.getLang("xhtmlxtras.abbr_delta_width",0)),inline:1}
,{
plugin_url:i}
)
}
);
e.addCommand("mceDel",function(){
e.windowManager.open({
file:i+"/del.htm",width:340+parseInt(e.getLang("xhtmlxtras.del_delta_width",0)),height:310+parseInt(e.getLang("xhtmlxtras.del_delta_width",0)),inline:1}
,{
plugin_url:i}
)
}
);
e.addCommand("mceIns",function(){
e.windowManager.open({
file:i+"/ins.htm",width:340+parseInt(e.getLang("xhtmlxtras.ins_delta_width",0)),height:310+parseInt(e.getLang("xhtmlxtras.ins_delta_width",0)),inline:1}
,{
plugin_url:i}
)
}
);
e.addCommand("mceAttributes",function(){
e.windowManager.open({
file:i+"/attributes.htm",width:380,height:370,inline:1}
,{
plugin_url:i}
)
}
);
e.addButton("cite",{
title:"xhtmlxtras.cite_desc",cmd:"mceCite"}
);
e.addButton("acronym",{
title:"xhtmlxtras.acronym_desc",cmd:"mceAcronym"}
);
e.addButton("abbr",{
title:"xhtmlxtras.abbr_desc",cmd:"mceAbbr"}
);
e.addButton("del",{
title:"xhtmlxtras.del_desc",cmd:"mceDel"}
);
e.addButton("ins",{
title:"xhtmlxtras.ins_desc",cmd:"mceIns"}
);
e.addButton("attribs",{
title:"xhtmlxtras.attribs_desc",cmd:"mceAttributes"}
);
if(tinymce.isIE){
function t(o,a){
if(a.set){
a.content=a.content.replace(/<abbr([^>]+)>/gi,"<html:abbr $1>");
a.content=a.content.replace(/<\/abbr>/gi,"</html:abbr>")
}}
e.onBeforeSetContent.add(t);
e.onPostProcess.add(t)
}
e.onNodeChange.add(function(n,s,a,o){
a=n.dom.getParent(a,"CITE,ACRONYM,ABBR,DEL,INS");
s.setDisabled("cite",o);
s.setDisabled("acronym",o);
s.setDisabled("abbr",o);
s.setDisabled("del",o);
s.setDisabled("ins",o);
s.setDisabled("attribs",a&&a.nodeName=="BODY");
s.setActive("cite",0);
s.setActive("acronym",0);
s.setActive("abbr",0);
s.setActive("del",0);
s.setActive("ins",0);
if(a){
do{
s.setDisabled(a.nodeName.toLowerCase(),0);
s.setActive(a.nodeName.toLowerCase(),1)
}
while(a=a.parentNode)
}}
)
}
,getInfo:function(){
return{
longname:"XHTML Xtras Plugin",author:"Moxiecode Systems AB",authorurl:"http://tinymce.moxiecode.com",infourl:"http://wiki.moxiecode.com/index.php/TinyMCE:Plugins/xhtmlxtras",version:tinymce.majorVersion+"."+tinymce.minorVersion}
}}
);
tinymce.PluginManager.add("xhtmlxtras",tinymce.plugins.XHTMLXtrasPlugin)
}
)();
