
/* Copyright (C) 2005-2009 Zimbra Inc. http://www.zimbra.com/ */
if(AjxPackage.define("Alert")){
if(AjxPackage.define("ajax.util.AjxPluginDetector")){
AjxPluginDetector=function(){};
AjxPluginDetector.canDetectPlugins=function(){
return AjxEnv.isIE||(navigator.plugins&&navigator.plugins.length>0)
};
AjxPluginDetector.detectFlash=function(){
if(AjxEnv.isIE){
return AjxPluginDetector.detectActiveXControl("ShockwaveFlash.ShockwaveFlash.1")
}else{
return AjxPluginDetector.detectPlugin("Shockwave","Flash")
}};
AjxPluginDetector.detectPDFReader=function(){
if(AjxEnv.isIE){
return(AjxPluginDetector.detectActiveXControl("PDF.PdfCtrl.5")||AjxPluginDetector.detectActiveXControl("AcroExch.Document"))
}else{
var e=false;
if(AjxEnv.isChrome){
e=AjxPluginDetector.detectPlugin("Chrome PDF Viewer")
}else{
if(AjxEnv.isFirefox){
e=AjxPluginDetector.detectPlugin("Firefox PDF Plugin for Mac OS X")
}}
if(!e){
e=AjxPluginDetector.detectPlugin("Adobe Acrobat")
}
return e
}};
AjxPluginDetector.detectDirector=function(){
if(AjxEnv.isIE){
return AjxPluginDetector.detectActiveXControl("SWCtl.SWCtl.1")
}else{
return AjxPluginDetector.detectPlugin("Shockwave","Director")
}};
AjxPluginDetector.detectQuickTime=function(){
if(AjxEnv.isIE){
return AjxPluginDetector.detectQuickTimeActiveXControl()
}else{
return AjxPluginDetector.detectPlugin("QuickTime")
}};
AjxPluginDetector.getQuickTimeVersion=function(){
if(AjxEnv.isIE){
var n=new ActiveXObject("QuickTimeCheckObject.QuickTimeCheck.1");
if(n.IsQuickTimeAvailable(0)){
try{
var a=Number(n.QuickTimeVersion).toString(16);
var t=[];
for(var s=0;
s<3;
s++){
t[s]=Number(a.charAt(s))
}
return t
}
catch(r){}}
return null
}else{
var o=AjxPluginDetector.matchPluginName(/QuickTime Plug-in (\d+)\.?(\d+)?\.?(\d+)?/);
if(o){
var t=[];
for(var s=0;
s<3;
s++){
t[s]=Number(o[s+1]||0)
}
return t
}else{
return null
}}};
AjxPluginDetector.detectReal=function(){
if(AjxEnv.isIE){
return AjxPluginDetector.detectActiveXControl("rmocx.RealPlayer G2 Control")||AjxPluginDetector.detectActiveXControl("RealPlayer.RealPlayer(tm) ActiveX Control (32-bit)")||AjxPluginDetector.detectActiveXControl("RealVideo.RealVideo(tm) ActiveX Control (32-bit)")
}else{
return AjxPluginDetector.detectPlugin("RealPlayer")
}};
AjxPluginDetector.detectWindowsMedia=function(){
if(AjxEnv.isIE){
return AjxPluginDetector.detectActiveXControl("MediaPlayer.MediaPlayer.1")
}else{
return AjxPluginDetector.detectPlugin("Windows Media")
}};
AjxPluginDetector.detectPlugin=function(){
var o=AjxPluginDetector.detectPlugin.arguments;
var i=navigator.plugins;
var t=i.length;
for(var a=0;
a<t;
a++){
var n=0;
for(var e=0;
e<o.length;
e++){
if(i[a]){
if((i[a].name.indexOf(o[e])>=0)){
n++
}else{
if(i[a].description.indexOf(o[e])>=0){
n++
}}}}
if(n==o.length){
return true
}else{
if(n){}}}
return false
};
AjxPluginDetector.matchPluginName=function(t){
var o=navigator.plugins;
var a=o.length;
for(var i=0;
i<a;
i++){
var e=o[i].name.match(t);
if(e){
return e
}}
return null
};
AjxPluginDetector.detectActiveXControl=function(t){
try{
new ActiveXObject(t);
return true
}
catch(a){
return false
}};
AjxPluginDetector.detectQuickTimeActiveXControl=function(a){
try{
var t=new ActiveXObject("QuickTimeCheckObject.QuickTimeCheck.1");
return t.IsQuickTimeAvailable(0)
}
catch(i){
return false
}};
AjxPluginDetector._argumentsToString=function(e){
var o=[];
for(var t=0,a=e.length;
t<a;
t++){
o[t]=e[t]
}
return o.join(",")
}
}
if(AjxPackage.define("zimbraMail.share.view.ZmAlert")){
ZmAlert=function(){
this._isLooping=false
};
ZmAlert.prototype.start=null;
ZmAlert.prototype.stop=null;
ZmAlert.prototype._update=null;
ZmAlert.prototype._startLoop=function(){
if(!ZmAlertLoop.INSTANCE){
ZmAlertLoop.INSTANCE=new ZmAlertLoop()
}
ZmAlertLoop.INSTANCE._add(this);
this._isLooping=true
};
ZmAlert.prototype._stopLoop=function(){
if(!this._isLooping){
return
}
if(ZmAlertLoop.INSTANCE){
ZmAlertLoop.INSTANCE._remove(this)
}
this._isLooping=false;
this._update(false)
};
ZmAlertLoop=function(){
this._alerts=new AjxVector();
this._flashOn=false;
if(appCtxt.multiAccounts){
appCtxt.accountList.addActiveAcountListener(new AjxListener(this,this._accountChangeListener),0)
}};
ZmAlertLoop.prototype._add=function(e){
this._alerts.add(e,0,true);
if(!this._alertInterval){
this._alertInterval=setInterval(AjxCallback.simpleClosure(this._alertTimerCallback,this),1500)
}};
ZmAlertLoop.prototype._remove=function(e){
this._alerts.remove(e);
if(this._alertInterval&&!this._alerts.size()){
clearInterval(this._alertInterval);
this._alertInterval=0
}};
ZmAlertLoop.prototype._alertTimerCallback=function(){
this._flashOn=!this._flashOn;
for(var e=0,t=this._alerts.size();
e<t;
e++){
this._alerts.get(e)._update(this._flashOn)
}};
ZmAlertLoop.prototype._accountChangeListener=function(){
var t=this._alerts.getArray();
var e;
while(e=t.unshift()){
e.stop()
}}
}
if(AjxPackage.define("zimbraMail.share.view.ZmAccountAlert")){
ZmAccountAlert=function(e){
ZmAlert.call(this);
this.account=e;
this._alertApps={};
appCtxt.accountList.addActiveAcountListener(new AjxListener(this,this._accountListener))
};
ZmAccountAlert.prototype=new ZmAlert;
ZmAccountAlert.prototype.constructor=ZmAccountAlert;
ZmAccountAlert.prototype.toString=function(){
return"ZmAccountAlert"
};
ZmAccountAlert.get=function(e){
ZmAccountAlert.INSTANCES=ZmAccountAlert.INSTANCES||{};
if(!ZmAccountAlert.INSTANCES[e.id]){
ZmAccountAlert.INSTANCES[e.id]=new ZmAccountAlert(e)
}
return ZmAccountAlert.INSTANCES[e.id]
};
ZmAccountAlert.prototype.start=function(e){
if(this.account!=appCtxt.getActiveAccount()){
this._started=true;
if(e){
this._alertApps[e.getName()]=e
}}};
ZmAccountAlert.prototype.stop=function(){
this._started=false
};
ZmAccountAlert.prototype._accountListener=function(t){
if(t.account==this.account){
this.stop();
for(var e in this._alertApps){
this._alertApps[e].startAlert()
}
this._alertApps={}
}}
}
if(AjxPackage.define("zimbraMail.share.view.ZmAppAlert")){
ZmAppAlert=function(e){
this.app=e
};
ZmAppAlert.prototype.toString=function(){
return"ZmAppAlert"
};
ZmAppAlert.prototype.start=function(){
if(!this._getAppButton().isSelected){
this._getAppButton().showAlert(true);
if(!this._stopAlertListenerObj){
this._stopAlertListenerObj=new AjxListener(this,this.stop);
this._getAppButton().addSelectionListener(this._stopAlertListenerObj)
}}};
ZmAppAlert.prototype.stop=function(){
if(this._getAppButton().isSelected){
this._getAppButton().showAlert(false)
}};
ZmAppAlert.prototype._getAppButton=function(){
return appCtxt.getAppController().getAppChooserButton(this.app.getName())
}
}
if(AjxPackage.define("zimbraMail.share.view.ZmBrowserAlert")){
ZmBrowserAlert=function(){
ZmAlert.call(this);
this._originalTitle=null;
this.altTitle=null;
var t=new AjxListener(this,this._focusListener);
DwtShell.getShell(window).addFocusListener(t);
DwtShell.getShell(window).addBlurListener(t);
var e=new AjxListener(this,this._globalEventListener);
DwtEventManager.addListener(DwtEvent.ONMOUSEDOWN,e);
DwtEventManager.addListener(DwtEvent.ONKEYDOWN,e)
};
ZmBrowserAlert.prototype=new ZmAlert;
ZmBrowserAlert.prototype.constructor=ZmBrowserAlert;
ZmBrowserAlert.prototype.toString=function(){
return"ZmBrowserAlert"
};
ZmBrowserAlert.getInstance=function(){
return ZmBrowserAlert.INSTANCE=ZmBrowserAlert.INSTANCE||new ZmBrowserAlert()
};
ZmBrowserAlert.prototype.start=function(e){
if(this._isLooping){
return
}
this.altTitle=e||ZmMsg.newMessage;
if(!this._clientHasFocus){
if(!this._favIcon){
this._favIcon=appContextPath+"/img/logo/favicon.ico";
this._blankIcon=appContextPath+"/img/logo/blank.ico"
}
this._startLoop()
}};
ZmBrowserAlert.prototype.stop=function(){
this._stopLoop()
};
ZmBrowserAlert.prototype._update=function(e){
Dwt.setFavIcon(e?this._blankIcon:this._favIcon);
var t=document;
if(e){
this._origTitle=t.title;
t.title=this.altTitle
}else{
if(t.title==this.altTitle){
t.title=this._origTitle
}}};
ZmBrowserAlert.prototype._focusListener=function(e){
this._clientHasFocus=e.state==DwtFocusEvent.FOCUS;
if(this._clientHasFocus){
this.stop()
}};
ZmBrowserAlert.prototype._globalEventListener=function(){
this._clientHasFocus=true;
this.stop()
}
}
if(AjxPackage.define("zimbraMail.share.view.ZmDesktopAlert")){
ZmDesktopAlert=function(){
if(window.webkitNotifications){
this.useWebkit=true
}else{
if(window.Notification){
this.useNotification=true
}}};
ZmDesktopAlert.prototype=new ZmAlert;
ZmDesktopAlert.prototype.constructor=ZmDesktopAlert;
ZmDesktopAlert.prototype.toString=function(){
return"ZmDesktopAlert"
};
ZmDesktopAlert.getInstance=function(){
return ZmDesktopAlert.INSTANCE=ZmDesktopAlert.INSTANCE||new ZmDesktopAlert()
};
ZmDesktopAlert.prototype.getDisplayText=function(){
if(this.useWebkit||this.useNotification){
return ZmMsg.showPopup
}};
ZmDesktopAlert.prototype.start=function(o,e,i){
if(this.useWebkit){
var t=this._showWebkitNotification.bind(this,o,e,i);
this._checkWebkitPermission(t)
}else{
if(this.useNotification){
var a=this._showNotification.bind(this,o,e,i);
this._checkNotificationPermission(a)
}}};
ZmDesktopAlert.prototype._checkWebkitPermission=function(e){
var t=window.webkitNotifications.checkPermission()==0;
if(t){
e()
}else{
if(!ZmDesktopAlert.requestedPermission){
ZmDesktopAlert.requestedPermission=true;
window.webkitNotifications.requestPermission(this._checkWebkitPermission.bind(this,e))
}}};
ZmDesktopAlert.prototype._showWebkitNotification=function(o,a,i){
i=i||false;
var t=skin.hints.notificationBanner;
var e=window.webkitNotifications.createNotification(t,o,a);
e.show();
e.onclick=function(){
e.cancel()
};
if(i){
if(!ZmDesktopAlert.notificationArray){
ZmDesktopAlert.notificationArray=[]
}
ZmDesktopAlert.notificationArray.push(e)
}else{
setTimeout(e.cancel.bind(e),5000)
}};
ZmDesktopAlert.prototype._checkNotificationPermission=function(t){
var a=window.Notification.permission==="granted";
if(a){
t()
}else{
if(!ZmDesktopAlert.requestedPermission){
ZmDesktopAlert.requestedPermission=true;
var e=this._checkNotificationPermission.bind(this,t);
this.requestRequestPermission(e)
}}};
ZmDesktopAlert.prototype.requestRequestPermission=function(t){
var e=appCtxt.getYesNoMsgDialog();
var a=this._doRequestPermission.bind(this,e,t);
e.registerCallback(DwtDialog.YES_BUTTON,a);
e.setMessage(ZmMsg.notificationPermission,DwtMessageDialog.INFO_STYLE);
e.popup()
};
ZmDesktopAlert.prototype._doRequestPermission=function(e,t){
e.popdown();
window.Notification.requestPermission(t)
};
ZmDesktopAlert.prototype._showNotification=function(o,a,i){
var t=skin.hints.notificationBanner;
var e=new Notification(o,{
body:a,icon:t}
);
e.onclick=function(){
e.close()
};
if(i){
if(!ZmDesktopAlert.notificationArray){
ZmDesktopAlert.notificationArray=[]
}
ZmDesktopAlert.notificationArray.push(e)
}else{
setTimeout(e.close.bind(e),5000)
}};
ZmDesktopAlert.closeNotification=function(){
var a=ZmDesktopAlert.notificationArray,t;
if(a){
while(t=a.pop()){
try{
t.cancel()
}
catch(i){}}}}
}
if(AjxPackage.define("zimbraMail.share.view.ZmSoundAlert")){
ZmSoundAlert=function(){
this.html5AudioEnabled=ZmSoundAlert.isHtml5AudioEnabled();
this.enabled=this.html5AudioEnabled||AjxPluginDetector.detectQuickTime()||AjxPluginDetector.detectWindowsMedia();
if(this.enabled){
var e=this._element=document.createElement("DIV");
e.style.position="relative";
e.style.top="-1000px";
e.style.left="-1000px";
document.body.appendChild(this._element)
}else{
DBG.println("No QuickTime or Windows Media plugin detected. Sound alerts are disabled.")
}};
ZmSoundAlert.isHtml5AudioEnabled=function(){
try{
var t=new Audio("");
if(!t.canPlayType){
return false
}}
catch(i){
return false
}
var a=t.canPlayType("audio/wav");
return(a!=="no"&&a!=="")
};
ZmSoundAlert.prototype.toString=function(){
return"ZmSoundAlert"
};
ZmSoundAlert.getInstance=function(){
return ZmSoundAlert.INSTANCE=ZmSoundAlert.INSTANCE||new ZmSoundAlert()
};
ZmSoundAlert.prototype.start=function(t){
if(!this.enabled){
return
}
var o=new Date().getTime();
if(this._lastTime&&((o-this._lastTime)<5000)){
return
}
this._lastTime=o;
t=t||"/public/sounds/im/alert.wav";
var a=appContextPath+t;
var i;
if(this.html5AudioEnabled){
i='<audio src="'+a+'" autoplay="yes"></audio>'
}else{
var n=Dwt.getNextId();
var e=["<object CLASSID='CLSID:6BF52A52-394A-11d3-B153-00C04F79FAA6' type='audio/wav'>","<param name='url' value='",a,"'>","<param name='autostart' value='true'>","<param name='controller' value='true'>","<embed id='",n,"' src='",a,"' controller='false' autostart='true' type='audio/wav'/>","</object>"];
i=e.join("")
}
this._element.innerHTML=i;
if(!this.html5AudioEnabled&&AjxEnv.isFirefox&&AjxEnv.isWindows){
if(this._blurActionId){
AjxTimedAction.cancelAction(this._blurActionId);
this._blurActionId=null
}
this._blurEmbedTimer(n,0)
}};
ZmSoundAlert.prototype._blurEmbedTimer=function(a,t){
var e=new AjxTimedAction(this,this._blurEmbed,[a,t]);
this._blurActionId=AjxTimedAction.scheduleAction(e,500)
};
ZmSoundAlert.prototype._blurEmbed=function(i,a){
this._blurActionId=null;
var t=document.getElementById(i);
if(t&&t.blur){
t.blur()
}
var e=appCtxt.getKeyboardMgr().getFocusObj();
if(e&&e.focus){
e.focus()
}
if(a<2){
this._blurEmbedTimer(i,a+1)
}}
}};
