
/* Copyright (C) 2005-2009 Zimbra Inc. http://www.zimbra.com/ */
if(AjxPackage.define("ContactsCore")){
if(AjxPackage.define("ajax.dwt.widgets.DwtChooser")){
DwtChooser=function(a){
if(arguments.length==0){
return
}
DwtComposite.call(this,a.parent,a.className);
this._slvClassName=a.slvClassName;
this._tlvClassName=a.tlvClassName;
this._layoutStyle=a.layoutStyle?a.layoutStyle:DwtChooser.HORIZ_STYLE;
this._selectStyle=a.selectStyle?a.selectStyle:DwtChooser.MULTI_SELECT;
this._mode=a.listStyle?a.listStyle:DwtChooser.MODE_MOVE;
this._noDuplicates=(a.noDuplicates!==false);
this._singleHeight=a.singleHeight?a.singleHeight:45;
this._listSize=a.listSize;
this._sourceEmptyOk=a.sourceEmptyOk;
this._allButtons=a.allButtons;
this._hasTextField=a.hasTextField;
this._handleButtonInfo(a.buttonInfo);
this._mode=a.mode?a.mode:this._hasMultiButtons?DwtChooser.MODE_COPY:DwtChooser.MODE_MOVE;
this._createHtml();
this._initialize();
var t=a.parent.getSize();
var o=a.listWidth||t.x;
var e=a.listHeight||t.y;
if(o&&e){
this.resize(o,e)
}};
DwtChooser.prototype=new DwtComposite;
DwtChooser.prototype.constructor=DwtChooser;
DwtChooser.HORIZ_STYLE=1;
DwtChooser.VERT_STYLE=2;
DwtChooser.SINGLE_SELECT=1;
DwtChooser.MULTI_SELECT=2;
DwtChooser.MODE_COPY=1;
DwtChooser.MODE_MOVE=2;
DwtChooser.REMOVE_BTN_ID="__remove__";
DwtChooser.ADD_ALL_BTN_ID="__addAll__";
DwtChooser.REMOVE_ALL_BTN_ID="__removeAll__";
DwtChooser.prototype.toString=function(){
return"DwtChooser"
};
DwtChooser.prototype.setItems=function(t,e,a){
e=e?e:DwtChooserListView.SOURCE;
this._reset(e);
this.addItems(t,e,true);
this._selectFirst(e);
if(a){
this._reset((e==DwtChooserListView.SOURCE)?DwtChooserListView.TARGET:DwtChooserListView.SOURCE)
}};
DwtChooser.prototype.getItems=function(e){
e=e?e:DwtChooserListView.TARGET;
if(e==DwtChooserListView.SOURCE){
return this.sourceListView.getList().clone()
}else{
if(this._hasMultiButtons){
var a={};
for(var t in this._data){
a[t]=this._data[t].clone()
}
return a
}else{
return this._data[this._buttonInfo[0].id].clone()
}}};
DwtChooser.prototype.addItems=function(t,e,o,r){
e=e?e:DwtChooserListView.SOURCE;
var s=(t instanceof AjxVector)?t.getArray():(t instanceof Array)?t:[t];
if(e==DwtChooserListView.SOURCE){
for(var a=0;
a<s.length;
a++){
this._addToSource(s[a],null,o)
}}else{
var n;
if(this._selectStyle==DwtChooser.SINGLE_SELECT){
this.targetListView._resetList();
s=(s.length>0)?[s[0]]:s
}
for(var a=0;
a<s.length;
a++){
this._addToTarget(s[a],r,o)
}}
if(e==DwtChooserListView.SOURCE){
var s=this.sourceListView.getList();
this._sourceSize=s?s.size():0
}};
DwtChooser.prototype.removeItems=function(o,e,a){
o=(o instanceof AjxVector)?o.getArray():(o instanceof Array)?o:[o];
for(var t=0;
t<o.length;
t++){
(e==DwtChooserListView.SOURCE)?this._removeFromSource(o[t],a):this._removeFromTarget(o[t],a)
}};
DwtChooser.prototype.transfer=function(t,o,e){
o=o?o:this._activeButtonId;
this._setActiveButton(o);
if(this._mode==DwtChooser.MODE_MOVE){
if(this._selectStyle==DwtChooser.SINGLE_SELECT){
var a=this.targetListView.getList();
if(a&&a.size()){
this.remove(a,true)
}}
this.removeItems(t,DwtChooserListView.SOURCE,true)
}
this.addItems(t,DwtChooserListView.TARGET,e);
this.sourceListView.deselectAll()
};
DwtChooser.prototype.remove=function(o,a){
o=(o instanceof AjxVector)?o.getArray():(o instanceof Array)?o:[o];
if(this._mode==DwtChooser.MODE_MOVE){
for(var t=0;
t<o.length;
t++){
var e=this._getInsertionIndex(this.sourceListView,o[t]);
this.sourceListView.addItem(o[t],e,true)
}
this._sourceSize=o?o.length:0
}
this.removeItems(o,DwtChooserListView.TARGET)
};
DwtChooser.prototype.setSelectStyle=function(o,r){
if(o==this._selectStyle){
return
}
this._selectStyle=o;
if(this._defLabel){
var t=this._button[this._buttonInfo[0].id];
t.setText((o==DwtChooser.SINGLE_SELECT)?AjxMsg.select:AjxMsg.add)
}
if(!r){
var n=this.getSize();
this.resize(n.x,n.y)
}
if(this._allButtons){
this._addAllButton.setVisible(o==DwtChooser.MULTI_SELECT);
this._removeAllButton.setVisible(o==DwtChooser.MULTI_SELECT);
this._enableButtons()
}
if(o==DwtChooser.SINGLE_SELECT){
var s=this.targetListView.getList();
var e=s?s.clone().getArray():null;
if(e&&e.length){
this._reset(DwtChooserListView.TARGET);
this.addItems(e[0],DwtChooserListView.TARGET,true);
this.targetListView.deselectAll();
if(e.length>1&&this._mode==DwtChooser.MODE_MOVE){
this.addItems(e.slice(1),DwtChooserListView.SOURCE,true)
}
this._enableButtons()
}}
this.sourceListView.multiSelectEnabled=(o==DwtChooser.MULTI_SELECT);
this.targetListView.multiSelectEnabled=(o==DwtChooser.MULTI_SELECT)
};
DwtChooser.prototype.reset=function(e){
this._reset(e);
this._setActiveButton(this._buttonInfo[0].id);
this._enableButtons();
if(this._hasTextField){
this._textField.setValue("")
}};
DwtChooser.prototype._reset=function(e){
if(!e||e==DwtChooserListView.SOURCE){
this.sourceListView._resetList()
}
if(!e||e==DwtChooserListView.TARGET){
this.targetListView._resetList();
for(var t in this._data){
this._data[t].removeAll()
}}};
DwtChooser.prototype.addStateChangeListener=function(e){
this.targetListView.addStateChangeListener(e)
};
DwtChooser.prototype.removeStateChangeListener=function(e){
this.targetListView.removeStateChangeListener(e)
};
DwtChooser.prototype.getSourceListView=function(){
return document.getElementById(this._sourceListViewDivId)
};
DwtChooser.prototype.getButtons=function(){
return document.getElementById(this._buttonsDivId)
};
DwtChooser.prototype.getTargetListView=function(){
return document.getElementById(this._targetListViewDivId)
};
DwtChooser.prototype.getTextField=function(){
return this._textField
};
DwtChooser.prototype._createHtml=function(){
this._sourceListViewDivId=Dwt.getNextId();
this._targetListViewDivId=Dwt.getNextId();
this._buttonsDivId=Dwt.getNextId();
this._removeButtonDivId=Dwt.getNextId();
if(this._allButtons){
this._addAllButtonDivId=Dwt.getNextId();
this._removeAllButtonDivId=Dwt.getNextId()
}
if(this._hasTextField){
this._textFieldTdId=Dwt.getNextId()
}
var a=[];
var e=0;
if(this._layoutStyle==DwtChooser.HORIZ_STYLE){
a[e++]="<table cellspacing=0 cellpadding=0 border=0>";
a[e++]="<tr>";
a[e++]="<td id='";
a[e++]=this._sourceListViewDivId;
a[e++]="'></td>";
a[e++]="<td valign='middle' id='";
a[e++]=this._buttonsDivId;
a[e++]="'>";
if(this._allButtons){
a[e++]="<div id='";
a[e++]=this._addAllButtonDivId;
a[e++]="'></div><br>"
}
for(var t=0;
t<this._buttonInfo.length;
t++){
var o=this._buttonInfo[t].id;
a[e++]="<div id='";
a[e++]=this._buttonDivId[o];
a[e++]="'></div><br>"
}
a[e++]="<br><div id='";
a[e++]=this._removeButtonDivId;
a[e++]="'></div>";
if(this._allButtons){
a[e++]="<br><div id='";
a[e++]=this._removeAllButtonDivId;
a[e++]="'></div><br>"
}
a[e++]="</td>";
a[e++]="<td id='";
a[e++]=this._targetListViewDivId;
a[e++]="'></td>";
a[e++]="</tr>";
if(this._hasTextField){
a[e++]="<tr><td>";
a[e++]="<table border=0 width=100%><tr><td style='white-space:nowrap; width:1%'>";
a[e++]=AjxMsg.add;
a[e++]=":</td><td id='";
a[e++]=this._textFieldTdId;
a[e++]="'></td></tr></table>";
a[e++]="</td><td>&nbsp;</td><td>&nbsp;</td></tr>"
}
a[e++]="</table>"
}else{
a[e++]="<div id='";
a[e++]=this._sourceListViewDivId;
a[e++]="'></div>";
a[e++]="<div align='center' id='";
a[e++]=this._buttonsDivId;
a[e++]="'>";
a[e++]="<table><tr>";
if(this._allButtons){
a[e++]="<td id='";
a[e++]=this._addAllButtonDivId;
a[e++]="'></td>"
}
for(var t=0;
t<this._buttonInfo.length;
t++){
var o=this._buttonInfo[t].id;
a[e++]="<td id='";
a[e++]=this._buttonDivId[o];
a[e++]="'></td>"
}
a[e++]="<td id='";
a[e++]=this._removeButtonDivId;
a[e++]="'></td>";
if(this._allButtons){
a[e++]="<td id='";
a[e++]=this._removeAllButtonDivId;
a[e++]="'></td>"
}
a[e++]="</tr></table></div>";
a[e++]="<div id='";
a[e++]=this._targetListViewDivId;
a[e++]="'></div>"
}
this.getHtmlElement().innerHTML=a.join("")
};
DwtChooser.prototype._handleButtonInfo=function(t){
if(!t){
this._defLabel=(this._selectStyle==DwtChooser.SINGLE_SELECT)?AjxMsg.select:AjxMsg.add;
t=[{
label:this._defLabel}
]
}
this._buttonInfo=t;
this._buttonDivId={};
this._buttonId={};
if(this._buttonInfo.length==1){
if(!this._buttonInfo[0].id){
this._buttonInfo[0].id=Dwt.getNextId("DwtChooserButtonInfo_")
}
this._activeButtonId=this._buttonInfo[0].id
}
for(var e=0;
e<this._buttonInfo.length;
e++){
var a=this._buttonInfo[e].id;
this._buttonDivId[a]=Dwt.getNextId("DwtChooserButtonDiv_");
this._buttonId[a]=Dwt.getNextId("DwtChooserButton_")
}
this._hasMultiButtons=(this._buttonInfo.length>1)
};
DwtChooser.prototype._initialize=function(){
var e=new AjxListener(this,this._transferButtonListener);
this._button={};
this._buttonIndex={};
this._data={};
for(var t=0;
t<this._buttonInfo.length;
t++){
var o=this._buttonInfo[t].id;
this._button[o]=this._setupButton(o,this._buttonId[o],this._buttonDivId[o],this._buttonInfo[t].label);
this._button[o].addSelectionListener(e);
this._buttonIndex[o]=t;
this._data[o]=new AjxVector()
}
this.sourceListView=this._createSourceListView();
this._addListView(this.sourceListView,this._sourceListViewDivId);
this.sourceListView.addSelectionListener(new AjxListener(this,this._sourceListener));
this.targetListView=this._createTargetListView();
this._addListView(this.targetListView,this._targetListViewDivId);
this.targetListView.addSelectionListener(new AjxListener(this,this._targetListener));
this._removeButtonId=Dwt.getNextId("DwtChooserRemoveButton_");
this._removeButton=this._setupButton(DwtChooser.REMOVE_BTN_ID,this._removeButtonId,this._removeButtonDivId,AjxMsg.remove);
this._removeButton.addSelectionListener(new AjxListener(this,this._removeButtonListener));
if(this._allButtons){
this._addAllButtonId=Dwt.getNextId();
this._addAllButton=this._setupButton(DwtChooser.ADD_ALL_BTN_ID,this._addAllButtonId,this._addAllButtonDivId,AjxMsg.addAll);
this._addAllButton.addSelectionListener(new AjxListener(this,this._addAllButtonListener));
this._removeAllButtonId=Dwt.getNextId();
this._removeAllButton=this._setupButton(DwtChooser.REMOVE_ALL_BTN_ID,this._removeAllButtonId,this._removeAllButtonDivId,AjxMsg.removeAll);
this._removeAllButton.addSelectionListener(new AjxListener(this,this._removeAllButtonListener));
if(this._selectStyle==DwtChooser.SINGLE_SELECT){
this._addAllButton.setVisible(false);
this._removeAllButton.setVisible(false)
}}
if(this._hasTextField){
var a={
parent:this,type:DwtInputField.STRING};
this._textField=new DwtInputField(a);
this._textField.reparentHtmlElement(this._textFieldTdId);
this._textField._chooser=this;
this._textField.setHandler(DwtEvent.ONKEYUP,DwtChooser._onKeyUp);
Dwt.setSize(this._textField.getInputElement(),"100%",Dwt.DEFAULT)
}
if(this._selectStyle==DwtChooser.SINGLE_SELECT){
this.sourceListView.multiSelectEnabled=false;
this.targetListView.multiSelectEnabled=false
}};
DwtChooser.prototype._createSourceListView=function(){
return new DwtChooserListView(this,DwtChooserListView.SOURCE,this._slvClassName)
};
DwtChooser.prototype._createTargetListView=function(){
return new DwtChooserListView(this,DwtChooserListView.TARGET,this._tlvClassName)
};
DwtChooser.prototype._addListView=function(t,a){
var e=document.getElementById(a);
e.appendChild(t.getHtmlElement());
t.setUI(null,true);
t._initialized=true
};
DwtChooser.prototype.resize=function(n,e){
if(!n||!e){
return
}
if(n==Dwt.DEFAULT&&e==Dwt.DEFAULT){
return
}
var a=document.getElementById(this._buttonsDivId);
var r=Dwt.getSize(a);
var t,o,s;
if(this._layoutStyle==DwtChooser.HORIZ_STYLE){
t=this._listSize?this._listSize:(n==Dwt.DEFAULT)?n:Math.floor(((n-r.x)/2)-12);
o=s=e
}else{
t=n;
if(this._selectStyle==DwtChooser.SINGLE_SELECT){
o=this._listSize?this._listSize:(e==Dwt.DEFAULT)?e:e-r.y-this._singleHeight-30;
s=(e==Dwt.DEFAULT)?e:e-r.y-o-30
}else{
o=s=this._listSize?this._listSize:(e==Dwt.DEFAULT)?e:Math.floor(((e-r.y)/2)-12)
}}
this.sourceListView.setSize((t==Dwt.DEFAULT)?t:t+2,o);
this.targetListView.setSize((t==Dwt.DEFAULT)?t:t+2,s)
};
DwtChooser.prototype._setupButton=function(s,a,n,e){
var t=new DwtButton({
parent:this,id:a}
);
t.setText(e);
t.id=a;
t._buttonId=s;
var o=document.getElementById(n);
o.appendChild(t.getHtmlElement());
return t
};
DwtChooser.prototype._sourceListener=function(e){
if(e.detail==DwtListView.ITEM_DBL_CLICKED){
this.transfer(this.sourceListView.getSelection(),this._activeButtonId);
this.sourceListView.deselectAll()
}else{
if(this._activeButtonId==DwtChooser.REMOVE_BTN_ID){
var t=this._lastActiveTransferButtonId?this._lastActiveTransferButtonId:this._buttonInfo[0].id;
this._setActiveButton(t)
}}
this.targetListView.deselectAll();
this._enableButtons()
};
DwtChooser.prototype._targetListener=function(e){
if(e.detail==DwtListView.ITEM_DBL_CLICKED){
this.remove(this.targetListView.getSelection())
}else{
this._setActiveButton(DwtChooser.REMOVE_BTN_ID);
this.sourceListView.deselectAll();
this._enableButtons()
}};
DwtChooser.prototype._transferButtonListener=function(a){
var t=DwtControl.getTargetControl(a);
var s=t._buttonId;
var n=this.sourceListView.getSelection();
if(n&&n.length){
this.transfer(n,s);
var o=this.sourceListView.getList();
if(o&&o.size()){
this._selectFirst(DwtChooserListView.SOURCE)
}else{
this._enableButtons()
}}else{
var e=this._getEmailFromText();
if(e){
this.transfer([e],s)
}else{
this._setActiveButton(s)
}}};
DwtChooser.prototype._removeButtonListener=function(e){
this.remove(this.targetListView.getSelection());
var t=this.targetListView.getList();
if(t&&t.size()){
this._selectFirst(DwtChooserListView.TARGET)
}else{
this._enableButtons()
}};
DwtChooser.prototype._addAllButtonListener=function(e){
this.transfer(this.sourceListView.getList().clone());
this._selectFirst(DwtChooserListView.TARGET)
};
DwtChooser.prototype._removeAllButtonListener=function(e){
this.remove(this.targetListView.getList().clone());
this._selectFirst(DwtChooserListView.SOURCE)
};
DwtChooser.prototype._enableButtons=function(a,r){
var h=this.sourceListView.getList();
var c=this.targetListView.getList();
var o=(a||(this.sourceListView.getSelectionCount()>0));
for(var s=0;
s<this._buttonInfo.length;
s++){
var t=this._buttonInfo[s].id;
this._button[t].setEnabled(o)
}
var l=(r||(this.targetListView.getSelectionCount()>0));
this._removeButton.setEnabled(l);
if(this._allButtons&&(this._selectStyle==DwtChooser.MULTI_SELECT)){
var e=h?h.size():0;
var n=c?c.size():0;
this._addAllButton.setEnabled(e>0);
this._removeAllButton.setEnabled(n>0)
}};
DwtChooser.prototype._selectFirst=function(t,a){
var e=(t==DwtChooserListView.SOURCE)?this.sourceListView:this.targetListView;
var o=e.getList();
if(o&&o.size()>0){
e.setSelection(o.get(0))
}};
DwtChooser.prototype._setActiveButton=function(o){
if(!this._hasMultiButtons){
return
}
if(o!=this._activeButtonId){
var a=(this._activeButtonId==DwtChooser.REMOVE_BTN_ID)?this._removeButtonId:this._buttonId[this._activeButtonId];
if(a){
var e=DwtControl.findControl(document.getElementById(a));
if(e){
e.setDisplayState(DwtControl.NORMAL)
}}
a=(o==DwtChooser.REMOVE_BTN_ID)?this._removeButtonId:this._buttonId[o];
var t=DwtControl.findControl(document.getElementById(a));
if(t){
t.setDisplayState(DwtControl.DEFAULT)
}
this._activeButtonId=o;
if(o!=DwtChooser.REMOVE_BTN_ID){
this._lastActiveTransferButtonId=o
}}};
DwtChooser.prototype._isDuplicate=function(e,t){
return t.contains(e)
};
DwtChooser.prototype._addToSource=function(a,e,t){
if(!a){
return
}
if(!a._chooserIndex){
var o=this.sourceListView.getList();
a._chooserIndex=o?o.size()+1:1
}
this.sourceListView.addItem(a,e,t)
};
DwtChooser.prototype._addToTarget=function(l,e,s){
if(!l){
return
}
e=e?e:this._activeButtonId;
if(this._noDuplicates&&this._data[e]&&this._isDuplicate(l,this._data[e])){
return
}
var n=this.targetListView.getList();
if(n&&n.contains(l)&&l.clone){
var a=l.clone();
a.id=Dwt.getNextId();
l=a
}
var r=null;
if(this._hasMultiButtons){
n=[];
for(var t=0;
t<this._buttonInfo.length;
t++){
n=n.concat(this._data[this._buttonInfo[t].id].getArray())
}
var o=this._buttonIndex[e];
for(r=0;
r<n.length;
r++){
var h=this._buttonIndex[n[r]._buttonId];
if(h>o){
break
}}}
l._buttonId=e;
l.id=l.id||Dwt.getNextId();
this._data[e].add(l);
this.targetListView.addItem(l,r,s)
};
DwtChooser.prototype._removeFromSource=function(t,e){
if(!t){
return
}
var a=this.sourceListView.getList();
if(!a){
return
}
if(!a.contains(t)){
return
}
this.sourceListView.removeItem(t,e)
};
DwtChooser.prototype._removeFromTarget=function(t,e){
if(!t){
return
}
var a=this.targetListView.getList();
if(!a){
return
}
if(!a.contains(t)){
return
}
this._data[t._buttonId].remove(t);
this.targetListView.removeItem(t,e)
};
DwtChooser.prototype._getInsertionIndex=function(t,n){
var s=t.getList();
if(!s){
return null
}
var e=s.getArray();
for(var o=0;
o<e.length;
o++){
if(n._chooserIndex&&e[o]._chooserIndex&&(e[o]._chooserIndex>=n._chooserIndex)){
return o
}}
return null
};
DwtChooser.prototype._getEmailFromText=function(){
if(this._hasTextField){
var t=this._textField.getValue();
var e=AjxEmailAddress.parse(t);
if(e){
e.id=Dwt.getNextId();
return e
}}};
DwtChooser._onKeyUp=function(n){
var a=DwtUiEvent.getTarget(n);
var s=DwtControl.findControl(a);
var o=s._chooser;
var t=DwtKeyEvent.getCharCode(n);
if(t==3||t==13){
var e=o._getEmailFromText();
if(e){
o.transfer([e],o._activeButtonId);
a.value=""
}}
o._enableButtons(a.value.length)
};
DwtChooserListView=function(e){
if(arguments.length==0){
return
}
e=Dwt.getParams(arguments,DwtChooserListView.PARAMS);
e.className=e.className||"DwtChooserListView";
e.headerList=this._getHeaderList(parent);
DwtListView.call(this,e);
this.type=e.type;
this._chooserParent=e.parent.parent
};
DwtChooserListView.PARAMS=["parent","type","className","view"];
DwtChooserListView.SOURCE=1;
DwtChooserListView.TARGET=2;
DwtChooserListView.prototype=new DwtListView;
DwtChooserListView.prototype.constructor=DwtChooserListView;
DwtChooserListView.prototype._getHeaderList=function(){};
DwtChooserListView.prototype.toString=function(){
return"DwtChooserListView"
};
DwtChooserListView.prototype.setUI=function(t,e){
e=e?e:((this.type==DwtChooserListView.TARGET)||this.parent._sourceEmptyOk);
DwtListView.prototype.setUI.call(this,t,e)
};
DwtChooserListView.prototype._itemClicked=function(e,t){
if(!t.shiftKey&&!t.ctrlKey&&t.button==DwtMouseEvent.RIGHT){
return
}else{
DwtListView.prototype._itemClicked.call(this,e,t)
}};
DwtChooserListView.prototype._sortColumn=function(t,e){
this._chooserParent.search(t,e)
};
DwtChooserListView.prototype._getHeaderSashLocation=function(){
var t=this.getHtmlElement();
if(Dwt.getPosition(t)==Dwt.ABSOLUTE_STYLE){
return DwtListView.prototype._getHeaderSashLocation.call(this)
}
var a=Dwt.toWindow(t,0,0);
var e=Dwt.toWindow(this._chooserParent.getHtmlElement(),0,0);
if(!this._tmpPoint){
this._tmpPoint=new DwtPoint()
}
this._tmpPoint.x=a.x-e.x;
this._tmpPoint.y=a.y-e.y;
return this._tmpPoint
}
}
if(AjxPackage.define("zimbraMail.abook.model.ZmAddrBook")){
ZmAddrBook=function(e){
e.type=ZmOrganizer.ADDRBOOK;
ZmFolder.call(this,e)
};
ZmAddrBook.prototype=new ZmFolder;
ZmAddrBook.prototype.constructor=ZmAddrBook;
ZmAddrBook.ID_ADDRESSBOOK=ZmOrganizer.ID_ADDRBOOK;
ZmAddrBook.sortCompare=function(n,o){
var t=ZmOrganizer.checkSortArgs(n,o);
if(t!=null){
return t
}
if(n.link!=o.link){
return n.link?1:-1
}
if(n.nId==ZmFolder.ID_TRASH){
return 1
}
if(o.nId==ZmFolder.ID_TRASH){
return -1
}
var e=n.name.toLowerCase();
var a=o.name.toLowerCase();
if(e<a){
return -1
}
if(e>a){
return 1
}
return 0
};
ZmAddrBook.prototype.toString=function(){
return"ZmAddrBook"
};
ZmAddrBook.prototype.getIcon=function(){
if(this.nId==ZmFolder.ID_ROOT){
return null
}
if(this.nId==ZmFolder.ID_TRASH){
return"Trash"
}
if(this.link||this.isRemote()){
return"SharedContactsFolder"
}
if(this.nId==ZmFolder.ID_AUTO_ADDED){
return"EmailedContacts"
}
return"ContactsFolder"
};
ZmAddrBook.prototype.supportsPublicAccess=function(){
return true
};
ZmAddrBook.prototype.mayContain=function(s){
if(!s){
return true
}
if(this.id==ZmOrganizer.ID_DLS){
return false
}
if(s instanceof ZmAddrBook){
if(!appCtxt.multiAccounts){
return true
}
return this.mayContainFolderFromAccount(s.getAccount())
}
if(this.nId==ZmOrganizer.ID_ROOT){
return false
}
if(this.link){
if(this.isReadOnly()){
return false
}}
var t=(s instanceof Array)?s:[s];
var o=t[0];
if(o.type!=ZmItem.CONTACT&&o.type!=ZmItem.GROUP){
return false
}
if(o.folderId){
var n=true;
for(var a=0;
a<t.length;
a++){
var e=appCtxt.getById(t[a].folderId);
if(e!=this){
n=false;
break
}}
return !n
}
return true
}
}
if(AjxPackage.define("zimbraMail.abook.model.ZmContact")){
if(!window.ZmContact){
ZmContact=function(o,a,t,e){
if(arguments.length==0){
return
}
t=t||ZmItem.CONTACT;
ZmItem.call(this,t,o,a);
this.folderId=e;
this.attr={};
this.isGal=(this.list&&this.list.isGal);
this.participants=new AjxVector()
};
ZmContact.prototype=new ZmItem;
ZmContact.prototype.constructor=ZmContact;
ZmContact.F_anniversary="anniversary";
ZmContact.F_assistantPhone="assistantPhone";
ZmContact.F_attachment="attachment";
ZmContact.F_birthday="birthday";
ZmContact.F_callbackPhone="callbackPhone";
ZmContact.F_carPhone="carPhone";
ZmContact.F_company="company";
ZmContact.F_companyPhone="companyPhone";
ZmContact.F_custom="custom";
ZmContact.F_description="description";
ZmContact.F_department="department";
ZmContact.F_dlist="dlist";
ZmContact.F_email="email";
ZmContact.F_email2="email2";
ZmContact.F_email3="email3";
ZmContact.F_fileAs="fileAs";
ZmContact.F_firstName="firstName";
ZmContact.F_folderId="folderId";
ZmContact.F_homeCity="homeCity";
ZmContact.F_homeCountry="homeCountry";
ZmContact.F_homeFax="homeFax";
ZmContact.F_homePhone="homePhone";
ZmContact.F_homePhone2="homePhone2";
ZmContact.F_homePostalCode="homePostalCode";
ZmContact.F_homeState="homeState";
ZmContact.F_homeStreet="homeStreet";
ZmContact.F_homeURL="homeURL";
ZmContact.F_image="image";
ZmContact.F_imAddress="imAddress";
ZmContact.F_imAddress1="imAddress1";
ZmContact.F_imAddress2="imAddress2";
ZmContact.F_imAddress3="imAddress3";
ZmContact.F_jobTitle="jobTitle";
ZmContact.F_lastName="lastName";
ZmContact.F_maidenName="maidenName";
ZmContact.F_middleName="middleName";
ZmContact.F_mobilePhone="mobilePhone";
ZmContact.F_namePrefix="namePrefix";
ZmContact.F_nameSuffix="nameSuffix";
ZmContact.F_nickname="nickname";
ZmContact.F_notes="notes";
ZmContact.F_otherCity="otherCity";
ZmContact.F_otherCountry="otherCountry";
ZmContact.F_otherFax="otherFax";
ZmContact.F_otherPhone="otherPhone";
ZmContact.F_otherPostalCode="otherPostalCode";
ZmContact.F_otherState="otherState";
ZmContact.F_otherStreet="otherStreet";
ZmContact.F_otherURL="otherURL";
ZmContact.F_pager="pager";
ZmContact.F_phoneticFirstName="phoneticFirstName";
ZmContact.F_phoneticLastName="phoneticLastName";
ZmContact.F_phoneticCompany="phoneticCompany";
ZmContact.F_type="type";
ZmContact.F_workAltPhone="workAltPhone";
ZmContact.F_workCity="workCity";
ZmContact.F_workCountry="workCountry";
ZmContact.F_workEmail1="workEmail1";
ZmContact.F_workEmail2="workEmail2";
ZmContact.F_workEmail3="workEmail3";
ZmContact.F_workFax="workFax";
ZmContact.F_workMobile="workMobile";
ZmContact.F_workPhone="workPhone";
ZmContact.F_workPhone2="workPhone2";
ZmContact.F_workPostalCode="workPostalCode";
ZmContact.F_workState="workState";
ZmContact.F_workStreet="workStreet";
ZmContact.F_workURL="workURL";
ZmContact.X_fileAs="fileAs";
ZmContact.X_firstLast="firstLast";
ZmContact.X_fullName="fullName";
ZmContact.X_vcardXProps="vcardXProps";
ZmContact.X_outlookUserField="outlookUserField";
ZmContact.MC_cardOwner="cardOwner";
ZmContact.MC_workCardMessage="workCardMessage";
ZmContact.MC_homeCardMessage="homeCardMessage";
ZmContact.MC_homePhotoURL="homePhotoURL";
ZmContact.MC_workPhotoURL="workPhotoURL";
ZmContact.GAL_MODIFY_TIMESTAMP="modifyTimeStamp";
ZmContact.GAL_CREATE_TIMESTAMP="createTimeStamp";
ZmContact.GAL_ZIMBRA_ID="zimbraId";
ZmContact.GAL_OBJECT_CLASS="objectClass";
ZmContact.GAL_MAIL_FORWARD_ADDRESS="zimbraMailForwardingAddress";
ZmContact.GAL_CAL_RES_TYPE="zimbraCalResType";
ZmContact.GAL_CAL_RES_LOC_NAME="zimbraCalResLocationDisplayName";
var i=1;
ZmContact.FA_LAST_C_FIRST=i++;
ZmContact.FA_FIRST_LAST=i++;
ZmContact.FA_COMPANY=i++;
ZmContact.FA_LAST_C_FIRST_COMPANY=i++;
ZmContact.FA_FIRST_LAST_COMPANY=i++;
ZmContact.FA_COMPANY_LAST_C_FIRST=i++;
ZmContact.FA_COMPANY_FIRST_LAST=i++;
ZmContact.FA_CUSTOM=i++;
ZmContact.ADDRESS_FIELDS=[ZmContact.F_homeCity,ZmContact.F_homeCountry,ZmContact.F_homePostalCode,ZmContact.F_homeState,ZmContact.F_homeStreet,ZmContact.F_workCity,ZmContact.F_workCountry,ZmContact.F_workPostalCode,ZmContact.F_workState,ZmContact.F_workStreet,ZmContact.F_otherCity,ZmContact.F_otherCountry,ZmContact.F_otherPostalCode,ZmContact.F_otherState,ZmContact.F_otherStreet];
ZmContact.EMAIL_FIELDS=[ZmContact.F_email,ZmContact.F_workEmail1,ZmContact.F_workEmail2,ZmContact.F_workEmail3];
ZmContact.IM_FIELDS=[ZmContact.F_imAddress];
ZmContact.OTHER_FIELDS=[ZmContact.F_birthday,ZmContact.F_anniversary,ZmContact.F_custom];
ZmContact.PHONE_FIELDS=[ZmContact.F_mobilePhone,ZmContact.F_workPhone,ZmContact.F_workFax,ZmContact.F_companyPhone,ZmContact.F_homePhone,ZmContact.F_homeFax,ZmContact.F_pager,ZmContact.F_callbackPhone,ZmContact.F_assistantPhone,ZmContact.F_carPhone,ZmContact.F_otherPhone,ZmContact.F_otherFax,ZmContact.F_workAltPhone,ZmContact.F_workMobile];
ZmContact.PRIMARY_FIELDS=[ZmContact.F_image,ZmContact.F_namePrefix,ZmContact.F_firstName,ZmContact.F_phoneticFirstName,ZmContact.F_middleName,ZmContact.F_maidenName,ZmContact.F_lastName,ZmContact.F_phoneticLastName,ZmContact.F_nameSuffix,ZmContact.F_nickname,ZmContact.F_jobTitle,ZmContact.F_department,ZmContact.F_company,ZmContact.F_phoneticCompany,ZmContact.F_fileAs,ZmContact.F_folderId,ZmContact.F_notes];
ZmContact.URL_FIELDS=[ZmContact.F_homeURL,ZmContact.F_workURL,ZmContact.F_otherURL];
ZmContact.GAL_FIELDS=[ZmContact.GAL_MODIFY_TIMESTAMP,ZmContact.GAL_CREATE_TIMESTAMP,ZmContact.GAL_ZIMBRA_ID,ZmContact.GAL_OBJECT_CLASS,ZmContact.GAL_MAIL_FORWARD_ADDRESS,ZmContact.GAL_CAL_RES_TYPE,ZmContact.GAL_CAL_RES_LOC_NAME,ZmContact.F_type];
ZmContact.MYCARD_FIELDS=[ZmContact.MC_cardOwner,ZmContact.MC_homeCardMessage,ZmContact.MC_homePhotoURL,ZmContact.MC_workCardMessage,ZmContact.MC_workPhotoURL];
ZmContact.X_FIELDS=[ZmContact.X_firstLast,ZmContact.X_fullName,ZmContact.X_vcardXProps];
ZmContact.IGNORE_NORMALIZATION=[];
ZmContact.updateFieldConstants=function(){
ZmContact.DISPLAY_FIELDS=[].concat(ZmContact.ADDRESS_FIELDS,ZmContact.EMAIL_FIELDS,ZmContact.IM_FIELDS,ZmContact.OTHER_FIELDS,ZmContact.PHONE_FIELDS,ZmContact.PRIMARY_FIELDS,ZmContact.URL_FIELDS);
ZmContact.IGNORE_FIELDS=[].concat(ZmContact.GAL_FIELDS,ZmContact.MYCARD_FIELDS,ZmContact.X_FIELDS);
ZmContact.ALL_FIELDS=[].concat(ZmContact.DISPLAY_FIELDS,ZmContact.IGNORE_FIELDS);
ZmContact.IS_DATE={};
ZmContact.IS_DATE[ZmContact.F_birthday]=true;
ZmContact.IS_DATE[ZmContact.F_anniversary]=true;
ZmContact.IS_IGNORE={};
for(var e=0;
e<ZmContact.IGNORE_FIELDS.length;
e++){
ZmContact.IS_IGNORE[ZmContact.IGNORE_FIELDS[e]]=true
}
ZmContact.DL_PAGE_SIZE=100
};
ZmContact.updateFieldConstants();
ZmContact.IS_ADDONE={};
ZmContact.IS_ADDONE[ZmContact.F_custom]=true;
ZmContact.IS_ADDONE[ZmContact.F_imAddress]=true;
ZmContact.IS_ADDONE[ZmContact.X_outlookUserField]=true;
ZmContact.getAttributeName=function(t,e){
e=e||1;
return e>1||ZmContact.IS_ADDONE[t]?t+e:t
};
ZmContact.prototype.toString=function(){
return"ZmContact"
};
ZmContact.createFromDom=function(a,t){
var e=appCtxt.cacheGet(a.id);
if(e==null||(e&&e.rev!=a.rev)){
e=new ZmContact(a.id,t.list);
e._loadFromDom(a)
}else{
AjxUtil.hashUpdate(e.attr,a._attrs);
e.list=t.list||new ZmContactList(null)
}
return e
};
ZmContact.compareByFileAs=function(o,e){
var t=(o instanceof ZmContact)?o.getFileAs(true):ZmContact.computeFileAs(o._attrs).toLowerCase();
var n=(e instanceof ZmContact)?e.getFileAs(true):ZmContact.computeFileAs(e._attrs).toLowerCase();
if(!n||(t>n)){
return 1
}
if(t<n){
return -1
}
return 0
};
ZmContact.computeFileAs=function(a){
var t=(a instanceof ZmContact)?a.getAttrs():a;
if(!t){
return
}
var s=parseInt(t.fileAs);
var n;
var e=0;
switch(s){
case ZmContact.FA_LAST_C_FIRST:default:if(a&&a.isGal){
if(t.fullName){
return(t.fullName instanceof Array)?t.fullName[0]:t.fullName
}
return((t.email instanceof Array)?t.email[0]:t.email)
}
n=ZmContact.fileAsLastFirst(t.firstName,t.lastName,t.fullName,t.nickname);
break;
case ZmContact.FA_FIRST_LAST:n=ZmContact.fileAsFirstLast(t.firstName,t.lastName,t.fullName,t.nickname);
break;
case ZmContact.FA_COMPANY:if(t.company){
n=t.company
}
break;
case ZmContact.FA_LAST_C_FIRST_COMPANY:var o=ZmContact.fileAsLastFirst(t.firstName,t.lastName,t.fullName,t.nickname);
n=ZmContact.fileAsNameCompany(o,t.company);
break;
case ZmContact.FA_FIRST_LAST_COMPANY:var o=ZmContact.fileAsFirstLast(t.firstName,t.lastName,t.fullName,t.nickname);
n=ZmContact.fileAsNameCompany(o,t.company);
break;
case ZmContact.FA_COMPANY_LAST_C_FIRST:var o=ZmContact.fileAsLastFirst(t.firstName,t.lastName);
n=ZmContact.fileAsCompanyName(o,t.company);
break;
case ZmContact.FA_COMPANY_FIRST_LAST:var o=ZmContact.fileAsFirstLast(t.firstName,t.lastName);
n=ZmContact.fileAsCompanyName(o,t.company);
break;
case ZmContact.FA_CUSTOM:return t.fileAs.substring(2);
break
}
return n||t.fullName||""
};
ZmContact.fileAsFirstLast=function(o,a,t,e){
if(o&&a){
return AjxMessageFormat.format(ZmMsg.fileAsFirstLast,[o,a])
}
return o||a||t||e||""
};
ZmContact.fileAsLastFirst=function(o,a,t,e){
if(o&&a){
return AjxMessageFormat.format(ZmMsg.fileAsLastFirst,[o,a])
}
return o||a||t||e||""
};
ZmContact.fileAsNameCompany=function(t,e){
if(t&&e){
return AjxMessageFormat.format(ZmMsg.fileAsNameCompany,[t,e])
}
if(e){
return AjxMessageFormat.format(ZmMsg.fileAsCompanyAsSecondaryOnly,[e])
}
return t
};
ZmContact.fileAsCompanyName=function(t,e){
if(e&&t){
return AjxMessageFormat.format(ZmMsg.fileAsCompanyName,[t,e])
}
if(t){
return AjxMessageFormat.format(ZmMsg.fileAsNameAsSecondaryOnly,[t])
}
return e
};
ZmContact.computeCustomFileAs=function(e){
return[ZmContact.FA_CUSTOM,":",e].join("")
};
ZmContact.getAttr=function(t,e){
return(t instanceof ZmContact)?t.getAttr(e):(t&&t._attrs)?t._attrs[e]:null
};
ZmContact.getNormalizedAttrs=function(d,s,h){
var r={};
if(d){
var l=AjxUtil.keys(d);
l.sort(ZmContact.__BY_ATTRIBUTE);
var c={};
for(var o=0;
o<l.length;
o++){
var e=l[o];
var t=e.replace(/\d+$/,"");
if(s&&s!=t){
continue
}
if(AjxUtil.isArray(h)&&AjxUtil.indexOf(h,t)!=-1){
r[e]=d[e]
}else{
if(!c[t]){
c[t]=0
}
var n=ZmContact.getAttributeName(t,++c[t]);
r[n]=d[e]
}}}
return r
};
ZmContact.__RE_ATTRIBUTE=/^(.*?)(\d+)$/;
ZmContact.__BY_ATTRIBUTE=function(t,e){
var o=t.match(ZmContact.__RE_ATTRIBUTE)||[t,t,1];
var n=e.match(ZmContact.__RE_ATTRIBUTE)||[e,e,1];
return o[1]==n[1]?Number(o[2])-Number(n[2]):o[1].localeCompare(n[1])
};
ZmContact.setAttr=function(t,e,a){
if(t instanceof ZmContact){
t.setAttr(e,a)
}else{
t._attrs[e]=a
}};
ZmContact.isInTrash=function(e){
var t=(e instanceof ZmContact)?e.folderId:e.l;
var a=appCtxt.getById(t);
return(a&&a.isInTrash())
};
ZmContact.prototype.load=function(s,t,e){
var n={
GetContactsRequest:{
_jsns:"urn:zimbraMail"}};
var a=n.GetContactsRequest;
a.cn=[{
id:this.id}
];
var o=new AjxCallback(this,this._handleLoadResponse,[s]);
if(e){
var n={
GetContactsRequest:{
_jsns:"urn:zimbraMail"}};
n.GetContactsRequest.cn={
id:this.id};
e.addRequestParams(n,o,t)
}else{
appCtxt.getAppController().sendRequest({
jsonObj:n,asyncMode:true,callback:o,errorCallback:t}
)
}};
ZmContact.prototype._handleLoadResponse=function(a,e){
var t=e.getResponse().GetContactsResponse;
this.attr=t.cn[0]._attrs;
this.isLoaded=true;
if(a){
a.run(t.cn[0],this)
}};
ZmContact.prototype.clear=function(){};
ZmContact.prototype.isEmpty=function(){
for(var e in this.attr){
return false
}
return true
};
ZmContact.prototype.isShared=function(){
return this.addrbook&&this.addrbook.link
};
ZmContact.prototype.isReadOnly=function(){
if(this.isGal){
return true
}
return this.isShared()?this.addrbook&&this.addrbook.isReadOnly():false
};
ZmContact.prototype.isGroup=function(){
return Boolean(this.getAttr(ZmContact.F_dlist)||this.type==ZmItem.GROUP)
};
ZmContact.prototype.getGroupMembers=function(){
return this.isGroup()?AjxEmailAddress.parseEmailString(this.getAttr(ZmContact.F_dlist)):null
};
ZmContact.prototype.getIcon=function(){
if(this.isGal){
return"GALContact"
}
if(this.isShared()){
return"SharedContact"
}
if(this.isGroup()){
return"Group"
}
return"Contact"
};
ZmContact.prototype.getFolderId=function(){
return this.isShared()?this.folderId.split(":")[0]:this.folderId
};
ZmContact.prototype.getAttr=function(e){
var t=this.attr[e];
return t?((t instanceof Array)?t[0]:t):""
};
ZmContact.prototype.setAttr=function(e,t){
this.attr[e]=t
};
ZmContact.prototype.setParticipantStatus=function(e){
this.participantStatus=e
};
ZmContact.prototype.getParticipantStatus=function(){
return this.participantStatus
};
ZmContact.prototype.setParticipantRole=function(e){
this.participantRole=e
};
ZmContact.prototype.getParticipantRole=function(){
return this.participantRole
};
ZmContact.prototype.removeAttr=function(e){
delete this.attr[e]
};
ZmContact.prototype.getAttrs=function(a){
var t=this.attr;
if(a){
t={};
for(var e in this.attr){
if(e.replace(/\d+$/,"")==a){
t[e]=this.attr[e]
}}}
return t
};
ZmContact.prototype.getNormalizedAttrs=function(e){
return ZmContact.getNormalizedAttrs(this.attr,e,ZmContact.IGNORE_NORMALIZATION)
};
ZmContact.prototype.create=function(s,o){
var l={
CreateContactRequest:{
_jsns:"urn:zimbraMail"}};
var n=l.CreateContactRequest;
var r=n.cn={};
var a=s[ZmContact.F_folderId]||ZmFolder.ID_CONTACTS;
var t=appCtxt.getById(a);
if(t&&t.isRemote()){
a=t.getRemoteId()
}
r.l=a;
r.a=[];
for(var e in s){
if(e==ZmContact.F_folderId||e=="objectClass"||e=="zimbraId"||e=="createTimeStamp"||e=="modifyTimeStamp"){
continue
}
this._addRequestAttr(r,e,s[e])
}
var h=new AjxCallback(this,this._handleResponseCreate,[s,o!=null]);
if(o){
o.addRequestParams(l,h)
}else{
appCtxt.getAppController().sendRequest({
jsonObj:l,asyncMode:true,callback:h}
)
}};
ZmContact.prototype._handleResponseCreate=function(t,n,e){
if(n){
return
}
var h=e.getResponse().CreateContactResponse;
cn=h?h.cn[0]:null;
var l=cn?cn.id:null;
if(l){
this._fileAs=null;
this._fullName=null;
this.id=l;
this.modified=cn.md;
this.folderId=cn.l||ZmOrganizer.ID_ADDRBOOK;
for(var o in t){
if(!(t[o]==undefined||t[o]=="")){
this.setAttr(o,t[o])
}}
var r=this.isGroup()?ZmMsg.groupCreated:ZmMsg.contactCreated;
appCtxt.getAppController().setStatusMsg(r)
}else{
var r=this.isGroup()?ZmMsg.errorCreateGroup:ZmMsg.errorCreateContact;
var s=ZmMsg.errorTryAgain+"\n"+ZmMsg.errorContact;
appCtxt.getAppController().setStatusMsg(r,ZmStatusView.LEVEL_CRITICAL,s)
}};
ZmContact.prototype.createFromVCard=function(t,e){
var n={
CreateContactRequest:{
_jsns:"urn:zimbraMail"}};
var o=n.CreateContactRequest.cn={
l:ZmFolder.ID_CONTACTS};
o.vcard={
mid:t,part:e};
var a={
jsonObj:n,asyncMode:true,callback:(new AjxCallback(this,this._handleResponseCreateVCard)),errorCallback:(new AjxCallback(this,this._handleErrorCreateVCard))};
appCtxt.getAppController().sendRequest(a)
};
ZmContact.prototype._handleResponseCreateVCard=function(e){
appCtxt.getAppController().setStatusMsg(ZmMsg.contactCreated)
};
ZmContact.prototype._handleErrorCreateVCard=function(e){
appCtxt.getAppController().setStatusMsg(ZmMsg.errorCreateContact,ZmStatusView.LEVEL_CRITICAL)
};
ZmContact.prototype.modify=function(r,d){
if(this.list.isGal){
return
}
var m={
ModifyContactRequest:{
_jsns:"urn:zimbraMail",replace:"0",force:"1"}};
var l=m.ModifyContactRequest.cn={
id:this.id};
l.a=[];
var t=false;
for(var e in r){
if(e==ZmContact.F_folderId){
continue
}
this._addRequestAttr(l,e,(r[e]&&r[e].value)||r[e]);
t=true
}
if(ZmContact.F_firstName in r||ZmContact.F_lastName in r||ZmContact.F_company in r||ZmContact.X_fileAs in r){
var s={};
var n=[ZmContact.F_firstName,ZmContact.F_lastName,ZmContact.F_company,ZmContact.X_fileAs];
for(var o=0;
o<n.length;
o++){
var h=n[o];
var c=r[h];
s[h]=c!=null?c:this.getAttr(h)
}
var a=ZmContact.computeFileAs(s);
this._addRequestAttr(l,ZmContact.X_fullName,a)
}
if(t){
var u=new AjxCallback(this,this._handleResponseModify,[r,d]);
appCtxt.getAppController().sendRequest({
jsonObj:m,asyncMode:true,callback:u}
)
}else{
if(r[ZmContact.F_folderId]){
this._setFolder(r[ZmContact.F_folderId])
}}};
ZmContact.prototype._handleResponseModify=function(t,r,e){
var o=e.getResponse().ModifyContactResponse;
var s=o?o.cn[0]:null;
var n=s?s.id:null;
if(n&&n==this.id){
appCtxt.setStatusMsg(this.isGroup()?ZmMsg.groupSaved:ZmMsg.contactSaved);
if(t[ZmContact.F_folderId]&&this.folderId!=t[ZmContact.F_folderId]){
this._setFolder(t[ZmContact.F_folderId])
}}else{
var a=ZmMsg.errorTryAgain+"\n"+ZmMsg.errorContact;
appCtxt.getAppController().setStatusMsg(ZmMsg.errorModifyContact,ZmStatusView.LEVEL_CRITICAL,a)
}};
ZmContact.prototype._handleResponseMove=function(e,o){
var a=e&&appCtxt.getById(e);
var t=1;
if(a){
appCtxt.setStatusMsg(AjxMessageFormat.format(ZmMsg.actionMove,[t,AjxMessageFormat.format(ZmMsg[ZmItem.COUNT_KEY[ZmItem.CONTACT]],t),a.name]))
}
this._notify(ZmEvent.E_MODIFY,o)
};
ZmContact.prototype._setFolder=function(a){
var o=appCtxt.getById(this.folderId);
var e=o?o.nId:null;
if(e==a){
return
}
var n=appCtxt.getById(a);
if(this.isShared()||(n&&n.link)){
if(this.list){
this.list.moveItems({
items:[this],folder:n}
)
}}else{
var r={
ContactActionRequest:{
_jsns:"urn:zimbraMail"}};
r.ContactActionRequest.action={
id:this.id,op:"move",l:a};
var s=new AjxCallback(this,this._handleResponseMove,[a]);
var t=appCtxt.multiAccounts&&appCtxt.accountList.mainAccount.name;
appCtxt.getAppController().sendRequest({
jsonObj:r,asyncMode:true,callback:s,accountName:t}
)
}};
ZmContact.prototype.notifyModify=function(h,o){
var u=ZmItem.prototype.notifyModify.apply(this,arguments);
var n=window.parentAppCtxt||window.appCtxt;
n.clearAutocompleteCache(ZmAutocomplete.AC_TYPE_CONTACT);
if(u){
return u
}
var r=this.getFileAs();
var l=this.getFullName();
this._resetCachedFields();
var s={};
if(h._attrs){
var t=this.getAttrs();
for(var d in t){
s[d]=t[d];
if(h._attrs[d]==null){
this.removeAttr(d)
}}
for(var d in h._attrs){
this.setAttr(d,h._attrs[d])
}}
var e={
attr:h._attrs,oldAttr:s,fullNameChanged:(this.getFullName()!=l),fileAsChanged:(this.getFileAs()!=r),contact:this};
this.list.modifyLocal(h,e);
this._notify(ZmEvent.E_MODIFY,h);
var c=this.getBuddy();
if(c){
c._notifySetName(c.name)
}};
ZmContact.prototype.notifyDelete=function(){
ZmItem.prototype.notifyDelete.call(this);
var e=window.parentAppCtxt||window.appCtxt;
e.clearAutocompleteCache(ZmAutocomplete.AC_TYPE_CONTACT)
};
ZmContact.prototype.initFromEmail=function(e,t){
if(e instanceof AjxEmailAddress){
this.setAttr(ZmContact.F_email,e.getAddress());
this._initFullName(e,t)
}else{
this.setAttr(ZmContact.F_email,e)
}};
ZmContact.prototype.initFromPhone=function(e,t){
this.setAttr(t||ZmContact.F_companyPhone,e)
};
ZmContact.prototype.getEmail=function(t){
var e=(this.getAttr(ZmContact.F_email)||this.getAttr(ZmContact.F_workEmail1)||this.getAttr(ZmContact.F_email2)||this.getAttr(ZmContact.F_workEmail2)||this.getAttr(ZmContact.F_email3)||this.getAttr(ZmContact.F_workEmail3));
if(t){
e=AjxEmailAddress.parse(e);
if(e){
e.isGroup=this.isGroup;
e.canExpand=this.canExpand
}}
return e
};
ZmContact.prototype.getLookupEmail=function(t){
var e=this._lookupEmail;
if(t&&e){
e=AjxEmailAddress.parse(e);
e.isGroup=this.isGroup;
e.canExpand=this.canExpand
}
return e
};
ZmContact.prototype.getIMAddress=function(){
return this.getAttr(ZmContact.F_imAddress1)||this.getAttr(ZmContact.F_imAddress2)||this.getAttr(ZmContact.F_imAddress3)
};
ZmContact.prototype.getBuddy=function(){
var e;
if(appCtxt.get(ZmSetting.IM_ENABLED)&&ZmImApp.loggedIn()){
var t=AjxDispatcher.run("GetRoster");
e=t.getRosterItem(this.getAttr(ZmContact.F_email),false)||t.getRosterItem(this.getAttr(ZmContact.F_email2),false)||t.getRosterItem(this.getAttr(ZmContact.F_email3),false)||t.getRosterItem(this.getIMAddress(),true)
}
return e
};
ZmContact.prototype.getImPresence=function(){
var e=this.getBuddy();
return(e)?e.getPresence():null
};
ZmContact.prototype.getEmails=function(){
var s=[];
var a=this.getAttrs();
for(var t=0;
t<ZmContact.EMAIL_FIELDS.length;
t++){
var n=ZmContact.EMAIL_FIELDS[t];
for(var o=1;
true;
o++){
var e=ZmContact.getAttributeName(n,o);
if(!a[e]){
break
}
s.push(a[e])
}}
return s
};
ZmContact.prototype.getFullName=function(e){
var t=null;
if(!this._fullName||e){
var a=this.getAttr(ZmContact.X_fullName);
if(a){
this._fullName=(a instanceof Array)?a[0]:a
}else{
this._fullName=this.getFullNameForDisplay(false)
}
if(e){
t=this.getFullNameForDisplay(e)
}}
if(!this._fullName){
this._fullName=this.getFileAs()
}
return t||this._fullName
};
ZmContact.prototype.getFullNameForDisplay=function(a){
var o=this.getAttr(ZmContact.F_namePrefix);
var t=this.getAttr(ZmContact.F_firstName);
var c=this.getAttr(ZmContact.F_middleName);
var e=this.getAttr(ZmContact.F_maidenName);
var h=this.getAttr(ZmContact.F_lastName);
var l=this.getAttr(ZmContact.F_nameSuffix);
var s=ZmMsg.fullname;
if(l){
s=e?ZmMsg.fullnameMaidenSuffix:ZmMsg.fullnameSuffix
}else{
if(e){
s=ZmMsg.fullnameMaiden
}}
var r=new AjxMessageFormat(s);
var n=[o,t,c,e,h,l];
if(!a){
return AjxStringUtil.trim(r.format(n),true)
}
return this._getFullNameHtml(r,n)
};
ZmContact.prototype._getFullNameHtml=function(l,t){
var h=[];
var n=l.getSegments();
for(var o=0;
o<n.length;
o++){
var s=n[o];
if(s instanceof AjxFormat.TextSegment){
h.push(s.format());
continue
}
var r=s.getIndex();
var e=t[r];
var c=ZmContact.__RUBY_FIELDS[r]&&this.getAttr(ZmContact.__RUBY_FIELDS[r]);
h.push(AjxStringUtil.htmlRubyEncode(e,c))
}
return h.join("")
};
ZmContact.__RUBY_FIELDS=[null,ZmContact.F_phoneticFirstName,null,null,ZmContact.F_phoneticLastName,null];
ZmContact.prototype.getToolTip=function(e,o,a){
var t={
contact:this,entryTitle:this.getFileAs(),hint:a,buddy:this.getBuddy()};
return(AjxTemplate.expand("abook.Contacts#Tooltip",t))
};
ZmContact.prototype.getFileAs=function(e){
if(!this._fileAs){
this._fileAs=ZmContact.computeFileAs(this);
this._fileAsLC=this._fileAs?this._fileAs.toLowerCase():null
}
if(e&&!this._fileAsLC){
this._fileAsLC=this._fileAs.toLowerCase()
}
return e?this._fileAsLC:this._fileAs
};
ZmContact.prototype.getHeader=function(){
return this.id?this.getFileAs():ZmMsg.newContact
};
ZmContact.prototype.getImageUrl=function(){
var e=this.getAttr(ZmContact.F_image);
if(!e||!e.part){
return null
}
var t=appCtxt.get(ZmSetting.CSFE_MSG_FETCHER_URI);
return[t,"&id=",this.id,"&part=",e.part,"&t=",(new Date()).getTime()].join("")
};
ZmContact.prototype.getCompanyField=function(){
var t=this.getAttrs();
if(t==null){
return null
}
var a=parseInt(t.fileAs);
var o=[];
var e=0;
if(a==ZmContact.FA_LAST_C_FIRST||a==ZmContact.FA_FIRST_LAST){
if(t.jobTitle){
o[e++]=t.jobTitle;
if(t.company){
o[e++]=", "
}}
if(t.company){
o[e++]=t.company
}}else{
if(a==ZmContact.FA_COMPANY){
if(t.lastName){
o[e++]=t.lastName;
if(t.firstName){
o[e++]=", "
}}
if(t.firstName){
o[e++]=t.firstName
}
if(t.jobTitle){
o[e++]=" ("+t.jobTitle+")"
}}else{
if(t.jobTitle){
o[e++]=t.jobTitle;
if(t.company&&(t.fileAs==null||a==ZmContact.FA_LAST_C_FIRST||a==ZmContact.FA_FIRST_LAST)){
o[e++]=", "
}}
if(t.company&&(t.fileAs==null||a==ZmContact.FA_LAST_C_FIRST||a==ZmContact.FA_FIRST_LAST)){
o[e++]=t.company
}}}
if(o.length==0){
return null
}
return o.join("")
};
ZmContact.prototype.getWorkAddrField=function(e){
var t=this.getAttrs();
return this._getAddressField(t.workStreet,t.workCity,t.workState,t.workPostalCode,t.workCountry)
};
ZmContact.prototype.getHomeAddrField=function(e){
var t=this.getAttrs();
return this._getAddressField(t.homeStreet,t.homeCity,t.homeState,t.homePostalCode,t.homeCountry)
};
ZmContact.prototype.getOtherAddrField=function(e){
var t=this.getAttrs();
return this._getAddressField(t.otherStreet,t.otherCity,t.otherState,t.otherPostalCode,t.otherCountry)
};
ZmContact.prototype.getAddressBook=function(){
if(!this.addrbook){
this.addrbook=appCtxt.getById(this.folderId)
}
return this.addrbook
};
ZmContact.prototype._getAddressField=function(r,s,o,a,n){
if(r==null&&s==null&&o==null&&a==null&&n==null){
return null
}
var t=[];
var e=0;
if(r){
t[e++]=r;
if(s||o||a){
t[e++]="\n"
}}
if(s){
t[e++]=s;
if(o){
t[e++]=", "
}else{
if(a){
t[e++]=" "
}}}
if(o){
t[e++]=o;
if(a){
t[e++]=" "
}}
if(a){
t[e++]=a
}
if(n){
t[e++]="\n"+n
}
return t.join("")
};
ZmContact.prototype._initFullName=function(t,o){
var e=t.getName();
e=AjxStringUtil.trim(e.replace(AjxEmailAddress.commentPat,""));
if(e&&e.length){
this._setFullName(e,[" "])
}else{
if(!o){
e=t.getAddress();
if(e&&e.length){
var a=e.indexOf("@");
if(a==-1){
return
}
e=e.substr(0,a);
this._setFullName(e,[".","_"])
}}}};
ZmContact.prototype._setFullName=function(s,n){
var o=n[0];
for(var e=0;
e<n.length;
e++){
if(s.indexOf(n[e])!=-1){
o=n[e];
break
}}
var a=s.split(o);
var t=this["__setFullName_"+AjxEnv.DEFAULT_LOCALE]||this.__setFullName;
t.call(this,a,s,n)
};
ZmContact.prototype.__setFullName=function(e,a,t){
this.setAttr(ZmContact.F_firstName,e[0]);
if(e.length==2){
this.setAttr(ZmContact.F_lastName,e[1])
}else{
if(e.length==3){
this.setAttr(ZmContact.F_middleName,e[1]);
this.setAttr(ZmContact.F_lastName,e[2])
}}};
ZmContact.prototype.__setFullName_ja=function(e,a,t){
if(e.length>2){
this.__setFullName(e,a,t);
return
}
this.setAttr(ZmContact.F_lastName,e[0]);
if(e.length>1){
this.setAttr(ZmContact.F_firstName,e[1])
}};
ZmContact.prototype.__setFullName_ja_JP=ZmContact.prototype.__setFullName_ja;
ZmContact.prototype._addRequestAttr=function(n,t,o){
var e={
n:t};
if(t==ZmContact.F_image&&AjxUtil.isString(o)&&o.length){
if(o.indexOf("aid_")!=-1){
e.aid=o.substring(4)
}else{
e.part=o.substring(5)
}}else{
e._content=o||""
}
if(o instanceof Array){
if(!n._attrs){
n._attrs={}
}
n._attrs[t]=o||""
}else{
if(!n.a){
n.a=[]
}
n.a.push(e)
}};
ZmContact.prototype._resetCachedFields=function(){
this._fileAs=this._fileAsLC=this._fullName=null
};
ZmContact.prototype._loadFromDom=function(a){
this.isLoaded=true;
this.rev=a.rev;
this.sf=a.sf||a._attrs.sf;
this.folderId=a.l;
this.created=a.cd;
this.modified=a.md;
this.attr=a._attrs||{};
if(a.email){
this.attr[ZmContact.F_email]=a.email
}
if(a.email2){
this.attr[ZmContact.F_email2]=a.email2
}
if(a.email3){
this.attr[ZmContact.F_email3]=a.email3
}
this.type=(this.attr[ZmContact.F_dlist]!=null)?ZmItem.GROUP:ZmItem.CONTACT;
var t=window.parentAppCtxt||window.appCtxt;
this.addrbook=t.getById(this.folderId);
if(!this.isShared()){
this._parseFlags(a.f);
this._parseTags(a.t)
}else{
this.isLoaded=false
}
this._fileAs=ZmContact.computeFileAs(this);
this.isDL=this.isGal&&(this.attr[ZmContact.F_type]=="group");
if(this.isDL){
this.canExpand=a.exp;
var o=this.getEmails();
var t=window.parentAppCtxt||window.appCtxt;
for(var e=0;
e<o.length;
e++){
t.setIsExpandableDL(o[e],this.canExpand)
}}};
ZmContact.prototype.getAttendeeText=function(a,t){
var e=this.getEmail(true);
return(e?e.toString(t||(a&&a!=ZmCalBaseItem.PERSON)):"")
};
ZmContact.prototype.getAttendeeKey=function(){
var t=this.getLookupEmail()||this.getEmail();
var e=this.getFullName();
return t?t:e
};
ZmContact.prototype.getUnknownFields=function(t){
var r=ZmContact.__FIELD_MAP;
if(!r){
r=ZmContact.__FIELD_MAP={};
for(var n=0;
n<ZmContact.DISPLAY_FIELDS;
n++){
r[ZmContact.DISPLAY_FIELDS[n]]=true
}}
var e=[];
var o=this.getAttrs();
for(var a in o){
var s=a.replace(/\d+$/,"");
if(r[a]){
continue
}
e.push(s)
}
return this.getFields(e,t)
};
ZmContact.prototype.getFields=function(a,c){
var s;
var h=this.getAttrs();
for(var o=0;
o<a.length;
o++){
for(var t=1;
true;
t++){
var n=ZmContact.getAttributeName(a[o],t);
if(!h[n]){
break
}
if(!s){
s={}
}
s[n]=h[n]
}}
if(c&&s){
var l=AjxUtil.keys(s);
l.sort(c);
var e={};
for(var t=0;
t<l;
t++){
var r=l[t];
e[r]=a[r]
}
s=e
}
return s
};
ZmContact.prototype.getDLMembers=function(s,o,c){
var m={
list:[],more:false,isDL:{}};
if(!this.isDL){
return m
}
var l=this.getEmail();
var t=appCtxt.getApp(ZmApp.CONTACTS);
var r=t.getDL(l);
if(!r){
r=m;
r.more=true;
t.cacheDL(l,r)
}
o=o||ZmContact.DL_PAGE_SIZE;
var e=s||0;
var a=(s+o)-1;
if(r.list.length>=a+1||!r.more){
var h=r.list.slice(s,a+1);
m={
list:h,more:r.more||(r.list.length>a+1),isDL:r.isDL};
this._handleResponseGetDLMembers(e,o,c,m);
return
}
if(!r.total||(s<r.total)){
var u={
GetDistributionListMembersRequest:{
_jsns:"urn:zimbraAccount",offset:s,limit:o}};
var n=u.GetDistributionListMembersRequest;
n.dl={
_content:this.getEmail()};
var d=new AjxCallback(this,this._handleResponseGetDLMembers,[s,o,c]);
appCtxt.getAppController().sendRequest({
jsonObj:u,asyncMode:true,callback:d}
)
}else{
this._handleResponseGetDLMembers(e,o,c,m);
return
}};
ZmContact.prototype._handleResponseGetDLMembers=function(o,t,u,m){
if(!m.list){
var l=[];
var e=m.getResponse().GetDistributionListMembersResponse;
var r=appCtxt.getApp(ZmApp.CONTACTS).getDL(this.getEmail());
var d=r.more=e.more;
var c={};
var a=e.dlm;
if(a&&a.length){
for(var s=0,h=a.length;
s<h;
s++){
var n=a[s]._content;
l.push(n);
r.list[o+s]=n;
if(a[s].isDL){
c[n]=r.isDL[n]=true
}}}
r.total=e.total;
var m={
list:l,more:d,isDL:c}
}
u.run(m)
};
ZmContact.prototype.getAllDLMembers=function(o){
var e={
list:[],more:false,isDL:{}};
if(!this.isDL){
return e
}
var t=appCtxt.getApp(ZmApp.CONTACTS).getDL(this.getEmail());
if(t&&!t.more){
e={
list:t.list.slice(),more:false,isDL:t.isDL};
o.run(e);
return
}
var a=new AjxCallback(this,this._getNextDLChunk,[o]);
this.getDLMembers(t?t.list.length:0,null,a)
};
ZmContact.prototype._getNextDLChunk=function(o,e){
var t=appCtxt.getApp(ZmApp.CONTACTS).getDL(this.getEmail());
if(e.more){
var a=new AjxCallback(this,this._getNextDLChunk,[o]);
this.getDLMembers(t.list.length,null,a)
}else{
e.list=t.list.slice();
o.run(e)
}};
ZmContact._AB_FIELD={
firstName:ZmMsg.AB_FIELD_firstName,lastName:ZmMsg.AB_FIELD_lastName,middleName:ZmMsg.AB_FIELD_middleName,fullName:ZmMsg.AB_FIELD_fullName,jobTitle:ZmMsg.AB_FIELD_jobTitle,company:ZmMsg.AB_FIELD_company,email:ZmMsg.AB_FIELD_email,email2:ZmMsg.AB_FIELD_email2,email3:ZmMsg.AB_FIELD_email3,imAddress1:ZmMsg.AB_FIELD_imAddress1,imAddress2:ZmMsg.AB_FIELD_imAddress2,imAddress3:ZmMsg.AB_FIELD_imAddress3,image:ZmMsg.AB_FIELD_image,attachment:ZmMsg.AB_FIELD_attachment,workStreet:ZmMsg.AB_FIELD_street,workCity:ZmMsg.AB_FIELD_city,workState:ZmMsg.AB_FIELD_state,workPostalCode:ZmMsg.AB_FIELD_postalCode,workCountry:ZmMsg.AB_FIELD_country,workURL:ZmMsg.AB_FIELD_URL,workPhone:ZmMsg.AB_FIELD_workPhone,workPhone2:ZmMsg.AB_FIELD_workPhone2,workFax:ZmMsg.AB_FIELD_workFax,assistantPhone:ZmMsg.AB_FIELD_assistantPhone,companyPhone:ZmMsg.AB_FIELD_companyPhone,callbackPhone:ZmMsg.AB_FIELD_callbackPhone,homeStreet:ZmMsg.AB_FIELD_street,homeCity:ZmMsg.AB_FIELD_city,homeState:ZmMsg.AB_FIELD_state,homePostalCode:ZmMsg.AB_FIELD_postalCode,homeCountry:ZmMsg.AB_FIELD_country,homeURL:ZmMsg.AB_FIELD_URL,homePhone:ZmMsg.AB_FIELD_homePhone,homePhone2:ZmMsg.AB_FIELD_homePhone2,homeFax:ZmMsg.AB_FIELD_homeFax,mobilePhone:ZmMsg.AB_FIELD_mobilePhone,pager:ZmMsg.AB_FIELD_pager,carPhone:ZmMsg.AB_FIELD_carPhone,otherStreet:ZmMsg.AB_FIELD_street,otherCity:ZmMsg.AB_FIELD_city,otherState:ZmMsg.AB_FIELD_state,otherPostalCode:ZmMsg.AB_FIELD_postalCode,otherCountry:ZmMsg.AB_FIELD_country,otherURL:ZmMsg.AB_FIELD_URL,otherPhone:ZmMsg.AB_FIELD_otherPhone,otherFax:ZmMsg.AB_FIELD_otherFax,notes:ZmMsg.notes,birthday:ZmMsg.AB_FIELD_birthday};
ZmContact._AB_FILE_AS={
1:ZmMsg.AB_FILE_AS_lastFirst,2:ZmMsg.AB_FILE_AS_firstLast,3:ZmMsg.AB_FILE_AS_company,4:ZmMsg.AB_FILE_AS_lastFirstCompany,5:ZmMsg.AB_FILE_AS_firstLastCompany,6:ZmMsg.AB_FILE_AS_companyLastFirst,7:ZmMsg.AB_FILE_AS_companyFirstLast}
}}
if(AjxPackage.define("zimbraMail.abook.model.ZmContactList")){
ZmContactList=function(e,a,t){
if(arguments.length==0){
return
}
t=t||ZmItem.CONTACT;
ZmList.call(this,t,e);
this.isGal=(a===true);
this.isCanonical=false;
this.isLoaded=false;
this._app=appCtxt.getApp(ZmApp.CONTACTS);
this._emailToContact=this._app._byEmail;
this._imAddressToContact=this._app._byIM;
this._phoneToContact=this._app._byPhone
};
ZmContactList.prototype=new ZmList;
ZmContactList.prototype.constructor=ZmContactList;
ZmContactList.URL="/Contacts?fmt=cf&t=2&all";
ZmContactList.CONTACT_SPLIT_CHAR="\u001E";
ZmContactList.FIELD_SPLIT_CHAR="\u001D";
ZmContactList.IS_CONTACT_FIELD={
id:true,l:true,d:true,fileAsStr:true,rev:true};
ZmContactList.prototype.toString=function(){
return"ZmContactList"
};
ZmContactList.prototype.addLoadedCallback=function(e){
if(this.isLoaded){
e.run();
return
}
if(!this._loadedCallbacks){
this._loadedCallbacks=[]
}
this._loadedCallbacks.push(e)
};
ZmContactList.prototype._finishLoading=function(){
this.isLoaded=true;
if(this._loadedCallbacks){
var e;
while(e=this._loadedCallbacks.shift()){
e.run()
}}};
ZmContactList.prototype.load=function(n,e,t){
this.isCanonical=true;
var o=new AjxCallback(this,this._handleResponseLoad,[n]);
var a={
asyncMode:true,noBusyOverlay:true,callback:o,errorCallback:e};
a.restUri=AjxUtil.formatUrl({
path:["/home/",(t||appCtxt.getUsername()),ZmContactList.URL].join(""),qsReset:true}
);
appCtxt.getAppController().sendRequest(a)
};
ZmContactList.prototype._handleResponseLoad=function(h,d){
var l=d.getResponse();
if(l){
var c=l.split(ZmContactList.CONTACT_SPLIT_CHAR);
for(var a=0,n=c.length;
a<n;
a++){
var o=c[a].split(ZmContactList.FIELD_SPLIT_CHAR);
var s={}
,r={};
for(var t=0,e=o.length;
t<e;
t+=2){
if(ZmContactList.IS_CONTACT_FIELD[o[t]]){
s[o[t]]=o[t+1]
}else{
r[o[t]]=o[t+1]
}}
s._attrs=r;
this._addContact(s)
}}
this._finishLoading();
if(h){
h.run()
}};
ZmContactList.prototype.add=function(t,e){
if(!t.id||!this._idHash[t.id]){
this._vector.add(t,e);
if(t.id){
this._idHash[t.id]=t
}
this._updateHashes(t,true)
}};
ZmContactList.prototype.cache=function(h,t){
var n=function(){
return this.id
};
var o=function(l){
return this._vector.containsLike(l,n)
};
var r=t.sub(o,this);
this.getVector().merge(h,r);
var s=r.getArray();
for(var e=0;
e<s.length;
e++){
var a=s[e];
a.list=this;
if(a.id){
this._idHash[a.id]=a
}}};
ZmContactList.prototype._addContact=function(e){
e.list=this;
this._updateHashes(e,true);
var t=[],a=[];
if(e._attrs[ZmContact.F_firstName]){
t.push(e._attrs[ZmContact.F_firstName])
}
if(e._attrs[ZmContact.F_middleName]){
t.push(e._attrs[ZmContact.F_middleName])
}
if(e._attrs[ZmContact.F_lastName]){
t.push(e._attrs[ZmContact.F_lastName])
}
if(t.length){
e._attrs[ZmContact.X_fullName]=t.join(" ")
}
if(e._attrs[ZmContact.F_firstName]){
a.push(e._attrs[ZmContact.F_firstName])
}
if(e._attrs[ZmContact.F_lastName]){
a.push(e._attrs[ZmContact.F_lastName])
}
e._attrs[ZmContact.X_firstLast]=a.join(" ");
this.add(e)
};
ZmContactList.prototype._realizeContact=function(contact,idx){
if(contact instanceof ZmContact){
return contact
}
if(contact&&contact.type==ZmItem.CONTACT){
return contact
}
var args={
list:this};
var obj=eval(ZmList.ITEM_CLASS[this.type]);
var realContact=obj&&obj.createFromDom(contact,args);
if(this.isCanonical){
var a=this.getArray();
idx=idx||this._getIndexById(contact.id);
a[idx]=realContact;
this._updateHashes(realContact,true);
this._idHash[contact.id]=realContact
}
return realContact
};
ZmContactList.prototype._getIndexById=function(o){
var e=this.getArray();
for(var t=0;
t<e.length;
t++){
if(e[t].id==o){
return t
}}
return null
};
ZmContactList.prototype.getSubList=function(r,s,o){
if(o&&this.isCanonical){
var d=[];
var l=this.getArray();
var e=0;
this.setHasMore(false);
for(var h=0;
h<l.length;
h++){
l[h]=this._realizeContact(l[h],h);
var t=appCtxt.getById(l[h].folderId);
if(t&&t.nId==ZmOrganizer.normalizeId(o)){
if(e>=r){
if(d.length==s){
this.setHasMore(true);
break
}
d.push(l[h])
}
e++
}}
return AjxVector.fromArray(d)
}else{
var n=ZmList.prototype.getSubList.call(this,r,s);
if(n){
var c=n.getArray();
for(var h=0;
h<c.length;
h++){
c[h]=this._realizeContact(c[h],r+h)
}}
return n
}};
ZmContactList.prototype.getById=function(t){
if(!t||!this.isCanonical){
return null
}
var e=this._idHash[t];
return e?this._realizeContact(e):null
};
ZmContactList.prototype.getContactByEmail=function(t){
if(!t||!this.isCanonical){
return null
}
var e=this._emailToContact[t.toLowerCase()];
if(e){
e=this._realizeContact(e);
e._lookupEmail=t;
return e
}else{
return null
}};
ZmContactList.prototype.getContactByIMAddress=function(t){
var e=this._imAddressToContact[t.toLowerCase()];
return e?this._realizeContact(e):null
};
ZmContactList.prototype.getContactByPhone=function(e){
if(!e||!this.isCanonical){
return null
}
var a=this._getPhoneDigits(e);
var t=this._phoneToContact[a];
if(t){
t.contact=this._realizeContact(t.contact);
return t
}else{
return null
}};
ZmContactList.prototype.moveItems=function(e){
e=Dwt.getParams(arguments,["items","folder","attrs","outOfTrash"]);
e.items=AjxUtil.toArray(e.items);
var r=new ZmBatchCommand(true,null,true);
var n=new ZmBatchCommand(true,null,true);
var t=[];
var c=[];
if(e.items[0]&&e.items[0] instanceof ZmItem){
for(var a=0;
a<e.items.length;
a++){
var s=e.items[a];
if(s.isReadOnly()){
continue
}
if(s.isShared()||e.folder.link){
c.push(s);
if(!s.isLoaded){
n.add(new AjxCallback(s,s.load,[null,null]))
}
r.add(this._getCopyCmd(s,e.folder))
}else{
t.push(s)
}}}else{
t=e.items
}
if(c.length>0){
var h={
items:c,action:"delete",actionText:ZmMsg.actionMove,actionArg:e.folder.getName(false,false,true)};
if(n.size()){
var l=new AjxCallback(this,this._handleResponseLoadMove,[r,h]);
n.run(l)
}else{
var o=new AjxCallback(this,this._itemAction,[h]);
r.add(o);
var l=new AjxCallback(this,this._handleResponseMoveBatchCmd);
r.run(l)
}}
if(t.length>0){
var h=AjxUtil.hashCopy(e);
h.attrs=e.attrs||{};
h.attrs.l=e.folder.id;
h.action="move";
h.accountName=appCtxt.multiAccounts&&appCtxt.accountList.mainAccount.name;
if(h.folder.id==ZmFolder.ID_TRASH){
h.actionText=ZmMsg.actionTrash;
h.accountName=appCtxt.multiAccounts&&e.items[0].getAccount().name
}else{
h.actionText=ZmMsg.actionMove;
h.actionArg=e.folder.getName(false,false,true)
}
h.callback=e.outOfTrash&&new AjxCallback(this,this._handleResponseMoveItems,e);
this._itemAction(h)
}};
ZmContactList.prototype._handleResponseMoveBatchCmd=function(t){
var n=t.getResponse().BatchResponse.ContactActionResponse;
var o=n[0].action.id.split(",");
for(var a=0;
a<o.length;
a++){
var e=appCtxt.cacheGet(o[a]);
if(e&&e.isShared()){
e.notifyDelete();
appCtxt.cacheRemove(o[a])
}}};
ZmContactList.prototype._handleResponseLoadMove=function(t,a){
var e=new AjxCallback(this,this._itemAction,[a]);
t.add(e);
var o=new AjxCallback(this,this._handleResponseMoveBatchCmd);
t.run(o)
};
ZmContactList.prototype._handleResponseBatchLoad=function(a,o,t,e){
a.add(this._getCopyCmd(e,o))
};
ZmContactList.prototype._getCopyCmd=function(e,o){
var t=new ZmContact(null,this);
for(var a in e.attr){
t.attr[a]=e.attr[a]
}
t.attr[ZmContact.F_folderId]=o.id;
return new AjxCallback(t,t.create,[t.attr])
};
ZmContactList.prototype.deleteItems=function(e){
if(this.isGal){
return
}
ZmList.prototype.deleteItems.call(this,e)
};
ZmContactList.prototype.setIsGal=function(e){
this.isGal=e
};
ZmContactList.prototype.notifyCreate=function(node){
var obj=eval(ZmList.ITEM_CLASS[this.type]);
if(obj){
var item=obj.createFromDom(node,{
list:this}
);
var index=this._sortIndex(item);
var listSize=this.size();
var visible=false;
if(index<listSize||listSize==0||(index==listSize&&!this._hasMore)){
this.add(item,index);
this.createLocal(item);
visible=true
}
this._notify(ZmEvent.E_CREATE,{
items:[item],sortIndex:index,visible:visible}
)
}};
ZmContactList.prototype.moveLocal=function(t,e){
if(!this.isCanonical){
ZmList.prototype.moveLocal.call(this,t,e)
}
if(e==ZmFolder.ID_TRASH){
for(var a=0;
a<t.length;
a++){
this._updateHashes(t[a],false)
}}};
ZmContactList.prototype.deleteLocal=function(e){
ZmList.prototype.deleteLocal.call(this,e);
for(var t=0;
t<e.length;
t++){
this._updateHashes(e[t],false)
}};
ZmContactList.prototype.modifyLocal=function(n,o){
if(o){
o.items=[n];
this._notify(ZmEvent.E_MODIFY,o)
}
var e=o.contact;
if(this.isCanonical){
var s=new ZmContact(null,this);
s.id=o.contact.id;
s.attr=o.oldAttr;
this._updateHashes(s,false);
this._updateHashes(e,true)
}
if(o.fileAsChanged){
this.remove(e);
var t=this._sortIndex(e);
var a=this.size();
if(t<a||a==0||(t==a&&!this._hasMore)){
this.add(e,t)
}}
if(e.addrbook&&(e.addrbook.id!=e.folderId)){
e.addrbook=appCtxt.getById(e.folderId)
}};
ZmContactList.prototype.createLocal=function(e){
this._updateHashes(e,true)
};
ZmContactList.prototype._updateHashes=function(t,r){
this._app.updateCache(t,r);
for(var o=0;
o<ZmContact.EMAIL_FIELDS.length;
o++){
var h=ZmContact.EMAIL_FIELDS[o];
for(var n=1;
true;
n++){
var a=ZmContact.getAttributeName(h,n);
var e=ZmContact.getAttr(t,a);
if(!e){
break
}
if(r){
this._emailToContact[e.toLowerCase()]=t
}else{
delete this._emailToContact[e.toLowerCase()]
}}}
if(appCtxt.get(ZmSetting.VOICE_ENABLED)){
for(var o=0;
o<ZmContact.PHONE_FIELDS.length;
o++){
var h=ZmContact.PHONE_FIELDS[o];
for(var n=1;
true;
n++){
var a=ZmContact.getAttributeName(h,n);
var e=ZmContact.getAttr(t,a);
if(!e){
break
}
var s=this._getPhoneDigits(e);
if(s){
if(r){
this._phoneToContact[e]={
contact:t,field:a}
}else{
delete this._phoneToContact[e]
}}}}}
if(appCtxt.get(ZmSetting.IM_ENABLED)){
for(var o=0;
o<ZmContact.IM_FIELDS.length;
o++){
var h=ZmContact.IM_FIELDS[o];
for(var n=1;
true;
n++){
var a=ZmContact.getAttributeName(h,n);
var e=ZmContact.getAttr(t,a);
if(!e){
break
}
if(r){
this._imAddressToContact[e.toLowerCase()]=t
}else{
delete this._imAddressToContact[e.toLowerCase()]
}}}}};
ZmContactList.prototype._getPhoneDigits=function(e){
return e.replace(/[^\d]/g,"")
};
ZmContactList.prototype._sortIndex=function(e){
var t=this._vector.getArray();
for(var o=0;
o<t.length;
o++){
if(ZmContact.compareByFileAs(t[o],e)>0){
return o
}}
return t.length
};
ZmContactList.prototype._handleResponseModifyItem=function(t,e){}
}
if(AjxPackage.define("zimbraMail.abook.view.ZmContactsHelper")){
ZmContactsHelper=function(){};
ZmContactsHelper.search=function(a){
var t=a.obj;
if(t._searchButton){
t._searchButton.setEnabled(false)
}
a.sortBy=a.ascending?ZmSearch.NAME_ASC:ZmSearch.NAME_DESC;
a.types=AjxVector.fromArray([ZmItem.CONTACT]);
a.offset=a.offset||0;
a.limit=ZmContactsApp.SEARCHFOR_MAX;
a.contactSource=t._contactSource;
a.field="contact";
var e=new ZmSearch(a);
e.execute({
callback:a.respCallback,errorCallback:a.errorCallback}
)
};
ZmContactsHelper._processSearchResponse=function(t){
var e=t.getResults(ZmItem.CONTACT);
var l=[];
var c=e.getArray();
for(var s=0;
s<c.length;
s++){
var h=c[s];
if(h.isGroup()&&!h.isDL){
var n=h.getGroupMembers().good.toString(AjxEmailAddress.SEPARATOR);
ZmContactsHelper._addContactToList(l,h,n,true)
}else{
var r=h.isGal?[h.getEmail()]:h.getEmails();
for(var o=0;
o<r.length;
o++){
ZmContactsHelper._addContactToList(l,h,r[o])
}}}
return l
};
ZmContactsHelper._addContactToList=function(s,e,h,r){
var o=e.getFileAs();
var a=(o!=h)?o:"";
var t=new AjxEmailAddress(h,null,a,null,r);
t.id=Dwt.getNextId();
t.__contact=e;
t.icon=e.getIcon();
if(e.isDL){
t.isGroup=true;
t.canExpand=e.canExpand;
var n=window.parentAppCtxt||window.appCtxt;
n.setIsExpandableDL(h,t.canExpand)
}
s.push(t)
};
ZmContactsHelper._getEmailField=function(t,e,a,o,n){
if(o==ZmItem.F_TYPE){
t[e++]=AjxImg.getImageHtml(a.icon)
}else{
if(o==ZmItem.F_NAME){
t[e++]="<nobr>";
t[e++]=AjxStringUtil.htmlEncode(a.name);
t[e++]="</nobr>"
}else{
if(o==ZmItem.F_EMAIL){
t[e++]=AjxStringUtil.htmlEncode(a.address)
}else{
if(o==ZmItem.F_DEPARTMENT){
if(a.__contact){
t[e++]=AjxStringUtil.htmlEncode(ZmContact.getAttr(a.__contact,ZmContact.F_department))
}}}}}
return e
}
}
if(AjxPackage.define("zimbraMail.abook.view.ZmContactPicker")){
ZmContactPicker=function(e){
DwtDialog.call(this,{
parent:appCtxt.getShell(),title:ZmMsg.selectAddresses,id:"ZmContactPicker"}
);
this._buttonInfo=e;
this._initialized=false;
this._offset=0;
this._defaultQuery=".";
this._list=new AjxVector();
this._detailed=appCtxt.get(ZmSetting.DETAILED_CONTACT_SEARCH_ENABLED);
this._searchCleared={};
this._ignoreSetDragBoundries=true;
this._searchErrorCallback=new AjxCallback(this,this._handleErrorSearch)
};
ZmContactPicker.prototype=new DwtDialog;
ZmContactPicker.prototype.constructor=ZmContactPicker;
ZmContactPicker.CHOOSER_HEIGHT=300;
ZmContactPicker.SEARCH_BASIC="search";
ZmContactPicker.SEARCH_NAME="name";
ZmContactPicker.SEARCH_EMAIL="email";
ZmContactPicker.SEARCH_DEPT="dept";
ZmContactPicker.SEARCH_PHONETIC="phonetic";
ZmContactPicker.HINT={};
ZmContactPicker.HINT[ZmContactPicker.SEARCH_BASIC]=ZmMsg.contactPickerHint;
ZmContactPicker.HINT[ZmContactPicker.SEARCH_NAME]=ZmMsg.contactPickerHint;
ZmContactPicker.HINT[ZmContactPicker.SEARCH_EMAIL]=ZmMsg.contactPickerEmailHint;
ZmContactPicker.HINT[ZmContactPicker.SEARCH_DEPT]=ZmMsg.contactPickerDepartmentHint;
ZmContactPicker.HINT[ZmContactPicker.SEARCH_PHONETIC]=ZmMsg.contactPickerPhoneticHint;
ZmContactPicker.SHOW_ON_GAL=[ZmContactPicker.SEARCH_BASIC,ZmContactPicker.SEARCH_NAME,ZmContactPicker.SEARCH_EMAIL,ZmContactPicker.SEARCH_DEPT];
ZmContactPicker.SHOW_ON_NONGAL=[ZmContactPicker.SEARCH_BASIC,ZmContactPicker.SEARCH_NAME,ZmContactPicker.SEARCH_PHONETIC,ZmContactPicker.SEARCH_EMAIL];
ZmContactPicker.prototype.toString=function(){
return"ZmContactPicker"
};
ZmContactPicker.prototype.popup=function(h,s,l,n){
if(!this._initialized){
this._initialize(n);
this._initialized=true
}else{
if(appCtxt.multiAccounts&&this._account!=n){
this._account=n;
this._resetSelectDiv()
}}
this._offset=0;
var t=this._selectDiv?this._selectDiv.getValue():ZmContactsApp.SEARCHFOR_CONTACTS;
this._chooser.sourceListView.setSortByAsc(ZmItem.F_NAME,true);
this._chooser.reset();
if(h){
this._chooser._setActiveButton(h)
}
if(s){
for(var a in s){
this._chooser.addItems(s[a],DwtChooserListView.TARGET,true,a)
}}
for(var r in this._searchField){
var c=this._searchField[r];
c.disabled=false;
if(l){
c.className="";
c.value=AjxUtil.isObject(l)?(l[r]||""):l;
this._searchCleared[r]=true
}else{
c.className="searchFieldHint";
c.value=ZmContactPicker.HINT[r];
this._searchCleared[r]=false
}}
var o=this._searchField[ZmContactPicker.SEARCH_BASIC]||this._searchField[ZmContactPicker.SEARCH_NAME];
o.focus();
this._prevButton.setEnabled(false);
this._nextButton.setEnabled(false);
this.search(null,null,true);
DwtDialog.prototype.popup.call(this);
if((this.getLocation().x<0||this.getLocation().y<0)){
this.setLocation(0,30);
var u=Dwt.getWindowSize();
var d=this.getSize();
var e=document.getElementById(this._dragHandleId);
DwtDraggable.setDragBoundaries(e,100-d.x,u.x-100,0,u.y-100)
}};
ZmContactPicker.prototype.popdown=function(){
for(var e in this._searchField){
this._searchField[e].disabled=true
}
this._contactSource=null;
this._list.removeAll();
DwtDialog.prototype.popdown.call(this)
};
ZmContactPicker.prototype.search=function(l,o,r,t,s){
if(!AjxUtil.isSpecified(o)){
o=true
}
var n;
var m=[];
var e=[];
if(this._detailed){
var a=this.getSearchFieldValue(ZmContactPicker.SEARCH_NAME);
var d=this.getSearchFieldValue(ZmContactPicker.SEARCH_EMAIL);
var c=this.getSearchFieldValue(ZmContactPicker.SEARCH_DEPT);
var y=this.getSearchFieldValue(ZmContactPicker.SEARCH_PHONETIC);
var b=this._selectDiv&&(this._selectDiv.getValue()==ZmContactsApp.SEARCHFOR_GAL);
n=a||"";
if(d){
if(b){
e.push([{
attr:ZmContact.F_email,op:"has",value:d}
,{
attr:ZmContact.F_email2,op:"has",value:d}
,{
attr:ZmContact.F_email3,op:"has",value:d}
])
}else{
m.push("to:"+d+"*")
}}
if(c&&b){
e.push({
attr:ZmContact.F_department,op:"has",value:c}
)
}
if(y&&!b){
var p=[];
var h=y.split(/\s+/);
for(var f=0;
f<h.length;
f++){
p.push("#"+ZmContact.F_phoneticFirstName+":"+h[f]);
p.push("#"+ZmContact.F_phoneticLastName+":"+h[f])
}
m.push(p.join(" || "))
}}else{
n=this.getSearchFieldValue(ZmContactPicker.SEARCH_BASIC)
}
if(this._selectDiv){
var u=this._selectDiv.getValue();
this._contactSource=(u==ZmContactsApp.SEARCHFOR_CONTACTS||u==ZmContactsApp.SEARCHFOR_PAS)?ZmItem.CONTACT:ZmId.SEARCH_GAL;
if(u==ZmContactsApp.SEARCHFOR_PAS){
m.push(ZmSearchController.generateQueryForShares([ZmId.ITEM_CONTACT])||"is:local")
}else{
if(u==ZmContactsApp.SEARCHFOR_CONTACTS){
m.push("is:local")
}else{
if(u==ZmContactsApp.SEARCHFOR_GAL){
o=true
}}}}else{
this._contactSource=appCtxt.get(ZmSetting.CONTACTS_ENABLED,null,this._account)?ZmItem.CONTACT:ZmId.SEARCH_GAL;
if(this._contactSource==ZmItem.CONTACT){
m.push("is:local")
}}
if(!n.length&&this._contactSource==ZmId.SEARCH_GAL){
n=this._defaultQuery
}
if(this._contactSource==ZmItem.CONTACT&&n!=""){
n=n.replace(/\"/g,'\\"');
n='"'+n+'"'
}
this._searchIcon.className="DwtWait16Icon";
this._chooser.sourceListView.sortingEnabled=(this._contactSource==ZmItem.CONTACT);
var g={
obj:this,ascending:o,query:n,queryHint:m.join(" "),conds:e,offset:this._list.size(),lastId:t,lastSortVal:s,respCallback:(new AjxCallback(this,this._handleResponseSearch,[r])),errorCallback:this._searchErrorCallback,accountName:(this._account&&this._account.name),expandDL:true};
ZmContactsHelper.search(g)
};
ZmContactPicker.prototype._contentHtml=function(n){
var s;
var a=appCtxt.isChildWindow?parentAppCtxt:appCtxt;
if(a.multiAccounts){
var o=a.accountList.visibleAccounts;
for(var t=0;
t<o.length;
t++){
var n=o[t];
if(a.get(ZmSetting.CONTACTS_ENABLED,null,n)&&(a.get(ZmSetting.GAL_ENABLED,null,n)||a.get(ZmSetting.SHARING_ENABLED,null,n))){
s=true;
break
}}}else{
s=(a.get(ZmSetting.CONTACTS_ENABLED)&&(a.get(ZmSetting.GAL_ENABLED)||a.get(ZmSetting.SHARING_ENABLED)))
}
var e={
id:this._htmlElId,showSelect:s,detailed:this._detailed};
return(AjxTemplate.expand("abook.Contacts#ZmContactPicker",e))
};
ZmContactPicker.prototype._resetSelectDiv=function(){
this._selectDiv.clearOptions();
if(appCtxt.get(ZmSetting.CONTACTS_ENABLED,null,this._account)){
this._selectDiv.addOption(ZmMsg.contacts,false,ZmContactsApp.SEARCHFOR_CONTACTS);
if(appCtxt.get(ZmSetting.SHARING_ENABLED,null,this._account)){
this._selectDiv.addOption(ZmMsg.searchPersonalSharedContacts,false,ZmContactsApp.SEARCHFOR_PAS)
}}
if(appCtxt.get(ZmSetting.GAL_ENABLED,null,this._account)){
this._selectDiv.addOption(ZmMsg.GAL,true,ZmContactsApp.SEARCHFOR_GAL)
}
if(!appCtxt.get(ZmSetting.INITIALLY_SEARCH_GAL,null,this._account)||!appCtxt.get(ZmSetting.GAL_ENABLED,null,this._account)){
this._selectDiv.setSelectedValue(ZmContactsApp.SEARCHFOR_CONTACTS)
}};
ZmContactPicker.prototype.clearSearch=function(t){
if(t){
for(var e in this._searchField){
if(t==this._searchField[e]){
if(!this._searchCleared[e]){
t.className=t.value="";
this._searchCleared[e]=true
}
break
}}}};
ZmContactPicker.prototype.getSearchFieldValue=function(e){
if(!e&&!this._detailed){
e=ZmContactPicker.SEARCH_BASIC
}
var t=this._searchField[e];
return(this._searchCleared[e]&&t)?AjxStringUtil.trim(t.value):""
};
ZmContactPicker.prototype._initialize=function(s){
this.setContent(this._contentHtml(s));
this._searchIcon=document.getElementById(this._htmlElId+"_searchIcon");
this._searchButton=new DwtButton({
parent:this,parentElement:(this._htmlElId+"_searchButton")}
);
this._searchButton.setText(ZmMsg.search);
this._searchButton.addSelectionListener(new AjxListener(this,this._searchButtonListener));
var l=this._htmlElId+"_listSelect";
var c=document.getElementById(l);
if(c){
this._selectDiv=new DwtSelect({
parent:this,parentElement:l,id:Dwt.getNextId("ZmContactPickerSelect_")}
);
this._resetSelectDiv();
this._selectDiv.addChangeListener(new AjxListener(this,this._searchTypeListener))
}else{
this.setSize("600")
}
this._chooser=new ZmContactChooser({
parent:this,buttonInfo:this._buttonInfo}
);
this._chooser.reparentHtmlElement(this._htmlElId+"_chooser");
this._chooser.resize(this.getSize().x-25,ZmContactPicker.CHOOSER_HEIGHT);
var r=new AjxListener(this,this._pageListener);
this._prevButton=new DwtButton({
parent:this,parentElement:(this._htmlElId+"_pageLeft")}
);
this._prevButton.setText(ZmMsg.previous);
this._prevButton.setImage("LeftArrow");
this._prevButton.addSelectionListener(r);
this._nextButton=new DwtButton({
parent:this,style:DwtLabel.IMAGE_RIGHT,parentElement:(this._htmlElId+"_pageRight")}
);
this._nextButton.setText(ZmMsg.next);
this._nextButton.setImage("RightArrow");
this._nextButton.addSelectionListener(r);
var e=document.getElementById(this._htmlElId+"_paging");
if(e){
Dwt.setSize(e,this._chooser.sourceListView.getSize().x)
}
this.setButtonListener(DwtDialog.OK_BUTTON,new AjxListener(this,this._okButtonListener));
this.setButtonListener(DwtDialog.CANCEL_BUTTON,new AjxListener(this,this._cancelButtonListener));
this._searchField={};
this._searchRow={};
var a={}
,h,o={};
if(this._detailed){
a[ZmContactPicker.SEARCH_NAME]=this._htmlElId+"_searchNameField";
a[ZmContactPicker.SEARCH_EMAIL]=this._htmlElId+"_searchEmailField";
a[ZmContactPicker.SEARCH_DEPT]=this._htmlElId+"_searchDepartmentField";
a[ZmContactPicker.SEARCH_PHONETIC]=this._htmlElId+"_searchPhoneticField";
o[ZmContactPicker.SEARCH_NAME]=this._htmlElId+"_searchNameRow";
o[ZmContactPicker.SEARCH_PHONETIC]=this._htmlElId+"_searchPhoneticRow";
o[ZmContactPicker.SEARCH_EMAIL]=this._htmlElId+"_searchEmailRow";
o[ZmContactPicker.SEARCH_DEPT]=this._htmlElId+"_searchDepartmentRow"
}else{
a[ZmContactPicker.SEARCH_BASIC]=this._htmlElId+"_searchField";
o[ZmContactPicker.SEARCH_BASIC]=this._htmlElId+"_searchRow"
}
for(var n in a){
h=Dwt.byId(a[n]);
if(h){
this._searchField[n]=h;
Dwt.setHandler(h,DwtEvent.ONKEYUP,ZmContactPicker._keyPressHdlr);
Dwt.setHandler(h,DwtEvent.ONCLICK,ZmContactPicker._onclickHdlr)
}}
for(var t in o){
row=Dwt.byId(o[t]);
if(row){
this._searchRow[t]=row
}}
this._updateSearchRows(this._selectDiv&&this._selectDiv.getValue()||ZmContactsApp.SEARCHFOR_CONTACTS);
this._keyPressCallback=new AjxCallback(this,this._searchButtonListener)
};
ZmContactPicker.prototype._searchButtonListener=function(e){
this._offset=0;
this._list.removeAll();
this.search()
};
ZmContactPicker.prototype._handleResponseSearch=function(e,m){
var o=m.getResponse();
var u=o.getAttribute("more");
var n=o.getAttribute("offset");
var s=AjxUtil.isSpecified(n);
var a=o.getAttribute("info");
var r=a&&a[0].wildcard[0].expanded=="0";
if(!e&&!s&&(r||(this._contactSource==ZmId.SEARCH_GAL&&u))){
var c=appCtxt.getMsgDialog();
c.setMessage(ZmMsg.errorSearchNotExpanded);
c.popup();
if(r){
return
}}
var h=AjxVector.fromArray(ZmContactsHelper._processSearchResponse(o));
if(s){
this._list.merge(n,h);
this._list.hasMore=u
}else{
this._list=h
}
if(h.size()==0&&e){
this._chooser.sourceListView._setNoResultsHtml()
}
if(((this._list.size()-this._offset)<ZmContactsApp.SEARCHFOR_MAX)&&u){
var t=o.getResults(ZmItem.CONTACT);
var l=(t.size()>0)?t.getVector().getLast():null;
if(l){
if(l.__contact){
lastId=l.__contact.id;
lastSortVal=l.__contact.sf
}else{
lastId=l.id;
lastSortVal=l.sf
}}
if(!lastSortVal&&s){
this._searchIcon.className="ImgSearch";
return
}else{
if(!lastSortVal&&!s){
this._showResults(s,u,this.getSubList())
}else{
this.search(null,null,null,lastId,lastSortVal)
}}}else{
h=this.getSubList();
if(!h){
this._offset-=ZmContactsApp.SEARCHFOR_MAX;
if(this._offset<0){
this._offset=0
}
h=this.getSubList()
}
if(!u){
u=(this._offset+ZmContactsApp.SEARCHFOR_MAX)<this._list.size()
}
this._showResults(s,u,h)
}};
ZmContactPicker.prototype._showResults=function(a,e,t){
if(this._contactSource==ZmId.SEARCH_GAL&&!a){
this._prevButton.setEnabled(false);
this._nextButton.setEnabled(false)
}else{
this._prevButton.setEnabled(this._offset>0);
this._nextButton.setEnabled(e)
}
this._resetColHeaders();
this._chooser.setItems(t);
this._searchIcon.className="ImgSearch";
this._searchButton.setEnabled(true)
};
ZmContactPicker.prototype._updateSearchRows=function(e){
var a=(e==ZmContactsApp.SEARCHFOR_GAL)?ZmContactPicker.SHOW_ON_GAL:ZmContactPicker.SHOW_ON_NONGAL;
for(var t in this._searchRow){
Dwt.setVisible(this._searchRow[t],AjxUtil.indexOf(a,t)!=-1)
}
for(var t in this._searchField){
var n=this._searchField[t];
if(this._tabGroup.contains(n)){
this._tabGroup.removeMember(n)
}}
for(var o=0;
o<a.length;
o++){
this._tabGroup.addMember(this._searchField[a[o]])
}};
ZmContactPicker.prototype._handleErrorSearch=function(){
this._searchButton.setEnabled(true);
return false
};
ZmContactPicker.prototype._pageListener=function(o){
if(o.item==this._prevButton){
this._offset-=ZmContactsApp.SEARCHFOR_MAX;
if(this._offset<0){
this._offset=0
}
this._showResults(true,true,this.getSubList())
}else{
var s;
var e;
this._offset+=ZmContactsApp.SEARCHFOR_MAX;
var n=this.getSubList();
if(!n||((n.size()<ZmContactsApp.SEARCHFOR_MAX)&&this._list.hasMore)){
if(!n){
n=this._chooser.sourceListView.getList()
}
var t=(n.size()>0)?n.getLast():null;
if(t){
s=t.__contact.id;
e=t.__contact.sf
}
this.search(null,null,null,s,e)
}else{
var a=this._list.hasMore;
if(!a){
a=(this._offset+ZmContactsApp.SEARCHFOR_MAX)<this._list.size()
}
this._showResults(true,a,n)
}}};
ZmContactPicker.prototype.getSubList=function(){
var t=this._list.size();
var e=this._offset+ZmContactsApp.SEARCHFOR_MAX;
if(e>t){
e=t
}
return(this._offset<e)?(AjxVector.fromArray(this._list.getArray().slice(this._offset,e))):null
};
ZmContactPicker.prototype._searchTypeListener=function(t){
var e=t._args.oldValue;
var a=t._args.newValue;
if(e!=a){
this._updateSearchRows(a);
this._searchButtonListener()
}};
ZmContactPicker.prototype._resetColHeaders=function(){
var e=this._chooser.sourceListView;
e.headerColCreated=false;
var n=this._selectDiv&&(this._selectDiv.getValue()==ZmContactsApp.SEARCHFOR_GAL);
var t=0;
for(var a=0;
a<e._headerList.length;
a++){
var o=e._headerList[a]._field;
if(o==ZmItem.F_NAME){
t=a
}
if(o==ZmItem.F_DEPARTMENT){
e._headerList[a]._visible=n&&this._detailed
}}
var s=n?null:ZmItem.F_NAME;
e._headerList[t]._sortable=s;
e.createHeaderHtml(s)
};
ZmContactPicker.prototype._okButtonListener=function(e){
var t=this._chooser.getItems();
DwtDialog.prototype._buttonListener.call(this,e,[t])
};
ZmContactPicker.prototype._cancelButtonListener=function(e){
DwtDialog.prototype._buttonListener.call(this,e);
this.popdown()
};
ZmContactPicker._keyPressHdlr=function(a){
var t=DwtControl.getTargetControl(a);
var e=DwtKeyEvent.getCharCode(a);
t.clearSearch(DwtUiEvent.getTarget(a));
if(t._keyPressCallback&&(e==13||e==3)){
t._keyPressCallback.run();
return false
}
return true
};
ZmContactPicker._onclickHdlr=function(t){
var e=DwtControl.getTargetControl(t);
e.clearSearch(DwtUiEvent.getTarget(t))
};
ZmContactChooser=function(e){
DwtChooser.call(this,e)
};
ZmContactChooser.prototype=new DwtChooser;
ZmContactChooser.prototype.constructor=ZmContactChooser;
ZmContactChooser.prototype._createSourceListView=function(){
return new ZmContactChooserSourceListView(this)
};
ZmContactChooser.prototype._createTargetListView=function(){
return new ZmContactChooserTargetListView(this,(this._buttonInfo.length>1))
};
ZmContactChooser.prototype._isDuplicate=function(e,t){
return t.containsLike(e,e.getAddress)
};
ZmContactChooserSourceListView=function(e){
DwtChooserListView.call(this,{
parent:e,type:DwtChooserListView.SOURCE,view:ZmId.VIEW_CONTACT_SRC}
);
this.setScrollStyle(Dwt.CLIP)
};
ZmContactChooserSourceListView.prototype=new DwtChooserListView;
ZmContactChooserSourceListView.prototype.constructor=ZmContactChooserSourceListView;
ZmContactChooserSourceListView.prototype.toString=function(){
return"ZmContactChooserSourceListView"
};
ZmContactChooserSourceListView.prototype.getToolTipContent=function(a){
if(this._hoveredItem){
var t={
address:this._hoveredItem.address,contact:this._hoveredItem.__contact,ev:a,noRightClick:true};
var e=new AjxCallback(this,function(o){
appCtxt.getToolTipMgr().getToolTip(ZmToolTipMgr.PERSON,t,o)
}
);
return{
callback:e}
}else{
return""
}};
ZmContactChooserSourceListView.prototype._getHeaderList=function(){
var e=[];
e.push(new DwtListHeaderItem({
field:ZmItem.F_TYPE,icon:"Folder",width:ZmMsg.COLUMN_WIDTH_FOLDER_CN}
));
e.push(new DwtListHeaderItem({
field:ZmItem.F_NAME,text:ZmMsg._name,width:ZmMsg.COLUMN_WIDTH_NAME_CN,resizeable:true}
));
e.push(new DwtListHeaderItem({
field:ZmItem.F_DEPARTMENT,text:ZmMsg.department,width:ZmMsg.COLUMN_WIDTH_DEPARTMENT_CN,resizeable:true}
));
e.push(new DwtListHeaderItem({
field:ZmItem.F_EMAIL,text:ZmMsg.email,resizeable:true}
));
return e
};
ZmContactChooserSourceListView.prototype._resetColWidth=function(){
if(!this.headerColCreated){
return
}
var a=this._getLastColumnIndex();
if(a){
var t=this._headerList[a];
var e=document.getElementById(t._id);
if(e){
var o=e.firstChild;
e.style.width=o.style.width=(t._width||"")
}}};
ZmContactChooserSourceListView.prototype._calcRelativeWidth=function(a){
var t=this._headerList[a];
if(!t._width||(t._width&&t._width=="auto")){
var e=document.getElementById(t._id);
return(e)?(e.clientWidth-(AjxEnv.isIE?Dwt.SCROLLBAR_WIDTH:5)):null
}
return t._width
};
ZmContactChooserSourceListView.prototype._mouseOverAction=function(t,o){
DwtChooserListView.prototype._mouseOverAction.call(this,t,o);
var a=t.target.id||o.id;
var e=this.getItemFromElement(o);
this._hoveredItem=(a&&e)?e:null;
return true
};
ZmContactChooserSourceListView.prototype._getCellContents=function(t,e,o,n,r,s){
if(n==ZmItem.F_EMAIL&&AjxEnv.isIE){
var a=AjxStringUtil.getWidth(o.address);
t[e++]="<div style='float; left; overflow: visible; width: "+a+";'>";
e=ZmContactsHelper._getEmailField(t,e,o,n,r,s);
t[e++]="</div>"
}else{
e=ZmContactsHelper._getEmailField(t,e,o,n,r,s)
}
return e
};
ZmContactChooserSourceListView.prototype._getCellAttrText=function(e,t,a){
if(t==ZmItem.F_EMAIL){
return"style='position: relative; overflow: visible;'"
}};
ZmContactChooserTargetListView=function(e,t){
this._showType=t;
DwtChooserListView.call(this,{
parent:e,type:DwtChooserListView.TARGET,view:ZmId.VIEW_CONTACT_TGT}
);
this.setScrollStyle(Dwt.CLIP)
};
ZmContactChooserTargetListView.prototype=new DwtChooserListView;
ZmContactChooserTargetListView.prototype.constructor=ZmContactChooserTargetListView;
ZmContactChooserTargetListView.prototype.toString=function(){
return"ZmContactChooserTargetListView"
};
ZmContactChooserTargetListView.prototype._getHeaderList=function(){
var t=[];
var e=this._view;
if(this._showType){
t.push(new DwtListHeaderItem({
field:ZmItem.F_TYPE,icon:"ContactsPicker",width:ZmMsg.COLUMN_WIDTH_TYPE_CN}
))
}
t.push(new DwtListHeaderItem({
field:ZmItem.F_NAME,text:ZmMsg._name,width:ZmMsg.COLUMN_WIDTH_NAME_CN,resizeable:true}
));
t.push(new DwtListHeaderItem({
field:ZmItem.F_EMAIL,text:ZmMsg.email,resizeable:true}
));
return t
};
ZmContactChooserTargetListView.prototype._mouseOverAction=ZmContactChooserSourceListView.prototype._mouseOverAction;
ZmContactChooserTargetListView.prototype._getCellContents=function(t,e,o,n,r,s){
if(n==ZmItem.F_TYPE){
o.setType(o._buttonId);
t[e++]=ZmMsg[o.getTypeAsString()];
t[e++]=":"
}else{
if(n==ZmItem.F_EMAIL&&AjxEnv.isIE){
var a=AjxStringUtil.getWidth(o.address)+10;
t[e++]="<div style='float; left;  width: "+a+";'>";
e=ZmContactsHelper._getEmailField(t,e,o,n,r,s);
t[e++]="</div>"
}else{
e=ZmContactsHelper._getEmailField(t,e,o,n,r)
}}
return e
};
ZmContactChooserTargetListView.prototype._resetColWidth=function(){
if(!this.headerColCreated){
return
}
var a=this._getLastColumnIndex();
if(a){
var t=this._headerList[a];
var e=document.getElementById(t._id);
if(e){
var o=e.firstChild;
e.style.width=o.style.width=(t._width||"")
}}};
ZmContactChooserTargetListView.prototype._calcRelativeWidth=function(a){
var t=this._headerList[a];
if(!t._width||(t._width&&t._width=="auto")){
var e=document.getElementById(t._id);
return(e)?(e.clientWidth-(AjxEnv.isIE?Dwt.SCROLLBAR_WIDTH:5)):null
}
return t._width
};
ZmContactChooserTargetListView.prototype._getCellAttrText=function(e,t,a){
if(t==ZmItem.F_EMAIL){
return"style='position: relative; overflow: visible;'"
}}
}}
if(AjxPackage.define("abook.Contacts")){
AjxTemplate.register("abook.Contacts#ZmEditContactView",function(t,s,n,e){
var o=Boolean(e);
n=(typeof n=="string"?{
id:n}
:n)||{};
e=e||[];
var a=e.length;
e[a++]='<div id="';
e[a++]=n.id;
e[a++]="_DEBUG\"></div><table valign=top width='100%' cellspacing=0>";
e[a++]=AjxTemplate.expand("#ZmEditContactView_header",n);
e[a++]=AjxTemplate.expand("#ZmEditContactView_body",n);
e[a++]="</table>";
return o?e.length:e.join("")
}
,{
id:"abook.Contacts#ZmEditContactView"}
,false);
AjxTemplate.register("abook.Contacts",AjxTemplate.getTemplate("abook.Contacts#ZmEditContactView"),AjxTemplate.getParams("abook.Contacts#ZmEditContactView"));
AjxTemplate.register("abook.Contacts#ZmEditContactView_header",function(t,s,n,e){
var o=Boolean(e);
n=(typeof n=="string"?{
id:n}
:n)||{};
e=e||[];
var a=e.length;
e[a++]='<tr valign=top class=contactHeaderTable><td class=contactHeaderCell><div id="';
e[a++]=n.id;
e[a++]='_IMAGE" tabindex="100"></div><div id="';
e[a++]=n.id;
e[a++]="_REMOVE_IMAGE_row\" style='padding-left:7px;font-size:.8em'><nobr><a id=\"";
e[a++]=n.id;
e[a++]='_VIEW_IMAGE" href="#view" tabindex="101">';
e[a++]=ZmMsg.view;
e[a++]="</a>\n";
e[a++]="                    |\n";
e[a++]='                    <a id="';
e[a++]=n.id;
e[a++]='_REMOVE_IMAGE" href="#remove" tabindex="102">';
e[a++]=ZmMsg.remove;
e[a++]='</a></nobr></div></td><td class="contactHeaderCell" valign="bottom"><div style=\'padding:.125em\'><div id="';
e[a++]=n.id;
e[a++]='_FULLNAME"></div></div>';
if(appCtxt.get(ZmSetting.TAGGING_ENABLED)){
e[a++]='<div id="';
e[a++]=n.id;
e[a++]='_TAG"></div>'
}
e[a++]=AjxTemplate.expand("#ZmEditContactView_headerName",n);
e[a++]=AjxTemplate.expand("#ZmEditContactView_headerJobInfo",n);
e[a++]="</td><td class=contactHeaderCell><table><tr><td>";
e[a++]=ZmMsg.fileAsLabel;
e[a++]='</td><td><div id="';
e[a++]=n.id;
e[a++]='_FILE_AS" tabindex="400"></div></td></tr><tr><td>';
e[a++]=ZmMsg.locationLabel;
e[a++]='</td><td><div id="';
e[a++]=n.id;
e[a++]='_FOLDER" tabindex="401"></div></td></tr>';
if(appCtxt.multiAccounts){
e[a++]="<tr><td>";
e[a++]=ZmMsg.accountLabel;
e[a++]='</td><td><div id="';
e[a++]=n.id;
e[a++]='_ACCOUNT" tabindex="402"></div></td></tr>'
}
e[a++]="</table></td></tr>";
return o?e.length:e.join("")
}
,{
id:"abook.Contacts#ZmEditContactView_header"}
,false);
AjxTemplate.register("abook.Contacts#ZmEditContactView_headerName",function(t,s,n,e){
var o=Boolean(e);
n=(typeof n=="string"?{
id:n}
:n)||{};
e=e||[];
var a=e.length;
e[a++]='<div id="';
e[a++]=n.id;
e[a++]="_NAME_row\" style='padding-bottom:4;'><table border=0 cellpadding=0 cellspacing=0>";
if(appCtxt.get(ZmSetting.PHONETIC_CONTACT_FIELDS)){
e[a++]='<tr id="';
e[a++]=n.id;
e[a++]='_PHONETIC_row"><td id="';
e[a++]=n.id;
e[a++]='_PHONETIC_PREFIX"></td><td id="';
e[a++]=n.id;
e[a++]='_PHONETIC_FIRST_row"><div id="';
e[a++]=n.id;
e[a++]='_PHONETIC_FIRST" tabindex="190"></div></td><td id="';
e[a++]=n.id;
e[a++]='_PHONETIC_MIDDLE"></td><td id="';
e[a++]=n.id;
e[a++]='_PHONETIC_MAIDEN"></td><td id="';
e[a++]=n.id;
e[a++]='_PHONETIC_LAST_row"><div id="';
e[a++]=n.id;
e[a++]='_PHONETIC_LAST" tabindex="191"></div></td><td id="';
e[a++]=n.id;
e[a++]='_PHONETIC_SUFFIX"></td></tr>'
}
e[a++]='<tr><td id="';
e[a++]=n.id;
e[a++]="_PREFIX_row\" style='padding-right:4;'><div id=\"";
e[a++]=n.id;
e[a++]='_PREFIX" tabindex="200"></div></td><td style=\'padding-right:4;\'><div id="';
e[a++]=n.id;
e[a++]='_FIRST" tabindex="201"></div></td><td id="';
e[a++]=n.id;
e[a++]="_MIDDLE_row\" style='padding-right:4;'><div id=\"";
e[a++]=n.id;
e[a++]='_MIDDLE" tabindex="202"></div></td><td id="';
e[a++]=n.id;
e[a++]="_MAIDEN_row\" style='padding-right:4;'><table border=0 cellspacing=0 cellpadding=0><td style='padding:0 2;'>(</td><td><div id=\"";
e[a++]=n.id;
e[a++]="_MAIDEN\" tabindex=\"203\"></div></td><td style='padding:0 2;'>)</td></table></td><td style='padding-right:4;'><div id=\"";
e[a++]=n.id;
e[a++]='_LAST" tabindex="204"></div></td><td id="';
e[a++]=n.id;
e[a++]="_SUFFIX_row\" style='padding-right:4;'><table border=0 cellspacing=0 cellpadding=0><td style='padding-right:4;'>,</td><td><div id=\"";
e[a++]=n.id;
e[a++]='_SUFFIX" tabindex="205"></div></td></table></td><td><div id="';
e[a++]=n.id;
e[a++]='_DETAILS" tabindex="206"></div></td></tr></table></div><div id="';
e[a++]=n.id;
e[a++]="_NICKNAME_row\" style='padding-bottom:4;'><table border=0 cellpadding=0 cellspacing=0><tr><td>&ldquo;</td><td><div id=\"";
e[a++]=n.id;
e[a++]='_NICKNAME" tabindex="250"></div></td><td>&rdquo;</td></tr></table></div>';
return o?e.length:e.join("")
}
,{
id:"abook.Contacts#ZmEditContactView_headerName"}
,false);
AjxTemplate.register("abook.Contacts#ZmEditContactView_headerJobInfo",function(t,s,n,e){
var o=Boolean(e);
n=(typeof n=="string"?{
id:n}
:n)||{};
e=e||[];
var a=e.length;
e[a++]='<div id="';
e[a++]=n.id;
e[a++]="_JOB_row\" style='padding-bottom:4;'><table border=0 cellpadding=0 cellspacing=0><tr><td id=\"";
e[a++]=n.id;
e[a++]='_TITLE_row"><div id="';
e[a++]=n.id;
e[a++]='_TITLE" tabindex="301"></div></td><td id="';
e[a++]=n.id;
e[a++]='_TITLE_DEPARTMENT_SEP">&nbsp;-&nbsp;</td><td id="';
e[a++]=n.id;
e[a++]='_DEPARTMENT_row"><div id="';
e[a++]=n.id;
e[a++]='_DEPARTMENT" tabindex="302"></div></td></tr></table></div><div id="';
e[a++]=n.id;
e[a++]="_COMPANY_row\" style='padding-bottom:4;'><table border=0 cellpadding=0 cellspacing=0>";
if(appCtxt.get(ZmSetting.PHONETIC_CONTACT_FIELDS)){
e[a++]='<tr id="';
e[a++]=n.id;
e[a++]='_PHONETIC_COMPANY_row"><td><div id="';
e[a++]=n.id;
e[a++]='_PHONETIC_COMPANY" tabindex="304"></div></td></tr>'
}
e[a++]='<tr><td><div id="';
e[a++]=n.id;
e[a++]='_COMPANY" tabindex="305"></div></td></tr></table></div>';
return o?e.length:e.join("")
}
,{
id:"abook.Contacts#ZmEditContactView_headerJobInfo"}
,false);
AjxTemplate.register("abook.Contacts#ZmEditContactView_body",function(t,s,n,e){
var o=Boolean(e);
n=(typeof n=="string"?{
id:n}
:n)||{};
e=e||[];
var a=e.length;
e[a++]="<tr valign=top><td class=rowLabel>";
e[a++]=ZmMsg.emailLabel;
e[a++]='</td><td class=rowValue><div id="';
e[a++]=n.id;
e[a++]='_EMAIL" tabindex="500"></div></td></tr><tr valign=top><td class=rowLabel>';
e[a++]=ZmMsg.phoneLabel;
e[a++]='</td><td class=rowValue><div id="';
e[a++]=n.id;
e[a++]='_PHONE" tabindex="600"></div></td></tr><tr valign=top><td class=rowLabel>';
e[a++]=ZmMsg.imLabel;
e[a++]='</td><td class=rowValue><div id="';
e[a++]=n.id;
e[a++]='_IM" tabindex="700"></div></td></tr><tr valign=top><td class=rowLabel>';
e[a++]=ZmMsg.addressLabel;
e[a++]='</td><td class=rowValue><div id="';
e[a++]=n.id;
e[a++]='_ADDRESS" tabindex="800"></div></td></tr><tr valign=top><td class=rowLabel>';
e[a++]=ZmMsg.urlLabel;
e[a++]='</td><td class=rowValue><div id="';
e[a++]=n.id;
e[a++]='_URL" tabindex="900"></div></td></tr><tr valign=top><td class=rowLabel>';
e[a++]=ZmMsg.otherLabel;
e[a++]='</td><td class=rowValue><div id="';
e[a++]=n.id;
e[a++]='_OTHER" tabindex="1000"></div></td></tr><tr valign=top><td class=rowLabel>';
e[a++]=ZmMsg.notesLabel;
e[a++]='</td><td class=rowValue><div id="';
e[a++]=n.id;
e[a++]='_NOTES" tabindex="1100"></div></td></tr>';
return o?e.length:e.join("")
}
,{
id:"abook.Contacts#ZmEditContactView_body"}
,false);
AjxTemplate.register("abook.Contacts#ZmEditContactViewRows",function(t,s,n,e){
var o=Boolean(e);
n=(typeof n=="string"?{
id:n}
:n)||{};
e=e||[];
var a=e.length;
e[a++]='<table border=0 cellspacing=0 cellpadding=0><tbody id="';
e[a++]=n.id;
e[a++]='_rows" tabindex="100"></tbody></table>';
return o?e.length:e.join("")
}
,{
id:"abook.Contacts#ZmEditContactViewRows"}
,false);
AjxTemplate.register("abook.Contacts#ZmEditContactViewDetailsButton",function(t,s,n,e){
var o=Boolean(e);
n=(typeof n=="string"?{
id:n}
:n)||{};
e=e||[];
var a=e.length;
e[a++]='<span id="';
e[a++]=n.id;
e[a++]='_title" class="ZButtonBorder ZWidgetTitle"></span>';
return o?e.length:e.join("")
}
,{
id:"abook.Contacts#ZmEditContactViewDetailsButton"}
,false);
AjxTemplate.register("abook.Contacts#ZmEditContactViewInputSelect",function(t,s,n,e){
var o=Boolean(e);
n=(typeof n=="string"?{
id:n}
:n)||{};
e=e||[];
var a=e.length;
e[a++]="<table border=0 cellpadding=0 cellspacing=0><tr><td style='padding-right:3'><div id='";
e[a++]=n.id;
e[a++]="_input' tabindex=\"100\"></div></td><td><div id='";
e[a++]=n.id;
e[a++]='_select\' tabindex="200"></div></td></tr></table>';
return o?e.length:e.join("")
}
,{
id:"abook.Contacts#ZmEditContactViewInputSelect"}
,false);
AjxTemplate.register("abook.Contacts#ZmEditContactViewInputDoubleSelect",function(t,s,n,e){
var o=Boolean(e);
n=(typeof n=="string"?{
id:n}
:n)||{};
e=e||[];
var a=e.length;
e[a++]="<table border=0 cellpadding=0 cellspacing=0><tr><td style='padding-right:3'><div id='";
e[a++]=n.id;
e[a++]="_input' tabindex=\"100\"></div></td><td><div id='";
e[a++]=n.id;
e[a++]="_select' tabindex=\"200\"></div></td><td><div id='";
e[a++]=n.id;
e[a++]='_select2\' tabindex="300"></div></td></tr></table>';
return o?e.length:e.join("")
}
,{
id:"abook.Contacts#ZmEditContactViewInputDoubleSelect"}
,false);
AjxTemplate.register("abook.Contacts#ZmEditContactViewOther",function(t,s,n,e){
var o=Boolean(e);
n=(typeof n=="string"?{
id:n}
:n)||{};
e=e||[];
var a=e.length;
e[a++]="<table border=0 cellpadding=0 cellspacing=0><tr><td style='padding-right:3'><div id='";
e[a++]=n.id;
e[a++]="_input' tabindex=\"100\"></div></td><td style='padding-right:3'><div id='";
e[a++]=n.id;
e[a++]="_picker' tabindex=\"200\"></div></td><td style='padding-left:14px'><div id='";
e[a++]=n.id;
e[a++]='_select\' tabindex="300"></div></td></tr></table>';
return o?e.length:e.join("")
}
,{
id:"abook.Contacts#ZmEditContactViewOther"}
,false);
AjxTemplate.register("abook.Contacts#ZmEditContactViewAddressRow",function(t,s,n,e){
var o=Boolean(e);
n=(typeof n=="string"?{
id:n}
:n)||{};
e=e||[];
var a=e.length;
e[a++]='<table><tr id="';
e[a++]=n.id;
e[a++]='_row" class="DwtFormRow" valign=top><td><div id="';
e[a++]=n.id;
e[a++]='" tabindex="100"></div></td><td><div id="';
e[a++]=n.id;
e[a++]='_add" class="DwtFormRowAdd" tabindex="200"></div></td><td><div id="';
e[a++]=n.id;
e[a++]='_remove" class="DwtFormRowRemove" tabindex="300"></div></td></tr></table>';
return o?e.length:e.join("")
}
,{
id:"abook.Contacts#ZmEditContactViewAddressRow"}
,false);
AjxTemplate.register("abook.Contacts#ZmEditContactViewAddressSelect",function(t,s,n,e){
var o=Boolean(e);
n=(typeof n=="string"?{
id:n}
:n)||{};
e=e||[];
var a=e.length;
e[a++]="<table border=0 cellpadding=0 cellspacing=0><tr valign=top><td style='padding-right:3'><div id='";
e[a++]=n.id;
e[a++]="_input' tabindex=\"100\"></div></td><td><div id='";
e[a++]=n.id;
e[a++]='_select\' tabindex="200"></div></td></tr></table>';
return o?e.length:e.join("")
}
,{
id:"abook.Contacts#ZmEditContactViewAddressSelect"}
,false);
AjxTemplate.register("abook.Contacts#ZmEditContactViewAddress",function(t,s,n,e){
var o=Boolean(e);
n=(typeof n=="string"?{
id:n}
:n)||{};
e=e||[];
var a=e.length;
e[a++]="<table style='position:relative;left:-3'><tr><td><div id=\"";
e[a++]=n.id;
e[a++]='_STREET" tabindex="100"></div></td></tr></table><table style=\'position:relative;left:-3\'><tr><td><div id="';
e[a++]=n.id;
e[a++]='_CITY" tabindex="200"></div></td><td>,&nbsp;</td><td><div id="';
e[a++]=n.id;
e[a++]='_STATE" tabindex="300"></div></td><td>&nbsp;&nbsp;</td><td><div id="';
e[a++]=n.id;
e[a++]='_ZIP" tabindex="400"></div></td></tr></table><table style=\'position:relative;left:-3\'><tr><td><div id="';
e[a++]=n.id;
e[a++]='_COUNTRY" tabindex="500"></div></td></tr></table>';
return o?e.length:e.join("")
}
,{
id:"abook.Contacts#ZmEditContactViewAddress","class":"DwtForm ZmEditContactViewAddress"}
,false);
AjxTemplate.register("abook.Contacts#SplitView",function(t,s,n,e){
var o=Boolean(e);
n=(typeof n=="string"?{
id:n}
:n)||{};
e=e||[];
var a=e.length;
e[a++]="<table border=0 cellpadding=0 cellspacing=5 width=100% height=100%><col width=230></col><tr><td id='";
e[a++]=n.id;
e[a++]="_alphabetbar'></td></tr><tr height=100%><td valign=top><div id='";
e[a++]=n.id;
e[a++]="_splitview' style='position:relative;width:100%;height:100%'><div id='";
e[a++]=n.id;
e[a++]="_listview' style='position:absolute;width:230px;height:100%;left:0px'></div><div id='";
e[a++]=n.id;
e[a++]="_sash' style='position:absolute;width:8px;height:100%;left:230px'></div><div id='";
e[a++]=n.id;
e[a++]="_contentCell' style='position:absolute;height:100%;left:238px'><div class='ZmContactInfoView' id='";
e[a++]=n.id;
e[a++]="_content'></div></div></div></td></tr></table>";
return o?e.length:e.join("")
}
,{
id:"abook.Contacts#SplitView"}
,false);
AjxTemplate.register("abook.Contacts#SplitView_content",function(t,s,n,e){
var o=Boolean(e);
n=(typeof n=="string"?{
id:n}
:n)||{};
e=e||[];
var a=e.length;
e[a++]=AjxTemplate.expand("abook.Contacts#SplitView_header",n);
e[a++]="<table id='";
e[a++]=n.id;
e[a++]="_details'>";
e[a++]=ZmContactSplitView.showContactEmails(n);
e[a++]=ZmContactSplitView.showContactPhones(n);
e[a++]=ZmContactSplitView.showContactIMs(n);
e[a++]=ZmContactSplitView.showContactAddresses(n);
e[a++]=ZmContactSplitView.showContactUrls(n);
e[a++]=ZmContactSplitView.showContactOther(n);
e[a++]=ZmContactSplitView.showContactNotes(n);
e[a++]=ZmContactSplitView.showContactDLMembers(n);
e[a++]="</table>";
return o?e.length:e.join("")
}
,{
id:"abook.Contacts#SplitView_content"}
,false);
AjxTemplate.register("abook.Contacts#SplitView_header",function(e,t,s,n){
var a=Boolean(n);
s=(typeof s=="string"?{
id:s}
:s)||{};
n=n||[];
var o=n.length;
var r=s.contact;
var c=r.getImageUrl();
var l=appCtxt.multiAccounts&&r.account&&r.account.getDisplayName();
var h=r.isGroup()?"GroupPerson_48":"Person_48";
n[o++]="<table border=0 cellspacing=2 cellpadding=2 width=100% class='contactHeaderTable ";
n[o++]=s.contactHdrClass;
n[o++]="'><tr>";
if(c){
n[o++]='<td valign=bottom width=48 rowspan=2><img src="';
n[o++]=c;
n[o++]='" \n';
n[o++]="\t\t\t\t";
if(AjxEnv.isIE){
n[o++]="\n";
n[o++]="\t\t\t\t\theight=48\n";
n[o++]="\t\t\t\t"
}else{
n[o++]="\n";
n[o++]='\t\t\t\t\tstyle="max-width:48px;max-height:48px"\n';
n[o++]="\t\t\t\t"
}
n[o++]="\n";
n[o++]="\t\t\t\t border=0></td>"
}else{
n[o++]="<td valign=bottom width=48 rowspan=2>";
n[o++]=AjxImg.getImageHtml(h);
n[o++]="</td>"
}
n[o++]="<td id='";
n[o++]=s.id;
n[o++]="_tags' align='right' colspan=2></td></tr><tr><td valign=bottom>";
n[o++]=AjxTemplate.expand("#SplitView_headerName",s);
n[o++]=AjxTemplate.expand("#SplitView_headerJobInfo",s);
n[o++]="</td><td valign=bottom align='right'>";
if(l){
n[o++]="<table border=0 cellpadding=0 cellspacing=0 width=1%><tr><td class='contactLocation' nowrap=\"nowrap\">";
n[o++]=ZmMsg.accountLabel;
n[o++]="&nbsp;</td><td class='companyFolder' colspan=10>";
n[o++]=AjxStringUtil.htmlEncode(l);
n[o++]="</td></tr></table>"
}
n[o++]="<table border=0 cellpadding=0 cellspacing=0 width=1%><tr><td class='contactLocation' nowrap=\"nowrap\">";
n[o++]=ZmMsg.locationLabel;
n[o++]="&nbsp;</td>";
if(s.addrbook){
n[o++]="<td width=20>";
n[o++]=AjxImg.getImageHtml(s.addrbook.getIcon());
n[o++]="</td><td>&nbsp;</td><td class='companyFolder'>";
n[o++]=s.addrbook.getName();
n[o++]="</td>"
}else{
if(s.isGal){
n[o++]="<td width=20>";
n[o++]=AjxImg.getImageHtml("GAL");
n[o++]="</td><td>&nbsp;</td><td class='companyFolder'>";
n[o++]=ZmMsg.GAL;
n[o++]="</td>"
}}
n[o++]="</tr></table></td></tr></table>";
return a?n.length:n.join("")
}
,{
id:"abook.Contacts#SplitView_header"}
,false);
AjxTemplate.register("abook.Contacts#SplitView_headerName",function(e,a,r,s){
var o=Boolean(s);
r=(typeof r=="string"?{
id:r}
:r)||{};
s=s||[];
var n=s.length;
var l=r.contact;
var c=appCtxt.get(ZmSetting.PHONETIC_CONTACT_FIELDS);
var t=l.getFullNameForDisplay(c);
if(!c){
t=AjxStringUtil.htmlEncode(t)
}
var h=l.getAttr(ZmContact.F_nickname);
s[n++]="<div class='contactHeader ";
s[n++]=r.isInTrash?"Trash":"";
s[n++]="'>";
s[n++]=t;
s[n++]="</div>";
if(h){
s[n++]="<div class='companyName'>&ldquo;";
s[n++]=AjxStringUtil.htmlEncode(h);
s[n++]="&rdquo;</div>"
}
return o?s.length:s.join("")
}
,{
id:"abook.Contacts#SplitView_headerName"}
,false);
AjxTemplate.register("abook.Contacts#SplitView_headerJobInfo",function(e,a,h,s){
var o=Boolean(s);
h=(typeof h=="string"?{
id:h}
:h)||{};
s=s||[];
var n=s.length;
var l=h.contact;
var d=appCtxt.get(ZmSetting.PHONETIC_CONTACT_FIELDS);
var u=l.getAttr(ZmContact.F_company);
var m=l.getAttr(ZmContact.F_jobTitle);
var r=l.getAttr(ZmContact.F_department);
if(m||r){
s[n++]="<div class='companyName'>";
if(m){
s[n++]="<span>";
s[n++]=AjxStringUtil.htmlEncode(m);
s[n++]="</span>"
}
if(r){
if(m){
s[n++]="\n";
s[n++]="                &nbsp;-&nbsp;\n";
s[n++]="            "
}
s[n++]="<span>";
s[n++]=AjxStringUtil.htmlEncode(r);
s[n++]="</span>"
}
s[n++]="</div>"
}
if(u){
var c=d&&l.getAttr(ZmContact.F_phoneticCompany);
var t=AjxStringUtil.htmlRubyEncode(u,c);
s[n++]="<div class='companyName'>";
s[n++]=t;
s[n++]="</div>"
}
return o?s.length:s.join("")
}
,{
id:"abook.Contacts#SplitView_headerJobInfo"}
,false);
AjxTemplate.register("abook.Contacts#SplitView_dlmember-collapsed",function(t,s,n,e){
var o=Boolean(e);
n=(typeof n=="string"?{
id:n}
:n)||{};
e=e||[];
var a=e.length;
e[a++]="<td ";
e[a++]=n.expandTdText;
e[a++]=">";
e[a++]=n.html.join("");
e[a++]="</td><td class=rowLabel>";
e[a++]=n.contact.canExpand?ZmMsg.membersLabel:"";
e[a++]="</td><td colspan=2 class=rowValue>";
e[a++]=n.value;
e[a++]="</td>";
return o?e.length:e.join("")
}
,{
id:"abook.Contacts#SplitView_dlmember-collapsed"}
,false);
AjxTemplate.register("abook.Contacts#SplitView_dlmember-expanded",function(t,s,n,e){
var o=Boolean(e);
n=(typeof n=="string"?{
id:n}
:n)||{};
e=e||[];
var a=e.length;
e[a++]="<td ";
e[a++]=n.seenone?"":n.expandTdText;
e[a++]=">";
e[a++]=n.html.join("");
e[a++]="</td><td class='rowLabel'>";
e[a++]=n.seenone?"":ZmMsg.membersLabel;
e[a++]="</td><td colspan=2 class='rowValue'>";
e[a++]=n.value;
e[a++]="</td>";
return o?e.length:e.join("")
}
,{
id:"abook.Contacts#SplitView_dlmember-expanded"}
,false);
AjxTemplate.register("abook.Contacts#SplitView_address_value",function(a,r,s,t){
var n=Boolean(t);
s=(typeof s=="string"?{
id:s}
:s)||{};
t=t||[];
var o=t.length;
t[o++]="<tr valign=top><td class=rowLabel>";
t[o++]=s.seenone?"":s.label;
t[o++]="</td><td id='";
t[o++]=s.id;
t[o++]="_";
t[o++]=s.name;
t[o++]="' class=rowValue>";
var e=s.address;
if(e.Street){
t[o++]="<div>";
t[o++]=e.Street;
t[o++]="</div>"
}
if(e.City||e.State||e.PostalCode){
t[o++]="<div><span>";
t[o++]=e.City;
t[o++]="</span>";
if(e.City&&e.State){
t[o++]=", "
}
t[o++]="<span>";
t[o++]=e.State;
t[o++]="</span>";
if(e.City||e.State){
t[o++]="&nbsp;"
}
t[o++]="<span>";
t[o++]=e.PostalCode;
t[o++]="</span></div>"
}
if(e.Country){
t[o++]="<div>";
t[o++]=e.Country;
t[o++]="</div>"
}
t[o++]="</td><td style='color:gray' class='rowType'>&nbsp;";
t[o++]=s.type;
t[o++]="</td></tr>";
return n?t.length:t.join("")
}
,{
id:"abook.Contacts#SplitView_address_value"}
,false);
AjxTemplate.register("abook.Contacts#SplitView_list_item",function(t,s,n,e){
var o=Boolean(e);
n=(typeof n=="string"?{
id:n}
:n)||{};
e=e||[];
var a=e.length;
e[a++]="<tr valign=top>";
if(n.isDL){
e[a++]='<td><div class ="ImgBlank_16"></div></td>'
}
e[a++]="<td class='rowLabel'>";
e[a++]=n.seenone?"":n.label;
e[a++]="</td><td id='";
e[a++]=n.id;
e[a++]="_";
e[a++]=n.name1.replace(/['"]/g,"");
e[a++]="' ";
e[a++]=n.type?"":"colspan=2";
e[a++]=" class='rowValue'>";
e[a++]=n.value;
e[a++]="</td>";
if(n.type){
e[a++]="<td style='color:gray' class='rowType'>&nbsp;";
e[a++]=n.type;
e[a++]="</td>"
}
e[a++]="</tr>";
return o?e.length:e.join("")
}
,{
id:"abook.Contacts#SplitView_list_item"}
,false);
AjxTemplate.register("abook.Contacts#SplitViewGroup",function(t,s,n,e){
var o=Boolean(e);
n=(typeof n=="string"?{
id:n}
:n)||{};
e=e||[];
var a=e.length;
e[a++]=AjxTemplate.expand("abook.Contacts#SplitView_header",n);
e[a++]="<table>";
e[a++]=ZmContactSplitView.showContactGroup(n);
e[a++]="</table>";
return o?e.length:e.join("")
}
,{
id:"abook.Contacts#SplitViewGroup"}
,false);
AjxTemplate.register("abook.Contacts#SimpleView-NoResults",function(t,s,n,e){
var o=Boolean(e);
n=(typeof n=="string"?{
id:n}
:n)||{};
e=e||[];
var a=e.length;
e[a++]="<table width='100%' cellspacing=0 cellpadding=1><tr><td class='NoResults' valign='top' ><br/><br/>";
e[a++]=AjxMsg.noResults;
e[a++]="</td></tr></table>";
return o?e.length:e.join("")
}
,{
id:"abook.Contacts#SimpleView-NoResults"}
,false);
AjxTemplate.register("abook.Contacts#GroupView",function(t,s,n,e){
var o=Boolean(e);
n=(typeof n=="string"?{
id:n}
:n)||{};
e=e||[];
var a=e.length;
e[a++]="<!-- title bar --><table cellspacing=0 cellpadding=0 width=100%><tr class='contactHeaderRow' id='";
e[a++]=n.id;
e[a++]="_headerRow'><td width=20><center>";
e[a++]=AjxImg.getImageHtml("Group");
e[a++]="</center></td><td><div id='";
e[a++]=n.id;
e[a++]="_title' class='contactHeader'></div></td><td align='right' id='";
e[a++]=n.id;
e[a++]="_tags'></td></tr></table><table border=0 cellpadding=5 cellspacing=5 width=100% height=100%><tr><!-- content: left pane --><td width=50% valign=top><table border=0 cellpadding=2 cellspacing=2 width=100%><tr><td nowrap>*&nbsp;";
e[a++]=ZmMsg.groupNameLabel;
e[a++]="&nbsp;<input type='text' autocomplete='off' size=18 id='";
e[a++]=n.id;
e[a++]="_groupName'></td><td><table border=0 cellpadding=0 cellspacing=0><tr><td nowrap>";
e[a++]=ZmMsg.addressBookLabel;
e[a++]="&nbsp;</td><td id='";
e[a++]=n.id;
e[a++]="_folderSelect'></td></tr></table></td></tr><tr><td colspan='2' nowrap>*&nbsp;";
e[a++]=ZmMsg.groupMembers;
e[a++]="</td></tr></table><div class='groupMembers'  id='";
e[a++]=n.id;
e[a++]="_groupMembers'></div><table border=0 cellpadding=3 cellspacing=2 width=100%><tr><td id='";
e[a++]=n.id;
e[a++]="_delButton'></td><td id='";
e[a++]=n.id;
e[a++]="_delAllButton'></td><td width=100%></td></tr></table></td><!-- content: right pane --><td width=50% valign=top><fieldset><legend class='groupFieldset'>";
e[a++]=ZmMsg.addMembers;
e[a++]="</legend><table border=0>";
if(n.detailed){
e[a++]="<tr id='";
e[a++]=n.id;
e[a++]="_searchNameRow'><td align=right>";
e[a++]=ZmMsg.nameLabel;
e[a++]="</td><td><input type='text' id='";
e[a++]=n.id;
e[a++]="_searchNameField'></td><td id='";
e[a++]=n.id;
e[a++]="_searchButton' valign=top rowspan=3></td></tr>";
if(appCtxt.get(ZmSetting.PHONETIC_CONTACT_FIELDS)){
e[a++]="<tr id='";
e[a++]=n.id;
e[a++]="_searchPhoneticRow'><td align=right>";
e[a++]=ZmMsg.phoneticNameLabel;
e[a++]="</td><td><input type='text' id='";
e[a++]=n.id;
e[a++]="_searchPhoneticField'></td></tr>"
}
e[a++]="<tr id='";
e[a++]=n.id;
e[a++]="_searchEmailRow'><td align=right>";
e[a++]=ZmMsg.emailAddrLabel;
e[a++]="</td><td><input type='text' id='";
e[a++]=n.id;
e[a++]="_searchEmailField'></td></tr><tr id='";
e[a++]=n.id;
e[a++]="_searchDepartmentRow'><td align=right>";
e[a++]=ZmMsg.departmentLabel;
e[a++]="</td><td><input type='text' id='";
e[a++]=n.id;
e[a++]="_searchDepartmentField'></td></tr>"
}else{
e[a++]="<tr id='";
e[a++]=n.id;
e[a++]="_searchRow'><td align=right>";
e[a++]=ZmMsg.findLabel;
e[a++]="</td><td><input type='text' id='";
e[a++]=n.id;
e[a++]="_searchField'></td><td id='";
e[a++]=n.id;
e[a++]="_searchButton'></td></tr>"
}
if(n.showSearchIn){
e[a++]="<tr><td align=right>";
e[a++]=ZmMsg.searchIn;
e[a++]="</td><td colspan=2 id='";
e[a++]=n.id;
e[a++]="_listSelect'></td></tr>"
}
e[a++]="</table><div class='groupMembers' id='";
e[a++]=n.id;
e[a++]="_listView'></div><table border=0 cellpadding=3 cellspacing=2 width=100%><tr><td id='";
e[a++]=n.id;
e[a++]="_addButton'></td><td id='";
e[a++]=n.id;
e[a++]="_addAllButton'></td><td width=100%></td><td id='";
e[a++]=n.id;
e[a++]="_prevButton'></td><td id='";
e[a++]=n.id;
e[a++]="_nextButton'></td></tr></table><table border=0 cellpadding=3 cellspacing=2 width=100%><tr><td>";
e[a++]=ZmMsg.enterAddrBelow;
e[a++]="</td></tr><tr><td><textarea class='groupMembers' id='";
e[a++]=n.id;
e[a++]="_addNewField'></textarea></td><td id='";
e[a++]=n.id;
e[a++]="_addNewButton'></td></tr></table></fieldset></td></tr></table>";
return o?e.length:e.join("")
}
,{
id:"abook.Contacts#GroupView"}
,false);
AjxTemplate.register("abook.Contacts#ZmAlphabetBar",function(t,r,s,e){
var n=Boolean(e);
s=(typeof s=="string"?{
id:s}
:s)||{};
e=e||[];
var o=e.length;
e[o++]="<center><table class='AlphabetBarTable' border=0 cellpadding=0 cellspacing=0 width=80% id='";
e[o++]=s.id;
e[o++]="_alphabet'><tr>";
for(var a=0;
a<s.numLetters;
a++){
e[o++]="<td _idx='";
e[o++]=a;
e[o++]="' onclick='ZmContactAlphabetBar.alphabetClicked(this\n";
e[o++]="\t\t\t\t\t\t";
if(a>0){
e[o++]="\n";
e[o++]='\t\t\t\t\t\t\t, "';
e[o++]=s.sortVals[s.alphabet[a]]||s.alphabet[a];
e[o++]='"\n';
e[o++]="\t\t\t\t\t\t\t";
if(a+1<s.numLetters){
e[o++]="\n";
e[o++]='\t\t\t\t\t\t\t\t, "';
e[o++]=s.endSortVals[s.alphabet[a]]||s.alphabet[a+1];
e[o++]='"\n';
e[o++]="\t\t\t\t\t\t\t"
}}
e[o++]="\n";
e[o++]="\t\t\t\t\t\t); return false;'\n";
e[o++]="\t\t\t\t\t\t";
if(s.alphabet[a].length>1){
e[o++]=" colspan='";
e[o++]=s.alphabet[a].length/2+1;
e[o++]="' "
}
e[o++]="\n";
e[o++]="\t\t\t\t\t\tclass='DwtButton AlphabetBarCell' onmouseover='ZmContactAlphabetBar._onMouseOver(this)' onmouseout='ZmContactAlphabetBar._onMouseOut(this)' ";
e[o++]=(a>0)?" style='border-left-width:0;'>":">";
e[o++]=s.alphabet[a];
e[o++]="</td>"
}
e[o++]="</tr></table></center>";
return n?e.length:e.join("")
}
,{
id:"abook.Contacts#ZmAlphabetBar"}
,false);
AjxTemplate.register("abook.Contacts#Tooltip",function(e,t,r,s){
var a=Boolean(s);
r=(typeof r=="string"?{
id:r}
:r)||{};
s=s||[];
var o=s.length;
s[o++]="<table cellpadding=0 cellspacing=0 border=0 width=250><tr><td colspan=2 valign=top><div style='border-bottom: 1px solid black; margin-bottom:2px'><table cellpadding=0 cellspacing=0 border=0 width=100%><tr valign='bottom'><td style='font-weight:bold'>";
s[o++]=AjxStringUtil.htmlEncode(r.entryTitle);
s[o++]="</td><td align='right'>";
s[o++]=AjxImg.getImageHtml(r.contact.getIcon());
s[o++]="</td></tr></table></div></td></tr>";
if(r.contact.isGroup()){
var n=r.contact.getGroupMembers().good.getArray();
for(var h=0;
h<n.length;
h++){
s[o++]="<tr><td width=20>";
s[o++]=AjxImg.getImageHtml("Message");
s[o++]="</td><td>";
s[o++]=AjxStringUtil.htmlEncode(n[h].toString());
s[o++]="</td></tr>"
}}else{
s[o++]=AjxTemplate.expand("abook.Contacts#AddTooltipEntry",{
data:r,field:"fullName"}
);
s[o++]=AjxTemplate.expand("abook.Contacts#AddTooltipEntry",{
data:r,field:"jobTitle"}
);
s[o++]=AjxTemplate.expand("abook.Contacts#AddTooltipEntry",{
data:r,field:"company"}
);
s[o++]=AjxTemplate.expand("abook.Contacts#AddTooltipEntry",{
data:r,field:"mobilePhone"}
);
s[o++]=AjxTemplate.expand("abook.Contacts#AddTooltipEntry",{
data:r,field:"workPhone"}
);
s[o++]=AjxTemplate.expand("abook.Contacts#AddTooltipEntry",{
data:r,field:"homePhone"}
);
if(r.contact.isGal){
var l=r.contact.getEmails();
for(var h=0;
h<l.length&&l.length<=3;
h++){
s[o++]=AjxTemplate.expand("abook.Contacts#AddTooltipEntry",{
data:r,field:"email",val:l[h]}
)
}
s[o++]=AjxTemplate.expand("abook.Contacts#AddTooltipEntry",{
data:r,field:"notes",truncate:500}
)
}else{
s[o++]=AjxTemplate.expand("abook.Contacts#AddTooltipEntry",{
data:r,field:"email",val:r.contact._lookupEmail||r.email}
)
}}
if(r.buddy){
s[o++]='<tr><td colspan="2"><table align="center"><tr><td>';
s[o++]=AjxImg.getImageHtml(r.buddy.getPresence().getIcon());
s[o++]="</td><td>";
s[o++]=AjxStringUtil.htmlEncode(r.buddy.getPresence().getShowText());
s[o++]="</td></tr></table></td></tr>"
}
if(r.hint){
s[o++]="<tr><td colspan=\"2\"><div class='TooltipHint'><hr color=black size=1>";
s[o++]=r.hint;
s[o++]="</div></td></tr>"
}
s[o++]="</table>";
return a?s.length:s.join("")
}
,{
id:"abook.Contacts#Tooltip"}
,false);
AjxTemplate.register("abook.Contacts#TooltipNotInAddrBook",function(t,s,n,e){
var o=Boolean(e);
n=(typeof n=="string"?{
id:n}
:n)||{};
e=e||[];
var a=e.length;
if(n.hint){
e[a++]="<table cellpadding=0 cellspacing=0 border=0 width=250><tr><td valign=top>";
if(appCtxt.get(ZmSetting.CONTACTS_ENABLED)){
e[a++]="<div style='border-bottom: 1px solid black;'><table cellpadding=0 cellspacing=0 border=0 width=100%><tr valign='bottom'><td style='font-weight:bold'>";
e[a++]=ZmMsg.newContact;
e[a++]="</td><td align='right'>";
e[a++]=AjxImg.getImageHtml("NewContact");
e[a++]="</td></tr></table></div>"
}
e[a++]='<div class="TooltipNotInAddrBook">';
e[a++]=AjxStringUtil.htmlEncode(n.addrstr);
e[a++]="</div><hr color=black size=1><div class='TooltipHint'>";
e[a++]=n.hint;
e[a++]="</div></td></tr></table>"
}else{
e[a++]="<span style='font-weight:bold'>";
e[a++]=ZmMsg.emailLabel;
e[a++]=" </span>";
e[a++]=AjxStringUtil.htmlEncode(n.addrstr)
}
return o?e.length:e.join("")
}
,{
id:"abook.Contacts#TooltipNotInAddrBook"}
,false);
AjxTemplate.register("abook.Contacts#AddTooltipEntry",function(a,h,s,t){
var n=Boolean(t);
s=(typeof s=="string"?{
id:s}
:s)||{};
t=t||[];
var o=t.length;
if(s.val==null){
var e=appCtxt.get(ZmSetting.PHONETIC_CONTACT_FIELDS);
s.val=s.field=="fullName"?s.data.contact.getFullNameForDisplay(e):s.data.contact.getAttr(s.field)
}
if(s.val!=null&&s.val!=""){
t[o++]="<tr valign=top><td class='ZmTooltipLabel'>";
t[o++]=AjxMessageFormat.format(ZmMsg.makeLabel,AjxStringUtil.htmlEncode(ZmContact._AB_FIELD[s.field]));
t[o++]="</td>";
if(s.truncate){
t[o++]="<td>";
t[o++]=AjxMessageFormat.format(ZmMsg.makeLabel,AjxStringUtil.htmlEncode(s.val.substring(0,s.truncate)));
t[o++]="</td>"
}else{
var r="";
if(s.field=="fullName"){
r=e?s.val:AjxStringUtil.htmlEncode(s.val)
}else{
r=AjxStringUtil.htmlEncode(s.val)
}
t[o++]="<td style='white-space:nowrap;'>";
t[o++]=r;
t[o++]="</td>"
}
t[o++]="</tr>"
}
return n?t.length:t.join("")
}
,{
id:"abook.Contacts#AddTooltipEntry"}
,false);
AjxTemplate.register("abook.Contacts#ZmContactPicker",function(t,s,n,e){
var o=Boolean(e);
n=(typeof n=="string"?{
id:n}
:n)||{};
e=e||[];
var a=e.length;
e[a++]="<div class='ZmContactPicker'><table border=0 cellpadding=1 cellspacing=1 width=100%><tr><td width=600><table border=0 cellpadding=0 cellspacing=0>";
if(n.detailed){
e[a++]="<tr><td valign=middle colspan=3 width=400><div id='";
e[a++]=n.id;
e[a++]="_searchIcon' class=\"ImgSearch\"></div></td></tr><tr id='";
e[a++]=n.id;
e[a++]="_searchNameRow'><td align=right>";
e[a++]=ZmMsg.nameLabel;
e[a++]="</td><td>&nbsp;<input type='text' autocomplete='off' size=30 nowrap id='";
e[a++]=n.id;
e[a++]="_searchNameField'>&nbsp;</td><td id='";
e[a++]=n.id;
e[a++]="_searchButton' rowspan=3 valign=top></td></tr>";
if(appCtxt.get(ZmSetting.PHONETIC_CONTACT_FIELDS)){
e[a++]="<tr id='";
e[a++]=n.id;
e[a++]="_searchPhoneticRow'><td align=right>";
e[a++]=ZmMsg.phoneticNameLabel;
e[a++]="</td><td>&nbsp;<input type='text' autocomplete='off' size=30 nowrap id='";
e[a++]=n.id;
e[a++]="_searchPhoneticField'>&nbsp;</td></tr>"
}
e[a++]="<tr id='";
e[a++]=n.id;
e[a++]="_searchEmailRow'><td align=right>";
e[a++]=ZmMsg.emailAddrLabel;
e[a++]="</td><td>&nbsp;<input type='text' autocomplete='off' size=30 nowrap id='";
e[a++]=n.id;
e[a++]="_searchEmailField'>&nbsp;</td></tr><tr id='";
e[a++]=n.id;
e[a++]="_searchDepartmentRow'><td align=right>";
e[a++]=ZmMsg.departmentLabel;
e[a++]="</td><td>&nbsp;<input type='text' autocomplete='off' size=30 nowrap id='";
e[a++]=n.id;
e[a++]="_searchDepartmentField'>&nbsp;</td></tr>"
}else{
e[a++]="<tr id='";
e[a++]=n.id;
e[a++]="_searchRow'><td width=20 valign=middle><div id='";
e[a++]=n.id;
e[a++]="_searchIcon' class=\"ImgSearch\"></div></td><td><input type='text' autocomplete='off' size=30 nowrap id='";
e[a++]=n.id;
e[a++]="_searchField'>&nbsp;</td><td id='";
e[a++]=n.id;
e[a++]="_searchButton'></td></tr>"
}
e[a++]="</table></td><td align=right valign=bottom>";
if(n.showSelect){
e[a++]="<table border=0 cellpadding=0 cellspacing=0><tr><td class='Label nobreak'>";
e[a++]=ZmMsg.showNames;
e[a++]="&nbsp;</td><td id='";
e[a++]=n.id;
e[a++]="_listSelect'></td></tr></table>"
}
e[a++]="</td></tr></table><div id='";
e[a++]=n.id;
e[a++]="_chooser'></div><div id='";
e[a++]=n.id;
e[a++]="_paging'><center><table border=0 cellspacing=0 cellpadding=0 width=100%><tr><td>&nbsp;&nbsp;&nbsp;</td><td id='";
e[a++]=n.id;
e[a++]="_pageLeft'></td><td width=100%></td><td id='";
e[a++]=n.id;
e[a++]="_pageRight' align=right></td></tr></table></center></div></div>";
return o?e.length:e.join("")
}
,{
id:"abook.Contacts#ZmContactPicker"}
,false);
AjxTemplate.register("abook.Contacts#ZmContactSearch",function(t,s,n,e){
var o=Boolean(e);
n=(typeof n=="string"?{
id:n}
:n)||{};
e=e||[];
var a=e.length;
e[a++]="<div id='";
e[a++]=n.id;
e[a++]="_preamble'></div><table border=0 cellpadding=1 cellspacing=1 width=100%><tr><td><table border=0 cellpadding=0 cellspacing=0><tr><td width=20 valign=middle><div id='";
e[a++]=n.id;
e[a++]="_searchIcon' class=\"ImgSearch\"></div></td><td><input type='text' autocomplete='off' size=30 nowrap id='";
e[a++]=n.id;
e[a++]="_searchField'>&nbsp;</td><td id='";
e[a++]=n.id;
e[a++]="_searchButton'></td></tr></table></td><td align=right>";
if(n.showSelect){
e[a++]="<table border=0 cellpadding=0 cellspacing=0><tr><td class='Label nobreak'>";
e[a++]=ZmMsg.showNames;
e[a++]="&nbsp;</td><td id='";
e[a++]=n.id;
e[a++]="_folders'></td></tr></table>"
}
e[a++]="</td></tr></table><div id='";
e[a++]=n.id;
e[a++]="_results' class='contactSearchResultsDiv'></div>";
return o?e.length:e.join("")
}
,{
id:"abook.Contacts#ZmContactSearch"}
,false)
};
