
/* Copyright (C) 2005-2009 Zimbra Inc. http://www.zimbra.com/ */
if(AjxPackage.define("Portal")){
if(AjxPackage.define("zimbraMail.portal.controller.ZmPortalController")){
ZmPortalController=function(e,t){
if(arguments.length==0){
return
}
ZmListController.call(this,e,t);
ZmOperation.registerOp(ZmId.OP_PAUSE_TOGGLE,{
textKey:"pause",image:"Pause",style:DwtButton.TOGGLE_STYLE}
);
this._listeners[ZmOperation.REFRESH]=new AjxListener(this,this._refreshListener);
this._listeners[ZmOperation.PAUSE_TOGGLE]=new AjxListener(this,this._pauseListener)
};
ZmPortalController.prototype=new ZmListController;
ZmPortalController.prototype.constructor=ZmPortalController;
ZmPortalController.prototype.toString=function(){
return"ZmPortalController"
};
ZmPortalController.prototype.show=function(){
ZmListController.prototype.show.call(this);
this._setup(this._currentView);
var e=new Object();
e[ZmAppViewMgr.C_TOOLBAR_TOP]=this._toolbar[this._currentView];
e[ZmAppViewMgr.C_APP_CONTENT]=this._listView[this._currentView];
this._setView({
view:this._currentView,elements:e,isAppView:true}
)
};
ZmPortalController.prototype.setPaused=function(o){
var e=this._listView[this._currentView];
var t=e&&e.getPortletIds();
if(t&&t.length>0){
var n=appCtxt.getApp(ZmApp.PORTAL).getPortletMgr();
for(var a=0;
a<t.length;
a++){
var s=n.getPortletById(t[a]);
s.setPaused(o)
}}};
ZmPortalController.prototype._defaultView=function(){
return ZmId.VIEW_PORTAL
};
ZmPortalController.prototype._getToolBarOps=function(){
return[ZmOperation.REFRESH]
};
ZmPortalController.prototype._createNewView=function(e){
return new ZmPortalView(this._container,this,this._dropTgt)
};
ZmPortalController.prototype._setViewContents=function(e){
this._listView[e].set()
};
ZmPortalController.prototype._refreshListener=function(){
this._app.refreshPortlets()
};
ZmPortalController.prototype._pauseListener=function(i){
var a=this._toolbar[this._currentView];
var t=a&&a.getButton(ZmOperation.REFRESH);
var e=i.item.isToggled();
if(t){
t.setEnabled(!e)
}
this.setPaused(e)
};
ZmPortalController.prototype._resetOperations=function(t,e){
t.enable(this._getToolBarOps(),true)
}
}
if(AjxPackage.define("zimbraMail.portal.model.ZmPortlet")){
ZmPortlet=function(h,t,a){
ZmItem.call(this,ZmItem.PORTLET,t,h);
var o=appCtxt.getZimletMgr();
this.zimletName=a.zimlet;
this.zimletCtxt=o.getZimletsHash()[this.zimletName];
this.zimlet=this.zimletCtxt&&this.zimletCtxt.handlerObject;
this.global=/^true|on|yes$/i.test(a.global);
this.icon=a.icon;
this.title=a.title;
if(this.title){
this.title=this.zimletCtxt?this.zimletCtxt.processMessage(a.title):a.zimlet
}
var l=this.zimletCtxt&&this.zimletCtxt.portlet;
this.actionUrl=l&&l.actionUrl;
this.properties={};
var r=l&&l.portletProperties;
for(var s in r){
var e=r[s];
this.properties[e.name]=e.value
}
if(a.properties){
for(var s=0;
s<a.properties.length;
s++){
var e=a.properties[s];
this.properties[e.name]=e._content
}}
if(this.zimletCtxt){
for(var n in this.properties){
this.properties[n]=this.zimletCtxt.replaceObj(ZmZimletContext.RE_SCAN_APP,this.properties[n],ZmZimletContext.APP)
}}
if(this.actionUrl){
this.setRefreshInterval(this.actionUrl.refresh)
}};
ZmPortlet.prototype=new ZmItem;
ZmPortlet.prototype.constructor=ZmPortlet;
ZmPortlet.prototype.toString=function(){
return"ZmPortlet"
};
ZmPortlet.prototype.view;
ZmPortlet.prototype._refreshActionId=-1;
ZmPortlet.prototype.refresh=function(){
if(this.view){
this._refreshTime=new Date().getTime();
if(this.actionUrl){
this.view.setContentUrl(this.actionUrl.target)
}else{
if(this.zimlet instanceof ZmZimletBase){
this.zimlet.portletRefreshed(this)
}else{
if(this.zimlet){
var e=AjxMessageFormat.format(ZmMsg.zimletNotLoaded,this.zimletName);
this.setContent(e)
}else{
var e=AjxMessageFormat.format(ZmMsg.zimletUnknown,this.zimletName);
this.setContent(e)
}}}}};
ZmPortlet.prototype.setRefreshInterval=function(e){
if(this._refreshActionId!=-1){
clearInterval(this._refreshActionId);
this._refreshActionId=-1
}
this._refreshInterval=e;
if(e){
if(!this._refreshAction){
this._refreshAction=AjxCallback.simpleClosure(this.refresh,this)
}
this._refreshActionId=setInterval(this._refreshAction,e)
}};
ZmPortlet.prototype.setContent=function(e){
if(this.view){
this.view.setContent(e)
}else{}};
ZmPortlet.prototype.setContentUrl=function(e){
if(this.view){
this.view.setContentUrl(e)
}else{}};
ZmPortlet.prototype.setPaused=function(a){
if(this._refreshActionId!=-1&&a){
this._pauseTime=new Date().getTime();
clearInterval(this._refreshActionId);
this._refreshActionId=-1
}else{
if(this._refreshInterval&&!a){
var i=this._refreshInterval-(this._pauseTime-this._refreshTime);
var t=i<this._refreshInterval?i:0;
var e=AjxCallback.simpleClosure(this._resumeRefresh,this);
setTimeout(e,t)
}}};
ZmPortlet.prototype._resumeRefresh=function(){
this.refresh();
this._refreshActionId=setInterval(this._refreshAction,this._refreshInterval)
}
}
if(AjxPackage.define("zimbraMail.portal.model.ZmPortletMgr")){
ZmPortletMgr=function(){
this._portlets={};
this._loadedZimlets={};
this._delayedPortlets={}
};
ZmPortletMgr.prototype.createPortlets=function(o,t){
o=o!=null?o:false;
var l=[];
t=t||appCtxt.getApp(ZmApp.PORTAL).getManifest();
if(t){
var r=t.portal;
var e=r&&r.portlets;
if(e){
for(var n=0;
n<e.length;
n++){
var h=e[n];
var s=h.global=="true";
if(s!=o){
continue
}
var a=h.panel&&h.panel.id;
if(a&&!this._portlets[a]&&document.getElementById(a)){
this.createPortlet(a,h);
l.push(a)
}}}}
return l
};
ZmPortletMgr.prototype.createPortlet=function(i,t){
var a=new ZmPortlet(null,i,t);
this._portlets[i]=a;
var e=a.zimletName;
if(this._loadedZimlets[e]){
this._portletCreated(a)
}else{
if(e){
if(!this._delayedPortlets[e]){
this._delayedPortlets[e]=[]
}
this._delayedPortlets[e].push(a)
}}
return a
};
ZmPortletMgr.prototype.getPortlets=function(){
return this._portlets
};
ZmPortletMgr.prototype.getPortletById=function(e){
return this._portlets[e]
};
ZmPortletMgr.prototype.zimletLoaded=function(t){
this._loadedZimlets[t.name]=true;
var a=this._delayedPortlets[t.name];
if(a){
for(var e=0;
e<a.length;
e++){
var o=a[e];
this._portletCreated(o,t)
}}
delete this._delayedPortlets[t.name]
};
ZmPortletMgr.prototype.allZimletsLoaded=function(){
for(var e in this._portlets){
var a=this._portlets[e];
if(!this._loadedZimlets[a.zimletName]){
var t=document.getElementById(a.id);
if(t){
t.innerHTML=""
}}}};
ZmPortletMgr.prototype._portletCreated=function(o,i){
if(!i){
i=appCtxt.getZimletMgr().getZimletsHash()[o.zimletName]
}
var a=document.getElementById(o.id);
var e=new ZmPortletView(a,o);
var t=i.handlerObject;
o.zimlet=t;
if(t){
t.portletCreated(o)
}}
}
if(AjxPackage.define("zimbraMail.portal.view.ZmPortalView")){
ZmPortalView=function(i,t,e){
var a=this._getHeaderList();
ZmListView.call(this,{
parent:i,className:"ZmPortalView",posStyle:Dwt.ABSOLUTE_STYLE,view:ZmId.VIEW_PORTAL,controller:t,headerList:a,dropTgt:e}
);
this.setLocation(Dwt.LOC_NOWHERE,Dwt.LOC_NOWHERE);
this.setScrollStyle(Dwt.SCROLL)
};
ZmPortalView.prototype=new ZmListView;
ZmPortalView.prototype.constructor=ZmPortalView;
ZmPortalView.prototype.toString=function(){
return"ZmPortalView"
};
ZmPortalView.prototype.getPortletIds=function(){
return this._portletIds||[]
};
ZmPortalView.prototype._getHeaderList=function(){
return[]
};
ZmPortalView.prototype.set=function(){
if(this._rendered){
Dwt.setTitle(this.getTitle());
return
}
var e=new AjxCallback(this,this._initializeView2);
appCtxt.getApp(ZmApp.PORTAL).getManifest(e)
};
ZmPortalView.prototype._initializeView2=function(t){
var a=t&&t.portal;
if(a){
this.getHtmlElement().innerHTML=a.html||""
}
var e=appCtxt.getApp(ZmApp.PORTAL).getPortletMgr();
this._portletIds=e.createPortlets();
this._rendered=true
};
ZmPortalView.prototype.getTitle=function(){
return[ZmMsg.zimbraTitle,this._controller.getApp().getDisplayName()].join(": ")
}
}
if(AjxPackage.define("zimbraMail.portal.view.ZmPortletView")){
ZmPortletView=function(t,a,e){
e=e||"ZmPortlet";
DwtComposite.call(this,{
parent:DwtShell.getShell(window),className:e,posStyle:DwtControl.STATIC_STYLE}
);
this._portlet=a;
this._portlet.view=this;
this._contentsEl=this.getHtmlElement();
if(t){
t.portlet="loaded";
t.innerHTML="";
t.appendChild(this._contentsEl)
}
this.setIcon(a.icon);
this.setTitle(a.title);
this.setContentUrl(a.actionUrl&&a.actionUrl.target)
};
ZmPortletView.prototype=new DwtComposite;
ZmPortletView.prototype.constructor=ZmPortletView;
ZmPortletView.prototype.toString=function(){
return"ZmPortletView"
};
ZmPortletView.prototype.setIcon=function(e){
if(e==null||!this._iconEl){
return
}
AjxImg.setImage(this._iconEl,e)
};
ZmPortletView.prototype.setTitle=function(e){
if(e==null||!this._titleEl){
return
}
this._titleEl.innerHTML=e
};
ZmPortletView.prototype.setContent=function(e){
if(AjxUtil.isString(e)){
this._contentsEl.innerHTML=e
}else{
if(AjxUtil.ELEMENT_NODE){
this._contentsEl.innerHTML="";
this._contentsEl.appendChild(e)
}else{
this._contentsEl.innerHTML=AjxStringUtil.htmlEncode(String(e))
}}};
ZmPortletView.prototype.setContentUrl=function(e){
if(!e){
return
}
var a=this._portlet.properties;
var i=AjxCallback.simpleClosure(ZmPortletView.__replaceProp,null,a);
e=e.replace(ZmZimletContext.RE_SCAN_PROP,i);
e=this._portlet.zimletCtxt?this._portlet.zimletCtxt.makeURL({
target:e}
,null,a):e;
var t=["<iframe style='border:none;width:100%;height:100%' ","src='",e,"'>","</iframe>"].join("");
this.setContent(t)
};
ZmPortletView.__replaceProp=function(a,t,e,i){
return a[i]
}
}};
