
/* Copyright (C) 2005-2009 Zimbra Inc. http://www.zimbra.com/ */
if(AjxPackage.define("Slides")){
if(AjxPackage.define("zimbraMail.slides.view.ZmSlideThemeManager")){
ZmSlideThemeManager=function(){};
ZmSlideThemeManager.prototype.getMasterSlideContent=function(e){
if(e&&this._currentTitleSlideContent!=null){
return this._currentTitleSlideContent
}
if(this._currentNotesSlideContent!=null){
return this._currentNotesSlideContent
}
return'<div style="background-color:purple; position:absolute; left: 0%; top:15%; width:100%; height:1%;"></div>'
};
ZmSlideThemeManager.prototype.setNotesSlideContent=function(e){
this._currentNotesSlideContent=e
};
ZmSlideThemeManager.prototype.setTitleSlideContent=function(e){
this._currentTitleSlideContent=e
};
ZmSlideThemeManager.prototype.parseSlideTheme=function(o){
this._currentNotesSlideContent="";
this._currentTitleSlideContent="";
var a=o.firstChild;
while(a){
var t=(a.className=="titlemaster");
if(t){
this._currentTitleSlideContent=a.innerHTML
}
var e=(a.className=="slidemaster");
if(e){
this._currentNotesSlideContent=a.innerHTML
}
a=a.nextSibling
}
if(!this._currentTitleSlideContent){
this._currentTitleSlideContent=this._currentNotesSlideContent
}};
ZmSlideThemeManager.prototype.getThemeCSSPath=function(e){
return"/public/slides/themes/"+e+"/css/slide.css"
};
ZmSlideThemeManager.prototype.getThemeSlidePath=function(e){
return"/public/slides/themes/"+e+"/slide.html"
};
ZmSlideThemeManager.prototype.loadThemeCSS=function(t){
var e=this.getThemeCSSPath(t);
this.loadCSS(e)
};
ZmSlideThemeManager.prototype.loadCSS=function(e){
var t=document.createElement("link");
t.type="text/css";
t.rel="stylesheet";
t.href=e;
t.media="screen";
t.title="dynamicLoadedSheet";
document.getElementsByTagName("head")[0].appendChild(t)
};
ZmSlideLayoutManager=function(){};
ZmSlideLayoutManager.prototype.getSlideLayout=function(o,a,s){
var t=[];
var e=0;
var n=s||"Click here to edit title";
t[e++]='<div class="slide_object_title" style="position: absolute; left: 4%; top: 3%; width: 92%; height: 9%;">'+n+"</div>";
if(!a){
t[e++]='<div class="slide_object_notes" style="position: absolute; left: 4%; top: 23%; width: 92%; height: 72%;">Click here to edit slide contents <br> </div>'
}
return t.join("")
}
}
if(AjxPackage.define("zimbraMail.slides.view.ZmSlideComponentEditor")){
ZmSlideComponentEditor=function(e){
if(arguments.length==0){
return
}
e=Dwt.getParams(arguments,DwtHtmlEditor.PARAMS);
e.className=e.className||"DwtHtmlEditor";
DwtComposite.call(this,e);
this.__eventClosure=AjxCallback.simpleClosure(this.__eventClosure,this);
this._pendingContent=e.content||"";
this._htmlModeInited=false;
this._controller=e.controller;
this._iframe=e.iframe;
this._iFrameId=this._iframe.id;
this._mode=DwtHtmlEditor.HTML;
this._initialize()
};
ZmSlideComponentEditor.prototype=new DwtHtmlEditor();
ZmSlideComponentEditor.prototype.constructor=ZmSlideComponentEditor;
ZmSlideComponentEditor._VALUE="value";
ZmSlideComponentEditor.FONT_SIZE_VALUES=["8pt","10pt","12pt","14pt","18pt","24pt","36pt"];
ZmSlideComponentEditor.FONT_FAMILY=[{
name:"Times New Roman",value:"Times New Roman, Times, serif"}
,{
name:"Arial",value:"Arial, Helvetica, sans-serif"}
,{
name:"Courier",value:"Courier, Courier New, mono"}
,{
name:"Verdana",value:"Verdana, Arial, Helvetica, sans-serif"}
];
ZmSlideComponentEditor.prototype.enable=function(e){};
ZmSlideComponentEditor.prototype.setMode=function(t,e){
return
};
ZmSlideComponentEditor.prototype.getMode=function(){
return ZmSlideComponentEditor.HTML
};
ZmSlideComponentEditor.prototype.getIframe=function(){
return this._iframe
};
ZmSlideComponentEditor.prototype.getInputElement=function(){
return this._iframe
};
ZmSlideComponentEditor.prototype._initialize=function(){
this._initHtmlMode(this._pendingContent)
};
ZmSlideComponentEditor.prototype._initHtmlMode=function(e){
this._pendingContent=e||"";
this._keyEvent=new DwtKeyEvent();
this._stateEvent=new DwtHtmlEditorStateEvent();
this._stateEvent.dwtObj=this;
this._updateStateAction=new AjxTimedAction(this,this._updateState);
this._finishHtmlModeInit();
return this._iframe
};
ZmSlideComponentEditor.prototype._finishHtmlModeInit=function(){
this._updateState();
this._htmlModeInited=true;
this._registerEditorEventHandlers(this._iframe,this._getIframeDoc())
};
ZmSlideComponentEditor.prototype._getIframeDoc=function(){
return this._iframe?Dwt.getIframeDoc(this._iframe):null
};
ZmSlideComponentEditor.prototype._getIframeWin=function(){
return Dwt.getIframeWindow(this._iframe)
};
ZmSlideComponentEditor.prototype.setToolbar=function(e){
this._toolbar=e
};
ZmSlideComponentEditor.prototype._initToolBar=function(){
var e=this._toolbar;
this._createFontFamilyMenu(e);
this._createFontSizeMenu(e);
this._createStyleMenu(e);
this._createJustifyMenu(e);
e.setVisible(true);
new DwtControl({
parent:e,className:"vertSep"}
);
var t=new AjxListener(this,this._insElementListener);
var o={
parent:e,style:DwtButton.TOGGLE_STYLE};
this._listButton=new DwtToolBarButton(o);
this._listButton.setToolTipContent(ZmMsg.bulletedList);
this._listButton.setImage("BulletedList");
this._listButton.setData(ZmSlideComponentEditor._VALUE,DwtHtmlEditor.UNORDERED_LIST);
this._listButton.addSelectionListener(t);
this._numberedListButton=new DwtToolBarButton(o);
this._numberedListButton.setToolTipContent(ZmMsg.numberedList);
this._numberedListButton.setImage("NumberedList");
this._numberedListButton.setData(ZmSlideComponentEditor._VALUE,DwtHtmlEditor.ORDERED_LIST);
this._numberedListButton.addSelectionListener(t);
var a=new AjxListener(this,this._indentListener);
this._outdentButton=new DwtToolBarButton({
parent:e}
);
this._outdentButton.setToolTipContent(ZmMsg.outdent);
this._outdentButton.setImage("Outdent");
this._outdentButton.setData(ZmSlideComponentEditor._VALUE,DwtHtmlEditor.OUTDENT);
this._outdentButton.addSelectionListener(a);
this._indentButton=new DwtToolBarButton({
parent:e}
);
this._indentButton.setToolTipContent(ZmMsg.indent);
this._indentButton.setImage("Indent");
this._indentButton.setData(ZmSlideComponentEditor._VALUE,DwtHtmlEditor.INDENT);
this._indentButton.addSelectionListener(a);
new DwtControl({
parent:e,className:"vertSep"}
);
var a=new AjxListener(this,this._fontStyleListener);
this._boldButton=new DwtToolBarButton(o);
this._boldButton.setImage("Bold");
this._boldButton.setToolTipContent(AjxKeys["editor.Bold.summary"]);
this._boldButton.setData(ZmSlideComponentEditor._VALUE,DwtHtmlEditor.BOLD_STYLE);
this._boldButton.addSelectionListener(a);
this._italicButton=new DwtToolBarButton(o);
this._italicButton.setImage("Italics");
this._italicButton.setToolTipContent(AjxKeys["editor.Italic.summary"]);
this._italicButton.setData(ZmSlideComponentEditor._VALUE,DwtHtmlEditor.ITALIC_STYLE);
this._italicButton.addSelectionListener(a);
this._underlineButton=new DwtToolBarButton(o);
this._underlineButton.setImage("Underline");
this._underlineButton.setToolTipContent(AjxKeys["editor.Underline.summary"]);
this._underlineButton.setData(ZmSlideComponentEditor._VALUE,DwtHtmlEditor.UNDERLINE_STYLE);
this._underlineButton.addSelectionListener(a);
e.setVisible(true);
this._styleMenu.checkItem(ZmSlideComponentEditor._VALUE,DwtHtmlEditor.PARAGRAPH,true);
this._justifyMenu.checkItem(ZmSlideComponentEditor._VALUE,DwtHtmlEditor.JUSTIFY_LEFT,true)
};
ZmSlideComponentEditor.prototype._createFontFamilyMenu=function(e){
this._fontFamilyButton=new DwtToolBarButton({
parent:e}
);
this._fontFamilyButton.dontStealFocus();
this._fontFamilyButton.setSize(Dwt.DEFAULT);
this._fontFamilyButton.setAlign(DwtLabel.ALIGN_LEFT);
var r=new ZmPopupMenu(this._fontFamilyButton,"ActionMenu",null,this._controller);
var s=new AjxListener(this,this._fontFamilyListener);
var a="";
for(var o=0;
o<ZmSlideComponentEditor.FONT_FAMILY.length;
o++){
var n=ZmSlideComponentEditor.FONT_FAMILY[o];
var t=r.createMenuItem(n.name,{
text:n.name}
);
t.addSelectionListener(s);
t.setData(ZmSlideComponentEditor._VALUE,o);
if(o==0){
a=n.name
}}
this._fontFamilyButton.setMenu(r);
this._fontFamilyButton.setText(a)
};
ZmSlideComponentEditor.prototype._createFontSizeMenu=function(a){
this._fontSizeButton=new DwtToolBarButton({
parent:a}
);
this._fontSizeButton.dontStealFocus();
var e=new ZmPopupMenu(this._fontSizeButton,null,null,this._controller);
var t=new AjxListener(this,this._fontSizeListener);
var r="";
for(var o=0;
o<ZmSlideComponentEditor.FONT_SIZE_VALUES.length;
o++){
var l=ZmSlideComponentEditor.FONT_SIZE_VALUES[o];
var n=o+1;
var h=n+" ("+l+")";
var s=e.createMenuItem(o,{
text:h}
);
s.addSelectionListener(t);
s.setData(ZmSlideComponentEditor._VALUE,n);
if(o==2){
r=h
}}
this._fontSizeButton.setMenu(e);
this._fontSizeButton.setText(r)
};
ZmSlideComponentEditor.prototype._getFontSizeLabel=function(a){
for(var e=0;
e<ZmSlideComponentEditor.FONT_SIZE_VALUES.length;
e++){
var t=ZmSlideComponentEditor.FONT_SIZE_VALUES[e];
if(a==t){
return((e+1)+" ("+t+")")
}}
return"3 (12pt)"
};
ZmSlideComponentEditor.prototype._createStyleMenu=function(e){
var n=new DwtToolBarButton({
parent:e}
);
n.setText("x");
n._textEl.innerHTML="<span style='font-size:13px'>&sect;</span>";
n.setToolTipContent(ZmMsg.sections);
n.dontStealFocus();
var l=this._styleMenu=new ZmPopupMenu(n,null,null,this._controller);
var h=new AjxListener(this,this._styleListener);
var o=[{
label:ZmMsg.normal,id:DwtHtmlEditor.PARAGRAPH}
,{
label:ZmMsg.heading1,id:DwtHtmlEditor.H1}
,{
label:ZmMsg.heading2,id:DwtHtmlEditor.H2}
,{
label:ZmMsg.heading3,id:DwtHtmlEditor.H3}
,{
label:ZmMsg.heading4,id:DwtHtmlEditor.H4}
,{
label:ZmMsg.heading5,id:DwtHtmlEditor.H5}
,{
label:ZmMsg.heading6,id:DwtHtmlEditor.H6}
,{
label:ZmMsg.address,id:DwtHtmlEditor.ADDRESS}
,{
label:ZmMsg.preformatted,id:DwtHtmlEditor.PREFORMATTED}
];
for(var a=0;
a<o.length;
a++){
var r=o[a];
var t=l.createMenuItem(r.id,{
text:r.label,style:DwtMenuItem.RADIO_STYLE}
);
t.addSelectionListener(h);
t.setData(ZmSlideComponentEditor._VALUE,r.id);
if(a==0){
t.setChecked(true,true)
}}
n.setMenu(l)
};
ZmSlideComponentEditor.prototype._createJustifyMenu=function(t){
var e=new DwtToolBarButton({
parent:t}
);
e.dontStealFocus();
e.setImage("LeftJustify");
e.setToolTipContent(ZmMsg.alignment);
var h=this._justifyMenu=new ZmPopupMenu(e,null,null,this._controller);
var r=new AjxListener(this,this._justificationListener);
var n=[{
image:"LeftJustify",id:DwtHtmlEditor.JUSTIFY_LEFT}
,{
image:"CenterJustify",id:DwtHtmlEditor.JUSTIFY_CENTER}
,{
image:"RightJustify",id:DwtHtmlEditor.JUSTIFY_RIGHT}
,{
image:"FullJustify",id:DwtHtmlEditor.JUSTIFY_FULL}
];
for(var o=0;
o<n.length;
o++){
var s=n[o];
var a=h.createMenuItem(s.id,{
image:s.image,style:DwtMenuItem.RADIO_STYLE}
);
a.addSelectionListener(r);
a.setData(ZmSlideComponentEditor._VALUE,s.id);
if(o==0){
a.setChecked(true,true)
}}
e.setMenu(h,false,DwtMenuItem.RADIO_STYLE)
};
ZmSlideComponentEditor.prototype._fontStyleListener=function(e){
this.setFont(null,e.item.getData(ZmSlideComponentEditor._VALUE))
};
ZmSlideComponentEditor.prototype._fontColorListener=function(e){
this.setFont(null,null,null,e.detail||"#000000")
};
ZmSlideComponentEditor.prototype._fontHiliteListener=function(e){
this.setFont(null,null,null,null,e.detail||"#ffffff")
};
ZmSlideComponentEditor.prototype._styleListener=function(e){
this.setStyle(e.item.getData(ZmSlideComponentEditor._VALUE))
};
ZmSlideComponentEditor.prototype._fontFamilyListener=function(e){
var t=e.item.getData(ZmSlideComponentEditor._VALUE);
this.setFont(ZmSlideComponentEditor.FONT_FAMILY[t].value);
this._fontFamilyButton.setText(ZmSlideComponentEditor.FONT_FAMILY[t].name)
};
ZmSlideComponentEditor.prototype._fontSizeListener=function(e){
this.setFont(null,null,e.item.getData(ZmSlideComponentEditor._VALUE))
};
ZmSlideComponentEditor.prototype._indentListener=function(e){
this.setIndent(e.item.getData(ZmSlideComponentEditor._VALUE))
};
ZmSlideComponentEditor.prototype._insElementListener=function(t){
var e=t.item.getData(ZmSlideComponentEditor._VALUE);
switch(e){
default:this.insertElement(e)
}};
ZmSlideComponentEditor.prototype._createToolBar=function(e,a){
var t=this._toolbar=new DwtToolBar({
parent:e,className:"ZToolbar SlideEditorToolbar",posStyle:DwtControl.ABSOLUTE_STYLE,cellSpacing:2,index:0}
);
this._initToolBar();
this._toolbar.setVisible(false);
return t
}
}
if(AjxPackage.define("zimbraMail.slides.view.DwtAnimate")){
DwtAnimate=function(){
this._framesPerSecond=22;
this._duration=1000;
this._interval=this._duration/this._framesPerSecond
};
DwtAnimate.prototype.setFramesPerSecond=function(e){
this._framesPerSecond=e
};
DwtAnimate.prototype.setDuration=function(e){
this._duration=e
};
DwtAnimate.prototype.calculateInterval=function(){
this._interval=Math.ceil(1000/this._framesPerSecond);
this._noOfFrames=Math.ceil(this._duration/this._interval)
};
DwtAnimate.prototype.animate=function(n,s,t,e){
t=parseFloat(t);
e=parseFloat(e);
var o=e-t;
this.calculateInterval();
var a=this;
for(i=1;
i<=this._noOfFrames;
i++){
(function(){
var h=i;
function r(){
var c=(o*h/a._noOfFrames)*(h/a._noOfFrames)+t;
var l=(s=="opacity")?"":"px";
if(window.attachEvent&&!l){
c*=100;
n.style.zoom=1;
n.style.filter="alpha(opacity="+c+")"
}else{
n.style[s]=c+l
}}
timer=setTimeout(r,a._interval*h)
}
)()
}};
DwtAnimate.prototype.animateExpansion=function(s,d,c,g){
this._callback=g;
var a=parseFloat(d.x);
var m=parseFloat(d.y);
var o=parseFloat(d.width);
var h=parseFloat(d.height);
var e=parseFloat(c.x);
var u=parseFloat(c.y);
var t=parseFloat(c.width);
var r=parseFloat(c.height);
this.calculateInterval();
var l=this;
var f={
left:(e-a),top:(u-m),width:(t-o),height:(r-h)};
var n={
left:a,top:m,width:o,height:h};
var p=["left","top","width","height"];
AjxTimedAction.scheduleAction(new AjxTimedAction(this,this._animateExpansion,[s,f,n,p,1]),this._interval)
};
DwtAnimate.prototype._animateExpansion=function(n,h,a,c,t){
if(t>this._noOfFrames){
if(this._callback){
this._callback.run()
}
n.parentNode.removeChild(n);
return
}
var l="px";
var e=this._noOfFrames;
for(var o in c){
var s=c[o];
var r=(h[s]*t/e)*(t/e)+a[s];
n.style[s]=r+l
}
AjxTimedAction.scheduleAction(new AjxTimedAction(this,this._animateExpansion,[n,h,a,c,t+1]),this._interval)
}
}
if(AjxPackage.define("zimbraMail.slides.view.ZmSlideEditView")){
ZmSlideEditView=function(s,n,o,t,e){
if(arguments.length==0){
return
}
n=n||"ZmSlideEditView";
o=o||Dwt.ABSOLUTE_STYLE;
DwtComposite.call(this,{
parent:s,className:n,posStyle:o}
);
this._controller=t;
var a=this.getHtmlElement();
a.style.overflow="";
this._themeManager=new ZmSlideThemeManager();
this._layoutManager=new ZmSlideLayoutManager();
this._docMgr=new ZmDocletMgr();
this._state=ZmSlideEditView.NEW
};
ZmSlideEditView.prototype=new DwtComposite;
ZmSlideEditView.prototype.constructor=ZmSlideEditView;
ZmSlideEditView.prototype.toString=function(){
return"ZmSlideEditView"
};
ZmSlideEditView.TYPE_DIV=1;
ZmSlideEditView.TYPE_LEFT_TOP_BOX=2;
ZmSlideEditView.TYPE_RIGHT_TOP_BOX=3;
ZmSlideEditView.TYPE_LEFT_BOTTOM_BOX=4;
ZmSlideEditView.TYPE_RIGHT_BOTTOM_BOX=5;
ZmSlideEditView.TYPE_TOP_SASH=6;
ZmSlideEditView.TYPE_BOTTOM_SASH=7;
ZmSlideEditView.TYPE_LEFT_SASH=8;
ZmSlideEditView.TYPE_RIGHT_SASH=9;
ZmSlideEditView.TYPE_DRAG_PROXY_DIV=10;
ZmSlideEditView.TYPE_PREVIEW=11;
ZmSlideEditView.DRAG_THRESHOLD=4;
ZmSlideEditView.APP_ZIMBRA_PPT="application/x-zimbra-slides";
ZmSlideEditView.SLIDE_OBJECTS=["slide_object_notes","slide_object_title","slide_object_img","slide_object_graph"];
ZmSlideEditView.EDITABLE_OBJECTS={
slide_object_notes:true,slide_object_title:true};
ZmSlideEditView.LIMIT_HEIGHT_PERCENTAGE=90;
ZmSlideEditView.NEW="new";
ZmSlideEditView.EDIT="edit";
ZmSlideEditView.prototype.isEditable=function(e){
if(!e){
return false
}
return ZmSlideEditView.EDITABLE_OBJECTS[e.className]
};
ZmSlideEditView.prototype.getCurrentSlideElement=function(){
return this._currentSlideDiv
};
ZmSlideEditView.prototype.getCurrentPreviewSlideElement=function(){
return this._currentPreviewSlideDiv
};
ZmSlideEditView.prototype._createHTML=function(){
var t=this.getHtmlElement();
this._initIframe();
var e=this._editor=new ZmSlideComponentEditor({
parent:appCtxt.getShell(),iframe:this._iframe,controller:this._controller}
);
e._enableDesignMode(e._getIframeDoc());
this._toolbar=e._createToolBar(this);
this.initSlideContainer();
this._createSelectionBoxes()
};
ZmSlideEditView.prototype.initSlideContainer=function(){
var t=this.getSize();
var o=this._toolbar.getSize();
var e=this._slideContainer;
if(!e){
e=this._slideContainer=document.createElement("div");
e.className="slidecontainer";
this.getHtmlElement().appendChild(e)
}
var n=0.19*t.x;
e.style.height=(t.y)+"px";
e.style.width=(0.81*t.x)+"px";
var a=this._previewContainer;
if(!a){
a=this._previewContainer=document.createElement("div");
a.className="previewcontainer";
this.getHtmlElement().appendChild(a)
}
a.style.height=(t.y)+"px";
a.style.width=(0.2*t.x)+"px";
if(this._slideParent){
this.resizeSlide(this._slideParent)
}};
ZmSlideEditView.prototype.createNewSlide=function(){
this._controller.setFileName(window.fileInfo?window.fileInfo.name:"Untitled");
this.createSlide()
};
ZmSlideEditView.prototype.resizeSlide=function(t){
var n=Dwt.getBounds(this._slideContainer);
Dwt.setPosition(t,Dwt.ABSOLUTE_STYLE);
var o=80;
var e=(100/n.height)*((3/4)*0.8*n.width);
if(e>ZmSlideEditView.LIMIT_HEIGHT_PERCENTAGE){
o=(o*ZmSlideEditView.LIMIT_HEIGHT_PERCENTAGE)/e;
e=ZmSlideEditView.LIMIT_HEIGHT_PERCENTAGE
}
var a=(100-e)/2;
Dwt.setBounds(t,"10%",a+"%",o+"%",e+"%")
};
ZmSlideEditView.prototype.createSlide=function(t,n,h,c){
var s=this._currentSlideDiv;
if(s){
this.convertToPercentage(s);
this._syncPreview();
Dwt.setVisible(s,false);
if(this._slideParent){
this._slideParent.parentNode.removeChild(this._slideParent)
}}
var a=document.createElement("div");
a.className="slide";
Dwt.setPosition(a,Dwt.ABSOLUTE_STYLE);
var e=Dwt.getBounds(this._slideContainer);
var r=this._slideParent=document.createElement("div");
r.className=(c?"photoalbum":"slideparent");
this.resizeSlide(r);
this._slideContainer.appendChild(r);
r.style.opacity=0;
r.appendChild(a);
var l=this._currentSlideThemeDiv=document.createElement("div");
l.className="slidemaster";
l.innerHTML=c?"":this._themeManager.getMasterSlideContent();
Dwt.setPosition(l,Dwt.ABSOLUTE_STYLE);
r.appendChild(l);
a.style.zIndex=Dwt.Z_VIEW;
l.style.zIndex=Dwt.Z_VIEW-10;
Dwt.setBounds(a,0,0,"100%","100%");
Dwt.setBounds(l,0,0,"100%","100%");
this._currentSlideDiv=a;
a.innerHTML=c?"":this._layoutManager.getSlideLayout(null,n,h);
if(!t){
this.createPreviewSlide()
}
var o=this._animationMgr;
if(!this._animationMgr){
o=this._animationMgr=new DwtAnimate()
}
o.setFramesPerSecond(16);
o.setDuration(700);
o.animate(r,"opacity",0,1)
};
ZmSlideEditView.prototype.getNextPreviewSlideParent=function(e){
var t=e.nextSibling;
while(t&&(t.className!="previewslideparent")){
t=t.nextSibling
}
return t
};
ZmSlideEditView.prototype.getPreviousPreviewSlideParent=function(t){
var e=t.previousSibling;
while(e&&(e.className!="previewslideparent")){
e=e.previousSibling
}
return e
};
ZmSlideEditView.prototype.deleteSlide=function(){
this._promptDeleteSlide()
};
ZmSlideEditView.prototype._promptDeleteSlide=function(){
var e=new AjxCallback(this,this._continueDeleteSlide);
var t=this._deleteConfirmDlg=new DwtConfirmDialog(appCtxt.getShell());
t.popup(ZmMsg.slides_confirmDeleteSlide,e)
};
ZmSlideEditView.prototype._continueDeleteSlide=function(){
this._deleteConfirmDlg.popdown();
this._syncPreview();
var t=this.getNextPreviewSlideParent(this._previewSlideParent);
if(!t){
t=this.getPreviousPreviewSlideParent(this._previewSlideParent)
}
if(this._previewSlideParent&&this._previewSlideParent.parentNode){
this._previewSlideParent.parentNode.removeChild(this._previewSlideParent)
}
if(t){
var e=t.firstChild;
this.clearCurrentSelection();
this._currentSlideDiv.innerHTML=e.innerHTML;
this._currentPreviewSlideDiv=e;
this._previewSlideParent=t
}
if(!t){
this.createSlide()
}};
ZmSlideEditView.prototype.resizePreviewSlide=function(t){
var o=Dwt.getBounds(this._previewContainer);
var a=90;
var e=(100/o.height)*((3/4)*0.9*o.width);
Dwt.setSize(t,a+"%",e+"%")
};
ZmSlideEditView.prototype.resizeAllPreviewSlides=function(){
var e=this._previewContainer.firstChild;
while(e){
if(e.className=="previewslideparent"){
this.resizePreviewSlide(e)
}
e=this.getNextPreviewSlideParent(e)
}};
ZmSlideEditView.prototype.createPreviewSlide=function(){
var o=this._currentPreviewSlideDiv=document.createElement("div");
o.className="preview";
var t=this._previewSlideParent=document.createElement("div");
t.className="previewslideparent";
this.resizePreviewSlide(t);
this._previewContainer.appendChild(t);
this.associateItemWithElement(null,o,ZmSlideEditView.TYPE_PREVIEW);
t.appendChild(o);
var a=this._currentPreviewSlideThemeDiv=document.createElement("div");
a.className="slidemaster";
Dwt.setPosition(a,Dwt.ABSOLUTE_STYLE);
Dwt.setLocation(a,0,0);
t.appendChild(a);
Dwt.setSize(o,"100%","100%");
Dwt.setSize(a,"100%","100%");
o.innerHTML=this._currentSlideDiv.innerHTML;
o.style.zIndex=Dwt.Z_VIEW;
a.style.zIndex=Dwt.Z_VIEW-10;
var e=o.offsetWidth*32/1600;
if(e<3){
e=3
}
o.style.fontSize=e+"px";
a.innerHTML=this._currentSlideThemeDiv.innerHTML
};
ZmSlideEditView.prototype._initializeSlideEditView=function(){
this._createHTML();
var e=this.getCurrentSlideElement();
this._setMouseEventHdlrs();
this._listenerMouseOver=new AjxListener(this,ZmSlideEditView.prototype._mouseOverListener);
this._listenerMouseOut=new AjxListener(this,ZmSlideEditView.prototype._mouseOutListener);
this._listenerMouseDown=new AjxListener(this,ZmSlideEditView.prototype._mouseDownListener);
this._listenerMouseUp=new AjxListener(this,ZmSlideEditView.prototype._mouseUpListener);
this._listenerMouseMove=new AjxListener(this,ZmSlideEditView.prototype._mouseMoveListener);
this._listenerDoubleClick=new AjxListener(this,ZmSlideEditView.prototype._doubleClickListener);
this.addListener(DwtEvent.ONMOUSEOVER,this._listenerMouseOver);
this.addListener(DwtEvent.ONMOUSEOUT,this._listenerMouseOut);
this.addListener(DwtEvent.ONMOUSEDOWN,this._listenerMouseDown);
this.addListener(DwtEvent.ONMOUSEUP,this._listenerMouseUp);
this.addListener(DwtEvent.ONMOUSEMOVE,this._listenerMouseMove);
this.addListener(DwtEvent.ONDBLCLICK,this._listenerDoubleClick)
};
ZmSlideEditView.prototype.getTargetItemDiv=function(e){
return this.findItemDiv(DwtUiEvent.getTarget(e))
};
ZmSlideEditView.prototype.findItemDiv=function(e){
if(!e){
return
}
while(e&&(e.id!=this._htmlElId)){
if(e.id&&this._data[e.id]){
return e
}
e=e.parentNode
}
return null
};
ZmSlideEditView.prototype.getTitle=function(){
return"Zimbra Presentation : Edit Slide"
};
ZmSlideEditView.prototype.getController=function(){
return this._controller
};
ZmSlideEditView.prototype.set=function(e){};
ZmSlideEditView.prototype.setBounds=function(t,o,a,e){
DwtComposite.prototype.setBounds.call(this,t,o,a,e);
this.initSlideContainer();
this.resizeAllPreviewSlides()
};
ZmSlideEditView.prototype._getItemData=function(e,a,o){
o=o||(e?e.id:null);
var t=this._data[o];
return t?t[a]:null
};
ZmSlideEditView.prototype.associateItemWithElement=function(o,t,a,s,n){
s=s||this._getItemId(o);
if(t){
t.id=s
}
this._data[s]={
item:o,id:s,type:a};
if(n){
for(var e in n){
this._data[s][e]=n[e]
}}
return s
};
ZmSlideEditView.prototype.getItemFromElement=function(e){
return this._getItemData(e,"item")
};
ZmSlideEditView.prototype._getItemId=function(e){
return DwtId.getListViewItemId(DwtId.WIDGET_ITEM,this.id,e?e.id:Dwt.getNextId())
};
ZmSlideEditView.prototype._createSelectionBoxes=function(){
var o=this.getHtmlElement();
var e=["_topSash","_bottomSash","_leftSash","_rightSash","_dragProxyDiv","_leftTopSelectionBox","_rightTopSelectionBox","_leftBottomSelectionBox","_rightBottomSelectionBox"];
var s=["SelectionSash_Top","SelectionSash_Bottom","SelectionSash_Left","SelectionSash_Right","DragProxy","SelectionCornerBox","ImgClose","SelectionCornerBox","SelectionCornerBox"];
var n=["move","move","move","move","move","nw-resize","pointer","sw-resize","se-resize"];
var a=[ZmSlideEditView.TYPE_TOP_SASH,ZmSlideEditView.TYPE_BOTTOM_SASH,ZmSlideEditView.TYPE_LEFT_SASH,ZmSlideEditView.TYPE_RIGHT_SASH,ZmSlideEditView.TYPE_DRAG_PROXY_DIV,ZmSlideEditView.TYPE_LEFT_TOP_BOX,ZmSlideEditView.TYPE_RIGHT_TOP_BOX,ZmSlideEditView.TYPE_LEFT_BOTTOM_BOX,ZmSlideEditView.TYPE_RIGHT_BOTTOM_BOX];
var h=null;
for(var t in e){
var r=e[t];
h=this[r]=document.createElement("div");
h.className=s[t];
Dwt.setPosition(h,Dwt.ABSOLUTE_STYLE);
Dwt.setCursor(h,n[t]);
o.appendChild(h);
this.associateItemWithElement(null,h,a[t]);
Dwt.setVisible(h,false);
h.style.zIndex=Dwt.Z_VIEW+100
}};
ZmSlideEditView.prototype._initIframe=function(){
var a=this.getHtmlElement();
var e=this._iframe=document.createElement("iframe");
e.id=Dwt.getNextId();
e.style.visibility="hidden";
e.setAttribute("border","0",false);
e.setAttribute("frameborder","0",false);
e.setAttribute("vspace","0",false);
e.setAttribute("autocomplete","off",false);
e.setAttribute("allowtransparency","true",false);
Dwt.setPosition(this._iframe,Dwt.ABSOLUTE_STYLE);
Dwt.setBounds(this._iframe,10,10,100,100);
a.appendChild(this._iframe);
var t=this._iframe.contentWindow;
this._doc=t?t.document:null;
this._pushIframeContent(this._iframe);
e.style.zIndex=Dwt.Z_VIEW+100
};
ZmSlideEditView.prototype._pushIframeContent=function(t){
if(!t){
return
}
var e=t.contentWindow;
var o=e?e.document:null;
if(o){
o.open();
var a=[];
a.push("<html>");
a.push('<link href="'+window.contextPath+"/css/skin,slides.css?locale="+AjxEnv.DEFAULT_LOCALE+'" rel="stylesheet" type="text/css" />');
if(this._currentTheme){
a.push('<link href="'+this.getThemeCSSPath(this._currentTheme)+'" rel="stylesheet" type="text/css" />')
}
a.push("<body></body>");
a.push("</html>");
o.write(a.join(""));
o.close();
e.focus()
}};
ZmSlideEditView.prototype._doubleClickListener=function(e){
return true
};
ZmSlideEditView.prototype._doubleClickAction=function(e,t){
return true
};
ZmSlideEditView.prototype._mouseDownListener=function(e){
var t=DwtUiEvent.getTarget(e);
return this._mouseDownAction(e,t)
};
ZmSlideEditView.prototype._mouseDownAction=function(a,n){
n=this._getActionDiv(n);
if(n.className=="slidemaster"&&n.parentNode){
n=this._getActionDiv(n.parentNode.firstChild)
}
if(!n){
return false
}
if(n.className=="preview"||(n.parentNode&&n.parentNode.className=="preview")){
if(n.parentNode&&n.parentNode.className=="preview"){
n=n.parentNode
}
this._animateCallback(n);
return true
}
if(this.isSlideObject(n)){
this._handleItemSelection(n);
this._recordTargetPosition(a,n);
return true
}
var e=this.getTargetItemDiv(a);
var o=false;
var t;
if(e){
t=this._getItemData(e,"type");
o=(t==ZmSlideEditView.TYPE_RIGHT_TOP_BOX);
this._recordTargetPosition(a,e)
}
if(!o){
this.clearCurrentSelection()
}
return false
};
ZmSlideEditView.prototype.animateExpansion=function(s,o){
if(this._currentPreviewSlideDiv==s){
this._animateCallback(s);
return
}
var n=s.parentNode;
var t=Dwt.toWindow(n,0,0,this.getHtmlElement(),true);
var d=Dwt.getSize(n);
t.y=t.y-this._previewContainer.scrollTop;
var e=Dwt.toWindow(o.parentNode,0,0,this.getHtmlElement(),true);
var c=Dwt.getSize(o.parentNode);
var l=this.createSlideProxy(s.parentNode,t,d);
this.getHtmlElement().appendChild(l);
var h={
x:t.x,y:t.y,width:d.x,height:d.y};
var r={
x:e.x,y:e.y,width:c.x,height:c.y};
var a=this._animationMgr1;
if(!this._animationMgr1){
a=this._animationMgr1=new DwtAnimate()
}
a.setFramesPerSecond(25);
a.setDuration(400);
a.animateExpansion(l,h,r,new AjxCallback(this,this._animateCallback,[s]))
};
ZmSlideEditView.prototype.createSlideProxy=function(o,a,t){
var e=document.createElement("div");
Dwt.setPosition(e,Dwt.ABSOLUTE_STYLE);
Dwt.setBounds(e,a.x,a.y,t.x,t.y);
e.className=o.className;
e.innerHTML=o.innerHTML;
e.style.zIndex=4000;
return e
};
ZmSlideEditView.prototype._animateCallback=function(e){
this.clearCurrentSelection();
this._currentSlideDiv.innerHTML=e.innerHTML;
this._currentPreviewSlideDiv=e;
this._previewSlideParent=e.parentNode
};
ZmSlideEditView.prototype.clearCurrentSelection=function(){
if(this._selectedDiv!=null){
if(this.isEditable(this._selectedDiv)){
this._replaceEditorContent()
}
this._deselectComponent();
return true
}
return false
};
ZmSlideEditView.prototype.isPreviewComponent=function(e){
return(e&&e.parentNode&&(e.parentNode.className=="preview"||e.parentNode.className=="previewslideparent"))
};
ZmSlideEditView.prototype._handleItemSelection=function(e){
if(this.isSlideObject(e)){
if(this._selectedDiv!=null&&this.isEditable(this._selectedDiv)){
this._replaceEditorContent()
}
if(this.isEditable(e)){
this._createEditor(e)
}
this._selectedDiv=e;
this._selectComponent(e)
}};
ZmSlideEditView.prototype._createEditor=function(t){
var r=t.innerHTML;
var s=this._iframe;
var e=Dwt.toWindow(t,0,0,this._currentSlideDiv,true);
var h=Dwt.getSize(t);
var n=Dwt.toWindow(this._currentSlideDiv,0,0,this.getHtmlElement(),true);
Dwt.setBounds(s,n.x+e.x,n.y+e.y,h.x,h.y);
t.innerHTML="";
s.className="SlideComponentEditor";
s.style.visibility="visible";
var o=s.contentWindow;
if(o!=null){
var c=o.document;
if(c!=null){
var l=["<body>",r,"</body>"].join("");
if(c.body){
c.body.className=t.className?t.className:"";
c.body.innerHTML=r
}
c.designMode="on";
setTimeout(function(){
o.focus()
}
,300)
}}
s.style.zIndex=Dwt.Z_VIEW+100;
t.style.zIndex=Dwt.Z_VIEW-20;
if(this._toolbar){
this._toolbar.setVisible(true);
var a=this._toolbar.getSize();
this._toolbar.setBounds(n.x,n.y-20-3,Dwt.DEFAULT,25);
this._toolbar.getHtmlElement().style.zIndex=Dwt.Z_VIEW+100
}};
ZmSlideEditView.prototype._replaceEditorContent=function(){
try{
if(!this._selectedDiv||!this._iframe){
return
}
var a=this._iframe;
var e=a?a.contentWindow:null;
var n=e?e.document:null;
if(!n){
return
}
var o=(n&&n.body)?n.body.innerHTML:"";
try{
if(AjxEnv.isGeckoBased||AjxEnv.isSafari){
n.designMode="off"
}}
catch(t){}
this._iframe.style.visibility="hidden";
Dwt.setBounds(this._iframe,-100,-100,10,10);
this._selectedDiv.innerHTML=o
}
catch(t){}
this._syncPreview();
if(this._toolbar){
this._toolbar.setVisible(false)
}};
ZmSlideEditView.prototype._recordTargetPosition=function(t,o){
this._clickDiv=o;
var e=Dwt.toWindow(o,0,0,this.getCurrentSlideElement(),true);
var a={
dndStarted:false,view:this,el:o,elementOffset:e,docX:t.docX,docY:t.docY};
this._clickDivData=a
};
ZmSlideEditView.prototype._selectComponent=function(h){
var a=Dwt.toWindow(h,0,0,this.getCurrentSlideElement(),true);
var o=Dwt.getSize(h);
var s=Dwt.toWindow(this.getCurrentSlideElement(),0,0,this.getHtmlElement(),true);
var t=s.x+a.x-4;
var r=s.y+a.y-4;
var n=o.x+8;
var e=o.y+8;
Dwt.setBounds(this._topSash,t,r,n,Dwt.DEFAULT);
Dwt.setBounds(this._bottomSash,t,r+e-4,n,Dwt.DEFAULT);
Dwt.setBounds(this._leftSash,t,r,Dwt.DEFAULT,o.y);
Dwt.setBounds(this._rightSash,t+n-4,r,Dwt.DEFAULT,o.y);
Dwt.setLocation(this._leftTopSelectionBox,t-4,r-4);
Dwt.setLocation(this._rightTopSelectionBox,t+n-4-2,r-4-4);
Dwt.setLocation(this._leftBottomSelectionBox,t-4,r+e-4);
Dwt.setLocation(this._rightBottomSelectionBox,t+n-4,r+e-4);
Dwt.setVisible(this._topSash,true);
Dwt.setVisible(this._bottomSash,true);
Dwt.setVisible(this._leftSash,true);
Dwt.setVisible(this._rightSash,true);
Dwt.setVisible(this._leftTopSelectionBox,true);
Dwt.setVisible(this._rightTopSelectionBox,true);
Dwt.setVisible(this._leftBottomSelectionBox,true);
Dwt.setVisible(this._rightBottomSelectionBox,true)
};
ZmSlideEditView.prototype._deselectComponent=function(e){
Dwt.setVisible(this._topSash,false);
Dwt.setVisible(this._bottomSash,false);
Dwt.setVisible(this._leftSash,false);
Dwt.setVisible(this._rightSash,false);
Dwt.setVisible(this._leftTopSelectionBox,false);
Dwt.setVisible(this._rightTopSelectionBox,false);
Dwt.setVisible(this._leftBottomSelectionBox,false);
Dwt.setVisible(this._rightBottomSelectionBox,false)
};
ZmSlideEditView.prototype._mouseMoveListener=function(n){
if(!this._clickDiv&&!this._clickDivData){
return
}
var o=DwtShell.mouseEvent;
o.setFromDhtmlEvent(n,true);
if(!this._clickDiv){
return
}
var s=this._clickDivData;
var t=o.docX-s.docX;
var e=o.docY-s.docY;
var a=this._getItemData(this._clickDiv,"type");
if(!this.isEditable(this._clickDiv)&&!a){
this._handleSashMovement(t,e);
return false
}
switch(a){
case ZmSlideEditView.TYPE_TOP_SASH:case ZmSlideEditView.TYPE_BOTTOM_SASH:case ZmSlideEditView.TYPE_LEFT_SASH:case ZmSlideEditView.TYPE_RIGHT_SASH:this._handleSashMovement(t,e);
break;
case ZmSlideEditView.TYPE_LEFT_TOP_BOX:case ZmSlideEditView.TYPE_LEFT_BOTTOM_BOX:case ZmSlideEditView.TYPE_RIGHT_BOTTOM_BOX:this._handleResize(t,e,a);
break
}
o._stopPropagation=true;
o._returnValue=false;
o.setToDhtmlEvent(n);
return false
};
ZmSlideEditView.prototype._handleResize=function(r,n,c){
var l=this._clickDivData;
if(this._selectedDiv!=null&&l!=null){
this._resizeStarted=true;
var a=Dwt.getBounds(this._selectedDiv);
var o=a.x+a.width;
var d=a.y+a.height;
var s=this.getOffsetBounds();
var t=s.x+a.x;
var u=s.y+a.y;
var h=a.width;
var e=a.height;
switch(c){
case ZmSlideEditView.TYPE_LEFT_TOP_BOX:t=t+r;
u=u+n;
h=a.width-r;
e=a.height-n;
break;
case ZmSlideEditView.TYPE_LEFT_BOTTOM_BOX:t=t+r;
h=a.width-r;
e=a.height+n;
break;
case ZmSlideEditView.TYPE_RIGHT_BOTTOM_BOX:h=a.width+r;
e=a.height+n;
break
}
this._clearInvalidStyles(this._dragProxyDiv);
this._enableDragProxyDiv(true);
Dwt.setBounds(this._dragProxyDiv,t-2,u-2,h-2,e-2)
}};
ZmSlideEditView.prototype._enableDragProxyDiv=function(e){
this._dragProxyDiv.style.display=(e?"inline":"none")
};
ZmSlideEditView.prototype._handleSashMovement=function(t,e){
var o=this._clickDivData;
if(this._selectedDiv!=null&&o!=null){
this._divDndStarted=true;
var a=Dwt.getBounds(this._selectedDiv);
var n=this.getOffsetBounds();
this._dragProxyDiv.style.display="inline";
Dwt.setBounds(this._dragProxyDiv,n.x+a.x+t,n.y+a.y+e,a.width,a.height)
}};
ZmSlideEditView.prototype._mouseUpListener=function(a){
var n=this.getTargetItemDiv(a);
delete this._clickDiv;
delete this._clickDivData;
var o=this.getOffsetBounds();
var e=this._getItemData(n,"type");
if(e==ZmSlideEditView.TYPE_RIGHT_TOP_BOX){
this.deleteTextBox()
}else{
if(this._divDndStarted){
var t=Dwt.getBounds(this._dragProxyDiv);
this._clearInvalidStyles(this._selectedDiv);
Dwt.setLocation(this._selectedDiv,t.x-o.x,t.y-o.y);
this._restoreSelectionMode()
}else{
if(this._resizeStarted){
this._clearInvalidStyles(this._dragProxyDiv);
var t=Dwt.getBounds(this._dragProxyDiv);
this._clearInvalidStyles(this._selectedDiv);
Dwt.setBounds(this._selectedDiv,t.x-o.x,t.y-o.y,t.width-2,t.height-2);
this._restoreSelectionMode()
}}}
return this._mouseUpAction(a,n)
};
ZmSlideEditView.prototype._restoreSelectionMode=function(){
this._selectComponent(this._selectedDiv);
this._enableDragProxyDiv(false);
if(this.isEditable(this._selectedDiv)){
this._replaceEditorContent()
}
this._divDndStarted=false;
this._resizeStarted=false;
this._syncPreview()
};
ZmSlideEditView.prototype._mouseUpAction=function(e,t){
return true
};
ZmSlideEditView.prototype._mouseOutListener=function(e){
var t=this.getTargetItemDiv(e);
if(!t){
return
}
this._mouseOutAction(e,t)
};
ZmSlideEditView.prototype._mouseOutAction=function(e,t){
return true
};
ZmSlideEditView.prototype._mouseOverListener=function(e){
var t=this.getTargetItemDiv(e);
if(!t){
return
}
return this._mouseOverAction(e,t)
};
ZmSlideEditView.prototype._mouseOverAction=function(e,t){
return true
};
ZmSlideEditView.prototype._clearInvalidStyles=function(e){};
ZmSlideEditView.prototype.fixComponents=function(a){
var e=this.getCurrentSlideElement();
var t=e.firstChild;
while(t){
this.convertToPercentage(t);
t=t.nextSibling
}};
ZmSlideEditView.prototype._syncPreview=function(){
this.fixComponents(this.getCurrentSlideElement());
this.getCurrentPreviewSlideElement().innerHTML=this.getCurrentSlideElement().innerHTML
};
ZmSlideEditView.prototype.convertToPercentage=function(e){
var r=this._getItemData(e,"type");
if(!this.isSlideObject(e)){
return
}
var a=e.style.left;
var h=e.style.top;
var o=e.parentNode;
var t=Dwt.getSize(o);
var c=Dwt.getSize(e);
var l=(c.x/t.x)*100;
var s=(c.y/t.y)*100;
e.style.width=l+"%";
e.style.height=s+"%";
if(a.match(/\px$/)||h.match(/\px$/)){
var n=Dwt.toWindow(e,0,0,o,null,null);
a=(n.x/t.x)*100;
h=(n.y/t.y)*100;
e.style.left=a+"%";
e.style.top=h+"%"
}};
ZmSlideEditView.prototype.getOffsetBounds=function(){
return Dwt.toWindow(this.getCurrentSlideElement(),0,0,this.getHtmlElement(),true)
};
ZmSlideEditView.prototype.insertTextBox=function(t){
var a=document.createElement("div");
a.className="slide_object_notes";
a.innerHTML=t||ZmMsg.slides_textBoxMessage;
Dwt.setPosition(a,Dwt.ABSOLUTE_STYLE);
Dwt.setBounds(a,"5%","80%",200,100);
var e=this.getCurrentSlideElement();
e.appendChild(a)
};
ZmSlideEditView.prototype.insertImage=function(){
var e=prompt(ZmMsg.slides_imageURL);
if(e!=null){
this._insertImage(e)
}};
ZmSlideEditView.prototype._insertImage=function(a){
var n=document.createElement("div");
n.className="slide_object_img";
n.style.zIndex=Dwt.Z_VIEW;
Dwt.setPosition(n,Dwt.ABSOLUTE_STYLE);
Dwt.setBounds(n,"20%","20%",200,100);
n.style.overflow="hidden";
var t=this;
var o=document.createElement("img");
o.onload=function(){
t.resizeImg(n,o);
t._syncPreview();
t._importPendingImages()
};
o.src=a;
n.appendChild(o);
var e=this.getCurrentSlideElement();
e.appendChild(n)
};
ZmSlideEditView.prototype.insertFile=function(a){
var e=this._controller.getRestUrl();
for(var t in a){
if(!a[t]){
return
}
this._insertImage(e+"/"+a[t])
}};
ZmSlideEditView.prototype.importSlides=function(a){
var e="";
if(window.restPage||!window.opener){
return
}
var t=window.opener.appCtxt;
this._pendingSlides=window.opener.importSlidesQueue||[];
if(this._pendingSlides.length>0){
this._importPendingImages()
}else{
this.createNewSlide()
}
this._state=ZmSlideEditView.NEW
};
ZmSlideEditView.prototype.isImage=function(e){
var t=AjxStringUtil.parseURL(e);
return(t&&t.fileName)?t.fileName.toLowerCase().match(/\.jpg$|\.gif$|\.jpeg$|\.png$|\.bmp$$/):false
};
ZmSlideEditView.prototype._importPendingImages=function(){
if(this._pendingSlides&&this._pendingSlides.length>0){
var e=this._pendingSlides.pop();
var t=AjxStringUtil.parseURL(e);
var a=(t&&t.fileName)?t.fileName:"";
this.createSlide(null,true,null,true);
if(this.isImage(e)){
this._insertImage(e)
}else{
this.insertTextBox("<a href='"+e+"'>"+a+"</a>");
this._importPendingImages()
}}};
ZmSlideEditView.prototype.resizeImg=function(h,r){
var s=r.offsetWidth;
var e=r.offsetHeight;
var t=this.getCurrentSlideElement();
var n=s/e;
var o=t.offsetWidth;
var a=t.offsetHeight;
if(s>o){
percentWidth=90;
percentHeight=percentWidth*e/s
}else{
if(e>a){
percentHeight=90;
percentWidth=percentHeight*s/e
}else{
percentHeight=100*e/a;
percentWidth=100*s/o
}}
Dwt.setBounds(h,(100-percentWidth)/2+"%",15/2+(85-percentHeight)/2+"%",percentWidth+"%",percentHeight+"%");
Dwt.setSize(r,"100%","100%")
};
ZmSlideEditView.prototype.insertGraph=function(t,o){
var n=document.createElement("div");
n.className="slide_object_graph";
n.innerHTML="";
Dwt.setPosition(n,Dwt.ABSOLUTE_STYLE);
Dwt.setBounds(n,20,20,400,300);
var e=this.getCurrentSlideElement();
e.appendChild(n);
var a=new FusionCharts(t,Dwt.getNextId(),"400","300","0","0");
a.setDataURL(o);
a.render(n)
};
ZmSlideEditView.prototype.deleteTextBox=function(e){
e=(e!=null)?e:this._selectedDiv;
if(!e){
return
}
if(!this.isSlideObject(e)){
return
}
if(e.parentNode){
if(e==this._selectedDiv){
if(this.isEditable(e)){
this._replaceEditorContent()
}
this._deselectComponent()
}
e.parentNode.removeChild(e)
}};
ZmSlideEditView.prototype.runSlideShow=function(){
var o=[];
var e=0;
e=this.getSlideHTML(o,e,true,true);
var t="_new";
var a=["width=",(screen.width||640),",","height=",(screen.height||480),",","fullscreen=yes"].join("");
var s=open("",t,a);
var n=s.document;
this.writeSlideShowContent(n,o)
};
ZmSlideEditView.prototype.writeSlideShowContent=function(a,t){
var e=[];
e.push('<link href="'+window.contextPath+'/css/slides.css" rel="stylesheet" type="text/css" />');
if(this._currentTheme){
e.push('<link href="'+this.getThemeCSSPath(this._currentTheme)+'" rel="stylesheet" type="text/css" />')
}
e.push("<style>");
e.push(".slide {");
e.push("font-size: 32px;");
e.push("overflow: hidden;");
e.push("}");
e.push("body {");
e.push("background-color: #000000;");
e.push("}");
e.push("</style>");
t.push('<script language="javascript" src="'+window.contextPath+'/public/slides/presentation.js"><\/script>');
a.open();
a.write("<head>");
a.write(e.join(""));
a.write("</head>");
a.write("<body>");
a.write(t.join(""));
a.write("</body>");
a.close()
};
ZmSlideEditView.prototype.getSlideHTML=function(r,c,t,l){
var n=0;
if(this._previewContainer.firstChild){
var a=this._previewContainer.firstChild;
while(a){
var o=a.firstChild;
if(o&&(o.className=="preview")){
var d=Dwt.Z_VIEW;
var e=l?75:100;
var h=(!l&&n==0)?"":";display:none;";
r[c++]=["<div class='slide' style='z-index:",d,h,"'>"].join("");
r[c++]=o.innerHTML;
r[c++]="</div>";
n++
}
a=a.nextSibling
}}
if(t){
c=this.getEndSlideContent(r)
}
var s=this._currentTheme?["theme='",this._currentTheme,"'"].join(""):"";
r[c++]=["<div class='slidemaster' ",s," style='width:100%;height:100%;position:absolute;left:0%;top:0%;z-index:",(Dwt.Z_VIEW-50),(l?";display:none;":""),"'>"].join("");
r[c++]=this._currentSlideThemeDiv.innerHTML;
r[c++]="</div>";
if(t){
c=this.getSplashScreenContent(r)
}
if(l){
c=this.getNavigationButtonContent(r)
}
return c
};
ZmSlideEditView.prototype.getSplashScreenContent=function(t){
var e=t.length;
t[e++]=["<div class='splashscreen' id='splashscreen' style='width:100%;height:100%;position:absolute;left:0%;top:0%;display: block;z-index:",(Dwt.Z_VIEW+100),"'>"].join("");
t[e++]="<center>"+ZmMsg.loading+"</center>";
t[e++]="</div>";
return e
};
ZmSlideEditView.prototype.getEndSlideContent=function(t){
var e=t.length;
t[e++]=["<div class='endslide' id='endslide' style='width:100%;height:100%;position:absolute;left:0%;top:0%;display: none;z-index:",(Dwt.Z_VIEW),"'>"].join("");
t[e++]="<center>"+ZmMsg.slides_endSlideMsg+"</center>";
t[e++]="</div>";
return e
};
ZmSlideEditView.prototype.getNavigationButtonContent=function(o){
var e=o.length;
var t=window.contextPath+"/img/large/ImgLeftArrow_32.gif";
var a=window.contextPath+"/img/large/ImgRightArrow_32.gif";
o[e++]='<div class="slideShowNavToolbar"><span class="navBtns" onclick="goPrevSlide()"> <img class="navImg" src="'+t+'"/> </span><span class="navBtns" onclick="goNextSlide()"> <img class="navImg" src="'+a+'"/> </span></div>';
return e
};
ZmSlideEditView.prototype.saveFile=function(){
var o=[];
var e=0;
e=this.getSlideHTML(o,e);
var n=this._controller.getFileName();
if(n==""){
message=ZmMsg.emptyDocName
}else{
message=this._docMgr.checkInvalidDocName(n)
}
if(message){
var a=DwtMessageDialog.WARNING_STYLE;
var t=this.warngDlg=appCtxt.getMsgDialog();
t.setMessage(message,a);
t.popup();
t.registerCallback(DwtDialog.OK_BUTTON,new AjxCallback(this,this._okListener,[t]));
return false
}
window.fileInfo.name=n;
window.fileInfo.content=this._origContent=o.join("");
window.fileInfo.contentType=ZmSlideEditView.APP_ZIMBRA_PPT;
this._docMgr.setSaveCallback(new AjxCallback(this,this._saveHandler));
this._docMgr.saveDocument(window.fileInfo)
};
ZmSlideEditView.prototype._okListener=function(e){
e.popdown()
};
ZmSlideEditView.prototype._saveHandler=function(a,e){
if(e){
var t=new AjxMessageFormat(ZmMsg.saveConflictPresentation);
appCtxt.setStatusMsg(t.format(a[0].name),ZmStatusView.LEVEL_WARNING)
}else{
if(a&&a.length>0){
window.fileInfo.id=a[0].id;
window.fileInfo.version=a[0].ver;
appCtxt.setStatusMsg(ZmMsg.savedPresentation,ZmStatusView.LEVEL_INFO);
this._state=ZmSlideEditView.EDIT
}}};
ZmSlideEditView.prototype.loadData=function(e){
return this._docMgr.getItemInfo({
id:e}
)
};
ZmSlideEditView.prototype.loadSlide=function(n,a){
var o=this._docMgr.fetchDocumentContent(n);
this._controller.setFileName(n.name?n.name:"Untitled");
if(o){
var s=this.getSlideParserDiv();
s.innerHTML=this._origContent=o;
if(!a){
this.parseSlideContent();
this._state=ZmSlideEditView.EDIT
}else{
var t=[];
t.push("<style>");
t.push(".slide {");
t.push("font-size: 32px;");
t.push("overflow: hidden;");
t.push("}");
t.push("body {");
t.push("background-color: #000000;");
t.push("}");
t.push("</style>");
o=[o];
var e=this.getEndSlideContent(o);
e=this.getSplashScreenContent(o);
e=this.getNavigationButtonContent(o);
if(document.body){
this._themeManager.loadCSS(window.contextPath+"/css/slides.css");
if(this._currentTheme){
this._themeManager.loadThemeCSS(this._currentTheme)
}
document.body.innerHTML=t.join("")+o.join("");
initSlides();
window.onresize=_resize
}}}};
ZmSlideEditView.prototype.parseSlideTheme=function(){
var t=this._slideParserDiv.firstChild;
while(t){
var e=t.className;
if(e=="slidemaster"){
var a=t.getAttribute("theme");
if(a){
this._currentTheme=a;
return
}}
t=t.nextSibling
}
return
};
ZmSlideEditView.prototype.getSlideParserDiv=function(){
if(!this._slideParserDiv){
this._slideParserDiv=document.createElement("div");
this._slideParserDiv.style.display="none";
this.getHtmlElement().appendChild(this._slideParserDiv)
}
return this._slideParserDiv
};
ZmSlideEditView.prototype.cleanupSlideParserDiv=function(){
var t=this._slideParserDiv.firstChild;
while(t){
var e=t.nextSibling;
t.parentNode.removeChild(t);
t=e
}};
ZmSlideEditView.prototype.parseSlideContent=function(){
this.createSlide(true);
var s=this._slideParserDiv.firstChild;
while(s){
var n=s.className;
if(n=="slidemaster"){
var r=s.getAttribute("theme");
if(r){
this._currentTheme=r;
this.changeCSS(r)
}
this._currentSlideThemeDiv.innerHTML=s.innerHTML;
this._themeManager.setNotesSlideContent(s.innerHTML)
}
s=s.nextSibling
}
s=this._slideParserDiv.firstChild;
while(s){
var e=(s.className=="slide");
if(e){
this.createPreviewSlide();
this._currentPreviewSlideDiv.innerHTML=s.innerHTML;
this._currentPreviewSlideThemeDiv.innerHTML=this._currentSlideThemeDiv.innerHTML
}
s=s.nextSibling
}
this.cleanupSlideParserDiv();
var a=this._previewContainer.firstChild;
var t=a?a.firstChild:null;
var o=t?t.nextSibling:null;
if(t){
this._currentSlideDiv.innerHTML=t.innerHTML
}
if(o){
this._currentSlideThemeDiv.innerHTML=o.innerHTML
}
this._slideParserDiv.parentNode.removeChild(this._slideParserDiv)
};
ZmSlideEditView.prototype.isSlideObject=function(a){
if(!a){
return false
}
var e=a.className+",";
var t=ZmSlideEditView.SLIDE_OBJECTS.join(",")+",";
return(t.indexOf(e)>=0)
};
ZmSlideEditView.prototype._getActionDiv=function(t){
var e=this._getItemData(t,"type");
if(e){
return t
}
while(t&&!this.isActionDiv(t)){
t=t.parentNode
}
return t
};
ZmSlideEditView.prototype.isActionDiv=function(t){
if(!t.className){
return false
}
var e=t.className;
return((e.indexOf("slide")>=0)||(e.indexOf("preview")>=0))
};
ZmSlideEditView.prototype.setTheme=function(r){
this.clearCurrentSelection();
this._selectedDiv=null;
this._currentTheme=r;
var a=this._themeManager.getThemeSlidePath(r);
var s=this._docMgr.getThemeContent(a);
var h=this.getSlideParserDiv();
h.innerHTML=s;
this._themeManager.parseSlideTheme(h);
var n=this._previewContainer.firstChild;
var o=true;
while(n){
if(n.className=="previewslideparent"){
var t=n?n.firstChild:null;
var e=t?t.nextSibling:null;
if(e&&e.className=="slidemaster"){
e.innerHTML=this._themeManager.getMasterSlideContent(o);
o=false
}}
n=this.getNextPreviewSlideParent(n)
}
this._currentSlideThemeDiv.innerHTML=this._themeManager.getMasterSlideContent();
this.changeCSS(r)
};
ZmSlideEditView.prototype.changeCSS=function(e){
this._themeManager.loadThemeCSS(e);
this._pushIframeContent(this._iframe)
};
ZmSlideEditView.prototype.getThemeCSSPath=function(e){
return"/public/slides/themes/"+e+"/css/slide.css"
};
ZmSlideEditView.prototype.getThemeSlidePath=function(e){
return"/public/slides/themes/"+e+"/slide.html"
};
ZmSlideEditView.prototype.checkForChanges=function(){
var a=[];
var e=0;
e=this.getSlideHTML(a,e);
var t=(this._state==ZmSlideEditView.NEW)||(this._origContent!=a.join(""));
if(t){
return ZmMsg.exitPresentationUnsavedChanges
}}
}
if(AjxPackage.define("zimbraMail.briefcase.model.ZmDocletMgr")){
ZmDocletMgr=function(){};
ZmDocletMgr.prototype.saveDocument=function(e){
this._uploadSaveDocs2([{
id:e.id,name:e.name,version:(e.version?e.version:1),folderId:e.folderId}
],null,null,e.name,e.content,e.contentType,e.descEnabled,e.desc)
};
ZmDocletMgr.prototype._uploadSaveDocs2=function(n,d,l,v,u,a,y,f){
var w=AjxSoapDoc.create("BatchRequest","urn:zimbra",null);
w.setMethodAttribute("onerror","continue");
for(var m=0;
m<n.length;
m++){
var g=n[m];
if(g.done){
continue
}
var e=w.set("SaveDocumentRequest",null,null,"urn:zimbraMail");
e.setAttribute("requestId",m);
var c=w.set("doc",null,e);
if(g.id){
c.setAttribute("id",g.id);
c.setAttribute("ver",g.version)
}else{
c.setAttribute("l",g.folderId)
}
if(a){
c.setAttribute("ct",a)
}
if(g.guid){
var b=w.set("upload",null,c);
b.setAttribute("id",g.guid)
}
if(v!=null&&u!=null){
var r=w.set("content",u,c);
c.setAttribute("name",v)
}
c.setAttribute("descEnabled",y?"true":"false");
if(f){
c.setAttribute("desc",f)
}}
var t=[n,d,l];
var o=new AjxCallback(this,this._uploadSaveDocsResponse,t);
var p={
soapDoc:w,asyncMode:true,callback:o};
var s=window.opener&&window.opener.appCtxt;
if(s){
var h=s.getActiveAccount();
p.accountName=(h&&h.id!=ZmAccountList.DEFAULT_ID)?h.name:null
}
this.sendRequest(p)
};
ZmDocletMgr.prototype.sendRequest=function(e){
if(!this._requestMgr){
this._requestMgr=new ZmRequestMgr(this)
}
e.noSession=true;
return this._requestMgr.sendRequest(e)
};
ZmDocletMgr.prototype._uploadSaveDocsResponse=function(n,g,m,t){
var c=t&&t._data&&t._data.BatchResponse;
var v=[];
if(c&&c.SaveDocumentResponse){
for(var b=0;
b<c.SaveDocumentResponse.length;
b++){
var e=c.SaveDocumentResponse[b];
n[e.requestId].done=true;
n[e.requestId].rest=e.doc[0].rest;
n[e.requestId].ver=e.doc[0].ver;
n[e.requestId].id=e.doc[0].id;
if(n[e.requestId].folderId){
v.push(n[e.requestId].folderId)
}}}
var l=null;
if(c&&c.Fault){
var h=[];
l=[];
for(var b=0;
b<c.Fault.length;
b++){
var r=c.Fault[b];
var y=r.Detail.Error;
var a=y.Code;
var u=y.a;
if(a==ZmCsfeException.MAIL_ALREADY_EXISTS||a==ZmCsfeException.MODIFY_CONFLICT){
var w=n[r.requestId];
for(var d in u){
var f=u[d];
switch(f.n){
case"id":w.id=f._content;
break;
case"ver":w.version=f._content;
break;
case"rest":w.rest=f._content;
break
}}
l.push(w)
}else{
h[r.requestId]=r
}}}
var s=window.opener&&window.opener.appCtxt;
var o=s&&s.getAppController();
if(o&&!o.getInstantNotify()){
o.sendNoOp()
}
if(this._saveCallback){
this._saveCallback.run(n,l)
}};
ZmDocletMgr.prototype.setSaveCallback=function(e){
this._saveCallback=e
};
ZmDocletMgr.prototype._kickPolling=function(e){};
ZmDocletMgr.prototype._handleException=function(t,e){};
ZmDocletMgr.prototype.runAppFunction=function(t,e){};
ZmDocletMgr.prototype.fetchDocumentContent=function(o){
var a=o.rest;
var n=AjxStringUtil.parseURL(a);
if(n&&n.path){
var e=AjxRpc.invoke("",n.path+"?fmt=native&ver="+o.version,{}
,null,true);
var t="";
if(e&&e.success){
t=this._pendingContent=e.text
}
return t
}
return""
};
ZmDocletMgr.prototype.getItemInfo=function(a){
var l=AjxSoapDoc.create("GetItemRequest","urn:zimbraMail");
var o=l.set("item");
if(a.path){
o.setAttribute("path",a.path)
}else{
if(a.folderId&&a.id){
o.setAttribute("l",a.folderId);
o.setAttribute("id",a.id)
}else{
if(a.folderId&&a.name){
o.setAttribute("l",a.folderId);
o.setAttribute("name",a.name)
}else{
if(a.id){
o.setAttribute("id",a.id)
}}}}
var r=[];
var e=(a.callback?true:false);
var n=null;
if(e){
n=new AjxCallback(this,this.handleGetItemResponse,[a])
}
var s=window.opener&&window.opener.appCtxt;
if(s&&s.multiAccounts){
var h=s.getActiveAccount();
a.accountName=h&&h.name
}
var c={
soapDoc:l,asyncMode:e,callback:n,accountName:a.accountName};
var t=this.sendRequest(c);
if(!e&&t){
var d=this.handleGetItemResponse(a,t.GetItemResponse);
return d
}
return null
};
ZmDocletMgr.prototype.handleGetItemResponse=function(r,e){
var s=r.path;
var h=r.callback;
var a=e;
if(e&&e._data){
a=e&&e._data&&e._data.GetItemResponse
}
var t=a&&a.doc&&a.doc[0];
var o=null;
if(t){
o=new ZmItem();
var n=t;
if(n.id){
o.id=n.id
}
if(n.rest){
o.rest=n.rest
}
if(n.l){
o.folderId=n.l
}
if(n.name){
o.name=n.name
}
if(n.cr){
o.creator=n.cr
}
if(n.d){
o.createDate=new Date(Number(n.d))
}
if(n.md){
o.modifyDate=new Date(Number(n.md))
}
if(n.leb){
o.modifier=n.leb
}
if(n.s){
o.size=Number(n.s)
}
if(n.ver){
o.version=Number(n.ver)
}
if(n.ct){
o.contentType=n.ct.split(";")[0]
}
o.folderId=t.l||ZmOrganizer.ID_BRIEFCASE;
o.locked=false;
if(n.loid){
o.locked=true;
o.lockId=n.loid;
o.lockUser=n.loe;
o.lockTime=new Date(Number(n.lt))
}
o.descEnabled=n.descEnabled
}
if(h){
h.run(o)
}
return o
};
ZmDocletMgr.createItem=function(e){
var t=new ZmDocletMgr();
return t.handleGetItemResponse({}
,e)
};
ZmDocletMgr.prototype.getThemeContent=function(t){
if(!t){
return""
}
var e=AjxRpc.invoke("",t,{}
,null,true);
var a="";
if(e&&e.success){
a=e.text
}
return a
};
ZmDocletMgr.INVALID_DOC_NAME_CHARS="[\\|]";
ZmDocletMgr.INVALID_DOC_NAME_RE=new RegExp(ZmDocletMgr.INVALID_DOC_NAME_CHARS);
ZmDocletMgr.prototype.checkInvalidDocName=function(t){
var e;
t=t.replace(/^\s+/,"").replace(/\s+$/,"");
if(t==""){
e=ZmMsg.emptyDocName
}else{
if(!ZmOrganizer.VALID_NAME_RE.test(t)||ZmDocletMgr.INVALID_DOC_NAME_RE.test(t)){
e=AjxMessageFormat.format(ZmMsg.errorInvalidName,AjxStringUtil.htmlEncode(t))
}else{
if(t.length>ZmOrganizer.MAX_NAME_LENGTH){
e=AjxMessageFormat.format(ZmMsg.nameTooLong,ZmOrganizer.MAX_NAME_LENGTH)
}}}
return e
};
ZmDocletMgr.prototype.unlock=function(o,s,e,t){
var a={
ItemActionRequest:{
_jsns:"urn:zimbraMail",action:{
id:o.id,op:"unlock"}}};
var n={
jsonObj:a,asyncMode:Boolean(s),callback:s,errorCallback:e,accountName:t};
return this.sendRequest(n)
};
ZmDocletMgr.getEditURLForContentType=function(t){
AjxDispatcher.require("Startup1_1");
var e="Slides.jsp";
switch(t){
case ZmMimeTable.APP_ZIMBRA_SLIDES:e="Slides.jsp";
break;
case ZmMimeTable.APP_ZIMBRA_SPREADSHEET:e="SpreadsheetDoc.jsp";
break;
case ZmMimeTable.APP_ZIMBRA_DOC:e="Docs.jsp";
break;
default:return null
}
return(window.appContextPath+"/public/"+e)
}
}
if(AjxPackage.define("zimbraMail.share.view.dialog.ZmUploadDialog")){
ZmUploadDialog=function(e,t){
t=t||"ZmUploadDialog";
var a=ZmMsg.uploadDocs;
DwtDialog.call(this,{
parent:e,className:t,title:a}
);
this.setButtonListener(DwtDialog.OK_BUTTON,new AjxListener(this,this._upload));
this._createUploadHtml();
this._showLinkTitleText=false;
this._linkText={}
};
ZmUploadDialog.prototype=new DwtDialog;
ZmUploadDialog.prototype.constructor=ZmUploadDialog;
ZmUploadDialog.ACTION_KEEP_MINE="mine";
ZmUploadDialog.ACTION_KEEP_THEIRS="theirs";
ZmUploadDialog.ACTION_ASK="ask";
ZmUploadDialog.UPLOAD_FIELD_NAME="uploadFile";
ZmUploadDialog.UPLOAD_TITLE_FIELD_NAME="uploadFileTitle";
ZmUploadDialog.prototype._selector;
ZmUploadDialog.prototype._uploadFolder;
ZmUploadDialog.prototype._uploadCallback;
ZmUploadDialog.prototype._extensions;
ZmUploadDialog.prototype.enableLinkTitleOption=function(e){
this._showLinkTitleText=e
};
ZmUploadDialog.prototype.setAllowedExtensions=function(t){
this._extensions=t;
if(t){
for(var e=0;
e<t.length;
e++){
t[e]=t[e].toUpperCase()
}}};
ZmUploadDialog.prototype.getNotes=function(){
return(this._notes?this._notes.value:"")
};
ZmUploadDialog.prototype.setNotes=function(e){
if(this._notes){
this._notes.value=(e||"")
}};
ZmUploadDialog.prototype.popup=function(a,u,d,h,p,s,o){
this._uploadFolder=a;
this._uploadCallback=u;
this._supportsHTML5=AjxEnv.supportsHTML5File&&!this._showLinkTitleText&&(appCtxt.get(ZmSetting.DOCUMENT_SIZE_LIMIT)!=null);
this.setTitle(d||ZmMsg.uploadDocs);
var m=this._tableEl;
var f=m.rows;
while(f.length){
m.deleteRow(f.length-1)
}
this._addFileInputRow(p);
this.setButtonEnabled(DwtDialog.OK_BUTTON,true);
this.setButtonEnabled(DwtDialog.CANCEL_BUTTON,true);
var t=this._htmlElId;
var e=document.getElementById(t+"_label");
if(e){
Dwt.setVisible(e,!p)
}
var c=document.getElementById(t+"_actionRow");
if(c){
Dwt.setVisible(c,!s)
}
var r=document.getElementById(t+"_notesTD");
if(r){
Dwt.setVisible(r,o)
}
var l=document.getElementById((t+"_info"));
if(l){
var n=AjxUtil.formatSize(appCtxt.get(ZmSetting.DOCUMENT_SIZE_LIMIT)||0,true);
l.innerHTML=AjxMessageFormat.format(ZmMsg.attachmentLimitMsg,n)
}
DwtDialog.prototype.popup.call(this,h)
};
ZmUploadDialog.prototype.popdown=function(){
this._extensions=null;
this._enableStatus=false;
this._notes.removeAttribute("disabled");
this.setNotes("");
this._msgInfo.innerHTML="";
DwtDialog.prototype.popdown.call(this)
};
ZmUploadDialog.prototype.uploadFiles=function(a,n,t){
if(a.length==0){
return
}
this._uploadFolder=t;
var s=new AjxCallback(this,this._uploadSaveDocs,[a]);
var o=appCtxt.getUploadManager();
window._uploadManager=o;
try{
o.execute(s,n)
}
catch(e){
if(e.msg){
this._popupErrorDialog(e.msg)
}else{
this._popupErrorDialog(ZmMsg.unknownError)
}}};
ZmUploadDialog.prototype._upload=function(){
var e=this._uploadForm;
var o=[];
this._linkText={};
var l=e.elements;
var n=appCtxt.getActiveAccount().id;
if(e.action.length){
var s=e.action.indexOf("?")>0?"&limitAcct="+n:"limitAcct="+n;
e.action+=s
}
for(var u=0;
u<l.length;
u++){
var t=e.elements[u];
if(t.name!=ZmUploadDialog.UPLOAD_FIELD_NAME){
continue
}
if(!t.value){
continue
}
if(!this._checkExtension(t.value)){
var b=[this._extensions.join(", ")];
var r=AjxMessageFormat.format(ZmMsg.errorNotAllowedFile,b);
this._popupErrorDialog(r);
return
}
this._msgInfo.innerHTML="";
var h=this.getNotes();
if(this._supportsHTML5){
if(this._validateSize()){
var g=t.files;
for(var d=0;
d<g.length;
d++){
o.push({
name:g[d].name,fullname:g[d].name,notes:h}
)
}}else{
this._msgInfo.innerHTML=AjxMessageFormat.format(ZmMsg.attachmentSizeError,AjxUtil.formatSize(appCtxt.get(ZmSetting.DOCUMENT_SIZE_LIMIT)));
return
}}else{
var w={
fullname:t.value,name:t.value.replace(/^.*[\\\/:]/,""),notes:h};
o.push(w)
}
if(this._showLinkTitleText){
var c=t.id;
c=c.replace("_input","")+"_titleinput";
var m=document.getElementById(c);
if(m){
this._linkText[w.name]=m.value
}}}
if(o.length==0){
return
}
this.setButtonEnabled(DwtDialog.OK_BUTTON,false);
this.setButtonEnabled(DwtDialog.CANCEL_BUTTON,false);
var a=new AjxCallback(this,this._uploadSaveDocs,[o]);
var y=appCtxt.getUploadManager();
window._uploadManager=y;
try{
y.execute(a,this._uploadForm)
}
catch(p){
if(p.msg){
this._popupErrorDialog(p.msg)
}else{
this._popupErrorDialog(ZmMsg.unknownError)
}}};
ZmUploadDialog.prototype._checkExtension=function(e){
if(!this._extensions){
return true
}
var a=e.replace(/^.*\./,"").toUpperCase();
for(var t=0;
t<this._extensions.length;
t++){
if(this._extensions[t]==a){
return true
}}
return false
};
ZmUploadDialog.prototype._validateSize=function(){
var s=document.getElementsByName(ZmUploadDialog.UPLOAD_FIELD_NAME);
var o,a;
for(var t=0;
t<s.length;
t++){
o=s[t].files;
if(!o||o.length==0){
continue
}
for(var e=0;
e<o.length;
e++){
var n=o[e];
a=n.size||n.fileSize;
if(a>appCtxt.get(ZmSetting.DOCUMENT_SIZE_LIMIT)){
return false
}}}
return true
};
ZmUploadDialog.prototype._popupErrorDialog=function(t){
this.setButtonEnabled(DwtDialog.OK_BUTTON,true);
this.setButtonEnabled(DwtDialog.CANCEL_BUTTON,true);
var e=appCtxt.getMsgDialog();
e.setMessage(t,DwtMessageDialog.CRITICAL_STYLE,this._title);
e.popup()
};
ZmUploadDialog.prototype._uploadSaveDocs=function(o,e,n){
if(e!=AjxPost.SC_OK){
var a=AjxMessageFormat.format(ZmMsg.uploadError,e);
if(e=="413"){
a=ZmMsg.errorAttachmentTooBig
}
this._popupErrorDialog(a)
}else{
n=n.split(",");
for(var t=0;
t<o.length;
t++){
o[t].guid=n[t]
}
if(this._uploadFolder){
this._uploadSaveDocs2(o,e,n)
}else{
this._finishUpload(o,e,n)
}}};
ZmUploadDialog.prototype._uploadSaveDocs2=function(e,s,h){
var n=[];
var l=false;
for(var r=0;
r<e.length;
r++){
var a=e[r];
if(a.done){
continue
}
l=true;
var t={
_jsns:"urn:zimbraMail",requestId:r,doc:{}};
var c=t.doc;
if(a.id){
c.id=a.id;
c.ver=a.version
}else{
c.l=this._uploadFolder.id
}
if(a.notes){
c.desc=a.notes
}
c.upload={
id:a.guid};
n.push(t)
}
if(l){
var m={
BatchRequest:{
_jsns:"urn:zimbra",onerror:"continue",SaveDocumentRequest:((n.length==1)?n[0]:n)}};
var u=new AjxCallback(this,this._uploadSaveDocsResponse,[e,s,h]);
var o={
jsonObj:m,asyncMode:true,callback:u};
var d=appCtxt.getAppController();
d.sendRequest(o)
}};
ZmUploadDialog.prototype._uploadSaveDocsResponse=function(o,g,m,t){
var c=t&&t._data&&t._data.BatchResponse;
if(c&&c.SaveDocumentResponse){
for(var v=0;
v<c.SaveDocumentResponse.length;
v++){
var e=c.SaveDocumentResponse[v];
o[e.requestId].done=true;
o[e.requestId].name=e.doc[0].name;
o[e.requestId].id=e.doc[0].id;
o[e.requestId].ver=e.doc[0].ver;
o[e.requestId].version=e.doc[0].ver
}}
var h=[];
if(c&&c.Fault){
var s=[],l=false,r=false;
for(var v=0;
v<c.Fault.length;
v++){
var n=c.Fault[v];
var b=n.Detail.Error;
var a=b.Code;
var u=b.a;
r=(a==ZmCsfeException.LOCKED);
if(a==ZmCsfeException.MAIL_ALREADY_EXISTS||a==ZmCsfeException.MODIFY_CONFLICT){
var x=o[n.requestId];
for(var d in u){
var f=u[d];
switch(f.n){
case"itemId":x.id=f._content;
break;
case"id":x.id=f._content;
break;
case"ver":x.version=f._content;
break;
case"name":x.name=f._content;
break
}}
x.version=x.version||1;
h.push(x)
}else{
if(a==ZmCsfeException.MAIL_QUOTA_EXCEEDED){
l=true
}
s[n.requestId]=n
}}
if(l){
this._popupErrorDialog(ZmMsg.errorQuotaExceeded);
return
}else{
if(r){
this._popupErrorDialog(ZmMsg.errorItemLocked);
return
}else{
if(a==ZmCsfeException.SVC_PERM_DENIED){
this._popupErrorDialog(ZmMsg.errorPermissionDenied);
this.popdown();
return
}}}}
this.popdown();
var w=h.length;
var y=this._conflictAction||this._selector.getValue();
if(w>0&&y==ZmUploadDialog.ACTION_ASK){
var k=appCtxt.getUploadConflictDialog();
k.popup(this._uploadFolder,h,new AjxCallback(this,this._uploadSaveDocs2,[o,g,m]))
}else{
if(w>0&&y==ZmUploadDialog.ACTION_KEEP_MINE){
if(this._conflictAction){
this._shieldSaveDocs(o,g,m)
}else{
this._uploadSaveDocs2(o,g,m)
}}else{
if(this._uploadCallback){
this._finishUpload(o,g,m)
}else{
this._conflictAction=null
}}}};
ZmUploadDialog.prototype._shieldSaveDocs=function(t,e,a){
var o=appCtxt.getYesNoMsgDialog();
o.reset();
o.setButtonListener(DwtDialog.YES_BUTTON,new AjxListener(this,this._shieldSaveDocsYesCallback,[o,t,e,a]));
o.setMessage(ZmMsg.uploadConflictShield,DwtMessageDialog.WARNING_STYLE,ZmMsg.uploadConflict);
o.popup()
};
ZmUploadDialog.prototype._shieldSaveDocsYesCallback=function(o,t,e,a){
this._uploadSaveDocs2(t,e,a);
o.popdown()
};
ZmUploadDialog.prototype.setConflictAction=function(e){
this._conflictAction=e
};
ZmUploadDialog.prototype._finishUpload=function(n,e,s){
var o=[];
for(var a in n){
var t=n[a].name;
if(this._linkText[t]){
n[a].linkText=this._linkText[t]
}
o.push(t)
}
this._uploadCallback.run(this._uploadFolder,o,n);
this._conflictAction=null
};
ZmUploadDialog.prototype._addFileInputRow=function(p){
var e=Dwt.getNextId();
var l=e+"_input";
var o=e+"_remove";
var a=e+"_add";
var n=e+"_size";
var g=this._tableEl;
var y=g.insertRow(-1);
var f=y.insertCell(-1);
f.innerHTML=ZmMsg.fileLabel;
var u=y.insertCell(-1);
u.innerHTML=["<input id='",l,"' type='file' name='",ZmUploadDialog.UPLOAD_FIELD_NAME,"' size=30 ",(this._supportsHTML5?"multiple":""),">"].join("");
var u=y.insertCell(-1);
u.id=n;
u.innerHTML="&nbsp;";
if(this._supportsHTML5){
var d=document.getElementById(l);
var s=u;
Dwt.setHandler(d,"onchange",AjxCallback.simpleClosure(this._handleFileSize,this,d,s))
}
if(p){
u.colSpan=3
}else{
var u=y.insertCell(-1);
u.innerHTML=["<span ","id='",o,"' ","onmouseover='this.style.cursor=\"pointer\"' ","onmouseout='this.style.cursor=\"default\"' ","style='color:blue;text-decoration:underline;'",">",ZmMsg.remove,"</span>"].join("");
var h=document.getElementById(o);
Dwt.setHandler(h,DwtEvent.ONCLICK,ZmUploadDialog._removeHandler);
var u=y.insertCell(-1);
u.innerHTML="&nbsp;";
var u=y.insertCell(-1);
u.innerHTML=["<span ","id='",a,"' ","onmouseover='this.style.cursor=\"pointer\"' ","onmouseout='this.style.cursor=\"default\"' ","style='color:blue;text-decoration:underline;'",">",ZmMsg.add,"</span>"].join("");
var r=document.getElementById(a);
Dwt.setHandler(r,DwtEvent.ONCLICK,ZmUploadDialog._addHandler)
}
if(this._showLinkTitleText){
var t=e+"_titleinput";
var m=g.insertRow(-1);
var c=m.insertCell(-1);
c.innerHTML=[ZmMsg.linkTitleOptionalLabel].join("");
c=m.insertCell(-1);
c.innerHTML=["<input id='",t,"' type='text' name='",ZmUploadDialog.UPLOAD_TITLE_FIELD_NAME,"' size=40>"].join("");
c.colSpan=3
}};
ZmUploadDialog.prototype._handleFileSize=function(h,n){
var e=h.files;
if(!e){
return
}
var t=[],s,r=0;
for(var o=0;
o<e.length;
o++){
var a=e[o];
var l=a.size||a.fileSize;
if(l>appCtxt.get(ZmSetting.DOCUMENT_SIZE_LIMIT)){
s="RedC"
}
r+=l
}
if(n){
n.innerHTML="  ("+AjxUtil.formatSize(r,true)+")";
if(s){
Dwt.addClass(n,"RedC")
}else{
Dwt.delClass(n,"RedC")
}}};
ZmUploadDialog._removeHandler=function(e){
var s=DwtUiEvent.getTarget(e||window.event);
var h=s.parentNode;
var c=h.parentNode;
var a=c;
if(s.id){
var t=s.id;
t=t.replace("_remove","")+"_titleinput";
var o=document.getElementById(t);
if(o){
var r=o.parentNode;
var l=r.parentNode;
a=l
}}
if(c.previousSibling==null&&a.nextSibling==null){
var n=DwtControl.findControl(s);
n._addFileInputRow()
}
if(a!=c){
a.parentNode.removeChild(a)
}
c.parentNode.removeChild(c)
};
ZmUploadDialog._addHandler=function(a){
var t=DwtUiEvent.getTarget(a||window.event);
var e=DwtControl.findControl(t);
e._addFileInputRow()
};
ZmUploadDialog.prototype._createUploadHtml=function(){
var n=this._htmlElId;
var a=appCtxt.get(ZmSetting.CSFE_UPLOAD_URI);
var t={
id:n,uri:a};
this.setContent(AjxTemplate.expand("share.Dialogs#UploadDialog",t));
this._uploadForm=document.getElementById((n+"_form"));
this._tableEl=document.getElementById((n+"_table"));
this._msgInfo=document.getElementById((n+"_msg"));
this._notes=document.getElementById((n+"_notes"));
this._selector=new DwtSelect({
parent:this}
);
this._selector.addOption(ZmMsg.uploadActionKeepMine,false,ZmUploadDialog.ACTION_KEEP_MINE);
this._selector.addOption(ZmMsg.uploadActionKeepTheirs,false,ZmUploadDialog.ACTION_KEEP_THEIRS);
this._selector.addOption(ZmMsg.uploadActionAsk,true,ZmUploadDialog.ACTION_ASK);
this._selector.reparentHtmlElement((n+"_conflict"));
var e=document.getElementById((n+"_info"));
if(e){
var o=AjxUtil.formatSize(appCtxt.get(ZmSetting.DOCUMENT_SIZE_LIMIT)||0,true);
e.innerHTML=AjxMessageFormat.format(ZmMsg.attachmentLimitMsg,o)
}}
}
if(AjxPackage.define("zimbraMail.notebook.view.ZmUploadConflictDialog")){
ZmUploadConflictDialog=function(t,a){
a=a||"ZmUploadConflictDialog";
var o=ZmMsg.uploadConflict;
var e=[DwtDialog.OK_BUTTON,DwtDialog.CANCEL_BUTTON];
DwtDialog.call(this,{
parent:t,className:a,title:o,standardButtons:e}
);
this.setButtonListener(DwtDialog.OK_BUTTON,new AjxListener(this,this._resolve));
this._mineId=this._htmlElId+"_mine";
this._theirsId=this._htmlElId+"_theirs";
this._viewId=this._htmlElId+"_view";
this._createUploadHtml()
};
ZmUploadConflictDialog.prototype=new DwtDialog;
ZmUploadConflictDialog.prototype.constructor=ZmUploadConflictDialog;
ZmUploadConflictDialog.prototype.toString=function(){
return"ZmUploadConflictDialog"
};
ZmUploadConflictDialog._MINE="mine";
ZmUploadConflictDialog._THEIRS="theirs";
ZmUploadConflictDialog.prototype._mineId;
ZmUploadConflictDialog.prototype._theirsId;
ZmUploadConflictDialog.prototype._viewId;
ZmUploadConflictDialog.prototype._table;
ZmUploadConflictDialog.prototype._conflicts;
ZmUploadConflictDialog.prototype._conflictCallback;
ZmUploadConflictDialog.prototype.popup=function(o,e,r,s){
this._uploadFolder=o;
this._conflicts=e;
this._conflictCallback=r;
var a=this._table;
for(var t=a.rows.length-1;
t>0;
t--){
a.deleteRow(t)
}
for(var t=0;
t<e.length;
t++){
var n=e[t];
this.__addFileRow(a,n)
}
DwtDialog.prototype.popup.call(this,s)
};
ZmUploadConflictDialog.prototype.popdown=function(){
DwtDialog.prototype.popdown.call(this);
this._conflictCallback=null
};
ZmUploadConflictDialog.prototype._resolve=function(){
var e=this._conflicts;
var t=this._conflictCallback;
this.popdown();
if(t){
t.run(e)
}};
ZmUploadConflictDialog.prototype._selectAll=function(o){
var a=this.getHtmlElement();
var n=a.getElementsByTagName("INPUT");
for(var t=0;
t<n.length;
t++){
var e=n[t];
if(e.type!="radio"){
continue
}
e.checked=e.value==o;
ZmUploadConflictDialog.__setFileDone(e)
}};
ZmUploadConflictDialog._handleMine=function(t){
var a=DwtUiEvent.getTarget(t);
var e=Dwt.getObjectFromElement(a);
e._selectAll(ZmUploadConflictDialog._MINE)
};
ZmUploadConflictDialog._handleTheirs=function(t){
var a=DwtUiEvent.getTarget(t);
var e=Dwt.getObjectFromElement(a);
e._selectAll(ZmUploadConflictDialog._THEIRS)
};
ZmUploadConflictDialog._handleRadio=function(e){
var t=DwtUiEvent.getTarget(e);
ZmUploadConflictDialog.__setFileDone(t)
};
ZmUploadConflictDialog.__setFileDone=function(e){
var t=Dwt.getObjectFromElement(e);
t.done=e.value==ZmUploadConflictDialog._THEIRS
};
ZmUploadConflictDialog._handleViewTheirs=function(e){
var s=DwtUiEvent.getTarget(e);
var o=Dwt.getObjectFromElement(s);
var r=o.dialog;
var a=o.file;
var h=[r._uploadFolder.restUrl||r._uploadFolder.getRestUrl(),"/",AjxStringUtil.urlComponentEncode(a.name)].join("");
var t="_new";
var l=["width=",(window.outerWidth||640),",","height=",(window.outerHeight||480),",","location,menubar,","resizable,scrollbars,status,toolbar"].join("");
var n=open(h,t,l)
};
ZmUploadConflictDialog._handleLinkOver=function(e){
this.style.cursor="pointer"
};
ZmUploadConflictDialog._handleLinkOut=function(e){
this.style.cursor="default"
};
ZmUploadConflictDialog.prototype._createUploadHtml=function(){
var h=document.createElement("DIV");
h.innerHTML=ZmMsg.uploadConflictDesc;
h.style.marginBottom="0.5em";
var o=this._table=document.createElement("TABLE");
o.border=0;
o.cellPadding=0;
o.cellSpacing=3;
var s=o.insertRow(-1);
var e=s.insertCell(-1);
var r=this._mineId;
var n=ZmMsg._new;
var a=ZmUploadConflictDialog._handleMine;
e.appendChild(this.__createLink(r,n,a));
var e=s.insertCell(-1);
var r=this._theirsId;
var n=ZmMsg.old;
var a=ZmUploadConflictDialog._handleTheirs;
e.appendChild(this.__createLink(r,n,a));
var t=this._getContentDiv();
t.appendChild(h);
t.appendChild(o)
};
ZmUploadConflictDialog.prototype.__addFileRow=function(r,t){
var h=ZmUploadConflictDialog._handleRadio;
var l=r.insertRow(-1);
var n=l.insertCell(-1);
var o=ZmUploadConflictDialog._MINE;
n.appendChild(this.__createRadio(t.name,o,true,h,t));
var n=l.insertCell(-1);
var o=ZmUploadConflictDialog._THEIRS;
n.appendChild(this.__createRadio(t.name,o,false,h,t));
var n=l.insertCell(-1);
n.style.paddingLeft="1em";
n.innerHTML=AjxStringUtil.htmlEncode(t.name);
var n=l.insertCell(-1);
n.style.paddingLeft="2em";
var e=this._viewId+(r.rows.length-1);
var s=ZmMsg.viewOld;
var h=ZmUploadConflictDialog._handleViewTheirs;
var a={
dialog:this,file:t};
n.appendChild(this.__createLink(e,s,h,a))
};
ZmUploadConflictDialog.prototype.__createRadio=function(a,h,r,s,t){
var e;
if(AjxEnv.isIE){
var n=[];
var o=0;
n[o++]="<INPUT type=radio name='";
n[o++]=a;
n[o++]="'";
if(r){
n[o++]=" checked"
}
n[o++]=">";
e=document.createElement(n.join(""))
}else{
e=document.createElement("INPUT");
e.type="radio";
e.checked=r;
e.name=a
}
e.value=h;
if(s){
Dwt.setHandler(e,DwtEvent.ONCLICK,s);
Dwt.associateElementWithObject(e,t||this)
}
return e
};
ZmUploadConflictDialog.prototype.__createLink=function(n,o,a,e){
var t=document.createElement("SPAN");
t.id=n;
t.style.color="blue";
t.style.textDecoration="underline";
t.innerHTML=o;
Dwt.setHandler(t,DwtEvent.ONMOUSEOVER,ZmUploadConflictDialog._handleLinkOver);
Dwt.setHandler(t,DwtEvent.ONMOUSEOUT,ZmUploadConflictDialog._handleLinkOut);
Dwt.setHandler(t,DwtEvent.ONCLICK,a);
Dwt.associateElementWithObject(t,e||this);
return t
}
}
if(AjxPackage.define("zimbraMail.slides.controller.ZmSlideEditController")){
ZmSlideEditController=function(){
this._requestMgr=new ZmRequestMgr(this)
};
ZmSlideEditController.prototype.toString=function(){
return"ZmSlideController"
};
ZmSlideEditController.prototype.setToolBar=function(e){
this._toolbar=e;
this._initToolBar()
};
ZmSlideEditController.prototype.setCurrentView=function(e){
this._currentView=e
};
ZmSlideEditController._VALUE="value";
ZmSlideEditController.ACTION_INSERT_TEXTBOX="textbox";
ZmSlideEditController.ACTION_DELETE_TEXTBOX="delete";
ZmSlideEditController.ACTION_INSERT_IMG="insertimg";
ZmSlideEditController.ACTION_INSERT_IMG1="insertimg1";
ZmSlideEditController.ACTION_INSERT_GRPH="insertgrph";
ZmSlideEditController.ACTION_NEW_SLIDE="newslide";
ZmSlideEditController.ACTION_DELETE_SLIDE="deleteslide";
ZmSlideEditController.ACTION_RUN="run";
ZmSlideEditController.ACTION_THEMES="themes";
ZmSlideEditController.ACTION_SAVE="save";
ZmSlideEditController.prototype._initToolBar=function(){
var n=this._toolbar;
this._fileName=new DwtInputField({
parent:n,size:20}
);
var a=new AjxListener(this,this._actionListener);
this._saveSlide=new DwtToolBarButton({
parent:n}
);
this._saveSlide.setToolTipContent(ZmMsg.save);
this._saveSlide.setImage("Save");
this._saveSlide.setText(ZmMsg.save);
this._saveSlide.setData(ZmSlideEditController._VALUE,ZmSlideEditController.ACTION_SAVE);
this._saveSlide.addSelectionListener(a);
new DwtControl({
parent:n,className:"vertSep"}
);
this._insertSlide=new DwtToolBarButton({
parent:n}
);
this._insertSlide.setToolTipContent(ZmMsg.slides_insertSlide);
this._insertSlide.setImage("AddSlide");
this._insertSlide.setText(ZmMsg.slides_insertSlide);
this._insertSlide.setData(ZmSlideEditController._VALUE,ZmSlideEditController.ACTION_NEW_SLIDE);
this._insertSlide.addSelectionListener(a);
this._deleteSlideButton=new DwtToolBarButton({
parent:n}
);
this._deleteSlideButton.setToolTipContent(ZmMsg.slides_deleteSlide);
this._deleteSlideButton.setImage("DeleteSlide");
this._deleteSlideButton.setText(ZmMsg.slides_deleteSlide);
this._deleteSlideButton.setData(ZmSlideEditController._VALUE,ZmSlideEditController.ACTION_DELETE_SLIDE);
this._deleteSlideButton.addSelectionListener(a);
this._insertButton=new DwtToolBarButton({
parent:n}
);
this._insertButton.setToolTipContent(ZmMsg.slides_insertTextBox);
this._insertButton.setImage("AddTextBox");
this._insertButton.setText(ZmMsg.slides_insertTextBox);
this._insertButton.setData(ZmSlideEditController._VALUE,ZmSlideEditController.ACTION_INSERT_TEXTBOX);
this._insertButton.addSelectionListener(a);
this._deleteButton=new DwtToolBarButton({
parent:n}
);
this._deleteButton.setToolTipContent(ZmMsg.slides_deleteTextBox);
this._deleteButton.setImage("DeleteTextBox");
this._deleteButton.setText(ZmMsg.slides_deleteTextBox);
this._deleteButton.setData(ZmSlideEditController._VALUE,ZmSlideEditController.ACTION_DELETE_TEXTBOX);
this._deleteButton.addSelectionListener(a);
var h=this._insertImage1=new DwtToolBarButton({
parent:n}
);
h.setImage("AddImage");
h.setToolTipContent(ZmMsg.insertImage);
h.setText(ZmMsg.insertImage);
h.setData(ZmSlideEditController._VALUE,ZmSlideEditController.ACTION_INSERT_IMG1);
h.addSelectionListener(a);
var d=new ZmPopupMenu(h,null,null,this);
var o=new AjxListener(this,this._imgListener);
var c=[{
name:ZmMsg.uploadNewFile,value:"upload"}
,{
name:ZmMsg.insertLink,value:"link"}
];
for(var r=0;
r<c.length;
r++){
var l=d.createMenuItem(c[r].name,{
text:c[r].name}
);
l.addSelectionListener(o);
l.setData(ZmSlideEditController._VALUE,c[r].value)
}
h.setMenu(d);
this._themesButton=new DwtToolBarButton({
parent:n}
);
this._themesButton.setToolTipContent(ZmMsg.slides_runSlideShow);
this._themesButton.setText(ZmMsg.slides_themes);
this._themesButton.setData(ZmSlideEditController._VALUE,ZmSlideEditController.ACTION_THEMES);
this._themesButton.addSelectionListener(a);
var t=new ZmPopupMenu(this._themesButton,null,null,this);
var s=new AjxListener(this,this._themeListener);
var e=[{
name:ZmMsg.slides_themeDefault,value:"default"}
,{
name:ZmMsg.slides_themeDarkBlue,value:"darkblue"}
,{
name:ZmMsg.slides_themeBlue,value:"blue"}
,{
name:ZmMsg.slides_themeGreen,value:"green"}
,{
name:ZmMsg.slides_themePurple,value:"purple"}
,{
name:ZmMsg.slides_themeBlueBand,value:"blueband"}
];
for(var r=0;
r<e.length;
r++){
var l=t.createMenuItem(e[r].name,{
text:e[r].name}
);
l.addSelectionListener(s);
l.setData(ZmSlideEditController._VALUE,e[r].value)
}
this._themesButton.setMenu(t);
this._runSlideShow=new DwtToolBarButton({
parent:n}
);
this._runSlideShow.setToolTipContent(ZmMsg.slides_runSlideShow);
this._runSlideShow.setImage("RunSlides");
this._runSlideShow.setText(ZmMsg.slides_runSlideShow);
this._runSlideShow.setData(ZmSlideEditController._VALUE,ZmSlideEditController.ACTION_RUN);
this._runSlideShow.addSelectionListener(a);
n.setVisible(true)
};
ZmSlideEditController.prototype._actionListener=function(e){
var t=e.item.getData(ZmSlideEditController._VALUE);
if(t==ZmSlideEditController.ACTION_INSERT_TEXTBOX){
this._currentView.insertTextBox()
}else{
if(t==ZmSlideEditController.ACTION_DELETE_TEXTBOX){
this._currentView.deleteTextBox()
}else{
if(t==ZmSlideEditController.ACTION_NEW_SLIDE){
this._currentView.createSlide()
}else{
if(t==ZmSlideEditController.ACTION_DELETE_SLIDE){
this._currentView.deleteSlide()
}else{
if(t==ZmSlideEditController.ACTION_RUN){
this._currentView.runSlideShow()
}else{
if(t==ZmSlideEditController.ACTION_SAVE){
this._currentView.saveFile()
}else{
if(t==ZmSlideEditController.ACTION_INSERT_IMG){
this._currentView.insertImage()
}else{
if(t==ZmSlideEditController.ACTION_INSERT_IMG1){
if(!this._insertObjectsCallback){
this._insertObjectsCallback=new AjxCallback(this,this._insertObjects)
}
this.__popupUploadDialog(this._insertObjectsCallback)
}}}}}}}}};
ZmSlideEditController.prototype.getRestUrl=function(){
var e="";
if(window.restPage){
e=location.href;
e=e.split("/");
e.pop();
e=e.join("/")
}else{
var t=window.opener.appCtxt;
var a=t.getById(window.fileInfo.folderId);
e=a.getRestUrl()
}
return e
};
ZmSlideEditController.prototype.__popupUploadDialog=function(o){
var e=this.getRestUrl();
var a={
id:window.fileInfo.folderId,restUrl:e};
var t=appCtxt.getUploadDialog();
t.addPopdownListener(new AjxListener(this,this.focus));
t.popup(a,o,ZmMsg.insertAttachment)
};
ZmSlideEditController.prototype._insertObjects=function(t,e){
this._currentView.insertFile(e)
};
ZmSlideEditController.prototype._imgListener=function(e){
var t=e.item.getData(ZmSlideEditController._VALUE);
if(t=="upload"){
if(!this._insertObjectsCallback){
this._insertObjectsCallback=new AjxCallback(this,this._insertObjects)
}
this.__popupUploadDialog(this._insertObjectsCallback)
}else{
this._currentView.insertImage()
}};
ZmSlideEditController.prototype._themeListener=function(e){
var t=e.item.getData(ZmSlideEditController._VALUE);
this._currentView.setTheme(t)
};
ZmSlideEditController.prototype.getKeyMapName=function(){
return"Global"
};
ZmSlideEditController.prototype.setStatusMsg=function(){
if(!this.statusView){
this.statusView=new ZmStatusView(appCtxt.getShell(),"ZmStatus",Dwt.ABSOLUTE_STYLE,ZmId.STATUS_VIEW)
}
params=Dwt.getParams(arguments,ZmStatusView.MSG_PARAMS);
params.transitions=ZmToast.DEFAULT_TRANSITIONS;
this.statusView.setStatusMsg(params)
};
ZmSlideEditController.prototype.getFileName=function(){
return this._fileName?this._fileName.getValue():null
};
ZmSlideEditController.prototype.setFileName=function(e){
if(this._fileName){
this._fileName.setValue(e)
}};
ZmSlideEditController.prototype.sendRequest=function(e){
e.noSession=true;
this._requestMgr.sendRequest(e)
};
ZmSlideEditController.prototype._kickPolling=function(e){};
ZmSlideEditController.prototype.exit=function(){
return this._currentView.checkForChanges()
};
window.onbeforeunload=function(){
return appCtxt.getAppController().exit()
}
}};
