
/* Copyright (C) 2005-2009 Zimbra Inc. http://www.zimbra.com/ */
/*
 * The contents of this file are subject to the Mozilla Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
 * License for the specific language governing rights and limitations
 * under the License.
 *
 * The Original Code is BrowserPlus (tm).
 *
 * The Initial Developer of the Original Code is Yahoo!.
 * Portions created by Yahoo! are Copyright (c) 2009 Yahoo! Inc.
 * All rights reserved.
 *
 * Contributor(s):
 */
BrowserPlus=(typeof BrowserPlus!="undefined"&&BrowserPlus)?BrowserPlus:(function(){
var p=false;
var n="__browserPlusPluginID";
var o="uninitialized";
var s=[];
var i="application/x-yahoo-browserplus_2";
var l,c,d,r,e;
return{
initWhenAvailable:function(y,b){
setTimeout(function(){
try{
navigator.plugins.refresh(false)
}
catch(w){}
BrowserPlus.init(y,function(v){
if(v.success){
b(v)
}else{
BrowserPlus.initWhenAvailable(y,b)
}}
)
}
,1000)
}
,clientSystemInfo:function(){
return h()
}
,listActiveServices:function(y){
if(y==null||y.constructor!=Function){
throw new Error("BrowserPlus.services() invoked without  required callback parameter.")
}
return m().EnumerateServices(y)
}
,getPlatformInfo:function(){
if(m()===null){
throw new Error("BrowserPlus.getPlatformInfo() invoked, but init() has not completed successfully.")
}
return m().Info()
}
,isServiceLoaded:function(b,y){
return((b!=undefined&&BrowserPlus.hasOwnProperty(b))&&(y==undefined||BrowserPlus[b].hasOwnProperty(y)))
}
,describeService:function(b,y){
if(y==null||y.constructor!=Function){
throw new Error("BrowserPlus.services() invoked without  required callback parameter")
}
if(m()===null){
throw new Error("BrowserPlus.describeService() invoked, but init() has not completed successfully.")
}
return m().DescribeService(b,y)
}
,isServiceActivated:function(b,y){
return m().DescribeService(b,(function(){
var w=y;
return function(v){
w(v.success)
}
}
)())
}
,isInitialized:function(){
return(o==="succeeded")
}
,require:function(b,w){
if(w==null||w.constructor!=Function){
throw new Error("BrowserPlus.require() invoked without required callback parameter")
}
var y=function(x){
if(x.success){
var q=[];
for(var v=0;
v<x.value.length;
v++){
if(x.value[v].fullDesc){
u({
value:x.value[v].fullDesc}
);
q.push({
service:x.value[v].service,version:x.value[v].version}
)
}else{
BrowserPlus.describeService({
service:x.value[v].service,version:x.value[v].version}
,u);
q=x.value
}}
x.value=q
}
w(x)
};
m().RequireService(b,y);
return true
}
,init:function(w,b){
if(h().browser=="Safari"){
navigator.plugins.refresh(false)
}
var q=null;
var x=null;
if(b==null){
x=w
}else{
q=w;
x=b
}
if(x==null||x.constructor!=Function){
throw new Error("BrowserPlus.init() invoked without  required callback parameter")
}
if(q===null){
q=new Object
}
if(typeof(q.locale)=="undefined"){
q.locale=h().locale
}
var y=true;
if(!q.supportLevel||q.supportLevel==="experimental"){
y=(h().supportLevel!=="unsupported")
}else{
if(q.supportLevel==="supported"){
y=(h().supportLevel==="supported")
}}
if(!y){
x({
success:false,error:"bp.unsupportedClient"}
);
return
}
if(o==="succeeded"){
x({
success:true}
);
return
}
if(o=="inprogress"){
s.push(x);
return
}
o="inprogress";
if(typeof(window.onunload)=="undefined"){
window.onunload=function(){}
}
var k=false;
if(g()&&m()!==null){
k=true
}
if(!k){
o="uninitialized";
x({
success:false,error:"bp.notInstalled"}
);
return
}else{
s.push(x);
var v=(function(){
var j=q;
return function(){
var W=function(D){
if(!D.success&&D.error==="bp.switchVersion"&&h().browser!=="Explorer"){
var S="application/x-yahoo-browserplus_";
S+=D.verboseError;
if(S!==i){
i=S;
setTimeout(function(){
try{
var M=document.getElementById(n);
if(M){
document.documentElement.removeChild(M.parentNode)
}
navigator.plugins.refresh(false)
}
catch(F){}
if(g()&&m()!==null){
setTimeout(function(){
m().Initialize(j,W)
}
,10)
}else{
W(D)
}}
,10);
return
}}
if(!D.success&&D.error==="bp.switchVersion"){
D={
success:false,error:"bp.notInstalled",verboseError:"BrowserPlus isn't installed, or couldn't be loaded"}
}
o=D.success?"succeeded":"uninitialized";
var B=s;
s=[];
for(var C=0;
C<B.length;
C++){
B[C](D)
}};
try{
m().Initialize(j,W)
}
catch(O){
var z=h();
var A={
success:false,error:"bp.notInstalled",verboseError:String(O)};
if(z.browser=="Explorer"){
A.error="bp.unsupportedClient"
}else{
if(z.browser=="Firefox"){
try{
navigator.plugins.refresh(true)
}
catch(T){}}}
W(A)
}}
}
)();
setTimeout(v,0)
}}
,_detectBrowser:function(){
return BrowserPlus.clientSystemInfo()
}};
function g(){
if(t()){
return a()
}else{
return f()
}}
function f(){
var y=navigator.mimeTypes[i];
if(typeof(y)!=="object"||typeof(y.enabledPlugin)!=="object"){
return false
}
var b=document.createElement("div");
b.style.visibility="hidden";
b.style.borderStyle="hidden";
b.style.width=0;
b.style.height=0;
b.style.border=0;
b.style.position="absolute";
b.style.top=0;
b.style.left=0;
b.innerHTML='<object type="'+i+'" id="'+n+'" name="'+n+'"></object>';
document.documentElement.appendChild(b);
p=true;
return true
}
function a(){
if(m()!=null){
return true
}
try{
var y=document.createElement("object");
y.id=n;
y.type=i;
y.style.display="none";
document.body.appendChild(y);
document.getElementById(n).Ping();
p=true;
return true
}
catch(w){
try{
document.body.removeChild(y)
}
catch(b){}}
return false
}
function m(){
if(p){
return document.getElementById(n)
}
return null
}
function t(){
return(h().browser=="Explorer")
}
function u(w){
w=w.value;
var k=w.name;
var y=w.versionString;
if(!BrowserPlus[k]){
BrowserPlus[k]={};
BrowserPlus[k].corelet=k;
BrowserPlus[k].version=y
}
if(!BrowserPlus[k][y]){
BrowserPlus[k][y]={};
BrowserPlus[k][y].corelet=k;
BrowserPlus[k][y].version=y
}
if(k=="core"){
BrowserPlus[k].version=y
}
if(w.functions){
for(var b=0;
b<w.functions.length;
b++){
var x=w.functions[b].name;
var v=(function(){
var q=x;
return function(z,j){
if(j==null||j.constructor!=Function){
throw new Error("BrowserPlus."+k+"."+q+"() invoked without  required callback parameter")
}
return m().ExecuteMethod(k,y,q,z,j)
}
}
)();
BrowserPlus[k][y][x]=v;
if(y==BrowserPlus[k].version){
BrowserPlus[k][x]=v
}}}}
function h(){
var q=[{
string:navigator.vendor,subString:"Apple",identity:"Safari"}
,{
string:navigator.vendor,subString:"Google",identity:"Chrome"}
,{
prop:window.opera,identity:"Opera"}
,{
string:navigator.userAgent,subString:"Firefox",identity:"Firefox"}
,{
string:navigator.userAgent,subString:"MSIE",identity:"Explorer",versionSearch:"MSIE"}
];
var x=[{
string:navigator.platform,subString:"Win",identity:"Windows"}
,{
string:navigator.platform,subString:"Mac",identity:"Mac"}
,{
string:navigator.platform,subString:"Linux",identity:"Linux"}
];
var v={
Mac:{
Firefox:"supported",Safari:"supported"}
,Windows:{
Explorer:{
"8":"supported","7":"supported","6":"experimental"}
,Safari:"supported",Firefox:"supported",Chrome:"supported"}};
var b;
function w(O){
for(var j=0;
j<O.length;
j++){
var z=O[j].string;
var T=O[j].prop;
b=O[j].versionSearch||O[j].identity;
if(z){
if(z.indexOf(O[j].subString)!=-1){
return O[j].identity
}}else{
if(T){
return O[j].identity
}}}
return null
}
function y(z){
var j=z.indexOf(b);
if(j==-1){
return null
}else{
return parseFloat(z.substring(j+b.length+1))
}}
function k(){
if(v[d]&&v[d][l]){
var j=v[d][l];
if(typeof j==="string"){
return j
}else{
if(j[c]){
return j[c]
}else{
return"unsupported"
}}}else{
return"unsupported"
}}
if(!l){
l=w(q)||"An unknown browser";
c=y(navigator.userAgent)||y(navigator.appVersion)||"an unknown version";
d=w(x)||"an unknown OS";
if(d==="Mac"&&navigator.userAgent.indexOf("Intel")==-1){
e="unsupported"
}else{
if(navigator.userAgent.indexOf("Firefox/2.0.0")!=-1){
e="unsupported"
}else{
e=k()
}}
r=navigator.languaextrage||navigator.browserLanguage||navigator.userLanguage||navigator.systemLanguage
}
return{
browser:l,version:c,os:d,locale:r,supportLevel:e}
}}
)();
if(typeof YAHOO=="undefined"||!YAHOO){
var YAHOO={}
}
if(typeof YAHOO.bp=="undefined"||!YAHOO.bp){
YAHOO.bp=BrowserPlus
};
