
/* Copyright (C) 2005-2009 Zimbra Inc. http://www.zimbra.com/ */
DwtComboBox=function(e){
if(arguments.length==0){
return
}
e=Dwt.getParams(arguments,DwtComboBox.PARAMS);
e.className=e.className||"DwtComboBox";
DwtComposite.call(this,e);
this.input=null;
this._button=null;
this._textToValue={};
this._valueToText={};
this._valueToItem={};
this._size=0;
this._hasMenuCallback=true;
this._menuItemListenerObj=new AjxListener(this,this._menuItemListener);
this._inputParams=e.inputParams;
this._createHtml()
};
DwtComboBox.PARAMS=["parent","inputParams","className","posStyle","dialog"];
DwtComboBox.prototype=new DwtComposite;
DwtComboBox.prototype.constructor=DwtComboBox;
DwtComboBox.prototype.toString=function(){
return"DwtComboBox"
};
DwtComboBox.prototype.TEMPLATE="dwt.Widgets#DwtComboBox";
DwtComboBox.prototype.getTabGroupMember=function(){
return this._tabGroup
};
DwtComboBox.prototype.addChangeListener=function(e){
this.addListener(DwtEvent.ONCHANGE,e)
};
DwtComboBox.prototype.removeChangeListener=function(e){
this.removeListener(DwtEvent.ONCHANGE,e)
};
DwtComboBox.prototype.add=function(i,t,e){
this._textToValue[i]=t;
this._valueToText[t]=i;
if(!this._hasMenuCallback){
var a=this._button.getMenu();
this._createMenuItem(a,i)
}
if(e){
this.setText(i)
}
this._size++;
this._updateButton()
};
DwtComboBox.prototype.remove=function(t){
var e=this._valueToItem[t];
if(e){
this._button.getMenu().removeChild(e);
var a=this._valueToText[t];
delete this._textToValue[a];
delete this._valueToText[t];
delete this._valueToItem[t];
if(this.getText()==a){
this.setText("")
}
this._size--;
this._updateButton()
}};
DwtComboBox.prototype.removeAll=function(){
this._button.setMenu(new AjxCallback(this,this._createMenu),true);
this._hasMenuCallback=true;
this._textToValue={};
this._valueToText={};
this._valueToItem={};
this._size=0;
this._updateButton()
};
DwtComboBox.prototype.getValue=function(){
var e=this.getText();
return this._textToValue[e]
};
DwtComboBox.prototype.setValue=function(e){
var t=this._valueToText[e];
this.setText(t||e)
};
DwtComboBox.prototype.getText=function(){
return this.input.getValue()
};
DwtComboBox.prototype.setText=function(e){
this.input.setValue(e)
};
DwtComboBox.prototype.setEnabled=function(e){
if(e!=this._enabled){
DwtComposite.prototype.setEnabled.call(this,e);
this.input.setEnabled(e);
this._button.setEnabled(e)
}};
DwtComboBox.prototype.focus=function(){
this.input.focus()
};
DwtComboBox.prototype._createMenu=function(){
var o=new DwtMenu({
parent:this}
);
for(var e in this._textToValue){
var t=this._createMenuItem(o,e);
var a=this._textToValue[e];
this._valueToItem[a]=t
}
this._hasMenuCallback=false;
return o
};
DwtComboBox.prototype._createMenuItem=function(a,t){
var e=new DwtMenuItem({
parent:a}
);
e.setText(t);
e.addSelectionListener(this._menuItemListenerObj);
if(!this._menuWidth){
this._menuWidth=this.getW()-10
}
e.getHtmlElement().style.minWidth=this._menuWidth;
return e
};
DwtComboBox.prototype._menuItemListener=function(i){
var t=i.dwtObj;
var o=this.input.getValue();
var n=t.getText();
this.input.setValue(n);
var a=DwtUiEvent.getEvent(i);
a._args={
selectObj:this,newValue:n,oldValue:o};
this.notifyListeners(DwtEvent.ONCHANGE,a);
var e=this.input.getInputElement();
e.focus();
e.select()
};
DwtComboBox.prototype._handleKeyDown=function(e){
this.__ovalue=this.input.getValue();
return true
};
DwtComboBox.prototype._handleKeyUp=function(t){
DwtInputField._keyUpHdlr(t);
var e=DwtUiEvent.getEvent(t);
e._args={
selectObj:this,newValue:this.input.getValue(),oldValue:this.__ovalue};
this.notifyListeners(DwtEvent.ONCHANGE,e);
return true
};
DwtComboBox.prototype._updateButton=function(){
this._button.setVisible(this._size>0)
};
DwtComboBox.prototype._createHtml=function(e){
var t={
id:this._htmlElId};
this._createHtmlFromTemplate(e||this.TEMPLATE,t)
};
DwtComboBox.prototype._createHtmlFromTemplate=function(t,a){
DwtComposite.prototype._createHtmlFromTemplate.call(this,t,a);
var e=this._inputParams||{};
e.parent=this;
e.size=e.size||40;
delete this._inputParams;
this.input=new DwtInputField(e);
this.input.replaceElement(a.id+"_input");
this.input.setHandler(DwtEvent.ONKEYDOWN,AjxCallback.simpleClosure(this._handleKeyDown,this));
this.input.setHandler(DwtEvent.ONKEYUP,AjxCallback.simpleClosure(this._handleKeyUp,this));
this._button=new DwtComboBoxButton({
parent:this}
);
this._button.setMenu(new AjxListener(this,this._createMenu),true);
this._button.replaceElement(a.id+"_button");
this._updateButton();
this._tabGroup=new DwtTabGroup(this._htmlElId);
this._tabGroup.addMember(this.input);
this._tabGroup.addMember(this._button)
};
DwtComboBox.prototype._replaceElementHook=function(t,a,e,i){
DwtComposite.prototype._replaceElementHook.apply(this,arguments);
if(t.size){
this.input.getInputElement().size=t.size
}
if(t.title){
this.input.setHint(t.title)
}};
DwtComboBoxButton=function(e){
e=Dwt.getParams(arguments,DwtComboBoxButton.PARAMS);
e.posStyle=Dwt.RELATIVE_STYLE;
DwtButton.call(this,e)
};
DwtComboBoxButton.prototype=new DwtButton;
DwtComboBoxButton.prototype.constructor=DwtComboBoxButton;
DwtComboBoxButton.prototype.toString=function(){
return"DwtComboBoxButton"
};
DwtComboBoxButton.PARAMS=["parent","className"];
DwtComboBoxButton.prototype.TEMPLATE="dwt.Widgets#DwtComboBoxButton";
