
/* Copyright (C) 2005-2009 Zimbra Inc. http://www.zimbra.com/ */
DwtConfirmDialog=function(t,e){
if(arguments.length==0){
return
}
var a=[DwtDialog.YES_BUTTON,DwtDialog.NO_BUTTON,DwtDialog.CANCEL_BUTTON];
DwtDialog.call(this,{
parent:t,className:e||"DwtConfirmDialog",title:AjxMsg.confirmTitle,standardButtons:a}
);
this._questionDiv=document.createElement("DIV");
this._questionDiv.className="DwtConfirmDialogQuestion";
this._getContentDiv().appendChild(this._questionDiv);
this.registerCallback(DwtDialog.YES_BUTTON,this._handleYesButton,this);
this.registerCallback(DwtDialog.NO_BUTTON,this._handleNoButton,this);
this.registerCallback(DwtDialog.CANCEL_BUTTON,this._handleCancelButton,this)
};
DwtConfirmDialog.prototype=new DwtDialog;
DwtConfirmDialog.prototype.constructor=DwtConfirmDialog;
DwtConfirmDialog.prototype.toString=function(){
return"DwtConfirmDialog"
};
DwtConfirmDialog.prototype.popup=function(a,e,i,t,o){
this._questionDiv.innerHTML=a||"";
this._yesCallback=e;
this._noCallback=i;
this._cancelCallback=t;
this.setButtonVisible(DwtDialog.CANCEL_BUTTON,Boolean(i));
DwtDialog.prototype.popup.call(this,o)
};
DwtConfirmDialog.prototype.popdown=function(){
this._yesCallback=this._noCallback=this._cancelCallback=null;
DwtDialog.prototype.popdown.call(this)
};
DwtConfirmDialog.prototype._handleYesButton=function(e){
if(this._yesCallback){
this._yesCallback.run(e)
}
this.popdown()
};
DwtConfirmDialog.prototype._handleNoButton=function(e){
if(this._noCallback){
this._noCallback.run(e)
}
this.popdown()
};
DwtConfirmDialog.prototype._handleCancelButton=function(e){
if(this._cancelCallback){
this._cancelCallback.run(e)
}
this.popdown()
};
DwtConfirmDialog.prototype._getSeparatorTemplate=function(){
return""
};
