
/* Copyright (C) 2005-2009 Zimbra Inc. http://www.zimbra.com/ */
DwtLabel=function(e){
if(arguments.length==0){
return
}
e=Dwt.getParams(arguments,DwtLabel.PARAMS);
e.className=e.className||"DwtLabel";
DwtControl.call(this,e);
this._style=e.style||(DwtLabel.IMAGE_LEFT|DwtLabel.ALIGN_CENTER);
this._textBackground=null;
this._textForeground=null;
this._createHtml()
};
DwtLabel.PARAMS=["parent","style","className","posStyle","id","index"];
DwtLabel.prototype=new DwtControl;
DwtLabel.prototype.constructor=DwtLabel;
DwtLabel.prototype.toString=function(){
return"DwtLabel"
};
DwtLabel.IMAGE_LEFT=1;
DwtLabel.IMAGE_RIGHT=2;
DwtLabel.ALIGN_LEFT=4;
DwtLabel.ALIGN_RIGHT=8;
DwtLabel.ALIGN_CENTER=16;
DwtLabel._LAST_STYLE=16;
DwtLabel.prototype.TEMPLATE="dwt.Widgets#ZLabel";
DwtLabel.prototype.dispose=function(){
delete this._dropDownEl;
delete this._iconEl;
delete this._textEl;
DwtControl.prototype.dispose.call(this)
};
DwtLabel.prototype.setEnabled=function(e){
if(e!=this._enabled){
DwtControl.prototype.setEnabled.call(this,e);
this.__setImage(this.__imageInfo)
}};
DwtLabel.prototype.getImage=function(){
return this.__imageInfo
};
DwtLabel.prototype.setImage=function(e){
this.__imageInfo=e;
this.__setImage(e)
};
DwtLabel.prototype.setDisabledImage=function(e){};
DwtLabel.prototype.getText=function(){
return(this.__text!=null)?this.__text:null
};
DwtLabel.prototype.setText=function(e){
if(!this._textEl){
return
}
if(e==null||e==""){
this.__text=null;
this._textEl.innerHTML=""
}else{
this.__text=e;
this._textEl.innerHTML=e
}};
DwtLabel.prototype.setTextBackground=function(e){
this._textBackground=e;
if(this._textEl){
this._textEl.style.backgroundColor=e
}};
DwtLabel.prototype.setTextForeground=function(e){
this._textForeground=e;
if(this._textEl){
this._textEl.style.color=e
}};
DwtLabel.prototype.setAlign=function(e){
this._style=e;
this.__setImage(this.__imageInfo)
};
DwtLabel.prototype.isStyle=function(e){
return this._style&e
};
DwtLabel.prototype._createHtml=function(e){
var t={
id:this._htmlElId};
this._createHtmlFromTemplate(e||this.TEMPLATE,t)
};
DwtLabel.prototype._createHtmlFromTemplate=function(e,t){
DwtControl.prototype._createHtmlFromTemplate.call(this,e,t);
this._textEl=document.getElementById(t.id+"_title")
};
DwtLabel.prototype._getIconEl=function(){
var e=(this._style&DwtLabel.IMAGE_RIGHT?"right":"left");
return this._iconEl||(this._iconEl=document.getElementById(this._htmlElId+"_"+e+"_icon"))
};
DwtLabel.prototype.__setImage=function(t){
var e=this._getIconEl();
if(e){
if(t){
AjxImg.setImage(e,t,null,!this._enabled);
var a=(this._style&DwtLabel.IMAGE_RIGHT?"ZHasRightIcon":"ZHasLeftIcon");
Dwt.addClass(this.getHtmlElement(),a)
}else{
e.innerHTML=""
}}};
