
/* Copyright (C) 2005-2009 Zimbra Inc. http://www.zimbra.com/ */
DwtTree=function(a){
if(arguments.length==0){
return
}
a=Dwt.getParams(arguments,DwtTree.PARAMS);
a.className=a.className||"DwtTree";
DwtComposite.call(this,a);
var e=[DwtEvent.ONMOUSEDOWN,DwtEvent.ONMOUSEUP,DwtEvent.ONDBLCLICK];
if(!AjxEnv.isIE){
e=e.concat([DwtEvent.ONMOUSEOVER,DwtEvent.ONMOUSEOUT])
}
this._setEventHdlrs(e);
var t=a.style;
if(!t){
this._style=DwtTree.SINGLE_STYLE
}else{
if(t==DwtTree.CHECKEDITEM_STYLE){
t|=DwtTree.SINGLE_STYLE
}
this._style=t
}
this.isCheckedStyle=((this._style&DwtTree.CHECKEDITEM_STYLE)!=0);
this.isCheckedByDefault=a.isCheckedByDefault;
this._selectedItems=new AjxVector();
this._selEv=new DwtSelectionEvent(true)
};
DwtTree.PARAMS=["parent","style","className","posStyle"];
DwtTree.prototype=new DwtComposite;
DwtTree.prototype.constructor=DwtTree;
DwtTree.prototype.toString=function(){
return"DwtTree"
};
DwtTree.SINGLE_STYLE=1;
DwtTree.MULTI_STYLE=2;
DwtTree.CHECKEDITEM_STYLE=4;
DwtTree.ITEM_SELECTED=0;
DwtTree.ITEM_DESELECTED=1;
DwtTree.ITEM_CHECKED=2;
DwtTree.ITEM_ACTIONED=3;
DwtTree.ITEM_DBL_CLICKED=4;
DwtTree.ITEM_EXPANDED=1;
DwtTree.ITEM_COLLAPSED=2;
DwtTree.prototype.getStyle=function(){
return this._style
};
DwtTree.prototype.addSelectionListener=function(e){
this.addListener(DwtEvent.SELECTION,e)
};
DwtTree.prototype.addPreSelectionListener=function(e){
this.addListener(DwtEvent.PRE_SELECTION,e)
};
DwtTree.prototype.removeSelectionListener=function(e){
this.removeListener(DwtEvent.SELECTION,e)
};
DwtTree.prototype.addTreeListener=function(e){
this.addListener(DwtEvent.TREE,e)
};
DwtTree.prototype.removeTreeListener=function(e){
this.removeListener(DwtEvent.TREE,e)
};
DwtTree.prototype.getItemCount=function(){
return this.getItems().length
};
DwtTree.prototype.getItems=function(){
return this._children.getArray()
};
DwtTree.prototype.clearItems=function(){
var e=this.getItems();
for(var t=0;
t<e.length;
t++){
this.removeChild(e[t])
}
this._getContainerElement().innerHTML=""
};
DwtTree.prototype.deselectAll=function(){
var e=this._selectedItems.getArray();
var o=this._selectedItems.size();
for(var t=0;
t<o;
t++){
if(e[t]){
e[t]._setSelected(false)
}}
if(o>0){
this._notifyListeners(DwtEvent.SELECTION,this._selectedItems.getArray(),DwtTree.ITEM_DESELECTED,null,this._selEv)
}
this._selectedItems.removeAll()
};
DwtTree.prototype.getSelection=function(){
return this._selectedItems.getArray()
};
DwtTree.prototype.setSelection=function(n,r,c,e){
if(!n){
return
}
var l=this._selectedItems.getArray();
var h=this._selectedItems.size();
var d;
var t=0;
var s=false;
for(var o=0;
o<h;
o++){
if(l[o]==n){
s=true
}else{
l[o]._setSelected(false);
this._selectedItems.remove(l[o]);
if(d==null){
d=new Array()
}
d[t++]=l[o]
}}
if(d&&!r){
this._notifyListeners(DwtEvent.SELECTION,d,DwtTree.ITEM_DESELECTED,null,this._selEv,c)
}
if(s){
return
}
this._selectedItems.add(n);
this._expandUp(n);
if(n._setSelected(true,e)&&!r){
this._notifyListeners(DwtEvent.SELECTION,[n],DwtTree.ITEM_SELECTED,null,this._selEv,c)
}};
DwtTree.prototype.getSelectionCount=function(){
return this._selectedItems.size()
};
DwtTree.prototype.addChild=function(e){
if(e instanceof DwtTreeItem){
return
}
DwtComposite.prototype.addChild.apply(this,arguments)
};
DwtTree.prototype.addSeparator=function(){
var e=document.createElement("div");
e.className="vSpace";
this._getContainerElement().appendChild(e)
};
DwtTree.prototype._expandUp=function(t){
var e=t.parent;
while(e instanceof DwtTreeItem){
e.setExpanded(true);
e.setVisible(true);
e=e.parent
}};
DwtTree.prototype._addItem=function(t,e){
this._children.add(t,e);
var i=this._getContainerElement();
var a=i.childNodes.length;
if(e==null||e>a){
i.appendChild(t.getHtmlElement())
}else{
i.insertBefore(t.getHtmlElement(),i.childNodes[e])
}};
DwtTree.prototype._getContainerElement=DwtTree.prototype.getHtmlElement;
DwtTree.prototype.sort=function(a){
var t=this.getItems();
t.sort(a);
var e=document.createDocumentFragment();
AjxUtil.foreach(t,function(n,o){
e.appendChild(n.getHtmlElement());
n._index=o
}
);
this._getContainerElement().appendChild(e)
};
DwtTree.prototype.removeChild=function(t){
this._children.remove(t);
this._selectedItems.remove(t);
var e=t.getHtmlElement();
if(e.parentNode){
e.parentNode.removeChild(e)
}};
DwtTree.prototype._getNextTreeItem=function(n){
var a=this.getSelection();
var l=(a&&a.length)?a[0]:null;
var e=null,h=-1;
var r=this.getTreeItemList(true);
if(l){
for(var o=0,s=r.length;
o<s;
o++){
var t=r[o];
if(t==l){
h=n?o+1:o-1;
break
}}
e=r[h]
}else{
if(r&&r.length){
e=n?r[0]:r[r.length-1]
}}
return e
};
DwtTree.prototype.getTreeItemList=function(e){
return this._addToList([],e)
};
DwtTree.prototype._addToList=function(n,s,o){
if(o&&!o._isSeparator&&(!s||(o.getVisible()&&o._selectionEnabled))){
n.push(o)
}
if(!o||!s||o._expanded){
var a=o||this;
var t=a.getChildren?a.getChildren():[];
for(var e=0;
e<t.length;
e++){
this._addToList(n,s,t[e])
}}
return n
};
DwtTree.prototype._deselect=function(e){
if(this._selectedItems.contains(e)){
this._selectedItems.remove(e);
e._setSelected(false);
this._notifyListeners(DwtEvent.SELECTION,[e],DwtTree.ITEM_DESELECTED,null,this._selEv)
}};
DwtTree.prototype._itemActioned=function(t,e){
if(this._actionedItem){
this._actionedItem._setActioned(false);
this._notifyListeners(DwtEvent.SELECTION,[this._actionedItem],DwtTree.ITEM_DESELECTED,e,this._selEv)
}
this._actionedItem=t;
t._setActioned(true);
this._notifyListeners(DwtEvent.SELECTION,[t],DwtTree.ITEM_ACTIONED,e,this._selEv)
};
DwtTree.prototype._itemChecked=function(t,e){
this._notifyListeners(DwtEvent.SELECTION,[t],DwtTree.ITEM_CHECKED,e,this._selEv)
};
DwtTree.prototype._itemClicked=function(n,o){
var t;
var e=this._selectedItems.getArray();
var s=this._selectedItems.size();
if(this._style&DwtTree.SINGLE_STYLE||(!o.shiftKey&&!o.ctrlKey)){
var r=this._notifyListeners(DwtEvent.PRE_SELECTION,[n],DwtTree.ITEM_SELECTED,o,this._selEv);
if(r===false){
return
}
if(s>0){
for(t=0;
t<s;
t++){
e[t]._setSelected(false)
}
this._notifyListeners(DwtEvent.SELECTION,this._selectedItems.getArray(),DwtTree.ITEM_DESELECTED,o,this._selEv);
this._selectedItems.removeAll()
}
this._selectedItems.add(n);
if(n._setSelected(true)){
this._notifyListeners(DwtEvent.SELECTION,[n],DwtTree.ITEM_SELECTED,o,this._selEv)
}}else{
if(o.ctrlKey){
if(this._selectedItems.contains(n)){
this._selectedItems.remove(n);
n._setSelected(false);
this._notifyListeners(DwtEvent.SELECTION,[n],DwtTree.ITEM_DESELECTED,o,this._selEv)
}else{
this._selectedItems.add(n);
if(n._setSelected(true)){
this._notifyListeners(DwtEvent.SELECTION,[n],DwtTree.ITEM_SELECTED,o,this._selEv)
}}}else{}}};
DwtTree.prototype._itemDblClicked=function(t,e){
this._notifyListeners(DwtEvent.SELECTION,[t],DwtTree.ITEM_DBL_CLICKED,e,this._selEv)
};
DwtTree.prototype._itemExpanded=function(a,t,e){
if(!e){
this._notifyListeners(DwtEvent.TREE,[a],DwtTree.ITEM_EXPANDED,t,DwtShell.treeEvent)
}};
DwtTree.prototype._itemCollapsed=function(l,s,n){
var o;
if(!n){
this._notifyListeners(DwtEvent.TREE,[l],DwtTree.ITEM_COLLAPSED,s,DwtShell.treeEvent)
}
var h=false;
var r=this._selectedItems.getArray();
var e=this._selectedItems.size();
var c;
var t=0;
for(o=0;
o<e;
o++){
if(r[o]._isChildOf(l)){
h=true;
if(c==null){
c=new Array()
}
c[t++]=r[o];
r[o]._setSelected(false);
this._selectedItems.remove(r[o])
}}
if(c){
this._notifyListeners(DwtEvent.SELECTION,c,DwtTree.ITEM_DESELECTED,s,this._selEv)
}
if(h&&!this._selectedItems.contains(l)){
this._selectedItems.add(l);
if(l._setSelected(true)){
this._notifyListeners(DwtEvent.SELECTION,[l],DwtTree.ITEM_SELECTED,s,this._selEv)
}}};
DwtTree.prototype._notifyListeners=function(n,e,i,a,t,o){
if(this.isListenerRegistered(n)){
if(a){
DwtUiEvent.copy(t,a)
}
t.items=e;
if(e.length==1){
t.item=e[0]
}
t.detail=i;
t.kbNavEvent=o;
var s=this.notifyListeners(n,t);
if(n==DwtEvent.SELECTION){
this.shell.notifyGlobalSelection(t)
}
return s
}};
