
/* Copyright (C) 2005-2009 Zimbra Inc. http://www.zimbra.com/ */
ButtonGrid=function(e){
XFG.assignUniqueId(this,"__BUTTON_GRID__");
for(var t in e){
this[t]=e[t]
}
if(this.onChange){
this.setOnChange(this.onChange)
}
this.value=[]
};
var BGP=ButtonGrid.prototype;
BGP.choices=null;
BGP.numCols=4;
BGP.cssClass="xform_button_grid_medium";
BGP.onChange=null;
BGP.multiple=true;
BGP.addBracketingCells=false;
BGP.setOnChange=function(e){
if(e&&typeof e=="string"){
e=new Function("value, event",e)
}
this.onChange=e
};
BGP.getValue=function(){
return this.value
};
BGP.setValue=function(e){
if(e==null){
e=[]
}
if(typeof e=="string"){
e=e.split(",")
}
this.value=e;
this.showValue()
};
BGP.showValue=function(){
var n=this.value;
if(n==null){
n=""
}
if(typeof n=="string"){
n=n.split(",")
}
var o="{|[",s="]|}";
n=o+n.join(s+o)+s;
var r=this.choices;
for(var a=0;
a<r.length;
a++){
var t=XFG.getEl(this.getButtonId(a));
var e=(n.indexOf(o+r[a].value+s)>-1);
if(e){
XFG.showSelected(t)
}else{
XFG.hideSelected(t)
}}};
BGP.toggleValue=function(t,e){
if(this.multiple){
if(this.valueIsSelected(t)){
this.deselectValue(t,e)
}else{
this.selectValue(t,e)
}}else{
this.value=t
}
return this.value
};
BGP.valueIsSelected=function(t){
for(var e=0;
e<this.value.length;
e++){
if(this.value[e]==t){
return true
}}};
BGP.selectValue=function(t,e){
if(!this.valueIsSelected(t)){
this.value.push(t)
}
if(e){
XFG.showSelected(e)
}};
BGP.deselectValue=function(a,t){
if(this.valueIsSelected(a)){
for(var e=0;
e<this.value.length;
e++){
if(this.value[e]==a){
this.value=this.value.slice(0,e).concat(this.value.slice(e+1,this.value.length))
}}}
if(t){
XFG.hideSelected(t)
}};
BGP.getButtonId=function(e){
return this.__id+"_button_"+e
};
BGP.onButtonClick=function(i,e,t){
var a=this.toggleValue(i,e);
if(this.onChange){
this.onChange(a,t)
}};
BGP.getHTML=function(){
if(this.choices==null){
return(this.__HTMLOutput=null)
}
var e=new AjxBuffer();
var o=this.cssClass+"_button";
e.append('<table class="',this.cssClass,'_table">');
var a=0;
var s=Math.ceil(this.choices.length/this.numCols);
for(var n=0;
n<s;
n++){
e.append("<tr>\r");
if(this.addBracketingCells){
e.append("\t<td width=50%><div class=",this.cssClass+"_start></div></td>")
}
for(var h=0;
h<this.numCols;
h++){
var t=this.choices[a];
if(typeof t=="string"){
t=this.choices[a]={
value:t,label:t}
}
e.append("<td class=",this.cssClass+"_td ><div id=",this.getButtonId(a)," class=",o," onclick=\"XFG.cacheGet('",this.__id,"').onButtonClick('",t.value,"',this,event);\">",t.label,"</div></td>");
a++;
if(a>=this.choices.length){
break
}}
if(this.addBracketingCells){
e.append("<td width=50%><div class=",this.cssClass+"_end></div></td>")
}
e.append("</tr>")
}
e.append("</table>");
this.__HTMLOutput=e.toString();
return this.__HTMLOutput
};
BGP.insertIntoXForm=function(a,t,e){
e.innerHTML=this.getHTML()
};
BGP.updateChoicesHTML=function(n){
var t=0;
for(var a=0;
a<numRows;
a++){
for(var o=0;
o<this.numCols;
o++){
var e=document.getElementById(this.getButtonId(t));
if(e){
e.innerHTML=n[t].label
}
t++;
if(t>=n.length){
break
}}}};
BGP.updateInXForm=function(i,a,o,t){
var e=(o instanceof Array?o.join(","):o);
if(!i.forceUpdate&&this.__lastDisplayValue==e){
return
}
this.setValue(o);
this.__lastDisplayValue=e
};
