
/* Copyright (C) 2005-2009 Zimbra Inc. http://www.zimbra.com/ */
XModelItemFactory=function(){};
XModelItemFactory.createItem=function(t,e,o){
var a=t.type;
constructor=this.getItemTypeConstructor(a||_UNTYPED_);
var i=new constructor();
i._setAttributes(t);
if(i.id!=null&&i.ref==null){
i.ref=i.id
}
var n=this.getIdPath(t,e);
i.__idPath=n;
i.__xmodel=o;
i.__parentItem=e;
i.initModelItem();
o.indexItem(i,n);
return i
};
XModelItemFactory.getIdPath=function(t,e){
if(t.path){
return t.path
}
return this.getFullPath(t.id,(e?e.getIdPath():""))
};
XModelItemFactory.getFullPath=function(e,t){
if(e==null){
return null
}
if(t==null){
t=""
}
var a=e;
if(e=="."){
a=t
}else{
if(e==".."){
t=t.split("/");
a=t.slice(0,t.length-1).join("/")
}else{
if(t==""){
a=e
}else{
a=t+"/"+e
}}}
return a
};
XModelItemFactory.typeConstructorMap={};
XModelItemFactory.createItemType=function(i,e,a,t){
if(a==null){
a=new Function()
}
if(typeof t=="string"){
t=this.getItemTypeConstructor(t)
}
if(t==null){
t=XModelItem
}
a.prototype=new t();
a.prototype.type=e;
a.prototype.constructor=a;
a.prototype.toString=new Function("return '[XModelItem:"+e+" path=\"' + this.getIdPath() + '\"]'");
a.toString=new Function("return '[Class XModelItem:"+e+"]'");
this.registerItemType(i,e,a);
return a
};
XModelItemFactory.registerItemType=function(a,e,t){
window[a]=e;
this.typeConstructorMap[e]=t
};
XModelItemFactory.getItemTypeConstructor=function(e){
var t=this.typeConstructorMap[e];
if(t==null){
t=this.typeConstructorMap.string
}
return t
};
XModelItem=function(){};
XModelItemFactory.createItemType("_UNTYPED_","untyped",XModelItem,Object);
XModelItemFactory.registerItemType("_OBJECT_","object",XModelItem);
XModelItem.prototype.__isXModelItem=true;
XModelItem.prototype.getterScope=_INHERIT_;
XModelItem.prototype.setterScope=_INHERIT_;
XModelItem.prototype._setAttributes=function(e){
this._attributes=e;
for(var t in e){
this[t]=e[t]
}};
XModelItem.prototype.initModelItem=function(){
this._eventMgr=new AjxEventMgr()
};
XModelItem.prototype.initializeItems=function(){
var e=this.getItems();
if(e!=null){
this.items=this.getModel().initItemList(e,this)
}};
XModelItem.prototype.getModel=function(){
return this.__xmodel
};
XModelItem.prototype.getParentItem=function(){
return this.__parentItem
};
XModelItem.prototype.getIdPath=function(){
return this.__idPath
};
XModelItem.prototype.getItems=function(){
return this.items
};
XModelItem.prototype.addItem=function(e){
if(!e.__isXModelItem){
e=this.xmodel.initItem(e,this)
}
if(this.items==null){
this.items=[]
}
this.items.push(e)
};
XModelItem.prototype.getConstraints=function(){
return this.constraints
};
XModelItem.prototype.getRequired=function(){
return this.required
};
XModelItem.prototype.getReadonly=function(){
return this.readonly
};
XModelItem.prototype.getReadOnly=XModelItem.prototype.getReadonly;
XModelItem.prototype.getDefaultValue=function(){
return new Object()
};
XModel.registerErrorMessage("valueIsRequired",AjxMsg.valueIsRequired);
XModelItem.prototype.validate=function(n,a,o,e){
if(n==null||n===""){
if(this.getRequired()){
throw this.getModel().getErrorMessage("valueIsRequired",n)
}}else{
n=this.validateType(n)
}
var r=this.getConstraints();
if(r==null){
return n
}
if(!(AjxUtil.isInstance(r,Array))){
r=[r]
}
for(var t=0;
t<r.length;
t++){
var s=r[t];
if(s.type=="method"){
n=s.value.call(this,n,a,o,e)
}}
return n
};
XModelItem.prototype.getDefaultErrorMessage=function(){
return this.errorMessage
};
XModelItem.prototype.validateType=function(e){
return e
};
XModelItem.prototype.length=null;
XModelItem.prototype.minLength=null;
XModelItem.prototype.maxLength=null;
XModelItem.prototype.pattern=null;
XModelItem.prototype.enumeration=null;
XModelItem.prototype.whiteSpace=null;
XModelItem.prototype.getLength=function(){
return this.length
};
XModelItem.prototype.getMinLength=function(){
return this.minLength
};
XModelItem.prototype.getMaxLength=function(){
return this.maxLength
};
XModelItem.prototype.getPattern=function(){
if(this.pattern!=null&&this.pattern.checked==null){
if(AjxUtil.isString(this.pattern)){
this.pattern=[new RegExp(this.pattern)]
}else{
if(AjxUtil.isInstance(this.pattern,RegExp)){
this.pattern=[this.pattern]
}else{
if(AjxUtil.isArray(this.pattern)){
for(var e=0;
e<this.pattern.length;
e++){
var t=this.pattern[e];
if(AjxUtil.isString(t)){
this.pattern[e]=new RegExp(this.pattern[e])
}}}else{}}}
this.pattern.checked=true
}
return this.pattern
};
XModelItem.prototype.getEnumeration=function(){
return this.enumeration
};
XModelItem.prototype.getWhiteSpace=function(){
return this.whiteSpace
};
XModel.registerErrorMessage("notAString",AjxMsg.notAString);
XModel.registerErrorMessage("stringLenWrong",AjxMsg.stringLenWrong);
XModel.registerErrorMessage("stringTooShort",AjxMsg.stringTooShort);
XModel.registerErrorMessage("stringTooLong",AjxMsg.stringTooLong);
XModel.registerErrorMessage("stringMismatch",AjxMsg.stringMismatch);
XModelItem.prototype.validateString=function(i){
if(i==null){
return
}
if(!AjxUtil.isString(i)){
throw this.getModel().getErrorMessage("notAString",i)
}
i=this._normalizeAndValidate(i);
var a=this.getLength();
if(a!==null){
if(i.length!==a){
throw this.getModel().getErrorMessage("stringLenWrong",a)
}}else{
var e=this.getMaxLength();
if(e!==null&&i.length>e){
throw this.getModel().getErrorMessage("stringTooLong",e)
}
var t=this.getMinLength();
if(t!==null&&i.length<t){
throw this.getModel().getErrorMessage("stringTooShort",t)
}}
return i
};
XModel.registerErrorMessage("invalidEmailAddr",AjxMsg.invalidEmailAddr);
XModelItem.prototype.validateEmailAddress=function(i){
if(i==null){
return
}
if(!AjxUtil.isString(i)){
throw this.getModel().getErrorMessage("notAString",i)
}
i=this._normalizeAndValidate(i);
var a=this.getLength();
if(a!==null){
if(i.length!==a){
throw this.getModel().getErrorMessage("stringLenWrong",a)
}}else{
var e=this.getMaxLength();
if(e!==null&&i.length>e){
throw this.getModel().getErrorMessage("stringTooLong",e)
}
var t=this.getMinLength();
if(t!==null&&i.length<t){
throw this.getModel().getErrorMessage("stringTooShort",t)
}
var o=i.split("@");
if(!o||o[0]==null||o[0]==""){
throw this.getModel().getErrorMessage("invalidEmailAddr")
}else{
if(!AjxUtil.isValidEmailNonReg(i)){
throw this.getModel().getErrorMessage("invalidEmailAddr")
}}}
return i
};
XModelItem.prototype._normalizeAndValidate=function(n){
var s=this.getWhiteSpace();
if(s!==null){
if(s==="replace"||s==="collapse"){
n=n.replace(/[\t\r\n]/g," ")
}
if(s==="collapse"){
n=n.replace(/^\s+/,"").replace(/\s+$/,"").replace(/[ ]+/," ")
}}
var o=this.getPattern();
if(o!=null){
var e=false;
for(var t=0;
t<o.length;
t++){
if(o[t].test(n)){
e=true;
break
}}
if(!e){
throw this.getModel().getErrorMessage("stringMismatch",n)
}}
var a=this.getEnumeration();
if(a!==null){
var e=false;
for(var t=0;
t<a.length;
t++){
if(a[t]===n){
e=true;
break
}}
if(!e){
throw this.getModel().getErrorMessage("stringMismatch",n)
}}
return n
};
XModelItem.prototype.totalDigits=null;
XModelItem.prototype.fractionDigits=null;
XModelItem.prototype.maxInclusive=null;
XModelItem.prototype.maxExclusive=null;
XModelItem.prototype.minInclusive=null;
XModelItem.prototype.minExclusive=null;
XModelItem.prototype.getTotalDigits=function(){
return this.totalDigits
};
XModelItem.prototype.getFractionDigits=function(){
return this.fractionDigits
};
XModelItem.prototype.getMinInclusive=function(){
return this.minInclusive
};
XModelItem.prototype.getMinExclusive=function(){
return this.minExclusive
};
XModelItem.prototype.getMaxInclusive=function(){
return this.maxInclusive
};
XModelItem.prototype.getMaxExclusive=function(){
return this.maxExclusive
};
XModelItem.prototype.addListener=function(t,a,e){
return this._eventMgr.addListener(t,a,e)
};
XModelItem.prototype.removeListener=function(e,t){
return this._eventMgr.removeListener(e,t)
};
XModelItem.prototype.removeAllListeners=function(e){
return this._eventMgr.removeAll(e)
};
XModelItem.prototype.isListenerRegistered=function(e){
return this._eventMgr.isListenerRegistered(e)
};
XModelItem.prototype.notifyListeners=function(e,t){
return this._eventMgr.notifyListeners(e,t)
};
XModel.registerErrorMessage("notANumber",AjxMsg.notANumber);
XModel.registerErrorMessage("numberTotalExceeded",AjxMsg.numberTotalExceeded);
XModel.registerErrorMessage("numberFractionExceeded",AjxMsg.numberFractionExceeded);
XModel.registerErrorMessage("numberMoreThanMax",AjxMsg.numberMoreThanMax);
XModel.registerErrorMessage("numberMoreThanEqualMax",AjxMsg.numberMoreThanEqualMax);
XModel.registerErrorMessage("numberLessThanMin",AjxMsg.numberLessThanMin);
XModel.registerErrorMessage("numberLessThanEqualMin",AjxMsg.numberLessThanEqualMin);
XModelItem.prototype.validateNumber=function(o){
o=this._normalizeAndValidate(o);
var a=parseFloat(o);
if(isNaN(a)||!AjxUtil.FLOAT_RE.test(o)){
throw this.getModel().getErrorMessage("notANumber",o)
}
var r=this.getTotalDigits();
if(this.totalDigits!==null){
var n=Math.floor(a);
if(n.toString().length>r){
throw this.getModel().getErrorMessage("numberTotalExceeded",o,r)
}}
var l=this.getFractionDigits();
if(this.fractionDigits!==null){
var e=String(a-Math.floor(a));
if(e.indexOf(".")!=-1&&e.replace(/^\d*\./,"").length>l){
throw this.getModel().getErrorMessage("numberFractionExceeded",o,l)
}}
var t=this.getMaxInclusive();
if(t!==null&&a>t){
throw this.getModel().getErrorMessage("numberMoreThanMax",t)
}
var s=this.getMaxExclusive();
if(s!==null&&a>=s){
throw this.getModel().getErrorMessage("numberMoreThanEqualMax",s)
}
var h=this.getMinInclusive();
if(h!==null&&a<h){
throw this.getModel().getErrorMessage("numberLessThanMin",h)
}
var i=this.getMinExclusive();
if(i!==null&&a<=i){
throw this.getModel().getErrorMessage("numberLessThanEqualMin",i)
}
return a
};
XModel.registerErrorMessage("notAnInteger",AjxMsg.notAnInteger);
XModelItem.prototype.validateInt=function(t){
var e=this.validateNumber(t);
var a=parseInt(t);
if(a!=e){
throw this.getModel().getErrorMessage("notAnInteger",t)
}
return a
};
XModelItem.prototype.msecInOneDay=(1000*60*60*24);
XModel.registerErrorMessage("invalidDateString",AjxMsg.invalidDateString);
XModelItem.prototype.validateDate=function(o){
if(AjxUtil.isInstance(o,Date)){
return o
}
if(AjxUtil.isString(o)){
o=o.toLowerCase();
var t=new Date();
if(o.indexOf("/")>-1){
var i=o.split("/");
if(i.length==3){
var n=i[0];
var e=i[1];
var a=i[2];
if(n.length<=2&&e.length<=2&&a.length==4){
n=parseInt(XModel.removePreceedingZero(n));
e=parseInt(XModel.removePreceedingZero(e));
a=parseInt(XModel.removePreceedingZero(a));
if(!isNaN(n)&&!isNaN(e)&&!isNaN(a)){
n-=1;
t.setFullYear(a,n,e);
t.setHours(0,0,0,0);
return t
}}}}else{
t.setHours(0,0,0,0);
if(o==AjxMsg.today){
return t
}else{
if(o==AjxMsg.yesterday){
t.setTime(t.getTime()-this.msecInOneDay);
return t
}else{
if(o==AjxMsg.tomorrow){
t.setTime(t.getTime()+this.msecInOneDay);
return t
}}}}}
throw this.getModel().getErrorMessage("invalidDateString",o);
return o
};
XModel.removePreceedingZero=function(t){
var a=/^[0]*(.*)$/;
var e=t.match(a);
if(e!=null){
return e[1]
}else{
return t
}};
XModel.registerErrorMessage("invalidTimeString",AjxMsg.invalidTimeString);
XModelItem.prototype.validateTime=function(n){
if(AjxUtil.isNumber(n)){
return n
}
if(AjxUtil.isInstance(n,Date)){
return((n.getHours()*360)+(n.getMinutes()*60)+n.getSeconds())*1000
}
if(AjxUtil.isString(n)){
n=n.toLowerCase();
if(n.indexOf(":")>-1){
n=n.split(":");
var e=false;
var a=n[n.length-1];
e=(a.indexOf(I18nMsg.periodPm.toLowerCase())>-1);
var t=parseInt(n[0]);
var i=parseInt(n[1]);
var o=(n.length==3?parseInt(n[2]):0);
if(!isNaN(t)&&!isNaN(i)&&!isNaN(o)){
t-=1;
if(e&&t>11){
t+=12
}
return((t*360)+(i*60)+o)*1000
}}}
throw this.getModel().getErrorMessage("invalidTimeString",n)
};
XModel.registerErrorMessage("invalidDatetimeString",AjxMsg.invalidDatetimeString);
XModelItem.prototype.validateDateTime=function(t){
if(AjxUtil.isInstance(t,Date)){
return t
}
if(AjxUtil.isNumber(t)){
return t
}
if(AjxUtil.isString(t)){
var e=this.validateDate(t);
if(t.indexOf(":")>-1){
var a=t.split(" ")[1];
a=this.validateTimeString(a);
e.setTime(e.getTime()+a)
}
return e
}
throw this.getModel().getErrorMessage("invalidDatetimeString",t)
};
String_XModelItem=function(){};
XModelItemFactory.createItemType("_STRING_","string",String_XModelItem);
String_XModelItem.prototype.validateType=XModelItem.prototype.validateString;
String_XModelItem.prototype.getDefaultValue=function(){
return""
};
Number_XModelItem=function(){};
XModelItemFactory.createItemType("_NUMBER_","number",Number_XModelItem);
Number_XModelItem.prototype.validateType=XModelItem.prototype.validateNumber;
Number_XModelItem.prototype.getDefaultValue=function(){
return 0
};
Integer_XModelItem=function(){};
XModelItemFactory.createItemType("_INT_","int",Integer_XModelItem);
Integer_XModelItem.prototype.validateType=XModelItem.prototype.validateInt;
Integer_XModelItem.prototype.getDefaultValue=function(){
return 0
};
Date_XModelItem=function(){};
XModelItemFactory.createItemType("_DATE_","date",Date_XModelItem);
Date_XModelItem.prototype.validateType=XModelItem.prototype.validateDate;
Date_XModelItem.prototype.getDefaultValue=function(){
return new Date()
};
Time_XModelItem=function(){};
XModelItemFactory.createItemType("_TIME_","time",Time_XModelItem);
Time_XModelItem.prototype.validateType=XModelItem.prototype.validateTime;
Time_XModelItem.prototype.getDefaultValue=function(){
return new Date()
};
Datetime_XModelItem=function(){};
XModelItemFactory.createItemType("_DATETIME_","datetime",Datetime_XModelItem);
Datetime_XModelItem.prototype.validateType=XModelItem.prototype.validateDateTime;
Datetime_XModelItem.prototype.getDefaultValue=function(){
return new Date()
};
List_XModelItem=function(){};
XModelItemFactory.createItemType("_LIST_","list",List_XModelItem);
List_XModelItem.prototype.getDefaultValue=function(){
return new Array()
};
List_XModelItem.prototype.outputType=_STRING_;
List_XModelItem.prototype.itemDelimiter=",";
List_XModelItem.prototype.listItem={
type:_UNTYPED_};
List_XModelItem.prototype.getOutputType=function(){
return this.outputType
};
List_XModelItem.prototype.getItemDelimiter=function(){
return this.itemDelimiter
};
List_XModelItem.prototype.getListItem=function(){
return this.listItem
};
List_XModelItem.prototype.initializeItems=function(){
var e=this.listItem;
e.ref=e.id="#";
this.listItem=XModelItemFactory.createItem(e,this,this.getModel());
this.listItem.initializeItems()
};
List_XModelItem.prototype.validateType=function(e){
return e
};
Enum_XModelItem=function(){
XModel.registerErrorMessage("didNotMatchChoice",AjxMsg.didNotMatchChoice)
};
XModelItemFactory.createItemType("_ENUM_","enum",Enum_XModelItem);
Enum_XModelItem.prototype.getDefaultValue=function(){
return this.getChoices()[0]
};
Enum_XModelItem.prototype.getChoices=function(){
if(typeof this.choices=="function"){
this.choices=this.choices.call(this)
}
return this.choices
};
Enum_XModelItem.prototype.getSelection=function(){
return this.selection
};
Enum_XModelItem.prototype.validateType=function(a){
var o=this.getSelection()==_OPEN_;
if(o){
return a
}
var n=this.getChoices();
for(var t=0;
t<n.length;
t++){
var e=n[t];
if(AjxUtil.isInstance(e,Object)){
if(e.value==a){
return a
}}else{
if(e==a){
return a
}}}
throw this.getModel().getErrorMessage("didNotMatchChoice",a)
};
FileSize_XModelItem=function(){};
XModelItemFactory.createItemType("_FILE_SIZE_","file_size",FileSize_XModelItem);
FileSize_XModelItem.prototype.validateType=XModelItem.prototype.validateNumber;
FileSize_XModelItem.prototype.getterScope=_MODELITEM_;
FileSize_XModelItem.prototype.setterScope=_MODELITEM_;
FileSize_XModelItem.prototype.getter="getValue";
FileSize_XModelItem.prototype.setter="setValue";
FileSize_XModelItem.prototype.units=AjxUtil.SIZE_MEGABYTES;
FileSize_XModelItem.prototype.minInclusive=0;
FileSize_XModelItem.prototype.maxInclusive=922337203685477;
FileSize_XModelItem.prototype.maxLength=15;
FileSize_XModelItem.prototype.getValue=function(ins,current,ref){
var value=eval("ins."+ref);
return value?AjxUtil.formatSizeForUnits(value,AjxUtil.SIZE_KILOBYTES,false,2):1
};
FileSize_XModelItem.prototype.setValue=function(val,ins,current,ref){
var value=eval("ins."+ref+" = AjxUtil.parseSize(val, this.units)");
return isNaN(value)?1:value
};
HostNameOrIp_XModelItem=function(){};
XModelItemFactory.createItemType("_HOSTNAME_OR_IP_","hostname_or_ip",HostNameOrIp_XModelItem);
HostNameOrIp_XModelItem.prototype.validateType=XModelItem.prototype.validateString;
HostNameOrIp_XModelItem.prototype.maxLength=256;
HostNameOrIp_XModelItem.prototype.pattern=[AjxUtil.HOST_NAME_RE,AjxUtil.IP_ADDRESS_RE,AjxUtil.IP_ADDRESS_WITH_PORT_RE,AjxUtil.HOST_NAME_WITH_PORT_RE];
ShortURL_XModelItem=function(){};
XModelItemFactory.createItemType("_SHORT_URL_","short_url",ShortURL_XModelItem);
ShortURL_XModelItem.prototype.validateType=XModelItem.prototype.validateString;
ShortURL_XModelItem.prototype.maxLength=256;
ShortURL_XModelItem.prototype.pattern=[AjxUtil.SHORT_URL_RE,AjxUtil.IP_SHORT_URL_RE];
Port_XModelItem=function(){};
XModelItemFactory.createItemType("_PORT_","port",Port_XModelItem);
Port_XModelItem.prototype.validateType=XModelItem.prototype.validateNumber;
Port_XModelItem.prototype.minInclusive=0;
Port_XModelItem.prototype.maxInclusive=65535;
Percent_XModelItem=function(){};
XModelItemFactory.createItemType("_PERCENT_","percent",Percent_XModelItem);
Percent_XModelItem.prototype.validateType=XModelItem.prototype.validateNumber;
Percent_XModelItem.prototype.minInclusive=0;
Percent_XModelItem.prototype.maxInclusive=100;
EmailAddress_XModelItem=function(){};
XModelItemFactory.createItemType("_EMAIL_ADDRESS_","email_address",EmailAddress_XModelItem);
EmailAddress_XModelItem.prototype.validateType=XModelItem.prototype.validateEmailAddress;
EmailAddress_XModelItem.prototype.maxLength=256;
