
/* Copyright (C) 2005-2009 Zimbra Inc. http://www.zimbra.com/ */
AjxPost=function(e){
this._callback=null;
this._iframeId=e
};
AjxPost._reqIds=0;
AjxPost._outStandingRequests=new Object();
AjxPost.SC_CONTINUE=100;
AjxPost.SC_OK=200;
AjxPost.SC_ACCEPTED=202;
AjxPost.SC_NO_CONTENT=204;
AjxPost.SC_BAD_REQUEST=400;
AjxPost.SC_UNAUTHORIZED=401;
AjxPost.SC_REQUEST_TIMEOUT=408;
AjxPost.SC_CONFLICT=409;
AjxPost.SC_REQUEST_ENTITY_TOO_LARGE=413;
AjxPost.SC_INTERNAL_SERVER_ERROR=500;
AjxPost.SC_BAD_GATEWAY=502;
AjxPost.SC_SERVICE_UNAVAILABLE=503;
AjxPost.prototype.execute=function(l,e,h){
var c=e.getElementsByTagName("input");
var o=new Array();
for(var a=0;
a<c.length;
a++){
var d=c[a];
if(d.type=="file"){
o.push(d);
continue
}
if(d.name&&d.name.match(/^filename\d+$/)){
d.parentNode.removeChild(d);
a--;
continue
}}
this._addHiddenFileNames(o);
e.target=this._iframeId;
this._callback=l;
var r=new AjxPostRequest(e);
var t=new AjxTimedAction(this,this._onFailure,[r.id]);
var s=h?h:5000;
AjxPost._outStandingRequests[r.id]=r;
try{
r.send(t,s)
}
catch(n){
if(AjxEnv.isIE){
if(n.number==-2147024891){
throw new AjxException(ZmMsg.uploadErrorAccessDenied,n.number)
}}
throw n
}};
AjxPost.prototype._addHiddenFileNames=function(t){
var e=0;
for(var o=0;
o<t.length;
o++){
var s=t[o];
if(s.files&&s.files.length>1){
var n=s.files,h=[];
for(var a=0;
a<n.length;
a++){
var r=n[a];
h.push(r.name||r.fileName)
}
this._addHiddenFileName(t[o],h.join("\n"),++e)
}else{
this._addHiddenFileName(t[o],t[o].value,++e)
}}};
AjxPost.prototype._addHiddenFileName=function(e,i,t){
var a=document.createElement("input");
a.type="hidden";
a.name="filename"+(t);
a.value=i;
e.parentNode.insertBefore(a,e)
};
AjxPost.prototype._onFailure=function(t){
var e=AjxPost._outStandingRequests[t];
e.cancel();
delete AjxPost._outStandingRequests[t];
if(this._callback){
this._callback.run([404]);
this._callback=null
}};
AjxPost.prototype.loaded=function(e,a,i){
var t=AjxPost._outStandingRequests[a];
if(t&&!t.hasBeenCancelled()){
t.cancelTimeout()
}
delete AjxPost._outStandingRequests[a];
if(this._callback){
this._callback.run(e,i);
this._callback=null
}};
AjxPostRequest=function(t){
this.id=AjxPost._reqIds++;
this._cancelled=false;
this._form=t;
var e=t.elements.namedItem("requestId");
if(!e){
e=t.ownerDocument.createElement("input");
e.type="hidden";
e.name="requestId"
}
e.value=this.id;
t.appendChild(e)
};
AjxPostRequest.prototype.send=function(t,e){
this._form.submit()
};
AjxPostRequest.prototype.hasBeenCancelled=function(){
return this._cancelled
};
AjxPostRequest.prototype.cancelTimeout=function(){
AjxTimedAction.cancelAction(this._timeoutId)
};
AjxPostRequest.prototype.cancel=function(){
this._cancelled=true
};
