
/* Copyright (C) 2005-2009 Zimbra Inc. http://www.zimbra.com/ */
AjxSoapDoc=function(){
this._soapURI=AjxSoapDoc._SOAP_URI
};
AjxSoapDoc.prototype.toString=function(){
return"AjxSoapDoc"
};
AjxSoapDoc._SOAP_URI="http://www.w3.org/2003/05/soap-envelope";
AjxSoapDoc._XMLNS_URI="http://www.w3.org/2000/xmlns";
AjxSoapDoc.create=function(e,a,r,s){
var n=new AjxSoapDoc();
n._xmlDoc=AjxXmlDoc.create();
var o=n._xmlDoc.getDoc();
if(!s){
s=AjxSoapDoc._SOAP_URI
}
n._soapURI=s;
var t=o.createElementNS&&!AjxEnv.isSafari;
var i=t?o.createElementNS(s,"soap:Envelope"):o.createElement("soap:Envelope");
if(!t){
i.setAttribute("xmlns:soap",s)
}
o.appendChild(i);
var h=t?o.createElementNS(s,"soap:Body"):o.createElement("soap:Body");
i.appendChild(h);
n._methodEl=a&&t?o.createElementNS(a,e):o.createElement(e);
if(a!=null&&!t){
if(r==null){
n._methodEl.setAttribute("xmlns",a)
}else{
n._methodEl.setAttribute("xmlns:"+r,a)
}}
h.appendChild(n._methodEl);
return n
};
AjxSoapDoc.createFromDom=function(t){
var e=new AjxSoapDoc();
e._xmlDoc=AjxXmlDoc.createFromDom(t);
e._methodEl=e._check(e._xmlDoc);
return e
};
AjxSoapDoc.createFromXml=function(e){
var t=new AjxSoapDoc();
t._xmlDoc=AjxXmlDoc.createFromXml(e);
t._methodEl=t._check(t._xmlDoc);
return t
};
AjxSoapDoc.element2FaultObj=function(t){
var e=t.firstChild;
if(!AjxEnv.isSafari){
if(e!=null&&e.namespaceURI!=AjxSoapDoc._SOAP_URI||e.nodeName!=(t.prefix+":Fault")){
return null
}}else{
if(e!=null&&e.nodeName!=(t.prefix+":Fault")){
return null
}}
return new AjxSoapFault(e)
};
AjxSoapDoc.prototype.setMethodAttribute=function(e,t){
this._methodEl.setAttribute(e,t)
};
AjxSoapDoc.prototype.set=function(t,l,c,n){
var h=this.getDoc();
var e=h.createElementNS&&!AjxEnv.isSafari;
var a=t?(n&&e?h.createElementNS(n,t):h.createElement(t)):h.createDocumentFragment();
if((n!==undefined)&&(n!==null)&&!e){
a.setAttribute("xmlns",n)
}
if(l!=null){
if(typeof l=="object"){
for(var r in l){
var o=l[r];
if(r.charAt(0)=="!"){
a.setAttribute(r.substr(1),o)
}else{
if(o instanceof Array){
for(var s=0;
s<o.length;
++s){
this.set(r,o[s],a)
}}else{
this.set(r,o,a)
}}}}else{
a.appendChild(h.createTextNode(l))
}}
if(!c){
c=this._methodEl
}
return c.appendChild(a)
};
AjxSoapDoc.prototype.getMethod=function(){
return this._methodEl
};
AjxSoapDoc.prototype.createHeaderElement=function(){
var a=this._xmlDoc.getDoc();
var t=a.firstChild;
var i=this.getHeader();
if(i!=null){
throw new AjxSoapException("SOAP header already exists",AjxSoapException.ELEMENT_EXISTS,"AjxSoapDoc.prototype.createHeaderElement")
}
var e=a.createElementNS&&!AjxEnv.isSafari;
i=e?a.createElementNS(this._soapURI,"soap:Header"):a.createElement("soap:Header");
t.insertBefore(i,t.firstChild);
return i
};
AjxSoapDoc.prototype.getHeader=function(){
var t=this._xmlDoc.getDoc();
var e=AjxEnv.isIE?(t.getElementsByTagName(t.firstChild.prefix+":Header")):(t.getElementsByTagNameNS(this._soapURI,"Header"));
return e?e[0]:null
};
AjxSoapDoc.prototype.getBody=function(){
var t=this._xmlDoc.getDoc();
var e=AjxEnv.isIE?(t.getElementsByTagName(t.firstChild.prefix+":Body")):(t.getElementsByTagNameNS(this._soapURI,"Body"));
return e?e[0]:null
};
AjxSoapDoc.prototype.getByTagName=function(t){
if(t.indexOf(":")==-1){
t="soap:"+t
}
var e=this.getDoc().getElementsByTagName(t);
if(e.length==1){
return e[0]
}else{
if(e.length>0){
return e
}else{
return null
}}};
AjxSoapDoc.prototype.ensureHeader=function(){
return(this.getHeader()||this.createHeaderElement())
};
AjxSoapDoc.prototype.getDoc=function(){
return this._xmlDoc.getDoc()
};
AjxSoapDoc.prototype.adoptNode=function(t){
if(AjxEnv.isFirefox3up||!AjxEnv.isFirefox){
try{
var a=this.getDoc();
if(a.adoptNode){
return a.adoptNode(t,true)
}}
catch(e){}}
return t.parentNode.removeChild(t)
};
AjxSoapDoc.prototype.getXml=function(){
return AjxEnv.isSafari||AjxEnv.isOpera?(AjxXmlDoc.getXml(this._xmlDoc.getDoc())):AjxXmlDoc.replaceInvalidChars(this._xmlDoc.getDoc().xml)
};
AjxSoapDoc.prototype._check=function(t){
var a=t.getDoc();
if(a.childNodes.length!=1){
throw new AjxSoapException("Invalid SOAP PDU",AjxSoapException.INVALID_PDU,"AjxSoapDoc.createFromXml:1")
}
var e=a.firstChild;
if(!AjxEnv.isSafari){
if(e.namespaceURI!=AjxSoapDoc._SOAP_URI||e.nodeName!=(e.prefix+":Envelope")||(e.childNodes.length<1||e.childNodes.length>2)){
throw new AjxSoapException("Invalid SOAP PDU",AjxSoapException.INVALID_PDU,"AjxSoapDoc.createFromXml:2")
}}else{
if(e.nodeName!=(e.prefix+":Envelope")){
throw new AjxSoapException("Invalid SOAP PDU",AjxSoapException.INVALID_PDU,"AjxSoapDoc.createFromXml:2")
}}};
