
/* Copyright (C) 2005-2009 Zimbra Inc. http://www.zimbra.com/ */
AjxHistoryMgr=function(){
this.currentLocation=null;
this.listener=null;
this.iframe=null;
this.ignoreLocationChange=null;
this.WAIT_TIME=AjxEnv.isIE?400:200;
this.currentWaitTime=0;
this.ieAtomicLocationChange=null;
this._eventMgr=new AjxEventMgr();
this._evt=new AjxEvent();
this._initialize()
};
AjxHistoryMgr.BLANK_FILE="blankHistory.html";
AjxHistoryMgr.IFRAME_ID="DhtmlHistoryFrame";
AjxHistoryMgr.LOCATION_CHECK_INTERVAL=100;
AjxHistoryMgr.prototype.addListener=function(e){
return this._eventMgr.addListener(AjxEvent.HISTORY,e)
};
AjxHistoryMgr.prototype.removeListener=function(e){
return this._eventMgr.removeListener(AjxEvent.HISTORY,e)
};
AjxHistoryMgr.prototype.add=function(a){
var e=this;
var t=function(){
if(e.currentWaitTime>0){
e.currentWaitTime=e.currentWaitTime-e.WAIT_TIME
}
a=e._removeHash(a);
if(AjxEnv.isIE){
if(document.getElementById(a)){
throw new DwtException("AjxHistoryMgr: location has same ID as DOM element")
}}
e.ignoreLocationChange=true;
this.ieAtomicLocationChange=true;
e.currentLocation=a;
window.location.hash=a;
if(AjxEnv.isIE){
e.iframe.src=AjxHistoryMgr.BLANK_FILE+"?"+a
}
this.ieAtomicLocationChange=false
};
window.setTimeout(t,this.currentWaitTime);
this.currentWaitTime=this.currentWaitTime+e.WAIT_TIME
};
AjxHistoryMgr.prototype.getCurrentLocation=function(){
return this._removeHash(window.location.hash)
};
AjxHistoryMgr.prototype._initialize=function(){
var e=this.getCurrentLocation();
this.currentLocation=e;
if(AjxEnv.isIE){
var n=[];
var o=0;
n[o++]="<iframe style='border: 0px; width: 1px; ";
n[o++]="height: 1px; position: absolute; bottom: 0px; ";
n[o++]="right: 0px; visibility: visible;' ";
n[o++]="id='"+AjxHistoryMgr.IFRAME_ID+"' ";
n[o++]="src='"+AjxHistoryMgr.BLANK_FILE+"?"+e+"'>";
n[o++]="</iframe>";
var s=document.createElement("div");
document.body.appendChild(s);
s.innerHTML=n.join("")
}
if(AjxEnv.isIE){
this.iframe=document.getElementById(AjxHistoryMgr.IFRAME_ID)
}
var t=this;
var a=function(){
t._checkLocation()
};
setInterval(a,AjxHistoryMgr.LOCATION_CHECK_INTERVAL)
};
AjxHistoryMgr.prototype._checkLocation=function(){
if(!AjxEnv.isIE&&this.ignoreLocationChange){
this.ignoreLocationChange=false;
return
}
if(!AjxEnv.isIE&&this.ieAtomicLocationChange){
return
}
var e=this.getCurrentLocation();
if(e==this.currentLocation){
return
}
this.ieAtomicLocationChange=true;
if(AjxEnv.isIE&&this._getIFrameHash()!=e){
this.iframe.src=AjxHistoryMgr.BLANK_FILE+"?"+e
}else{
if(AjxEnv.isIE){
return
}}
this.currentLocation=e;
this.ieAtomicLocationChange=false;
this._evt.data=e;
this._eventMgr.notifyListeners(AjxEvent.HISTORY,this._evt)
};
AjxHistoryMgr.prototype._getIFrameHash=function(){
var e=document.getElementById(AjxHistoryMgr.IFRAME_ID);
var a=e.contentWindow.document;
var t=new String(a.location.search);
if(t.length==1&&t.charAt(0)=="?"){
t=""
}else{
if(t.length>=2&&t.charAt(0)=="?"){
t=t.substring(1)
}}
return t
};
AjxHistoryMgr.prototype._removeHash=function(e){
if(e==null||e==undefined){
return null
}else{
if(e==""){
return""
}else{
if(e.length==1&&e.charAt(0)=="#"){
return""
}else{
if(e.length>1&&e.charAt(0)=="#"){
return e.substring(1)
}else{
return e
}}}}};
AjxHistoryMgr.prototype.iframeLoaded=function(e){
if(this.ignoreLocationChange){
this.ignoreLocationChange=false;
return
}
var t=new String(e.search);
if(t.length==1&&t.charAt(0)=="?"){
t=""
}else{
if(t.length>=2&&t.charAt(0)=="?"){
t=t.substring(1)
}}
window.location.hash=t;
this._evt.data=t;
this._eventMgr.notifyListeners(AjxEvent.HISTORY,this._evt)
};
