
/* Copyright (C) 2005-2009 Zimbra Inc. http://www.zimbra.com/ */
AjxSelectionManager=function(e){
this._owner=e
};
AjxSelectionManager.SELECT_ONE_CLEAR_OTHERS=0;
AjxSelectionManager.TOGGLE_ONE_LEAVE_OTHERS=1;
AjxSelectionManager.SELECT_TO_ANCHOR=2;
AjxSelectionManager.DESELECT_ALL=3;
AjxSelectionManager.SELECT_ALL=4;
AjxSelectionManager.prototype.getItems=function(){
if(this._selectedItems==null){
this._selectedItems=this._createItemsCollection()
}
return this._selectedItems
};
AjxSelectionManager.prototype.getLength=function(){
return this.getItems().length
};
AjxSelectionManager.prototype.getAnchor=function(){
if(this._anchor==null){
var e=this.getItems();
if(e.length>0){
this._anchor=e[0]
}}
return this._anchor
};
AjxSelectionManager.prototype.getCursor=function(){
if(this._cursor==null){
this._cursor=this.getAnchor()
}
return this._cursor
};
AjxSelectionManager.prototype.isSelected=function(e){
return this.getItems().binarySearch(e)!=-1
};
AjxSelectionManager.prototype.selectOneItem=function(e){
this.select(e,AjxSelectionManager.SELECT_ONE_CLEAR_OTHERS)
};
AjxSelectionManager.prototype.toggleItem=function(e){
this.select(e,AjxSelectionManager.TOGGLE_ONE_LEAVE_OTHERS)
};
AjxSelectionManager.prototype.selectFromAnchorToItem=function(e){
this.select(e,AjxSelectionManager.SELECT_TO_ANCHOR)
};
AjxSelectionManager.prototype.deselectAll=function(){
this.select(null,AjxSelectionManager.DESELECT_ALL)
};
AjxSelectionManager.prototype.selectAll=function(){
this.select(null,AjxSelectionManager.SELECT_ALL)
};
AjxSelectionManager.prototype.select=function(f,s){
this._setAnchorAndCursor(f,s);
var m=this._selectedItems;
var n=(m==null)?0:m.length;
this._selectedItems=null;
this._selectedItems=this._createItemsCollection();
var e=this._owner.getItemCount();
var u=false;
var o=false;
var c=false;
for(var h=0;
h<e;
++h){
var l=this._owner.getItem(h);
var d=this._isItemOldSelection(l,m);
var t=d;
switch(s){
case AjxSelectionManager.SELECT_TO_ANCHOR:if(this._anchor==null){
this._anchor=l
}
var a=(l==this._anchor||l==f);
var r=false;
if(!c&&a){
c=true;
r=true
}
t=c;
if((!r||this._anchor==f)&&c&&a){
c=false
}
break;
case AjxSelectionManager.SELECT_ONE_CLEAR_OTHERS:t=(l==f);
break;
case AjxSelectionManager.TOGGLE_ONE_LEAVE_OTHERS:if(l==f){
t=!d
}
break;
case AjxSelectionManager.DESELECT_ALL:t=false;
break;
case AjxSelectionManager.SELECT_ALL:t=true;
break
}
if(t){
this._selectedItems.add(l);
u=(this._selectedItems.length>1)
}
if(t!=d){
if(this._owner.itemSelectionChanged!=null){
this._owner.itemSelectionChanged(l,h,t)
}
o=true
}}
o=o||(n!=this._selectedItems.length);
if(u){
this._selectedItems.sort()
}
if(o&&this._owner.selectionChanged!=null){
this._owner.selectionChanged(f)
}};
AjxSelectionManager.prototype.removeItem=function(t){
if(this._selectedItems){
var e=this._selectedItems.binarySearch(t);
if(e>-1){
this._selectedItems.removeAt(e)
}}};
AjxSelectionManager.prototype._createItemsCollection=function(){
return new AjxVector()
};
AjxSelectionManager.prototype._isItemOldSelection=function(t,i){
var e=false;
if(i){
var a=i.binarySearch(t);
if(a>-1){
i.removeAt(a)
}
e=(a!=-1)
}
return e
};
AjxSelectionManager.prototype._setAnchorAndCursor=function(e,t){
switch(t){
case AjxSelectionManager.SELECT_TO_ANCHOR:this._cursor=e;
break;
case AjxSelectionManager.SELECT_ONE_CLEAR_OTHERS:this._anchor=e;
this._cursor=e;
break;
case AjxSelectionManager.TOGGLE_ONE_LEAVE_OTHERS:this._anchor=e;
this._cursor=e;
break;
case AjxSelectionManager.DESELECT_ALL:this._anchor=null;
this._cursor=null;
break;
case AjxSelectionManager.SELECT_ALL:return
}};
