
/* Copyright (C) 2005-2009 Zimbra Inc. http://www.zimbra.com/ */
(function(){
tinymce.create("tinymce.plugins.FullPagePlugin",{
init:function(e,a){
var i=this;
i.editor=e;
e.addCommand("mceFullPageProperties",function(){
e.windowManager.open({
file:a+"/fullpage.htm",width:430+parseInt(e.getLang("fullpage.delta_width",0)),height:495+parseInt(e.getLang("fullpage.delta_height",0)),inline:1}
,{
plugin_url:a,head_html:i.head}
)
}
);
e.addButton("fullpage",{
title:"fullpage.desc",cmd:"mceFullPageProperties"}
);
e.onBeforeSetContent.add(i._setContent,i);
e.onSetContent.add(i._setBodyAttribs,i);
e.onGetContent.add(i._getContent,i)
}
,getInfo:function(){
return{
longname:"Fullpage",author:"Moxiecode Systems AB",authorurl:"http://tinymce.moxiecode.com",infourl:"http://wiki.moxiecode.com/index.php/TinyMCE:Plugins/fullpage",version:tinymce.majorVersion+"."+tinymce.minorVersion}
}
,_setBodyAttribs:function(s,e){
var u,n,r,l,a,c,d,h=this.head.match(/body(.*?)>/i);
if(h&&h[1]){
u=h[1].match(/\s*(\w+\s*=\s*".*?"|\w+\s*=\s*'.*?'|\w+\s*=\s*\w+|\w+)\s*/g);
if(u){
for(n=0,r=u.length;
n<r;
n++){
l=u[n].split("=");
a=l[0].replace(/\s/,"");
c=l[1];
if(c){
c=c.replace(/^\s+/,"").replace(/\s+$/,"");
d=c.match(/^["'](.*)["']$/);
if(d){
c=d[1]
}}else{
c=a
}
s.dom.setAttrib(s.getBody(),"style",c)
}}}}
,_createSerializer:function(){
return new tinymce.dom.Serializer({
dom:this.editor.dom,apply_source_formatting:true}
)
}
,_setContent:function(i,a){
var h=this,e,d,s=a.content,r,l="";
if(a.source_view&&i.getParam("fullpage_hide_in_source_view")){
return
}
s=s.replace(/<(\/?)BODY/gi,"<$1body");
e=s.indexOf("<body");
if(e!=-1){
e=s.indexOf(">",e);
h.head=s.substring(0,e+1);
d=s.indexOf("</body",e);
if(d==-1){
d=s.indexOf("</body",d)
}
a.content=s.substring(e+1,d);
h.foot=s.substring(d);
function n(t){
return t.replace(/<\/?[A-Z]+/g,function(o){
return o.toLowerCase()
}
)
}
h.head=n(h.head);
h.foot=n(h.foot)
}else{
h.head="";
if(i.getParam("fullpage_default_xml_pi")){
h.head+='<?xml version="1.0" encoding="'+i.getParam("fullpage_default_encoding","ISO-8859-1")+'" ?>\n'
}
h.head+=i.getParam("fullpage_default_doctype",'<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">');
h.head+="\n<html>\n<head>\n<title>"+i.getParam("fullpage_default_title","Untitled document")+"</title>\n";
if(r=i.getParam("fullpage_default_encoding")){
h.head+='<meta http-equiv="Content-Type" content="'+r+'" />\n'
}
if(r=i.getParam("fullpage_default_font_family")){
l+="font-family: "+r+";"
}
if(r=i.getParam("fullpage_default_font_size")){
l+="font-size: "+r+";"
}
if(r=i.getParam("fullpage_default_text_color")){
l+="color: "+r+";"
}
h.head+="</head>\n<body"+(l?' style="'+l+'"':"")+">\n";
h.foot="\n</body>\n</html>"
}}
,_getContent:function(e,i){
var a=this;
if(!i.source_view||!e.getParam("fullpage_hide_in_source_view")){
i.content=tinymce.trim(a.head)+"\n"+tinymce.trim(i.content)+"\n"+tinymce.trim(a.foot)
}}}
);
tinymce.PluginManager.add("fullpage",tinymce.plugins.FullPagePlugin)
}
)();
