
/* Copyright (C) 2005-2009 Zimbra Inc. http://www.zimbra.com/ */
(function(){
tinymce.create("tinymce.plugins.Layer",{
init:function(e,a){
var i=this;
i.editor=e;
e.addCommand("mceInsertLayer",i._insertLayer,i);
e.addCommand("mceMoveForward",function(){
i._move(1)
}
);
e.addCommand("mceMoveBackward",function(){
i._move(-1)
}
);
e.addCommand("mceMakeAbsolute",function(){
i._toggleAbsolute()
}
);
e.addButton("moveforward",{
title:"layer.forward_desc",cmd:"mceMoveForward"}
);
e.addButton("movebackward",{
title:"layer.backward_desc",cmd:"mceMoveBackward"}
);
e.addButton("absolute",{
title:"layer.absolute_desc",cmd:"mceMakeAbsolute"}
);
e.addButton("insertlayer",{
title:"layer.insertlayer_desc",cmd:"mceInsertLayer"}
);
e.onInit.add(function(){
if(tinymce.isIE){
e.getDoc().execCommand("2D-Position",false,true)
}}
);
e.onNodeChange.add(i._nodeChange,i);
e.onVisualAid.add(i._visualAid,i)
}
,getInfo:function(){
return{
longname:"Layer",author:"Moxiecode Systems AB",authorurl:"http://tinymce.moxiecode.com",infourl:"http://wiki.moxiecode.com/index.php/TinyMCE:Plugins/layer",version:tinymce.majorVersion+"."+tinymce.minorVersion}
}
,_nodeChange:function(t,e,o){
var a,i;
a=this._getParentLayer(o);
i=t.dom.getParent(o,"DIV,P,IMG");
if(!i){
e.setDisabled("absolute",1);
e.setDisabled("moveforward",1);
e.setDisabled("movebackward",1)
}else{
e.setDisabled("absolute",0);
e.setDisabled("moveforward",!a);
e.setDisabled("movebackward",!a);
e.setActive("absolute",a&&a.style.position.toLowerCase()=="absolute")
}}
,_visualAid:function(t,i,a){
var o=t.dom;
tinymce.each(o.select("div,p",i),function(n){
if(/^(absolute|relative|static)$/i.test(n.style.position)){
if(a){
o.addClass(n,"mceItemVisualAid")
}else{
o.removeClass(n,"mceItemVisualAid")
}}}
)
}
,_move:function(r){
var t=this.editor,n,s=[],o=this._getParentLayer(t.selection.getNode()),a=-1,h=-1,e;
e=[];
tinymce.walk(t.getBody(),function(i){
if(i.nodeType==1&&/^(absolute|relative|static)$/i.test(i.style.position)){
e.push(i)
}}
,"childNodes");
for(n=0;
n<e.length;
n++){
s[n]=e[n].style.zIndex?parseInt(e[n].style.zIndex):0;
if(a<0&&e[n]==o){
a=n
}}
if(r<0){
for(n=0;
n<s.length;
n++){
if(s[n]<s[a]){
h=n;
break
}}
if(h>-1){
e[a].style.zIndex=s[h];
e[h].style.zIndex=s[a]
}else{
if(s[a]>0){
e[a].style.zIndex=s[a]-1
}}}else{
for(n=0;
n<s.length;
n++){
if(s[n]>s[a]){
h=n;
break
}}
if(h>-1){
e[a].style.zIndex=s[h];
e[h].style.zIndex=s[a]
}else{
e[a].style.zIndex=s[a]+1
}}
t.execCommand("mceRepaint")
}
,_getParentLayer:function(e){
return this.editor.dom.getParent(e,function(t){
return t.nodeType==1&&/^(absolute|relative|static)$/i.test(t.style.position)
}
)
}
,_insertLayer:function(){
var e=this.editor,t=e.dom.getPos(e.dom.getParent(e.selection.getNode(),"*"));
e.dom.add(e.getBody(),"div",{
style:{
position:"absolute",left:t.x,top:(t.y>20?t.y:20),width:100,height:100}
,"class":"mceItemVisualAid"}
,e.selection.getContent()||e.getLang("layer.content"))
}
,_toggleAbsolute:function(){
var e=this.editor,t=this._getParentLayer(e.selection.getNode());
if(!t){
t=e.dom.getParent(e.selection.getNode(),"DIV,P,IMG")
}
if(t){
if(t.style.position.toLowerCase()=="absolute"){
e.dom.setStyles(t,{
position:"",left:"",top:"",width:"",height:""}
);
e.dom.removeClass(t,"mceItemVisualAid")
}else{
if(t.style.left==""){
t.style.left=20+"px"
}
if(t.style.top==""){
t.style.top=20+"px"
}
if(t.style.width==""){
t.style.width=t.width?(t.width+"px"):"100px"
}
if(t.style.height==""){
t.style.height=t.height?(t.height+"px"):"100px"
}
t.style.position="absolute";
e.addVisual(e.getBody())
}
e.execCommand("mceRepaint");
e.nodeChanged()
}}}
);
tinymce.PluginManager.add("layer",tinymce.plugins.Layer)
}
)();
