
/* Copyright (C) 2005-2009 Zimbra Inc. http://www.zimbra.com/ */
(function(){
var e=tinymce.each;
tinymce.create("tinymce.plugins.PastePlugin",{
init:function(s,n){
var o=this,t;
o.editor=s;
o.url=n;
o.onPreProcess=new tinymce.util.Dispatcher(o);
o.onPostProcess=new tinymce.util.Dispatcher(o);
o.onPreProcess.add(o._preProcess);
o.onPostProcess.add(o._postProcess);
o.onPreProcess.add(function(l,r){
s.execCallback("paste_preprocess",l,r)
}
);
o.onPostProcess.add(function(l,r){
s.execCallback("paste_postprocess",l,r)
}
);
function a(r){
var l=s.dom;
o.onPreProcess.dispatch(o,r);
r.node=l.create("div",0,r.content);
o.onPostProcess.dispatch(o,r);
r.content=s.serializer.serialize(r.node,{
getInner:1}
);
if(/<(p|h[1-6]|ul|ol)/.test(r.content)){
o._insertBlockContent(s,l,r.content)
}else{
o._insert(r.content)
}}
s.addCommand("mceInsertClipboardContent",function(l,r){
a(r)
}
);
function i(c){
var y,d,f,u=s.selection,b=s.dom,g=s.getBody(),r;
if(b.get("_mcePaste")){
return
}
y=b.add(g,"div",{
id:"_mcePaste"}
,"&nbsp;");
if(g!=s.getDoc().body){
r=b.getPos(s.selection.getStart(),g).y
}else{
r=g.scrollTop
}
b.setStyles(y,{
position:"absolute",left:-10000,top:r,width:1,height:1,overflow:"hidden"}
);
if(tinymce.isIE){
f=b.doc.body.createTextRange();
f.moveToElementText(y);
f.execCommand("Paste");
b.remove(y);
if(y.innerHTML==="&nbsp;"){
return
}
a({
content:y.innerHTML}
);
return tinymce.dom.Event.cancel(c)
}else{
d=s.selection.getRng();
y=y.firstChild;
f=s.getDoc().createRange();
f.setStart(y,0);
f.setEnd(y,1);
u.setRng(f);
window.setTimeout(function(){
var h="";
e(b.select("div[id=_mcePaste]").reverse(),function(l){
h+=(b.select("> span.Apple-style-span div",l)[0]||b.select("> span.Apple-style-span",l)[0]||l).innerHTML;
b.remove(l)
}
);
if(d){
u.setRng(d)
}
a({
content:h}
)
}
,0)
}}
if(s.getParam("paste_auto_cleanup_on_paste",true)){
if(tinymce.isOpera||/Firefox\/2/.test(navigator.userAgent)){
s.onKeyDown.add(function(l,r){
if(((tinymce.isMac?r.metaKey:r.ctrlKey)&&r.keyCode==86)||(r.shiftKey&&r.keyCode==45)){
i(r)
}}
)
}else{
s.onPaste.addToTop(function(l,r){
return i(r)
}
)
}}
if(s.getParam("paste_block_drop")){
s.onInit.add(function(){
s.dom.bind(s.getBody(),["dragend","dragover","draggesture","dragdrop","drop","drag"],function(r){
r.preventDefault();
r.stopPropagation();
return false
}
)
}
)
}
o._legacySupport()
}
,getInfo:function(){
return{
longname:"Paste text/word",author:"Moxiecode Systems AB",authorurl:"http://tinymce.moxiecode.com",infourl:"http://wiki.moxiecode.com/index.php/TinyMCE:Plugins/paste",version:tinymce.majorVersion+"."+tinymce.minorVersion}
}
,_preProcess:function(n,a){
var t=this.editor,s=a.content,i,o;
function i(r){
e(r,function(h){
if(h.constructor==RegExp){
s=s.replace(h,"")
}else{
s=s.replace(h[0],h[1])
}}
)
}
if(/(class=\"?Mso|style=\"[^\"]*\bmso\-|w:WordDocument)/.test(s)||a.wordContent){
a.wordContent=true;
i([/^\s*(&nbsp;)+/g,/(&nbsp;|<br[^>]*>)+\s*$/g]);
if(t.getParam("paste_convert_middot_lists",true)){
i([[/<!--\[if !supportLists\]-->/gi,"$&__MCE_ITEM__"],[/(<span[^>]+:\s*symbol[^>]+>)/gi,"$1__MCE_ITEM__"],[/(<span[^>]+mso-list:[^>]+>)/gi,"$1__MCE_ITEM__"]])
}
i([/<!--[\s\S]+?-->/gi,/<\/?(img|font|meta|link|style|div|v:\w+)[^>]*>/gi,/<\\?\?xml[^>]*>/gi,/<\/?o:[^>]*>/gi,/ (id|name|language|type|on\w+|v:\w+)=\"([^\"]*)\"/gi,/ (id|name|language|type|on\w+|v:\w+)=(\w+)/gi,[/<(\/?)s>/gi,"<$1strike>"],/<script[^>]+>[\s\S]*?<\/script>/gi,[/&nbsp;/g,"\u00a0"]]);
if(!t.getParam("paste_retain_style_properties")){
i([/<\/?(span)[^>]*>/gi])
}}
o=t.getParam("paste_strip_class_attributes","all");
if(o!="none"){
if(o=="all"){
i([/ class=\"([^\"]*)\"/gi,/ class=(\w+)/gi])
}else{
i([/ class=\"(mso[^\"]*)\"/gi,/ class=(mso\w+)/gi])
}}
if(t.getParam("paste_remove_spans")){
i([/<\/?(span)[^>]*>/gi])
}
a.content=s
}
,_postProcess:function(o,a){
var n=this,s=n.editor,i=s.dom,t;
if(a.wordContent){
e(i.select("a",a.node),function(r){
if(!r.href||r.href.indexOf("#_Toc")!=-1){
i.remove(r,1)
}}
);
if(n.editor.getParam("paste_convert_middot_lists",true)){
n._convertLists(o,a)
}
t=s.getParam("paste_retain_style_properties");
if(tinymce.is(t,"string")){
t=tinymce.explode(t)
}
e(i.select("*",a.node),function(c){
var r={}
,u=0,d,p,f;
if(t){
for(d=0;
d<t.length;
d++){
p=t[d];
f=i.getStyle(c,p);
if(f){
r[p]=f;
u++
}}}
i.setAttrib(c,"style","");
if(t&&u>0){
i.setStyles(c,r)
}else{
if(c.nodeName=="SPAN"&&!c.className){
i.remove(c,true)
}}}
)
}
if(s.getParam("paste_remove_styles")||(s.getParam("paste_remove_styles_if_webkit")&&tinymce.isWebKit)){
e(i.select("*[style]",a.node),function(r){
r.removeAttribute("style");
r.removeAttribute("mce_style")
}
)
}else{
if(tinymce.isWebKit){
e(i.select("*",a.node),function(r){
r.removeAttribute("mce_style")
}
)
}}}
,_convertLists:function(l,m){
var s=l.editor.dom,r,a,p=-1,u,t=[],o,n;
e(s.select("p",m.node),function(d){
var y,c="",f,g,h,i;
for(y=d.firstChild;
y&&y.nodeType==3;
y=y.nextSibling){
c+=y.nodeValue
}
c=d.innerHTML.replace(/<\/?\w+[^>]*>/gi,"").replace(/&nbsp;/g,"\u00a0");
if(/^(__MCE_ITEM__)+[\u2022\u00b7\u00a7\u00d8o]\s*\u00a0*/.test(c)){
f="ul"
}
if(/^__MCE_ITEM__\s*\w+\.\s*\u00a0{2,}/.test(c)){
f="ol"
}
if(f){
u=parseFloat(d.style.marginLeft||0);
if(u>p){
t.push(u)
}
if(!r||f!=o){
r=s.create(f);
s.insertAfter(r,d)
}else{
if(u>p){
r=a.appendChild(s.create(f))
}else{
if(u<p){
h=tinymce.inArray(t,u);
i=s.getParents(r.parentNode,f);
r=i[i.length-1-h]||r
}}}
e(s.select("span",d),function(b){
var w=b.innerHTML.replace(/<\/?\w+[^>]*>/gi,"");
if(f=="ul"&&/^[\u2022\u00b7\u00a7\u00d8o]/.test(w)){
s.remove(b)
}else{
if(/^[\s\S]*\w+\.(&nbsp;|\u00a0)*\s*/.test(w)){
s.remove(b)
}}}
);
g=d.innerHTML;
if(f=="ul"){
g=d.innerHTML.replace(/__MCE_ITEM__/g,"").replace(/^[\u2022\u00b7\u00a7\u00d8o]\s*(&nbsp;|\u00a0)+\s*/,"")
}else{
g=d.innerHTML.replace(/__MCE_ITEM__/g,"").replace(/^\s*\w+\.(&nbsp;|\u00a0)+\s*/,"")
}
a=r.appendChild(s.create("li",0,g));
s.remove(d);
p=u;
o=f
}else{
r=p=0
}}
);
n=m.node.innerHTML;
if(n.indexOf("__MCE_ITEM__")!=-1){
m.node.innerHTML=n.replace(/__MCE_ITEM__/g,"")
}}
,_insertBlockContent:function(r,y,s){
var v,u,w=r.selection,t,n,x,o,p;
function a(i){
var h;
if(tinymce.isIE){
h=r.getDoc().body.createTextRange();
h.moveToElementText(i);
h.collapse(false);
h.select()
}else{
w.select(i,1);
w.collapse(false)
}}
this._insert('<span id="_marker">&nbsp;</span>',1);
u=y.get("_marker");
v=y.getParent(u,"p,h1,h2,h3,h4,h5,h6,ul,ol,th,td");
if(v&&!/TD|TH/.test(v.nodeName)){
u=y.split(v,u);
e(y.create("div",0,s).childNodes,function(i){
t=u.parentNode.insertBefore(i.cloneNode(true),u)
}
);
a(t)
}else{
y.setOuterHTML(u,s);
w.select(r.getBody(),1);
w.collapse(0)
}
y.remove("_marker");
n=w.getStart();
x=y.getViewPort(r.getWin());
o=r.dom.getPos(n).y;
p=n.clientHeight;
if(o<x.y||o+p>x.y+x.h){
r.getDoc().body.scrollTop=o<x.y?o:o-x.h+25
}}
,_insert:function(a,t){
var i=this.editor;
if(!i.selection.isCollapsed()){
i.getDoc().execCommand("Delete",false,null)
}
i.execCommand(tinymce.isGecko?"insertHTML":"mceInsertContent",false,a,{
skip_undo:t}
)
}
,_legacySupport:function(){
var a=this,t=a.editor;
e(["mcePasteText","mcePasteWord"],function(i){
t.addCommand(i,function(){
t.windowManager.open({
file:a.url+(i=="mcePasteText"?"/pastetext.htm":"/pasteword.htm"),width:parseInt(t.getParam("paste_dialog_width","450")),height:parseInt(t.getParam("paste_dialog_height","400")),inline:1}
)
}
)
}
);
t.addButton("pastetext",{
title:"paste.paste_text_desc",cmd:"mcePasteText"}
);
t.addButton("pasteword",{
title:"paste.paste_word_desc",cmd:"mcePasteWord"}
);
t.addButton("selectall",{
title:"paste.selectall_desc",cmd:"selectall"}
)
}}
);
tinymce.PluginManager.add("paste",tinymce.plugins.PastePlugin)
}
)();
