
/* Copyright (C) 2005-2009 Zimbra Inc. http://www.zimbra.com/ */
(function(){
tinymce.create("tinymce.plugins.Save",{
init:function(e,a){
var i=this;
i.editor=e;
e.addCommand("mceSave",i._save,i);
e.addCommand("mceCancel",i._cancel,i);
e.addButton("save",{
title:"save.save_desc",cmd:"mceSave"}
);
e.addButton("cancel",{
title:"save.cancel_desc",cmd:"mceCancel"}
);
e.onNodeChange.add(i._nodeChange,i);
e.addShortcut("ctrl+s",e.getLang("save.save_desc"),"mceSave")
}
,getInfo:function(){
return{
longname:"Save",author:"Moxiecode Systems AB",authorurl:"http://tinymce.moxiecode.com",infourl:"http://wiki.moxiecode.com/index.php/TinyMCE:Plugins/save",version:tinymce.majorVersion+"."+tinymce.minorVersion}
}
,_nodeChange:function(t,e,a){
var t=this.editor;
if(t.getParam("save_enablewhendirty")){
e.setDisabled("save",!t.isDirty());
e.setDisabled("cancel",!t.isDirty())
}}
,_save:function(){
var a=this.editor,e,n,o,t;
e=tinymce.DOM.get(a.id).form||tinymce.DOM.getParent(a.id,"form");
if(a.getParam("save_enablewhendirty")&&!a.isDirty()){
return
}
tinyMCE.triggerSave();
if(n=a.getParam("save_onsavecallback")){
if(a.execCallback("save_onsavecallback",a)){
a.startContent=tinymce.trim(a.getContent({
format:"raw"}
));
a.nodeChanged()
}
return
}
if(e){
a.isNotDirty=true;
if(e.onsubmit==null||e.onsubmit()!=false){
e.submit()
}
a.nodeChanged()
}else{
a.windowManager.alert("Error: No form element found.")
}}
,_cancel:function(){
var e=this.editor,a,t=tinymce.trim(e.startContent);
if(a=e.getParam("save_oncancelcallback")){
e.execCallback("save_oncancelcallback",e);
return
}
e.setContent(t);
e.undoManager.clear();
e.nodeChanged()
}}
);
tinymce.PluginManager.add("save",tinymce.plugins.Save)
}
)();
